/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/process","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(K){for(var e=[],v=0,L=K.length;v<L;v++)e[v]=J[K[v]];return e};define(J[102],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(J[46],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(E){return(r,f,w)=>{let t=null,P=null;if(typeof w.value=="function"?(t="value",P=w.value):typeof w.get=="function"&&(t="get",P=w.get),!P)throw new Error("not supported");w[t]=E(P,f)}}e.createDecorator=v;function L(E,r,f){let w=null,t=null;if(typeof f.value=="function"?(w="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",t=f.get),!t)throw new Error("not supported");const P=`$memoize$${r}`;f[w]=function(...b){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,b)}),this[P]}}e.memoize=L;function k(E,r,f){return v((w,t)=>{const P=`$debounce$${t}`,b=`$debounce$result$${t}`;return function(...p){this[b]||(this[b]=f?f():void 0),clearTimeout(this[P]),r&&(this[b]=r(this[b],...p),p=[this[b]]),this[P]=setTimeout(()=>{w.apply(this,p),this[b]=f?f():void 0},E)}})}e.debounce=k;function M(E,r,f){return v((w,t)=>{const P=`$throttle$timer$${t}`,b=`$throttle$result$${t}`,p=`$throttle$lastRun$${t}`,d=`$throttle$pending$${t}`;return function(...g){if(this[b]||(this[b]=f?f():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),r&&(this[b]=r(this[b],...g)),this[d])return;const I=this[p]+E;I<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0},I-Date.now()))}})}e.throttle=M}),define(J[17],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=v,e.errorHandler=new v;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function k(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function M(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function E(c){if(c instanceof Error){let{name:i,message:a}=c;const n=c.stacktrace||c.stack;return{$isError:!0,name:i,message:a,stack:n}}return c}e.transformErrorForSerialization=E;const r="Canceled";function f(c){return c instanceof Error&&c.name===r&&c.message===r}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(r);this.name=this.message}}e.CancellationError=w;function t(){const c=new Error(r);return c.name=c.message,c}e.canceled=t;function P(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=P;function b(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=b;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function g(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=g;class I extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=I;class y extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=y;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=u;function h(c){const i=c;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=h;function s(c,i=Object.create(null)){const a=new Error(c);return i.actions&&(a.actions=i.actions),a}e.createErrorWithActions=s}),define(J[31],Z([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(F,R=0){return F[F.length-(1+R)]}e.tail=L;function k(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=k;function M(F,R,T=(O,B)=>O===B){if(F===R)return!0;if(!F||!R||F.length!==R.length)return!1;for(let O=0,B=F.length;O<B;O++)if(!T(F[O],R[O]))return!1;return!0}e.equals=M;function E(F,R,T){let O=0,B=F.length-1;for(;O<=B;){const N=(O+B)/2|0,V=T(F[N],R);if(V<0)O=N+1;else if(V>0)B=N-1;else return N}return-(O+1)}e.binarySearch=E;function r(F,R){let T=0,O=F.length;if(O===0)return 0;for(;T<O;){const B=Math.floor((T+O)/2);R(F[B])?O=B:T=B+1}return T}e.findFirstInSorted=r;function f(F,R,T){if(F=F|0,F>=R.length)throw new TypeError("invalid index");let O=R[Math.floor(R.length*Math.random())],B=[],N=[],V=[];for(let x of R){const ie=T(x,O);ie<0?B.push(x):ie>0?N.push(x):V.push(x)}return F<B.length?f(F,B,T):F<B.length+V.length?V[0]:f(F-(B.length+V.length),N,T)}e.quickSelect=f;function w(F,R){const T=[];let O;for(const B of F.slice(0).sort(R))!O||R(O[0],B)!==0?(O=[B],T.push(O)):O.push(B);return T}e.groupBy=w;function t(F,R,T){const O=[];function B(x,ie,ne){if(ie===0&&ne.length===0)return;const ce=O[O.length-1];ce&&ce.start+ce.deleteCount===x?(ce.deleteCount+=ie,ce.toInsert.push(...ne)):O.push({start:x,deleteCount:ie,toInsert:ne})}let N=0,V=0;for(;;){if(N===F.length){B(N,0,R.slice(V));break}if(V===R.length){B(N,F.length-N,[]);break}const x=F[N],ie=R[V],ne=T(x,ie);ne===0?(N+=1,V+=1):ne<0?(B(N,1,[]),N+=1):ne>0&&(B(N,0,[ie]),V+=1)}return O}e.sortedDiff=t;function P(F,R,T){const O=t(F,R,T),B=[],N=[];for(const V of O)B.push(...F.slice(V.start,V.start+V.deleteCount)),N.push(...V.toInsert);return{removed:B,added:N}}e.delta=P;function b(F,R,T){if(T===0)return[];const O=F.slice(0,T).sort(R);return d(F,R,O,T,F.length),O}e.top=b;function p(F,R,T,O,B){return T===0?Promise.resolve([]):new Promise((N,V)=>{(async()=>{const x=F.length,ie=F.slice(0,T).sort(R);for(let ne=T,ce=Math.min(T+O,x);ne<x;ne=ce,ce=Math.min(ce+O,x)){if(ne>T&&await new Promise(se=>setTimeout(se)),B&&B.isCancellationRequested)throw(0,v.canceled)();d(F,R,ie,ne,ce)}return ie})().then(N,V)})}e.topAsync=p;function d(F,R,T,O,B){for(const N=T.length;O<B;O++){const V=F[O];if(R(V,T[N-1])<0){T.pop();const x=r(T,ie=>R(V,ie)<0);T.splice(x,0,V)}}}function g(F){return F.filter(R=>!!R)}e.coalesce=g;function I(F){let R=0;for(let T=0;T<F.length;T++)F[T]&&(F[R]=F[T],R+=1);F.length=R}e.coalesceInPlace=I;function y(F,R,T){F.splice(T,0,F.splice(R,1)[0])}e.move=y;function u(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=u;function h(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=h;function s(F,R){if(!R)return F.filter((O,B)=>F.indexOf(O)===B);const T=Object.create(null);return F.filter(O=>{const B=R(O);return T[B]?!1:(T[B]=!0,!0)})}e.distinct=s;function c(F){const R=new Set;return F.filter(T=>R.has(T)?!1:(R.add(T),!0))}e.distinctES6=c;function i(F){const R=Object.create(null);return T=>{const O=F(T);return R[O]?!1:(R[O]=!0,!0)}}e.uniqueFilter=i;function a(F,R){for(let T=F.length-1;T>=0;T--){const O=F[T];if(R(O))return T}return-1}e.lastIndex=a;function n(F,R){return F.length>0?F[0]:R}e.firstOrDefault=n;function o(F,R,T=(O,B)=>O===B){let O=0;for(let B=0,N=Math.min(F.length,R.length);B<N&&T(F[B],R[B]);B++)O++;return O}e.commonPrefixLength=o;function l(F){return[].concat(...F)}e.flatten=l;function m(F,R){let T=typeof R=="number"?F:0;typeof R=="number"?T=F:(T=0,R=F);const O=[];if(T<=R)for(let B=T;B<R;B++)O.push(B);else for(let B=T;B>R;B--)O.push(B);return O}e.range=m;function S(F,R,T){return F.reduce((O,B)=>(O[R(B)]=T?T(B):B,O),Object.create(null))}e.index=S;function D(F,R){return F.push(R),()=>A(F,R)}e.insert=D;function A(F,R){const T=F.indexOf(R);if(T>-1)return F.splice(T,1),R}e.remove=A;function W(F,R,T){const O=F.slice(0,R),B=F.slice(R);return O.concat(T,B)}e.arrayInsert=W;function C(F,R){let T;if(typeof R=="number"){let O=R;T=()=>{const B=Math.sin(O++)*179426549;return B-Math.floor(B)}}else T=Math.random;for(let O=F.length-1;O>0;O-=1){const B=Math.floor(T()*(O+1)),N=F[O];F[O]=F[B],F[B]=N}}e.shuffle=C;function X(F,R){const T=F.indexOf(R);T>-1&&(F.splice(T,1),F.unshift(R))}e.pushToStart=X;function te(F,R){const T=F.indexOf(R);T>-1&&(F.splice(T,1),F.push(R))}e.pushToEnd=te;function oe(F,R){return Array.isArray(F)?F.map(R):R(F)}e.mapArrayOrNot=oe;function Y(F){return Array.isArray(F)?F:[F]}e.asArray=Y;function Q(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=Q;function _(F,R){for(const T of F){const O=R(T);if(O!==void 0)return O}}e.mapFind=_;function q(F,R,T){const O=$(F,R),B=F.length,N=T.length;F.length=B+N;for(let V=B-1;V>=O;V--)F[V+N]=F[V];for(let V=0;V<N;V++)F[V+O]=T[V]}e.insertInto=q;function z(F,R,T,O){const B=$(F,R),N=F.splice(B,T);return q(F,B,O),N}e.splice=z;function $(F,R){return R<0?Math.max(R+F.length,0):Math.min(R,F.length)}function H(F,R){let T=Number.MAX_SAFE_INTEGER,O=0;return F.forEach((B,N)=>{const V=R(B);V<T&&(T=V,O=N)}),O}e.minIndex=H;function U(F,R){let T=Number.MIN_SAFE_INTEGER,O=0;return F.forEach((B,N)=>{const V=R(B);V>T&&(T=V,O=N)}),O}e.maxIndex=U;class j{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let T=this.firstIdx;for(;T<this.items.length&&R(this.items[T]);)T++;const O=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,O}takeFromEndWhile(R){let T=this.lastIdx;for(;T>=0&&R(this.items[T]);)T--;const O=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,O}}e.ArrayQueue=j}),define(J[43],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const k=this;let M=!1,E;return function(){return M||(M=!0,E=L.apply(k,arguments)),E}}e.once=v}),define(J[63],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function k(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function E(){return M}L.empty=E;function*r(c){yield c}L.single=r;function f(c){return c||M}L.from=f;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function t(c){return c[Symbol.iterator]().next().value}L.first=t;function P(c,i){for(const a of c)if(i(a))return!0;return!1}L.some=P;function b(c,i){for(const a of c)if(i(a))return a}L.find=b;function*p(c,i){for(const a of c)i(a)&&(yield a)}L.filter=p;function*d(c,i){let a=0;for(const n of c)yield i(n,a++)}L.map=d;function*g(...c){for(const i of c)for(const a of i)yield a}L.concat=g;function*I(c){for(const i of c)for(const a of i)yield a}L.concatNested=I;function y(c,i,a){let n=a;for(const o of c)n=i(n,o);return n}L.reduce=y;function*u(c,i,a=c.length){for(i<0&&(i+=c.length),a<0?a+=c.length:a>c.length&&(a=c.length);i<a;i++)yield c[i]}L.slice=u;function h(c,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,c];const n=c[Symbol.iterator]();for(let o=0;o<i;o++){const l=n.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return n}}]}L.consume=h;function s(c,i,a=(n,o)=>n===o){const n=c[Symbol.iterator](),o=i[Symbol.iterator]();for(;;){const l=n.next(),m=o.next();if(l.done!==m.done)return!1;if(l.done)return!0;if(!a(l.value,m.value))return!1}}L.equals=s})(v=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function E(i,a=!1){let n=0,o=i.length,l="",m=0,S=16,D=0;function A(Q){let _=0,q=0;for(;_<Q;){const z=i.charCodeAt(n);if(z>=48&&z<=57)q=q*16+z-48;else if(z>=65&&z<=70)q=q*16+z-65+10;else if(z>=97&&z<=102)q=q*16+z-97+10;else break;n++,_++}return _<Q&&(q=-1),q}function W(Q){n=Q,l="",m=0,S=16,D=0}function C(){const Q=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&w(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&w(i.charCodeAt(n)))for(n++;n<i.length&&w(i.charCodeAt(n));)n++;else return D=3,i.substring(Q,n);let _=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&w(i.charCodeAt(n))){for(n++;n<i.length&&w(i.charCodeAt(n));)n++;_=n}else D=3;return i.substring(Q,_)}function X(){let Q="",_=n;for(;;){if(n>=o){Q+=i.substring(_,n),D=2;break}const q=i.charCodeAt(n);if(q===34){Q+=i.substring(_,n),n++;break}if(q===92){if(Q+=i.substring(_,n),n++,n>=o){D=2;break}switch(i.charCodeAt(n++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const $=A(4);$>=0?Q+=String.fromCharCode($):D=4;break;default:D=5}_=n;continue}if(q>=0&&q<=31)if(f(q)){Q+=i.substring(_,n),D=2;break}else D=6;n++}return Q}function te(){if(l="",D=0,m=n,n>=o)return m=o,S=17;let Q=i.charCodeAt(n);if(r(Q)){do n++,l+=String.fromCharCode(Q),Q=i.charCodeAt(n);while(r(Q));return S=15}if(f(Q))return n++,l+=String.fromCharCode(Q),Q===13&&i.charCodeAt(n)===10&&(n++,l+=`
`),S=14;switch(Q){case 123:return n++,S=1;case 125:return n++,S=2;case 91:return n++,S=3;case 93:return n++,S=4;case 58:return n++,S=6;case 44:return n++,S=5;case 34:return n++,l=X(),S=10;case 47:const _=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<o&&!f(i.charCodeAt(n));)n++;return l=i.substring(_,n),S=12}if(i.charCodeAt(n+1)===42){n+=2;const q=o-1;let z=!1;for(;n<q;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,z=!0;break}n++}return z||(n++,D=1),l=i.substring(_,n),S=13}return l+=String.fromCharCode(Q),n++,S=16;case 45:if(l+=String.fromCharCode(Q),n++,n===o||!w(i.charCodeAt(n)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=C(),S=11;default:for(;n<o&&oe(Q);)n++,Q=i.charCodeAt(n);if(m!==n){switch(l=i.substring(m,n),l){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return l+=String.fromCharCode(Q),n++,S=16}}function oe(Q){if(r(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let Q;do Q=te();while(Q>=12&&Q<=15);return Q}return{setPosition:W,getPosition:()=>n,scan:a?Y:te,getToken:()=>S,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>D}}e.createScanner=E;function r(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function P(i,a){const n=[],o=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(A,W,C,X){m.value=A,m.offset=W,m.length=C,m.type=X,m.colonOffset=void 0,l=m}try{h(i,{onObjectBegin:(A,W)=>{if(a<=A)throw o;l=void 0,S=a>A,n.push("")},onObjectProperty:(A,W,C)=>{if(a<W||(D(A,W,C,"property"),n[n.length-1]=A,a<=W+C))throw o},onObjectEnd:(A,W)=>{if(a<=A)throw o;l=void 0,n.pop()},onArrayBegin:(A,W)=>{if(a<=A)throw o;l=void 0,n.push(0)},onArrayEnd:(A,W)=>{if(a<=A)throw o;l=void 0,n.pop()},onLiteralValue:(A,W,C)=>{if(a<W||(D(A,W,C,c(A)),a<=W+C))throw o},onSeparator:(A,W,C)=>{if(a<=W)throw o;if(A===":"&&l&&l.type==="property")l.colonOffset=W,S=!1,l=void 0;else if(A===","){const X=n[n.length-1];typeof X=="number"?n[n.length-1]=X+1:(S=!0,n[n.length-1]=""),l=void 0}}})}catch(A){if(A!==o)throw A}return{path:n,previousNode:l,isAtPropertyKey:S,matches:A=>{let W=0;for(let C=0;W<A.length&&C<n.length;C++)if(A[W]===n[C]||A[W]==="*")W++;else if(A[W]!=="**")return!1;return W===A.length}}}e.getLocation=P;function b(i,a=[],n=M.DEFAULT){let o=null,l=[];const m=[];function S(A){Array.isArray(l)?l.push(A):o!==null&&(l[o]=A)}return h(i,{onObjectBegin:()=>{const A={};S(A),m.push(l),l=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const A=[];S(A),m.push(l),l=A,o=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:S,onError:(A,W,C)=>{a.push({error:A,offset:W,length:C})}},n),l[0]}e.parse=b;function p(i,a=[],n=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(A){o.type==="property"&&(o.length=A-o.offset,o=o.parent)}function m(A){return o.children.push(A),A}h(i,{onObjectBegin:A=>{o=m({type:"object",offset:A,length:-1,parent:o,children:[]})},onObjectProperty:(A,W,C)=>{o=m({type:"property",offset:W,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:A,offset:W,length:C,parent:o})},onObjectEnd:(A,W)=>{o.length=A+W-o.offset,o=o.parent,l(A+W)},onArrayBegin:(A,W)=>{o=m({type:"array",offset:A,length:-1,parent:o,children:[]})},onArrayEnd:(A,W)=>{o.length=A+W-o.offset,o=o.parent,l(A+W)},onLiteralValue:(A,W,C)=>{m({type:c(A),offset:W,length:C,parent:o,value:A}),l(W+C)},onSeparator:(A,W,C)=>{o.type==="property"&&(A===":"?o.colonOffset=W:A===","&&l(W))},onError:(A,W,C)=>{a.push({error:A,offset:W,length:C})}},n);const D=o.children[0];return D&&delete D.parent,D}e.parseTree=p;function d(i,a){if(!i)return;let n=i;for(let o of a)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===o){n=m.children[1],l=!0;break}if(!l)return}else{const l=o;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}e.findNodeAtLocation=d;function g(i){if(!i.parent||!i.parent.children)return[];const a=g(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;a.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&a.push(n)}return a}e.getNodePath=g;function I(i){switch(i.type){case"array":return i.children.map(I);case"object":const a=Object.create(null);for(let n of i.children){const o=n.children[1];o&&(a[n.children[0].value]=I(o))}return a;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=I;function y(i,a,n=!1){return a>=i.offset&&a<i.offset+i.length||n&&a===i.offset+i.length}e.contains=y;function u(i,a,n=!1){if(y(i,a,n)){const o=i.children;if(Array.isArray(o))for(let l=0;l<o.length&&o[l].offset<=a;l++){const m=u(o[l],a,n);if(m)return m}return i}}e.findNodeAtOffset=u;function h(i,a,n=M.DEFAULT){const o=E(i,!1);function l(T){return T?()=>T(o.getTokenOffset(),o.getTokenLength()):()=>!0}function m(T){return T?O=>T(O,o.getTokenOffset(),o.getTokenLength()):()=>!0}const S=l(a.onObjectBegin),D=m(a.onObjectProperty),A=l(a.onObjectEnd),W=l(a.onArrayBegin),C=l(a.onArrayEnd),X=m(a.onLiteralValue),te=m(a.onSeparator),oe=l(a.onComment),Y=m(a.onError),Q=n&&n.disallowComments,_=n&&n.allowTrailingComma;function q(){for(;;){const T=o.scan();switch(o.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:Q||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(T){case 12:case 13:Q?z(10):oe();break;case 16:z(1);break;case 15:case 14:break;default:return T}}}function z(T,O=[],B=[]){if(Y(T),O.length+B.length>0){let N=o.getToken();for(;N!==17;){if(O.indexOf(N)!==-1){q();break}else if(B.indexOf(N)!==-1)break;N=q()}}}function $(T){const O=o.getTokenValue();return T?X(O):D(O),q(),!0}function H(){switch(o.getToken()){case 11:let T=0;try{T=JSON.parse(o.getTokenValue()),typeof T!="number"&&(z(2),T=0)}catch(O){z(2)}X(T);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return q(),!0}function U(){return o.getToken()!==10?(z(3,[],[2,5]),!1):($(!1),o.getToken()===6?(te(":"),q(),R()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function j(){S(),q();let T=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(T||z(4,[],[]),te(","),q(),o.getToken()===2&&_)break}else T&&z(6,[],[]);U()||z(4,[],[2,5]),T=!0}return A(),o.getToken()!==2?z(7,[2],[]):q(),!0}function F(){W(),q();let T=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(T||z(4,[],[]),te(","),q(),o.getToken()===4&&_)break}else T&&z(6,[],[]);R()||z(4,[],[4,5]),T=!0}return C(),o.getToken()!==4?z(8,[4],[]):q(),!0}function R(){switch(o.getToken()){case 3:return F();case 1:return j();case 10:return $(!0);default:return H()}}return q(),o.getToken()===17?n.allowEmptyContent?!0:(z(4,[],[]),!1):R()?(o.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=h;function s(i,a){let n=E(i),o=[],l,m=0,S;do switch(S=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:m!==S&&o.push(i.substring(m,S)),a!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,a)),m=n.getPosition();break}while(l!==17);return o.join("")}e.stripComments=s;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[103],Z([0,1,40]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,t){let P,b,p,d,g;if(w){for(d=w.offset,g=d+w.length,p=d;p>0&&!r(f,p-1);)p--;let m=g;for(;m<f.length&&!r(f,m);)m++;b=f.substring(p,m),P=M(b,t)}else b=f,P=0,p=0,d=0,g=f.length;const I=E(t,f);let y=!1,u=0,h;t.insertSpaces?h=k(" ",t.tabSize||4):h="	";const s=(0,v.createScanner)(b,!1);let c=!1;function i(){return I+k(h,P+u)}function a(){let m=s.scan();for(y=!1;m===15||m===14;)y=y||m===14,m=s.scan();return c=m===16||s.getTokenError()!==0,m}const n=[];function o(m,S,D){!c&&S<g&&D>d&&f.substring(S,D)!==m&&n.push({offset:S,length:D-S,content:m})}let l=a();if(l!==17){const m=s.getTokenOffset()+p,S=k(h,P);o(S,p,m)}for(;l!==17;){let m=s.getTokenOffset()+s.getTokenLength()+p,S=a(),D="";for(;!y&&(S===12||S===13);){const W=s.getTokenOffset()+p;o(" ",m,W),m=s.getTokenOffset()+s.getTokenLength()+p,D=S===12?i():"",S=a()}if(S===2)l!==1&&(u--,D=i());else if(S===4)l!==3&&(u--,D=i());else{switch(l){case 3:case 1:u++,D=i();break;case 5:case 12:D=i();break;case 13:y?D=i():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(c=!0);break;case 16:c=!0;break}y&&(S===12||S===13)&&(D=i())}const A=s.getTokenOffset()+p;o(D,m,A),l=S}return n}e.format=L;function k(f,w){let t="";for(let P=0;P<w;P++)t+=f;return t}function M(f,w){let t=0,P=0;const b=w.tabSize||4;for(;t<f.length;){const p=f.charAt(t);if(p===" ")P++;else if(p==="	")P+=b;else break;t++}return Math.floor(P/b)}function E(f,w){for(let t=0;t<w.length;t++){const P=w.charAt(t);if(P==="\r")return t+1<w.length&&w.charAt(t+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=E;function r(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=r}),define(J[77],Z([0,1,40,103]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,t,P){return M(w,t,void 0,P)}e.removeProperty=k;function M(w,t,P,b,p){const d=t.slice(),g=[],I=(0,v.parseTree)(w,g);let y,u;for(;d.length>0&&(u=d.pop(),y=(0,v.findNodeAtLocation)(I,d),y===void 0&&P!==void 0);)typeof u=="string"?P={[u]:P}:P=[P];if(y)if(y.type==="object"&&typeof u=="string"&&Array.isArray(y.children)){const h=(0,v.findNodeAtLocation)(y,[u]);if(h!==void 0)if(P===void 0){if(!h.parent)throw new Error("Malformed AST");const s=y.children.indexOf(h.parent);let c,i=h.parent.offset+h.parent.length;if(s>0){const a=y.children[s-1];c=a.offset+a.length}else c=y.offset+1,y.children.length>1&&(i=y.children[1].offset);return E(w,{offset:c,length:i-c,content:""},b)}else return E(w,{offset:h.offset,length:h.length,content:JSON.stringify(P)},b);else{if(P===void 0)return[];const s=`${JSON.stringify(u)}: ${JSON.stringify(P)}`,c=p?p(y.children.map(a=>a.children[0].value)):y.children.length;let i;if(c>0){const a=y.children[c-1];i={offset:a.offset+a.length,length:0,content:","+s}}else y.children.length===0?i={offset:y.offset+1,length:0,content:s}:i={offset:y.offset+1,length:0,content:s+","};return E(w,i,b)}}else if(y.type==="array"&&typeof u=="number"&&Array.isArray(y.children))if(P!==void 0){const h=`${JSON.stringify(P)}`;let s;if(y.children.length===0||u===0)s={offset:y.offset+1,length:0,content:y.children.length===0?h:h+","};else{const c=u===-1||u>y.children.length?y.children.length:u,i=y.children[c-1];s={offset:i.offset+i.length,length:0,content:","+h}}return E(w,s,b)}else{const h=u,s=y.children[h];let c;if(y.children.length===1)c={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===h){const i=y.children[h-1],a=i.offset+i.length,n=y.offset+y.length;c={offset:a,length:n-2-a,content:""}}else c={offset:s.offset,length:y.children[h+1].offset-s.offset,content:""};return E(w,c,b)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${y.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return E(w,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(P)},b)}}e.setProperty=M;function E(w,t,P){let b=r(w,t),p=t.offset,d=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;p>0&&!(0,L.isEOL)(b,p-1);)p--;for(;d<b.length&&!(0,L.isEOL)(b,d);)d++}const g=(0,L.format)(b,{offset:p,length:d-p},P);for(let y=g.length-1;y>=0;y--){const u=g[y];b=r(b,u),p=Math.min(p,u.offset),d=Math.max(d,u.offset+u.length),d+=u.content.length-u.length}const I=w.length-(b.length-d)-p;return[{offset:p,length:I,content:b.substring(p,d)}]}e.withFormatting=E;function r(w,t){return w.substring(0,t.offset)+t.content+w.substring(t.offset+t.length)}e.applyEdit=r;function f(w,t){let P=t.slice(0).sort((p,d)=>{const g=p.offset-d.offset;return g===0?p.length-d.length:g}),b=w.length;for(let p=P.length-1;p>=0;p--){let d=P[p];if(d.offset+d.length<=b)w=r(w,d);else throw new Error("Overlapping edit");b=d.offset}return w}e.applyEdits=f}),define(J[57],Z([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(u){u[u.DependsOnKbLayout=-1]="DependsOnKbLayout",u[u.Unknown=0]="Unknown",u[u.Backspace=1]="Backspace",u[u.Tab=2]="Tab",u[u.Enter=3]="Enter",u[u.Shift=4]="Shift",u[u.Ctrl=5]="Ctrl",u[u.Alt=6]="Alt",u[u.PauseBreak=7]="PauseBreak",u[u.CapsLock=8]="CapsLock",u[u.Escape=9]="Escape",u[u.Space=10]="Space",u[u.PageUp=11]="PageUp",u[u.PageDown=12]="PageDown",u[u.End=13]="End",u[u.Home=14]="Home",u[u.LeftArrow=15]="LeftArrow",u[u.UpArrow=16]="UpArrow",u[u.RightArrow=17]="RightArrow",u[u.DownArrow=18]="DownArrow",u[u.Insert=19]="Insert",u[u.Delete=20]="Delete",u[u.KEY_0=21]="KEY_0",u[u.KEY_1=22]="KEY_1",u[u.KEY_2=23]="KEY_2",u[u.KEY_3=24]="KEY_3",u[u.KEY_4=25]="KEY_4",u[u.KEY_5=26]="KEY_5",u[u.KEY_6=27]="KEY_6",u[u.KEY_7=28]="KEY_7",u[u.KEY_8=29]="KEY_8",u[u.KEY_9=30]="KEY_9",u[u.KEY_A=31]="KEY_A",u[u.KEY_B=32]="KEY_B",u[u.KEY_C=33]="KEY_C",u[u.KEY_D=34]="KEY_D",u[u.KEY_E=35]="KEY_E",u[u.KEY_F=36]="KEY_F",u[u.KEY_G=37]="KEY_G",u[u.KEY_H=38]="KEY_H",u[u.KEY_I=39]="KEY_I",u[u.KEY_J=40]="KEY_J",u[u.KEY_K=41]="KEY_K",u[u.KEY_L=42]="KEY_L",u[u.KEY_M=43]="KEY_M",u[u.KEY_N=44]="KEY_N",u[u.KEY_O=45]="KEY_O",u[u.KEY_P=46]="KEY_P",u[u.KEY_Q=47]="KEY_Q",u[u.KEY_R=48]="KEY_R",u[u.KEY_S=49]="KEY_S",u[u.KEY_T=50]="KEY_T",u[u.KEY_U=51]="KEY_U",u[u.KEY_V=52]="KEY_V",u[u.KEY_W=53]="KEY_W",u[u.KEY_X=54]="KEY_X",u[u.KEY_Y=55]="KEY_Y",u[u.KEY_Z=56]="KEY_Z",u[u.Meta=57]="Meta",u[u.ContextMenu=58]="ContextMenu",u[u.F1=59]="F1",u[u.F2=60]="F2",u[u.F3=61]="F3",u[u.F4=62]="F4",u[u.F5=63]="F5",u[u.F6=64]="F6",u[u.F7=65]="F7",u[u.F8=66]="F8",u[u.F9=67]="F9",u[u.F10=68]="F10",u[u.F11=69]="F11",u[u.F12=70]="F12",u[u.F13=71]="F13",u[u.F14=72]="F14",u[u.F15=73]="F15",u[u.F16=74]="F16",u[u.F17=75]="F17",u[u.F18=76]="F18",u[u.F19=77]="F19",u[u.NumLock=78]="NumLock",u[u.ScrollLock=79]="ScrollLock",u[u.US_SEMICOLON=80]="US_SEMICOLON",u[u.US_EQUAL=81]="US_EQUAL",u[u.US_COMMA=82]="US_COMMA",u[u.US_MINUS=83]="US_MINUS",u[u.US_DOT=84]="US_DOT",u[u.US_SLASH=85]="US_SLASH",u[u.US_BACKTICK=86]="US_BACKTICK",u[u.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",u[u.US_BACKSLASH=88]="US_BACKSLASH",u[u.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",u[u.US_QUOTE=90]="US_QUOTE",u[u.OEM_8=91]="OEM_8",u[u.OEM_102=92]="OEM_102",u[u.NUMPAD_0=93]="NUMPAD_0",u[u.NUMPAD_1=94]="NUMPAD_1",u[u.NUMPAD_2=95]="NUMPAD_2",u[u.NUMPAD_3=96]="NUMPAD_3",u[u.NUMPAD_4=97]="NUMPAD_4",u[u.NUMPAD_5=98]="NUMPAD_5",u[u.NUMPAD_6=99]="NUMPAD_6",u[u.NUMPAD_7=100]="NUMPAD_7",u[u.NUMPAD_8=101]="NUMPAD_8",u[u.NUMPAD_9=102]="NUMPAD_9",u[u.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",u[u.NUMPAD_ADD=104]="NUMPAD_ADD",u[u.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",u[u.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",u[u.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",u[u.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",u[u.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",u[u.ABNT_C1=110]="ABNT_C1",u[u.ABNT_C2=111]="ABNT_C2",u[u.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,s){this._keyCodeToStr[h]=s,this._strToKeyCode[s.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const M=new k,E=new k,r=new k;(function(){function u(h,s,c=s,i=c){M.define(h,s),E.define(h,c),r.define(h,i)}u(0,"unknown"),u(1,"Backspace"),u(2,"Tab"),u(3,"Enter"),u(4,"Shift"),u(5,"Ctrl"),u(6,"Alt"),u(7,"PauseBreak"),u(8,"CapsLock"),u(9,"Escape"),u(10,"Space"),u(11,"PageUp"),u(12,"PageDown"),u(13,"End"),u(14,"Home"),u(15,"LeftArrow","Left"),u(16,"UpArrow","Up"),u(17,"RightArrow","Right"),u(18,"DownArrow","Down"),u(19,"Insert"),u(20,"Delete"),u(21,"0"),u(22,"1"),u(23,"2"),u(24,"3"),u(25,"4"),u(26,"5"),u(27,"6"),u(28,"7"),u(29,"8"),u(30,"9"),u(31,"A"),u(32,"B"),u(33,"C"),u(34,"D"),u(35,"E"),u(36,"F"),u(37,"G"),u(38,"H"),u(39,"I"),u(40,"J"),u(41,"K"),u(42,"L"),u(43,"M"),u(44,"N"),u(45,"O"),u(46,"P"),u(47,"Q"),u(48,"R"),u(49,"S"),u(50,"T"),u(51,"U"),u(52,"V"),u(53,"W"),u(54,"X"),u(55,"Y"),u(56,"Z"),u(57,"Meta"),u(58,"ContextMenu"),u(59,"F1"),u(60,"F2"),u(61,"F3"),u(62,"F4"),u(63,"F5"),u(64,"F6"),u(65,"F7"),u(66,"F8"),u(67,"F9"),u(68,"F10"),u(69,"F11"),u(70,"F12"),u(71,"F13"),u(72,"F14"),u(73,"F15"),u(74,"F16"),u(75,"F17"),u(76,"F18"),u(77,"F19"),u(78,"NumLock"),u(79,"ScrollLock"),u(80,";",";","OEM_1"),u(81,"=","=","OEM_PLUS"),u(82,",",",","OEM_COMMA"),u(83,"-","-","OEM_MINUS"),u(84,".",".","OEM_PERIOD"),u(85,"/","/","OEM_2"),u(86,"`","`","OEM_3"),u(110,"ABNT_C1"),u(111,"ABNT_C2"),u(87,"[","[","OEM_4"),u(88,"\\","\\","OEM_5"),u(89,"]","]","OEM_6"),u(90,"'","'","OEM_7"),u(91,"OEM_8"),u(92,"OEM_102"),u(93,"NumPad0"),u(94,"NumPad1"),u(95,"NumPad2"),u(96,"NumPad3"),u(97,"NumPad4"),u(98,"NumPad5"),u(99,"NumPad6"),u(100,"NumPad7"),u(101,"NumPad8"),u(102,"NumPad9"),u(103,"NumPad_Multiply"),u(104,"NumPad_Add"),u(105,"NumPad_Separator"),u(106,"NumPad_Subtract"),u(107,"NumPad_Decimal"),u(108,"NumPad_Divide")})();var f;(function(u){function h(n){return M.keyCodeToStr(n)}u.toString=h;function s(n){return M.strToKeyCode(n)}u.fromString=s;function c(n){return E.keyCodeToStr(n)}u.toUserSettingsUS=c;function i(n){return r.keyCodeToStr(n)}u.toUserSettingsGeneral=i;function a(n){return E.strToKeyCode(n)||r.strToKeyCode(n)}u.fromUserSettings=a})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl",u[u.KeyCode=255]="KeyCode"})(w||(w={}));var t;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function P(u,h){const s=(h&65535)<<16>>>0;return(u|s)>>>0}e.KeyChord=P;function b(u,h){if(u===0)return null;const s=(u&65535)>>>0,c=(u&4294901760)>>>16;return c!==0?new g([p(s,h),p(c,h)]):new g([p(s,h)])}e.createKeybinding=b;function p(u,h){const s=!!(u&2048),c=!!(u&256),i=h===2?c:s,a=!!(u&1024),n=!!(u&512),o=h===2?s:c,l=u&255;return new d(i,a,n,o,l)}e.createSimpleKeybinding=p;class d{constructor(h,s,c,i,a){this.ctrlKey=h,this.shiftKey=s,this.altKey=c,this.metaKey=i,this.keyCode=a}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",c=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${h}${s}${c}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(h){if(h.length===0)throw(0,v.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let s=0,c=this.parts.length;s<c;s++)s!==0&&(h+=";"),h+=this.parts[s].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let s=0;s<this.parts.length;s++)if(!this.parts[s].equals(h.parts[s]))return!1;return!0}}e.ChordKeybinding=g;class I{constructor(h,s,c,i,a,n){this.ctrlKey=h,this.shiftKey=s,this.altKey=c,this.metaKey=i,this.keyLabel=a,this.keyAriaLabel=n}}e.ResolvedKeybindingPart=I;class y{}e.ResolvedKeybinding=y}),define(J[2],Z([0,1,43,63]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function E(n){M=n}if(e.setDisposableTracker=E,k){const n="__is_disposable_tracked__";E(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[n]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==u.None)try{o[n]=!0}catch{}}markAsDisposed(o){if(o&&o!==u.None)try{o[n]=!0}catch{}}markAsSingleton(o){}})}function r(n){return M?.trackDisposable(n),n}function f(n){M?.markAsDisposed(n)}function w(n,o){M?.setParent(n,o)}function t(n,o){if(!!M)for(const l of n)M.setParent(l,o)}function P(n){return M?.markAsSingleton(n),n}e.markAsSingleton=P;class b extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=b;function p(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=p;function d(n){if(L.Iterable.is(n)){let o=[];for(const l of n)if(l)try{l.dispose()}catch(m){o.push(m)}if(o.length===1)throw o[0];if(o.length>1)throw new b(o);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=d;function g(...n){const o=I(()=>d(n));return t(n,o),o}e.combinedDisposable=g;function I(n){const o=r({dispose:(0,v.once)(()=>{f(o),n()})});return o}e.toDisposable=I;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,r(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return w(o,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new y,r(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,r(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&w(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&w(o,null),o}}e.MutableDisposable=h;class s{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class c{constructor(){this.references=new Map}acquire(o,...l){let m=this.references.get(o);m||(m={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,m));const{object:S}=m,D=(0,v.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(o,m.object),this.references.delete(o))});return m.counter++,{object:S,dispose:D}}}e.ReferenceCollection=c;class i{constructor(o){this.referenceCollection=o}async acquire(o,...l){const m=this.referenceCollection.acquire(o,...l);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(S){throw m.dispose(),S}}}e.AsyncReferenceCollection=i;class a{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=a}),define(J[104],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(M){this.element=M,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let M=this._first;for(;M!==v.Undefined;){const E=M.next;M.prev=v.Undefined,M.next=v.Undefined,M=E}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,E){const r=new v(M);if(this._first===v.Undefined)this._first=r,this._last=r;else if(E){const w=this._last;this._last=r,r.prev=w,w.next=r}else{const w=this._first;this._first=r,r.next=w,w.prev=r}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(r))}}shift(){if(this._first!==v.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==v.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==v.Undefined&&M.next!==v.Undefined){const E=M.prev;E.next=M.next,M.next.prev=E}else M.prev===v.Undefined&&M.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):M.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):M.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==v.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function K(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function E(f){M.push(f,Date.now())}function r(){const f=[];for(let w=0;w<M.length;w+=2)f.push({name:M[w],startTime:M[w+1]});return f}return{mark:E,getMarks:r}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const E of performance.getEntriesByType("mark"))M.push({name:E.name,startTime:Math.round(k+E.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(J[3],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let L=!1,k=!1,M=!1,E=!1,r=!1,f=!1,w=!1,t,P=v,b,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=g&&d?.sandboxed,typeof navigator=="object"&&!g)p=navigator.userAgent,L=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,w=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=p.indexOf("Linux")>=0,f=!0,t=navigator.language,P=t;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",M=d.platform==="linux",E=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,t=v,P=v;const n=d.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),l=o.availableLanguages["*"];t=o.locale,P=l||v,b=o._translationsConfigFile}catch(o){}r=!0}else console.error("Unable to resolve platform.");var I;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function y(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let u=0;k?u=1:L?u=3:M&&(u=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=E,e.isNative=r,e.isWeb=f,e.isIOS=w,e.platform=u,e.userAgent=p,e.language=P;var h;(function(n){function o(){return e.language}n.value=o;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=l;function m(){return e.language==="en"}n.isDefault=m})(h=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let D=0,A=l.length;D<A;D++){const W=l[D];if(W.id===S.data.vscodeSetImmediateId){l.splice(D,1),W.callback();return}}});let m=0;return S=>{const D=++m;l.push({id:D,callback:S}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const o=Promise.resolve();return l=>o.then(l)}();var s;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||w?2:L?1:3;let c=!0,i=!1;function a(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,c=new Uint16Array(n.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=a}),define(J[32],Z([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,v.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,v.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(J[8],Z([0,1,32]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,M=90,E=122,r=46,f=47,w=92,t=58,P=63;class b extends Error{constructor(s,c,i){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const n=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${n} ${a} of type ${c}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function p(h,s){if(typeof h!="string")throw new b(s,"string",h)}function d(h){return h===f||h===w}function g(h){return h===f}function I(h){return h>=L&&h<=M||h>=k&&h<=E}function y(h,s,c,i){let a="",n=0,o=-1,l=0,m=0;for(let S=0;S<=h.length;++S){if(S<h.length)m=h.charCodeAt(S);else{if(i(m))break;m=f}if(i(m)){if(!(o===S-1||l===1))if(l===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==r||a.charCodeAt(a.length-2)!==r){if(a.length>2){const D=a.lastIndexOf(c);D===-1?(a="",n=0):(a=a.slice(0,D),n=a.length-1-a.lastIndexOf(c)),o=S,l=0;continue}else if(a.length!==0){a="",n=0,o=S,l=0;continue}}s&&(a+=a.length>0?`${c}..`:"..",n=2)}else a.length>0?a+=`${c}${h.slice(o+1,S)}`:a=h.slice(o+1,S),n=S-o-1;o=S,l=0}else m===r&&l!==-1?++l:l=-1}return a}function u(h,s){if(s===null||typeof s!="object")throw new b("pathObject","Object",s);const c=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return c?c===s.root?`${c}${i}`:`${c}${h}${i}`:i}e.win32={resolve(...h){let s="",c="",i=!1;for(let a=h.length-1;a>=-1;a--){let n;if(a>=0){if(n=h[a],p(n,"path"),n.length===0)continue}else s.length===0?n=v.cwd():(n=v.env[`=${s}`]||v.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==s.toLowerCase()&&n.charCodeAt(2)===w)&&(n=`${s}\\`));const o=n.length;let l=0,m="",S=!1;const D=n.charCodeAt(0);if(o===1)d(D)&&(l=1,S=!0);else if(d(D))if(S=!0,d(n.charCodeAt(1))){let A=2,W=A;for(;A<o&&!d(n.charCodeAt(A));)A++;if(A<o&&A!==W){const C=n.slice(W,A);for(W=A;A<o&&d(n.charCodeAt(A));)A++;if(A<o&&A!==W){for(W=A;A<o&&!d(n.charCodeAt(A));)A++;(A===o||A!==W)&&(m=`\\\\${C}\\${n.slice(W,A)}`,l=A)}}}else l=1;else I(D)&&n.charCodeAt(1)===t&&(m=n.slice(0,2),l=2,o>2&&d(n.charCodeAt(2))&&(S=!0,l=3));if(m.length>0)if(s.length>0){if(m.toLowerCase()!==s.toLowerCase())continue}else s=m;if(i){if(s.length>0)break}else if(c=`${n.slice(l)}\\${c}`,i=S,S&&s.length>0)break}return c=y(c,!i,"\\",d),i?`${s}\\${c}`:`${s}${c}`||"."},normalize(h){p(h,"path");const s=h.length;if(s===0)return".";let c=0,i,a=!1;const n=h.charCodeAt(0);if(s===1)return g(n)?"\\":h;if(d(n))if(a=!0,d(h.charCodeAt(1))){let l=2,m=l;for(;l<s&&!d(h.charCodeAt(l));)l++;if(l<s&&l!==m){const S=h.slice(m,l);for(m=l;l<s&&d(h.charCodeAt(l));)l++;if(l<s&&l!==m){for(m=l;l<s&&!d(h.charCodeAt(l));)l++;if(l===s)return`\\\\${S}\\${h.slice(m)}\\`;l!==m&&(i=`\\\\${S}\\${h.slice(m,l)}`,c=l)}}}else c=1;else I(n)&&h.charCodeAt(1)===t&&(i=h.slice(0,2),c=2,s>2&&d(h.charCodeAt(2))&&(a=!0,c=3));let o=c<s?y(h.slice(c),!a,"\\",d):"";return o.length===0&&!a&&(o="."),o.length>0&&d(h.charCodeAt(s-1))&&(o+="\\"),i===void 0?a?`\\${o}`:o:a?`${i}\\${o}`:`${i}${o}`},isAbsolute(h){p(h,"path");const s=h.length;if(s===0)return!1;const c=h.charCodeAt(0);return d(c)||s>2&&I(c)&&h.charCodeAt(1)===t&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let s,c;for(let n=0;n<h.length;++n){const o=h[n];p(o,"path"),o.length>0&&(s===void 0?s=c=o:s+=`\\${o}`)}if(s===void 0)return".";let i=!0,a=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++a;const n=c.length;n>1&&d(c.charCodeAt(1))&&(++a,n>2&&(d(c.charCodeAt(2))?++a:i=!1))}if(i){for(;a<s.length&&d(s.charCodeAt(a));)a++;a>=2&&(s=`\\${s.slice(a)}`)}return e.win32.normalize(s)},relative(h,s){if(p(h,"from"),p(s,"to"),h===s)return"";const c=e.win32.resolve(h),i=e.win32.resolve(s);if(c===i||(h=c.toLowerCase(),s=i.toLowerCase(),h===s))return"";let a=0;for(;a<h.length&&h.charCodeAt(a)===w;)a++;let n=h.length;for(;n-1>a&&h.charCodeAt(n-1)===w;)n--;const o=n-a;let l=0;for(;l<s.length&&s.charCodeAt(l)===w;)l++;let m=s.length;for(;m-1>l&&s.charCodeAt(m-1)===w;)m--;const S=m-l,D=o<S?o:S;let A=-1,W=0;for(;W<D;W++){const X=h.charCodeAt(a+W);if(X!==s.charCodeAt(l+W))break;X===w&&(A=W)}if(W!==D){if(A===-1)return i}else{if(S>D){if(s.charCodeAt(l+W)===w)return i.slice(l+W+1);if(W===2)return i.slice(l+W)}o>D&&(h.charCodeAt(a+W)===w?A=W:W===2&&(A=3)),A===-1&&(A=0)}let C="";for(W=a+A+1;W<=n;++W)(W===n||h.charCodeAt(W)===w)&&(C+=C.length===0?"..":"\\..");return l+=A,C.length>0?`${C}${i.slice(l,m)}`:(i.charCodeAt(l)===w&&++l,i.slice(l,m))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const s=e.win32.resolve(h);if(s.length<=2)return h;if(s.charCodeAt(0)===w){if(s.charCodeAt(1)===w){const c=s.charCodeAt(2);if(c!==P&&c!==r)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(I(s.charCodeAt(0))&&s.charCodeAt(1)===t&&s.charCodeAt(2)===w)return`\\\\?\\${s}`;return h},dirname(h){p(h,"path");const s=h.length;if(s===0)return".";let c=-1,i=0;const a=h.charCodeAt(0);if(s===1)return d(a)?h:".";if(d(a)){if(c=i=1,d(h.charCodeAt(1))){let l=2,m=l;for(;l<s&&!d(h.charCodeAt(l));)l++;if(l<s&&l!==m){for(m=l;l<s&&d(h.charCodeAt(l));)l++;if(l<s&&l!==m){for(m=l;l<s&&!d(h.charCodeAt(l));)l++;if(l===s)return h;l!==m&&(c=i=l+1)}}}}else I(a)&&h.charCodeAt(1)===t&&(c=s>2&&d(h.charCodeAt(2))?3:2,i=c);let n=-1,o=!0;for(let l=s-1;l>=i;--l)if(d(h.charCodeAt(l))){if(!o){n=l;break}}else o=!1;if(n===-1){if(c===-1)return".";n=c}return h.slice(0,n)},basename(h,s){s!==void 0&&p(s,"ext"),p(h,"path");let c=0,i=-1,a=!0,n;if(h.length>=2&&I(h.charCodeAt(0))&&h.charCodeAt(1)===t&&(c=2),s!==void 0&&s.length>0&&s.length<=h.length){if(s===h)return"";let o=s.length-1,l=-1;for(n=h.length-1;n>=c;--n){const m=h.charCodeAt(n);if(d(m)){if(!a){c=n+1;break}}else l===-1&&(a=!1,l=n+1),o>=0&&(m===s.charCodeAt(o)?--o==-1&&(i=n):(o=-1,i=l))}return c===i?i=l:i===-1&&(i=h.length),h.slice(c,i)}for(n=h.length-1;n>=c;--n)if(d(h.charCodeAt(n))){if(!a){c=n+1;break}}else i===-1&&(a=!1,i=n+1);return i===-1?"":h.slice(c,i)},extname(h){p(h,"path");let s=0,c=-1,i=0,a=-1,n=!0,o=0;h.length>=2&&h.charCodeAt(1)===t&&I(h.charCodeAt(0))&&(s=i=2);for(let l=h.length-1;l>=s;--l){const m=h.charCodeAt(l);if(d(m)){if(!n){i=l+1;break}continue}a===-1&&(n=!1,a=l+1),m===r?c===-1?c=l:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||a===-1||o===0||o===1&&c===a-1&&c===i+1?"":h.slice(c,a)},format:u.bind(null,"\\"),parse(h){p(h,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return s;const c=h.length;let i=0,a=h.charCodeAt(0);if(c===1)return d(a)?(s.root=s.dir=h,s):(s.base=s.name=h,s);if(d(a)){if(i=1,d(h.charCodeAt(1))){let A=2,W=A;for(;A<c&&!d(h.charCodeAt(A));)A++;if(A<c&&A!==W){for(W=A;A<c&&d(h.charCodeAt(A));)A++;if(A<c&&A!==W){for(W=A;A<c&&!d(h.charCodeAt(A));)A++;A===c?i=A:A!==W&&(i=A+1)}}}}else if(I(a)&&h.charCodeAt(1)===t){if(c<=2)return s.root=s.dir=h,s;if(i=2,d(h.charCodeAt(2))){if(c===3)return s.root=s.dir=h,s;i=3}}i>0&&(s.root=h.slice(0,i));let n=-1,o=i,l=-1,m=!0,S=h.length-1,D=0;for(;S>=i;--S){if(a=h.charCodeAt(S),d(a)){if(!m){o=S+1;break}continue}l===-1&&(m=!1,l=S+1),a===r?n===-1?n=S:D!==1&&(D=1):n!==-1&&(D=-1)}return l!==-1&&(n===-1||D===0||D===1&&n===l-1&&n===o+1?s.base=s.name=h.slice(o,l):(s.name=h.slice(o,n),s.base=h.slice(o,l),s.ext=h.slice(n,l))),o>0&&o!==i?s.dir=h.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let s="",c=!1;for(let i=h.length-1;i>=-1&&!c;i--){const a=i>=0?h[i]:v.cwd();p(a,"path"),a.length!==0&&(s=`${a}/${s}`,c=a.charCodeAt(0)===f)}return s=y(s,!c,"/",g),c?`/${s}`:s.length>0?s:"."},normalize(h){if(p(h,"path"),h.length===0)return".";const s=h.charCodeAt(0)===f,c=h.charCodeAt(h.length-1)===f;return h=y(h,!s,"/",g),h.length===0?s?"/":c?"./":".":(c&&(h+="/"),s?`/${h}`:h)},isAbsolute(h){return p(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let s;for(let c=0;c<h.length;++c){const i=h[c];p(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.posix.normalize(s)},relative(h,s){if(p(h,"from"),p(s,"to"),h===s||(h=e.posix.resolve(h),s=e.posix.resolve(s),h===s))return"";const c=1,i=h.length,a=i-c,n=1,o=s.length-n,l=a<o?a:o;let m=-1,S=0;for(;S<l;S++){const A=h.charCodeAt(c+S);if(A!==s.charCodeAt(n+S))break;A===f&&(m=S)}if(S===l)if(o>l){if(s.charCodeAt(n+S)===f)return s.slice(n+S+1);if(S===0)return s.slice(n+S)}else a>l&&(h.charCodeAt(c+S)===f?m=S:S===0&&(m=0));let D="";for(S=c+m+1;S<=i;++S)(S===i||h.charCodeAt(S)===f)&&(D+=D.length===0?"..":"/..");return`${D}${s.slice(n+m)}`},toNamespacedPath(h){return h},dirname(h){if(p(h,"path"),h.length===0)return".";const s=h.charCodeAt(0)===f;let c=-1,i=!0;for(let a=h.length-1;a>=1;--a)if(h.charCodeAt(a)===f){if(!i){c=a;break}}else i=!1;return c===-1?s?"/":".":s&&c===1?"//":h.slice(0,c)},basename(h,s){s!==void 0&&p(s,"ext"),p(h,"path");let c=0,i=-1,a=!0,n;if(s!==void 0&&s.length>0&&s.length<=h.length){if(s===h)return"";let o=s.length-1,l=-1;for(n=h.length-1;n>=0;--n){const m=h.charCodeAt(n);if(m===f){if(!a){c=n+1;break}}else l===-1&&(a=!1,l=n+1),o>=0&&(m===s.charCodeAt(o)?--o==-1&&(i=n):(o=-1,i=l))}return c===i?i=l:i===-1&&(i=h.length),h.slice(c,i)}for(n=h.length-1;n>=0;--n)if(h.charCodeAt(n)===f){if(!a){c=n+1;break}}else i===-1&&(a=!1,i=n+1);return i===-1?"":h.slice(c,i)},extname(h){p(h,"path");let s=-1,c=0,i=-1,a=!0,n=0;for(let o=h.length-1;o>=0;--o){const l=h.charCodeAt(o);if(l===f){if(!a){c=o+1;break}continue}i===-1&&(a=!1,i=o+1),l===r?s===-1?s=o:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||i===-1||n===0||n===1&&s===i-1&&s===c+1?"":h.slice(s,i)},format:u.bind(null,"/"),parse(h){p(h,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return s;const c=h.charCodeAt(0)===f;let i;c?(s.root="/",i=1):i=0;let a=-1,n=0,o=-1,l=!0,m=h.length-1,S=0;for(;m>=i;--m){const D=h.charCodeAt(m);if(D===f){if(!l){n=m+1;break}continue}o===-1&&(l=!1,o=m+1),D===r?a===-1?a=m:S!==1&&(S=1):a!==-1&&(S=-1)}if(o!==-1){const D=n===0&&c?1:n;a===-1||S===0||S===1&&a===o-1&&a===n+1?s.base=s.name=h.slice(D,o):(s.name=h.slice(D,a),s.base=h.slice(D,o),s.ext=h.slice(a,o))}return n>0?s.dir=h.slice(0,n-1):c&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...E){const r=E.reduce((t,P)=>(t[P]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(t=>!r[t]).forEach(t=>{for(let P=0;P<f.length;P++)if(t.search(f[P])!==-1){delete M[t];break}})}e.sanitizeProcessEnvironment=k}),define(J[78],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.None=0]="None",r[r.Hyper=1]="Hyper",r[r.Super=2]="Super",r[r.Fn=3]="Fn",r[r.FnLock=4]="FnLock",r[r.Suspend=5]="Suspend",r[r.Resume=6]="Resume",r[r.Turbo=7]="Turbo",r[r.Sleep=8]="Sleep",r[r.WakeUp=9]="WakeUp",r[r.KeyA=10]="KeyA",r[r.KeyB=11]="KeyB",r[r.KeyC=12]="KeyC",r[r.KeyD=13]="KeyD",r[r.KeyE=14]="KeyE",r[r.KeyF=15]="KeyF",r[r.KeyG=16]="KeyG",r[r.KeyH=17]="KeyH",r[r.KeyI=18]="KeyI",r[r.KeyJ=19]="KeyJ",r[r.KeyK=20]="KeyK",r[r.KeyL=21]="KeyL",r[r.KeyM=22]="KeyM",r[r.KeyN=23]="KeyN",r[r.KeyO=24]="KeyO",r[r.KeyP=25]="KeyP",r[r.KeyQ=26]="KeyQ",r[r.KeyR=27]="KeyR",r[r.KeyS=28]="KeyS",r[r.KeyT=29]="KeyT",r[r.KeyU=30]="KeyU",r[r.KeyV=31]="KeyV",r[r.KeyW=32]="KeyW",r[r.KeyX=33]="KeyX",r[r.KeyY=34]="KeyY",r[r.KeyZ=35]="KeyZ",r[r.Digit1=36]="Digit1",r[r.Digit2=37]="Digit2",r[r.Digit3=38]="Digit3",r[r.Digit4=39]="Digit4",r[r.Digit5=40]="Digit5",r[r.Digit6=41]="Digit6",r[r.Digit7=42]="Digit7",r[r.Digit8=43]="Digit8",r[r.Digit9=44]="Digit9",r[r.Digit0=45]="Digit0",r[r.Enter=46]="Enter",r[r.Escape=47]="Escape",r[r.Backspace=48]="Backspace",r[r.Tab=49]="Tab",r[r.Space=50]="Space",r[r.Minus=51]="Minus",r[r.Equal=52]="Equal",r[r.BracketLeft=53]="BracketLeft",r[r.BracketRight=54]="BracketRight",r[r.Backslash=55]="Backslash",r[r.IntlHash=56]="IntlHash",r[r.Semicolon=57]="Semicolon",r[r.Quote=58]="Quote",r[r.Backquote=59]="Backquote",r[r.Comma=60]="Comma",r[r.Period=61]="Period",r[r.Slash=62]="Slash",r[r.CapsLock=63]="CapsLock",r[r.F1=64]="F1",r[r.F2=65]="F2",r[r.F3=66]="F3",r[r.F4=67]="F4",r[r.F5=68]="F5",r[r.F6=69]="F6",r[r.F7=70]="F7",r[r.F8=71]="F8",r[r.F9=72]="F9",r[r.F10=73]="F10",r[r.F11=74]="F11",r[r.F12=75]="F12",r[r.PrintScreen=76]="PrintScreen",r[r.ScrollLock=77]="ScrollLock",r[r.Pause=78]="Pause",r[r.Insert=79]="Insert",r[r.Home=80]="Home",r[r.PageUp=81]="PageUp",r[r.Delete=82]="Delete",r[r.End=83]="End",r[r.PageDown=84]="PageDown",r[r.ArrowRight=85]="ArrowRight",r[r.ArrowLeft=86]="ArrowLeft",r[r.ArrowDown=87]="ArrowDown",r[r.ArrowUp=88]="ArrowUp",r[r.NumLock=89]="NumLock",r[r.NumpadDivide=90]="NumpadDivide",r[r.NumpadMultiply=91]="NumpadMultiply",r[r.NumpadSubtract=92]="NumpadSubtract",r[r.NumpadAdd=93]="NumpadAdd",r[r.NumpadEnter=94]="NumpadEnter",r[r.Numpad1=95]="Numpad1",r[r.Numpad2=96]="Numpad2",r[r.Numpad3=97]="Numpad3",r[r.Numpad4=98]="Numpad4",r[r.Numpad5=99]="Numpad5",r[r.Numpad6=100]="Numpad6",r[r.Numpad7=101]="Numpad7",r[r.Numpad8=102]="Numpad8",r[r.Numpad9=103]="Numpad9",r[r.Numpad0=104]="Numpad0",r[r.NumpadDecimal=105]="NumpadDecimal",r[r.IntlBackslash=106]="IntlBackslash",r[r.ContextMenu=107]="ContextMenu",r[r.Power=108]="Power",r[r.NumpadEqual=109]="NumpadEqual",r[r.F13=110]="F13",r[r.F14=111]="F14",r[r.F15=112]="F15",r[r.F16=113]="F16",r[r.F17=114]="F17",r[r.F18=115]="F18",r[r.F19=116]="F19",r[r.F20=117]="F20",r[r.F21=118]="F21",r[r.F22=119]="F22",r[r.F23=120]="F23",r[r.F24=121]="F24",r[r.Open=122]="Open",r[r.Help=123]="Help",r[r.Select=124]="Select",r[r.Again=125]="Again",r[r.Undo=126]="Undo",r[r.Cut=127]="Cut",r[r.Copy=128]="Copy",r[r.Paste=129]="Paste",r[r.Find=130]="Find",r[r.AudioVolumeMute=131]="AudioVolumeMute",r[r.AudioVolumeUp=132]="AudioVolumeUp",r[r.AudioVolumeDown=133]="AudioVolumeDown",r[r.NumpadComma=134]="NumpadComma",r[r.IntlRo=135]="IntlRo",r[r.KanaMode=136]="KanaMode",r[r.IntlYen=137]="IntlYen",r[r.Convert=138]="Convert",r[r.NonConvert=139]="NonConvert",r[r.Lang1=140]="Lang1",r[r.Lang2=141]="Lang2",r[r.Lang3=142]="Lang3",r[r.Lang4=143]="Lang4",r[r.Lang5=144]="Lang5",r[r.Abort=145]="Abort",r[r.Props=146]="Props",r[r.NumpadParenLeft=147]="NumpadParenLeft",r[r.NumpadParenRight=148]="NumpadParenRight",r[r.NumpadBackspace=149]="NumpadBackspace",r[r.NumpadMemoryStore=150]="NumpadMemoryStore",r[r.NumpadMemoryRecall=151]="NumpadMemoryRecall",r[r.NumpadMemoryClear=152]="NumpadMemoryClear",r[r.NumpadMemoryAdd=153]="NumpadMemoryAdd",r[r.NumpadMemorySubtract=154]="NumpadMemorySubtract",r[r.NumpadClear=155]="NumpadClear",r[r.NumpadClearEntry=156]="NumpadClearEntry",r[r.ControlLeft=157]="ControlLeft",r[r.ShiftLeft=158]="ShiftLeft",r[r.AltLeft=159]="AltLeft",r[r.MetaLeft=160]="MetaLeft",r[r.ControlRight=161]="ControlRight",r[r.ShiftRight=162]="ShiftRight",r[r.AltRight=163]="AltRight",r[r.MetaRight=164]="MetaRight",r[r.BrightnessUp=165]="BrightnessUp",r[r.BrightnessDown=166]="BrightnessDown",r[r.MediaPlay=167]="MediaPlay",r[r.MediaRecord=168]="MediaRecord",r[r.MediaFastForward=169]="MediaFastForward",r[r.MediaRewind=170]="MediaRewind",r[r.MediaTrackNext=171]="MediaTrackNext",r[r.MediaTrackPrevious=172]="MediaTrackPrevious",r[r.MediaStop=173]="MediaStop",r[r.Eject=174]="Eject",r[r.MediaPlayPause=175]="MediaPlayPause",r[r.MediaSelect=176]="MediaSelect",r[r.LaunchMail=177]="LaunchMail",r[r.LaunchApp2=178]="LaunchApp2",r[r.LaunchApp1=179]="LaunchApp1",r[r.SelectTask=180]="SelectTask",r[r.LaunchScreenSaver=181]="LaunchScreenSaver",r[r.BrowserSearch=182]="BrowserSearch",r[r.BrowserHome=183]="BrowserHome",r[r.BrowserBack=184]="BrowserBack",r[r.BrowserForward=185]="BrowserForward",r[r.BrowserStop=186]="BrowserStop",r[r.BrowserRefresh=187]="BrowserRefresh",r[r.BrowserFavorites=188]="BrowserFavorites",r[r.ZoomToggle=189]="ZoomToggle",r[r.MailReply=190]="MailReply",r[r.MailForward=191]="MailForward",r[r.MailSend=192]="MailSend",r[r.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:r=>M[r]||0,toEnum:r=>k[r]||0,toString:r=>L[r]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(f,w,t,P,b){this.ctrlKey=f,this.shiftKey=w,this.altKey=t,this.metaKey=P,this.scanCode=b}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function r(f,w){L[f]=w,k[w]=f,M[w.toLowerCase()]=f}r(0,"None"),r(1,"Hyper"),r(2,"Super"),r(3,"Fn"),r(4,"FnLock"),r(5,"Suspend"),r(6,"Resume"),r(7,"Turbo"),r(8,"Sleep"),r(9,"WakeUp"),r(10,"KeyA"),r(11,"KeyB"),r(12,"KeyC"),r(13,"KeyD"),r(14,"KeyE"),r(15,"KeyF"),r(16,"KeyG"),r(17,"KeyH"),r(18,"KeyI"),r(19,"KeyJ"),r(20,"KeyK"),r(21,"KeyL"),r(22,"KeyM"),r(23,"KeyN"),r(24,"KeyO"),r(25,"KeyP"),r(26,"KeyQ"),r(27,"KeyR"),r(28,"KeyS"),r(29,"KeyT"),r(30,"KeyU"),r(31,"KeyV"),r(32,"KeyW"),r(33,"KeyX"),r(34,"KeyY"),r(35,"KeyZ"),r(36,"Digit1"),r(37,"Digit2"),r(38,"Digit3"),r(39,"Digit4"),r(40,"Digit5"),r(41,"Digit6"),r(42,"Digit7"),r(43,"Digit8"),r(44,"Digit9"),r(45,"Digit0"),r(46,"Enter"),r(47,"Escape"),r(48,"Backspace"),r(49,"Tab"),r(50,"Space"),r(51,"Minus"),r(52,"Equal"),r(53,"BracketLeft"),r(54,"BracketRight"),r(55,"Backslash"),r(56,"IntlHash"),r(57,"Semicolon"),r(58,"Quote"),r(59,"Backquote"),r(60,"Comma"),r(61,"Period"),r(62,"Slash"),r(63,"CapsLock"),r(64,"F1"),r(65,"F2"),r(66,"F3"),r(67,"F4"),r(68,"F5"),r(69,"F6"),r(70,"F7"),r(71,"F8"),r(72,"F9"),r(73,"F10"),r(74,"F11"),r(75,"F12"),r(76,"PrintScreen"),r(77,"ScrollLock"),r(78,"Pause"),r(79,"Insert"),r(80,"Home"),r(81,"PageUp"),r(82,"Delete"),r(83,"End"),r(84,"PageDown"),r(85,"ArrowRight"),r(86,"ArrowLeft"),r(87,"ArrowDown"),r(88,"ArrowUp"),r(89,"NumLock"),r(90,"NumpadDivide"),r(91,"NumpadMultiply"),r(92,"NumpadSubtract"),r(93,"NumpadAdd"),r(94,"NumpadEnter"),r(95,"Numpad1"),r(96,"Numpad2"),r(97,"Numpad3"),r(98,"Numpad4"),r(99,"Numpad5"),r(100,"Numpad6"),r(101,"Numpad7"),r(102,"Numpad8"),r(103,"Numpad9"),r(104,"Numpad0"),r(105,"NumpadDecimal"),r(106,"IntlBackslash"),r(107,"ContextMenu"),r(108,"Power"),r(109,"NumpadEqual"),r(110,"F13"),r(111,"F14"),r(112,"F15"),r(113,"F16"),r(114,"F17"),r(115,"F18"),r(116,"F19"),r(117,"F20"),r(118,"F21"),r(119,"F22"),r(120,"F23"),r(121,"F24"),r(122,"Open"),r(123,"Help"),r(124,"Select"),r(125,"Again"),r(126,"Undo"),r(127,"Cut"),r(128,"Copy"),r(129,"Paste"),r(130,"Find"),r(131,"AudioVolumeMute"),r(132,"AudioVolumeUp"),r(133,"AudioVolumeDown"),r(134,"NumpadComma"),r(135,"IntlRo"),r(136,"KanaMode"),r(137,"IntlYen"),r(138,"Convert"),r(139,"NonConvert"),r(140,"Lang1"),r(141,"Lang2"),r(142,"Lang3"),r(143,"Lang4"),r(144,"Lang5"),r(145,"Abort"),r(146,"Props"),r(147,"NumpadParenLeft"),r(148,"NumpadParenRight"),r(149,"NumpadBackspace"),r(150,"NumpadMemoryStore"),r(151,"NumpadMemoryRecall"),r(152,"NumpadMemoryClear"),r(153,"NumpadMemoryAdd"),r(154,"NumpadMemorySubtract"),r(155,"NumpadClear"),r(156,"NumpadClearEntry"),r(157,"ControlLeft"),r(158,"ShiftLeft"),r(159,"AltLeft"),r(160,"MetaLeft"),r(161,"ControlRight"),r(162,"ShiftRight"),r(163,"AltRight"),r(164,"MetaRight"),r(165,"BrightnessUp"),r(166,"BrightnessDown"),r(167,"MediaPlay"),r(168,"MediaRecord"),r(169,"MediaFastForward"),r(170,"MediaRewind"),r(171,"MediaTrackNext"),r(172,"MediaTrackPrevious"),r(173,"MediaStop"),r(174,"Eject"),r(175,"MediaPlayPause"),r(176,"MediaSelect"),r(177,"LaunchMail"),r(178,"LaunchApp2"),r(179,"LaunchApp1"),r(180,"SelectTask"),r(181,"LaunchScreenSaver"),r(182,"BrowserSearch"),r(183,"BrowserHome"),r(184,"BrowserBack"),r(185,"BrowserForward"),r(186,"BrowserStop"),r(187,"BrowserRefresh"),r(188,"BrowserFavorites"),r(189,"ZoomToggle"),r(190,"MailReply"),r(191,"MailForward"),r(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function r(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,r(0,0),r(1,0),r(2,0),r(3,0),r(4,0),r(5,0),r(6,0),r(7,0),r(8,0),r(9,0),r(46,3),r(47,9),r(48,1),r(49,2),r(50,10),r(63,8),r(64,59),r(65,60),r(66,61),r(67,62),r(68,63),r(69,64),r(70,65),r(71,66),r(72,67),r(73,68),r(74,69),r(75,70),r(76,0),r(77,79),r(78,7),r(79,19),r(80,14),r(81,11),r(82,20),r(83,13),r(84,12),r(85,17),r(86,15),r(87,18),r(88,16),r(89,78),r(90,108),r(91,103),r(92,106),r(93,104),r(94,3),r(95,94),r(96,95),r(97,96),r(98,97),r(99,98),r(100,99),r(101,100),r(102,101),r(103,102),r(104,93),r(105,107),r(107,58),r(108,0),r(109,0),r(110,71),r(111,72),r(112,73),r(113,74),r(114,75),r(115,76),r(116,77),r(117,0),r(118,0),r(119,0),r(120,0),r(121,0),r(122,0),r(123,0),r(124,0),r(125,0),r(126,0),r(127,0),r(128,0),r(129,0),r(130,0),r(131,0),r(132,0),r(133,0),r(134,105),r(136,0),r(138,0),r(139,0),r(140,0),r(141,0),r(142,0),r(143,0),r(144,0),r(145,0),r(146,0),r(147,0),r(148,0),r(149,0),r(150,0),r(151,0),r(152,0),r(153,0),r(154,0),r(155,0),r(156,0),r(157,5),r(158,4),r(159,6),r(160,57),r(161,5),r(162,4),r(163,6),r(164,57),r(165,0),r(166,0),r(167,0),r(168,0),r(169,0),r(170,0),r(171,0),r(172,0),r(173,0),r(174,0),r(175,0),r(176,0),r(177,0),r(178,0),r(179,0),r(180,0),r(181,0),r(182,0),r(183,0),r(184,0),r(185,0),r(186,0),r(187,0),r(188,0),r(189,0),r(190,0),r(191,0),r(192,0)}()}),define(J[106],Z([0,1,57,78]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(E){E=E.toLowerCase().trim();let r=!1,f=!1,w=!1,t=!1,P;do P=!1,/^ctrl(\+|\-)/.test(E)&&(r=!0,E=E.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(E)&&(f=!0,E=E.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(E)&&(w=!0,E=E.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(E)&&(t=!0,E=E.substr("meta-".length),P=!0),/^win(\+|\-)/.test(E)&&(t=!0,E=E.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(E)&&(t=!0,E=E.substr("cmd-".length),P=!0);while(P);let b;const p=E.indexOf(" ");return p>0?(b=E.substring(0,p),E=E.substring(p)):(b=E,E=""),{remains:E,ctrl:r,shift:f,alt:w,meta:t,key:b}}static parseSimpleKeybinding(E){const r=this._readModifiers(E),f=v.KeyCodeUtils.fromUserSettings(r.key);return[new v.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,f),r.remains]}static parseKeybinding(E,r){if(!E)return null;const f=[];let w;do[w,E]=this.parseSimpleKeybinding(E),f.push(w);while(E.length>0);return new v.ChordKeybinding(f)}static parseSimpleUserBinding(E){const r=this._readModifiers(E),f=r.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],P=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(r.ctrl,r.shift,r.alt,r.meta,P),r.remains]}const w=v.KeyCodeUtils.fromUserSettings(r.key);return[new v.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,w),r.remains]}static parseUserBinding(E){if(!E)return[];const r=[];let f;for(;E.length>0;)[f,E]=this.parseSimpleUserBinding(E),r.push(f);return r}}e.KeybindingParser=k}),define(J[107],Z([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new k(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[4],Z([0,1,17,43,2,104,107]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var r;(function(h){h.None=()=>k.Disposable.None;function s(Q){return(_,q=null,z)=>{let $=!1,H;return H=Q(U=>{if(!$)return H?H.dispose():$=!0,_.call(q,U)},null,z),$&&H.dispose(),H}}h.once=s;function c(Q,_){return m((q,z=null,$)=>Q(H=>q.call(z,_(H)),null,$))}h.map=c;function i(Q,_){return m((q,z=null,$)=>Q(H=>{_(H),q.call(z,H)},null,$))}h.forEach=i;function a(Q,_){return m((q,z=null,$)=>Q(H=>_(H)&&q.call(z,H),null,$))}h.filter=a;function n(Q){return Q}h.signal=n;function o(...Q){return(_,q=null,z)=>(0,k.combinedDisposable)(...Q.map($=>$(H=>_.call(q,H),null,z)))}h.any=o;function l(Q,_,q){let z=q;return c(Q,$=>(z=_(z,$),z))}h.reduce=l;function m(Q){let _;const q=new b({onFirstListenerAdd(){_=Q(q.fire,q)},onLastListenerRemove(){_.dispose()}});return q.event}function S(Q,_,q=100,z=!1,$){let H,U,j,F=0;const R=new b({leakWarningThreshold:$,onFirstListenerAdd(){H=Q(T=>{F++,U=_(U,T),z&&!j&&(R.fire(U),U=void 0),clearTimeout(j),j=setTimeout(()=>{const O=U;U=void 0,j=void 0,(!z||F>1)&&R.fire(O),F=0},q)})},onLastListenerRemove(){H.dispose()}});return R.event}h.debounce=S;function D(Q,_=(q,z)=>q===z){let q=!0,z;return a(Q,$=>{const H=q||!_($,z);return q=!1,z=$,H})}h.latch=D;function A(Q,_){return[h.filter(Q,_),h.filter(Q,q=>!_(q))]}h.split=A;function W(Q,_=!1,q=[]){let z=q.slice(),$=Q(j=>{z?z.push(j):U.fire(j)});const H=()=>{z&&z.forEach(j=>U.fire(j)),z=null},U=new b({onFirstListenerAdd(){$||($=Q(j=>U.fire(j)))},onFirstListenerDidAdd(){z&&(_?setTimeout(H):H())},onLastListenerRemove(){$&&$.dispose(),$=null}});return U.event}h.buffer=W;class C{constructor(_){this.event=_}map(_){return new C(c(this.event,_))}forEach(_){return new C(i(this.event,_))}filter(_){return new C(a(this.event,_))}reduce(_,q){return new C(l(this.event,_,q))}latch(){return new C(D(this.event))}debounce(_,q=100,z=!1,$){return new C(S(this.event,_,q,z,$))}on(_,q,z){return this.event(_,q,z)}once(_,q,z){return s(this.event)(_,q,z)}}function X(Q){return new C(Q)}h.chain=X;function te(Q,_,q=z=>z){const z=(...j)=>U.fire(q(...j)),$=()=>Q.on(_,z),H=()=>Q.removeListener(_,z),U=new b({onFirstListenerAdd:$,onLastListenerRemove:H});return U.event}h.fromNodeEventEmitter=te;function oe(Q,_,q=z=>z){const z=(...j)=>U.fire(q(...j)),$=()=>Q.addEventListener(_,z),H=()=>Q.removeEventListener(_,z),U=new b({onFirstListenerAdd:$,onLastListenerRemove:H});return U.event}h.fromDOMEventEmitter=oe;function Y(Q){return new Promise(_=>s(Q)(_))}h.toPromise=Y})(r=e.Event||(e.Event={}));class f{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${f._idPool++}`}start(s){this._stopWatch=new E.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function t(h){const s=w;return w=h,{dispose(){w=s}}}e.setGlobalLeakWarningThreshold=t;class P{constructor(s,c=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let c=w;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||s<c)return;this._stacks||(this._stacks=new Map);const i=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(i)||0;if(this._stacks.set(i,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let n,o=0;for(const[l,m]of this._stacks)(!n||o<m)&&(n=l,o=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${o}):`),console.warn(n)}return()=>{const n=this._stacks.get(i)||0;this._stacks.set(i,n-1)}}}class b{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=w>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(s,c,i)=>{this._listeners||(this._listeners=new M.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(c?[s,c]:s);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,c);const o=this._leakageMon?.check(this._listeners.size),l=(0,k.toDisposable)(()=>{o&&o(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof k.DisposableStore?i.add(l):Array.isArray(i)&&i.push(l),l}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,i]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,i):c[0].call(c[1],i)}catch(a){(0,v.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=b;class p extends b{async fireAsync(s,c,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,s]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[a,n]=this._asyncDeliveryQueue.shift(),o=[],l={...n,waitUntil:m=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");i&&(m=i(m,typeof a=="function"?a:a[0])),o.push(m)}};try{typeof a=="function"?a.call(void 0,l):a[0].call(a[1],l)}catch(m){(0,v.onUnexpectedError)(m);continue}Object.freeze(o),await Promise.allSettled(o).then(m=>{for(const S of m)S.status==="rejected"&&(0,v.onUnexpectedError)(S.reason)})}}}}e.AsyncEmitter=p;class d extends b{constructor(s){super(s);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=d;class g extends d{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=g;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const c={event:s,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const i=()=>{this.hasListeners&&this.unhook(c);const a=this.events.indexOf(c);this.events.splice(a,1)};return(0,k.toDisposable)((0,L.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(c=>this.emitter.fire(c))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class y{constructor(){this.buffers=[]}wrapEvent(s){return(c,i,a)=>s(n=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>c.call(i,n)):c.call(i,n)},void 0,a)}bufferEvents(s){const c=[];this.buffers.push(c);const i=s();return this.buffers.pop(),c.forEach(a=>a()),i}}e.EventBufferer=y;class u{constructor(){this.listening=!1,this.inputEvent=r.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(J[24],Z([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(r,f){const w=setTimeout(r.bind(f),0);return{dispose(){clearTimeout(w)}}});var k;(function(r){function f(w){return w===r.None||w===r.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}r.isCancellationToken=f,r.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),r.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=E}),define(J[108],Z([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(P){const b=this._icons.get(P.id);b?P.description?b.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function M(t,P){return new r(t,P)}e.registerCodicon=M;function E(t){return t?t.replace(/\$\((.*?)\)/g,(P,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=E;class r{constructor(P,b,p){this.id=P,this.definition=b,this.description=p,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=r;function f(t,P){const b=["codicon","codicon-"+t];return P&&b.push("codicon-modifier-"+P),b}e.getClassNamesArray=f;var w;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function b(g){if(g instanceof r)return["codicon","codicon-"+g.id];const I=P.exec(g.id);if(!I)return b(r.error);let[,y,u]=I;const h=["codicon","codicon-"+y];return u&&h.push("codicon-modifier-"+u.substr(1)),h}t.asClassNameArray=b;function p(g){return b(g).join(" ")}t.asClassName=p;function d(g){return"."+b(g).join(".")}t.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(r=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,17,2]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(h){const s=h;return s?[s.on,s.pause,s.resume,s.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=k;function M(h){const s=h;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(h,s){return new r(h,s)}e.newWriteableStream=E;class r{constructor(s,c){this.reducer=s,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(c=>c(s))}emitError(s){this.listeners.error.length===0?(0,v.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(c=>c(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,c){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(s,c){if(this.state.destroyed)return;let i;switch(s){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const a=i.indexOf(c);a>=0&&i.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,s){const c=[];let i;for(;(i=h.read())!==null;)c.push(i);return s(c)}e.consumeReadable=f;function w(h,s,c){const i=[];let a;for(;(a=h.read())!==null&&i.length<c;)i.push(a);return a===null&&i.length>0?s(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return h.read()}}}e.peekReadable=w;function t(h,s){return new Promise((c,i)=>{const a=[];P(h,{onData:n=>{s&&a.push(n)},onError:n=>{s?i(n):c(void 0)},onEnd:()=>{c(s?s(a):void 0)}})})}e.consumeStream=t;function P(h,s){h.on("error",c=>s.onError(c)),h.on("end",()=>s.onEnd()),h.on("data",c=>s.onData(c))}e.listenStream=P;function b(h,s){return new Promise((c,i)=>{const a=new L.DisposableStore,n=[],o=S=>{if(n.push(S),n.length>s)return a.dispose(),h.pause(),c({stream:h,buffer:n,ended:!1})},l=S=>i(S),m=()=>c({stream:h,buffer:n,ended:!0});a.add((0,L.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),a.add((0,L.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),a.add((0,L.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}e.peekStream=b;function p(h,s){const c=E(s);return c.end(h),c}e.toStream=p;function d(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let s=!1;return{read:()=>s?null:(s=!0,h)}}e.toReadable=g;function I(h,s,c){const i=E(c);return P(h,{onData:a=>i.write(s.data(a)),onError:a=>i.error(s.error?s.error(a):a),onEnd:()=>i.end()}),i}e.transform=I;function y(h,s,c){let i=!1;return{read:()=>{const a=s.read();return i?a:(i=!0,a!==null?c([h,a]):h)}}}e.prefixedReadable=y;function u(h,s,c){let i=!1;const a=E(c);return P(s,{onData:n=>i?a.write(n):(i=!0,a.write(c([h,n]))),onError:n=>a.error(n),onEnd:()=>{i||(i=!0,a.write(h)),a.end()}}),a}e.prefixedStream=u}),define(J[18],Z([0,1,64]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,M;class E{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return L?new E(Buffer.allocUnsafe(o)):new E(new Uint8Array(o))}static wrap(o){return L&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new E(o)}static fromString(o,l){return!(l?.dontUseNodeBuffer||!1)&&L?new E(Buffer.from(o)):(k||(k=new TextEncoder),new E(k.encode(o)))}static concat(o,l){if(typeof l=="undefined"){l=0;for(let D=0,A=o.length;D<A;D++)l+=o[D].byteLength}const m=E.alloc(l);let S=0;for(let D=0,A=o.length;D<A;D++){const W=o[D];m.set(W,S),S+=W.byteLength}return m}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(o,l){return new E(this.buffer.subarray(o,l))}set(o,l){o instanceof E?this.buffer.set(o.buffer,l):this.buffer.set(o,l)}readUInt32BE(o){return w(this.buffer,o)}writeUInt32BE(o,l){t(this.buffer,o,l)}readUInt32LE(o){return P(this.buffer,o)}writeUInt32LE(o,l){b(this.buffer,o,l)}readUInt8(o){return p(this.buffer,o)}writeUInt8(o,l){d(this.buffer,o,l)}}e.VSBuffer=E;function r(n,o){return n[o+0]<<0>>>0|n[o+1]<<8>>>0}e.readUInt16LE=r;function f(n,o,l){n[l+0]=o&255,o=o>>>8,n[l+1]=o&255}e.writeUInt16LE=f;function w(n,o){return n[o]*2**24+n[o+1]*2**16+n[o+2]*2**8+n[o+3]}e.readUInt32BE=w;function t(n,o,l){n[l+3]=o,o=o>>>8,n[l+2]=o,o=o>>>8,n[l+1]=o,o=o>>>8,n[l]=o}e.writeUInt32BE=t;function P(n,o){return n[o+0]<<0>>>0|n[o+1]<<8>>>0|n[o+2]<<16>>>0|n[o+3]<<24>>>0}e.readUInt32LE=P;function b(n,o,l){n[l+0]=o&255,o=o>>>8,n[l+1]=o&255,o=o>>>8,n[l+2]=o&255,o=o>>>8,n[l+3]=o&255}e.writeUInt32LE=b;function p(n,o){return n[o]}e.readUInt8=p;function d(n,o,l){n[l]=o}e.writeUInt8=d;function g(n){return v.consumeReadable(n,o=>E.concat(o))}e.readableToBuffer=g;function I(n){return v.toReadable(n)}e.bufferToReadable=I;function y(n){return v.consumeStream(n,o=>E.concat(o))}e.streamToBuffer=y;async function u(n){return n.ended?E.concat(n.buffer):E.concat([...n.buffer,await y(n.stream)])}e.bufferedStreamToBuffer=u;function h(n){return v.toStream(n,o=>E.concat(o))}e.bufferToStream=h;function s(n){return v.transform(n,{data:o=>typeof o=="string"?E.fromString(o):E.wrap(o)},o=>E.concat(o))}e.streamToBufferReadableStream=s;function c(n){return v.newWriteableStream(o=>E.concat(o),n)}e.newWriteableBufferStream=c;function i(n,o){return v.prefixedReadable(n,o,l=>E.concat(l))}e.prefixedBufferReadable=i;function a(n,o){return v.prefixedStream(n,o,l=>E.concat(l))}e.prefixedBufferStream=a}),define(J[25],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function k(G,...re){return re.length===0?G:G.replace(L,function(le,de){const ve=parseInt(de,10);return isNaN(ve)||ve<0||ve>=re.length?le:re[ve]})}e.format=k;const M=/{([^}]+)}/g;function E(G,re){return G.replace(M,(le,de)=>re[de]??le)}e.format2=E;function r(G){return G.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=r;function f(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(G,re){let le=0;const de=re.charCodeAt(0);for(let ve=G.length-1;ve>=0;ve--)G.charCodeAt(ve)===de&&le++;return le}e.count=w;function t(G,re,le="\u2026"){return G.length<=re?G:`${G.substr(0,re)}${le}`}e.truncate=t;function P(G,re=" "){const le=b(G,re);return p(le,re)}e.trim=P;function b(G,re){if(!G||!re)return G;const le=re.length;if(le===0||G.length===0)return G;let de=0;for(;G.indexOf(re,de)===de;)de=de+le;return G.substring(de)}e.ltrim=b;function p(G,re){if(!G||!re)return G;const le=re.length,de=G.length;if(le===0||de===0)return G;let ve=de,Me=-1;for(;Me=G.lastIndexOf(re,ve-1),!(Me===-1||Me+le!==ve);){if(Me===0)return"";ve=Me}return G.substring(0,ve)}e.rtrim=p;function d(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(G){return G.replace(/\*/g,"")}e.stripWildcards=g;function I(G,re,le={}){if(!G)throw new Error("Cannot create regex from empty string");re||(G=f(G)),le.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let de="";return le.global&&(de+="g"),le.matchCase||(de+="i"),le.multiline&&(de+="m"),le.unicode&&(de+="u"),new RegExp(G,de)}e.createRegExp=I;function y(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function u(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function h(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=h;function s(G){return G.split(/\r\n|\r|\n/)}e.splitLines=s;function c(G){for(let re=0,le=G.length;re<le;re++){const de=G.charCodeAt(re);if(de!==32&&de!==9)return re}return-1}e.firstNonWhitespaceIndex=c;function i(G,re=0,le=G.length){for(let de=re;de<le;de++){const ve=G.charCodeAt(de);if(ve!==32&&ve!==9)return G.substring(re,de)}return G.substring(re,le)}e.getLeadingWhitespace=i;function a(G,re=G.length-1){for(let le=re;le>=0;le--){const de=G.charCodeAt(le);if(de!==32&&de!==9)return le}return-1}e.lastNonWhitespaceIndex=a;function n(G,re){return G<re?-1:G>re?1:0}e.compare=n;function o(G,re,le=0,de=G.length,ve=0,Me=re.length){for(;le<de&&ve<Me;le++,ve++){let Ce=G.charCodeAt(le),ze=re.charCodeAt(ve);if(Ce<ze)return-1;if(Ce>ze)return 1}const Fe=de-le,We=Me-ve;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=o;function l(G,re){return m(G,re,0,G.length,0,re.length)}e.compareIgnoreCase=l;function m(G,re,le=0,de=G.length,ve=0,Me=re.length){for(;le<de&&ve<Me;le++,ve++){let Ce=G.charCodeAt(le),ze=re.charCodeAt(ve);if(Ce===ze)continue;const he=Ce-ze;if(!(he===32&&D(ze))&&!(he===-32&&D(Ce)))return S(Ce)&&S(ze)?he:o(G.toLowerCase(),re.toLowerCase(),le,de,ve,Me)}const Fe=de-le,We=Me-ve;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=m;function S(G){return G>=97&&G<=122}e.isLowerAsciiLetter=S;function D(G){return G>=65&&G<=90}e.isUpperAsciiLetter=D;function A(G){return S(G)||D(G)}function W(G,re){return G.length===re.length&&C(G,re)}e.equalsIgnoreCase=W;function C(G,re,le=G.length){for(let de=0;de<le;de++){const ve=G.charCodeAt(de),Me=re.charCodeAt(de);if(ve!==Me){if(A(ve)&&A(Me)){const Fe=Math.abs(ve-Me);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(ve).toLowerCase()!==String.fromCharCode(Me).toLowerCase())return!1}}return!0}function X(G,re){const le=re.length;return re.length>G.length?!1:C(G,re,le)}e.startsWithIgnoreCase=X;function te(G,re){let le,de=Math.min(G.length,re.length);for(le=0;le<de;le++)if(G.charCodeAt(le)!==re.charCodeAt(le))return le;return de}e.commonPrefixLength=te;function oe(G,re){let le,de=Math.min(G.length,re.length);const ve=G.length-1,Me=re.length-1;for(le=0;le<de;le++)if(G.charCodeAt(ve-le)!==re.charCodeAt(Me-le))return le;return de}e.commonSuffixLength=oe;function Y(G){return 55296<=G&&G<=56319}e.isHighSurrogate=Y;function Q(G){return 56320<=G&&G<=57343}e.isLowSurrogate=Q;function _(G,re){return(G-55296<<10)+(re-56320)+65536}e.computeCodePoint=_;function q(G,re,le){const de=G.charCodeAt(le);if(Y(de)&&le+1<re){const ve=G.charCodeAt(le+1);if(Q(ve))return _(de,ve)}return de}e.getNextCodePoint=q;function z(G,re){const le=G.charCodeAt(re-1);if(Q(le)&&re>1){const de=G.charCodeAt(re-2);if(Y(de))return _(de,le)}return le}function $(G,re){const le=Be.getInstance(),de=re,ve=G.length,Me=q(G,ve,re);re+=Me>=65536?2:1;let Fe=le.getGraphemeBreakType(Me);for(;re<ve;){const We=q(G,ve,re),Ce=le.getGraphemeBreakType(We);if(Ue(Fe,Ce))break;re+=We>=65536?2:1,Fe=Ce}return re-de}e.nextCharLength=$;function H(G,re){const le=Be.getInstance(),de=re,ve=z(G,re);re-=ve>=65536?2:1;let Me=le.getGraphemeBreakType(ve);for(;re>0;){const Fe=z(G,re),We=le.getGraphemeBreakType(Fe);if(Ue(We,Me))break;re-=Fe>=65536?2:1,Me=We}return de-re}e.prevCharLength=H;function U(G,re){const le=Be.getInstance(),de=G.length,ve=re,Me=q(G,de,re),Fe=le.getGraphemeBreakType(Me);re+=Me>=65536?2:1;let We=Fe;for(;re<de;){const ze=q(G,de,re),he=le.getGraphemeBreakType(ze);if(Ue(We,he))break;re+=ze>=65536?2:1,We=he}const Ce=re;for(re=ve,We=Fe;re>0;){const ze=z(G,re),he=le.getGraphemeBreakType(ze);if(Ue(he,We))break;re-=ze>=65536?2:1,We=he}return[re,Ce]}function j(G,re){return re>0&&Q(G.charCodeAt(re))?U(G,re-1):U(G,re)}e.getCharContainingOffset=j;const F=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function R(G){return F.test(G)}e.containsRTL=R;const T=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function O(G){return T.test(G)}e.containsEmoji=O;const B=/^[\t\n\r\x20-\x7E]*$/;function N(G){return B.test(G)}e.isBasicASCII=N,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=V;function x(G){for(let re=0,le=G.length;re<le;re++)if(ie(G.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=x;function ie(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=ie;function ne(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=ne;function ce(G,re){if(G.length<re)return G;const le=/\b/g;let de=0;for(;le.test(G)&&!(G.length-le.lastIndex<re);)de=le.lastIndex,le.lastIndex+=1;return G.substring(de).replace(/^\s/,"")}e.lcut=ce;const se=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function fe(G){return G&&(G=G.replace(se,""),G=G.replace(ae,""),G=G.replace(pe,"")),G}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function Pe(G){return we(G)?G.substr(1):G}e.stripUTF8BOM=Pe;function Se(G,re){if(!G||!re||G.length<re.length)return!1;const le=re.length,de=G.toLowerCase();let ve=0,Me=-1;for(;ve<le;){const Fe=de.indexOf(re[ve],Me+1);if(Fe<0)return!1;Me=Fe,ve++}return!0}e.fuzzyContains=Se;function me(G,re=!1){return G?(re&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=me;function Ee(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Ee;function Le(G,re=1){if(re===0)return"";let le=-1;do le=G.indexOf(`
`,le+1),re--;while(re>0&&le>=0);return le===-1?G:(G[le-1]==="\r"&&le--,G.substr(0,le))}e.getNLines=Le;function Te(G){const re=90-65+1;return G=G%(2*re),G<re?String.fromCharCode(97+G):String.fromCharCode(65+G-re)}e.singleLetterHash=Te;function Ne(G){return Be.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Ne;function Ue(G,re){return G===0?re!==5&&re!==7:G===2&&re===3?!1:G===4||G===2||G===3||re===4||re===2||re===3?!0:!(G===8&&(re===8||re===9||re===11||re===12)||(G===11||G===9)&&(re===9||re===10)||(G===12||G===10)&&re===10||re===5||re===13||re===7||G===1||G===13&&re===14||G===6&&re===6)}e.breakBetweenGraphemeBreakType=Ue;var Ge;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const le=this._data,de=le.length/3;let ve=1;for(;ve<=de;)if(re<le[3*ve])ve=2*ve;else if(re>le[3*ve+1])ve=2*ve+1;else return le[3*ve+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(G,re){if(G===0)return 0;const le=ot(G,re);if(le!==void 0)return le;const de=z(re,G);return G-=Ye(de),G}e.getLeftDeleteOffset=Ze;function ot(G,re){let le=z(re,G);for(G-=Ye(le);ut(le)||le===65039||le===8419;){if(G===0)return;le=z(re,G),G-=Ye(le)}if(!!ne(le)){if(G>=0){const de=z(re,G);de===8205&&(G-=Ye(de))}return G}}function Ye(G){return G>=65536?2:1}function ut(G){return 127995<=G&&G<=127999}var xe;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(J[79],Z([0,1,25]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(y){return k(y,0)}e.hash=L;function k(y,u){switch(typeof y){case"object":return y===null?M(349,u):Array.isArray(y)?f(y,u):w(y,u);case"string":return r(y,u);case"boolean":return E(y,u);case"number":return M(y,u);case"undefined":return M(937,u);default:return M(617,u)}}e.doHash=k;function M(y,u){return(u<<5)-u+y|0}function E(y,u){return M(y?433:863,u)}function r(y,u){u=M(149417,u);for(let h=0,s=y.length;h<s;h++)u=M(y.charCodeAt(h),u);return u}e.stringHash=r;function f(y,u){return u=M(104579,u),y.reduce((h,s)=>k(s,h),u)}function w(y,u){return u=M(181387,u),Object.keys(y).sort().reduce((h,s)=>(h=r(s,h),k(y[s],h)),u)}class t{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=k(u,this._value),this._value}}e.Hasher=t;var P;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function b(y,u,h=32){const s=h-u,c=~((1<<s)-1);return(y<<u|(c&y)>>>s)>>>0}function p(y,u=0,h=y.byteLength,s=0){for(let c=0;c<h;c++)y[u+c]=s}function d(y,u,h="0"){for(;y.length<u;)y=h+y;return y}function g(y,u=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((y>>>0).toString(16),u/4)}e.toHexString=g;class I{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const h=u.length;if(h===0)return;const s=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,a,n;for(i!==0?(a=i,n=-1,i=0):(a=u.charCodeAt(0),n=0);;){let o=a;if(v.isHighSurrogate(a))if(n+1<h){const l=u.charCodeAt(n+1);v.isLowSurrogate(l)?(n++,o=v.computeCodePoint(a,l)):o=65533}else{i=a;break}else v.isLowSurrogate(a)&&(o=65533);if(c=this._push(s,c,o),n++,n<h)a=u.charCodeAt(n);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(u,h,s){return s<128?u[h++]=s:s<2048?(u[h++]=192|(s&1984)>>>6,u[h++]=128|(s&63)>>>0):s<65536?(u[h++]=224|(s&61440)>>>12,u[h++]=128|(s&4032)>>>6,u[h++]=128|(s&63)>>>0):(u[h++]=240|(s&1835008)>>>18,u[h++]=128|(s&258048)>>>12,u[h++]=128|(s&4032)>>>6,u[h++]=128|(s&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=I._bigBlock32,h=this._buffDV;for(let S=0;S<64;S+=4)u.setUint32(S,h.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)u.setUint32(S,b(u.getUint32(S-12,!1)^u.getUint32(S-32,!1)^u.getUint32(S-56,!1)^u.getUint32(S-64,!1),1),!1);let s=this._h0,c=this._h1,i=this._h2,a=this._h3,n=this._h4,o,l,m;for(let S=0;S<80;S++)S<20?(o=c&i|~c&a,l=1518500249):S<40?(o=c^i^a,l=1859775393):S<60?(o=c&i|c&a|i&a,l=2400959708):(o=c^i^a,l=3395469782),m=b(s,5)+o+n+l+u.getUint32(S*4,!1)&4294967295,n=a,a=i,i=b(c,30),c=s,s=m;this._h0=this._h0+s&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=I,I._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(D){return Array.isArray(D)}e.isArray=v;function L(D){return typeof D=="string"}e.isString=L;function k(D){return Array.isArray(D)&&D.every(A=>L(A))}e.isStringArray=k;function M(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=M;function E(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=E;function r(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=r;function f(D){return D===!0||D===!1}e.isBoolean=f;function w(D){return typeof D=="undefined"}e.isUndefined=w;function t(D){return!P(D)}e.isDefined=t;function P(D){return w(D)||D===null}e.isUndefinedOrNull=P;function b(D,A){if(!D)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=b;function p(D){if(P(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=p;function d(...D){const A=[];for(let W=0;W<D.length;W++){const C=D[W];if(P(C))throw new Error(`Assertion Failed: argument at index ${W} is undefined or null`);A.push(C)}return A}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function I(D){if(!M(D))return!1;for(let A in D)if(g.call(D,A))return!1;return!0}e.isEmptyObject=I;function y(D){return typeof D=="function"}e.isFunction=y;function u(...D){return D.length>0&&D.every(y)}e.areFunctions=u;function h(D,A){const W=Math.min(D.length,A.length);for(let C=0;C<W;C++)s(D[C],A[C])}e.validateConstraints=h;function s(D,A){if(L(A)){if(typeof D!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(y(A)){try{if(D instanceof A)return}catch{}if(!P(D)&&D.constructor===A||A.length===1&&A.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function c(D){let A=[],W=Object.getPrototypeOf(D);for(;Object.prototype!==W;)A=A.concat(Object.getOwnPropertyNames(W)),W=Object.getPrototypeOf(W);return A}e.getAllPropertyNames=c;function i(D){const A=[];for(const W of c(D))typeof D[W]=="function"&&A.push(W);return A}e.getAllMethodNames=i;function a(D,A){const W=X=>function(){const te=Array.prototype.slice.call(arguments,0);return A(X,te)};let C={};for(const X of D)C[X]=W(X);return C}e.createProxyObject=a;function n(D){return D===null?void 0:D}e.withNullAsUndefined=n;function o(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=o;function l(D){return class{constructor(){return new Proxy({},{get(A,W){if(A[W])return A[W];throw new Error(`Not Implemented: ${D}->${String(W)}`)}})}}}e.NotImplementedProxy=l;function m(D,A="Unreachable"){throw new Error(A)}e.assertNever=m;function S(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=S}),define(J[29],Z([0,1,8,3,25,13]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(n){return n===47||n===92}e.isPathSeparator=E;function r(n){return n.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=r;function f(n){return n.indexOf("/")===-1&&(n=r(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=f;function w(n,o=v.posix.sep){if(!n)return"";const l=n.length,m=n.charCodeAt(0);if(E(m)){if(E(n.charCodeAt(1))&&!E(n.charCodeAt(2))){let D=3;const A=D;for(;D<l&&!E(n.charCodeAt(D));D++);if(A!==D&&!E(n.charCodeAt(D+1))){for(D+=1;D<l;D++)if(E(n.charCodeAt(D)))return n.slice(0,D+1).replace(/[\\/]/g,o)}}return o}else if(y(m)&&n.charCodeAt(1)===58)return E(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let S=n.indexOf("://");if(S!==-1){for(S+=3;S<l;S++)if(E(n.charCodeAt(S)))return n.slice(0,S+1)}return""}e.getRoot=w;function t(n){if(!L.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let l=2;const m=l;for(;l<n.length&&(o=n.charCodeAt(l),o!==92);l++);return!(m===l||(o=n.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=t;const P=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(n,o=L.isWindows){const l=o?P:b;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||o&&p.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=d;function g(n,o,l){const m=n===o;return!l||m?m:!n||!o?!1:(0,k.equalsIgnoreCase)(n,o)}e.isEqual=g;function I(n,o,l,m=v.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let D=o.length;return o.charAt(o.length-1)===m&&D--,n.charAt(D)===m}return o.charAt(o.length-1)!==m&&(o+=m),n.indexOf(o)===0}e.isEqualOrParent=I;function y(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=y;function u(n,o){return L.isWindows&&n.endsWith(":")&&(n+=v.sep),(0,v.isAbsolute)(n)||(n=(0,v.join)(o,n)),n=(0,v.normalize)(n),L.isWindows?(n=(0,k.rtrim)(n,v.sep),n.endsWith(":")&&(n+=v.sep)):(n=(0,k.rtrim)(n,v.sep),n||(n=v.sep)),n}e.sanitizeFilePath=u;function h(n){const o=(0,v.normalize)(n);return L.isWindows?n.length>3?!1:s(o)&&(n.length===2||o.charCodeAt(2)===92):o===v.posix.sep}e.isRootOrDriveLetter=h;function s(n){return L.isWindows?y(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function c(n){return s(n)?n[0]:void 0}e.getDriveLetter=c;function i(n,o,l){return o.length>n.length?-1:n===o?0:(l&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=i;function a(n){const o=n.split(":");let l,m,S;if(o.forEach(D=>{const A=Number(D);(0,M.isNumber)(A)?m===void 0?m=A:S===void 0&&(S=A):l=l?[l,D].join(":"):D}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:S!==void 0?S:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(J[44],Z([0,1,13]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const I=Array.isArray(g)?[]:{};return Object.keys(g).forEach(y=>{g[y]&&typeof g[y]=="object"?I[y]=L(g[y]):I[y]=g[y]}),I}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const I=[g];for(;I.length>0;){const y=I.shift();Object.freeze(y);for(const u in y)if(M.call(y,u)){const h=y[u];typeof h=="object"&&!Object.isFrozen(h)&&I.push(h)}}return g}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function E(g,I){return r(g,I,new Set)}e.cloneAndChange=E;function r(g,I,y){if((0,v.isUndefinedOrNull)(g))return g;const u=I(g);if(typeof u!="undefined")return u;if((0,v.isArray)(g)){const h=[];for(const s of g)h.push(r(s,I,y));return h}if((0,v.isObject)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const h={};for(let s in g)M.call(g,s)&&(h[s]=r(g[s],I,y));return y.delete(g),h}return g}function f(g,I,y=!0){return(0,v.isObject)(g)?((0,v.isObject)(I)&&Object.keys(I).forEach(u=>{u in g?y&&((0,v.isObject)(g[u])&&(0,v.isObject)(I[u])?f(g[u],I[u],y):g[u]=I[u]):g[u]=I[u]}),g):I}e.mixin=f;function w(g,I){if(g===I)return!0;if(g==null||I===null||I===void 0||typeof g!=typeof I||typeof g!="object"||Array.isArray(g)!==Array.isArray(I))return!1;let y,u;if(Array.isArray(g)){if(g.length!==I.length)return!1;for(y=0;y<g.length;y++)if(!w(g[y],I[y]))return!1}else{const h=[];for(u in g)h.push(u);h.sort();const s=[];for(u in I)s.push(u);if(s.sort(),!w(h,s))return!1;for(y=0;y<h.length;y++)if(!w(g[h[y]],I[h[y]]))return!1}return!0}e.equals=w;function t(g){const I=new Set;return JSON.stringify(g,(y,u)=>{if((0,v.isObject)(u)||Array.isArray(u)){if(I.has(u))return"[Circular]";I.add(u)}return u})}e.safeStringify=t;function P(g,I,y){const u=I(g);return typeof u=="undefined"?y:u}e.getOrDefault=P;function b(g,I){const y=Object.create(null);return!g||!I||Object.keys(I).forEach(h=>{const s=g[h],c=I[h];w(s,c)||(y[h]=c)}),y}e.distinct=b;function p(g,I){const y=I.toLowerCase(),u=Object.keys(g).find(h=>h.toLowerCase()===y);return u?g[u]:g[I]}e.getCaseInsensitive=p;function d(g,I){const y=Object.create(null);for(const u of Object.keys(g))I(u,g[u])&&(y[u]=g[u]);return y}e.filter=d}),define(J[7],Z([0,1,8,3]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,E=/^\/\//;function r(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!M.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(n,o){return!n&&!o?"file":n}function w(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==P&&(o=P+o):o=P;break}return o}const t="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(o,l,m,S,D,A=!1){typeof o=="object"?(this.scheme=o.scheme||t,this.authority=o.authority||t,this.path=o.path||t,this.query=o.query||t,this.fragment=o.fragment||t):(this.scheme=f(o,A),this.authority=l||t,this.path=w(this.scheme,m||t),this.query=S||t,this.fragment=D||t,r(this,A))}static isUri(o){return o instanceof p?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return h(this,!1)}with(o){if(!o)return this;let{scheme:l,authority:m,path:S,query:D,fragment:A}=o;return l===void 0?l=this.scheme:l===null&&(l=t),m===void 0?m=this.authority:m===null&&(m=t),S===void 0?S=this.path:S===null&&(S=t),D===void 0?D=this.query:D===null&&(D=t),A===void 0?A=this.fragment:A===null&&(A=t),l===this.scheme&&m===this.authority&&S===this.path&&D===this.query&&A===this.fragment?this:new g(l,m,S,D,A)}static parse(o,l=!1){const m=b.exec(o);return m?new g(m[2]||t,a(m[4]||t),a(m[5]||t),a(m[7]||t),a(m[9]||t),l):new g(t,t,t,t,t)}static file(o){let l=t;if(L.isWindows&&(o=o.replace(/\\/g,P)),o[0]===P&&o[1]===P){const m=o.indexOf(P,2);m===-1?(l=o.substring(2),o=P):(l=o.substring(2,m),o=o.substring(m)||P)}return new g("file",l,o,t,t)}static from(o){const l=new g(o.scheme,o.authority,o.path,o.query,o.fragment);return r(l,!0),l}static joinPath(o,...l){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&o.scheme==="file"?m=p.file(v.win32.join(h(o,!0),...l)).path:m=v.posix.join(o.path,...l),o.with({path:m})}toString(o=!1){return s(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof p)return o;{const l=new g(o);return l._formatted=o.external,l._fsPath=o._sep===d?o.fsPath:null,l}}else return o}}e.URI=p;const d=L.isWindows?1:void 0;class g extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(o=!1){return o?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(n,o){let l,m=-1;for(let S=0;S<n.length;S++){const D=n.charCodeAt(S);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||o&&D===47)m!==-1&&(l+=encodeURIComponent(n.substring(m,S)),m=-1),l!==void 0&&(l+=n.charAt(S));else{l===void 0&&(l=n.substr(0,S));const A=I[D];A!==void 0?(m!==-1&&(l+=encodeURIComponent(n.substring(m,S)),m=-1),l+=A):m===-1&&(m=S)}}return m!==-1&&(l+=encodeURIComponent(n.substring(m))),l!==void 0?l:n}function u(n){let o;for(let l=0;l<n.length;l++){const m=n.charCodeAt(l);m===35||m===63?(o===void 0&&(o=n.substr(0,l)),o+=I[m]):o!==void 0&&(o+=n[l])}return o!==void 0?o:n}function h(n,o){let l;return n.authority&&n.path.length>1&&n.scheme==="file"?l=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?l=n.path.substr(1):l=n.path[1].toLowerCase()+n.path.substr(2):l=n.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=h;function s(n,o){const l=o?u:y;let m="",{scheme:S,authority:D,path:A,query:W,fragment:C}=n;if(S&&(m+=S,m+=":"),(D||S==="file")&&(m+=P,m+=P),D){let X=D.indexOf("@");if(X!==-1){const te=D.substr(0,X);D=D.substr(X+1),X=te.indexOf(":"),X===-1?m+=l(te,!1):(m+=l(te.substr(0,X),!1),m+=":",m+=l(te.substr(X+1),!1)),m+="@"}D=D.toLowerCase(),X=D.indexOf(":"),X===-1?m+=l(D,!1):(m+=l(D.substr(0,X),!1),m+=D.substr(X))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const X=A.charCodeAt(1);X>=65&&X<=90&&(A=`/${String.fromCharCode(X+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const X=A.charCodeAt(0);X>=65&&X<=90&&(A=`${String.fromCharCode(X+32)}:${A.substr(2)}`)}m+=l(A,!0)}return W&&(m+="?",m+=l(W,!1)),C&&(m+="#",m+=o?C:y(C,!1)),m}function c(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+c(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(i)?n.replace(i,o=>c(o)):n}}),define(J[109],Z([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const t=w;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function k(w){const t=[];let P;try{const b=JSON.parse(w.arguments),p=b[b.length-1];p&&p.__$stack&&(b.pop(),P=p.__$stack),t.push(...b)}catch(b){t.push("Unable to log remote console arguments",w.arguments)}return{args:t,stack:P}}e.parse=k;function M(w){if(typeof w!="string")return M(k(w).stack);const t=w;if(t){const P=E(t),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(b&&b.length===4)return{uri:v.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=M;function E(w){if(!w)return w;const t=w.indexOf(`
`);return t===-1?w:w.substring(0,t)}function r(w,t){const{args:P,stack:b}=k(w),p=typeof P[0]=="string"&&P.length===1;let d=E(b);d&&(d=`(${d.trim()})`);let g=[];if(typeof P[0]=="string"?d&&p?g=[`%c[${t}] %c${P[0]} %c${d}`,f("blue"),f(""),f("grey")]:g=[`%c[${t}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:g=[`%c[${t}]%`,f("blue"),...P],d&&!p&&g.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=r;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(K,e,v,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(K,v):k?k.value=v:e.set(K,v),v},qe=this&&this.__classPrivateFieldGet||function(K,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call(K):L?L.value:e.get(K)};define(J[37],Z([0,1,31,25,7]),function(K,e,v,L,k){"use strict";var M,E,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(a,n,o){let l=a.get(n);return l===void 0&&(l=o,a.set(n,l)),l}e.getOrSet=f;function w(a){const n=[];return a.forEach((o,l)=>{n.push(`${l} => ${o}`)}),`Map(${a.size}) {${n.join(", ")}}`}e.mapToString=w;function t(a){const n=[];return a.forEach(o=>{n.push(o)}),`Set(${a.size}) {${n.join(", ")}}`}e.setToString=t;class P{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=P;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class p{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class g{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class I{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class y{constructor(n){this._iter=n}static forUris(n=()=>!1){return new y(new g(n))}static forPaths(){return new y(new p)}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new b)}clear(){this._root=void 0}set(n,o){const l=this._iter.reset(n);let m;for(this._root||(this._root=new I,this._root.segment=l.value()),m=this._root;;){const D=l.cmp(m.segment);if(D>0)m.left||(m.left=new I,m.left.segment=l.value()),m=m.left;else if(D<0)m.right||(m.right=new I,m.right.segment=l.value()),m=m.right;else if(l.hasNext())l.next(),m.mid||(m.mid=new I,m.mid.segment=l.value()),m=m.mid;else break}const S=m.value;return m.value=o,m.key=n,S}fill(n,o){const l=o.slice(0);(0,v.shuffle)(l);for(let m of l)this.set(m,n)}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let l=this._root;for(;l;){const m=o.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const l=this._iter.reset(n),m=[];let S=this._root;for(;S;){const D=l.cmp(S.segment);if(D>0)m.push([1,S]),S=S.left;else if(D<0)m.push([-1,S]),S=S.right;else if(l.hasNext())l.next(),m.push([0,S]),S=S.mid;else{for(o?(S.left=void 0,S.mid=void 0,S.right=void 0):S.value=void 0;m.length>0&&S.isEmpty();){let[A,W]=m.pop();switch(A){case 1:W.left=void 0;break;case 0:W.mid=void 0;break;case-1:W.right=void 0;break}S=W}break}}}findSubstr(n){const o=this._iter.reset(n);let l=this._root,m;for(;l;){const S=o.cmp(l.segment);if(S>0)l=l.left;else if(S<0)l=l.right;else if(o.hasNext())o.next(),m=l.value||m,l=l.mid;else break}return l&&l.value||m}findSuperstr(n){const o=this._iter.reset(n);let l=this._root;for(;l;){const m=o.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(n){for(const[o,l]of this)n(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){if(!n)return;const o=[n];for(;o.length>0;){const l=o.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&o.push(l.left),l.mid&&o.push(l.mid),l.right&&o.push(l.right))}}}e.TernarySearchTree=y;class u{constructor(n,o){this[M]="ResourceMap",n instanceof u?(this.map=new Map(n.map),this.toKey=o??u.defaultToKey):(this.map=new Map,this.toKey=n??u.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),o),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[l,m]of this.map)n(m,k.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield k.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[k.URI.parse(n[0]),n[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[k.URI.parse(n[0]),n[1]]}}e.ResourceMap=u,u.defaultToKey=a=>a.toString();var h;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class s{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const l=this._map.get(n);if(!!l)return o!==0&&this.touch(l,o),l.value}set(n,o,l=0){let m=this._map.get(n);if(m)m.value=o,l!==0&&this.touch(m,l);else{switch(m={key:n,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(n,m),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const l=this._state;let m=this._head;for(;m;){if(o?n.bind(o)(m.value,m.key,this):n(m.value,m.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const n=this,o=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.key,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}values(){const n=this,o=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.value,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}entries(){const n=this,o=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:[l.key,l.value],done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>n;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,l=n.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const l=n.next,m=n.previous;n===this._tail?(m.next=void 0,this._tail=m):(l.previous=m,m.next=l),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const l=n.next,m=n.previous;n===this._head?(l.previous=void 0,this._head=l):(l.previous=m,m.next=l),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,l)=>{n.push([l,o])}),n}fromJSON(n){this.clear();for(const[o,l]of n)this.set(o,l)}}e.LinkedMap=s;class c extends s{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class i{constructor(n){r.set(this,void 0),bt(this,r,n,"f")}get size(){return qe(this,r,"f").size}forEach(n,o){qe(this,r,"f").forEach(n,o)}get(n){return qe(this,r,"f").get(n)}has(n){return qe(this,r,"f").has(n)}entries(){return qe(this,r,"f").entries()}keys(){return qe(this,r,"f").keys()}values(){return qe(this,r,"f").values()}[(r=new WeakMap,Symbol.iterator)](){return qe(this,r,"f").entries()}}e.ReadonlyMapView=i}),define(J[110],Z([0,1,18,25,7]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(t){return JSON.stringify(t,f)}e.stringify=M;function E(t){let P=JSON.parse(t);return P=w(P),P}e.parse=E;var r;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(r=e.MarshalledId||(e.MarshalledId={}));function f(t,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function w(t,P=0){if(!t||P>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return k.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof v.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let b=0;b<t.length;++b)t[b]=w(t[b],P+1);else for(const b in t)Object.hasOwnProperty.call(t,b)&&(t[b]=w(t[b],P+1))}return t}e.revive=w}),define(J[10],Z([0,1,3,7]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.userData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebook="vscode-notebook",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractive="vscode-interactive",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,t){this._hosts[f]=w,this._ports[f]=t}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let t=this._hosts[w];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const P=this._ports[w],b=this._connectionTokens[w];let p=`path=${encodeURIComponent(f.path)}`;return typeof b=="string"&&(p+=`&tkn=${encodeURIComponent(b)}`),L.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${t}:${P}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new M;class E{asBrowserUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===k.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${k.vscodeFileResource}://${E.FALLBACK_AUTHORITY}`)?t.with({scheme:k.vscodeFileResource,authority:t.authority||E.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeFileResource?t.with({scheme:k.file,authority:t.authority!==E.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}E.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new E}),define(J[65],Z([0,1,37]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new v.LRUCache(1e4);function k(w){return f(w,"NFC",L)}e.normalizeNFC=k;const M=new v.LRUCache(1e4);function E(w){return f(w,"NFD",M)}e.normalizeNFD=E;const r=/[^\u0000-\u0080]/;function f(w,t,P){if(!w)return w;const b=P.get(w);if(b)return b;let p;return r.test(w)?p=w.normalize(t):p=w,P.set(w,p),p}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(t){return E(t).replace(w,"")}}()}),define(J[15],Z([0,1,29,10,8,3,25,7]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(p){return(0,r.uriToFsPath)(p,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,g,I=!1){return d===g?0:(0,E.compare)(this.getComparisonKey(d,I),this.getComparisonKey(g,I))}isEqual(d,g,I=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,I)===this.getComparisonKey(g,I)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,I=!1){if(d.scheme===g.scheme){if(d.scheme===L.Schemas.file)return v.isEqualOrParent(f(d),f(g),this._ignorePathCasing(d))&&d.query===g.query&&(I||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return v.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(I||d.fragment===g.fragment)}return!1}joinPath(d,...g){return r.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===L.Schemas.file?g=r.URI.file(k.dirname(f(d))).path:(g=k.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===L.Schemas.file?g=r.URI.file(k.normalize(f(d))).path:g=k.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===L.Schemas.file){const u=k.relative(f(d),f(g));return M.isWindows?v.toSlashes(u):u}let I=d.path||"/",y=g.path||"/";if(this._ignorePathCasing(d)){let u=0;for(const h=Math.min(I.length,y.length);u<h&&!(I.charCodeAt(u)!==y.charCodeAt(u)&&I.charAt(u).toLowerCase()!==y.charAt(u).toLowerCase());u++);I=y.substr(0,u)+I.substr(u)}return k.posix.relative(I,y)}resolvePath(d,g){if(d.scheme===L.Schemas.file){const I=r.URI.file(k.resolve(f(d),g));return d.with({authority:I.authority,path:I.path})}return g=v.toPosixPath(g),d.with({path:k.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,E.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=k.sep){if(d.scheme===L.Schemas.file){const I=f(d);return I.length>v.getRoot(I).length&&I[I.length-1]===g}else{const I=d.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=k.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=k.sep){let I=!1;if(d.scheme===L.Schemas.file){const y=f(d);I=y!==void 0&&y.length===v.getRoot(y).length&&y[y.length-1]===g}else{g="/";const y=d.path;I=y.length===1&&y.charCodeAt(y.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(p=>p.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new w(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(p,d){const g=[];for(let I=0;I<p.length;I++){const y=d(p[I]);p.some((u,h)=>h===I?!1:(0,e.isEqualOrParent)(y,d(u)))||g.push(p[I])}return g}e.distinctParents=t;var P;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(g){const I=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[s,c]=h.split(":");s&&c&&I.set(s,c)});const u=g.path.substring(0,g.path.indexOf(";"));return u&&I.set(p.META_DATA_MIME,u),I}p.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function b(p,d,g){if(d){let I=p.path;return I&&I[0]!==k.posix.sep&&(I=k.posix.sep+I),p.with({scheme:g,authority:d,path:I})}return p.with({scheme:g})}e.toLocalResource=b}),define(J[9],Z([0,1,24,17,4,2,15]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function r(z){return!!z&&typeof z.then=="function"}e.isThenable=r;function f(z){const $=new v.CancellationTokenSource,H=z($.token),U=new Promise((j,F)=>{const R=$.token.onCancellationRequested(()=>{R.dispose(),$.dispose(),F((0,L.canceled)())});Promise.resolve(H).then(T=>{R.dispose(),$.dispose(),j(T)},T=>{R.dispose(),$.dispose(),F(T)})});return new class{cancel(){$.cancel()}then(j,F){return U.then(j,F)}catch(j){return this.then(void 0,j)}finally(j){return U.finally(j)}}}e.createCancelablePromise=f;function w(z,$,H){return Promise.race([z,new Promise(U=>$.onCancellationRequested(()=>U(H)))])}e.raceCancellation=w;async function t(z){let $=-1;const H=z.map((j,F)=>j.then(R=>($=F,R))),U=await Promise.race(H);return z.forEach((j,F)=>{F!==$&&j.cancel()}),U}e.raceCancellablePromises=t;function P(z,$,H){let U;const j=setTimeout(()=>{U?.(void 0),H?.()},$);return Promise.race([z.finally(()=>clearTimeout(j)),new Promise(F=>U=F)])}e.raceTimeout=P;function b(z){return new Promise(($,H)=>{const U=z();r(U)?U.then($,H):$(U)})}e.asPromise=b;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(H,H).then(U)})}return new Promise((H,U)=>{this.queuedPromise.then(H,U)})}return this.activePromise=$(),new Promise((H,U)=>{this.activePromise.then(j=>{this.activePromise=null,H(j)},j=>{this.activePromise=null,U(j)})})}}e.Throttler=p;class d{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue($,H){const j=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get($)===j&&this.promiseMap.delete($)});return this.promiseMap.set($,j),j}}e.SequencerByKey=g;class I{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,H=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,j)=>{this.doResolve=U,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class y{constructor($){this.delayer=new I($),this.throttler=new p}trigger($,H){return this.delayer.trigger(()=>this.throttler.queue($),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class u{constructor(){this._isOpen=!1,this._promise=new Promise(($,H)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class h extends u{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function s(z,$){return $?new Promise((H,U)=>{const j=setTimeout(()=>{F.dispose(),H()},z),F=$.onCancellationRequested(()=>{clearTimeout(j),F.dispose(),U((0,L.canceled)())})}):f(H=>s(z,H))}e.timeout=s;function c(z,$=0){const H=setTimeout(z,$);return(0,M.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=c;function i(z){const $=[];let H=0;const U=z.length;function j(){return H<U?z[H++]():null}function F(R){R!=null&&$.push(R);const T=j();return T?T.then(F):Promise.resolve($)}return Promise.resolve(null).then(F)}e.sequence=i;function a(z,$=U=>!!U,H=null){let U=0;const j=z.length,F=()=>{if(U>=j)return Promise.resolve(H);const R=z[U++];return Promise.resolve(R()).then(O=>$(O)?Promise.resolve(O):F())};return F()}e.first=a;function n(z,$=U=>!!U,H=null){if(z.length===0)return Promise.resolve(H);let U=z.length;const j=()=>{U=-1;for(const F of z)F.cancel?.()};return new Promise((F,R)=>{for(const T of z)T.then(O=>{--U>=0&&$(O)?(j(),F(O)):U===0&&F(H)}).catch(O=>{--U>=0&&(j(),R(O))})})}e.firstParallel=n;class o{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((H,U)=>{this.outstandingPromises.push({factory:$,c:H,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const H=$.factory();H.then($.c,$.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class l extends o{constructor(){super(1)}}e.Queue=l;class m{constructor(){this.queues=new Map}queueFor($,H=E.extUri){const U=H.getComparisonKey($);let j=this.queues.get(U);return j||(j=new l,k.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(U)}),this.queues.set(U,j)),j}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=m;class S{constructor($,H){this._token=-1,typeof $=="function"&&typeof H=="number"&&this.setIfNotSet($,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},H)}setIfNotSet($,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},H))}}e.TimeoutTimer=S;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setInterval(()=>{$()},H)}}e.IntervalTimer=D;class A{constructor($,H){this.timeoutToken=-1,this.runner=$,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class W{constructor($,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=W;class C extends A{constructor($,H){super($,H);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=C;class X extends M.Disposable{constructor($,H,U,j){super();this.maxWorkChunkSize=$,this.maxPendingWork=H,this.throttleDelay=U,this.handler=j,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=$=>{const H=setTimeout(()=>$(z));let U=!1;return{dispose(){U||(U=!0,clearTimeout(H))}}}}else e.runWhenIdle=(z,$)=>{const H=requestIdleCallback(z,typeof $=="number"?{timeout:$}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(H))}}}}();class te{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=te;async function oe(z,$,H){let U;for(let j=0;j<H;j++)try{return await z()}catch(F){U=F,await s($)}throw U}e.retry=oe;class Y{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,H,U){return this._pending={taskId:$,cancel:()=>U?.(),promise:H},H.then(()=>this.donePending($),()=>this.donePending($)),H}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let H,U;const j=new Promise((F,R)=>{H=F,U=R});this._next={run:$,promise:j,promiseResolve:H,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=Y;class Q{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,H)=>{this.completeCallback=$,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(H=>{this.completeCallback($),this.resolved=!0,H()})}error($){return new Promise(H=>{this.errorCallback($),this.rejected=!0,H()})}cancel(){new Promise($=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=_;var q;(function(z){async function $(H){let U;const j=await Promise.all(H.map(F=>F.then(R=>R,R=>{U||(U=R)})));if(typeof U!="undefined")throw U;return j}z.settled=$})(q=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,9,29,37,8,25]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function r(){return Object.create(null)}e.getEmptyExpression=r;const f="**",w="/",t="[/\\\\]",P="[^/\\\\]",b=/\//g;function p(U){switch(U){case 0:return"";case 1:return`${P}*?`;default:return`(?:${t}|${P}+${t}|${t}${P}+)*?`}}function d(U,j){if(!U)return[];const F=[];let R=!1,T=!1,O="";for(const B of U){switch(B){case j:if(!R&&!T){F.push(O),O="";continue}break;case"{":R=!0;break;case"}":R=!1;break;case"[":T=!0;break;case"]":T=!1;break}O+=B}return O&&F.push(O),F}e.splitGlobAware=d;function g(U){if(!U)return"";let j="";const F=d(U,w);if(F.every(R=>R===f))j=".*";else{let R=!1;F.forEach((T,O)=>{if(T===f){R||(j+=p(2),R=!0);return}let B=!1,N="",V=!1,x="";for(const ie of T){if(ie!=="}"&&B){N+=ie;continue}if(V&&(ie!=="]"||!x)){let ne;ie==="-"?ne=ie:(ie==="^"||ie==="!")&&!x?ne="^":ie===w?ne="":ne=E.escapeRegExpCharacters(ie),x+=ne;continue}switch(ie){case"{":B=!0;continue;case"[":V=!0;continue;case"}":j+=`(?:${d(N,",").map(se=>g(se)).join("|")})`,B=!1,N="";break;case"]":j+="["+x+"]",V=!1,x="";break;case"?":j+=P;continue;case"*":j+=p(1);continue;default:j+=E.escapeRegExpCharacters(ie)}}O<F.length-1&&(F[O+1]!==f||O+2<F.length)&&(j+=t),R=!1})}return j}const I=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),a=function(){return!1},n=function(){return null};function o(U,j){if(!U)return n;let F;typeof U!="string"?F=U.pattern:F=U,F=F.trim();const R=`${F}_${!!j.trimForExclusions}`;let T=i.get(R);if(T)return l(T,U);let O;if(I.test(F)){const B=F.substr(4);T=function(N,V){return typeof N=="string"&&N.endsWith(B)?F:null}}else(O=y.exec(m(F,j)))?T=S(O[1],F):(j.trimForExclusions?h:u).test(F)?T=D(F,j):(O=s.exec(m(F,j)))?T=A(O[1].substr(1),F,!0):(O=c.exec(m(F,j)))?T=A(O[1],F,!1):T=W(F);return i.set(R,T),l(T,U)}function l(U,j){return typeof j=="string"?U:function(F,R){return L.isEqualOrParent(F,j.base)?U(M.relative(j.base,F),R):null}}function m(U,j){return j.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function S(U,j){const F=`/${U}`,R=`\\${U}`,T=function(B,N){return typeof B!="string"?null:N?N===U?j:null:B===U||B.endsWith(F)||B.endsWith(R)?j:null},O=[U];return T.basenames=O,T.patterns=[j],T.allBasenames=O,T}function D(U,j){const F=H(U.slice(1,-1).split(",").map(N=>o(N,j)).filter(N=>N!==n),U),R=F.length;if(!R)return n;if(R===1)return F[0];const T=function(N,V){for(let x=0,ie=F.length;x<ie;x++)if(F[x](N,V))return U;return null},O=F.find(N=>!!N.allBasenames);O&&(T.allBasenames=O.allBasenames);const B=F.reduce((N,V)=>V.allPaths?N.concat(V.allPaths):N,[]);return B.length&&(T.allPaths=B),T}function A(U,j,F){const R=M.sep===M.posix.sep,T=R?U:U.replace(b,M.sep),O=M.sep+T,B=M.posix.sep+U,N=F?function(V,x){return typeof V=="string"&&(V===T||V.endsWith(O)||!R&&(V===U||V.endsWith(B)))?j:null}:function(V,x){return typeof V=="string"&&(V===T||!R&&V===U)?j:null};return N.allPaths=[(F?"*/":"./")+U],N}function W(U){try{const j=new RegExp(`^${g(U)}$`);return function(F){return j.lastIndex=0,typeof F=="string"&&j.test(F)?U:null}}catch(j){return n}}function C(U,j,F){return!U||typeof j!="string"?!1:X(U)(j,void 0,F)}e.match=C;function X(U,j={}){if(!U)return a;if(typeof U=="string"||Q(U)){const F=o(U,j);if(F===n)return a;const R=function(T,O){return!!F(T,O)};return F.allBasenames&&(R.allBasenames=F.allBasenames),F.allPaths&&(R.allPaths=F.allPaths),R}return z(U,j)}e.parse=X;function te(U){if(!U)return;let j;return F=>(j||(j=(U()||Promise.resolve([])).then(R=>R?Y(R):{})),j.then(R=>!!R[F]))}e.hasSiblingPromiseFn=te;function oe(U){if(!U)return;let j;return F=>{if(!j){const R=U();j=R?Y(R):{}}return!!j[F]}}e.hasSiblingFn=oe;function Y(U){const j={};for(const F of U)j[F]=!0;return j}function Q(U){const j=U;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=Q;function _(U){return U.allBasenames||[]}e.getBasenameTerms=_;function q(U){return U.allPaths||[]}e.getPathTerms=q;function z(U,j){const F=H(Object.getOwnPropertyNames(U).map(N=>$(N,U[N],j)).filter(N=>N!==n)),R=F.length;if(!R)return n;if(!F.some(N=>!!N.requiresSiblings)){if(R===1)return F[0];const N=function(ie,ne){for(let ce=0,se=F.length;ce<se;ce++){const ae=F[ce](ie,ne);if(ae)return ae}return null},V=F.find(ie=>!!ie.allBasenames);V&&(N.allBasenames=V.allBasenames);const x=F.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return x.length&&(N.allPaths=x),N}const T=function(N,V,x){let ie;for(let ne=0,ce=F.length;ne<ce;ne++){const se=F[ne];se.requiresSiblings&&x&&(V||(V=M.basename(N)),ie||(ie=V.substr(0,V.length-M.extname(N).length)));const ae=se(N,V,ie,x);if(ae)return ae}return null},O=F.find(N=>!!N.allBasenames);O&&(T.allBasenames=O.allBasenames);const B=F.reduce((N,V)=>V.allPaths?N.concat(V.allPaths):N,[]);return B.length&&(T.allPaths=B),T}function $(U,j,F){if(j===!1)return n;const R=o(U,F);if(R===n)return n;if(typeof j=="boolean")return R;if(j){const T=j.when;if(typeof T=="string"){const O=(B,N,V,x)=>{if(!x||!R(B,N))return null;const ie=T.replace("$(basename)",V),ne=x(ie);return(0,v.isThenable)(ne)?ne.then(ce=>ce?U:null):ne?U:null};return O.requiresSiblings=!0,O}}return R}function H(U,j){const F=U.filter(N=>!!N.basenames);if(F.length<2)return U;const R=F.reduce((N,V)=>{const x=V.basenames;return x?N.concat(x):N},[]);let T;if(j){T=[];for(let N=0,V=R.length;N<V;N++)T.push(j)}else T=F.reduce((N,V)=>{const x=V.patterns;return x?N.concat(x):N},[]);const O=function(N,V){if(typeof N!="string")return null;if(!V){let ie;for(ie=N.length;ie>0;ie--){const ne=N.charCodeAt(ie-1);if(ne===47||ne===92)break}V=N.substr(ie)}const x=R.indexOf(V);return x!==-1?T[x]:null};O.basenames=R,O.patterns=T,O.allBasenames=R;const B=U.filter(N=>!N.basenames);return B.push(O),B}}),define(J[33],Z([0,1,29,10,8,3,15,25,7]),function(K,e,v,L,k,M,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(o,l,m){if(typeof o=="string"&&(o=f.URI.file(o)),m){const D=m.getWorkspaceFolder(o);if(D){const A=m.getWorkspace().folders.length>1;let W;if((0,E.isEqual)(D.uri,o)?W="":W=(0,E.relativePath)(D.uri,o),A){const C=D.name?D.name:(0,E.basename)(D.uri);W=W?C+" \u2022 "+W:C}return W}}if(o.scheme!==L.Schemas.file&&o.scheme!==L.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(o.fsPath))return(0,k.normalize)(P(o.fsPath));let S=(0,k.normalize)(o.fsPath);return!M.isWindows&&l?.userHome&&(S=p(S,l.userHome.fsPath)),S}e.getPathLabel=w;function t(o){if(!o)return;typeof o=="string"&&(o=f.URI.file(o));const l=(0,E.basename)(o)||(o.scheme===L.Schemas.file?o.fsPath:o.path);return M.isWindows&&(0,v.isRootOrDriveLetter)(l)?P(l):l}e.getBaseLabel=t;function P(o){return(0,v.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=P;let b=Object.create(null);function p(o,l){if(M.isWindows||!o||!l)return o;let m=b.original===l?b.normalized:void 0;return m||(m=`${(0,r.rtrim)(l,k.posix.sep)}${k.posix.sep}`,b={original:l,normalized:m}),(M.isLinux?o.startsWith(m):(0,r.startsWithIgnoreCase)(o,m))&&(o=`~/${o.substr(m.length)}`),o}e.tildify=p;function d(o,l){return o.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const g="\u2026",I="\\\\",y="~";function u(o,l=k.sep){const m=new Array(o.length);let S=!1;for(let D=0;D<o.length;D++){let A=o[D];if(A===""){m[D]=`.${l}`;continue}if(!A){m[D]=A;continue}S=!0;let W="";A.indexOf(I)===0?(W=A.substr(0,A.indexOf(I)+I.length),A=A.substr(A.indexOf(I)+I.length)):A.indexOf(l)===0?(W=A.substr(0,A.indexOf(l)+l.length),A=A.substr(A.indexOf(l)+l.length)):A.indexOf(y)===0&&(W=A.substr(0,A.indexOf(y)+y.length),A=A.substr(A.indexOf(y)+y.length));const C=A.split(l);for(let X=1;S&&X<=C.length;X++)for(let te=C.length-X;S&&te>=0;te--){S=!1;let oe=C.slice(te,te+X).join(l);for(let Y=0;!S&&Y<o.length;Y++)if(Y!==D&&o[Y]&&o[Y].indexOf(oe)>-1){const Q=te+X===C.length,_=te>0&&o[Y].indexOf(l)>-1?l+oe:oe,q=o[Y].endsWith(_);S=!Q||q}if(!S){let Y="";(C[0].endsWith(":")||W!=="")&&(te===1&&(te=0,X++,oe=C[0]+l+oe),te>0&&(Y=C[0]+l),Y=W+Y),te>0&&(Y=Y+g+l),Y=Y+oe,te+X<C.length&&(Y=Y+l+g),m[D]=Y}}S&&(m[D]=A)}return m}e.shorten=u;var h;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function s(o,l=Object.create(null)){const m=[];let S=!1,D="";for(const A of o)if(A==="$"||S&&A==="{")D&&m.push({value:D,type:h.TEXT}),D="",S=!0;else if(A==="}"&&S){const W=l[D];if(typeof W=="string")W.length&&m.push({value:W,type:h.VARIABLE});else if(W){const C=m[m.length-1];(!C||C.type!==h.SEPARATOR)&&m.push({value:W.label,type:h.SEPARATOR})}D="",S=!1}else D+=A;return D&&!S&&m.push({value:D,type:h.TEXT}),m.filter((A,W)=>{if(A.type===h.SEPARATOR){const C=m[W-1],X=m[W+1];return[C,X].every(te=>te&&(te.type===h.VARIABLE||te.type===h.TEXT)&&te.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=s;function c(o,l){return M.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):o.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function i(o,l){return M.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,""):M.isWindows?o.replace(/&&|&/g,m=>m==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function a(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=a;function n(o){const l=o.indexOf("/")!==-1?k.posix:k.win32,m=l.basename(o),S=l.dirname(o);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}e.splitName=n}),define(J[28],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return v.test(f)}e.isUUID=L;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function r(){E(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,w="";return w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w}e.generateUuid=r}),define(J[112],Z([0,1,58,30,43]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(E,r){if(await new Promise((t,P)=>{const b=L.createReadStream(E),p=v.createHash("sha1");b.pipe(p);const d=(0,k.once)((g,I)=>{b.removeAllListeners(),p.removeAllListeners(),g?P(g):t(I)});b.once("error",d),b.once("end",d),p.once("error",d),p.once("data",g=>d(void 0,g.toString("hex")))})!==r)throw new Error("Hash mismatch")}e.checksum=M}),define(J[80],Z([0,1,239]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new v.StringDecoder(M),this.remaining=null}write(M){const E=[],r=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(r.length<1)return E;let f=0,w,t=f;for(;t<r.length;)if(w=r.charCodeAt(t),w===13||w===10){if(E.push(r.substring(f,t)),t++,t<r.length){const P=w;w=r.charCodeAt(t),(P===13&&w===10||P===10&&w===13)&&t++}f=t}else t++;return this.remaining=f<r.length?r.substr(f):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(J[113],Z([0,1,26]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(r){const f=r.replace(/\-/g,":").toLowerCase();return!L.has(f)}function M(){return new Promise(async(r,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{r(await E())}catch(t){f(t)}finally{clearTimeout(w)}})}e.getMac=M;function E(){return new Promise((r,f)=>{try{const w=(0,v.networkInterfaces)();for(let t in w){const P=w[t];if(P){for(const{mac:b}of P)if(k(b))return r(b)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(J[66],Z([0,1,26,17,37,28,113]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,P=0;const b=(0,v.networkInterfaces)();for(let p in b){const d=b[p];if(d)for(const{mac:g,internal:I}of d)I||(P+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(t+=1))}this._value=P>0?t/P:0}return this._value}};let r;async function f(){return r||(r=(async()=>await w()||M.generateUuid())()),r}e.getMachineId=f;async function w(){try{const t=await new Promise((b,p)=>{K(["crypto"],b,p)}),P=await(0,E.getMac)();return t.createHash("sha256").update(P,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(J[19],Z([0,1,30,26,114,9,29,65,8,3,15,7,28]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function d(_,q=p.UNLINK){if((0,E.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return q===p.UNLINK?I(_):g(_)}async function g(_){try{const q=(0,f.join)((0,L.tmpdir)(),(0,b.generateUuid)());try{await e.Promises.rename(_,q)}catch(z){return I(_)}I(q).catch(z=>{})}catch(q){if(q.code!=="ENOENT")throw q}}async function I(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function y(_){if((0,E.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(_,{recursive:!0})}e.rimrafSync=y;async function u(_,q){return c(await(q?h(_):(0,k.promisify)(v.readdir)(_)))}async function h(_){try{return await(0,k.promisify)(v.readdir)(_,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const q=[],z=await u(_);for(const $ of z){let H=!1,U=!1,j=!1;try{const F=await e.Promises.lstat((0,f.join)(_,$));H=F.isFile(),U=F.isDirectory(),j=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}q.push({name:$,isFile:()=>H,isDirectory:()=>U,isSymbolicLink:()=>j})}return q}function s(_){return c(v.readdirSync(_))}e.readdirSync=s;function c(_){return _.map(q=>typeof q=="string"?w.isMacintosh?(0,r.normalizeNFC)(q):q:(q.name=w.isMacintosh?(0,r.normalizeNFC)(q.name):q.name,q))}async function i(_){const q=await u(_),z=[];for(const $ of q)await n.existsDirectory((0,f.join)(_,$))&&z.push($);return z}function a(_,q=1e3){return new Promise(z=>{let $=!1;const H=setInterval(()=>{$||($=!0,v.access(_,U=>{$=!1,U&&(clearInterval(H),z(void 0))}))},q)})}e.whenDeleted=a;var n;(function(_){async function q(H){let U;try{if(U=await e.Promises.lstat(H),!U.isSymbolicLink())return{stat:U}}catch(j){}try{return{stat:await e.Promises.stat(H),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(w.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw F}throw j}}_.stat=q;async function z(H){try{const{stat:U,symbolicLink:j}=await _.stat(H);return U.isFile()&&j?.dangling!==!0}catch(U){}return!1}_.existsFile=z;async function $(H){try{const{stat:U,symbolicLink:j}=await _.stat(H);return U.isDirectory()&&j?.dangling!==!0}catch(U){}return!1}_.existsDirectory=$})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new M.ResourceQueue;function l(_,q,z){return o.queueFor(P.URI.file(_),t.extUriBiasedIgnorePathCase).queue(()=>{const $=A(z);return new Promise((H,U)=>S(_,q,$,j=>j?U(j):H()))})}let m=!0;function S(_,q,z,$){if(!m)return v.writeFile(_,q,{mode:z.mode,flag:z.flag},$);v.open(_,z.flag,z.mode,(H,U)=>{if(H)return $(H);v.writeFile(U,q,j=>{if(j)return v.close(U,()=>$(j));v.fdatasync(U,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),m=!1),v.close(U,R=>$(R))))})})}function D(_,q,z){const $=A(z);if(!m)return v.writeFileSync(_,q,{mode:$.mode,flag:$.flag});const H=v.openSync(_,$.flag,$.mode);try{v.writeFileSync(H,q);try{v.fdatasyncSync(H)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),m=!1}}finally{v.closeSync(H)}}e.writeFileSync=D;function A(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function W(_,q){if(_===q)return;async function z($){try{const H=await e.Promises.lstat($);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes($,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(_,q),await z(q)}catch($){if(_.toLowerCase()!==q.toLowerCase()&&$.code==="EXDEV"||_.endsWith("."))await C(_,q,{preserveSymlinks:!1}),await d(_,p.MOVE),await z(q);else throw $}}async function C(_,q,z){return te(_,q,{root:{source:_,target:q},options:z,handledSourcePaths:new Set})}const X=511;async function te(_,q,z){if(z.handledSourcePaths.has(_))return;z.handledSourcePaths.add(_);const{stat:$,symbolicLink:H}=await n.stat(_);if(H){if(z.options.preserveSymlinks)try{return await Q(_,q,z)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(H.dangling)return}return $.isDirectory()?oe(_,q,$.mode&X,z):Y(_,q,$.mode&X)}async function oe(_,q,z,$){await e.Promises.mkdir(q,{recursive:!0,mode:z});const H=await u(_);for(const U of H)await te((0,f.join)(_,U),(0,f.join)(q,U),$)}async function Y(_,q,z){await e.Promises.copyFile(_,q),await e.Promises.chmod(q,z)}async function Q(_,q,z){let $=await e.Promises.readlink(_);(0,E.isEqualOrParent)($,z.root.source,!w.isLinux)&&($=(0,f.join)(z.root.target,$.substr(z.root.source.length+1))),await e.Promises.symlink($,q)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(0,k.promisify)(v.read)}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(0,k.promisify)(v.write)}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return i}get writeFile(){return l}get rm(){return d}get move(){return W}get copy(){return C}}}),define(J[81],Z([0,1,30,8,25,19]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(t){const P=(0,L.dirname)(t);if(t===P)return t;const b=((0,L.basename)(t)||t).toLowerCase();try{const d=(0,M.readdirSync)(P).filter(g=>g.toLowerCase()===b);if(d.length===1){const g=E(P);if(g)return(0,L.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(b);if(g>=0){const I=E(P);if(I)return(0,L.join)(I,d[g])}}}catch(p){}return null}e.realcaseSync=E;async function r(t){try{return await M.Promises.realpath(t)}catch(P){const b=w(t);return await M.Promises.access(b,v.constants.R_OK),b}}e.realpath=r;function f(t){try{return v.realpathSync(t)}catch(P){const b=w(t);return v.accessSync(b,v.constants.R_OK),b}}e.realpathSync=f;function w(t){return(0,k.rtrim)((0,L.normalize)(t),L.sep)}}),define(J[115],Z([0,1,59]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(r,f,w,t=1){let P=!1;return new Promise(b=>{const p=setTimeout(()=>{if(!P)return P=!0,b(0)},w);k(r,f,t,d=>{if(!P)return P=!0,clearTimeout(p),b(d)})})}e.findFreePort=L;function k(r,f,w,t){if(f===0)return t(0);const P=new v.Socket;P.once("connect",()=>(E(P),k(r+w,f-1,w,t))),P.once("data",()=>{}),P.once("error",b=>(E(P),b.code!=="ECONNREFUSED"?k(r+w,f-1,w,t):t(r))),P.connect(r,"127.0.0.1")}function M(r,f,w){let t=!1,P,b=1;const p=v.createServer({pauseOnConnect:!0});function d(g,I){t||(t=!0,p.removeAllListeners(),p.close(),P&&clearTimeout(P),I(g))}return new Promise(g=>{P=setTimeout(()=>{d(0,g)},w),p.on("listening",()=>{d(r,g)}),p.on("error",I=>{I&&(I.code==="EADDRINUSE"||I.code==="EACCES")&&b<f?(r++,b++,p.listen(r,"127.0.0.1")):d(0,g)}),p.on("close",()=>{d(0,g)}),p.listen(r,"127.0.0.1")})}e.findFreePortFaster=M;function E(r){try{r.removeAllListeners("connect"),r.removeAllListeners("error"),r.end(),r.destroy(),r.unref()}catch(f){console.error(f)}}}),define(J[116],Z([0,1,26,8,19]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,E=/^Microsoft.PowerShell_.*/,r=/^Microsoft.PowerShellPreview_.*/;var f;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class P{constructor(c,i,a){this.exePath=c,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:s=!1}={}){return s?w===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:s=!1,findPreview:c=!1}={}){const i=b({useAlternateBitness:s});if(!i)return null;const a=L.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let n=-1,o=null;for(const S of await k.Promises.readdir(a)){let D=-1;if(c){const W=S.indexOf("-");if(W<0)continue;const C=S.substring(0,W);if(!M.test(C)||S.substring(W+1)!=="preview")continue;D=parseInt(C,10)}else{if(!M.test(S))continue;D=parseInt(S,10)}if(D<=n)continue;const A=L.join(a,S,"pwsh.exe");!await k.SymlinkSupport.existsFile(A)||(o=A,n=D)}if(!o)return null;const l=i.includes("x86")?" (x86)":"",m=c?" Preview":"";return new P(o,`PowerShell${m}${l}`,!0)}async function d({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=s?{pwshMsixDirRegex:r,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(c))if(i.test(n)){const o=L.join(c,n,"pwsh.exe");return new P(o,a)}return null}function g(){const s=L.join(v.homedir(),".dotnet","tools","pwsh.exe");return new P(s,".NET Core PowerShell Global Tool")}function I(){const s=L.join(process.env.windir,w===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(s,"Windows PowerShell",!0)}async function*y(){let s=await p();s&&(yield s),s=await p({useAlternateBitness:!0}),s&&(yield s),s=await d(),s&&(yield s),s=g(),s&&(yield s),s=await p({findPreview:!0}),s&&(yield s),s=await d({findPreview:!0}),s&&(yield s),s=await p({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=I(),s&&(yield s)}async function*u(){for await(const s of y())await s.exists()&&(yield s)}e.enumeratePowerShellInstallations=u;async function h(){for await(const s of u())return s;return null}e.getFirstAvailablePowerShellInstallation=h}),define(J[82],Z([0,1,41,10]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(E){return new Promise((r,f)=>{let w;const t=new Map;function P(p,d,g,I,y){const u=t.get(d);if(p===E||u){const h={name:b(g),cmd:g,pid:p,ppid:d,load:I,mem:y};t.set(p,h),p===E&&(w=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((s,c)=>s.pid-c.pid)))}}function b(p){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,y=/\\pipe\\winpty-control/,u=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(g.exec(p))return"watcherService ";if(I.exec(p))return"electron-crash-reporter";if(y.exec(p))return"winpty-process";if(u.exec(p))return"console-window-host (Windows internal process)";let s=h.exec(p);if(s&&s.length===2)return s[1]==="renderer"?d.exec(p)?"shared-process":"window":s[1];const c=/[a-zA-Z-]+\.js/g;let i="";do s=c.exec(p),s&&(i+=s+" ");while(s);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{K(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(E,g=>{d.getProcessCpuUsage(g,I=>{const y=new Map;I.forEach(u=>{const h=p(u.commandLine||"");y.set(u.pid,{name:b(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),w=y.get(E),w?(y.forEach(u=>{const h=y.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),y.forEach(u=>{u.children&&(u.children=u.children.sort((h,s)=>h.pid-s.pid))}),r(w)):f(new Error(`Root process ${E} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[w];const g=[];for(;d.length;){const y=d.shift();y&&(g.push(y.pid),y.children&&(d=d.concat(y.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);I+=" "+g.join(" "),(0,v.exec)(I,{},(y,u,h)=>{if(y||h)f(y||new Error(h.toString()));else{const s=u.toString().split(`
`);for(let c=0;c<g.length;c++){const i=t.get(g[c]);i.load=parseFloat(s[c])}if(!w){f(new Error(`Root process ${E} not found`));return}r(w)}})};(0,v.exec)("which ps",{},(d,g,I)=>{if(d||I)if(process.platform!=="linux")f(d||new Error(I.toString()));else{const y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,v.exec)(y,{},(u,h,s)=>{u||s?f(u||new Error(s.toString())):(M(h,P),p())})}else{const y=g.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${y} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,s,c)=>{h||c&&!c.includes("screen size is bogus")?f(h||new Error(c.toString())):(M(s,P),process.platform==="linux"?p():w?r(w):f(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=k;function M(E,r){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=E.toString().split(`
`);for(const t of w){const P=f.exec(t.trim());P&&P.length===6&&r(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(J[117],Z([0,1,30,29,2,65,8,3,19]),function(K,e,v,L,k,M,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(b,p,d){return P({path:b,isDirectory:!1},p,d)}e.watchFile=w;function t(b,p,d){return P({path:b,isDirectory:!0},p,d)}e.watchFolder=t,e.CHANGE_BUFFER_DELAY=100;function P(b,p,d){if(r.isMacintosh&&(0,L.isEqualOrParent)(b.path,"/Volumes/"))return d(`Refusing to watch ${b.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=(0,E.basename)(b.path),I=new Map;let y=!1,u=[(0,k.toDisposable)(()=>{I.forEach(h=>(0,k.dispose)(h)),I.clear()})];try{const h=(0,v.watch)(b.path);u.push((0,k.toDisposable)(()=>{h.removeAllListeners(),h.close()}));const s=new Set;b.isDirectory&&f.Promises.readdir(b.path).then(c=>c.forEach(i=>s.add(i))),h.on("error",(c,i)=>{y||d(`Failed to watch ${b.path} for changes using fs.watch() (${c}, ${i})`)}),h.on("change",(c,i)=>{if(y)return;let a="";if(i&&(a=i.toString(),r.isMacintosh&&(a=(0,M.normalizeNFC)(a))),!a||c!=="change"&&c!=="rename")return;const n=b.isDirectory?(0,E.join)(b.path,a):b.path;if(b.isDirectory)if(c==="rename"){const o=I.get(n);o&&(0,k.dispose)(o);const l=setTimeout(async()=>{I.delete(n);const m=await f.Promises.exists(n);if(y)return;let S;m?s.has(a)?S="changed":(S="added",s.add(a)):(s.delete(a),S="deleted"),p(S,n)},e.CHANGE_BUFFER_DELAY);I.set(n,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let o;s.has(a)?o="changed":(o="added",s.add(a)),p(o,n)}else if(c==="rename"||a!==g){const o=setTimeout(async()=>{const l=await f.Promises.exists(n);y||(l?(p("changed",n),u=[P(b,p,d)]):p("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(u),u=[(0,k.toDisposable)(()=>clearTimeout(o))]}else p("changed",n)})}catch(h){f.Promises.exists(b.path).then(s=>{s&&!y&&d(`Failed to watch ${b.path} for changes using fs.watch() (${h.toString()})`)})}return(0,k.toDisposable)(()=>{y=!0,u=(0,k.dispose)(u)})}}),define(J[118],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,13,118]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){v.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(r,f,w,t,P)=>{const b=E(r,t,w);b.popup({window:(0,L.withNullAsUndefined)(v.BrowserWindow.fromWebContents(r.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{b&&r.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function E(r,f,w){const t=new v.Menu;return w.forEach(P=>{let b;P.type==="separator"?b=new v.MenuItem({type:P.type}):Array.isArray(P.submenu)?b=new v.MenuItem({submenu:E(r,f,P.submenu),label:P.label}):b=new v.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(p,d,g)=>r.sender.send(f,P.id,g)}),t.append(b)}),t}});var ue=this&&this.__decorate||function(K,e,v,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(K,e,v,L);else for(var r=K.length-1;r>=0;r--)(E=K[r])&&(M=(k<3?E(M):k>3?E(e,v,M):E(e,v))||M);return k>3&&M&&Object.defineProperty(e,v,M),M};define(J[35],Z([0,1,31,9,18,24,46,17,4,2,110,25,13]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function d(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function I(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(y||(y={}));class u{constructor(U){this.buffer=U,this.pos=0}read(U){const j=this.buffer.slice(this.pos,this.pos+U);return this.pos+=j.byteLength,j}}class h{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var s;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(s||(s={}));function c(H){const U=k.VSBuffer.alloc(4);return U.writeUInt32BE(H,0),U}function i(H){return H.read(4).readUInt32BE(0)}function a(H){const U=k.VSBuffer.alloc(1);return U.writeUInt8(H,0),U}const n={Undefined:a(s.Undefined),String:a(s.String),Buffer:a(s.Buffer),VSBuffer:a(s.VSBuffer),Array:a(s.Array),Object:a(s.Object)},o=typeof Buffer!="undefined";function l(H,U){if(typeof U=="undefined")H.write(n.Undefined);else if(typeof U=="string"){const j=k.VSBuffer.fromString(U);H.write(n.String),H.write(c(j.byteLength)),H.write(j)}else if(o&&Buffer.isBuffer(U)){const j=k.VSBuffer.wrap(U);H.write(n.Buffer),H.write(c(j.byteLength)),H.write(j)}else if(U instanceof k.VSBuffer)H.write(n.VSBuffer),H.write(c(U.byteLength)),H.write(U);else if(Array.isArray(U)){H.write(n.Array),H.write(c(U.length));for(const j of U)l(H,j)}else{const j=k.VSBuffer.fromString(JSON.stringify(U));H.write(n.Object),H.write(c(j.byteLength)),H.write(j)}}function m(H){switch(H.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return H.read(i(H)).toString();case s.Buffer:return H.read(i(H)).buffer;case s.VSBuffer:return H.read(i(H));case s.Array:{const j=i(H),F=[];for(let R=0;R<j;R++)F.push(m(H));return F}case s.Object:return JSON.parse(H.read(i(H)).toString())}}class S{constructor(U,j,F=null,R=1e3){this.protocol=U,this.ctx=j,this.logger=F,this.timeoutDelay=R,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel(U,j){this.channels.set(U,j),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const j=this.send([U.type]);this.logger&&this.logger.logOutgoing(j,0,1,I(U.type));return}case 201:case 202:case 204:case 203:{const j=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(j,U.id,1,I(U.type),U.data);return}}}send(U,j=void 0){const F=new h;return l(F,U),l(F,j),this.sendBuffer(F.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(j){return 0}}onRawMessage(U){const j=new u(U),F=m(j),R=m(j),T=F[0];switch(T){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],1,`${d(T)}: ${F[2]}.${F[3]}`,R),this.onPromise({type:T,id:F[1],channelName:F[2],name:F[3],arg:R});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],1,`${d(T)}: ${F[2]}.${F[3]}`,R),this.onEventListen({type:T,id:F[1],channelName:F[2],name:F[3],arg:R});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],1,`${d(T)}`),this.disposeActiveRequest({type:T,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],1,`${d(T)}`),this.disposeActiveRequest({type:T,id:F[1]})}}onPromise(U){const j=this.channels.get(U.channelName);if(!j){this.collectPendingRequest(U);return}const F=new M.CancellationTokenSource;let R;try{R=j.call(this.ctx,U.name,U.arg,F.token)}catch(B){R=Promise.reject(B)}const T=U.id;R.then(B=>{this.sendResponse({id:T,data:B,type:201}),this.activeRequests.delete(U.id)},B=>{B instanceof Error?this.sendResponse({id:T,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:T,data:B,type:203}),this.activeRequests.delete(U.id)});const O=(0,w.toDisposable)(()=>F.cancel());this.activeRequests.set(U.id,O)}onEventListen(U){const j=this.channels.get(U.channelName);if(!j){this.collectPendingRequest(U);return}const F=U.id,T=j.listen(this.ctx,U.name,U.arg)(O=>this.sendResponse({id:F,data:O,type:204}));this.activeRequests.set(U.id,T)}disposeActiveRequest(U){const j=this.activeRequests.get(U.id);j&&(j.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let j=this.pendingRequests.get(U.channelName);j||(j=[],this.pendingRequests.set(U.channelName,j));const F=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:U,timeoutTimer:F})}flushPendingRequests(U){const j=this.pendingRequests.get(U);if(j){for(const F of j)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=S;var D;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(U,j=null){this.protocol=U,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=j}getChannel(U){const j=this;return{call(F,R,T){return j.isDisposed?Promise.reject(r.canceled()):j.requestPromise(U,F,R,T)},listen(F,R){return j.isDisposed?Promise.reject(r.canceled()):j.requestEvent(U,F,R)}}}requestPromise(U,j,F,R=M.CancellationToken.None){const T=this.lastRequestId++,B={id:T,type:100,channelName:U,name:j,arg:F};if(R.isCancellationRequested)return Promise.reject(r.canceled());let N;return new Promise((x,ie)=>{if(R.isCancellationRequested)return ie(r.canceled());const ne=()=>{const pe=fe=>{switch(fe.type){case 201:this.handlers.delete(T),x(fe.data);break;case 202:this.handlers.delete(T);const we=new Error(fe.data.message);we.stack=fe.data.stack,we.name=fe.data.name,ie(we);break;case 203:this.handlers.delete(T),ie(fe.data);break}};this.handlers.set(T,pe),this.sendRequest(B)};let ce=null;this.state===y.Idle?ne():(ce=(0,L.createCancelablePromise)(pe=>this.whenInitialized()),ce.then(()=>{ce=null,ne()}));const se=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:T,type:101}),ie(r.canceled())},ae=R.onCancellationRequested(se);N=(0,w.combinedDisposable)((0,w.toDisposable)(se),ae),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(U,j,F){const R=this.lastRequestId++,O={id:R,type:102,channelName:U,name:j,arg:F};let B=null;const N=new f.Emitter({onFirstListenerAdd:()=>{B=(0,L.createCancelablePromise)(x=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add(N),this.sendRequest(O)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete(N),this.sendRequest({id:R,type:103}))}}),V=x=>N.fire(x.data);return this.handlers.set(R,V),N.event}sendRequest(U){switch(U.type){case 100:case 102:{const j=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(j,U.id,0,`${d(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const j=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(j,U.id,0,d(U.type));return}}}send(U,j=void 0){const F=new h;return l(F,U),l(F,j),this.sendBuffer(F.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(j){return 0}}onBuffer(U){const j=new u(U),F=m(j),R=m(j),T=F[0];switch(T){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,I(T)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,F[1],0,I(T),R),this.onResponse({type:F[0],id:F[1],data:R})}}onResponse(U){if(U.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(U.id);j&&j(U)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}ue([E.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class W{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:j,onDidClientDisconnect:F})=>{f.Event.once(j.onMessage)(T=>{const O=new u(T),B=m(O),N=new S(j,B),V=new A(j);this.channels.forEach((ie,ne)=>N.registerChannel(ne,ie));const x={channelServer:N,channelClient:V,ctx:B};this._connections.add(x),this._onDidAddConnection.fire(x),F(()=>{N.dispose(),V.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)})})})}get connections(){const U=[];return this._connections.forEach(j=>U.push(j)),U}getChannel(U,j){const F=this;return{call(R,T,O){let B;if((0,b.isFunction)(j)){let V=(0,v.getRandomElement)(F.connections.filter(j));B=V?Promise.resolve(V):f.Event.toPromise(f.Event.filter(F.onDidAddConnection,j))}else B=j.routeCall(F,R,T);const N=B.then(V=>V.channelClient.getChannel(U));return X(N).call(R,T,O)},listen(R,T){if((0,b.isFunction)(j))return F.getMulticastEvent(U,j,R,T);const O=j.routeEvent(F,R,T).then(B=>B.channelClient.getChannel(U));return X(O).listen(R,T)}}}getMulticastEvent(U,j,F,R){const T=this;let O=new w.DisposableStore;const B=new f.Emitter({onFirstListenerAdd:()=>{O=new w.DisposableStore;const N=new f.EventMultiplexer,V=new Map,x=ne=>{const se=ne.channelClient.getChannel(U).listen(F,R),ae=N.add(se);V.set(ne,ae)},ie=ne=>{const ce=V.get(ne);!ce||(ce.dispose(),V.delete(ne))};T.connections.filter(j).forEach(x),f.Event.filter(T.onDidAddConnection,j)(x,void 0,O),T.onDidRemoveConnection(ie,void 0,O),N.event(B.fire,B,O),O.add(N)},onLastListenerRemove:()=>{O.dispose()}});return B.event}registerChannel(U,j){this.channels.set(U,j),this._connections.forEach(F=>{F.channelServer.registerChannel(U,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=W;class C{constructor(U,j,F=null){const R=new h;l(R,j),U.send(R.buffer),this.channelClient=new A(U,F),this.channelServer=new S(U,j,F)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,j){this.channelServer.registerChannel(U,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function X(H){return{call(U,j,F){return H.then(R=>R.call(U,j,F))},listen(U,j){const F=new f.Relay;return H.then(R=>F.input=R.listen(U,j)),F.event}}}e.getDelayedChannel=X;function te(H){let U=!1;return{call(j,F,R){return U?H.call(j,F,R):(0,L.timeout)(0).then(()=>U=!0).then(()=>H.call(j,F,R))},listen(j,F){if(U)return H.listen(j,F);const R=new f.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>R.input=H.listen(j,F)),R.event}}}e.getNextTickChannel=te;class oe{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const j of U.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await f.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=oe;var Y;(function(H){function U(R,T){const O=R,B=T&&T.disableMarshalling,N=new Map;for(const V in O)F(V)&&N.set(V,f.Event.buffer(O[V],!0));return new class{listen(V,x){const ie=N.get(x);if(ie)return ie;throw new Error(`Event not found: ${x}`)}call(V,x,ie){const ne=O[x];if(typeof ne=="function"){if(!B&&Array.isArray(ie))for(let ce=0;ce<ie.length;ce++)ie[ce]=(0,t.revive)(ie[ce]);return ne.apply(O,ie)}throw new Error(`Method not found: ${x}`)}}}H.fromService=U;function j(R,T){const O=T&&T.disableMarshalling;return new Proxy({},{get(B,N){if(typeof N=="string")return T?.properties?.has(N)?T.properties.get(N):F(N)?R.listen(N):async function(...V){let x;T&&!(0,b.isUndefinedOrNull)(T.context)?x=[T.context,...V]:x=V;const ie=await R.call(N,x);return O?ie:(0,t.revive)(ie)};throw new Error(`Property not found: ${String(N)}`)}})}H.toService=j;function F(R){return R[0]==="o"&&R[1]==="n"&&P.isUpperAsciiLetter(R.charCodeAt(2))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let U=H.toString();if(U!=="[object Object]")return U}return H}function q(H){return Array.isArray(H)?H.map(_):_(H)}function z(H,U,j,F,R,T,O){O=q(O);const B=Q[R],N=B[F%B.length];let V=[`%c[${H}]%c[${String(U).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(T)?(V=V.concat(O),V.push(")")):V.push(O),console.log.apply(console,V)}e.logWithColors=z;class ${constructor(U,j){this._outgoingPrefix=U,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,j,F,R,T){this._totalOutgoing+=U,z(this._outgoingPrefix,this._totalOutgoing,U,j,F,R,T)}logIncoming(U,j,F,R,T){this._totalIncoming+=U,z(this._incomingPrefix,this._totalIncoming,U,j,F,R,T)}}e.IPCLogger=$}),define(J[120],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(J[121],Z([0,1,18,4,35]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>v.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class E extends k.IPCClient{constructor(f,w){const t=new M(f);super(t,w);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[83],Z([0,1,18,4,2,3,32,35]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function t(){return w||(w=v.VSBuffer.alloc(0)),w}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,l){if(o===0)return t();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const A=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=o),A}if(this._chunks[0].byteLength>o){const A=this._chunks[0].slice(0,o);return l&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),A}let m=v.VSBuffer.alloc(o),S=0,D=0;for(;o>0;){const A=this._chunks[D];if(A.byteLength>o){const W=A.slice(0,o);m.set(W,S),S+=o,l&&(this._chunks[D]=A.slice(o),this._totalLength-=o),o-=o}else m.set(A,S),S+=A.byteLength,l?(this._chunks.shift(),this._totalLength-=A.byteLength):D++,o-=A.byteLength}return m}}e.ChunkStream=P;var b;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var p;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(o,l,m,S){this.type=o,this.id=l,this.ack=m,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(o){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const m=this._state.messageType,S=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(m,S,D,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=v.VSBuffer.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this._writeSoon(l,o.data)}_bufferAdd(o,l){const m=this._totalLength===0;return this._data.push(o,l),this._totalLength+=o.byteLength+l.byteLength,m}_bufferTake(){const o=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,l){this._bufferAdd(o,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class y extends k.Disposable{constructor(o){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new d(1,0,0,o))}}e.Protocol=y;class u extends r.IPCClient{constructor(o,l,m=null){super(o,l,m);this.protocol=o}static fromSocket(o,l){return new u(new y(o),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=u;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,E.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class s{constructor(o){this.data=o,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],l=0,m=this._first;for(;m;)o[l++]=m.data,m=m.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const l=new s(o);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{constructor(){this.lastRuns=[];const o=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=o-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const o=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let m=0;for(let S=0;S<i._HISTORY_LENGTH;S++)o-this.lastRuns[S]<=l&&m++;return 1-m/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class a{constructor(o,l=null,m=i.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new d(5,0,0,t());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const l=new d(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let l=0,m=o.length;l<m;l++)this._socketWriter.write(o[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new d(6,0,0,t())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const l=this._outgoingUnackMsg.toArray();for(let m=0,S=l.length;m<S;m++)this._socketWriter.write(l[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new d(1,l,this._incomingAckId,o);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(o){const l=new d(2,0,0,o);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),l=Date.now()-o.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new d(3,0,this._incomingAckId,t());this._socketWriter.write(o)}}e.PersistentProtocol=a}),define(J[122],Z([0,1,14,18,4,2,35,120]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,P){const b=k.Event.fromNodeEventEmitter(v.ipcMain,P,(d,g)=>({event:d,message:g})),p=k.Event.filter(b,({event:d})=>d.sender.id===t);return k.Event.map(p,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends E.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const P=k.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:b})=>b);return k.Event.map(P,b=>{const p=b.id,d=w.Clients.get(p);d&&d.dispose();const g=new k.Emitter;w.Clients.set(p,(0,M.toDisposable)(()=>g.fire()));const I=f(p,"vscode:message"),y=k.Event.any(k.Event.signal(f(p,"vscode:disconnect")),g.event);return{protocol:new r.Protocol(b,I),onDidClientDisconnect:y}})}}e.Server=w,w.Clients=new Map}),define(J[84],Z([0,1,14,4,28,121]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends M.Client{constructor(w,t){super({addEventListener:(P,b)=>w.addListener(P,b),removeEventListener:(P,b)=>w.removeListener(P,b),postMessage:P=>w.postMessage(P),start:()=>w.start(),close:()=>w.close()},t)}}e.Client=E;async function r(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const t=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(b,p)=>({nonce:p,port:b.ports[0]})),{port:P}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,b=>b.nonce===w)));return P}e.connect=r}),define(J[85],Z([0,1,9,4,2,13]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));function r(P){const b=P;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=r;var f;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(f||(f={}));class w extends k.Disposable{constructor(b,p=Object.create(null)){super();this.database=b,this.options=p,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((p,d)=>this.accept(d,p)),b.deleted?.forEach(p=>this.accept(p,void 0))}accept(b,p){if(this.state===f.Closed)return;let d=!1;(0,M.isUndefinedOrNull)(p)?d=this.cache.delete(b):this.cache.get(b)!==p&&(this.cache.set(b,p),d=!0),d&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,p){const d=this.cache.get(b);return(0,M.isUndefinedOrNull)(d)?p:d}getBoolean(b,p){const d=this.get(b);return(0,M.isUndefinedOrNull)(d)?p:d==="true"}getNumber(b,p){const d=this.get(b);return(0,M.isUndefinedOrNull)(d)?p:parseInt(d,10)}async set(b,p){if(this.state===f.Closed)return;if((0,M.isUndefinedOrNull)(p))return this.delete(b);const d=String(p);if(this.cache.get(b)!==d)return this.cache.set(b,d),this.pendingInserts.set(b,d),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===f.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class t{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((p,d)=>this.items.set(d,p)),b.delete&&b.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=t}),define(J[123],Z([0,1,9,4,37,8,19]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class r{constructor(t,P=Object.create(null)){this.path=t,this.options=P,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,P=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(p=>P.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(t){const P=await this.whenConnected;return this.doUpdateItems(P,t)}doUpdateItems(t,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,k.mapToString)(P.insert):"0"}), delete(${P.delete?(0,k.setToString)(P.delete):"0"})`),this.transaction(t,()=>{const b=P.insert,p=P.delete;if(b&&b.size>0){const d=[];d.push([]);let g=0;b.forEach((I,y)=>{let u=d[g];u.length>r.MAX_HOST_PARAMETERS&&(g++,u=[],d.push(u)),u.push(y,I)}),d.forEach(I=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(I.length/2).fill("(?,?)").join(",")}`,y=>y.run(I),()=>{const y=[];let u=0;return b.forEach((h,s)=>{y.push(s),u+=h.length}),`Keys: ${y.join(", ")} Length: ${u}`})})}if(p&&p.size){const d=[];d.push([]);let g=0;p.forEach(I=>{let y=d[g];y.length>r.MAX_HOST_PARAMETERS&&(g++,y=[],d.push(y)),y.push(I)}),d.forEach(I=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(I.length).fill("?").join(",")})`,y=>y.run(I),()=>{const y=[];return p.forEach(u=>{y.push(u)}),`Keys: ${y.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,t)}doClose(t,P){return new Promise((b,p)=>{t.db.close(d=>(d&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${d}`),this.path===r.IN_MEMORY_PATH?b():!t.isErroneous&&!t.isInMemory?this.backup().then(b,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),b())):typeof P=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const I=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:P()}).then(()=>I(),y=>(I(),Promise.reject(y)))})).then(b,p):p(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return E.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const P=await this.whenConnected,b=await this.get(P,t?"PRAGMA integrity_check":"PRAGMA quick_check"),p=t?b.integrity_check:b.quick_check;return P.isErroneous?`${p} (last error: ${P.lastError})`:P.isInMemory?`${p} (in-memory!)`:p}async connect(t,P=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${P})`);try{return await this.doConnect(t)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&P)return await(0,v.timeout)(r.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await E.Promises.unlink(t);try{await E.Promises.rename(this.toBackupPath(t),t)}catch(p){}return await this.doConnect(t)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(r.IN_MEMORY_PATH)}}}handleSQLiteError(t,P){t.isErroneous=!0,t.lastError=P,this.logger.error(P)}doConnect(t){return new Promise((P,b)=>{new Promise((p,d)=>{K(["@vscode/sqlite3"],p,d)}).then(p=>{const d={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(t,g=>g?d.db?d.db.close(()=>b(g)):b(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(d),I=>d.db.close(()=>b(I)))),isInMemory:t===r.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},b)})}exec(t,P){return new Promise((b,p)=>{t.db.exec(P,d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${d}`),p(d)):b())})}get(t,P){return new Promise((b,p)=>{t.db.get(P,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${d}`),p(d)):b(g))})}all(t,P){return new Promise((b,p)=>{t.db.all(P,(d,g)=>d?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${d}`),p(d)):b(g))})}transaction(t,P){return new Promise((b,p)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),P(),t.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${d}`),p(d)):b())})})}prepare(t,P,b,p){const d=t.db.prepare(P),g=I=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${I} (${P}). Details: ${p()}`)};d.on("error",g),b(d),d.finalize(I=>{I&&g(I),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=r,r.IN_MEMORY_PATH=":memory:",r.BUSY_OPEN_TIMEOUT=2e3,r.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,M=k*24,E=M*7,r=M*30,f=M*365;function w(P,b){typeof P!="number"&&(P=P.getTime());const p=Math.round((new Date().getTime()-P)/1e3);if(p<-30)return(0,v.localize)(0,null,w(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let d;return p<L?(d=p,b?d===1?(0,v.localize)(2,null,d):(0,v.localize)(3,null,d):d===1?(0,v.localize)(4,null,d):(0,v.localize)(5,null,d)):p<k?(d=Math.floor(p/L),b?d===1?(0,v.localize)(6,null,d):(0,v.localize)(7,null,d):d===1?(0,v.localize)(8,null,d):(0,v.localize)(9,null,d)):p<M?(d=Math.floor(p/k),b?d===1?(0,v.localize)(10,null,d):(0,v.localize)(11,null,d):d===1?(0,v.localize)(12,null,d):(0,v.localize)(13,null,d)):p<E?(d=Math.floor(p/M),b?d===1?(0,v.localize)(14,null,d):(0,v.localize)(15,null,d):d===1?(0,v.localize)(16,null,d):(0,v.localize)(17,null,d)):p<r?(d=Math.floor(p/E),b?d===1?(0,v.localize)(18,null,d):(0,v.localize)(19,null,d):d===1?(0,v.localize)(20,null,d):(0,v.localize)(21,null,d)):p<f?(d=Math.floor(p/r),b?d===1?(0,v.localize)(22,null,d):(0,v.localize)(23,null,d):d===1?(0,v.localize)(24,null,d):(0,v.localize)(25,null,d)):(d=Math.floor(p/f),b?d===1?(0,v.localize)(26,null,d):(0,v.localize)(27,null,d):d===1?(0,v.localize)(28,null,d):(0,v.localize)(29,null,d))}e.fromNow=w;function t(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(J[126],Z([12,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,31,13,126]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(w,t){return t&&(w.stack||w.stacktrace)?k.localize(0,null,r(w),E(w.stack)||E(w.stacktrace)):r(w)}function E(w){return Array.isArray(w)?w.join(`
`):w}function r(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function f(w=null,t=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const P=v.coalesce(w),b=f(P[0],t);return P.length>1?k.localize(4,null,b,P.length):b}if(L.isString(w))return w;if(w.detail){const P=w.detail;if(P.error)return M(P.error,t);if(P.exception)return M(P.exception,t)}return w.stack?M(w,t):w.message?w.message:k.localize(5,null)}e.toErrorMessage=f}),define(J[127],Z([12,11]),function(K,e){return K.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,r,f=r){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=r,this.modifierLabels[3]=f}toLabel(E,r,f){if(r.length===0)return null;const w=[];for(let t=0,P=r.length;t<P;t++){const b=r[t],p=f(b);if(p===null)return null;w[t]=k(b,p,this.modifierLabels[E])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,E,r){if(E===null)return"";const f=[];return M.ctrlKey&&f.push(r.ctrlKey),M.shiftKey&&f.push(r.shiftKey),M.altKey&&f.push(r.altKey),M.metaKey&&f.push(r.metaKey),E!==""&&f.push(E),f.join(r.separator)}}),define(J[129],Z([12,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,41,29,10,44,8,3,32,13,80,19,129]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(s,c){if(r.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const a=v.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(n=>{a.once("error",o=>{n({success:!1,error:o})}),a.once("exit",(o,l)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?p(i.status):1})}else if(r.isLinux||r.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(a=>{v.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(n,o,l)=>{a(n?{success:!1,error:n}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function g(s=f.env){return s.comspec||"cmd.exe"}e.getWindowsShell=g;class I{constructor(c,i,a,n){if(i!==void 0&&a!==void 0&&n!==void 0)this.cmd=c,this.args=i,this.shell=a,this.options=n;else{const o=c;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(f.env).forEach(l=>{o[l]=f.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(E.sep);return i!==-1&&(c=c.substring(i+1)),I.WellKnowCommands[c]?c:"other"}start(c){return r.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(i=>{let a,n;const o=new Promise((l,m)=>{a=l,n=m});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=v.exec(l,this.options,(m,S,D)=>{this.childProcess=null;const A=m;A&&A.killed?n({killed:this.terminateRequested,stdout:S.toString(),stderr:D.toString()}):this.handleExec(a,c,m,S,D)})}else{let l=null;const m=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,a,c,n);const D={terminated:this.terminateRequested};w.isNumber(S)&&(D.cmdCode=S),a(D)};if(this.shell&&r.isWindows){const S=M.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let D=!1,A=!1;const W=[];let C=this.ensureQuotes(this.cmd);W.push(C.value),D=C.quoted,this.args&&this.args.forEach(te=>{C=this.ensureQuotes(te),W.push(C.value),A=A&&C.quoted});const X=["/s","/c"];D?A?X.push('"'+W.join(" ")+'"'):W.length>1?X.push('"'+W[0]+'" '+W.slice(1).join(" ")):X.push('"'+W[0]+'"'):X.push(W.join(" ")),l=v.spawn(g(),X,S)}else this.cmd&&(l=v.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(w.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,n({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",m),this.handleSpawn(l,a,c,n,!0)))}return o})}handleClose(c,i,a,n){}ensureQuotes(c){return I.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,d(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!r.isWindows)return c(!1);const i=v.spawn(g(),["/s","/c"]);i.on("error",a=>c(!0)),i.on("exit",a=>c(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class y extends I{constructor(c,i,a,n){super(c,i,a,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,a,n,o){[n,o].forEach((l,m)=>{const S=new t.LineDecoder;S.write(l).forEach(W=>{i({line:W,source:m===0?0:1})});const A=S.end();A&&i({line:A,source:m===0?0:1})}),c({terminated:this.terminateRequested,error:a})}handleSpawn(c,i,a,n,o){const l=new t.LineDecoder,m=new t.LineDecoder;c.stdout.on("data",S=>{l.write(S).forEach(A=>a({line:A,source:0}))}),c.stderr.on("data",S=>{m.write(S).forEach(A=>a({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=m}handleClose(c,i,a,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&a({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&a({line:l,source:1})}}e.LineProcess=y;function u(s){let c=[],i=!1;const a=function(n){if(i){c.push(n);return}(!s.send(n,l=>{if(l&&console.error(l),i=!1,c.length>0){const m=c.slice(0);c=[],m.forEach(S=>a(S))}})||r.isWindows)&&(i=!0)};return{send:a}}e.createQueuedSender=u;var h;(function(s){async function c(i,a,n){if(E.isAbsolute(i))return i;if(a===void 0&&(a=f.cwd()),E.dirname(i)!=="."||(n===void 0&&w.isString(f.env.PATH)&&(n=f.env.PATH.split(E.delimiter)),n===void 0||n.length===0))return E.join(a,i);async function l(m){if(await P.Promises.exists(m)){let S;try{S=await P.Promises.stat(m)}catch(D){D.message.startsWith("EACCES")&&(S=await P.Promises.lstat(m))}return S?!S.isDirectory():!1}return!1}for(let m of n){let S;if(E.isAbsolute(m)?S=E.join(m,i):S=E.join(a,m,i),await l(S))return S;let D=S+".com";if(await l(D)||(D=S+".exe",await l(D)))return D}return E.join(a,i)}s.findExecutable=c})(h=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(p,d){return p===1?L.isWindows?P():M.getWindowsShell(d):w(p,d)}e.getSystemShell=E;function r(p,d){return p===1?L.isWindows?b(d):M.getWindowsShell(d):w(p,d)}e.getSystemShellSync=r;let f=null;function w(p,d){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,v.userInfo)().shell}catch(I){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let t=null;async function P(){return t||(t=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),t}function b(p){if(t)return t;const d=L.isWindows&&parseFloat((0,v.release)())>=10,g=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${p.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?I:M.getWindowsShell(p)}}),define(J[86],Z([0,1,41,9,18,24,109,17,4,2,44,3,68,35]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(y){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>k.VSBuffer.wrap(Buffer.from(u,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(y,u){this.modulePath=y,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(y){const u=this;return{call(h,s,c){return u.requestPromise(y,h,s,c)},listen(h,s){return u.requestEvent(y,h,s)}}}requestPromise(y,u,h,s=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(r.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(y),i=(0,L.createCancelablePromise)(o=>c.call(u,h,o)),a=s.onCancellationRequested(()=>i.cancel()),n=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{a.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(y,u,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let s;const c=new f.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(y).listen(u,h)(c.fire,c),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),P.isMacintosh&&u.env&&delete u.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,y,u);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,E.isRemoteConsoleLog)(l)){(0,E.log)(l,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),a=h.event,n={send:i,onMessage:a};this._client=new p.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,m)=>{process.removeListener("exit",o),this.activeRequests.forEach(S=>(0,w.dispose)(S)),this.activeRequests.clear(),l!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:m})})}return this._client}getCachedChannel(y){let u=this.channels.get(y);return u||(u=this.client.getChannel(y),this.channels.set(y,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(J[131],Z([12,11]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,4,2]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(r,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(r,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(r){super();this.channel=r}reload(r){this.channel.call("reload",[r])}get onReload(){return this.channel.listen("reload")}close(r){this.channel.call("close",[r])}get onClose(){return this.channel.listen("close")}attachSession(r,f,w){this.channel.call("attach",[r,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(r,f){this.channel.call("terminate",[r,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(r,f,w){return this.channel.call("openExtensionDevelopmentHostWindow",[r,f||{},w])}}e.ExtensionHostDebugChannelClient=M}),define(J[155],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(E){this.driver=E}listen(E,r){throw new Error(`No event found: ${r}`)}call(E,r,f){switch(r){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${r}`)}}e.WindowDriverChannel=v;class L{constructor(E){this.channel=E}click(E,r,f){return this.channel.call("click",[E,r,f])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,r){return this.channel.call("setValue",[E,r])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,r){return this.channel.call("getElements",[E,r])}getElementXY(E,r,f){return this.channel.call("getElementXY",[E,r,f])}typeInEditor(E,r){return this.channel.call("typeInEditor",[E,r])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,r){return this.channel.call("writeInTerminal",[E,r])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=k}),define(J[156],Z([0,1,125,46,10,8,32,15,7]),function(K,e,v,L,k,M,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(d,g,I){this._args=d,this.paths=g,this.productService=I}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",K).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,r.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,r.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,r.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,r.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,r.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=E.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.join)(d,"argv.json")):(0,r.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,r.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.resolve)(d):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,M.resolve)(d):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.resolve)(d);const g=E.env.VSCODE_EXTENSIONS;if(g)return g;const I=E.env.VSCODE_PORTABLE;return I?(0,M.join)(I,"extensions"):(0,r.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,M.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,M.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!E.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,r.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([L.memoize],w.prototype,"appRoot",null),ue([L.memoize],w.prototype,"userHome",null),ue([L.memoize],w.prototype,"userDataPath",null),ue([L.memoize],w.prototype,"appSettingsHome",null),ue([L.memoize],w.prototype,"tmpDir",null),ue([L.memoize],w.prototype,"userRoamingDataHome",null),ue([L.memoize],w.prototype,"settingsResource",null),ue([L.memoize],w.prototype,"userDataSyncHome",null),ue([L.memoize],w.prototype,"userDataSyncLogResource",null),ue([L.memoize],w.prototype,"sync",null),ue([L.memoize],w.prototype,"machineSettingsResource",null),ue([L.memoize],w.prototype,"globalStorageHome",null),ue([L.memoize],w.prototype,"workspaceStorageHome",null),ue([L.memoize],w.prototype,"keybindingsResource",null),ue([L.memoize],w.prototype,"keyboardLayoutResource",null),ue([L.memoize],w.prototype,"argvResource",null),ue([L.memoize],w.prototype,"snippetsHome",null),ue([L.memoize],w.prototype,"isExtensionDevelopment",null),ue([L.memoize],w.prototype,"untitledWorkspacesHome",null),ue([L.memoize],w.prototype,"installSourcePath",null),ue([L.memoize],w.prototype,"builtinExtensionsPath",null),ue([L.memoize],w.prototype,"extensionsPath",null),ue([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ue([L.memoize],w.prototype,"extensionDevelopmentKind",null),ue([L.memoize],w.prototype,"extensionTestsLocationURI",null),ue([L.memoize],w.prototype,"debugExtensionHost",null),ue([L.memoize],w.prototype,"serviceMachineIdResource",null),ue([L.memoize],w.prototype,"telemetryLogResource",null),ue([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function t(p,d){return b(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId)}e.parseExtensionHostPort=t;function P(p,d){return b(p["inspect-search"],p["inspect-brk-search"],5876,d)}e.parseSearchPort=P;function b(p,d,g,I,y){const h=Number(d||p)||(I?null:g),s=h?Boolean(!!d):!1;return{port:h,break:s,debugId:y}}}),define(J[87],Z([0,1,240,3,134]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function r(d,g,I=E){const y={},u=[],h=[];for(let a in g){const n=g[a];n.alias&&(y[a]=n.alias),n.type==="string"||n.type==="string[]"?(u.push(a),n.deprecates&&u.push(n.deprecates)):n.type==="boolean"&&(h.push(a),n.deprecates&&h.push(n.deprecates))}const s=v(d,{string:u,boolean:h,alias:y}),c={},i=s;c._=s._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(let a in g){const n=g[a];n.alias&&delete i[n.alias];let o=i[a];n.deprecates&&i.hasOwnProperty(n.deprecates)&&(o||(o=i[n.deprecates]),delete i[n.deprecates]),typeof o!="undefined"&&(n.type==="string[]"?o&&!Array.isArray(o)&&(o=[o]):n.type==="string"&&Array.isArray(o)&&(o=o.pop(),I.onMultipleValues(a,o)),c[a]=o),delete i[a]}for(let a in i)I.onUnknownOption(a);return c}e.parseArgs=r;function f(d,g){let I="";return g.args&&(Array.isArray(g.args)?I=` <${g.args.join("> <")}>`:I=` <${g.args}>`),g.alias?`-${g.alias} --${d}${I}`:`--${d}${I}`}function w(d,g){let I=0,y=[];for(const c in d){const i=d[c],a=f(c,i);I=Math.max(I,a.length),y.push([a,i.description])}let u=I+2+1;if(g-u<25)return y.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let h=g-u-1,s=[];for(const c of y){let i=c[0],a=P(c[1],h),n=t(u-i.length-2);s.push("  "+i+n+a[0]);for(let o=1;o<a.length;o++)s.push(t(u)+a[o])}return s}e.formatOptions=w;function t(d){return" ".repeat(d)}function P(d,g){let I=[];for(;d.length;){let y=d.length<g?d.length:d.lastIndexOf(" ",g),u=d.slice(0,y).trim();d=d.slice(y),I.push(u)}return I}function b(d,g,I,y,u=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let s=[`${d} ${I}`];s.push(""),s.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),s.push(""),u&&(L.isWindows?s.push((0,k.localize)(35,null,g)):s.push((0,k.localize)(36,null,g)),s.push(""));const c={};for(const i in y){const a=y[i];if(a.description&&a.cat){let n=c[a.cat];n||(c[a.cat]=n={}),n[i]=a}}for(let i in c){const a=i;let n=c[a];n&&(s.push(M[a]),s.push(...w(n,h)),s.push(""))}return s.join(`
`)}e.buildHelpMessage=b;function p(d,g){return`${d||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(J[157],Z([0,1,59,154,87]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(r){super();this.windowsMainService=r}call(r,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1],w[2]):super.call(r,f,w)}async openExtensionDevelopmentHostWindow(r,f,w){const t=(0,k.parseArgs)(r,k.OPTIONS);t.debugRenderer=w;const P=t.extensionDevelopmentPath;if(!P)return{success:!1};let b;const p=Object.keys(f);for(let h of p){let s=f[h];s===null||(b||(b=Object.create(null)),b[h]=s)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(P,{context:5,cli:t,userEnv:b});if(!w)return{success:!0};const g=d.win;if(!g)return{success:!0};const I=g.webContents.debugger;let y=I.isAttached()?Infinity:0;const u=(0,v.createServer)(h=>{y++==0&&I.attach();let s=!1;const c=n=>{s||h.write(JSON.stringify(n)+"\0")},i=(n,o,l,m)=>c({method:o,params:l,sessionId:m});g.on("close",()=>{I.removeListener("message",i),h.end(),s=!0}),I.addListener("message",i);let a=Buffer.alloc(0);h.on("data",n=>{a=Buffer.concat([a,n]);for(let o=a.indexOf(0);o!==-1;o=a.indexOf(0)){let l;try{const m=a.slice(0,o).toString("utf8");a=a.slice(o+1),l=JSON.parse(m)}catch(m){console.error("error reading cdp line",m)}I.sendCommand(l.method,l.params,l.sessionId).then(m=>c({id:l.id,sessionId:l.sessionId,result:m})).catch(m=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:m.message}}))}}),h.on("error",n=>{console.error("error on cdp pipe:",n)}),h.on("close",()=>{s=!0,--y==0&&I.detach()})});return await new Promise(h=>u.listen(0,h)),g.on("close",()=>u.close()),{rendererDebugPort:u.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function K(e,v,L,k){function M(r){const f=E(r),w=[f];return e.isAbsolute(f)||w.unshift(k),e.resolve(...w)}function E(r){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const t=r["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(P,"AppData","Roaming")}break;case"darwin":w=e.join(v.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:M}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,32]),function(e,v,L,k,M,E){const r=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(r,"package.json").fsPath);return K(v,L,f.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=K(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,156,158]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(r,f){super(r,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(r)},f)}}e.NativeEnvironmentService=M}),define(J[161],Z([0,1,30,26,8]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(E){const r=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(r,""),E&&console.log(`Marker file for --wait created: ${r}`),r}catch(f){E&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(J[162],Z([0,1,137]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(b){return b=b.trim(),b==="*"||L.test(b)}e.isValidVersionStr=M;function E(b){if(!M(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=b.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=E;function r(b){if(!b)return null;let p=b.majorBase,d=b.majorMustEqual,g=b.minorBase,I=b.minorMustEqual,y=b.patchBase,u=b.patchMustEqual;b.hasCaret&&(p===0||(I=!1),u=!1);let h=0;if(b.preRelease){const s=k.exec(b.preRelease);if(s){const[,c,i,a]=s;h=Date.UTC(Number(c),Number(i)-1,Number(a))}}return{majorBase:p,majorMustEqual:d,minorBase:g,minorMustEqual:I,patchBase:y,patchMustEqual:u,isMinimum:b.hasGreaterEquals,notBefore:h}}e.normalizeVersion=r;function f(b,p,d){let g;typeof b=="string"?g=r(E(b)):g=b;let I;p instanceof Date?I=p.getTime():typeof p=="string"&&(I=new Date(p).getTime());let y;if(typeof d=="string"?y=r(E(d)):y=d,!g||!y)return!1;let u=g.majorBase,h=g.minorBase,s=g.patchBase,c=y.majorBase,i=y.minorBase,a=y.patchBase,n=y.notBefore,o=y.majorMustEqual,l=y.minorMustEqual,m=y.patchMustEqual;return y.isMinimum?u>c?!0:u<c?!1:h>i?!0:h<i||I&&I<n?!1:s>=a:(u===1&&c===0&&(!o||!l||!m)&&(c=1,i=0,a=0,o=!0,l=!1,m=!1),u<c?!1:u>c?!o:h<i?!1:h>i?!l:s<a?!1:s>a?!m:!(I&&I<n))}e.isValidVersion=f;function w(b,p,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:P(b,p,d.engines.vscode,g)}e.isValidExtensionVersion=w;function t(b,p,d){return b==="*"||P(p,d,b)}e.isEngineValid=t;function P(b,p,d,g=[]){let I=r(E(d));if(!I)return g.push(v.localize(0,null,d)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return g.push(v.localize(1,null,d)),!1}else if(!I.majorMustEqual)return g.push(v.localize(2,null,d)),!1;return f(b,p,I)?!0:(g.push(v.localize(3,null,b,d)),!1)}}),define(J[163],Z([0,1,2,10,35,86]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends v.Disposable{constructor(f,w,t,P){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[164],Z([0,1,2,10,35,86]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends v.Disposable{constructor(f,w,t,P,b={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=P,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],Z([0,1,41,111,10,80]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(f,w,t,P,b){this.watchedFolder=f,this.eventCallback=t,this.logCallback=P,this.verboseLogging=b,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(p=>(0,L.parse)(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,v.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,f);const w=new M.LineDecoder;this.handle.stdout.on("data",t=>{const P=[];for(const b of w.write(t)){const p=b.split("|");if(p.length===2){const d=Number(p[0]),g=p[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(I=>I(g))){this.verboseLogging&&this.log(g);continue}P.push({type:E.changeTypeMap[d],path:g})}else this.log(p[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,P)=>this.onExit(t,P))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,8,25,165]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(r,f,w,t){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=t,this.service=void 0,this.folder=r[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(v.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,v.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,r=>this.onFileEvents(r),r=>this.onLogMessage(r),this.verboseLogging)}setVerboseLogging(r){this.verboseLogging=r,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(r){this.isDisposed||r.length>0&&this.onDidFilesChange(r)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(J[69],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,M=[],E=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=v}),define(J[167],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=v;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let E of this._nodes.values())E.outgoing.size===0&&M.push(E);return M}insertEdge(M,E){const r=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(E);r.outgoing.set(this._hashFn(E),f),f.incoming.set(this._hashFn(M),r)}removeNode(M){const E=this._hashFn(M);this._nodes.delete(E);for(let r of this._nodes.values())r.outgoing.delete(E),r.incoming.delete(E)}lookupOrInsertNode(M){const E=this._hashFn(M);let r=this._nodes.get(E);return r||(r=new v(M),this._nodes.set(E,r)),r}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[E,r]of this._nodes)M.push(`${E}, (incoming)[${[...r.incoming.keys()].join(", ")}], (outgoing)[${[...r.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,E]of this._nodes){const r=new Set([M]),f=this._findCycle(E,r);if(f)return f}}_findCycle(M,E){for(let[r,f]of M.outgoing){if(E.has(r))return[...E,r].join(" -> ");E.add(r);const w=this._findCycle(f,E);if(w)return w;E.delete(r)}}}e.Graph=L}),define(J[5],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=f})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(r,f,w,t){f[v.DI_TARGET]===f?f[v.DI_DEPENDENCIES].push({id:r,index:w,optional:t}):(f[v.DI_DEPENDENCIES]=[{id:r,index:w,optional:t}],f[v.DI_TARGET]=f)}function k(r){if(v.serviceIds.has(r))return v.serviceIds.get(r);const f=function(w,t,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,P,!1)};return f.toString=()=>r,v.serviceIds.set(r,f),f}e.createDecorator=k;function M(r){return r}e.refineServiceDecorator=M;function E(r){return function(f,w,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(r,f,t,!0)}}e.optional=E}),define(J[70],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(J[88],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,E)=>K(["vscode-encrypt"],M,E))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(E){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(E){return M}}}e.EncryptionMainService=L}),define(J[47],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(J[168],Z([0,1,10,3,32,136,5]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var r;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(r=e.TargetPlatform||(e.TargetPlatform={}));function f(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=f;function w(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=w;function t(s,c){let i;switch(s){case 1:i=3;break;case 3:i=2;break;case 2:i=1;break}return P(i,c)}e.getTargetPlatformFromOS=t;function P(s,c){switch(s){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=P,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":P(L.platform,k.arch);function b(s,c){return c==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function p(s,c,i){if(b(c,i))return!1;if(s==="undefined"||s==="universal")return!0;if(s==="unknown")return!1;if(s===i)return!0;switch(i){case"win32-x64":return s==="win32-ia32";case"win32-arm64":return s==="win32-ia32";default:return!1}}e.isTargetPlatformCompatible=p;function d(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=d;var g;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=5]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(g=e.SortBy||(e.SortBy={}));var I;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var y;(function(s){s.Install="install",s.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var u;(function(s){s[s.None=0]="None",s[s.Install=1]="Install",s[s.Update=2]="Update"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,E.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class h extends Error{constructor(c,i){super(c);this.code=i,this.name=i}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,E.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,E.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,E.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,M.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,M.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,E.createDecorator)("IExtensionManagementCLIService")}),define(J[169],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(J[170],Z([0,1,25,5]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=k;function M(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class r{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,b){if(typeof P=="undefined"||P===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof P=="string"||typeof b=="string"){let p=typeof P=="string"?P:P.value,d=typeof b=="string"?b:b.value;return v.equalsIgnoreCase(p,d)}return P._lower===b._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=r;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function w(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,25,170]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,v.compareIgnoreCase)(d.id,g.id)===0}e.areSameExtensions=k;class M{constructor(g,I){this.version=I,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function E(d,g){return`${d}.${g}`}e.getExtensionId=E;function r(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function f(d,g){return r(E(d,g))}e.getGalleryExtensionId=f;function w(d,g){const I=[],y=u=>{for(const h of I)if(h.some(s=>k(g(s),g(u))))return h;return null};for(const u of d){const h=y(u);h?h.push(u):I.push([u])}return I}e.groupByExtension=w;function t(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function P(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function b(d){const g=new Set;for(const I of d)I.malicious&&g.add(I.id.id);return g}e.getMaliciousExtensionsSet=b;function p(d,g){const I=[],y=g.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const u=y.shift();if(u&&I.every(h=>!k(h.identifier,{id:u}))){const h=d.filter(s=>k(s.identifier,{id:u}));h.length===1&&(I.push(h[0]),y.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=p}),define(J[89],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(J[172],Z([0,1,41,10,8,3,105,19,68,138,89]),function(K,e,v,L,k,M,E,r,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=w.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends b{openTerminal(s,c){return this.spawnTerminal(v,s,f.getWindowsShell(),c)}spawnTerminal(s,c,i,a){const n=c.windowsExec||p.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const o=k.basename(n).toLowerCase();if(o==="cmder"||o==="cmder.exe")return s.spawn(n,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return n.indexOf(" ")>=0&&l.push('""'),l.push(n),(o==="wt"||o==="wt.exe")&&l.push("-d ."),new Promise((m,S)=>{const D=I(process),A=s.spawn(i,l,{cwd:a,env:D});A.on("error",S),A.on("exit",()=>m())})}runInTerminal(s,c,i,a,n){const o="windowsExec"in n&&n.windowsExec?n.windowsExec:p.getDefaultTerminalWindows();return new Promise((l,m)=>{const S=`"${c} - ${P}"`,D=`""${i.join('" "')}" & pause"`,A=["/c","start",S,"/wait",o,"/c",D],W=Object.assign({},I(process),a);Object.keys(W).filter(te=>W[te]===null).forEach(te=>delete W[te]);const C={cwd:c,env:W,windowsVerbatimArguments:!0};v.spawn(p.CMD,A,C).on("error",te=>{m(y(te))}),l(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class d extends b{openTerminal(s,c){return this.spawnTerminal(v,s,c)}runInTerminal(s,c,i,a,n){const o=n.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,m)=>{if(o===t.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const S=o===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`,K).fsPath,"-t",s||P,"-w",c];for(let X of i)A.push("-a"),A.push(X);if(a){const X=Object.assign({},I(process),a);for(let te in X){const oe=X[te];oe===null?(A.push("-u"),A.push(te)):(A.push("-e"),A.push(`${te}=${oe}`))}}let W="";const C=v.spawn(d.OSASCRIPT,A);C.on("error",X=>{m(y(X))}),C.stderr.on("data",X=>{W+=X.toString()}),C.on("exit",X=>{if(X===0)l(void 0);else if(W){const te=W.split(`
`,1);m(new Error(te[0]))}else m(new Error(w.localize(1,null,S,X)))})}else m(new Error(w.localize(2,null,o)))})}spawnTerminal(s,c,i){const a=c.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{const l=["-a",a];i&&l.push(i);const m=I(process),S=s.spawn("/usr/bin/open",l,{cwd:i,env:m});S.on("error",o),S.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends b{openTerminal(s,c){return this.spawnTerminal(v,s,c)}runInTerminal(s,c,i,a,n){const o=n.linuxExec?Promise.resolve(n.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{let S=[];o.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const A=`${u(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;S.push(`''${A}''`);const W=Object.assign({},I(process),a);Object.keys(W).filter(oe=>W[oe]===null).forEach(oe=>delete W[oe]);const C={cwd:c,env:W};let X="";const te=v.spawn(D,S,C);te.on("error",oe=>{m(y(oe))}),te.stderr.on("data",oe=>{X+=oe.toString()}),te.on("exit",oe=>{if(oe===0)l(void 0);else if(X){const Y=X.split(`
`,1);m(new Error(Y[0]))}else m(new Error(w.localize(4,null,D,oe)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async s=>{M.isLinux?await r.Promises.exists("/etc/debian_version")?s("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?s("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?s("konsole"):process.env.COLORTERM?s(process.env.COLORTERM):process.env.TERM?s(process.env.TERM):s("xterm"):s("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,c,i){const a=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{a.then(l=>{const m=I(process),S=s.spawn(l,[],{cwd:i,env:m});S.on("error",o),S.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=w.localize(3,null);function I(h){const s={...h.env};return(0,E.sanitizeProcessEnvironment)(s),s}function y(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function u(h){let s="";for(let c of h)c.indexOf(" ")>=0?s+='"'+c+'"':s+=c,s+=" ";return s}}),define(J[20],Z([0,1,37,8,25,13,7,140,5]),function(K,e,v,L,k,M,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(_){return _.create===!0}e.isFileOpenForWriteOptions=w;var t;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var P;(function(_){_[_.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var b;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=p;function d(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function I(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=I;var y;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(q,z){super(q);this.code=z}}e.FileSystemProviderError=u;function h(_,q){const z=new u(_.toString(),q);return c(z,q),z}e.createFileSystemProviderError=h;function s(_){return _||h((0,r.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=s;function c(_,q){return _.name=q?`${q} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=c;function i(_){if(!_)return y.Unknown;if(_ instanceof u)return _.code;const q=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!q)return y.Unknown;switch(q[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=i;function a(_){if(_ instanceof D)return _.fileOperationResult;switch(i(_)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var n;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor(q,z,$){this.resource=q,this.operation=z,this.target=$}isOperation(q){return this.operation===q}}e.FileOperationEvent=o;var l;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(q,z){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of q)switch($.type){case 1:this.added||(this.added=v.TernarySearchTree.forUris(()=>z)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=v.TernarySearchTree.forUris(()=>z)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=v.TernarySearchTree.forUris(()=>z)),this.deleted.set($.resource,$);break}}contains(q,...z){return this.doContains(q,{includeChildren:!1},...z)}affects(q,...z){return this.doContains(q,{includeChildren:!0},...z)}doContains(q,z,...$){if(!q)return!1;const H=$.length>0;return!!((!H||$.includes(1))&&(this.added?.get(q)||z.includeChildren&&this.added?.findSuperstr(q))||(!H||$.includes(0))&&(this.updated?.get(q)||z.includeChildren&&this.updated?.findSuperstr(q))||(!H||$.includes(2))&&(this.deleted?.findSubstr(q)||z.includeChildren&&this.deleted?.findSuperstr(q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function S(_,q,z){return!_||!q||_===q||q.length>_.length?!1:(q.charAt(q.length-1)!==L.sep&&(q+=L.sep),z?(0,k.startsWithIgnoreCase)(_,q):_.indexOf(q)===0)}e.isParent=S;class D extends Error{constructor(q,z,$){super(q);this.fileOperationResult=z,this.options=$}}e.FileOperationError=D;class A extends D{constructor(q,z,$){super(q,2,$);this.stat=z}}e.NotModifiedSinceFileOperationError=A;var W;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=X;async function te(_,q){if(!q.canHandleResource(E.URI.from({scheme:_.scheme})))return new Promise(z=>{const $=q.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===_.scheme&&H.added&&($.dispose(),z())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(q){return(0,M.isNumber)(q)||(q=0),q<oe.KB?(0,r.localize)(1,null,q.toFixed(0)):q<oe.MB?(0,r.localize)(2,null,(q/oe.KB).toFixed(2)):q<oe.GB?(0,r.localize)(3,null,(q/oe.MB).toFixed(2)):q<oe.TB?(0,r.localize)(4,null,(q/oe.GB).toFixed(2)):(0,r.localize)(5,null,(q/oe.TB).toFixed(2))}}e.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var Y;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function Q(_){return{maxFileSize:_===0?300*oe.MB:16*oe.GB,maxHeapSize:_===0?700*oe.MB:2*700*oe.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,241,135,87,20]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(b,p){const d={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,y)=>{console.warn((0,L.localize)(1,null,I,y))}},g=(0,k.parseArgs)(b,k.OPTIONS,p?d:void 0);return g.goto&&g._.forEach(I=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),g["max-memory"]&&v(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function r(b){const p=b.findIndex(d=>!/^-/.test(d));if(p>-1)return[...b.slice(0,p),...b.slice(p+1)]}function f(b){let[,...p]=b;process.env.VSCODE_DEV&&(p=r(p)||[]);const d=!P(process.env);return E(p,d)}e.parseMainProcessArgv=f;function w(b){const[,,...p]=b;return E(p,!0)}e.parseCLIProcessArgv=w;function t(b,...p){const d=b.indexOf("--");return d===-1?b.push(...p):b.splice(d,0,...p),b}e.addArg=t;function P(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(J[90],Z([0,1,41,159,24,67,17,3,28,130,54]),function(K,e,v,L,k,M,E,r,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function P(d,g,I){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):r.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(I)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(I)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async y=>{const u=new k.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),u.dispose(!0),y({})},1e4);try{const s=await p(d,u.token);y(s)}catch(s){(0,E.isPromiseCanceledError)(s)||d.error(`[resolve shell env] Unable to resolve shell environment (${s}). Proceeding without shell environment...`),y({})}finally{clearTimeout(h),u.dispose()}})),b)}e.resolveShellEnv=P;let b;async function p(d,g){const I=new Promise(async(y,u)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",s);const c=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",a);const n=await(0,w.getSystemShell)(r.OS,a);if(d.trace("getUnixShellEnvironment#shell",n),g.isCancellationRequested)return u(E.canceled);const o=L.basename(n);let l,m;/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,m=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,m=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),l);const S=(0,v.spawn)(n,[...m,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});g.onCancellationRequested(()=>(S.kill(),u(E.canceled))),S.on("error",W=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(W)),y({})});const D=[];S.stdout.on("data",W=>D.push(W));const A=[];S.stderr.on("data",W=>A.push(W)),S.on("close",(W,C)=>{const X=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",X);const te=Buffer.concat(A).toString("utf8");if(te.trim()&&d.trace("getUnixShellEnvironment#stderr",te),W||C)return u(new Error(`Failed to get environment (code ${W}, signal ${C})`));const oe=i.exec(X),Y=oe?oe[1]:"{}";try{const Q=JSON.parse(Y);h?Q.ELECTRON_RUN_AS_NODE=h:delete Q.ELECTRON_RUN_AS_NODE,s?Q.ELECTRON_NO_ATTACH_CONSOLE=s:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Q),y(Q)}catch(Q){d.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(Q)),u(Q)}})});try{return await I}catch(y){return d.error("getUnixShellEnvironment#error",(0,M.toErrorMessage)(y)),{}}}}),define(J[91],Z([0,1,3,7,20]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=M;function E(f){const w=new r;for(const t of f)w.processEvent(t);return w.normalize()}e.normalizeFileChanges=E;class r{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const t=this.mapPathToChange.get(w.path);if(t){const P=t.type,b=w.type;P===1&&b===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(t),1)):P===2&&b===1?t.type=0:P===1&&b===0||(t.type=b)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],t=[];return this.normalized.filter(P=>P.type!==2?(w.push(P),!1):!0).sort((P,b)=>P.path.length-b.path.length).filter(P=>t.some(b=>(0,k.isParent)(P.path,b,!v.isLinux))?!1:(t.push(P.path),!0)).concat(w)}}}),define(J[173],Z([0,1,9,2,8,81,19,117,91]),function(K,e,v,L,k,M,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(P,b,p,d){super();this.path=P,this.onDidFilesChange=b,this.onLogMessage=p,this.verboseLogging=d,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(r.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:b}=await E.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(b)try{p=await(0,M.realpath)(p)}catch(d){if(this.onError(d),b.dangling)return}P.isDirectory()?this._register((0,r.watchFolder)(p,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},d=>this.onError(d))):this._register((0,r.watchFile)(p,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,f.normalizeFileChanges)(b);if(this.verboseLogging)for(const d of p)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(J[71],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[M,E]of k)this.set(M,E)}set(k,M){const E=this._entries.get(k);return this._entries.set(k,M),E}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(J[174],Z([0,1,9,17,69,167,5,71]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class t{constructor(d=new r.ServiceCollection,g=!1,I){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=I,this._services.set(E.IInstantiationService,this)}createChild(d){return new t(d,this._strict,this)}invokeFunction(d,...g){let I=b.traceInvocation(d),y=!1;try{return d({get:(h,s)=>{if(y)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(h,I);if(!c&&s!==E.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return c}},...g)}finally{y=!0,I.stop()}}createInstance(d,...g){let I,y;return d instanceof k.SyncDescriptor?(I=b.traceCreation(d.ctor),y=this._createInstance(d.ctor,d.staticArguments.concat(g),I)):(I=b.traceCreation(d),y=this._createInstance(d,g,I)),I.stop(),y}_createInstance(d,g=[],I){let y=E._util.getServiceDependencies(d).sort((s,c)=>s.index-c.index),u=[];for(const s of y){let c=this._getOrCreateServiceInstance(s.id,I);if(!c&&this._strict&&!s.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${s.id}.`);u.push(c)}let h=y.length>0?y[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${g.length} static arguments`);let s=h-g.length;s>0?g=g.concat(new Array(s)):g=g.slice(0,h)}return new d(...[...g,...u])}_setServiceInstance(d,g){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let I=this._getServiceInstanceOrDescriptor(d);return I instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,I,g.branch(d,!0)):(g.branch(d,!1),I)}_safeCreateAndCacheServiceInstance(d,g,I){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,I)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,I){const y=new M.Graph(s=>s.id.toString());let u=0;const h=[{id:d,desc:g,_trace:I}];for(;h.length;){const s=h.pop();if(y.lookupOrInsertNode(s),u++>1e3)throw new w(y);for(let c of E._util.getServiceDependencies(s.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(c.id);if(!i&&!c.optional&&console.warn(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`),i instanceof k.SyncDescriptor){const a={id:c.id,desc:i,_trace:s._trace.branch(c.id,!0)};y.insertEdge(s,a),h.push(a)}}}for(;;){const s=y.roots();if(s.length===0){if(!y.isEmpty())throw new w(y);break}for(const{data:c}of s){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,a)}y.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,I=[],y,u){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(g,I,y,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,I,y,u);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],I,y){if(I){const u=new v.IdleValue(()=>this._createInstance(d,g,y));return new Proxy(Object.create(null),{get(h,s){if(s in h)return h[s];let c=u.value,i=c[s];return typeof i!="function"||(i=i.bind(c),h[s]=i),i},set(h,s,c){return u.value[s]=c,!0}})}else return this._createInstance(d,g,y)}}e.InstantiationService=t;var P;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(P||(P={}));class b{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new b(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(d){return f?new b(0,d.name):b._None}branch(d,g){let I=new b(2,d.toString());return this._dep.push([d,g,I]),I}stop(){let d=Date.now()-this._start;b._totals+=d;let g=!1;function I(u,h){let s=[],c=new Array(u+1).join("	");for(const[i,a,n]of h._dep)if(a&&n){g=!0,s.push(`${c}CREATES -> ${i}`);let o=I(u+1,n);o&&s.push(o)}else s.push(`${c}uses -> ${i}`);return s.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(y.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(J[175],Z([0,1,17,128,57]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(r,f){super();if(f.length===0)throw(0,v.illegalArgument)("parts");this._os=r,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,r=>this._getLabel(r))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,r=>this._getAriaLabel(r))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,r=>this._getElectronAccelerator(r))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,r=>this._getUserSettingsLabel(r))}isWYSIWYG(){return this._parts.every(r=>this._isWYSIWYG(r))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(r=>this._getPart(r))}_getPart(r){return new k.ResolvedKeybindingPart(r.ctrlKey,r.shiftKey,r.altKey,r.metaKey,this._getLabel(r),this._getAriaLabel(r))}getDispatchParts(){return this._parts.map(r=>this._getDispatchPart(r))}getSingleModifierDispatchParts(){return this._parts.map(r=>this._getSingleModifierDispatchPart(r))}}e.BaseResolvedKeybinding=M}),define(J[176],Z([0,1,57,175]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(E,r){super(r,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const r=v.KeyCodeUtils.toUserSettingsUS(E.keyCode);return r&&r.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return k.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let r="";return E.ctrlKey&&(r+="ctrl+"),E.shiftKey&&(r+="shift+"),E.altKey&&(r+="alt+"),E.metaKey&&(r+="meta+"),r+=v.KeyCodeUtils.toString(E.keyCode),r}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(J[177],Z([0,1,9]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,M){if(k.length===0)return Promise.resolve(!1);const E=[];let r=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,v.isThenable)(f)&&E.push(f.then(w=>{w&&(r=!0)},w=>{M(w),r=!0}))}return v.Promises.settled(E).then(()=>r)}e.handleVetos=L}),define(J[6],Z([0,1,67,4,2,3,5]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function r(){return new Date().toISOString()}var f;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class t extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...a]))}debug(i,...a){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...a]))}info(i,...a){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...a]))}warn(i,...a){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...a]))}error(i,...a){if(this.checkLogLevel(f.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([i,...a]))}critical(i,...a){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...a]))}flush(){}format(i){let a="";for(let n=0;n<i.length;n++){let o=i[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(l){}a+=(n>0?" ":"")+o}return a}}e.AbstractMessageLogger=t;class P extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!M.isWindows}trace(i,...a){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${r()}][0m`,i,...a):console.log(`[main ${r()}]`,i,...a))}debug(i,...a){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${r()}][0m`,i,...a):console.log(`[main ${r()}]`,i,...a))}info(i,...a){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${r()}][0m`,i,...a):console.log(`[main ${r()}]`,i,...a))}warn(i,...a){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${r()}][0m`,i,...a):console.warn(`[main ${r()}]`,i,...a))}error(i,...a){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${r()}][0m`,i,...a):console.error(`[main ${r()}]`,i,...a))}critical(i,...a){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${r()}][0m`,i,...a):console.error(`[main ${r()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class b extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=b;class p extends w{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class d extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const n of this.logServices)n.trace(i,...a)}debug(i,...a){for(const n of this.logServices)n.debug(i,...a)}info(i,...a){for(const n of this.logServices)n.info(i,...a)}warn(i,...a){for(const n of this.logServices)n.warn(i,...a)}error(i,...a){for(const n of this.logServices)n.error(i,...a)}critical(i,...a){for(const n of this.logServices)n.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=g;class I extends k.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let n=this.loggers.get(i.toString());return n||(n=this.doCreateLogger(i,a?.always?f.Trace:this.logLevel,a),this.loggers.set(i.toString(),n),a?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class y{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=y;function u(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const i=h(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function h(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function s(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=s});var ee=this&&this.__param||function(K,e){return function(v,L){e(v,L,K)}};define(J[178],Z([0,1,9,18,40,77,47,20,5,6]),function(K,e,v,L,k,M,E,r,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(b){b.ERROR_INVALID_FILE="ERROR_INVALID_FILE",b.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let P=class{constructor(p,d,g){this.environmentService=p,this.fileService=d,this.logService=g,this.queue=new v.Queue}async updateSettings(p,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,p,d))}async doWrite(p,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,p.toString(),d);const{value:I,mtime:y,etag:u}=await this.fileService.readFile(p,{atomic:!0});let h=I.toString();const s=[];if((0,k.parse)(h,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(d,h,g)[0];if(c){h=h.substring(0,c.offset)+c.content+h.substring(c.offset+c.length);try{await this.fileService.writeFile(p,L.VSBuffer.fromString(h),{etag:u,mtime:y})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:p,path:d},g,I){return d.length?(0,M.setProperty)(g,d,p,I):[{content:JSON.stringify(p,null,I.insertSpaces&&I.tabSize?" ".repeat(I.tabSize):"	"),length:g.length,offset:0}]}};P=ue([ee(0,E.IEnvironmentService),ee(1,r.IFileService),ee(2,w.ILogService)],P),e.UserConfigurationFileService=P}),define(J[92],Z([0,1,6]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,E){switch(E){case v.LogLevel.Trace:return M.trace;case v.LogLevel.Debug:return M.debug;case v.LogLevel.Info:return M.info;case v.LogLevel.Warning:return M.warn;case v.LogLevel.Error:return M.error;case v.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(E=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(r=>{this._logger&&this._logger.setLevel(r)}))}set logger(E){this._logger=E;for(const{level:r,args:f}of this.buffer)L(E,r).apply(E,f);this.buffer=[]}_log(E,...r){this._logger?L(this._logger,E).apply(this._logger,r):this.getLevel()<=E&&this.buffer.push({level:E,args:r})}trace(E,...r){this._log(v.LogLevel.Trace,E,...r)}debug(E,...r){this._log(v.LogLevel.Debug,E,...r)}info(E,...r){this._log(v.LogLevel.Info,E,...r)}warn(E,...r){this._log(v.LogLevel.Warning,E,...r)}error(E,...r){this._log(v.LogLevel.Error,E,...r)}critical(E,...r){this._log(v.LogLevel.Critical,E,...r)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(J[179],Z([0,1,9,18,15,20,5,92,6]),function(K,e,v,L,k,M,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*M.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(p,d,g,I,y){super();this.name=p,this.resource=d,this.donotUseFormatters=I,this.fileService=y,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=p.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(p,d){this._log(p,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=d:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const p=I=>I<10?`0${I}`:I,d=I=>I<10?`00${I}`:I<100?`0${I}`:I,g=new Date;return`${g.getFullYear()}-${p(g.getMonth()+1)}-${p(g.getDate())} ${p(g.getHours())}:${p(g.getMinutes())}:${p(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(p){let d="";for(let g=0;g<p.length;g++){let I=p[g];if(typeof I=="object")try{I=JSON.stringify(I)}catch(y){}d+=(g>0?" ":"")+I}return d}};t=ue([ee(4,M.IFileService)],t),e.FileLogger=t;let P=class extends f.AbstractLoggerService{constructor(p,d,g){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(p,d,g){const I=new r.BufferLogService(d);return(0,M.whenProviderRegistered)(p,this.fileService).then(()=>I.logger=this.instantiationService.createInstance(t,(0,k.basename)(p),p,I.getLevel(),!!g?.donotUseFormatters)),I}};P=ue([ee(0,f.ILogService),ee(1,E.IInstantiationService),ee(2,M.IFileService)],P),e.FileLoggerService=P}),define(J[180],Z([0,1,4,7,6]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(b){this.service=b,this.onDidChangeLogLevel=v.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(b,p,d){switch(p){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=M;class E{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){E.setLevel(this.channel,b)}static setLevel(b,p){return b.call("setLevel",p)}}e.LogLevelChannelClient=E;class r{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,p){throw new Error(`Event not found: ${p}`)}async call(b,p,d){switch(p){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${p}`)}createLogger(b,p){this.loggers.set(b.toString(),this.loggerService.createLogger(b,p))}consoleLog(b,p){let d=console.log;switch(b){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...p)}log(b,p){const d=this.loggers.get(b.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,I]of p)switch(g){case k.LogLevel.Trace:d.trace(I);break;case k.LogLevel.Debug:d.debug(I);break;case k.LogLevel.Info:d.info(I);break;case k.LogLevel.Warning:d.warn(I);break;case k.LogLevel.Error:d.error(I);break;case k.LogLevel.Critical:d.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=r;class f extends k.AbstractLoggerService{constructor(b,p,d){super(b,p);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(b,p)=>{this.channel.call("consoleLog",[b,p])}})}doCreateLogger(b,p,d){return new w(this.channel,b,p,d)}}e.LoggerChannelClient=f;class w extends k.AbstractMessageLogger{constructor(b,p,d,g){super(g?.always);this.channel=b,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[p,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,p){const d=[[b,p]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(b){this.channel.call("log",[this.file,b])}}class t extends k.LogService{constructor(b,p){super(p);this.parent=b,this._register(b.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=t}),define(J[93],Z([0,1,20,6]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,w,t,P){try{const b=await new Promise((p,d)=>{K(["spdlog"],p,d)});return b.setFlushOn(L.LogLevel.Trace),b.createAsyncRotatingLogger(f,w,t,P)}catch(b){console.error(b)}return null}function M(f,w,t,P){const b=K.__$__nodeRequire("spdlog");return b.setFlushOn(L.LogLevel.Trace),b.createRotatingLogger(f,w,t,P)}e.createRotatingLogger=M;function E(f,w,t){switch(w){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class r extends L.AbstractMessageLogger{constructor(w,t,P,b){super();this.name=w,this.filepath=t,this.rotating=P,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const w=this.rotating?6:1,t=30/w*v.ByteSize.MB;return k(this.name,this.filepath,t,w).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:b,message:p}of this.buffer)E(this._logger,b,p);this.buffer=[]}})}log(w,t){this._logger?E(this._logger,w,t):this.getLevel()<=w&&this.buffer.push({level:w,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=r}),define(J[181],Z([0,1,10,15,28,20,179,6,93]),function(K,e,v,L,k,M,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends r.AbstractLoggerService{constructor(P,b){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=b}doCreateLogger(P,b,p){if(P.scheme===v.Schemas.file){const d=new f.SpdLogLogger(p?.name||(0,k.generateUuid)(),P.fsPath,!p?.donotRotate,b);return p?.donotUseFormatters&&d.clearFormatters(),d}else return new E.FileLogger(p?.name??(0,L.basename)(P),P,b,!!p?.donotUseFormatters,this.fileService)}};w=ue([ee(0,r.ILogService),ee(1,M.IFileService)],w),e.LoggerService=w}),define(J[182],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(E){return!v(E)&&!L(E)&&!k(E)}e.isMenubarMenuItemAction=M}),define(J[48],Z([0,1,10,3,32,15]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const r=L.globals.vscode.context.configuration();if(r)E=r.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const r=(0,M.dirname)(v.FileAccess.asFileUri("",K));E=K.__$__nodeRequire((0,M.joinPath)(r,"product.json").fsPath);const f=K.__$__nodeRequire((0,M.joinPath)(r,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:f.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(J[94],Z([0,1,18,17,141,20,48]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function r(P,b,p,d,g,I){let y;try{await f(P,b,p,d,g,I)}catch(u){y=u}finally{y&&g.errorTransformer&&(y=g.errorTransformer(y)),typeof y!="undefined"&&p.error(y),p.end()}}e.readFileIntoStream=r;async function f(P,b,p,d,g,I){w(I);const y=await P.open(b,{create:!1});try{w(I);let u=0,h=0,s=g&&typeof g.length=="number"?g.length:void 0,c=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof s=="number"?s:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,a=0;do h=await P.read(y,i,c.buffer,a,c.byteLength-a),i+=h,a+=h,u+=h,typeof s=="number"&&(s-=h),a===c.byteLength&&(await p.write(d(c)),c=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof s=="number"?s:g.bufferSize)),a=0);while(h>0&&(typeof s!="number"||s>0)&&w(I)&&t(u,g));if(a>0){let n=a;typeof s=="number"&&(n=Math.min(a,s)),p.write(d(c.slice(0,n)))}}catch(u){throw(0,M.ensureFileSystemProviderError)(u)}finally{await P.close(y)}}function w(P){if(P.isCancellationRequested)throw(0,L.canceled)();return!0}function t(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,E.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[183],Z([0,1,31,9,18,24,4,63,2,37,10,72,15,64,139,20,94,6]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class Ve extends f.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!0)))),this.watchedResources=w.TernarySearchTree.forUris(c=>{const i=this.getProvider(c.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(s,c){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:c});const i=new f.DisposableStore;return i.add(c.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(c)))),i.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:s}))),typeof c.onDidErrorOccur=="function"&&i.add(c.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:c}),this.provider.delete(s),(0,f.dispose)(i)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(i){c.push(i)}}),!this.provider.has(s)&&await L.Promises.settled(c)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,c){const i=this.provider.get(s.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return r.Iterable.map(this.provider,([s,c])=>({scheme:s,capabilities:c.capabilities}))}async withProvider(s){if(!(0,b.isAbsolutePath)(s))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const c=this.provider.get(s.scheme);if(!c){const i=new Error;throw i.name="ENOPRO",i.message=(0,d.localize)(1,null,s.toString()),i}return c}async withReadProvider(s){const c=await this.withProvider(s);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c)||(0,g.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const c=await this.withProvider(s);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,c){try{return await this.doResolveFile(s,c)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(s)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(s,c){const i=await this.withProvider(s),a=this.isPathCaseSensitive(i),n=c?.resolveTo,o=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,m=await i.stat(s);let S;return this.toFileStat(i,s,m,void 0,!!l,(D,A)=>{if(!S&&(S=w.TernarySearchTree.forUris(()=>!a),S.set(s,!0),n))for(const W of n)S.set(W,!0);return S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&o?A===1:!1})}async toFileStat(s,c,i,a,n,o){const{providerExtUri:l}=this.getExtUri(s),m={resource:c,name:l.basename(c),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(m.isDirectory&&o(m,a)){try{const S=await s.readdir(c),D=await L.Promises.settled(S.map(async([A,W])=>{try{const C=l.joinPath(c,A),X=n?await s.stat(C):{type:W};return await this.toFileStat(s,C,X,S.length,n,o)}catch(C){return this.logService.trace(C),null}}));m.children=(0,v.coalesce)(D)}catch(S){this.logService.trace(S),m.children=[]}return m}return m}async resolveAll(s){return L.Promises.settled(s.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(s){const c=await this.withProvider(s);try{return!!await c.stat(s)}catch(i){return!1}}async canCreateFile(s,c){try{await this.doValidateCreateFile(s,c)}catch(i){return i}return!0}async doValidateCreateFile(s,c){if(!c?.overwrite&&await this.exists(s))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(s)),3,c)}async createFile(s,c=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(s,i);const a=await this.writeFile(s,c);return this._onDidRunOperation.fire(new g.FileOperationEvent(s,0,a)),a}async writeFile(s,c,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,s,i)||await this.mkdirp(a,n.dirname(s));let l;if((0,g.hasReadWriteCapability)(a)&&!(c instanceof k.VSBuffer))if((0,p.isReadableStream)(c)){const m=await(0,p.peekStream)(c,3);m.ended?l=k.VSBuffer.concat(m.buffer):l=m}else l=(0,p.peekReadable)(c,m=>k.VSBuffer.concat(m),3);else l=c;!(0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(a,s,i,l):await this.doWriteBuffered(a,s,i,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l)}catch(o){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),i)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,c,i){if(!!i?.unlock&&!(s.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(c)));let n;try{n=await s.stat(c)}catch(o){return}if((n.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(c)),0,i);if(this.throwIfFileIsReadonly(c,n),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&i.mtime<n.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:n.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,i);return n}async readFile(s,c){const i=await this.withReadProvider(s);return c?.atomic?this.doReadFileAtomic(i,s,c):this.doReadFile(i,s,c)}async doReadFileAtomic(s,c,i){return new Promise((a,n)=>{this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,c,i);a(o)}catch(o){n(o)}})})}async doReadFile(s,c,i){const a=await this.doReadFileStream(s,c,{...i,preferUnbuffered:!0});return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(s,c){const i=await this.withReadProvider(s);return this.doReadFileStream(i,s,c)}async doReadFileStream(s,c,i){const a=new M.CancellationTokenSource,n=this.validateReadFile(c,i).then(l=>l,l=>{throw a.cancel(),l});let o;try{return typeof i?.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await n,!((0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasFileReadStreamCapability)(s))||(0,g.hasReadWriteCapability)(s)&&i?.preferUnbuffered?o=this.readFileUnbuffered(s,c,i):(0,g.hasFileReadStreamCapability)(s)?o=this.readFileStreamed(s,c,a.token,i):o=this.readFileBuffered(s,c,a.token,i),{...await n,value:o}}catch(l){o&&await(0,p.consumeStream)(o);const m=(0,d.localize)(8,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,l.stat,i):new g.FileOperationError(m,(0,g.toFileOperationResult)(l),i)}}readFileStreamed(s,c,i,a=Object.create(null)){const n=s.readFileStream(c,a,i);return(0,p.transform)(n,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),a)},o=>k.VSBuffer.concat(o))}readFileBuffered(s,c,i,a=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,I.readFileIntoStream)(s,c,n,o=>o,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),a)},i),n}readFileUnbuffered(s,c,i){const a=(0,p.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(c);typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.validateReadFileLimits(c,n.byteLength,i),a.end(k.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(s,c){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(s)),0,c);if(typeof c?.etag=="string"&&c.etag!==g.ETAG_DISABLED&&c.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),i,c);return this.validateReadFileLimits(s,i.size,c),i}validateReadFileLimits(s,c,i){if(i?.limits){let a;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(a=9),typeof i.limits.size=="number"&&c>i.limits.size&&(a=7),typeof a=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(s)),a)}}async canMove(s,c,i){return this.doCanMoveCopy(s,c,"move",i)}async canCopy(s,c,i){return this.doCanMoveCopy(s,c,"copy",i)}async doCanMoveCopy(s,c,i,a){if(s.toString()!==c.toString())try{const n=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(n,s,o,c,i,a)}catch(n){return n}return!0}async move(s,c,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=await this.doMoveCopy(a,s,n,c,"move",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,o==="move"?2:3,l)),l}async copy(s,c,i){const a=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=await this.doMoveCopy(a,s,n,c,"copy",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,o==="copy"?3:2,l)),l}async doMoveCopy(s,c,i,a,n,o){if(c.toString()===a.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(s,c,i,a,n,o);if(l&&!m&&o&&await this.del(a,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(a)),n==="copy"){if(s===i&&(0,g.hasFileFolderCopyCapability)(s))await s.copy(c,a,{overwrite:o});else{const S=await this.resolve(c);S.isDirectory?await this.doCopyFolder(s,S,i,a):await this.doCopyFile(s,c,i,a)}return n}else return s===i?(await s.rename(c,a,{overwrite:o}),n):(await this.doMoveCopy(s,c,i,a,"copy",o),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(s,c,i,a){if((0,g.hasOpenReadWriteCloseCapability)(s)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(s,c,i,a);if((0,g.hasOpenReadWriteCloseCapability)(s)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(s,c,i,a);if((0,g.hasReadWriteCapability)(s)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(s,c,i,a);if((0,g.hasReadWriteCapability)(s)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(s,c,i,a)}async doCopyFolder(s,c,i,a){await i.mkdir(a),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async n=>{const o=this.getExtUri(i).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),i,o):this.doCopyFile(s,n.resource,i,o)}))}async doValidateMoveCopy(s,c,i,a,n,o){let l=!1;if(s===i){const{providerExtUri:S,isPathCaseSensitive:D}=this.getExtUri(s);if(D||(l=S.isEqual(c,a)),l&&n==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(c),this.resourceForError(a)));if(!l&&S.isEqualOrParent(a,c))throw new Error((0,d.localize)(15,null,this.resourceForError(c),this.resourceForError(a)))}const m=await this.exists(a);if(m&&!l){if(!o)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(c),this.resourceForError(a)),4);if(s===i){const{providerExtUri:S}=this.getExtUri(s);if(S.isEqualOrParent(c,a))throw new Error((0,d.localize)(17,null,this.resourceForError(c),this.resourceForError(a)))}}return{exists:m,isSameResourceWithDifferentPathCase:l}}getExtUri(s){const c=this.isPathCaseSensitive(s);return{providerExtUri:c?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(c,s);const i=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,0,i)),i}async mkdirp(s,c){const i=[],{providerExtUri:a}=this.getExtUri(s);for(;!a.isEqual(c,a.dirname(c));)try{if(((await s.stat(c)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(c)));break}catch(n){if((0,g.toFileSystemProviderErrorCode)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(a.basename(c)),c=a.dirname(c)}for(let n=i.length-1;n>=0;n--){c=a.joinPath(c,i[n]);try{await s.mkdir(c)}catch(o){if((0,g.toFileSystemProviderErrorCode)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,c){try{await this.doValidateDelete(s,c)}catch(i){return i}return!0}async doValidateDelete(s,c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(s)));let n;try{n=await i.stat(s)}catch(l){}if(n)this.throwIfFileIsReadonly(s,n);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(s)),1);if(!!!c?.recursive){const l=await this.resolve(s);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(s)))}return i}async del(s,c){const i=await this.doValidateDelete(s,c),a=!!c?.useTrash,n=!!c?.recursive;await i.delete(s,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new g.FileOperationEvent(s,1))}onDidChangeFile(s,c){this._onDidChangeFilesRaw.fire({changes:s});let i,a;{for(const n of s)this.watchedResources.has(n.resource)?(i||(i=[]),i.push(n)):(a||(a=[]),a.push(n));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!c))}if(a){const n=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,c={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let a=!1,n=()=>{a=!0};i.add((0,f.toDisposable)(()=>n())),this.doWatch(s,c).then(o=>{a?(0,f.dispose)(o):n=()=>(0,f.dispose)(o)},o=>this.logService.error(o))}return c.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),i.add((0,f.toDisposable)(()=>{const a=this.watchedResources.get(s);typeof a=="number"&&(a<=1?this.watchedResources.delete(s):this.watchedResources.set(s,a-1))}))),i}async doWatch(s,c){const i=await this.withProvider(s),a=this.toWatchKey(i,s,c),n=this.activeWatchers.get(a)||{count:0,disposable:i.watch(s,c)};return this.activeWatchers.has(a)||this.activeWatchers.set(a,n),n.count+=1,(0,f.toDisposable)(()=>{n.count--,n.count===0&&((0,f.dispose)(n.disposable),this.activeWatchers.delete(a))})}toWatchKey(s,c,i){const{providerExtUri:a}=this.getExtUri(s);return[a.getComparisonKey(c),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,f.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,c,i,a){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,p.isReadableStream)(a)||(0,p.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(s,n,a):await this.doWriteReadableBufferedQueued(s,n,a)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,c,i){let a=0,n;if((0,p.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(s,c,o,o.byteLength,a,0),a+=o.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise(async(o,l)=>{(0,p.listenStream)(n,{onData:async m=>{n.pause();try{await this.doWriteBuffer(s,c,m,m.byteLength,a,0)}catch(S){return l(S)}a+=m.byteLength,setTimeout(()=>n.resume())},onError:m=>l(m),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,c,i){let a=0,n;for(;(n=i.read())!==null;)await this.doWriteBuffer(s,c,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(s,c,i,a,n,o){let l=0;for(;l<a;)l+=await s.write(c,n+l,i.buffer,o+l,a-l)}async doWriteUnbuffered(s,c,i,a){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,c,i,a))}async doWriteUnbufferedQueued(s,c,i,a){let n;a instanceof k.VSBuffer?n=a:(0,p.isReadableStream)(a)?n=await(0,k.streamToBuffer)(a):(0,p.isReadableBufferedStream)(a)?n=await(0,k.bufferedStreamToBuffer)(a):n=(0,k.readableToBuffer)(a),await s.writeFile(c,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(s,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,c,i,a))}async doPipeBufferedQueued(s,c,i,a){let n,o;try{n=await s.open(c,{create:!1}),o=await i.open(a,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,S=0,D=0;do D=await s.read(n,m,l.buffer,S,l.byteLength-S),await this.doWriteBuffer(i,o,l,D,m,S),m+=D,S+=D,S===l.byteLength&&(S=0);while(D>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,c,i,a))}async doPipeUnbufferedQueued(s,c,i,a){return i.writeFile(a,await s.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,c,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,c,i,a))}async doPipeUnbufferedToBufferedQueued(s,c,i,a){const n=await i.open(a,{create:!0,unlock:!1});try{const o=await s.readFile(c);await this.doWriteBuffer(i,n,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await i.close(n)}}async doPipeBufferedToUnbuffered(s,c,i,a){const n=await(0,k.streamToBuffer)(this.readFileBuffered(s,c,M.CancellationToken.None));await this.doWriteUnbuffered(i,a,void 0,n)}throwIfFileSystemIsReadonly(s,c){if(s.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(c)),6);return s}throwIfFileIsReadonly(s,c){if((c.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===t.Schemas.file?s.fsPath:s.toString(!0)}};u.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},u=ue([ee(0,y.ILogService)],u),e.FileService=u}),define(J[184],Z([0,1,31,9,18,4,29,2,8,3,15,64,19,142,20,94,173,163,164,91,166,6]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class i extends r.Disposable{constructor(n,o){super();this.logService=n,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:o,symbolicLink:l}=await b.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(o,l),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(n){try{const o=await b.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(o.map(async m=>{try{let S;m.isSymbolicLink()?S=(await this.stat((0,t.joinPath)(n,m.name))).type:S=this.toType(m),l.push([m.name,S])}catch(S){this.logService.trace(S)}})),l}catch(o){throw this.toFileSystemProviderError(o)}}toType(n,o){let l;return o?.dangling?l=d.FileType.Unknown:n.isFile()?l=d.FileType.File:n.isDirectory()?l=d.FileType.Directory:l=d.FileType.Unknown,o&&(l|=d.FileType.SymbolicLink),l}async readFile(n){try{const o=this.toFilePath(n);return await b.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(n,o,l){const m=(0,P.newWriteableStream)(S=>k.VSBuffer.concat(S.map(D=>k.VSBuffer.wrap(D))).buffer);return(0,g.readFileIntoStream)(this,n,m,S=>S.buffer,{...o,bufferSize:this.BUFFER_SIZE},l),m}async writeFile(n,o,l){let m;try{const S=this.toFilePath(n);if(!l.create||!l.overwrite){if(await b.Promises.exists(S)){if(!l.overwrite)throw(0,d.createFileSystemProviderError)((0,p.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,d.createFileSystemProviderError)((0,p.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(m,0,o,0,o.byteLength)}catch(S){throw await this.toFileSystemProviderWriteError(n,S)}finally{typeof m=="number"&&await this.close(m)}}async open(n,o){try{const l=this.toFilePath(n);if((0,d.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:D}=await b.SymlinkSupport.stat(l);D.mode&128||await b.Promises.chmod(l,D.mode|128)}catch(D){this.logService.trace(D)}let m;if((0,d.isFileOpenForWriteOptions)(o)){if(w.isWindows)try{await b.Promises.truncate(l,0),m="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}m||(m="w")}else m="r";const S=await b.Promises.open(l,m);return this.mapHandleToPos.set(S,0),(0,d.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(S,n),S}catch(l){throw(0,d.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await b.Promises.fdatasync(n)}catch(o){this.canFlush=!1,this.logService.error(o)}return await b.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}}async read(n,o,l,m,S){const D=this.normalizePos(n,o);let A=null;try{const W=await b.Promises.read(n,l,m,S,D);return typeof W=="number"?A=W:A=W.bytesRead,A}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(n,D,A)}}normalizePos(n,o){return o===this.mapHandleToPos.get(n)?null:o}updatePos(n,o,l){const m=this.mapHandleToPos.get(n);typeof m=="number"&&(typeof o=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,m+l):this.mapHandleToPos.delete(n)))}async write(n,o,l,m,S){return(0,L.retry)(()=>this.doWrite(n,o,l,m,S),100,3)}async doWrite(n,o,l,m,S){const D=this.normalizePos(n,o);let A=null;try{const W=await b.Promises.write(n,l,m,S,D);return typeof W=="number"?A=W:A=W.bytesWritten,A}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),W)}finally{this.updatePos(n,D,A)}}async mkdir(n){try{await b.Promises.mkdir(this.toFilePath(n))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(n,o){try{const l=this.toFilePath(n);await this.doDelete(l,o)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,o){o.recursive?await b.Promises.rm(n,b.RimRafMode.MOVE):await b.Promises.unlink(n)}async rename(n,o,l){const m=this.toFilePath(n),S=this.toFilePath(o);if(m!==S)try{await this.validateTargetDeleted(n,o,"move",l.overwrite),await b.Promises.move(m,S)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(2,null,(0,f.basename)(m),(0,f.basename)((0,f.dirname)(S)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(n,o,l){const m=this.toFilePath(n),S=this.toFilePath(o);if(m!==S)try{await this.validateTargetDeleted(n,o,"copy",l.overwrite),await b.Promises.copy(m,S,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,p.localize)(3,null,(0,f.basename)(m),(0,f.basename)((0,f.dirname)(S)),D.toString()))),this.toFileSystemProviderError(D)}}async validateTargetDeleted(n,o,l,m){const S=this.toFilePath(n),D=this.toFilePath(o);let A=!1;if(!!(this.capabilities&1024)||(A=(0,E.isEqual)(S,D,!0)),A&&l==="copy")throw(0,d.createFileSystemProviderError)((0,p.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!A&&await b.Promises.exists(D)){if(!m)throw(0,d.createFileSystemProviderError)((0,p.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(n,o){return o.recursive?this.watchRecursive(n,o.excludes):this.watchNonRecursive(n)}watchRecursive(n,o){const l={path:this.toFilePath(n),excludes:o},m=(0,v.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,r.toDisposable)(()=>{m(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,r.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,o;this.options?.watcher?.usePolling?(n=u.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?w.isWindows?n=s.FileWatcher:n=u.FileWatcher:n=y.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,h.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===c.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(n){const o=new I.FileWatcher(this.toFilePath(n),m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===c.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,r.combinedDisposable)(o,l)}toFilePath(n){return(0,f.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof d.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=d.FileSystemProviderErrorCode.NoPermissions;break;default:o=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(n,o){let l=this.toFileSystemProviderError(o);if(n&&l.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:m}=await b.SymlinkSupport.stat(this.toFilePath(n));m.mode&128||(l=(0,d.createFileSystemProviderError)(o,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(m){this.logService.trace(m)}return l}dispose(){super.dispose(),(0,r.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,r.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=i}),define(J[21],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(J[185],Z([0,1,58,6,21]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(r,f){this.productService=r,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(r,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,P]=w;let b=this.trustedExtensionUrlPublicKeys.get(r);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[r],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",r),!1;this.trustedExtensionUrlPublicKeys.set(r,[...b])}const p=Buffer.from(decodeURIComponent(P),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=p.slice(0,6),g=p.readUIntBE(0,6),I=Date.now()-g;if(I<0||I>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const y=p.slice(6),u=v.createVerify("SHA256");u.write(d),u.write(Buffer.from(t)),u.end();for(let h=0;h<b.length;h++){let s=b[h];if(s!==null){if(typeof s=="string")try{s=v.createPublicKey({key:Buffer.from(s,"base64"),format:"der",type:"spki"}),b[h]=s}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${r}:`,c),b[h]=null;continue}if(u.verify(s,y))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=ue([ee(0,k.IProductService),ee(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(J[55],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(J[186],Z([0,1,14,2,37,10,3,15,7,28,47,6]),function(K,e,v,L,k,M,E,r,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends L.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!E.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=v.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,I)=>this.handleResourceRequest(g,I)),d.protocol.interceptFileProtocol(M.Schemas.file,(g,I)=>this.handleFileRequest(g,I)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const I=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${I.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}handleResourceRequest(d,g){const I=f.URI.parse(d.url),y=M.FileAccess.asFileUri(I);return this.validRoots.findSubstr(y)?g({path:y.fsPath}):this.validExtensions.has((0,r.extname)(y))?g({path:y.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${y.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),I=g.toString(),y=async()=>d;return v.ipcMain.handle(I,y),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:g,update:u=>d=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),v.ipcMain.removeHandler(I)}}}};b=ue([ee(0,t.INativeEnvironmentService),ee(1,P.ILogService)],b),e.ProtocolMainService=b}),define(J[38],Z([0,1,102,13]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(E,r){v.ok(L.isString(E)),v.ok(L.isObject(r)),v.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,r)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new k}),define(J[187],Z([0,1,4,38]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(r){return r.length>0&&r.charAt(r.length-1)==="#"?r.substring(0,r.length-1):r}class M{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[k(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new M;L.Registry.add(e.Extensions.JSONContribution,E)}),define(J[49],Z([0,1,4,13,132,187,38]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var r;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(r=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=E.Registry.as(M.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new v.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new v.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,h=!0){this.registerConfigurations([u],h)}registerConfigurations(u,h=!0){const s=[];u.forEach(c=>{s.push(...this.validateAndRegisterProperties(c,h,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(u){const h=[],s=c=>{if(c.properties)for(const i in c.properties)h.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,c.properties[i]);c.allOf&&c.allOf.forEach(i=>s(i))};for(const c of u){s(c);const i=this.configurationContributors.indexOf(c);i!==-1&&this.configurationContributors.splice(i,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(u){const h=[],s=[];for(const c of u)for(const i in c)if(h.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...c[i]};const a={type:"object",default:this.defaultValues[i],description:k.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};s.push(b(i)),this.configurationProperties[i]=a,this.defaultLanguageConfigurationOverridesNode.properties[i]=a}else{this.defaultValues[i]=c[i];const a=this.configurationProperties[i];a&&(this.updatePropertyDefaultValue(i,a),this.updateSchema(i,a))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(u){const h=[];for(const s of u)for(const c in s)if(h.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const i=this.configurationProperties[c];i&&(this.updatePropertyDefaultValue(c,i),this.updateSchema(c,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const h of u)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(u,h=!0,s,c=3){c=L.isUndefinedOrNull(u.scope)?c:u.scope;let i=[],a=u.properties;if(a)for(let o in a){if(h&&g(o)){delete a[o];continue}const l=a[o];if(this.updatePropertyDefaultValue(o,l),e.OVERRIDE_PROPERTY_PATTERN.test(o)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?c:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!s?.restrictedConfigurations?.includes(o):l.restricted),a[o].hasOwnProperty("included")&&!a[o].included){this.excludedConfigurationProperties[o]=a[o],delete a[o];continue}else this.configurationProperties[o]=a[o];!a[o].deprecationMessage&&a[o].markdownDeprecationMessage&&(a[o].deprecationMessage=a[o].markdownDeprecationMessage),i.push(o)}let n=u.allOf;if(n)for(let o of n)i.push(...this.validateAndRegisterProperties(o,h,s,c));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const h=s=>{let c=s.properties;if(c)for(const a in c)this.updateSchema(a,c[a]);let i=s.allOf;i&&i.forEach(h)};h(u)}updateSchema(u,h){switch(e.allSettings.properties[u]=h,h.scope){case 1:e.applicationSettings.properties[u]=h;break;case 2:e.machineSettings.properties[u]=h;break;case 6:e.machineOverridableSettings.properties[u]=h;break;case 3:e.windowSettings.properties[u]=h;break;case 4:e.resourceSettings.properties[u]=h;break;case 5:e.resourceSettings.properties[u]=h,this.resourceLanguageSettingsSchema.properties[u]=h;break}}removeFromSchema(u,h){switch(delete e.allSettings.properties[u],h.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const h=`[${u}]`,s={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,s),e.allSettings.properties[h]=s,e.applicationSettings.properties[h]=s,e.machineSettings.properties[h]=s,e.machineOverridableSettings.properties[h]=s,e.windowSettings.properties[h]=s,e.resourceSettings.properties[h]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,h){let s=this.defaultValues[u];L.isUndefined(s)&&(s=h.default),L.isUndefined(s)&&(s=p(h.type)),h.default=s}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function b(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=b;function p(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const d=new t;E.Registry.add(e.Extensions.Configuration,d);function g(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?k.localize(5,null,y):d.getConfigurationProperties()[y]!==void 0?k.localize(6,null,y):null:k.localize(4,null)}e.validateProperty=g;function I(){const y=[],u=d.getConfigurationProperties();for(const h of Object.keys(u))y.push([h,u[h].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=I}),define(J[16],Z([0,1,44,13,7,49,5,38]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function f(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof k.URI)}e.isConfigurationOverrides=f;var w;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function P(a,n){const o=n?a?n.keys.filter(C=>a.keys.indexOf(C)===-1):[...n.keys]:[],l=a?n?a.keys.filter(C=>n.keys.indexOf(C)===-1):[...a.keys]:[],m=[];if(n&&a){for(const C of a.keys)if(n.keys.indexOf(C)!==-1){const X=y(a.contents,C),te=y(n.contents,C);v.equals(X,te)||m.push(C)}}const S=[],D=C=>{const X={};for(const te of C)for(const oe of te.identifiers)X[c(oe)]=te;return X},A=n?D(n.overrides):{},W=a?D(a.overrides):{};if(Object.keys(A).length)for(const C of o){const X=A[C];X&&S.push([(0,M.overrideIdentifierFromKey)(C),X.keys])}if(Object.keys(W).length)for(const C of l){const X=W[C];X&&S.push([(0,M.overrideIdentifierFromKey)(C),X.keys])}if(Object.keys(A).length&&Object.keys(W).length)for(const C of m){const X=W[C],te=A[C];if(X&&te){const oe=P({contents:X.contents,keys:X.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});S.push([(0,M.overrideIdentifierFromKey)(C),[...oe.added,...oe.removed,...oe.updated]])}}return{added:o,removed:l,updated:m,overrides:S}}e.compare=P;function b(a,n){const o=[];for(const l of Object.keys(a))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const m={};for(const S in a[l])m[S]=a[l][S];o.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(m),contents:p(m,n)})}return o}e.toOverrides=b;function p(a,n){const o=Object.create(null);for(let l in a)d(o,l,a[l],n);return o}e.toValuesTree=p;function d(a,n,o,l){const m=n.split("."),S=m.pop();let D=a;for(let A=0;A<m.length;A++){let W=m[A],C=D[W];switch(typeof C){case"undefined":C=D[W]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${m.slice(0,A+1).join(".")} is ${JSON.stringify(C)}`);return}D=C}if(typeof D=="object"&&D!==null)try{D[S]=o}catch(A){l(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(D)}`)}else l(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function g(a,n){const o=n.split(".");I(a,o)}e.removeFromValueTree=g;function I(a,n){const o=n.shift();if(n.length===0){delete a[o];return}if(Object.keys(a).indexOf(o)!==-1){const l=a[o];typeof l=="object"&&!Array.isArray(l)&&(I(l,n),Object.keys(l).length===0&&delete a[o])}}function y(a,n,o){function l(D,A){let W=D;for(const C of A){if(typeof W!="object"||W===null)return;W=W[C]}return W}const m=n.split("."),S=l(a,m);return typeof S=="undefined"?o:S}e.getConfigurationValue=y;function u(a,n,o){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(n[l])?u(a[l],n[l],o):o&&(a[l]=n[l]):a[l]=n[l])})}e.merge=u;function h(){const a=r.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=h;function s(){const a=Object.create(null),n=r.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let o in n){let l=n[o].default;d(a,o,l,m=>console.error(`Conflict in default settings: ${m}`))}return a}e.getDefaultValues=s;function c(a){return`[${a}]`}e.keyFromOverrideIdentifier=c;function i(a,n,o){const l=a.inspect(n),m=a.inspect(o);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:l.defaultValue}e.getMigratedSettingValue=i}),define(J[188],Z([0,1,31,4,40,2,37,44,13,7,16,49,38]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},a=[],n=[]){this._contents=i,this._keys=a,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,a){const n=this.getContentsForOverrideIdentifer(a);return n?i?(0,t.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.keys;return[]}override(i){const a=this.getContentsForOverrideIdentifer(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let n={};for(const o of v.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[o],m=a[o];m&&(typeof l=="object"&&typeof m=="object"?(l=r.deepClone(l),this.mergeContents(l,m)):l=m),n[o]=l}return new p(n,this.keys,this.overrides)}merge(...i){const a=r.deepClone(this.contents),n=r.deepClone(this.overrides),o=[...this.keys];for(const l of i){this.mergeContents(a,l.contents);for(const m of l.overrides){const[S]=n.filter(D=>v.equals(D.identifiers,m.identifiers));S?this.mergeContents(S.contents,m.contents):n.push(r.deepClone(m))}for(const m of l.keys)o.indexOf(m)===-1&&o.push(m)}return new p(a,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(i,a){for(const n of Object.keys(a)){if(n in i&&f.isObject(i[n])&&f.isObject(a[n])){this.mergeContents(i[n],a[n]);continue}i[n]=r.deepClone(a[n])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?r.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,a){this.addKey(i),(0,t.addToValueTree)(this.contents,i,a,n=>{throw new Error(n)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let a=this.keys.length;for(let n=0;n<a;n++)i.indexOf(this.keys[n])===0&&(a=n);this.keys.splice(a,1,i)}removeKey(i){let a=this.keys.indexOf(i);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=p;class d extends p{constructor(){const i=(0,t.getDefaultValues)(),a=(0,t.getConfigurationKeys)(),n=[];for(const o of Object.keys(i))P.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,P.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,a,n)}}e.DefaultConfigurationModel=d;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,a){if(!f.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,a)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,a){this._raw=i;const{contents:n,keys:o,overrides:l,restricted:m}=this.doParseRaw(i,a);this._configurationModel=new p(n,o,l),this._restrictedConfigurations=m||[]}doParseContent(i){let a={},n=null,o=[],l=[],m=[];function S(A){Array.isArray(o)?o.push(A):n!==null&&(o[n]=A)}let D={onObjectBegin:()=>{let A={};S(A),l.push(o),o=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let A=[];S(A),l.push(o),o=A,n=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:S,onError:(A,W,C)=>{m.push({error:A,offset:W,length:C})}};if(i)try{k.visit(i,D),a=o[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return a}doParseRaw(i,a){const n=b.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,n,!0,a);i=o.raw;const l=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),m=Object.keys(i),S=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:l,keys:m,overrides:S,restricted:o.restricted}}filter(i,a,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const l={},m=[];for(let S in i)if(P.OVERRIDE_PROPERTY_PATTERN.test(S)&&n){const D=this.filter(i[S],a,!1,o);l[S]=D.raw,m.push(...D.restricted)}else{const D=a[S],A=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&m.push(S),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&(o.skipRestricted&&D?.restricted||(l[S]=i[S]))}return{raw:l,restricted:m}}}e.ConfigurationModelParser=g;class I extends M.Disposable{constructor(i,a,n,o){super();this.userSettingsResource=i,this.scopes=a,this.fileService=o,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class y{constructor(i,a,n=new p,o=new p,l=new E.ResourceMap,m=new p,S=new E.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new E.ResourceMap,this._userConfiguration=null}getValue(i,a,n){return this.getConsolidateConfigurationModel(a,n).getValue(i)}updateValue(i,a,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new p,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,a===void 0?o.removeValue(i):o.setValue(i,a),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,a,n){const o=this.getConsolidateConfigurationModel(a,n),l=this.getFolderConfigurationModelForResource(a.resource,n),m=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,S=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),A=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),W=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),C=n?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,X=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,te=a.overrideIdentifier?m.override(a.overrideIdentifier).getValue(i):m.getValue(i),oe=o.getValue(i),Y=v.distinct(v.flatten(o.overrides.map(Q=>Q.identifiers))).filter(Q=>o.getOverrideValue(i,Q)!==void 0);return{defaultValue:S,userValue:D,userLocalValue:A,userRemoteValue:W,workspaceValue:C,workspaceFolderValue:X,memoryValue:te,value:oe,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userRemote:W!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:l?.freeze().getValue(i),override:a.overrideIdentifier?l?.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:m.getValue(i),override:a.overrideIdentifier?m.getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(i){const a=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,a){this._folderConfigurations.set(i,a),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const n=a.filter(o=>P.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const l=(0,P.overrideIdentifierFromKey)(o),m=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=i.getKeysForOverrideIdentifier(l),D=[...S.filter(A=>m.indexOf(A)===-1),...m.filter(A=>S.indexOf(A)===-1),...m.filter(A=>!r.equals(this._defaultConfiguration.override(l).getValue(A),i.override(l).getValue(A)))];return[l,D]});return this.updateDefaultConfiguration(i),{keys:a,overrides:n}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:n,removed:o,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),m=[...a,...n,...o];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:n,removed:o,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...a,...n,...o];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:n,removed:o,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...a,...n,...o];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:l}}compareAndUpdateFolderConfiguration(i,a){const n=this.folderConfigurations.get(i),{added:o,updated:l,removed:m,overrides:S}=(0,t.compare)(n,a);let D=[...o,...l,...m];return(D.length||!n)&&this.updateFolderConfiguration(i,a),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(i){const a=this.folderConfigurations.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:o,removed:l,overrides:m}=(0,t.compare)(a,void 0);return{keys:[...n,...o,...l],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,a){let n=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier?n.override(i.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:i},a){let n=this.getWorkspaceConsolidatedConfiguration();if(a&&i){const o=a.getFolder(i);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const l=this._memoryConfigurationByResource.get(i);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let a=this._foldersConsolidatedConfigurations.get(i);if(!a){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(a=n.merge(o),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(i,a)):a=n}return a}getFolderConfigurationModelForResource(i,a){if(a&&i){const n=a.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,a)=>{const{contents:n,overrides:o,keys:l}=this._folderConfigurations.get(a);return i.push([a,{contents:n,overrides:o,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>i.add(a)),this.userConfiguration.freeze().keys.forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>a.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>a.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>a.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(o=>a.add(o))),[...a.values()]}static parse(i){const a=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((m,S)=>(m.set(w.URI.revive(S[0]),this.parseConfigurationModel(S[1])),m),new E.ResourceMap);return new y(a,n,new p,o,l,new p,new E.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=y;function u(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,a=new Map;for(const o of c)o.keys.forEach(l=>i.add(l)),o.overrides.forEach(([l,m])=>{const S=(0,E.getOrSet)(a,l,new Set);m.forEach(D=>S.add(D))});const n=[];return a.forEach((o,l)=>n.push([l,[...o.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=u;class h{constructor(i,a,n,o){this.change=i,this.previous=a,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(S=>l.add(S)),i.overrides.forEach(([,S])=>S.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const m=new p;this.affectedKeys.forEach(S=>m.setValue(S,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(a){const n=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,a,this.currentWorkspace);return!r.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(i,a){let n=(0,t.toValuesTree)({[a]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(i=i[o],!i)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=h;class s extends h{constructor(i,a,n,o){super({keys:i.allKeys(),overrides:[]},void 0,i,a);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s}),define(J[189],Z([0,1,9,4,2,15,16,188,49,38]),function(K,e,v,L,k,M,E,r,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends k.Disposable{constructor(b,p){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new r.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,p)),this.configuration=new r.Configuration(new r.DefaultConfigurationModel,new r.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new r.Configuration(new r.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,p){const d=typeof b=="string"?b:void 0,g=(0,E.isConfigurationOverrides)(b)?b:(0,E.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(d,g,void 0)}updateValue(b,p,d,g){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(d,p,1)}onDidDefaultConfigurationChange(b){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new r.DefaultConfigurationModel,b);this.trigger(d,p,6)}trigger(b,p,d){const g=new r.ConfigurationChangeEvent(b,{data:p},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(J[190],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(E,r=L.Unknown,f){super(E);this._message=E,this._code=r,this._detail=f,this.isHandled=r===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof k&&E.isHandled}}e.RemoteAuthorityResolverError=k}),define(J[191],Z([0,1,9,18,24,17,4,2,28,83,190]),function(K,e,v,L,k,M,E,r,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var b;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(F){const R=new k.CancellationTokenSource;return setTimeout(()=>R.cancel(),F),R.token}function g(F,R){if(F.isCancellationRequested||R.isCancellationRequested)return k.CancellationToken.Cancelled;const T=new k.CancellationTokenSource;return F.onCancellationRequested(()=>T.cancel()),R.onCancellationRequested(()=>T.cancel()),T.token}class I{constructor(R){this._state="pending",this._disposables=new r.DisposableStore,this.promise=new Promise((T,O)=>{this._resolvePromise=T,this._rejectPromise=O}),R.isCancellationRequested?this._timeout():this._disposables.add(R.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(R){this._state==="pending"?this._disposables.add(R):R.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(R))}reject(R){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(R))}}function y(F,R){const T=new I(R);return T.registerDisposable(F.onControlMessage(O=>{const B=JSON.parse(O.toString()),N=z(B);N?T.reject(N):T.resolve(B)})),T.promise}function u(F,R,T,O,B,N){const V=new I(N);return R.connect(T,O,B,(x,ie)=>{V.didTimeout?(x&&F.error(x),ie?.dispose()):x||!ie?V.reject(x):V.resolve(ie)}),V.promise}function h(F,R){const T=new I(R);return F.then(O=>{T.didTimeout||T.resolve(O)},O=>{T.didTimeout||T.reject(O)}),T.promise}async function s(F,R,T,O){const B=U(F,R);F.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let N;try{N=await u(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,O)}catch(ne){throw F.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),F.logService.error(ne),ne}F.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let V,x;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(N,null),V=F.reconnectionProtocol,x=!1):(V=new w.PersistentProtocol(N,null),x=!0),F.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:F.connectionToken||"00000000000000000000"};V.sendControl(L.VSBuffer.fromString(JSON.stringify(ie)));try{const ne=await y(V,g(O,d(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const ae=new Error("Unexpected handshake message");throw ae.code="VSCODE_CONNECTION_ERROR",ae}F.logService.trace(`${B} 4/6. received SignRequest control message.`);const ce=await h(F.signService.sign(ne.data),O),se={type:"connectionType",commit:F.commit,signedData:ce,desiredConnectionType:R};return T&&(se.args=T),F.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(L.VSBuffer.fromString(JSON.stringify(se))),{protocol:V,ownsProtocol:x}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(F.logService.error(`${B} the handshake timed out. Error:`),F.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${B} received error control message when negotiating connection. Error:`),F.logService.error(ne)),x&&q(V),ne}}async function c(F,R,T,O){const B=Date.now(),N=U(F,R),{protocol:V,ownsProtocol:x}=await s(F,R,T,O),ie=new I(O);return ie.registerDisposable(V.onControlMessage(ne=>{const ce=JSON.parse(ne.toString()),se=z(ce);se?(F.logService.error(`${N} received error control message when negotiating connection. Error:`),F.logService.error(se),x&&q(V),ie.reject(se)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${j(B)}!`),ie.resolve({protocol:V,firstMessage:ce}))})),ie.promise}async function i(F,R){const{protocol:T}=await c(F,1,void 0,R);return{protocol:T}}async function a(F,R,T){const{protocol:O,firstMessage:B}=await c(F,2,R,T),N=B&&B.debugPort;return{protocol:O,debugPort:N}}async function n(F,R,T){const O=Date.now(),B=U(F,3),{protocol:N}=await s(F,3,R,T);return F.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${j(O)}!`),N}async function o(F,R,T){const{host:O,port:B,connectionToken:N}=await F.addressProvider.getAddress();return{commit:F.commit,host:O,port:B,connectionToken:N,reconnectionToken:R,reconnectionProtocol:T,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function l(F,R,T){try{const O=(0,f.generateUuid)(),B=await o(F,O,null),{protocol:N}=await i(B,k.CancellationToken.None);return new Q(F,R,T,O,N)}catch(O){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(O),Y.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentManagement=l;async function m(F,R){try{const T=(0,f.generateUuid)(),O=await o(F,T,null),{protocol:B,debugPort:N}=await a(O,R,k.CancellationToken.None);return new _(F,R,T,B,N)}catch(T){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(T),Y.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentExtensionHost=m;async function S(F,R,T){const O=await o(F,(0,f.generateUuid)(),null);return await n(O,{host:R,port:T},k.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function D(F){return(0,v.createCancelablePromise)(R=>new Promise((T,O)=>{const B=setTimeout(T,F*1e3);R.onCancellationRequested(()=>{clearTimeout(B),T()})}))}var A;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(A=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class W{constructor(R,T){this.reconnectionToken=R,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=W;class C{constructor(R,T,O,B){this.reconnectionToken=R,this.millisSinceLastIncomingData=T,this.durationSeconds=O,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class X{constructor(R,T,O){this.reconnectionToken=R,this.millisSinceLastIncomingData=T,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=X;class te{constructor(R,T,O){this.reconnectionToken=R,this.millisSinceLastIncomingData=T,this.attempt=O,this.type=4}}e.ConnectionGainEvent=te;class oe{constructor(R,T,O,B){this.reconnectionToken=R,this.millisSinceLastIncomingData=T,this.attempt=O,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class Y extends r.Disposable{constructor(R,T,O,B){super();this._connectionType=R,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=T,this.reconnectionToken=O,this.protocol=B,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(B.onSocketClose(N=>{const V=H(this._connectionType,this.reconnectionToken,!0);N?N.type===0?(this._options.logService.info(`${V} received socket close event (hadError: ${N.hadError}).`),N.error&&this._options.logService.error(N.error)):(this._options.logService.info(`${V} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this._options.logService.error(N.event)):this._options.logService.info(`${V} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(()=>{const N=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${N} received socket timeout event.`),this._beginReconnecting()})),Y._instances.push(this),Y._permanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(R,T,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=R,this._permanentFailureAttempt=T,this._permanentFailureHandled=O,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(Y._permanentFailure)return;const R=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const B=O<T.length?T[O]:T[T.length-1];try{if(B>0){const V=D(B);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,V)),this._options.logService.info(`${R} waiting for ${B} seconds before reconnecting...`);try{await V}catch{}}if(Y._permanentFailure){this._options.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${R} resolving connection...`);const N=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${R} connecting to ${N.host}:${N.port}...`),await this._reconnect(N,d(P)),this._options.logService.info(`${R} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(N),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(N),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable(N)){this._options.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this._options.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((0,M.isPromiseCanceledError)(N)){this._options.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if(N instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(N),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,t.RemoteAuthorityResolverError.isHandled(N));break}this._options.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(N),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!Y._permanentFailure)}_gotoPermanentFailure(R,T,O){this._onDidStateChange.fire(new oe(this.reconnectionToken,R,T,O)),q(this.protocol)}}Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class Q extends Y{constructor(R,T,O,B,N){super(1,R,B,N);this.client=this._register(new w.Client(N,{remoteAuthority:T,clientId:O},R.ipcLogger))}async _reconnect(R,T){await i(R,T)}}e.ManagementPersistentConnection=Q;class _ extends Y{constructor(R,T,O,B,N){super(2,R,O,B);this._startArguments=T,this.debugPort=N}async _reconnect(R,T){await a(R,this._startArguments,T)}}e.ExtensionHostPersistentConnection=_;function q(F){try{F.acceptDisconnect();const R=F.getSocket();F.dispose(),R.dispose()}catch(R){(0,M.onUnexpectedError)(R)}}function z(F){if(F&&F.type==="error"){const R=new Error(`Connection error: ${F.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function $(F,R){for(;F.length<R;)F+=" ";return F}function H(F,R,T){return`[remote-connection][${$(p(F),13)}][${R.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function U(F,R){return`${H(R,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function j(F){return`${Date.now()-F} ms`}}),define(J[73],Z([0,1,10]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===v.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function k(w){if(!w)return;const t=w.indexOf("+");return t<0?w:w.substr(0,t)}e.getRemoteName=k;function M(w){return w.scheme!==v.Schemas.file&&w.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=M;function E(w){if(w.folders.length)return w.folders.every(t=>M(t.uri))?w.folders[0].uri:void 0;if(w.configuration&&M(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=E;function r(w){return E(w)?.scheme}e.getVirtualWorkspaceScheme=r;function f(w){return E(w)!==void 0}e.isVirtualWorkspace=f}),define(J[95],Z([0,1,4,3,5,6]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var E;(function(p){p.Http="http",p.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var r;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(r=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function t(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=t;function P(p,d){return d?d!==1&&p<1024:!L.isWindows&&p<1024}e.isPortPrivileged=P;let b=class{constructor(d){this.logService=d,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,g){return this._tunnelProvider=d,d?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const g=[],I=Array.from(this._tunnels.values());for(let y of I){const u=Array.from(y.values());for(let h of u){const s=await h.value;s&&g.push(s)}}d(g)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(I=>I?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,I,y,u=!1,h=!1,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${I} on local port ${y}.`),!d)return;g||(g="localhost");const c=this.retainOrCreateTunnel(d,g,I,y,u,h,s);return c?c.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const I=g.get(d.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,I))}}}}async tryDisposeTunnel(d,g,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const y=I.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),y}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const I=this._tunnels.get(d);if(I&&I.has(g)){const y=I.get(g);y.refcount=0,await this.tryDisposeTunnel(d,g,y)}}addTunnelToMap(d,g,I){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:I})}async removeEmptyTunnelFromMap(d,g){const I=this._tunnels.get(d);I&&(await I.get(g)||I.delete(g),I.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let I=[d];w(d)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):t(d)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const y=I.map(u=>this._tunnels.get(u));for(const u of y){const h=u?.get(g);if(h)return h}}canTunnel(d){return!!f(d)}createWithProvider(d,g,I,y,u,h,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${I} on local port ${y}.`);const i={elevationRequired:u?P(y===void 0?I:y):!1},a={remoteAddress:{host:g,port:I},localAddressPort:y,public:h,protocol:s},n=d.forwardPort(a,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(g,I,n),n}};b=ue([ee(0,M.ILogService)],b),e.AbstractTunnelService=b}),define(J[50],Z([0,1,18,146,49,5,38]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function r(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=r;function f(d){return d.res.statusCode===204}async function w(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,v.streamToBuffer)(d.stream)).toString()}e.asText=w;async function t(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const I=(await(0,v.streamToBuffer)(d.stream)).toString();try{return JSON.parse(I)}catch(y){throw y.message+=`:
`+I,y}}e.asJson=t;function P(d){p(d)}e.updateProxyConfigurationsScope=P;let b;function p(d){const g=E.Registry.as(k.Extensions.Configuration);b&&g.deregisterConfigurations([b]),b={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.registerConfiguration(b)}p(2)}),define(J[192],Z([0,1,193,13]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(E,r){return E.protocol==="http:"?r.HTTP_PROXY||r.http_proxy||null:E.protocol==="https:"&&(r.HTTPS_PROXY||r.https_proxy||r.HTTP_PROXY||r.http_proxy)||null}async function M(E,r,f={}){const w=(0,v.parse)(E),t=f.proxyUrl||k(w,r);if(!t)return null;const P=(0,v.parse)(t);if(!/^https?:$/.test(P.protocol||""))return null;const b={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((p,d)=>{K(["http-proxy-agent"],p,d)}))(b):new(await new Promise((p,d)=>{K(["https-proxy-agent"],p,d)}))(b)}e.getProxyAgent=M}),define(J[194],Z([0,1,18,28]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,E,r){let f=r&&r.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await E.readFile(M.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await E.writeFile(M.serviceMachineIdResource,v.VSBuffer.fromString(f))}catch(w){}}return r&&r.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(J[74],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[195],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((k,M)=>K(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),E=new M.signer;if(E)return E.sign(k)}catch(M){}return k}}e.SignService=v}),define(J[39],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(J[22],Z([0,1,14,9,4,2,3,32,13,5,177,6,39]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var p;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class lt extends M.Disposable{constructor(I,y){super();this.logService=I,this.stateMainService=y,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",I);const y=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",y),v.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",I),v.app.removeListener("window-all-closed",y),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({join(y){I.push(y)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(I)}catch(y){this.logService.error(y)}try{await this.stateMainService.close()}catch(y){this.logService.error(y)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===I)return;this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const y=this.phaseWhen.get(this._phase);y&&(y.open(),this.phaseWhen.delete(this._phase))}async when(I){if(I<=this._phase)return;let y=this.phaseWhen.get(I);y||(y=new L.Barrier,this.phaseWhen.set(I,y)),await y.wait()}registerWindow(I){const y=new M.DisposableStore;this.windowCounter++,y.add(I.onWillLoad(h=>this._onWillLoadWindow.fire({window:I,workspace:h.workspace,reason:h.reason})));const u=(0,f.assertIsDefined)(I.win);u.on("close",h=>{const s=I.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),h.preventDefault(),this.unload(I,1).then(c=>{if(c){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(I),I.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,y.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,y){await this.unload(I,3)||I.reload(y)}async unload(I,y){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const u=this._quitRequested?2:y;let h=await this.onBeforeUnloadWindowInRenderer(I,u);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(I,u),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,u),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,y){return new Promise(u=>{const h=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${h}`,c=`vscode:cancel${h}`;v.ipcMain.once(s,()=>{u(!1)}),v.ipcMain.once(c,()=>{u(!0)}),I.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:c,reason:y})})}onBeforeUnloadWindowInMain(I,y){const u=[];return this._onBeforeUnloadWindow.fire({reason:y,window:I,veto(h){u.push(h)}}),(0,t.handleVetos)(u,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(I,y){return new Promise(u=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(s,()=>u()),I.send("vscode:onWillUnload",{replyChannel:s,reason:y})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${I}`),I&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(y=>{this.pendingQuitPromiseResolve=y,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(I){this.logService.trace("Lifecycle#relaunch()");const y=process.argv.slice(1);if(I?.addArgs&&y.push(...I.addArgs),I?.removeArgs)for(const s of I.removeArgs){const c=y.indexOf(s);c>=0&&y.splice(c,1)}const u=()=>{try{if(E.isWindows){const s=(0,r.cwd)();s!==process.cwd()&&process.chdir(s)}}catch(s){this.logService.error(s)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:y})};v.app.once("quit",u),await this.quit(!0)&&v.app.removeListener("quit",u)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const y of v.BrowserWindow.getAllWindows())if(y&&!y.isDestroyed()){let u;y.webContents&&!y.webContents.isDestroyed()?u=new Promise(h=>y.once("closed",h)):u=Promise.resolve(),y.destroy(),await u}})()]),v.app.exit(I)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=ue([ee(0,P.ILogService),ee(1,b.IStateMainService)],d),e.LifecycleMainService=d}),define(J[196],Z([0,1,4,2,5,22]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let E=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((t,P)=>{K(["native-keymap"],t,P)});this._keyboardLayoutData=r(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=r(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=ue([ee(0,M.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function r(f){const w=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:t}}}),define(J[96],Z([0,1,9,4,2,13,85,5]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,r.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var P;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(P=e.StorageTarget||(e.StorageTarget={}));class b extends k.Disposable{constructor(I={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,y){y===f?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:y,target:this.getKeyTargets(I)[y]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,y,u){return this.getStorage(y)?.get(I,u)}getBoolean(I,y,u){return this.getStorage(y)?.getBoolean(I,u)}getNumber(I,y,u){return this.getStorage(y)?.getNumber(I,u)}store(I,y,u,h){if((0,M.isUndefinedOrNull)(y)){this.remove(I,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,u,h),this.getStorage(u)?.set(I,y)})}remove(I,y){this.withPausedEmitters(()=>{this.updateKeyTarget(I,y,void 0),this.getStorage(y)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,y){const u=[],h=this.getKeyTargets(I);for(const s of Object.keys(h))h[s]===y&&u.push(s);return u}updateKeyTarget(I,y,u){const h=this.getKeyTargets(y);typeof u=="number"?h[I]!==u&&(h[I]=u,this.getStorage(y)?.set(f,JSON.stringify(h))):typeof h[I]=="number"&&(delete h[I],this.getStorage(y)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const y=this.get(f,I);if(y)try{return JSON.parse(y)}catch(u){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=w.NONE){this._onWillSaveState.fire({reason:I}),await v.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return d(I,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends b{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=p;async function d(g,I,y,u){const h=l=>{try{return JSON.parse(l)}catch(m){return l}},s=new Map,c=new Map;g.forEach((l,m)=>{s.set(m,l),c.set(m,h(l))});const i=new Map,a=new Map;I.forEach((l,m)=>{i.set(m,l),a.set(m,h(l))}),console.group(`Storage: Global (path: ${y})`);let n=[];s.forEach((l,m)=>{n.push({key:m,value:l})}),console.table(n),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${u})`);let o=[];i.forEach((l,m)=>{o.push({key:m,value:l})}),console.table(o),console.groupEnd(),console.log(a)}e.logStorage=d}),define(J[197],Z([0,1,3,32,7,28]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(w){if(v.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function r(w,t,P,b,p,d,g,I,y,u){const h=Object.create(null);h["common.machineId"]=g,h.sessionID=(0,M.generateUuid)()+Date.now(),h.commitHash=p,h.version=d,h["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,v.PlatformToString)(v.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=b,h["common.product"]=u||"desktop";const s=f(I||[]);s&&(h["common.msftInternal"]=s);let c=0;const i=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),v.isLinuxSnap&&(h["common.snap"]="true");const a=E(P);a&&(h["common.platformDetail"]=a);try{const n=await w.readFile(k.URI.file(y));h["common.source"]=n.value.toString().slice(0,30)}catch(n){}return h}e.resolveCommonProperties=r;function f(w){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const P=t.toLowerCase();return w.some(b=>P===b)}e.verifyMicrosoftInternalDomain=f}),define(J[34],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[198],Z([0,1,26,63,40,10,8,3,7,66,19,82,70,20,21,34]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(c,i){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,o=new Map,l=2e4;function m(A,W,C,X){const te=W.substring(A.length+1);return new Promise(async oe=>{let Y;try{Y=await t.Promises.readdir(W,{withFileTypes:!0})}catch(q){oe();return}if(X.count>=l){X.count+=Y.length,X.maxReached=!0,oe();return}let Q=Y.length;if(Q===0){oe();return}let _=Y;X.count+Y.length>l&&(X.maxReached=!0,Q=l-X.count,_=Y.slice(0,Q)),X.count+=Y.length;for(const q of _)if(q.isDirectory()){if(C.includes(q.name)||await m(A,(0,E.join)(W,q.name),C,X),--Q==0){oe();return}}else{const z=q.name.lastIndexOf(".");if(z>=0){const $=q.name.substring(z+1);$&&n.set($,(n.get($)??0)+1)}for(const $ of a)$.relativePathPattern?.test(te)!==!1&&$.filePattern.test(q.name)&&o.set($.tag,(o.get($.tag)??0)+1);if(--Q==0){oe();return}}})}const S={count:0,maxReached:!1};await m(c,c,i,S);const D=await h(c);return{configFiles:y(o),fileTypes:y(n),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=I;function y(c){return[...L.Iterable.map(c.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function u(){const c={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=u;async function h(c){try{const i=new Map,a=(0,E.join)(c,".vscode","launch.json"),n=await t.Promises.readFile(a),o=[],l=(0,k.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${a}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const m of l.configurations){const S=m.type;S&&(i.has(S)?i.set(S,i.get(S)+1):i.set(S,1))}return y(i)}catch(i){return[]}}e.collectLaunchConfigs=h;let s=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const n=v.cpus();return n&&n.length>0&&a.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),a.push(`Memory (System):  ${(v.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),r.isWindows||a.push(`Load (avg):       ${v.loadavg().map(o=>Math.round(o)).join(", ")}`),a.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,P.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async n=>{let[o,l]=n,m=this.formatProcessList(i,o);return a.forEach(S=>{if((0,b.isRemoteDiagnosticError)(S))m+=`
${S.errorMessage}`,l+=`
${S.errorMessage}`;else if(m+=`

Remote: ${S.hostName}`,S.processes&&(m+=`
${this.formatProcessList(i,S.processes)}`),S.workspaceMetadata){l+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const A=S.workspaceMetadata[D];let W=`${A.fileCount} files`;A.maxFilesReached&&(W=`more than ${W}`),l+=`|    Folder (${D}): ${W}`,l+=this.formatWorkspaceStats(A)}}}),{processInfo:m,workspaceInfo:l}})}async getSystemInfo(i,a){const{memory:n,vmHint:o,os:l,cpus:m}=u(),S={os:l,memory:n,cpus:m,vmHint:o,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return r.isWindows||(S.load=`${v.loadavg().map(D=>Math.round(D)).join(", ")}`),r.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(i,a){const n=[];return(0,P.listProcesses)(i.mainPID).then(async o=>(n.push(""),n.push(this.formatEnvironment(i)),n.push(""),n.push(this.formatProcessList(i,o)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(i))),a.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.formatMachineInfo(l.machineInfo)),l.processes&&n.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const m of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[m];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),n.push(`Folder (${m}): ${D}`),n.push(this.formatWorkspaceStats(S))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(i){const a=[],n=60;let o=0;const l=(A,W)=>{const C=` ${A}(${W})`;o+C.length>n?(a.push(m),m="|                 ",o=m.length):o+=C.length,m+=C};let m="|      File types:";const S=10;let D=i.fileTypes.length>S?S:i.fileTypes.length;for(let A=0;A<D;A++){const W=i.fileTypes[A];l(W.name,W.count)}if(a.push(m),i.configFiles.length>=0&&(m="|      Conf files:",o=0,i.configFiles.forEach(A=>{l(A.name,A.count)}),a.push(m)),i.launchConfigFiles.length>0){let A="|      Launch Configs:";i.launchConfigFiles.forEach(W=>{A+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),a.push(A)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(n=>n.length));return Object.keys(i).map(n=>`${n}:  ${" ".repeat(a-n.length)}  ${i[n]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],n=[];return i.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(a.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const m=f.URI.revive(l);if(m.scheme===M.Schemas.file){const S=m.fsPath;n.push(I(S,["node_modules",".git"]).then(D=>{let A=`${D.fileCount} files`;D.maxFilesReached&&(A=`more than ${A}`),a.push(`|    Folder (${(0,E.basename)(S)}): ${A}`),a.push(this.formatWorkspaceStats(D))}).catch(D=>{a.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else a.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>a.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(i,a){const n=new Map;i.windows.forEach(l=>n.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,n,o,a,0),o.join(`
`)}formatProcessItem(i,a,n,o,l){const m=l===0;let S;m?S=o.pid===i?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(S=`${S} (${a.get(o.pid)})`));const D=process.platform==="win32"?o.mem:v.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(D/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(o.children)&&o.children.forEach(A=>this.formatProcessItem(i,a,n,A,l+1))}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const n=f.URI.revive(a);if(n.scheme!==M.Schemas.file)continue;const o=n.fsPath;try{const l=await I(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),l.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),l.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};s=ue([ee(0,g.ITelemetryService),ee(1,d.IProductService)],s),e.DiagnosticsService=s}),define(J[199],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(M){this.appender=M}listen(M,E){throw new Error(`Event not found: ${E}`)}call(M,E,{eventName:r,data:f}){return this.appender.log(r,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(M){this.channel=M}log(M,E){return this.channel.call("log",{eventName:M,data:E}).then(void 0,r=>`Failed to log telemetry: ${console.warn(r)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(J[200],Z([0,1,2,44,25,147,16,49,48,38]),function(K,e,v,L,k,M,E,r,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let t=class{constructor(p,d){this._configurationService=d,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appender=p.appender,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let g of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(g),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(g=>{const I=/^[a-f0-9]+$/i.test(g["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})})}setExperimentProperty(p,d){this._experimentProperties[p]=d}setEnabled(p){this._enabled=p}_updateUserOptIn(){const p=this._configurationService?.getValue(P);this._userOptIn=p?p.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const p=await this._commonProperties;let d=p.sessionID,g=p["common.instanceId"],I=p["common.machineId"],y=p["common.firstSessionDate"],u=p["common.msftInternal"];return{sessionId:d,instanceId:g,machineId:I,firstSessionDate:y,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(p,d,g){return this.isOptedIn?this._commonProperties.then(I=>{d=(0,L.mixin)(d,I),d=(0,L.mixin)(d,this._experimentProperties),d=(0,L.cloneAndChange)(d,y=>{if(typeof y=="string")return this._cleanupInfo(y,g)}),this._appender.log(p,d)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(p,d,g){return this.publicLog(p,d,g)}publicLogError(p,d){return this.sendErrorTelemetry?this.publicLog(p,d,!0):Promise.resolve(void 0)}publicLogError2(p,d){return this.publicLogError(p,d)}_cleanupInfo(p,d){let g=p;if(d){const I=[];for(let s of this._cleanupPatterns)for(;;){const c=s.exec(p);if(!c)break;I.push([c.index,s.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(g="";;){const s=u.exec(p);if(!s)break;!y.test(s[0])&&I.every(([c,i])=>s.index<c||s.index>=i)&&(g+=p.substring(h,s.index)+"<REDACTED: user-file-path>",h=u.lastIndex)}h<p.length&&(g+=p.substr(h))}for(let I of this._cleanupPatterns)g=g.replace(I,"");return g}};t.IDLE_START_EVENT_NAME="UserIdleStart",t.IDLE_STOP_EVENT_NAME="UserIdleStop",t=ue([ee(1,E.IConfigurationService)],t),e.TelemetryService=t;const P="telemetry";w.Registry.as(r.Extensions.Configuration).registerConfiguration({id:P,order:110,type:"object",title:(0,M.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,M.localize)(2,null,f.default.nameLong,f.default.privacyStatementUrl):(0,M.localize)(1,null,f.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[75],Z([0,1,9,44,13,16]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.TelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(I,y){return Promise.resolve(void 0)}publicLog2(I,y){return this.publicLog(I,y)}publicLogError(I,y){return Promise.resolve(void 0)}publicLogError2(I,y){return this.publicLogError(I,y)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(y,u,h){}async publicLogError(y,u,h){}}e.NullEndpointTelemetryService=E;function r(...I){return{log:(y,u)=>I.forEach(h=>h.log(y,u)),flush:()=>v.Promises.settled(I.map(y=>y.flush()))}}e.combinedAppender=r,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(I,y){return y.onDidChangeConfiguration(u=>{u.source!==6&&I.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(u.source),configurationKeys:d(u.sourceConfig)})})}e.configurationTelemetry=f;var w;(function(I){I[I.NONE=0]="NONE",I[I.LOG=1]="LOG",I[I.USER=2]="USER"})(w=e.TelemetryLevel||(e.TelemetryLevel={}));function t(I,y){return y.disableTelemetry||!I.enableTelemetry?0:y.isBuilt?2:1}e.getTelemetryLevel=t;function P(I){const y=Object.create(null),u=Object.create(null),h=Object.create(null);p(I,h);for(let s in h){s=s.length>150?s.substr(s.length-149):s;const c=h[s];typeof c=="number"?u[s]=c:typeof c=="boolean"?u[s]=c?1:0:typeof c=="string"?y[s]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(y[s]=c)}return{properties:y,measurements:u}}e.validateTelemetryData=P;function b(I){if(!I)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{I.indexOf(`${h}+`)===0&&(y=h)}),y}e.cleanRemoteAuthority=b;function p(I,y,u=0,h){if(!!I)for(let s of Object.getOwnPropertyNames(I)){const c=I[s],i=h?h+s:s;Array.isArray(c)?y[i]=(0,L.safeStringify)(c):c instanceof Date?y[i]=c.toISOString():(0,k.isObject)(c)?u<2?p(c,y,u+1,i+"."):y[i]=(0,L.safeStringify)(c):y[i]=c}}function d(I){if(!I)return[];const y=[];return g(y,"",I),y}function g(I,y,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(h=>g(I,y?`${y}.${h}`:h,u[h])):I.push(y)}}),define(J[201],Z([0,1,31,24,17,44,3,7,16,47,168,171,162,20,6,21,50,194,96,34,75]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0;var c;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished"})(c||(c={}));function i(...T){return String(T.reduce((O,B)=>O|B,0))}var a;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class S{constructor(O=m){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,B=this.state.pageSize){return new S({...this.state,pageNumber:O,pageSize:B})}withFilter(O,...B){const N=[...this.state.criteria,...B.length?B.map(V=>({filterType:O,value:V})):[{filterType:O}]];return new S({...this.state,criteria:N})}withSortBy(O){return new S({...this.state,sortBy:O})}withSortOrder(O){return new S({...this.state,sortOrder:O})}withFlags(...O){return new S({...this.state,flags:O.reduce((B,N)=>B|N,0)})}withAssetTypes(...O){return new S({...this.state,assetTypes:O})}get raw(){const{criteria:O,pageNumber:B,pageSize:N,sortBy:V,sortOrder:x,flags:ie,assetTypes:ne}=this.state;return{filters:[{criteria:O,pageNumber:B,pageSize:N,sortBy:V,sortOrder:x}],assetTypes:ne,flags:ie}}get searchText(){const O=this.state.criteria.filter(B=>B.filterType===a.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function D(T,O){const B=(T||[]).filter(N=>N.statisticName===O)[0];return B?B.value:0}function A(T){const O="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(N=>N.assetType.indexOf(O)===0).reduce((N,V)=>{const x=te(T,V.assetType);return x&&N.push([V.assetType.substring(O.length),x]),N},[])}function W(T){if(T.properties){const O=T.properties.filter(V=>V.key===n.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),N=O.filter(V=>B.test(V.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return te(T,n.Repository)}function C(T){return{uri:`${T.fallbackAssetUri}/${n.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${n.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function X(T){const O=te(T,n.Icon);if(O)return O;const B=t.DefaultIconPath;return{uri:B,fallbackUri:B}}function te(T,O){return T.files.filter(N=>N.assetType===O)[0]?{uri:`${T.assetUri}/${O}`,fallbackUri:`${T.fallbackAssetUri}/${O}`}:null}function oe(T,O){const B=T.properties?T.properties.filter(V=>V.key===O):[],N=B.length>0&&B[0].value;return N?N.split(",").map(V=>(0,P.adoptToGalleryExtensionId)(V)):[]}function Y(T){const O=T.properties?T.properties.filter(B=>B.key===o.Engine):[];return O.length>0&&O[0].value||""}function Q(T){const O=T.properties?T.properties.filter(N=>N.key===o.LocalizedLanguages):[],B=O.length>0&&O[0].value||"";return B?B.split(","):[]}function _(T){return T.indexOf("preview")!==-1}function q(T){return T.targetPlatform?(0,t.toTargetPlatform)(T.targetPlatform):"undefined"}function z(T){const O=(0,v.distinct)(T.versions.map(q)),B=!!T.tags?.includes(t.WEB_EXTENSION_TAG),N=O.indexOf("web");return B?N===-1&&O.push("web"):N!==-1&&O.splice(N,1),O}function $(T,O,B,N){const V=z(T);let x=T.versions[0];return x=T.versions.find(ie=>ie.version===x.version&&(0,t.isTargetPlatformCompatible)(q(ie),V,t.CURRENT_TARGET_PLATFORM))||x,H(T,x,V,O,B,N)}function H(T,O,B,N,V,x){const ie={manifest:te(O,n.Manifest),readme:te(O,n.Details),changelog:te(O,n.Changelog),license:te(O,n.License),repository:W(O),download:C(O),icon:X(O),coreTranslations:A(O)};return{identifier:{id:(0,P.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:O.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,description:T.shortDescription||"",installCount:D(T.statistics,"install"),rating:D(T.statistics,"averagerating"),ratingCount:D(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:B,assets:ie,properties:{dependencies:oe(O,o.Dependency),extensionPack:oe(O,o.ExtensionPack),engine:Y(O),localizedLanguages:Q(O),targetPlatform:q(O)},preview:_(T.flags),telemetryData:{index:(V.pageNumber-1)*V.pageSize+N,querySource:x}}}let U=class{constructor(O,B,N,V,x,ie,ne,ce){this.requestService=B,this.logService=N,this.environmentService=V,this.telemetryService=x,this.fileService=ie,this.productService=ne,this.configurationService=ce;const se=ne.extensionsGallery;this.extensionsGalleryUrl=se&&se.serviceUrl,this.extensionsControlUrl=se&&se.controlUrl,this.commonHeadersPromise=R(ne.version,ne,this.environmentService,this.configurationService,this.fileService,O)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,B){const N=[];let V=new S().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,O.length).withFilter(a.Target,"Microsoft.VisualStudio.Code").withFilter(a.ExtensionName,...O.map(({id:ie})=>ie.toLowerCase()));O.every(ie=>!ie.version)&&(V=V.withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties,c.IncludeLatestVersionOnly));const{galleryExtensions:x}=await this.queryGallery(V,L.CancellationToken.None);for(let ie=0;ie<x.length;ie++){const ne=x[ie];if(!ne.versions.length)continue;const ce=(0,P.getGalleryExtensionId)(ne.publisher.publisherName,ne.extensionName),se=O.find(ae=>(0,P.areSameExtensions)(ae,{id:ce}))?.version;if(se){const ae=ne.versions.find(pe=>pe.version===se);ae&&N.push(H(ne,ae,z(ne),ie,V))}else N.push($(ne,ie,V))}return N}async getCompatibleExtension(O,B){const N=(0,t.isIExtensionIdentifier)(O)?null:O;if(N){if((0,t.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(N,B))return N}const{id:V,uuid:x}=N?N.identifier:O;let ie=new S().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");x?ie=ie.withFilter(a.ExtensionId,x):ie=ie.withFilter(a.ExtensionName,V);const{galleryExtensions:ne}=await this.queryGallery(ie,L.CancellationToken.None),[ce]=ne;if(!ce||!ce.versions.length)return null;const se=z(ce);if((0,t.isNotWebExtensionInWebTargetPlatform)(se,B))return null;for(let ae of ce.versions){if(!Y(ae)){const pe=await this.getEngine(ae);ae={...ae,properties:[...ae.properties||[],{key:o.Engine,value:pe}]}}if(await this.isRawExtensionVersionCompatible(ae,se,B))return H(ce,ae,se,0,ie)}return null}async isExtensionCompatible(O,B){if(!(0,t.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,B))return!1;let N=O.properties.engine;if(!N){const V=await this.getManifest(O,L.CancellationToken.None);if(!V)throw new Error("Manifest was not found");N=V.engines.vscode}return(0,b.isEngineValid)(N,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(O,B,N){if(!(0,t.isTargetPlatformCompatible)(q(O),B,N))return!1;const V=await this.getEngine(O);return(0,b.isEngineValid)(V,this.productService.version,this.productService.date)}async query(O,B){const N=L.CancellationToken.isCancellationToken(O)?{}:O,V=L.CancellationToken.isCancellationToken(O)?O:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let x=N.text||"";const ie=(0,M.getOrDefault)(N,fe=>fe.pageSize,50);let ne=new S().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,ie).withFilter(a.Target,"Microsoft.VisualStudio.Code");x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,we,Pe)=>(ne=ne.withFilter(a.Category,Pe||we),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,we,Pe)=>(ne=ne.withFilter(a.Tag,Pe||we),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(a.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),ne=ne.withFilter(a.SearchText,x)),ne=ne.withSortBy(0)):N.ids?ne=ne.withFilter(a.ExtensionId,...N.ids):N.names?ne=ne.withFilter(a.ExtensionName,...N.names):ne=ne.withSortBy(4),typeof N.sortBy=="number"&&(ne=ne.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(ne=ne.withSortOrder(N.sortOrder));const{galleryExtensions:ce,total:se}=await this.queryGallery(ne,V),ae=ce.map((fe,we)=>$(fe,we,ne,N.source)),pe=async(fe,we)=>{if(we.isCancellationRequested)throw(0,k.canceled)();const Pe=ne.withPage(fe+1),{galleryExtensions:Se}=await this.queryGallery(Pe,we);return Se.map((me,Ee)=>$(me,Ee,Pe,N.source))};return{firstPage:ae,total:se,pageSize:ne.pageSize,getPage:pe}}async queryGallery(O,B){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,c.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,i(c.Unpublished));const N=await this.commonHeadersPromise,V=JSON.stringify(O.raw),x={...N,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},ie=new Date().getTime();let ne,ce,se=0;try{if(ne=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:V,headers:x},B),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:se};const ae=await(0,I.asJson)(ne);if(ae){const pe=ae.results[0],fe=pe.extensions,we=pe.resultMetadata&&pe.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return se=we&&we.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:se}}return{galleryExtensions:[],total:se}}catch(ae){throw ce=ae,ae}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(V.length),duration:new Date().getTime()-ie,success:!!ne&&(0,I.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ce?(0,k.isPromiseCanceledError)(ce)?"canceled":(0,k.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(se)})}}async reportStatistic(O,B,N,V){if(!this.isEnabled())return;const x=E.isWeb?this.api(`/itemName/${O}.${B}/version/${N}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${B}/${N}/stats?statType=${V}`),ie=E.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:ie};try{await this.requestService.request({type:"POST",url:x,headers:ce},L.CancellationToken.None)}catch(se){}}async download(O,B,N){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const V=(0,P.getGalleryExtensionTelemetryData)(O),x=new Date().getTime(),ie=ae=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...V,duration:ae}),ne=N===1?"install":N===2?"update":"",ce=ne?{uri:`${O.assets.download.uri}${r.URI.parse(O.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${O.assets.download.fallbackUri}${r.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:O.assets.download,se=await this.getAsset(ce);await this.fileService.writeFile(B,se.stream),ie(new Date().getTime()-x)}async getReadme(O,B){if(O.assets.readme){const N=await this.getAsset(O.assets.readme,{},B);return await(0,I.asText)(N)||""}return""}async getManifest(O,B){if(O.assets.manifest){const N=await this.getAsset(O.assets.manifest,{},B),V=await(0,I.asText)(N);return V?JSON.parse(V):null}return null}async getManifestFromRawExtensionVersion(O,B){const N=te(O,n.Manifest);if(!N)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},x=await this.getAsset(N,{headers:V});return await(0,I.asJson)(x)}async getCoreTranslation(O,B){const N=O.assets.coreTranslations.filter(V=>V[0]===B.toUpperCase())[0];if(N){const V=await this.getAsset(N[1]),x=await(0,I.asText)(V);return x?JSON.parse(x):null}return null}async getChangelog(O,B){if(O.assets.changelog){const N=await this.getAsset(O.assets.changelog,{},B);return await(0,I.asText)(N)||""}return""}async getAllCompatibleVersions(O,B){let N=new S().withFlags(c.IncludeVersions,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");O.identifier.uuid?N=N.withFilter(a.ExtensionId,O.identifier.uuid):N=N.withFilter(a.ExtensionName,O.identifier.id);const{galleryExtensions:V}=await this.queryGallery(N,L.CancellationToken.None);if(!V.length)return[];const x=z(V[0]);if((0,t.isNotWebExtensionInWebTargetPlatform)(x,B))return[];const ie=[];for(const ne of V[0].versions)try{await this.isRawExtensionVersionCompatible(ne,x,B)&&ie.push({version:ne.version,date:ne.lastUpdated})}catch(ce){}return ie}async getAsset(O,B={},N=L.CancellationToken.None){const V=await this.commonHeadersPromise,x={type:"GET"},ie={...V,...B.headers||{}};B={...B,...x,headers:ie};const ne=O.uri,ce=O.fallbackUri,se={...B,url:ne};try{const ae=await this.requestService.request(se,N);if(ae.res.statusCode===200)return ae;const pe=await(0,I.asText)(ae);throw new Error(`Expected 200, got back ${ae.res.statusCode} instead.

${pe}`)}catch(ae){if((0,k.isPromiseCanceledError)(ae))throw ae;const pe=(0,k.getErrorMessage)(ae);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ne,message:pe});const fe={...B,url:ce};return this.requestService.request(fe,N)}}async getEngine(O){let B=Y(O);if(!B){const N=await this.getManifestFromRawExtensionVersion(O,L.CancellationToken.None);if(!N)throw new Error("Manifest was not found");B=N.engines.vscode}return B}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,I.asJson)(O),N=new Map;if(B)for(const V of B.malicious){const x=N.get(V)||{id:{id:V},malicious:!0,slow:!1};x.malicious=!0,N.set(V,x)}return[...N.values()]}};U=ue([ee(1,I.IRequestService),ee(2,d.ILogService),ee(3,w.IEnvironmentService),ee(4,h.ITelemetryService),ee(5,p.IFileService),ee(6,g.IProductService),ee(7,f.IConfigurationService)],U);let j=class extends U{constructor(O,B,N,V,x,ie,ne,ce){super(O,B,N,V,x,ie,ne,ce)}};j=ue([ee(0,u.IStorageService),ee(1,I.IRequestService),ee(2,d.ILogService),ee(3,w.IEnvironmentService),ee(4,h.ITelemetryService),ee(5,p.IFileService),ee(6,g.IProductService),ee(7,f.IConfigurationService)],j),e.ExtensionGalleryService=j;let F=class extends U{constructor(O,B,N,V,x,ie,ne){super(void 0,O,B,N,V,x,ie,ne)}};F=ue([ee(0,I.IRequestService),ee(1,d.ILogService),ee(2,w.IEnvironmentService),ee(3,h.ITelemetryService),ee(4,p.IFileService),ee(5,g.IProductService),ee(6,f.IConfigurationService)],F),e.ExtensionGalleryServiceWithNoStorageService=F;async function R(T,O,B,N,V,x){const ie={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T}`},ne=await(0,y.getServiceMachineId)(B,V,x);return(0,s.getTelemetryLevel)(O,B)>=2&&N.getValue("telemetry.enableTelemetry")===!0&&(ie["X-Market-User-Id"]=ne),ie}e.resolveMarketplaceHeaders=R}),define(J[202],Z([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(J[203],Z([0,1,108,4,2,5,38,202]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(I){function y(u){return u&&typeof u=="object"&&typeof u.id=="string"}I.isThemeColor=y})(f=e.ThemeColor||(e.ThemeColor={}));function w(I){return{id:I}}e.themeColorFromId=w;var t;(function(I){function y(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||f.isThemeColor(a.color))}I.isThemeIcon=y;const u=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function h(a){const n=u.exec(a);if(!n)return;let[,o]=n;return{id:o}}I.fromString=h;function s(a,n){let o=a.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),n&&(o=`${o}~${n}`),{id:o}}I.modify=s;function c(a,n){return a.id===n.id&&a.color?.id===n.color?.id}I.isEqual=c;function i(a,n){return{id:a.id,color:n?w(n):void 0}}I.asThemeIcon=i,I.asClassNameArray=v.CSSIcon.asClassNameArray,I.asClassName=v.CSSIcon.asClassName,I.asCSSSelector=v.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function P(I){switch(I){case r.ColorScheme.DARK:return"vs-dark";case r.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,k.toDisposable)(()=>{const u=this.themingParticipants.indexOf(y);this.themingParticipants.splice(u,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new b;E.Registry.add(e.Extensions.ThemingContribution,p);function d(I){return p.onColorThemeChange(I)}e.registerThemingParticipant=d;class g extends k.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(u=>this.onThemeChange(u)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,u){let h=this.theme.getColor(y);return h&&u&&(h=u(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(J[60],Z([0,1,14,3,5,39]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",r="#1E1E1E",f="#000000",w="theme",t="themeBackground",P="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let b=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(t,null);if(!d){let g;(L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=g==="hc-black"?f:g==="vs"?E:r}return L.isMacintosh&&d.toUpperCase()===r&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:P,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const I of v.BrowserWindow.getAllWindows())if(I.id===d){I.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};b=ue([ee(0,M.IStateMainService)],b),e.ThemeMainService=b}),define(J[42],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,E)=>({type:"idle",updateType:M,error:E}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(J[204],Z([0,1,3,148,49,38]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[205],Z([0,1,4,42]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(r){this.service=r}listen(r,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(r,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(r){this.channel=r,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(r){this._state=r,this._onStateChange.fire(r)}checkForUpdates(r){return this.channel.call("checkForUpdates",r)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(J[97],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(J[206],Z([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(r){this.handler=r}listen(r,f){throw new Error(`Event not found: ${f}`)}call(r,f,w){switch(f){case"handleURL":return this.handler.handleURL(v.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(r){this.channel=r}handleURL(r,f){return this.channel.call("handleURL",[r.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(r){this.next=r}async routeCall(r,f,w,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const P=v.URI.revive(w);if(P&&P.query){const b=/\bwindowId=(\d+)/.exec(P.query);if(b){const p=b[1],d=new RegExp(`window:${p}`),g=r.connections.find(I=>d.test(I.ctx));if(g)return g}}}return this.next.routeCall(r,f,w,t)}routeEvent(r,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(J[207],Z([0,1,9,2,7,21]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,t){const P=[...this.handlers.values()];return(0,v.first)(P.map(b=>()=>b.handleURL(w,t)),void 0,!1).then(b=>b||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=E;let r=class extends E{constructor(w){super();this.productService=w}create(w){let{authority:t,path:P,query:b,fragment:p}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&P&&P.indexOf("/")!==0&&(P=`/${P}`),k.URI.from({scheme:this.productService.urlProtocol,authority:t,path:P,query:b,fragment:p})}};r=ue([ee(0,M.IProductService)],r),e.NativeURLService=r}),define(J[208],Z([0,1,14,9,4,2,3,7]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return r.URI.parse(t)}catch(P){return null}}class w{constructor(P,b,p,d,g){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=P,E.isWindows){const u=d.isBuilt?[]:[`"${d.appRoot}"`];u.push("--open-url","--"),v.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,u)}const I=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(u,h)=>({event:u,url:h})),({event:u,url:h})=>(u.preventDefault(),h));this.disposables.add(I(u=>{const h=f(u);!h||this.urlService.open(h,{originalUrl:u})})),p.getWindows().filter(u=>u.isReady).length>0?this.flush():k.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||P.push(b);P.length!==0&&(this.uris=P,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(J[209],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(J[210],Z([0,1,14,2,10,7]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class E extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const t=M.URI.parse(f.url),P=E.validWebviewFilePaths.get(t.path);if(typeof P=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${P}`,p=k.FileAccess.asFileUri(b,K);return w(decodeURIComponent(p.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=E,E.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function k(w){return!!w.folderUri}e.isFolderToOpen=k;function M(w){return!!w.fileUri}e.isFileToOpen=M;function E(w){const t=r(w),P=w.getValue("window.menuBarVisibility");return P==="default"||t==="native"&&P==="compact"||v.isMacintosh&&v.isNative?"classic":P}e.getMenuBarVisibility=E;function r(w){if(v.isWeb)return"custom";const t=w.getValue("window");if(t){if(v.isMacintosh&&t.nativeTabs===!0||v.isMacintosh&&t.nativeFullScreen===!1)return"native";const p=t.titleBarStyle;if(p==="native"||p==="custom")return p}return v.isLinux?"native":"custom"}e.getTitleBarStyle=r;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(J[36],Z([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const E=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=E;var r;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(r=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(J[211],Z([0,1,14,4,2,210,36]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let r=class extends k.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,t){let P;if(typeof w.windowId=="number"){const{windowId:b}=w,p=this.windowsMainService.getWindowById(b);if(!p?.win)throw new Error(`Invalid windowId: ${b}`);P=p.win.webContents}else{const{webContentsId:b}=w;if(P=v.webContents.fromId(b),!P)throw new Error(`Invalid webContentsId: ${b}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(t)}async findInFrame(w,t,P,b){const p=this.getFrameByName(w,t),d=p;if(typeof d.findInFrame=="function"){d.findInFrame(P,{findNext:b.findNext,forward:b.forward});const g=(I,y)=>{y.finalUpdate&&(this._onFoundInFrame.fire(y),p.removeListener("found-in-frame",g))};p.on("found-in-frame",g)}}async stopFindInFrame(w,t,P){const p=this.getFrameByName(w,t);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,t){const P=this.windowsMainService.getWindowById(w.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${w}`);const b=P.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===t);if(!b)throw new Error(`Unknown frame: ${t}`);return b}};r=ue([ee(0,E.IWindowsMainService)],r),e.WebviewMainService=r}),define(J[212],Z([0,1,9,4,2]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:r,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(r,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>w()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch(P){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(r){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=r}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(J[213],Z([0,1,37,15,7,5]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var E;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function r(b){const p=b;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=r;function f(b){const p=b;return!!(p&&typeof p=="object"&&k.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(p,d,g,I){this._id=p,this._configuration=g,this._ignorePathCasing=I,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=w;class t{constructor(p,d){this.raw=d,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function P(b){return new t({uri:b,index:0,name:(0,L.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=P}),define(J[27],Z([0,1,29,40,77,33,10,8,3,15,7,151,5,73,213]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(_){return(typeof _=="string"?(0,r.extname)(_):(0,w.extname)(_))===g}e.hasWorkspaceFileExtension=I,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function y(_){return _.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function u(_){return _.hasOwnProperty("folderUri")}e.isRecentFolder=u;function h(_){return _.hasOwnProperty("fileUri")}e.isRecentFile=h;function s(_){const q=_;return typeof q?.id=="string"&&t.URI.isUri(q.uri)}e.isSingleFolderWorkspaceIdentifier=s;function c(_){if(_.configuration)return{id:_.id,configPath:_.configuration};if(_.folders.length===1)return{id:_.id,uri:_.folders[0].uri}}e.toWorkspaceIdentifier=c;function i(_){const q=_;return typeof q?.id=="string"&&t.URI.isUri(q.configPath)}e.isWorkspaceIdentifier=i;function a(_){const q=_;if(q?.uri)return{id:q.id,uri:t.URI.revive(q.uri)};const z=_;if(z?.configPath)return{id:z.id,configPath:t.URI.revive(z.configPath)};if(_?.id)return{id:_.id}}e.reviveIdentifier=a;function n(_,q){return w.extUriBiasedIgnorePathCase.isEqualOrParent(_,q.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function o(_){return l(_)||m(_)}e.isStoredWorkspaceFolder=o;function l(_){const q=_;return typeof q?.path=="string"&&(!q.name||typeof q.name=="string")}e.isRawFileWorkspaceFolder=l;function m(_){const q=_;return typeof q?.uri=="string"&&(!q.name||typeof q.name=="string")}e.isRawUriWorkspaceFolder=m;function S(_,q,z,$,H=!f.isWindows,U){if(_.scheme!==$.scheme)return{name:z,uri:_.toString(!0)};let j=q?void 0:U.relativePath($,_);if(j!==void 0)j.length===0?j=".":f.isWindows&&_.scheme===E.Schemas.file&&!H&&(j=j.replace(/\//g,"\\"));else if(_.scheme===E.Schemas.file)j=_.fsPath,f.isWindows&&(j=(0,M.normalizeDriveLetter)(j),H&&(j=(0,v.toSlashes)(j)));else{if(!U.isEqualAuthority(_.authority,$.authority))return{name:z,uri:_.toString(!0)};j=_.path}return{name:z,path:j}}e.getStoredWorkspaceFolder=S;function D(_,q,z){let $=[],H=new Set;const U=z.dirname(q);for(let j of _){let F;if(l(j))j.path&&(F=z.resolvePath(U,j.path));else if(m(j))try{F=t.URI.parse(j.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(R){console.warn(R)}if(F){let R=z.getComparisonKey(F);if(!H.has(R)){H.add(R);const T=j.name||z.basenameOrAuthority(F);$.push(new d.WorkspaceFolder({uri:F,name:T,index:$.length},j))}}}return $}e.toWorkspaceFolders=D;function A(_,q,z,$,H){let U=W(q,_);const j=H.dirname(q),F=H.dirname($),R=[],T=C(U.folders);for(const V of U.folders){const x=l(V)?H.resolvePath(j,V.path):t.URI.parse(V.uri);let ie;z?ie=!1:ie=!l(V)||(0,r.isAbsolute)(V.path),R.push(S(x,ie,V.name,F,T,H))}const O={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},B=k.setProperty(_,["folders"],R,O);let N=k.applyEdits(_,B);return U.remoteAuthority===(0,p.getRemoteAuthority)($)&&(N=k.applyEdits(N,k.removeProperty(N,["remoteAuthority"],O))),N}e.rewriteWorkspaceFileForNewLocation=A;function W(_,q){let z=L.parse(q);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter($=>o($));else throw new Error(`${_} looks like an invalid workspace file.`);return z}function C(_){return f.isWindows?_.some(q=>l(q)&&q.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function X(_){return _.workspace&&typeof _.workspace=="object"&&typeof _.workspace.id=="string"&&typeof _.workspace.configPath=="string"}function te(_){return typeof _.folderUri=="string"}function oe(_){return typeof _.fileUri=="string"}function Y(_,q){const z={workspaces:[],files:[]};if(_){const $=function(U,j){for(let F=0;F<U.length;F++)try{j(U[F],F)}catch(R){q.warn(`Error restoring recent entry ${JSON.stringify(U[F])}: ${R.toString()}. Skip entry.`)}},H=_;if(Array.isArray(H.entries))$(H.entries,U=>{const j=U.label,F=U.remoteAuthority;X(U)?z.workspaces.push({label:j,remoteAuthority:F,workspace:{id:U.workspace.id,configPath:t.URI.parse(U.workspace.configPath)}}):te(U)?z.workspaces.push({label:j,remoteAuthority:F,folderUri:t.URI.parse(U.folderUri)}):oe(U)&&z.files.push({label:j,remoteAuthority:F,fileUri:t.URI.parse(U.fileUri)})});else{const U=_;Array.isArray(U.workspaces3)&&$(U.workspaces3,(j,F)=>{const R=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[F]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?z.workspaces.push({label:R,workspace:{id:j.id,configPath:t.URI.parse(j.configURIPath)}}):typeof j=="string"&&z.workspaces.push({label:R,folderUri:t.URI.parse(j)})}),Array.isArray(U.files2)&&$(U.files2,(j,F)=>{const R=Array.isArray(U.fileLabels)&&U.fileLabels[F]||void 0;typeof j=="string"&&z.files.push({label:R,fileUri:t.URI.parse(j)})})}}return z}e.restoreRecentlyOpened=Y;function Q(_){const q={entries:[]};for(const z of _.workspaces)u(z)?q.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):q.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of _.files)q.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return q}e.toStoreData=Q}),define(J[51],Z([0,1,5,27]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function k(M){const E=M;return E&&(0,L.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=k}),define(J[52],Z([0,1,14,9,79,33,2,65,8,3,13,19,133,5,39,27]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let I=class gt{constructor(u){this.stateMainService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(u,h){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},h)}pickFolder(u,h){return this.doPick({...u,pickFolders:!0,title:(0,b.localize)(1,null)},h)}pickFile(u,h){return this.doPick({...u,pickFiles:!0,title:(0,b.localize)(2,null)},h)}pickWorkspace(u,h){const s=(0,b.localize)(3,null),c=(0,M.mnemonicButtonLabel)((0,b.localize)(4,null)),i=g.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:s,filters:i,buttonLabel:c},h)}async doPick(u,h){const s={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};s.defaultPath=u.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(s.properties=void 0,u.pickFiles&&u.pickFolders&&(s.properties=["multiSelections","openDirectory","openFile","createDirectory"])),s.properties||(s.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&s.properties.push("treatPackageAsDirectory");const c=h||v.BrowserWindow.getFocusedWindow(),i=await this.showOpenDialog(s,(0,t.withNullAsUndefined)(c));if(i&&i.filePaths&&i.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(i.filePaths[0])),i.filePaths}getWindowDialogQueue(u){if(u){let h=this.windowDialogQueues.get(u.id);return h||(h=new L.Queue,this.windowDialogQueues.set(u.id,h)),h}else return this.noWindowDialogueQueue}showMessageBox(u,h){return this.getWindowDialogQueue(h).queue(async()=>h?v.dialog.showMessageBox(h,u):v.dialog.showMessageBox(u))}async showSaveDialog(u,h){const s=this.acquireFileDialogLock(u,h);if(!s)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let c;return h?c=await v.dialog.showSaveDialog(h,u):c=await v.dialog.showSaveDialog(u),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,E.dispose)(s)}}normalizePath(u){return u&&w.isMacintosh&&(u=(0,r.normalizeNFC)(u)),u}normalizePaths(u){return u.map(h=>this.normalizePath(h))}async showOpenDialog(u,h){u.defaultPath&&(await P.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const s=this.acquireFileDialogLock(u,h);if(!s)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let c;return h?c=await v.dialog.showOpenDialog(h,u):c=await v.dialog.showOpenDialog(u),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,E.dispose)(s)}}acquireFileDialogLock(u,h){if(!h)return E.Disposable.None;let s=this.windowFileDialogLocks.get(h.id);s||(s=new Set,this.windowFileDialogLocks.set(h.id,s));const c=(0,k.hash)(u);if(!s.has(c))return s.add(c),(0,E.toDisposable)(()=>{s?.delete(c),s?.size===0&&this.windowFileDialogLocks.delete(h.id)})}};I.workingDirPickerStorageKey="pickerWorkingDir",I=ue([ee(0,d.IStateMainService)],I),e.DialogMainService=I}),define(J[214],Z([0,1,4,2,27]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(r,f){super();this.logService=r,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(r,f)=>(r?r.push(f):r=[f],r),M.STORAGE_CHANGE_DEBOUNCE_TIME)(r=>{r.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(r))}))}serializeGlobalStorageEvents(r){const f=new Map,w=new Set;return r.forEach(t=>{const P=this.storageMainService.globalStorage.get(t.key);typeof P=="string"?f.set(t.key,P):w.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(r,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(r,f,w){const t=(0,k.reviveIdentifier)(w.workspace),P=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(P.items.entries());case"updateItems":{const b=w;if(b.insert)for(const[p,d]of b.insert)P.set(p,d);b.delete&&b.delete.forEach(p=>P.delete(p));break}case"close":{if(t)return P.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(r){const f=r?this.storageMainService.workspaceStorage(r):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${r?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[215],Z([0,1,4,2,8,28,19,85,123,6,96,34,27]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends L.Disposable{constructor(y){super();this.logService=y,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new r.Storage(new r.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const y=await this.doCreate();this.storage.dispose(),this.storage=y,this._register(y.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(y);const u=y.getBoolean(t.IS_NEW_KEY);u===void 0?y.set(t.IS_NEW_KEY,!0):u&&y.set(t.IS_NEW_KEY,!1)}catch(y){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${y}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?y=>this.logService.trace(y):void 0,logError:y=>this.logService.error(y)}}doInit(y){return y.init()}get items(){return this.storage.items}get(y,u){return this.storage.get(y,u)}set(y,u){return this.storage.set(y,u)}delete(y){return this.storage.delete(y)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends p{constructor(y,u,h){super(u);this.options=y,this.environmentService=h}async doCreate(){let y;return this.options.useInMemoryStorage?y=f.SQLiteStorageDatabase.IN_MEMORY_PATH:y=(0,k.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new r.Storage(new f.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}))}async doInit(y){await super.doInit(y),this.updateTelemetryState(y)}updateTelemetryState(y){y.get(P.instanceStorageKey,void 0)===void 0&&y.set(P.instanceStorageKey,(0,M.generateUuid)()),y.get(P.firstSessionDateStorageKey,void 0)===void 0&&y.set(P.firstSessionDateStorageKey,new Date().toUTCString());const s=y.get(P.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();y.set(P.lastSessionDateStorageKey,typeof s=="undefined"?null:s),y.set(P.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends p{constructor(y,u,h,s){super(h);this.workspace=y,this.options=u,this.environmentService=s}async doCreate(){const{storageFilePath:y,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new r.Storage(new f.SQLiteStorageDatabase(y,{logging:this.createLoggingOptions()}),{hint:u?r.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const y=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,k.join)(y,g.WORKSPACE_STORAGE_NAME);return await E.Promises.exists(y)?{storageFilePath:u,wasCreated:!1}:(await E.Promises.mkdir(y,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(y),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(y){let u;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const h=(0,k.join)(y,g.WORKSPACE_META_NAME);await E.Promises.exists(h)||await E.Promises.writeFile(h,JSON.stringify(u,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(J[98],Z([0,1,43,2,47,5,22,6,215]),function(K,e,v,L,k,M,E,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(P,b,p){super();this.logService=P,this.environmentService=b,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async P=>{P.workspace&&this.workspaceStorage(P.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(P=>{P.join(this.globalStorage.close());for(const[,b]of this.mapWorkspaceToStorage)P.join(b.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const P=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(P.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),P}createWorkspaceStorage(P){return new f.WorkspaceStorageMain(P,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(P){let b=this.mapWorkspaceToStorage.get(P.id);return b||(this.logService.trace(`StorageMainService: creating workspace storage (${P.id})`),b=this.createWorkspaceStorage(P),this.mapWorkspaceToStorage.set(P.id,b),(0,v.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${P.id})`),this.mapWorkspaceToStorage.delete(P.id)})),b}};w=ue([ee(0,r.ILogService),ee(1,k.IEnvironmentService),ee(2,E.ILifecycleMainService)],w),e.StorageMainService=w}),define(J[99],Z([0,1,15,7,27]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,w,t){for(const b of f){const p=b.openedWorkspace;if((0,k.isWorkspaceIdentifier)(p)){const d=t(p);if(d){if(d.folders.some(g=>v.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return b}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(w,p.configPath))return b}}const P=f.filter(b=>(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(w,b.openedWorkspace.uri));if(P.length)return P.sort((b,p)=>-(b.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function E(f,w){for(const t of f)if((0,k.isWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,w)||(0,k.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,w))return t}e.findWindowOnWorkspaceOrFolder=E;function r(f,w){const t=P=>w.some(b=>v.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(P)));for(const P of f)if(P.config?.extensionDevelopmentPath?.some(b=>t(b)))return P}e.findWindowOnExtensionDevelopmentPath=r}),define(J[216],Z([0,1,14,2,3,15,7,16,22,6,39,36,27]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class mt extends L.Disposable{constructor(h,s,c,i,a){super();this.windowsMainService=h,this.stateMainService=s,this.lifecycleMainService=c,this.logService=i,this.configurationService=a,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(h.lastActiveWindow=this.toWindowState(i))}const s=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);s&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(s)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const c=I(h);this.stateMainService.setItem(mt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const s=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=s:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(c=>{const i=(0,b.isWorkspaceIdentifier)(h.openedWorkspace)&&c.workspace?.id===h.openedWorkspace.id,a=(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&c.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(c.folderUri,h.openedWorkspace.uri);(i||a)&&(c.uiState=s.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=s)}toWindowState(h){return{workspace:(0,b.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,b.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const s=this.doGetNewWindowState(h),c=this.configurationService.getValue("window");let i;return s.hasDefaultState?i=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),i&&k.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(i=!1)),s.mode===3&&!i&&(s.mode=1),s}doGetNewWindowState(h){const s=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=h.workspace;if((0,b.isWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(S.length)return S[0]}if((0,b.isSingleFolderWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(S.length)return S[0]}else if(h.backupPath){const S=this.state.openedWindows.filter(D=>D.backupPath===h.backupPath).map(D=>D.uiState);if(S.length)return S[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!s&&m)return m.uiState}let c;const i=v.screen.getAllDisplays();if(i.length===1)c=i[0];else{if(k.isMacintosh){const l=v.screen.getCursorScreenPoint();c=v.screen.getDisplayNearestPoint(l)}!c&&s&&(c=v.screen.getDisplayMatching(s.getBounds())),c||(c=v.screen.getPrimaryDisplay()||i[0])}let a=(0,P.defaultWindowState)();a.x=Math.round(c.bounds.x+c.bounds.width/2-a.width/2),a.y=Math.round(c.bounds.y+c.bounds.height/2-a.height/2);const n=this.configurationService.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")a.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")a.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&s){const l=s.serializeWindowState();l.mode===3?a.mode=3:a=l,o=a.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const s=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;s.some(c=>c.x===h.x||c.y===h.y);)h.x+=30,h.y+=30;return h}};p.windowsStateStorageKey="windowsState",p=ue([ee(0,P.IWindowsMainService),ee(1,t.IStateMainService),ee(2,f.ILifecycleMainService),ee(3,w.ILogService),ee(4,r.IConfigurationService)],p),e.WindowsStateHandler=p;function d(u){const h={openedWindows:[]},s=u||{openedWindows:[]};return s.lastActiveWindow&&(h.lastActiveWindow=g(s.lastActiveWindow)),s.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(s.lastPluginDevelopmentHostWindow)),Array.isArray(s.openedWindows)&&(h.openedWindows=s.openedWindows.map(c=>g(c))),h}e.restoreWindowsState=d;function g(u){const h={uiState:u.uiState};return u.backupPath&&(h.backupPath=u.backupPath),u.remoteAuthority&&(h.remoteAuthority=u.remoteAuthority),u.folder&&(h.folderUri=E.URI.parse(u.folder)),u.workspaceIdentifier&&(h.workspace={id:u.workspaceIdentifier.id,configPath:E.URI.parse(u.workspaceIdentifier.configURIPath)}),h}function I(u){return{lastActiveWindow:u.lastActiveWindow&&y(u.lastActiveWindow),lastPluginDevelopmentHostWindow:u.lastPluginDevelopmentHostWindow&&y(u.lastPluginDevelopmentHostWindow),openedWindows:u.openedWindows.map(h=>y(h))}}e.getWindowsStateStoreData=I;function y(u){return{workspaceIdentifier:u.workspace&&{id:u.workspace.id,configURIPath:u.workspace.configPath.toString()},folder:u.folderUri&&u.folderUri.toString(),backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.uiState}}}),define(J[100],Z([0,1,58,30,10,3,15]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function r(w){function t(){let P=w.scheme===k.Schemas.file?(0,E.originalFSPath)(w):w.toString();return M.isLinux||(P=P.toLowerCase()),(0,v.createHash)("md5").update(P).digest("hex")}return{id:t(),configPath:w}}e.getWorkspaceIdentifier=r;function f(w,t){function P(){if(w.scheme!==k.Schemas.file)return(0,v.createHash)("md5").update(w.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(w.fsPath)}catch(d){return}let p;return M.isLinux?p=t.ino:M.isMacintosh?p=t.birthtime.getTime():M.isWindows&&(typeof t.birthtimeMs=="number"?p=Math.floor(t.birthtimeMs):p=t.birthtime.getTime()),(0,v.createHash)("md5").update(w.fsPath).update(p?String(p):"").digest("hex")}const b=P();if(typeof b=="string")return{id:b,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(J[56],Z([0,1,58,59,26,18,17,4,2,8,3,28,35,83,217]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(S){this.socket=S,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const D=A=>S(M.VSBuffer.wrap(A));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(S){const D=A=>{S({type:0,hadError:A,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(S){return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(S){if(!this.socket.destroyed)try{this.socket.write(S.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((S,D)=>{if(this.socket.bufferSize===0){S();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),S()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=g;var I;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var y;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(y||(y={}));class u extends f.Disposable{constructor(S,D,A,W){super();this._onDidZlibFlush=this._register(new r.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new r.Emitter),this._onClose=this._register(new r.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=S,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=W,D?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,E.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),A&&(this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,E.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._totalOutgoingDataBytes+=S.byteLength,this._zlibDeflate?(this._zlibDeflate.write(S.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(M.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(S,!1)}_write(S,D){let A=2;S.byteLength<126?A+=0:S.byteLength<2**16?A+=2:A+=8;const W=M.VSBuffer.alloc(A);if(D?W.writeUInt8(194,0):W.writeUInt8(130,0),S.byteLength<126)W.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){W.writeUInt8(126,1);let C=1;W.writeUInt8(S.byteLength>>>8&255,++C),W.writeUInt8(S.byteLength>>>0&255,++C)}else{W.writeUInt8(127,1);let C=1;W.writeUInt8(0,++C),W.writeUInt8(0,++C),W.writeUInt8(0,++C),W.writeUInt8(0,++C),W.writeUInt8(S.byteLength>>>24&255,++C),W.writeUInt8(S.byteLength>>>16&255,++C),W.writeUInt8(S.byteLength>>>8&255,++C),W.writeUInt8(S.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=W.byteLength+S.byteLength,this.socket.write(M.VSBuffer.concat([W,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._totalIncomingWireBytes+=S.byteLength,this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),W=(D.readUInt8(0)&128)>>>7,C=D.readUInt8(1),X=(C&128)>>>7,te=C&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(te===126?2:0)+(te===127?8:0),this._state.fin=W,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),A=D.readUInt8(1),W=(A&128)>>>7;let C=A&127,X=1;C===126?C=D.readUInt8(++X)*2**8+D.readUInt8(++X):C===127&&(C=D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X));let te=0;W&&(te=D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X)),this._state.state=3,this._state.readLen=C,this._state.mask=te}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);h(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const A=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=A.length,this._onData.fire(M.VSBuffer.wrap(A))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await r.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=u;function h(m,S){if(S===0)return;let D=m.byteLength>>>2;for(let oe=0;oe<D;oe++){const Y=m.readUInt32BE(oe*4);m.writeUInt32BE(Y^S,oe*4)}let A=D*4,W=m.byteLength-A;const C=S>>>24&255,X=S>>>16&255,te=S>>>8&255;W>=1&&m.writeUInt8(m.readUInt8(A)^C,A),W>=2&&m.writeUInt8(m.readUInt8(A+1)^X,A+1),W>=3&&m.writeUInt8(m.readUInt8(A+2)^te,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function c(){const m=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):S=(0,w.join)((0,k.tmpdir)(),`vscode-ipc-${m}.sock`),a(S),S}e.createRandomIPCHandle=c;function i(m,S,D){const A=(0,v.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${D}-${S}-sock`;let W;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${D}-${S}.sock`):W=(0,w.join)(m,`${D}-${S}.sock`),a(W),W}e.createStaticIPCHandle=i;function a(m){const S=s[t.platform];typeof S=="number"&&m.length>=S&&console.warn(`WARNING: IPC handle "${m}" is longer than ${S} chars, try a shorter --user-data-dir`)}class n extends b.IPCServer{constructor(S){super(n.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const D=r.Event.fromNodeEventEmitter(S,"connection");return r.Event.map(D,A=>({protocol:new p.Protocol(new g(A)),onDidClientDisconnect:r.Event.once(r.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function o(m){return new Promise((S,D)=>{const A=(0,L.createServer)();A.on("error",D),A.listen(m,()=>{A.removeListener("error",D),S(new n(A))})})}e.serve=o;function l(m,S){return new Promise((D,A)=>{const W=(0,L.createConnection)(m,()=>{W.removeListener("error",A),D(p.Client.fromSocket(new g(W),S))});W.once("error",A)})}e.connect=l}),define(J[218],Z([0,1,56]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,t){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,t,P){return this.channel.call("click",[f,w,t,P])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,t){return this.channel.call("setValue",[f,w,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,t){return this.channel.call("getElements",[f,w,t])}getElementXY(f,w,t,P){return this.channel.call("getElementXY",[f,w,t,P])}typeInEditor(f,w,t){return this.channel.call("typeInEditor",[f,w,t])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,t){return this.channel.call("writeInTerminal",[f,w,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,t){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=M;async function E(r){const f=await(0,v.connect)(r,"driverClient"),w=f.getChannel("driver"),t=new k(w);return{client:f,driver:t}}e.connect=E}),define(J[219],Z([0,1,9,4,106,57,2,3,78,35,56,155,218,176,22,36]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(h){return h<21}let y=class{constructor(s,c,i,a){this.windowServer=s,this.options=c,this.windowsMainService=i,this.lifecycleMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(s){return this.registeredWindowIds.add(s),this.reloadingWindowIds.delete(s),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(s){this.reloadingWindowIds.add(s)}async getWindowIds(){return this.windowsMainService.getWindows().map(s=>s.id).filter(s=>this.registeredWindowIds.has(s)&&!this.reloadingWindowIds.has(s))}async capturePage(s){await this.whenUnfrozen(s);const c=this.windowsMainService.getWindowById(s);if(!c?.win)throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(s){await this.whenUnfrozen(s);const c=this.windowsMainService.getWindowById(s);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(s),this.lifecycleMainService.reload(c)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(s,c){await this.whenUnfrozen(s);const i=k.KeybindingParser.parseUserBinding(c);for(let a of i)await this._dispatchKeybinding(s,a)}async _dispatchKeybinding(s,c){if(c instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(s);if(!i?.win)throw new Error("Invalid window");const a=i.win.webContents,n=new M.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),l=new p.USLayoutResolvedKeybinding(n.toChord(),r.OS).getElectronAccelerator(),m=[];c.ctrlKey&&m.push("ctrl"),c.metaKey&&m.push("meta"),c.shiftKey&&m.push("shift"),c.altKey&&m.push("alt"),a.sendInputEvent({type:"keyDown",keyCode:l,modifiers:m}),I(c.keyCode)||a.sendInputEvent({type:"char",keyCode:l,modifiers:m}),a.sendInputEvent({type:"keyUp",keyCode:l,modifiers:m}),await(0,v.timeout)(100)}async click(s,c,i,a){await(await this.getWindowDriver(s)).click(c,i,a)}async doubleClick(s,c){await(await this.getWindowDriver(s)).doubleClick(c)}async setValue(s,c,i){await(await this.getWindowDriver(s)).setValue(c,i)}async getTitle(s){return await(await this.getWindowDriver(s)).getTitle()}async isActiveElement(s,c){return await(await this.getWindowDriver(s)).isActiveElement(c)}async getElements(s,c,i){return await(await this.getWindowDriver(s)).getElements(c,i)}async getElementXY(s,c,i,a){return await(await this.getWindowDriver(s)).getElementXY(c,i,a)}async typeInEditor(s,c,i){await(await this.getWindowDriver(s)).typeInEditor(c,i)}async getTerminalBuffer(s,c){return await(await this.getWindowDriver(s)).getTerminalBuffer(c)}async writeInTerminal(s,c,i){await(await this.getWindowDriver(s)).writeInTerminal(c,i)}async getLocaleInfo(s){return await(await this.getWindowDriver(s)).getLocaleInfo()}async getLocalizedStrings(s){return await(await this.getWindowDriver(s)).getLocalizedStrings()}async getWindowDriver(s){await this.whenUnfrozen(s);const c=`window:${s}`,i=new w.StaticRouter(n=>n===c),a=this.windowServer.getChannel("windowDriver",i);return new P.WindowDriverChannelClient(a)}async whenUnfrozen(s){for(;this.reloadingWindowIds.has(s);)await L.Event.toPromise(this.onDidReloadingChange.event)}};y=ue([ee(2,g.IWindowsMainService),ee(3,d.ILifecycleMainService)],y),e.Driver=y;async function u(h,s,c,i){const a=c.driverVerbose,n=i.createInstance(y,h,{verbose:a}),o=new b.WindowDriverRegistryChannel(n);h.registerChannel("windowDriverRegistry",o);const l=await(0,t.serve)(s),m=new b.DriverChannel(n);return l.registerChannel("driver",m),(0,E.combinedDisposable)(l,h)}e.serve=u}),define(J[23],Z([0,1,46,8,56,47,160,5]),function(K,e,v,L,k,M,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,r.refineServiceDecorator)(M.IEnvironmentService);class f extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([v.memoize],f.prototype,"cachedLanguagesPath",null),ue([v.memoize],f.prototype,"backupHome",null),ue([v.memoize],f.prototype,"backupWorkspacesPath",null),ue([v.memoize],f.prototype,"mainIPCHandle",null),ue([v.memoize],f.prototype,"mainLockfile",null),ue([v.memoize],f.prototype,"sandbox",null),ue([v.memoize],f.prototype,"driverVerbose",null),ue([v.memoize],f.prototype,"disableUpdates",null),ue([v.memoize],f.prototype,"disableKeytar",null),ue([v.memoize],f.prototype,"codeCachePath",null),ue([v.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(J[220],Z([0,1,58,30,29,10,8,3,15,7,19,51,16,23,20,6,27]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let y=class{constructor(h,s,c){this.configurationService=s,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,a)=>(0,k.isEqual)(i,a,!r.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let s=[];try{Array.isArray(h.rootURIWorkspaces)&&(s=h.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:w.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(s);let c=[];try{Array.isArray(h.folderURIWorkspaces)&&(c=h.folderURIWorkspaces.map(i=>w.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,s){this.workspaces.some(i=>h.workspace.id===i.workspace.id)||(this.workspaces.push(h),this.saveSync());const c=this.getBackupPath(h.workspace.id);return s&&this.moveBackupFolderSync(c,s),c}moveBackupFolderSync(h,s){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(s))try{L.renameSync(s,h)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(h){const s=h.id,c=this.workspaces.findIndex(i=>i.workspace.id===s);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(s=>this.backupUriComparer.isEqual(h,s))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const s=this.folders.findIndex(c=>this.backupUriComparer.isEqual(h,c));s!==-1&&(this.folders.splice(s,1),this.saveSync())}registerEmptyWindowBackupSync(h,s){const c=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:s}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(h){const s=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,h));s!==-1&&(this.emptyWindows.splice(s,1),this.saveSync())}getBackupPath(h){return(0,E.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const s=new Set,c=[];for(let i of h){const a=i.workspace;if(!(0,I.isWorkspaceIdentifier)(a))return[];if(!s.has(a.id)){s.add(a.id);const n=this.getBackupPath(a.id);await this.doHasBackups(n)?a.configPath.scheme!==M.Schemas.file||await t.Promises.exists(a.configPath.fsPath)?c.push(i):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return c}async validateFolders(h){if(!Array.isArray(h))return[];const s=[],c=new Set;for(let i of h){const a=this.backupUriComparer.getComparisonKey(i);if(!c.has(a)){c.add(a);const n=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(n)?i.scheme!==M.Schemas.file||await t.Promises.exists(i.fsPath)?s.push(i):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return s}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const s=[],c=new Set;for(let i of h){const a=i.backupFolder;if(typeof a!="string")return[];if(!c.has(a)){c.add(a);const n=this.getBackupPath(a);await this.doHasBackups(n)?s.push(i):await this.deleteStaleBackup(n)}}return s}async deleteStaleBackup(h){try{await t.Promises.exists(h)&&await t.Promises.rm(h,t.RimRafMode.MOVE)}catch(s){this.logService.error(`Backup: Could not delete stale backup: ${s.toString()}`)}}async convertToEmptyWindowBackup(h){let s=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,s));)s=this.getRandomEmptyWindowId();const c=this.getBackupPath(s);try{await t.Promises.rename(h,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:s}),!0}convertToEmptyWindowBackupSync(h){let s=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,s));)s=this.getRandomEmptyWindowId();const c=this.getBackupPath(s);try{L.renameSync(h,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:s}),!0}async getDirtyWorkspaces(){const h=[];for(const s of this.workspaces)await this.hasBackups(s)&&h.push(s.workspace);for(const s of this.folders)await this.hasBackups(s)&&h.push(s);return h}hasBackups(h){let s;return w.URI.isUri(h)?s=this.getBackupPath(this.getFolderHash(h)):(0,P.isWorkspaceBackupInfo)(h)?s=this.getBackupPath(h.workspace.id):s=h.backupFolder,this.doHasBackups(s)}async doHasBackups(h){try{const s=await t.Promises.readdir(h);for(const c of s)try{if((await t.Promises.readdir((0,E.join)(h,c))).length>0)return!0}catch(i){}}catch(s){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let s;return h.scheme===M.Schemas.file?s=r.isLinux?h.fsPath:h.fsPath.toLowerCase():s=h.toString().toLowerCase(),(0,v.createHash)("md5").update(s).digest("hex")}};y=ue([ee(0,p.IEnvironmentMainService),ee(1,b.IConfigurationService),ee(2,g.ILogService)],y),e.BackupMainService=y}),define(J[221],Z([0,1,59,56]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,E,r){const f=t=>r(t,void 0),w=v.createConnection({host:k,port:M},()=>{w.removeListener("error",f);const t=Buffer.alloc(16);for(let d=0;d<16;d++)t[d]=Math.round(Math.random()*256);const P=t.toString("base64");let b=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`];w.write(b.join(`\r
`)+`\r
\r
`);const p=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",p),r(void 0,new L.NodeSocket(w)))};w.on("data",p)});w.once("error",f)}}}),define(J[222],Z([0,1,59,9,2,115,16,6,21,191,95,221,74]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function p(y,u,h,s,c){return new d(y,u,h,s,c).waitForReady()}class d extends k.Disposable{constructor(u,h,s,c,i){super();this.defaultTunnelHost=h,this.suggestedLocalPort=i,this.public=!1,this._socketsDispose=new Map,this._options=u,this._server=v.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let u=await(0,M.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(u){u.pause();const h=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemoteHost,this.tunnelRemotePort),s=h.getSocket().socket,c=h.readEntireBuffer();h.dispose(),c.byteLength>0&&u.write(c.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),s.end()}),u.on("close",()=>s.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),s.destroy()}),s.on("end",()=>u.end()),s.on("close",()=>u.end()),s.on("error",()=>{u.destroy()}),u.pipe(s),s.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),s.end()})}}let g=class extends t.AbstractTunnelService{constructor(u,h,s,c,i){super(h);this.socketFactory=u,this.signService=s,this.productService=c,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,h,s,c,i,a,n){const o=this.getTunnelFromMap(h,s);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,s,c,i,a,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${s} on local port ${c}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},m=p(l,this.defaultTunnelHost,h,s,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,s,m),m}}};g=ue([ee(1,r.ILogService),ee(2,b.ISignService),ee(3,f.IProductService),ee(4,E.IConfigurationService)],g),e.BaseTunnelService=g;let I=class extends g{constructor(u,h,s,c){super(P.nodeSocketFactory,u,h,s,c)}};I=ue([ee(0,r.ILogService),ee(1,b.ISignService),ee(2,f.IProductService),ee(3,E.IConfigurationService)],I),e.TunnelService=I}),define(J[223],Z([0,1,193,18,17,2,13,16,47,90,6,192,217]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends M.Disposable{constructor(g,I,y){super();this.environmentService=I,this.logService=y,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,I){this.logService.trace("RequestService#request",g.url);const{proxyUrl:y,strictSSL:u}=this,h={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},s=g.agent?g.agent:await(0,P.getProxyAgent)(g.url||"",h,{proxyUrl:y,strictSSL:u});return g.agent=s,g.strictSSL=u,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,I)}async getNodeRequest(g){return((0,v.parse)(g.url).protocol==="https:"?await new Promise((u,h)=>{K(["https"],u,h)}):await new Promise((u,h)=>{K(["http"],u,h)})).request}_request(g,I){return new Promise(async(y,u)=>{let h;const s=(0,v.parse)(g.url),c=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,E.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),h=c(i,a=>{const n=(0,E.isNumber)(g.followRedirects)?g.followRedirects:3;if(a.statusCode&&a.statusCode>=300&&a.statusCode<400&&n>0&&a.headers.location)this._request({...g,url:a.headers.location,followRedirects:n-1},I).then(y,u);else{let o=a;a.headers["content-encoding"]==="gzip"&&(o=a.pipe((0,b.createGunzip)())),y({res:a,stream:(0,L.streamToBufferReadableStream)(o)})}}),h.on("error",u),g.timeout&&h.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&h.write(g.data),h.end(),I.onCancellationRequested(()=>{h.abort(),u((0,k.canceled)())})})}async resolveProxy(g){}};p=ue([ee(0,r.IConfigurationService),ee(1,f.INativeEnvironmentService),ee(2,t.ILogService)],p),e.RequestService=p}),define(J[224],Z([0,1,14,223]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(E){return v.net.request}class M extends L.RequestService{request(r,f){return super.request({...r||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(J[225],Z([0,1,14,9,4,2,10,13,84,23,22,6,48,55,60]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(y,u,h,s,c,i,a){super();this.machineId=y,this.userEnv=u,this.environmentMainService=h,this.lifecycleMainService=s,this.logService=c,this.themeMainService=i,this.protocolMainService=a,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),v.ipcMain.on("vscode:createSharedProcessMessageChannel",async(y,u)=>this.onWindowConnection(y,u))}async onWindowConnection(y,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(y.sender.isDestroyed())return h.close();y.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[h])}onWillShutdown(){const y=this.window;!y||(!y.isDestroyed()&&!y.webContents.isDestroyed()&&y.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(y.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{y.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(y=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),y()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(y=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),y()}))})()),this._whenIpcReady}createWindow(){const y=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${y.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),y.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:b.default}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",K).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=y=>{this.logService.trace("SharedProcess#close prevented"),y.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(y,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(y,u,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:u}})))}async connect(){await this.whenIpcReady;const y=(0,r.assertIsDefined)(this.window);return(0,f.connect)(y)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=ue([ee(2,w.IEnvironmentMainService),ee(3,t.ILifecycleMainService),ee(4,P.ILogService),ee(5,d.IThemeMainService),ee(6,p.IProtocolMainService)],g),e.SharedProcess=g}),define(J[226],Z([0,1,9,18,8,13,7,23,20,6]),function(K,e,v,L,k,M,E,r,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(p,d,g){this.storagePath=p,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,d){const g=this.storage[p];return(0,M.isUndefinedOrNull)(g)?d:g}setItem(p,d){this.setItems([{key:p,data:d}])}setItems(p){let d=!1;for(const{key:g,data:I}of p)this.storage[g]!==I&&((0,M.isUndefinedOrNull)(I)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=I,d=!0));d&&this.save()}removeItem(p){(0,M.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let P=class yt{constructor(p,d,g){this.fileStorage=new t(E.URI.file((0,k.join)(p.userDataPath,yt.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(p,d){return this.fileStorage.getItem(p,d)}setItem(p,d){this.fileStorage.setItem(p,d)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=ue([ee(0,r.IEnvironmentMainService),ee(1,w.ILogService),ee(2,f.IFileService)],P),e.StateMainService=P}),define(J[76],Z([0,1,9,24,4,16,23,22,6,21,50,42]),function(K,e,v,L,k,M,E,r,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(d,g,I){return`${I.updateUrl}/api/update/${d}/${g}/${I.commit}`}e.createUpdateURL=b;let p=class{constructor(g,I,y,u,h,s){this.lifecycleMainService=g,this.configurationService=I,this.environmentMainService=y,this.requestService=u,this.logService=h,this.productService=s,this._state=P.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),I=this.getProductQuality(g);if(!I){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(I),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,v.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=ue([ee(0,r.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,E.IEnvironmentMainService),ee(3,t.IRequestService),ee(4,f.ILogService),ee(5,w.IProductService)],p),e.AbstractUpdateService=p}),define(J[227],Z([0,1,14,46,4,2,16,23,22,6,21,50,34,42,76]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends d.AbstractUpdateService{constructor(y,u,h,s,c,i,a){super(y,u,s,c,i,a);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(y,u)=>u)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(y,u,h)=>({url:u,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(y,u,h,s)=>({releaseNotes:u,version:h,productVersion:h,date:s}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(y){this.logService.error("UpdateService error:",y);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?y:void 0;this.setState(p.State.Idle(1,h))}buildUpdateFeedUrl(y){let u;this.productService.darwinUniversalAssetId?u=this.productService.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(u,y,this.productService);try{v.autoUpdater.setFeedURL({url:h})}catch(s){this.logService.error("Failed to set update feed URL",s);return}return h}doCheckForUpdates(y){this.setState(p.State.CheckingForUpdates(y)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(y){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(y))}onUpdateDownloaded(y){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:y.version}),this.setState(p.State.Ready(y)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([L.memoize],g.prototype,"onRawError",null),ue([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateAvailable",null),ue([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ue([ee(0,f.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,b.ITelemetryService),ee(3,r.IEnvironmentMainService),ee(4,P.IRequestService),ee(5,w.ILogService),ee(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(J[228],Z([0,1,41,30,9,4,8,23,22,6,34,42]),function(K,e,v,L,k,M,E,r,f,w,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(g,I,y){if(this.lifecycleMainService=g,this.logService=y,this._state=P.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,I.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};b=ue([ee(0,f.ILifecycleMainService),ee(1,r.IEnvironmentMainService),ee(2,w.ILogService)],b);let p=class extends b{constructor(g,I,y,u,h,s){super(y,u,h);this.snap=g,this.snapRevision=I,this.telemetryService=s;const c=(0,L.watch)(E.dirname(this.snap)),i=M.Event.fromNodeEventEmitter(c,"change",(l,m)=>m),a=M.Event.filter(i,l=>l==="current"),o=M.Event.debounce(a,(l,m)=>m,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{o.dispose(),c.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+E.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((y,u)=>(0,L.realpath)(`${E.dirname(this.snap)}/current`,(h,s)=>h?u(h):y(s))),I=E.basename(g);return this.snapRevision!==I}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ue([ee(2,f.ILifecycleMainService),ee(3,r.IEnvironmentMainService),ee(4,w.ILogService),ee(5,t.ITelemetryService)],p),e.SnapUpdateService=p}),define(J[45],Z([0,1,14,30,4,40,33,2,10,8,3,15,13,19,153,51,52,23,5,6,21,99,27,100]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,u.createDecorator)("workspacesManagementMainService");let n=class extends r.Disposable{constructor(l,m,S,D,A){super();this.environmentMainService=l,this.logService=m,this.backupMainService=S,this.dialogMainService=D,this.productService=A,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,m=>(0,L.readFileSync)(m,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,m=>p.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(l,m){if(!!this.isWorkspacePath(l)&&l.scheme===f.Schemas.file)try{const S=m(l.fsPath);return S instanceof Promise?S.then(D=>this.doResolveWorkspace(l,D),D=>{}):this.doResolveWorkspace(l,S)}catch{return}}isWorkspacePath(l){return(0,i.isUntitledWorkspace)(l,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,m){try{const S=this.doParseStoredWorkspace(l,m),D=(0,a.getWorkspaceIdentifier)(l);return{id:D.id,configPath:D.configPath,folders:(0,i.toWorkspaceFolders)(S.folders,D.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:S.remoteAuthority,transient:S.transient}}catch(S){this.logService.warn(S.toString())}}doParseStoredWorkspace(l,m){const S=(0,M.parse)(m);if(S&&Array.isArray(S.folders))S.folders=S.folders.filter(D=>(0,i.isStoredWorkspaceFolder)(D));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return S}async createUntitledWorkspace(l,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(l,m),A=S.configPath.fsPath;return await p.Promises.mkdir((0,w.dirname)(A),{recursive:!0}),await p.Promises.writeFile(A,JSON.stringify(D,null,"	")),S}createUntitledWorkspaceSync(l,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(l,m),A=S.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(A),{recursive:!0}),(0,p.writeFileSync)(A,JSON.stringify(D,null,"	")),S}newUntitledWorkspace(l=[],m){const S=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,P.joinPath)(this.untitledWorkspacesHome,S),A=(0,P.joinPath)(D,i.UNTITLED_WORKSPACE_NAME),W=[];for(const C of l)W.push((0,i.getStoredWorkspaceFolder)(C.uri,!0,C.name,D,!t.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(A),storedWorkspace:{folders:W,remoteAuthority:m}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,i.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const m=(0,P.originalFSPath)(l.configPath);try{(0,p.rimrafSync)((0,w.dirname)(m));const S=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(S)&&(0,p.writeFileSync)((0,w.join)(S,"obsolete"),"")}catch(S){this.logService.warn(`Unable to delete untitled workspace ${m} (${S}).`)}}getUntitledWorkspacesSync(){const l=[];try{const m=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(S=>(0,P.joinPath)(this.untitledWorkspacesHome,S,i.UNTITLED_WORKSPACE_NAME));for(const S of m){const D=(0,a.getWorkspaceIdentifier)(S),A=this.resolveLocalWorkspaceSync(S);A?l.push({workspace:D,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return l}async enterWorkspace(l,m,S){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,m,S))return;const A=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(S));if(!!A)return this._onDidEnterWorkspace.fire({window:l,workspace:A.workspace}),A}async isValidTargetWorkspacePath(l,m,S){if(!S)return!0;if((0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,S))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(m,S)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,P.basename)(S)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,b.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,m){if(!l.config)return;l.focus();let S;return l.config.extensionDevelopmentPath||(S=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=m,l.config.backupPath=S,{workspace:m,backupPath:S}}};n=ue([ee(0,y.IEnvironmentMainService),ee(1,h.ILogService),ee(2,g.IBackupMainService),ee(3,I.IDialogMainService),ee(4,s.IProductService)],n),e.WorkspacesManagementMainService=n}),define(J[101],Z([0,1,14,31,24,3,13,7,19,16,54,5,6,97,36,27,45]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let y=class{constructor(h,s,c,i,a){this.logService=h,this.windowsMainService=s,this.urlService=c,this.workspacesManagementMainService=i,this.configurationService=a}async start(h,s){this.logService.trace("Received data from other instance: ",h,s),M.isMacintosh&&v.app.focus({steal:!0});const c=this.parseOpenUrl(h);if(c.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:a,url:n}of c)this.urlService.open(a,{originalUrl:n})})}else return this.startOpenWindow(h,s)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(s=>{try{return{uri:r.URI.parse(s),url:s}}catch(c){return null}})):[]}async startOpenWindow(h,s){const c=(0,t.isLaunchedFromCli)(s)?0:4;let i=[];const a=h.wait&&h.waitMarkerFilePath?r.URI.file(h.waitMarkerFilePath):void 0,n=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:c,cli:h,userEnv:s,waitMarkerFileURI:a,remoteAuthority:n});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let o=!1;if(h["new-window"]||h["unity-launch"])o=!0;else if(h["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!M.isMacintosh}if(o)i=this.windowsMainService.open({context:c,cli:h,userEnv:s,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:a,remoteAuthority:n});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),i=[l]):i=this.windowsMainService.open({context:c,cli:h,forceEmpty:!0,remoteAuthority:n})}}else i=this.windowsMainService.open({context:c,cli:h,userEnv:s,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:a,gotoLineMode:h.goto,remoteAuthority:n});if(a&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return v.BrowserWindow.getAllWindows().forEach(s=>{const c=this.windowsMainService.getWindowById(s.id);c?h.push(this.codeWindowToInfo(c)):h.push(this.browserWindowToInfo(s))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const s=this.windowsMainService.getWindows();return(await Promise.all(s.map(i=>new Promise(a=>{const n=i.remoteAuthority;if(n){const o=`vscode:getDiagnosticInfoResponse${i.id}`,l={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:o,args:l}),v.ipcMain.once(o,(m,S)=>{S||a({hostName:n,errorMessage:`Unable to resolve connection to '${n}'.`}),a(S)}),setTimeout(()=>{a({hostName:n,errorMessage:`Fetching remote diagnostics for '${n}' timed out.`})},5e3)}else a(void 0)})))).filter(i=>!!i)}getFolderURIs(h){const s=[],c=h.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(c))s.push(c.uri);else if((0,g.isWorkspaceIdentifier)(c)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);i&&i.folders.forEach(n=>{s.push(n.uri)})}return s}codeWindowToInfo(h){const s=this.getFolderURIs(h),c=(0,E.assertIsDefined)(h.win);return this.browserWindowToInfo(c,s,h.remoteAuthority)}browserWindowToInfo(h,s=[],c){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:s,remoteAuthority:c}}};y=ue([ee(0,b.ILogService),ee(1,d.IWindowsMainService),ee(2,p.IURLService),ee(3,I.IWorkspacesManagementMainService),ee(4,w.IConfigurationService)],y),e.LaunchMainService=y}),define(J[53],Z([0,1,41,14,26,114,46,4,33,2,10,8,3,7,81,66,19,145,52,23,5,22,6,21,34,60,36,27,45]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c,i,a,n,o,l,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,s.createDecorator)("nativeHostMainService");let D=class ct extends w.Disposable{constructor(W,C,X,te,oe,Y,Q,_,q,z){super();this.sharedProcess=W,this.windowsMainService=C,this.dialogMainService=X,this.lifecycleMainService=te,this.environmentMainService=oe,this.telemetryService=Y,this.logService=Q,this.productService=_,this.themeMainService=q,this.workspacesManagementMainService=z,this.onDidOpenWindow=r.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidMaximizeWindow=r.Event.filter(r.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=r.Event.filter(r.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=r.Event.filter(r.Event.fromNodeEventEmitter(L.app,"browser-window-blur",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=r.Event.any(r.Event.map(r.Event.filter(r.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),r.Event.filter(r.Event.fromNodeEventEmitter(L.app,"browser-window-focus",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=r.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new r.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new r.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=r.Event.debounce(r.Event.any(r.Event.filter(r.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",($,H,U)=>U),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),r.Event.fromNodeEventEmitter(L.screen,"display-added"),r.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(W){return this.windowsMainService.getWindowCount()}async getActiveWindowId(W){const C=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(W,C,X){return Array.isArray(C)?this.doOpenWindow(W,C,X):this.doOpenEmptyWindow(W,C)}async doOpenWindow(W,C,X=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:W,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:X.forceNewWindow,forceReuseWindow:X.forceReuseWindow,preferNewWindow:X.preferNewWindow,diffMode:X.diffMode,addMode:X.addMode,gotoLineMode:X.gotoLineMode,noRecentEntry:X.noRecentEntry,waitMarkerFileURI:X.waitMarkerFileURI,remoteAuthority:X.remoteAuthority||void 0})}async doOpenEmptyWindow(W,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:W},C)}async toggleFullScreen(W){const C=this.windowById(W);C&&C.toggleFullScreen()}async handleTitleDoubleClick(W){const C=this.windowById(W);C&&C.handleTitleDoubleClick()}async isMaximized(W){const C=this.windowById(W);return C?.win?C.win.isMaximized():!1}async maximizeWindow(W){const C=this.windowById(W);C?.win&&C.win.maximize()}async unmaximizeWindow(W){const C=this.windowById(W);C?.win&&C.win.unmaximize()}async minimizeWindow(W){const C=this.windowById(W);C?.win&&C.win.minimize()}async focusWindow(W,C){C&&typeof C.windowId=="number"&&(W=C.windowId);const X=this.windowById(W);X&&X.focus({force:C?.force??!1})}async setMinimumSize(W,C,X){const te=this.windowById(W);if(te?.win){const[oe,Y]=te.win.getSize(),[Q,_]=te.win.getMinimumSize(),[q,z]=[C??Q,X??_],[$,H]=[Math.max(oe,q),Math.max(Y,z)];(Q!==q||_!==z)&&te.win.setMinimumSize(q,z),(oe!==$||Y!==H)&&te.win.setSize($,H)}}async saveWindowSplash(W,C){this.themeMainService.saveWindowSplash(W,C)}async installShellCommand(W){const{source:C,target:X}=await this.getShellCommandLink();try{const{symbolicLink:te}=await I.SymlinkSupport.stat(C);if(te&&!te.dangling){const oe=await(0,d.realpath)(C);if(X===oe)return}await I.Promises.unlink(C)}catch(te){if(te.code!=="ENOENT")throw te}try{await I.Promises.symlink(X,C)}catch(te){if(te.code!=="EACCES"&&te.code!=="ENOENT")throw te;const{response:oe}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(oe===0)try{const Y=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${X}' '${C}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(Y)}catch(Y){throw new Error((0,y.localize)(3,null,C))}}}async uninstallShellCommand(W){const{source:C}=await this.getShellCommandLink();try{await I.Promises.unlink(C)}catch(X){switch(X.code){case"EACCES":const{response:te}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(te===0)try{const oe=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(oe)}catch(oe){throw new Error((0,y.localize)(7,null,C))}break;case"ENOENT":break;default:throw X}}}async getShellCommandLink(){const W=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await I.Promises.exists(W))throw new Error((0,y.localize)(8,null,W));return{source:C,target:W}}async showMessageBox(W,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(W))}async showSaveDialog(W,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(W))}async showOpenDialog(W,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(W))}toBrowserWindow(W){const C=this.windowById(W);if(C?.win)return C.win}async pickFileFolderAndOpen(W,C){const X=await this.dialogMainService.pickFileFolder(C);X&&(this.sendPickerTelemetry(X,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(X.map(async te=>await I.SymlinkSupport.existsDirectory(te)?{folderUri:p.URI.file(te)}:{fileUri:p.URI.file(te)})),C,W))}async pickFolderAndOpen(W,C){const X=await this.dialogMainService.pickFolder(C);X&&(this.sendPickerTelemetry(X,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(X.map(te=>({folderUri:p.URI.file(te)})),C,W))}async pickFileAndOpen(W,C){const X=await this.dialogMainService.pickFile(C);X&&(this.sendPickerTelemetry(X,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(X.map(te=>({fileUri:p.URI.file(te)})),C,W))}async pickWorkspaceAndOpen(W,C){const X=await this.dialogMainService.pickWorkspace(C);X&&(this.sendPickerTelemetry(X,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(X.map(te=>({workspaceUri:p.URI.file(te)})),C,W))}doOpenPicked(W,C,X){this.windowsMainService.open({context:3,contextWindowId:X,cli:this.environmentMainService.args,urisToOpen:W,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(W,C,X){const te=W?W.length:0;this.telemetryService.publicLog(C,{...X,outcome:te?"success":"canceled",numberOfPaths:te})}async showItemInFolder(W,C){L.shell.showItemInFolder(C)}async setRepresentedFilename(W,C){const X=this.windowById(W);X&&X.setRepresentedFilename(C)}async setDocumentEdited(W,C){const X=this.windowById(W);X&&X.setDocumentEdited(C)}async openExternal(W,C){return b.isLinuxSnap?this.safeSnapOpenExternal(C):L.shell.openExternal(C),!0}safeSnapOpenExternal(W){const C=process.env.GDK_PIXBUF_MODULE_FILE,X=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(W),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=X}moveItemToTrash(W,C){return L.shell.trashItem(C)}async isAdmin(){let W;return b.isWindows?W=(await new Promise((C,X)=>{K(["native-is-elevated"],C,X)}))():W=process.getuid()===0,W}async writeElevated(W,C,X,te){const oe=await new Promise((Y,Q)=>{K(["sudo-prompt"],Y,Q)});return new Promise((Y,Q)=>{const _=[`"${this.cliPath}"`];te?.unlock&&_.push("--file-chmod"),_.push("--file-write",`"${C.fsPath}"`,`"${X.fsPath}"`);const q={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};oe.exec(_.join(" "),q,(z,$,H)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),z?Q(z):Y(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(W,C,X){process.kill(C,X)}async readClipboardText(W,C){return L.clipboard.readText(C)}async writeClipboardText(W,C,X){return L.clipboard.writeText(C,X)}async readClipboardFindText(W){return L.clipboard.readFindText()}async writeClipboardFindText(W,C){return L.clipboard.writeFindText(C)}async writeClipboardBuffer(W,C,X,te){return L.clipboard.writeBuffer(C,Buffer.from(X),te)}async readClipboardBuffer(W,C){return L.clipboard.readBuffer(C)}async hasClipboard(W,C,X){return L.clipboard.has(C,X)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,C){const X=this.windowById(W);X&&X.updateTouchBar(C)}async notifyReady(W){const C=this.windowById(W);C&&C.setReady()}async relaunch(W,C){return this.lifecycleMainService.relaunch(C)}async reload(W,C){const X=this.windowById(W);if(X){if((0,m.isWorkspaceIdentifier)(X.openedWorkspace)){const te=X.openedWorkspace.configPath;if(te.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(te))?.transient)return this.openWindow(X.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(X,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(W){this.closeWindowById(W,W)}async closeWindowById(W,C){const X=this.windowById(C);if(X?.win)return X.win.close()}async quit(W){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(W,C){await this.lifecycleMainService.kill(C)}async resolveProxy(W,C){const te=this.windowById(W)?.win?.webContents?.session;if(te)return te.resolveProxy(C)}async openDevTools(W,C){const X=this.windowById(W);X?.win&&X.win.webContents.openDevTools(C)}async toggleDevTools(W){const C=this.windowById(W);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(W,C){const X=this.windowById(W);X?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&X.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(W,C,X,te){if(!b.isWindows)return;const oe=await new Promise((Y,Q)=>{K(["vscode-windows-registry"],Y,Q)});try{return oe.GetStringRegKey(C,X,te)}catch{return}}async getPassword(W,C,X){const te=await this.withKeytar(),oe=await te.getPassword(C,X);if(oe)try{let{content:Y,hasNextChunk:Q}=JSON.parse(oe);if(!Y||!Q)return oe;let _=1;for(;Q;){const q=await te.getPassword(C,`${X}-${_}`),z=JSON.parse(q);Y+=z.content,Q=z.hasNextChunk,_++}return Y}catch{return oe}return oe}async setPassword(W,C,X,te){const oe=await this.withKeytar(),Y=3,Q=async(_,q,z)=>{let $=0,H;for(;$<Y;)try{await oe.setPassword(_,q,z);return}catch(U){H=U,this.logService.warn("Error attempting to set a password: ",U),$++,await new Promise(j=>setTimeout(j,200))}throw H};if(b.isWindows&&te.length>ct.MAX_PASSWORD_LENGTH){let _=0,q=0,z=!0;for(;z;){const $=te.substring(_,_+ct.PASSWORD_CHUNK_SIZE);_+=ct.PASSWORD_CHUNK_SIZE,z=te.length-_>0;const H={content:$,hasNextChunk:z};await Q(C,q?`${X}-${q}`:X,JSON.stringify(H)),q++}}else await Q(C,X,te);this._onDidChangePassword.fire({service:C,account:X})}async deletePassword(W,C,X){const oe=await(await this.withKeytar()).deletePassword(C,X);return oe&&this._onDidChangePassword.fire({service:C,account:X}),oe}async findPassword(W,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(W,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((W,C)=>{K(["keytar"],W,C)})}windowById(W){if(typeof W=="number")return this.windowsMainService.getWindowById(W)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,ue([E.memoize],D.prototype,"cliPath",null),D=ue([ee(1,l.IWindowsMainService),ee(2,u.IDialogMainService),ee(3,c.ILifecycleMainService),ee(4,h.IEnvironmentMainService),ee(5,n.ITelemetryService),ee(6,i.ILogService),ee(7,a.IProductService),ee(8,o.IThemeMainService),ee(9,S.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(J[229],Z([0,1,14,24,4,79,2,28,88,6,53,21,36]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let d=class extends E.Disposable{constructor(I,y,u,h,s){super();this.logService=I,this.windowsMainService=y,this.nativeHostMainService=u,this.encryptionMainService=h,this.productService=s,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const I=k.Event.fromNodeEventEmitter(v.app,"login",(y,u,h,s,c)=>({event:y,webContents:u,req:h,authInfo:s,callback:c}));this._register(I(this.onLogin,this))}async onLogin({event:I,authInfo:y,req:u,callback:h}){if(!y.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&u.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}I.preventDefault();let s;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),s=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(y);try{s=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(s?.username,s?.password)}async resolveProxyCredentials(I){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.doResolveProxyCredentials(I);if(y)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(I){this.logService.trace("auth#doResolveProxyCredentials - enter",I);const y=String((0,M.hash)({scheme:I.scheme,host:I.host,port:I.port}));let u,h;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y);if(a){const n=JSON.parse(await this.encryptionMainService.decrypt(a));u=n.username,h=n.password}}catch(a){this.logService.error(a)}if(this.state!==p.StoredCredentialsUsed&&typeof u=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:u,password:h};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const c={authInfo:I,username:this.sessionCredentials?.username??u,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,r.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,c),this.state=p.LoginDialogShown;const i=await new Promise(a=>{const n=async(o,l,m)=>{if(l===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),s.win?.webContents.off("ipc-message",n),m){const S={username:m.username,password:m.password};try{if(m.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(S));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,y)}catch(D){this.logService.error(D)}a({username:S.username,password:S.password})}else a(void 0)};s.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=i,i}};d=ue([ee(0,w.ILogService),ee(1,b.IWindowsMainService),ee(2,t.INativeHostMainService),ee(3,f.IEncryptionMainService),ee(4,P.IProductService)],d),e.ProxyAuthHandler=d}),define(J[230],Z([0,1,14,26,33,2,10,3,82,143,70,52,23,5,101,6,53,48,21,55,61]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let c=class St{constructor(a,n,o,l,m,S,D,A,W){this.userEnv=a,this.environmentMainService=n,this.launchMainService=o,this.logService=l,this.diagnosticsService=m,this.dialogMainService=S,this.nativeHostMainService=D,this.protocolMainService=A,this.productService=W,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[n,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(n,o);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),v.ipcMain.on("vscode:listProcesses",async a=>{const n=[];try{const o=await this.launchMainService.getMainProcessId();n.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(o)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,t.isRemoteDiagnosticError)(m)?n.push({name:m.hostName,rootProcess:m}):m.processes&&n.push({name:m.hostName,rootProcess:m.processes})})}catch(o){this.logService.error(`Listing processes failed: ${o}`)}this.safeSend(a,"vscode:listProcessesResponse",n)}),v.ipcMain.on("vscode:issueReporterClipboard",async a=>{const n={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const o=await this.dialogMainService.showMessageBox(n,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",o.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const n=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",n)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(a,n)=>{const{id:o,from:l,args:m}=n;let S;switch(l){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}S&&S.webContents.send("vscode:runAction",{id:o,from:l,args:m})}),v.ipcMain.on("vscode:openExternal",(a,n)=>{this.nativeHostMainService.openExternal(void 0,n)}),v.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async a=>{const n=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",n.windows)})}safeSend(a,n,...o){a.sender.isDestroyed()||a.sender.send(n,...o)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const n=new M.DisposableStore,o=n.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,o,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:y.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",K).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,n.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,n.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const n=new M.DisposableStore,o=n.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,o,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:y.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",K).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,n.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,n.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,n,o){const l=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:o.title,backgroundColor:o.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,s.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,n)}getWindowPosition(a,n,o){let l;const m=v.screen.getAllDisplays();if(m.length===1)l=m[0];else{if(r.isMacintosh){const A=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(A)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||m[0])}const S={width:n,height:o},D=l.bounds;return S.x=D.x+D.width/2-S.width/2,S.y=D.y+D.height/2-S.height/2,D.width>0&&D.height>0&&(S.x<D.x&&(S.x=D.x),S.y<D.y&&(S.y=D.y),S.x>D.x+D.width&&(S.x=D.x),S.y>D.y+D.height&&(S.y=D.y),S.width>D.width&&(S.width=D.width),S.height>D.height&&(S.height=D.height)),S}async getPerformanceInfo(){try{const[a,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,n)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ue([ee(1,b.IEnvironmentMainService),ee(2,d.ILaunchMainService),ee(3,g.ILogService),ee(4,t.IDiagnosticsService),ee(5,P.IDialogMainService),ee(6,I.INativeHostMainService),ee(7,h.IProtocolMainService),ee(8,u.IProductService)],c),e.IssueMainService=c}),define(J[231],Z([0,1,24,16,23,22,6,53,21,50,34,42,76]),function(K,e,v,L,k,M,E,r,f,w,t,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends b.AbstractUpdateService{constructor(g,I,y,u,h,s,c,i){super(g,I,u,h,s,i);this.telemetryService=y,this.nativeHostMainService=c}buildUpdateFeedUrl(g){return(0,b.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(P.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},v.CancellationToken.None).then(w.asJson).then(I=>{!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(I))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const y=g?I.message||I:void 0;this.setState(P.State.Idle(1,y))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(P.State.Idle(1))}};p=ue([ee(0,M.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,t.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,w.IRequestService),ee(5,E.ILogService),ee(6,r.INativeHostMainService),ee(7,f.IProductService)],p),e.LinuxUpdateService=p}),define(J[232],Z([0,1,41,30,26,9,24,46,8,7,112,19,16,23,20,22,6,53,21,50,34,42,76]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(m,S=1e3){for(;!m();)await(0,M.timeout)(S)}let n;function o(){return typeof n=="undefined"&&(n=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),n}let l=class extends i.AbstractUpdateService{constructor(S,D,A,W,C,X,te,oe,Y){super(S,D,W,C,X,Y);this.telemetryService=A,this.fileService=te,this.nativeHostMainService=oe}get cachePath(){const S=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(S,{recursive:!0}).then(()=>S)}initialize(){super.initialize(),o()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(S){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),o()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,i.createUpdateURL)(D,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(c.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},E.CancellationToken.None).then(h.asJson).then(D=>{const A=o();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(c.State.Idle(A)),Promise.resolve(null)):A===1?(this.setState(c.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(c.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(W=>P.Promises.exists(W).then(C=>{if(C)return Promise.resolve(W);const X=D.url,te=D.hash,oe=`${W}.tmp`;return this.requestService.request({url:X},E.CancellationToken.None).then(Y=>this.fileService.writeFile(w.URI.file(oe),Y.stream)).then(te?()=>(0,t.checksum)(oe,D.hash):()=>{}).then(()=>P.Promises.rename(oe,W)).then(()=>W)})).then(W=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:W},C&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(D)):this.setState(c.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const A=S?D.message||D:void 0;this.setState(c.State.Idle(o(),A))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(c.State.Idle(o()))}async getUpdatePackagePath(S){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const D=S?X=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(X):()=>!0,A=await this.cachePath,C=(await P.Promises.readdir(A)).filter(D).map(async X=>{try{await P.Promises.unlink(f.join(A,X))}catch(te){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(c.State.Updating(S));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(o()))});const W=`${this.productService.win32MutexName}-ready`,C=await new Promise((X,te)=>{K(["windows-mutex"],X,te)});a(()=>C.isActive(W)).then(()=>this.setState(c.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}};ue([r.memoize],l.prototype,"cachePath",null),l=ue([ee(0,g.ILifecycleMainService),ee(1,b.IConfigurationService),ee(2,s.ITelemetryService),ee(3,p.IEnvironmentMainService),ee(4,h.IRequestService),ee(5,I.ILogService),ee(6,d.IFileService),ee(7,y.INativeHostMainService),ee(8,u.IProductService)],l),e.Win32UpdateService=l}),define(J[233],Z([0,1,14,9,24,4,33,2,10,8,72,3,7,149,51,16,52,23,54,201,20,22,6,21,55,98,34,203,60,61,36,27,45]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c,i,a,n,o,l,m,S,D,A,W,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(X||(X={}));let te=class extends r.Disposable{constructor(Y,Q,_,q,z,$,H,U,j,F,R,T,O,B){super();this.logService=Q,this.environmentMainService=_,this.fileService=q,this.configurationService=$,this.themeMainService=H,this.workspacesManagementMainService=U,this.backupMainService=j,this.telemetryService=F,this.dialogMainService=R,this.lifecycleMainService=T,this.productService=O,this.protocolMainService=B,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[N,V]=this.restoreWindowState(Y.state);this.windowState=N,this.logService.trace("window#ctor: using window state",N);const x=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),ne={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!x,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(ie?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};P.isLinux?ne.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):P.isWindows&&!this.environmentMainService.isBuilt&&(ne.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),P.isMacintosh&&!this.useNativeFullScreen()&&(ne.fullscreenable=!1),P.isMacintosh&&(ne.acceptFirstMouse=!0,ie?.clickThroughInactive===!1&&(ne.acceptFirstMouse=!1));const ce=P.isMacintosh&&ie?.nativeTabs===!0;ce&&(ne.tabbingIdentifier=this.productService.nameShort);const se=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(se&&(ne.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,P.isMacintosh||(ne.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(ne),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),P.isMacintosh&&se&&this._win.setSheetOffset(22),P.isMacintosh&&V&&(!ce||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ae=>typeof ae=="number")){const ae=this.windowState;this._win.setBounds({width:ae.width,height:ae.height,x:ae.x,y:ae.y})}x&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:N=>z.globalStorage.get(N),store:(N,V)=>z.globalStorage.set(N,V)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(Y){P.isMacintosh?this._win.setRepresentedFilename(Y):this.representedFilename=Y}getRepresentedFilename(){return P.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(Y){P.isMacintosh&&this._win.setDocumentEdited(Y),this.documentEdited=Y}isDocumentEdited(){return P.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(Y){P.isMacintosh&&Y?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(Y=>{if(this.isReady)return Y(this);this.whenReadyCallbacks.push(Y)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(Y=>{function Q(){_.dispose(),q.dispose(),Y()}const _=this.onDidClose(()=>Q()),q=this.onWillLoad(()=>Q())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(z,$,H)=>this.onWindowError(3,{reason:H,exitCode:$})),this._win.webContents.on("will-prevent-unload",z=>{z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const Y=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Q=z=>{for(let $=z;$;$=$.parent)if($.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},_=z=>z.resourceType==="xhr"||Q(z.frame);this._win.webContents.session.webRequest.onBeforeRequest((z,$)=>{const H=b.URI.parse(z.url);return H.path.endsWith(".svg")&&!(Y.has(H.scheme)||H.path.includes(f.Schemas.vscodeRemoteResource))?$({cancel:!_(z)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,$)=>{const H=z.responseHeaders,U=H["content-type"]||H["Content-Type"];if(U&&Array.isArray(U)){const j=b.URI.parse(z.url);if(j.path.endsWith(".svg")&&Y.has(j.scheme))return H["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:H});if(!j.path.includes(f.Schemas.vscodeRemoteResource)&&U.some(F=>F.toLowerCase().includes("image/svg")))return $({cancel:!_(z)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(z,$)=>{const H=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,H)})})}async onWindowError(Y,Q){switch(Y){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:Y,reason:Q?.reason,code:Q?.exitCode}),Y){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(Y===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const _=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,p.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,p.localize)(2,null))],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;_.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):_.response===2&&this.destroyWindow()}else if(Y===2){let _;Q?_=(0,p.localize)(6,null,Q.reason,Q.exitCode??"<unknown>"):_=(0,p.localize)(5,null);const q=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,p.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,p.localize)(8,null))],message:_,detail:(0,p.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;q.response===0?this.reload():q.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(Y){this.openedWorkspace?.id===Y.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const Y=this.getMenuBarVisibility();Y!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=Y,this.setMenuBarVisibility(Y));let Q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Q?.endsWith("/")&&(Q=Q.substr(0,Q.length-1));const _=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Q||"").indexOf("@")===-1&&(Q!==this.currentHttpProxy||_!==this.currentNoProxy)){this.currentHttpProxy=Q,this.currentNoProxy=_;const q=Q||"",z=_?`${_},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(Y){P.isMacintosh&&Y.win&&this._win.addTabbedWindow(Y.win)}load(Y,Q=Object.create(null)){this.isDocumentEdited()&&(!Q.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(Y,Q),this.readyState===0?this.currentConfig=Y:(this.pendingLoadConfig=Y,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",K).toString(!0));const _=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:Y.workspace,reason:Q.isReload?3:_?2:1})}updateConfiguration(Y,Q){const _=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(_){const q=(0,u.isLaunchedFromCli)(_)&&!(0,u.isLaunchedFromCli)(Y.userEnv),z=this.isExtensionDevelopmentHost;(q||z)&&(Y.userEnv={..._,...Y.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(Y.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Q.disableExtensions!==void 0&&(Y["disable-extensions"]=Q.disableExtensions),Y.fullscreen=this.isFullScreen,Y.maximized=this._win.isMaximized(),Y.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),Y.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(Y)}async reload(Y){const Q=Object.assign({},this.currentConfig);Q.workspace=await this.validateWorkspaceBeforeReload(Q),delete Q.filesToOpenOrCreate,delete Q.filesToDiff,delete Q.filesToWait,this.isExtensionDevelopmentHost&&Y&&(Q.verbose=Y.verbose,Q.debugId=Y.debugId,Q["inspect-extensions"]=Y["inspect-extensions"],Q["inspect-brk-extensions"]=Y["inspect-brk-extensions"],Q["extensions-dir"]=Y["extensions-dir"]),Q.isInitialStartup=!1,this.load(Q,{isReload:!0,disableExtensions:Y?.["disable-extensions"]})}async validateWorkspaceBeforeReload(Y){if((0,W.isWorkspaceIdentifier)(Y.workspace)){const Q=Y.workspace.configPath;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(Y.workspace)){const Q=Y.workspace.uri;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}return Y.workspace}serializeWindowState(){if(!this._win)return(0,A.defaultWindowState)();if(this.isFullScreen){let _;try{_=v.screen.getDisplayMatching(this.getBounds())}catch($){}const q=(0,A.defaultWindowState)();return{mode:3,display:_?_.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const Y=Object.create(null);let Q;if(!P.isMacintosh&&this._win.isMaximized()?Q=0:Q=1,Q===0?Y.mode=0:Y.mode=1,Q===1||Q===0){let _;Q===1?_=this.getBounds():_=this._win.getNormalBounds(),Y.x=_.x,Y.y=_.y,Y.width=_.width,Y.height=_.height}return Y}restoreWindowState(Y){(0,t.mark)("code/willRestoreCodeWindowState");let Q=!1;if(Y)try{const _=v.screen.getAllDisplays();Q=_.length>1,Y=this.validateWindowState(Y,_)}catch(_){this.logService.warn(`Unexpected error validating window state: ${_}
${_.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[Y||(0,A.defaultWindowState)(),Q]}validateWindowState(Y,Q){if(this.logService.trace(`window#validateWindowState: validating window state on ${Q.length} display(s)`,Y),typeof Y.x!="number"||typeof Y.y!="number"||typeof Y.width!="number"||typeof Y.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(Y.width<=0||Y.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Q.length===1){const z=this.getWorkingArea(Q[0]);if(z){let $=function(){!Y||typeof Y.x!="number"||typeof Y.y!="number"||!z||(Y.x<z.x&&(Y.x=z.x),Y.y<z.y&&(Y.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),$(),Y.width>z.width&&(Y.width=z.width),Y.height>z.height&&(Y.height=z.height),Y.x>z.x+z.width-128&&(Y.x=z.x+z.width-Y.width),Y.y>z.y+z.height-128&&(Y.y=z.y+z.height-Y.height),$()}return Y}if(Y.display&&Y.mode===3){const z=Q.find($=>$.id===Y.display);if(z&&typeof z.bounds?.x=="number"&&typeof z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,A.defaultWindowState)(3);return $.x=z.bounds.x,$.y=z.bounds.y,$}}let _,q;try{_=v.screen.getDisplayMatching({x:Y.x,y:Y.y,width:Y.width,height:Y.height}),q=this.getWorkingArea(_)}catch(z){}if(_&&q&&Y.x+Y.width>q.x&&Y.y+Y.height>q.y&&Y.x<q.x+q.width&&Y.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),Y}getWorkingArea(Y){if(Y.workArea.width>0&&Y.workArea.height>0)return Y.workArea;if(Y.bounds.width>0&&Y.bounds.height>0)return Y.bounds}getBounds(){const[Y,Q]=this._win.getPosition(),[_,q]=this._win.getSize();return{x:Y,y:Q,width:_,height:q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(Y){this.useNativeFullScreen()?this.setNativeFullScreen(Y):this.setSimpleFullScreen(Y),this.sendWhenReady(Y?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(Y){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(Y)}setSimpleFullScreen(Y){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(Y),this._win.webContents.focus()}useNativeFullScreen(){const Y=this.configurationService.getValue("window");return!Y||typeof Y.nativeFullScreen!="boolean"||Y.nativeTabs?!0:Y.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let Y=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(Y)<0&&(Y="classic"),Y}setMenuBarVisibility(Y,Q=!0){P.isMacintosh||(Y==="toggle"&&Q&&this.send("vscode:showInfoMessage",(0,p.localize)(10,null)),Y==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(Y)}):this.doSetMenuBarVisibility(Y))}doSetMenuBarVisibility(Y){const Q=this.isFullScreen;switch(Y){case"classic":this._win.setMenuBarVisibility(!Q),this._win.autoHideMenuBar=Q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(P.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(Y,Q,..._){this.isReady?this.send(Y,..._):this.ready().then(()=>{Q.isCancellationRequested||this.send(Y,..._)})}send(Y,...Q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${Y} for window that is destroyed`);return}this._win.webContents.send(Y,...Q)}}updateTouchBar(Y){!P.isMacintosh||this.touchBarGroups.forEach((Q,_)=>{const q=Y[_];Q.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(!!P.isMacintosh){for(let Y=0;Y<10;Y++){const Q=this.createTouchBarGroup();this.touchBarGroups.push(Q)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(Y=[]){const Q=this.createTouchBarGroupSegments(Y),_=new v.TouchBar.TouchBarSegmentedControl({segments:Q,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:_.segments[q].id,from:"touchbar"})}});return _}createTouchBarGroupSegments(Y=[]){return Y.map(_=>{let q;_.icon&&!m.ThemeIcon.isThemeIcon(_.icon)&&_.icon?.dark?.scheme===f.Schemas.file&&(q=v.nativeImage.createFromPath(b.URI.revive(_.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let z;return typeof _.title=="string"?z=_.title:z=_.title.value,{id:_.id,label:q?void 0:z,icon:q}})}dispose(){super.dispose(),this._win=null}};te=ue([ee(1,i.ILogService),ee(2,y.IEnvironmentMainService),ee(3,s.IFileService),ee(4,o.IStorageMainService),ee(5,g.IConfigurationService),ee(6,S.IThemeMainService),ee(7,C.IWorkspacesManagementMainService),ee(8,d.IBackupMainService),ee(9,l.ITelemetryService),ee(10,I.IDialogMainService),ee(11,c.ILifecycleMainService),ee(12,a.IProductService),ee(13,n.IProtocolMainService)],te),e.CodeWindow=te}),define(J[62],Z([0,1,14,31,9,4,33,2,10,3,15,7,19,152,5,22,6,39,27,45]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let s=class je extends r.Disposable{constructor(m,S,D,A){super();this.stateMainService=m,this.logService=S,this.workspacesManagementMainService=D,this.lifecycleMainService=A,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(m=>this.addRecentlyOpened([{workspace:m.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(m){const S=[],D=[];for(let A of m)if((0,u.isRecentWorkspace)(A))!this.workspacesManagementMainService.isUntitledWorkspace(A.workspace)&&a(S,A.workspace)===-1&&S.push(A);else if((0,u.isRecentFolder)(A))n(S,A.folderUri)===-1&&S.push(A);else{const W=o(D,A.fileUri)>=0,C=A.fileUri.scheme===f.Schemas.file&&je.COMMON_FILES_FILTER.indexOf((0,t.basename)(A.fileUri))>=0;!W&&!C&&(D.push(A),w.isWindows&&A.fileUri.scheme===f.Schemas.file&&v.app.addRecentDocument(A.fileUri.fsPath))}this.addEntriesFromStorage(S,D),S.length>je.MAX_TOTAL_RECENT_ENTRIES&&(S.length=je.MAX_TOTAL_RECENT_ENTRIES),D.length>je.MAX_TOTAL_RECENT_ENTRIES&&(D.length=je.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:S,files:D}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(m){const S=C=>{const X=i(C);for(const te of m)if(t.extUriBiasedIgnorePathCase.isEqual(te,X))return!1;return!0},D=this.getRecentlyOpened(),A=D.workspaces.filter(S),W=D.files.filter(S);(A.length!==D.workspaces.length||W.length!==D.files.length)&&(this.saveRecentlyOpened({files:W,workspaces:A}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;v.app.clearRecentDocuments();const m=this.getRecentlyOpened(),S=[];let D=0;for(let W=0;W<m.workspaces.length&&D<je.MAX_MACOS_DOCK_RECENT_WORKSPACES;W++){const C=i(m.workspaces[W]);if(C.scheme===f.Schemas.file){const X=(0,t.originalFSPath)(C);await b.Promises.exists(X)&&(S.push(X),D++)}}const A=[];for(let W=0;W<m.files.length&&D<je.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;W++){const C=i(m.files[W]);if(C.scheme===f.Schemas.file){const X=(0,t.originalFSPath)(C);if(je.COMMON_FILES_FILTER.includes((0,t.basename)(C))||S.includes(X))continue;await b.Promises.exists(X)&&(A.push(X),D++)}}A.reverse().forEach(W=>v.app.addRecentDocument(W)),S.reverse().forEach(W=>v.app.addRecentDocument(W))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(m){const S=[],D=[],A=m?.config?.workspace;(0,u.isWorkspaceIdentifier)(A)&&!this.workspacesManagementMainService.isUntitledWorkspace(A)?S.push({workspace:A}):(0,u.isSingleFolderWorkspaceIdentifier)(A)&&S.push({folderUri:A.uri});const W=m?.config?.filesToOpenOrCreate;if(W)for(let C of W){const X=C.fileUri;X&&o(D,X)===-1&&D.push({fileUri:X})}return this.addEntriesFromStorage(S,D),{workspaces:S,files:D}}addEntriesFromStorage(m,S){let D=this.getRecentlyOpenedFromStorage();for(let A of D.workspaces){let W=(0,u.isRecentFolder)(A)?n(m,A.folderUri):a(m,A.workspace);W>=0?m[W].label=m[W].label||A.label:m.push(A)}for(let A of D.files){let W=o(S,A.fileUri);W>=0?S[W].label=S[W].label||A.label:S.push(A)}}getRecentlyOpenedFromStorage(){const m=this.stateMainService.getItem(je.recentlyOpenedStorageKey);return(0,u.restoreRecentlyOpened)(m,this.logService)}saveRecentlyOpened(m){const S=(0,u.toStoreData)(m);this.stateMainService.setItem(je.recentlyOpenedStorageKey,S)}updateWindowsJumpList(){if(!w.isWindows)return;const m=[];if(m.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let S=[];for(let W of v.app.getJumpListSettings().removedItems){const C=W.args;if(C){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);X&&S.push(P.URI.parse(X[2]))}}this.removeRecentlyOpened(S);let D=!1;const A=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(W=>{const C=(0,u.isRecentWorkspace)(W)?W.workspace:W.folderUri,{title:X,description:te}=this.getWindowsJumpListLabel(C,W.label);let oe;return P.URI.isUri(C)?oe=`--folder-uri "${C.toString()}"`:(D=!0,oe=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:te.substr(0,255),program:process.execPath,args:oe,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&m.push({type:"custom",name:D?(0,p.localize)(2,null):(0,p.localize)(3,null),items:A})}m.push({type:"recent"});try{v.app.setJumpList(m)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}getWindowsJumpListLabel(m,S){if(S)return{title:(0,E.splitName)(S).name,description:S};if(P.URI.isUri(m))return{title:(0,t.basename)(m),description:c(m)};if(this.workspacesManagementMainService.isUntitledWorkspace(m))return{title:(0,p.localize)(4,null),description:""};let D=(0,t.basename)(m.configPath);return D.endsWith(u.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,D),description:c(m.configPath)}}};s.MAX_TOTAL_RECENT_ENTRIES=100,s.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,s.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,s.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],s.recentlyOpenedStorageKey="openedPathsList",s=ue([ee(0,y.IStateMainService),ee(1,I.ILogService),ee(2,h.IWorkspacesManagementMainService),ee(3,g.ILifecycleMainService)],s),e.WorkspacesHistoryMainService=s;function c(l){return l.scheme==="file"?(0,E.normalizeDriveLetter)(l.fsPath):l.toString()}function i(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,m){return l.findIndex(S=>(0,u.isRecentWorkspace)(S)&&S.workspace.id===m.id)}function n(l,m){return l.findIndex(S=>(0,u.isRecentFolder)(S)&&t.extUriBiasedIgnorePathCase.isEqual(S.folderUri,m))}function o(l,m){return l.findIndex(S=>t.extUriBiasedIgnorePathCase.isEqual(S.fileUri,m))}}),define(J[234],Z([0,1,14,9,24,33,3,7,144,16,23,22,6,182,53,21,39,34,42,61,36,62]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let a=class wt{constructor(l,m,S,D,A,W,C,X,te,oe,Y){this.updateService=l,this.configurationService=m,this.windowsMainService=S,this.environmentMainService=D,this.telemetryService=A,this.workspacesHistoryMainService=W,this.stateMainService=C,this.lifecycleMainService=X,this.logService=te,this.nativeHostMainService=oe,this.productService=Y,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(E.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(W,C,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(W,C,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(W,C,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(W,C,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const S=this.productService.reportIssueUrl;S&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(S,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(E.language){const W=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${W}lang=${E.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!E.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,m){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!E.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!E.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=v.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(E.isMacintosh?new v.Menu:null);return}const m=new v.Menu;let S;if(E.isMacintosh){const A=new v.Menu;S=new v.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),m.append(S)}if(E.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new v.Menu;A.append(new v.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new v.Menu,W=new v.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:A});this.setMenuById(A,"File"),m.append(W)}if(this.shouldDrawMenu("Edit")){const A=new v.Menu,W=new v.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),m.append(W)}if(this.shouldDrawMenu("Selection")){const A=new v.Menu,W=new v.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),m.append(W)}if(this.shouldDrawMenu("View")){const A=new v.Menu,W=new v.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:A});this.setMenuById(A,"View"),m.append(W)}if(this.shouldDrawMenu("Go")){const A=new v.Menu,W=new v.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),m.append(W)}if(this.shouldDrawMenu("Run")){const A=new v.Menu,W=new v.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),m.append(W)}if(this.shouldDrawMenu("Terminal")){const A=new v.Menu,W=new v.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),m.append(W)}let D;if(this.shouldDrawMenu("Window")){const A=new v.Menu;D=new v.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(D&&m.append(D),this.shouldDrawMenu("Help")){const A=new v.Menu,W=new v.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),m.append(W)}m.items&&m.items.length>0?v.Menu.setApplicationMenu(m):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const m=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),S=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const Q=new v.Menu;this.setMenuById(Q,"Preferences"),D=new v.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:Q})}const A=new v.Menu,W=new v.MenuItem({label:f.localize(12,null),role:"services",submenu:A}),C=new v.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new v.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new v.MenuItem({label:f.localize(15,null),role:"unhide"}),oe=new v.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),Y=[m];Y.push(...S),D&&Y.push(n(),D),Y.push(n(),W,n(),C,X,te,n(),oe),Y.forEach(Q=>l.append(Q))}shouldDrawMenu(l){if(!E.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,m){m.forEach(S=>{if((0,p.isMenubarMenuItemSeparator)(S))l.append(n());else if((0,p.isMenubarMenuItemSubmenu)(S)){const D=new v.Menu,A=new v.MenuItem({label:this.mnemonicLabel(S.label),submenu:D});this.setMenu(D,S.submenu.items),l.append(A)}else(0,p.isMenubarMenuItemRecentAction)(S)?l.append(this.createOpenRecentMenuItem(S)):(0,p.isMenubarMenuItemAction)(S)&&(S.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),E.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[S.id]?l.append(new v.MenuItem(this.likeAction(S.id,{label:this.mnemonicLabel(S.label),click:this.fallbackMenuHandlers[S.id]}))):l.append(this.createMenuItem(S.label,S.id,!1,S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)))})}setMenuById(l,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(l,this.menubarMenus[m].items)}insertCheckForUpdatesItems(l){const m=this.getUpdateMenuItems();m.length&&(m.forEach(S=>l.append(S)),l.append(n()))}createOpenRecentMenuItem(l){const m=r.URI.revive(l.uri),S=l.id,D=S==="openRecentFile"?{fileUri:m}:S==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new v.MenuItem(this.likeAction(S,{label:l.label,click:(A,W,C)=>{const X=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(l){return!!(l&&(!E.isMacintosh&&(l.ctrlKey||l.shiftKey)||E.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,m,S){const D={label:this.mnemonicLabel(l),role:S,enabled:!0};return new v.MenuItem(this.withKeybinding(m,D))}setMacWindowMenu(l){const m=new v.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),S=new v.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new v.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),W=[];this.currentEnableNativeTabs&&(W.push(n()),W.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),W.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),W.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),W.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),W.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,S,n(),A,...W,n(),D].forEach(C=>l.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,m,S,D){const A=this.mnemonicLabel(l),W=typeof m=="function"?m:(Y,Q,_)=>{const q=Y?Y.userSettingsLabel:null;let z=m;Array.isArray(m)&&(z=this.isOptionClick(_)?m[1]:m[0]),q&&_.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:q}):this.runActionInRenderer({type:"commandId",commandId:z})},C=typeof S=="boolean"?S:this.windowsMainService.getWindowCount()>0,X=typeof D=="boolean"?D:!1,te={label:A,click:W,enabled:C};X&&(te.type="checkbox",te.checked=X);let oe;return typeof m=="string"?oe=m:Array.isArray(m)&&(oe=m[0]),E.isMacintosh&&(oe==="editor.action.clipboardCutAction"?te.role="cut":oe==="editor.action.clipboardCopyAction"?te.role="copy":oe==="editor.action.clipboardPasteAction"&&(te.role="paste"),oe==="undo"?te.click=this.makeContextAwareClickHandler(W,{inDevTools:Y=>Y.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?te.click=this.makeContextAwareClickHandler(W,{inDevTools:Y=>Y.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(W,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(oe,te))}makeContextAwareClickHandler(l,m){return(S,D,A)=>{const W=v.BrowserWindow.getFocusedWindow();if(!W)return m.inNoWindow();if(W.webContents.isDevToolsFocused()&&W.webContents.devToolsWebContents)return m.inDevTools(W.webContents.devToolsWebContents);l(S,D||W,A)}}runActionInRenderer(l){let m=v.BrowserWindow.getFocusedWindow();if(!m){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(m=D.win)}const S=m?this.windowsMainService.getWindowById(m.id):void 0;if(S){if(this.logService.trace("menubar#runActionInRenderer",l),E.isMacintosh&&!this.environmentMainService.isBuilt&&!S.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const D={id:l.commandId,from:"menu"};S.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:l.userSettingsLabel};S.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,m){const S=typeof l=="string"?this.keybindings[l]:void 0;if(S?.label){if(S.isNative!==!1)m.accelerator=S.label,m.userSettingsLabel=S.userSettingsLabel;else if(typeof m.label=="string"){const D=m.label.indexOf("[");D>=0?m.label=`${m.label.substr(0,D)} [${S.label}]`:m.label=`${m.label} [${S.label}]`}}else m.accelerator=void 0;return m}likeAction(l,m,S=!m.accelerator){S&&(m=this.withKeybinding(l,m));const D=m.click;return m.click=(A,W,C)=>{this.reportMenuActionTelemetry(l),D&&D(A,W,C)},m}openUrl(l,m){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:i})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=ue([ee(0,u.IUpdateService),ee(1,w.IConfigurationService),ee(2,s.IWindowsMainService),ee(3,t.IEnvironmentMainService),ee(4,y.ITelemetryService),ee(5,c.IWorkspacesHistoryMainService),ee(6,I.IStateMainService),ee(7,P.ILifecycleMainService),ee(8,b.ILogService),ee(9,d.INativeHostMainService),ee(10,g.IProductService)],a),e.Menubar=a;function n(){return new v.MenuItem({type:"separator"})}}),define(J[235],Z([0,1,5,22,6,234]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let E=class{constructor(f,w,t){this.instantiationService=f,this.lifecycleMainService=w,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};E=ue([ee(0,v.IInstantiationService),ee(1,L.ILifecycleMainService),ee(2,k.ILogService)],E),e.MenubarMainService=E}),define(J[236],Z([0,1,14,30,26,31,24,4,29,43,33,2,10,8,72,3,32,15,13,7,150,51,16,52,23,20,5,22,6,48,21,55,73,39,61,233,99,216,27,100,62,45]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c,i,a,n,o,l,m,S,D,A,W,C,X,te,oe,Y,Q,_,q,z,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(F){return(0,_.isWorkspaceIdentifier)(F?.workspace)}function U(F){return(0,_.isSingleFolderWorkspaceIdentifier)(F?.workspace)}let j=class Je extends P.Disposable{constructor(R,T,O,B,N,V,x,ie,ne,ce,se,ae,pe,fe,we){super();this.machineId=R,this.initialUserEnv=T,this.logService=O,this.stateMainService=B,this.environmentMainService=N,this.lifecycleMainService=V,this.backupMainService=x,this.configurationService=ie,this.workspacesHistoryMainService=ne,this.workspacesManagementMainService=ce,this.instantiationService=se,this.dialogMainService=ae,this.fileService=pe,this.productService=fe,this.protocolMainService=we,this._onDidOpenWindow=this._register(new r.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new r.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new r.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new r.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(R=>this._onDidSignalReadyWindow.fire(R.window))),this._register(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const T=new P.DisposableStore;if(T.add(r.Event.any(R.onDidClose,R.onDidDestroy)(()=>T.dispose())),R.config.extensionDevelopmentPath)for(const O of R.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(h.URI.file(O)));R.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(h.URI.file(R.config.extensionTestsPath)))}}))}openEmptyWindow(R,T){let O=this.environmentMainService.args;const B=T?.remoteAuthority||void 0,N=!0,V=T?.forceReuseWindow,x=!V;return this.open({...R,cli:O,forceEmpty:N,forceNewWindow:x,forceReuseWindow:V,remoteAuthority:B})}open(R){this.logService.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const T=[],O=[],B=[],N=[],V=[];let x,ie=0;const ne=this.getPathsToOpen(R);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const fe of ne)U(fe)?R.addMode?T.push(fe):O.push(fe):H(fe)?B.push(fe):fe.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:fe.remoteAuthority}),x.filesToOpenOrCreate.push(fe)):fe.backupPath?V.push({backupFolder:(0,p.basename)(fe.backupPath),remoteAuthority:fe.remoteAuthority}):ie++;R.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),x&&R.waitMarkerFileURI&&(x.filesToWait={paths:[...x.filesToDiff,...x.filesToOpenOrCreate],waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(N.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),B.push(...N),V.push(...this.backupMainService.getEmptyWindowBackupPaths())):V.length=0;const{windows:ce,filesOpenedInWindow:se}=this.doOpen(R,B,O,V,ie,x,T);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${O.length}, emptyToRestore: ${V.length}, emptyToOpen: ${ie})`),ce.length>1)if(se)se.focus();else{const fe=this.windowsStateHandler.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let we=!0,Pe=!0;if(fe){const Se=ce.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Se.length&&(Se[0].focus(),we=!1,Pe=!1)}if(we)for(let Se=ce.length-1;Se>=0;Se--){const me=ce[Se];if(!(me.openedWorkspace&&N.some(Ee=>me.openedWorkspace&&Ee.workspace.id===me.openedWorkspace.id)||me.backupPath&&V.some(Ee=>me.backupPath&&Ee.backupFolder===(0,p.basename)(me.backupPath)))){me.focus(),Pe=!1;break}}Pe&&ce[ce.length-1].focus()}const ae=x&&x.filesToDiff.length>0;if(!ce.some(fe=>fe.isExtensionDevelopmentHost)&&!ae&&!R.noRecentEntry){const fe=[];for(const we of ne)H(we)&&!we.transient?fe.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):U(we)?fe.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&fe.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(fe)}const pe=R.waitMarkerFileURI;return R.context===0&&pe&&ce.length===1&&ce[0]&&(async()=>{await ce[0].whenClosedOrLoaded;try{await this.fileService.del(pe)}catch(fe){}})(),ce}doOpen(R,T,O,B,N,V,x){const ie=[];let ne;function ce(Se,me){ie.push(Se),me&&(ne=Se,V=void 0)}let{openFolderInNewWindow:se,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(R);if(!R.initialStartup&&x.length>0){const Se=x[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(Se);me&&ce(this.doAddFoldersToExistingWindow(me,x.map(Ee=>Ee.workspace.uri)))}const pe=O.length+T.length+B.length;if(V&&pe===0){const Se=V.filesToOpenOrCreate[0]||V.filesToDiff[0],me=this.getWindows().filter(Le=>V&&Le.remoteAuthority===V.remoteAuthority);let Ee;Se?.fileUri&&!ae&&((R.context===4||R.context===0||R.context===1)&&(Ee=(0,Y.findWindowOnFile)(me,Se.fileUri,Le=>Le.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(me))),Ee?(0,_.isWorkspaceIdentifier)(Ee.openedWorkspace)?T.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,_.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(R,Ee,V),!0):ce(this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow}),!0)}const fe=(0,M.distinct)(T,Se=>Se.workspace.id);if(fe.length>0){const Se=(0,M.coalesce)(fe.map(me=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(Se.length>0){const me=Se[0],Ee=V?.remoteAuthority===me.remoteAuthority?V:void 0;ce(this.doOpenFilesInExistingWindow(R,me,Ee),!!Ee),se=!0}fe.forEach(me=>{if(Se.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===me.workspace.id))return;const Ee=me.remoteAuthority,Le=V?.remoteAuthority===Ee?V:void 0;ce(this.doOpenFolderOrWorkspace(R,me,se,Le),!!Le),se=!0})}const we=(0,M.distinct)(O,Se=>y.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(we.length>0){const Se=(0,M.coalesce)(we.map(me=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(Se.length>0){const me=Se[0],Ee=V?.remoteAuthority===me.remoteAuthority?V:void 0;ce(this.doOpenFilesInExistingWindow(R,me,Ee),!!Ee),se=!0}we.forEach(me=>{if(Se.some(Te=>(0,_.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,me.workspace.uri)))return;const Ee=me.remoteAuthority,Le=V?.remoteAuthority===Ee?V:void 0;ce(this.doOpenFolderOrWorkspace(R,me,se,Le),!!Le),se=!0})}const Pe=(0,M.distinct)(B,Se=>Se.backupFolder);if(Pe.length>0&&Pe.forEach(Se=>{const me=Se.remoteAuthority,Ee=V?.remoteAuthority===me?V:void 0;ce(this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:Ee,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:R.forceNewTabbedWindow,emptyWindowBackupInfo:Se}),!!Ee),se=!0}),ie.length===0||V){V&&!N&&N++;const Se=V?V.remoteAuthority:R.remoteAuthority;for(let me=0;me<N;me++)ce(this.doOpenEmpty(R,se,Se,V),!!V),se=!0}return{windows:(0,M.distinct)(ie),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(R,T,O){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),T.focus();const B={filesToOpenOrCreate:O?.filesToOpenOrCreate,filesToDiff:O?.filesToDiff,filesToWait:O?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return T.sendWhenReady("vscode:openFiles",E.CancellationToken.None,B),T}doAddFoldersToExistingWindow(R,T){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),R.focus();const O={foldersToAdd:T};return R.sendWhenReady("vscode:addFolders",E.CancellationToken.None,O),R}doOpenEmpty(R,T,O,B,N){return!T&&!N&&typeof R.contextWindowId=="number"&&(N=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:O,forceNewWindow:T,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:B,windowToUse:N})}doOpenFolderOrWorkspace(R,T,O,B,N){return!O&&!N&&typeof R.contextWindowId=="number"&&(N=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({workspace:T.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:T.remoteAuthority,forceNewWindow:O,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:B,windowToUse:N})}getPathsToOpen(R){let T,O=!1,B=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(T=this.doExtractPathsFromAPI(R),O=!0):R.forceEmpty?T=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(T=this.doExtractPathsFromCLI(R.cli),T.length===0&&T.push(Object.create(null)),O=!0):(T=this.doGetPathsFromLastSession(),T.length===0&&T.push(Object.create(null)),B=!0),!R.addMode&&O){const N=T.filter(V=>U(V));if(N.length>1){const V=N[0].remoteAuthority;if(N.every(x=>x.remoteAuthority===V)){const x=this.workspacesManagementMainService.createUntitledWorkspaceSync(N.map(ie=>({uri:ie.workspace.uri})));T.push({workspace:x,remoteAuthority:V}),T=T.filter(ie=>!U(ie))}}}return R.initialStartup&&!B&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&T.unshift(...this.doGetPathsFromLastSession().filter(N=>H(N)||U(N)||N.backupPath)),T}doExtractPathsFromAPI(R){const T=[],O={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority};for(const B of(0,M.coalesce)(R.urisToOpen||[])){const N=this.resolveOpenable(B,O);if(N)N.label=B.label,T.push(N);else{const V=this.resourceFromOpenable(B),x={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(0,null))],defaultId:0,message:V.scheme===b.Schemas.file?(0,s.localize)(1,null):(0,s.localize)(2,null),detail:V.scheme===b.Schemas.file?(0,s.localize)(3,null,(0,t.getPathLabel)(V.fsPath,this.environmentMainService)):(0,s.localize)(4,null,V.toString()),noLink:!0};this.dialogMainService.showMessageBox(x,(0,u.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return T}doExtractPathsFromCLI(R){const T=[],O={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:!1},B=R["folder-uri"];if(B)for(const x of B){const ie=this.cliArgToUri(x);if(ie){const ne=this.resolveOpenable({folderUri:ie},O);ne&&T.push(ne)}}const N=R["file-uri"];if(N)for(const x of N){const ie=this.cliArgToUri(x);if(ie){const ne=this.resolveOpenable((0,_.hasWorkspaceFileExtension)(x)?{workspaceUri:ie}:{fileUri:ie},O);ne&&T.push(ne)}}const V=R._;for(const x of V){const ie=O.remoteAuthority?this.doResolvePathRemote(x,O):this.doResolveFilePath(x,O);ie&&T.push(ie)}return T}cliArgToUri(R){try{const T=h.URI.parse(R);if(!T.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${R}`);return}return T}catch(T){this.logService.error(`Invalid URI input string: ${R}, ${T.message}`)}}doGetPathsFromLastSession(){const R=this.getRestoreWindowsSetting();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":const T=[];R!=="one"&&T.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&T.push(this.windowsStateHandler.state.lastActiveWindow);const O=[];for(const B of T)if(B.workspace){const N=this.resolveOpenable({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});H(N)&&O.push(N)}else if(B.folderUri){const N=this.resolveOpenable({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});U(N)&&O.push(N)}else R!=="folders"&&B.backupPath&&O.push({backupPath:B.backupPath,remoteAuthority:B.remoteAuthority});return O}}getRestoreWindowsSetting(){let R;return this.lifecycleMainService.wasRestarted?R="all":(R=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}resolveOpenable(R,T=Object.create(null)){let O=this.resourceFromOpenable(R);return O.scheme===b.Schemas.file?((0,te.isFileToOpen)(R)&&(T={...T,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(O.fsPath,T)):this.doResolveRemoteOpenable(R,T)}doResolveRemoteOpenable(R,T){let O=this.resourceFromOpenable(R);const B=(0,C.getRemoteAuthority)(O)||T.remoteAuthority;if(O=(0,y.removeTrailingPathSeparator)((0,y.normalizePath)(O)),(0,te.isFileToOpen)(R)){if(T.gotoLineMode){const{path:N,line:V,column:x}=(0,f.parseLineAndColumnAware)(O.path);return{fileUri:O.with({path:N}),selection:V?{startLineNumber:V,startColumn:x||1}:void 0,remoteAuthority:B}}return{fileUri:O,remoteAuthority:B}}else if((0,te.isWorkspaceToOpen)(R))return{workspace:(0,q.getWorkspaceIdentifier)(O),remoteAuthority:B};return{workspace:(0,q.getSingleFolderWorkspaceIdentifier)(O),remoteAuthority:B}}resourceFromOpenable(R){return(0,te.isWorkspaceToOpen)(R)?R.workspaceUri:(0,te.isFolderToOpen)(R)?R.folderUri:R.fileUri}doResolveFilePath(R,T){let O,B;T.gotoLineMode&&({path:R,line:O,column:B}=(0,f.parseLineAndColumnAware)(R)),R=(0,f.sanitizeFilePath)((0,p.normalize)(R),(0,I.cwd)());try{const N=(0,L.statSync)(R);if(N.isFile()){if(!T.forceOpenWorkspaceAsFile){const V=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(R));if(V)return V.transient&&T.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},remoteAuthority:V.remoteAuthority,exists:!0,transient:V.transient}}return{fileUri:h.URI.file(R),selection:O?{startLineNumber:O,startColumn:B||1}:void 0,exists:!0}}else if(N.isDirectory())return{workspace:(0,q.getSingleFolderWorkspaceIdentifier)(h.URI.file(R),N),exists:!0}}catch(N){const V=h.URI.file(R);if(this.workspacesHistoryMainService.removeRecentlyOpened([V]),T.ignoreFileNotFound)return{fileUri:V,exists:!1}}}doResolvePathRemote(R,T){const O=R.charCodeAt(0),B=T.remoteAuthority;let N,V;T.gotoLineMode&&({path:R,line:N,column:V}=(0,f.parseLineAndColumnAware)(R)),O!==47&&((0,f.isWindowsDriveLetter)(O)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,f.toSlashes)(R)),R=`/${R}`);const x=h.URI.from({scheme:b.Schemas.vscodeRemote,authority:B,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,_.hasWorkspaceFileExtension)(R))return T.forceOpenWorkspaceAsFile?{fileUri:x,selection:N?{startLineNumber:N,startColumn:V||1}:void 0,remoteAuthority:T.remoteAuthority}:{workspace:(0,q.getWorkspaceIdentifier)(x),remoteAuthority:B};if(T.gotoLineMode||p.posix.basename(R).indexOf(".")!==-1)return{fileUri:x,selection:N?{startLineNumber:N,startColumn:V||1}:void 0,remoteAuthority:B}}return{workspace:(0,q.getSingleFolderWorkspaceIdentifier)(x),remoteAuthority:B}}shouldOpenNewWindow(R){const T=this.configurationService.getValue("window"),O=T?.openFoldersInNewWindow||"default",B=T?.openFilesInNewWindow||"off";let N=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(O==="on"||O==="off")&&(N=O==="on");let V=!1;return R.forceNewWindow||R.forceReuseWindow?V=!!R.forceNewWindow&&!R.forceReuseWindow:(g.isMacintosh?R.context===1&&(V=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!R.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(V=B==="on")),{openFolderInNewWindow:!!N,openFilesInNewWindow:V}}openExtensionDevelopmentHostWindow(R,T){const O=(0,Y.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if(O)return this.lifecycleMainService.reload(O,T.cli),O.focus(),[O];let B=T.cli["folder-uri"]||[],N=T.cli["file-uri"]||[],V=T.cli._;if(!V.length&&!B.length&&!N.length&&!T.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,se=ce&&(ce.workspace||ce.folderUri);se&&(h.URI.isUri(se)?se.scheme===b.Schemas.file?V=[se.fsPath]:B=[se.toString()]:se.configPath.scheme===b.Schemas.file?V=[(0,y.originalFSPath)(se.configPath)]:N=[se.configPath.toString()])}let x=T.remoteAuthority;for(const ce of R)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const se=h.URI.parse(ce),ae=(0,C.getRemoteAuthority)(se);ae&&(x?ae!==x&&this.logService.error("more than one extension development path authority"):x=ae)}V=V.filter(ce=>{const se=h.URI.file(ce);return(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:(0,C.getRemoteAuthority)(se)===x}),B=B.filter(ce=>{const se=this.cliArgToUri(ce);return se&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:se?(0,C.getRemoteAuthority)(se)===x:!1}),N=N.filter(ce=>{const se=this.cliArgToUri(ce);return se&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),se)?!1:se?(0,C.getRemoteAuthority)(se)===x:!1}),T.cli._=V,T.cli["folder-uri"]=B,T.cli["file-uri"]=N;const ie=!V.length&&!B.length&&!N.length,ne={context:T.context,cli:T.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:T.userEnv,noRecentEntry:!0,waitMarkerFileURI:T.waitMarkerFileURI,remoteAuthority:x};return this.open(ne)}openInBrowserWindow(R){const T=this.configurationService.getValue("window"),O={...this.environmentMainService.args,...R.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.initialUserEnv,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:R.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof T?.zoomLevel=="number"?T.zoomLevel:void 0,autoDetectHighContrast:T?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let B;if(!R.forceNewWindow&&!R.forceNewTabbedWindow&&(B=R.windowToUse||this.getLastActiveWindow(),B&&B.focus()),B){const N=B.config;!O.extensionDevelopmentPath&&N&&!!N.extensionDevelopmentPath&&(O.extensionDevelopmentPath=N.extensionDevelopmentPath,O.verbose=N.verbose,O["inspect-brk-extensions"]=N["inspect-brk-extensions"],O.debugId=N.debugId,O["inspect-extensions"]=N["inspect-extensions"],O["extensions-dir"]=N["extensions-dir"])}else{const N=this.windowsStateHandler.getNewWindowState(O);(0,d.mark)("code/willCreateCodeWindow");const V=B=this.instantiationService.createInstance(oe.CodeWindow,{state:N,extensionDevelopmentPath:O.extensionDevelopmentPath,isExtensionTestHost:!!O.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(V)}Je.WINDOWS.push(V),this._onDidOpenWindow.fire(V),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(V.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(V)),(0,w.once)(V.onDidClose)(()=>this.onWindowClosed(V)),(0,w.once)(V.onDidDestroy)(()=>this._onDidDestroyWindow.fire(V));const x=(0,u.assertIsDefined)(V.win?.webContents);x.removeAllListeners("devtools-reload-page"),x.on("devtools-reload-page",()=>this.lifecycleMainService.reload(V)),this.lifecycleMainService.registerWindow(V)}return O.windowId=B.id,B.isReady?this.lifecycleMainService.unload(B,4).then(N=>{N||this.doOpenInBrowserWindow(B,O,R)}):this.doOpenInBrowserWindow(B,O,R),B}doOpenInBrowserWindow(R,T,O){if(!T.extensionDevelopmentPath)if((0,_.isWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:T.workspace,remoteAuthority:T.remoteAuthority});else if((0,_.isSingleFolderWorkspaceIdentifier)(T.workspace))T.backupPath=this.backupMainService.registerFolderBackupSync(T.workspace.uri);else{const B=O.emptyWindowBackupInfo&&O.emptyWindowBackupInfo.backupFolder;T.backupPath=this.backupMainService.registerEmptyWindowBackupSync(B,T.remoteAuthority)}R.load(T)}onWindowClosed(R){const T=Je.WINDOWS.indexOf(R);Je.WINDOWS.splice(T,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=v.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(R){return this.doGetLastActiveWindow(this.getWindows().filter(T=>T.remoteAuthority===R))}doGetLastActiveWindow(R){const T=Math.max.apply(Math,R.map(O=>O.lastFocusTime));return R.find(O=>O.lastFocusTime===T)}sendToFocused(R,...T){const O=this.getFocusedWindow()||this.getLastActiveWindow();O&&O.sendWhenReady(R,E.CancellationToken.None,...T)}sendToAll(R,T,O){for(const B of this.getWindows())O&&O.indexOf(B.id)>=0||B.sendWhenReady(R,E.CancellationToken.None,T)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(R){const T=this.getWindows().filter(O=>O.id===R);return(0,M.firstOrDefault)(T)}getWindowByWebContents(R){const T=v.BrowserWindow.fromWebContents(R);if(!!T)return this.getWindowById(T.id)}};j.WINDOWS=[],j=ue([ee(2,S.ILogService),ee(3,X.IStateMainService),ee(4,n.IEnvironmentMainService),ee(5,m.ILifecycleMainService),ee(6,c.IBackupMainService),ee(7,i.IConfigurationService),ee(8,z.IWorkspacesHistoryMainService),ee(9,$.IWorkspacesManagementMainService),ee(10,l.IInstantiationService),ee(11,a.IDialogMainService),ee(12,o.IFileService),ee(13,A.IProductService),ee(14,W.IProtocolMainService)],j),e.WindowsMainService=j}),define(J[237],Z([0,1,51,36,62,45]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(f,w,t,P){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=t,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,t){return this.workspacesManagementMainService.createUntitledWorkspace(w,t)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=ue([ee(0,M.IWorkspacesManagementMainService),ee(1,L.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,v.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[238],Z([0,1,14,30,26,18,17,29,43,40,33,2,10,8,3,15,13,7,28,66,119,35,122,84,229,131,51,220,16,178,157,70,52,219,88,23,54,90,169,185,89,172,20,69,5,71,230,196,101,22,6,180,235,53,21,73,225,74,39,214,98,197,34,199,200,75,42,205,227,231,228,232,97,206,207,208,209,211,36,236,212,27,62,237,45]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c,i,a,n,o,l,m,S,D,A,W,C,X,te,oe,Y,Q,_,q,z,$,H,U,j,F,R,T,O,B,N,V,x,ie,ne,ce,se,ae,pe,fe,we,Pe,Se,me,Ee,Le,Te,Ne,Ue,Ge,Be,st,Ze,ot,Ye,ut,xe,G,re,le,de,ve,Me,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ce=class extends P.Disposable{constructor(he,ye,be,ge,Ie,De,ke,Ae,Re,$e){super();this.mainProcessNodeIpcServer=he,this.userEnv=ye,this.mainInstantiationService=be,this.logService=ge,this.environmentMainService=Ie,this.lifecycleMainService=De,this.configurationService=ke,this.stateMainService=Ae,this.fileService=Re,this.productService=$e,this.configureSession(),this.registerListeners()}configureSession(){const he=ge=>ge?.startsWith(`${b.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((ge,Ie,De,ke)=>he(ke.requestingUrl)?De(ye.has(Ie)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((ge,Ie,De,ke)=>he(ke.requestingUrl)?ye.has(Ie):!1);const be=v.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,p.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,E.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,E.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,s.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(be,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),v.app.on("activate",(be,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(be,ge)=>{ge.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),ge.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let he=[],ye;v.app.on("open-file",(be,ge)=>{this.logService.trace("app#open-file: ",ge),be.preventDefault(),he.push(this.getWindowOpenableFromPathSync(ge)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],ye=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",be=>{const ge=this.windowsMainService?.getWindowByWebContents(be.sender);let Ie,De;return ge?.config?(Ie=ge.config,De={...process.env,...ge.config.userEnv}):(Ie=this.environmentMainService.args,De=process.env),(0,Q.resolveShellEnv)(this.logService,Ie,De)}),v.ipcMain.handle("vscode:writeNlsFile",(be,ge,Ie)=>{const De=this.validateNlsPath([ge]);if(!De||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,M.VSBuffer.fromString(Ie))}),v.ipcMain.handle("vscode:readNlsFile",async(be,...ge)=>{const Ie=this.validateNlsPath(ge);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(he){let ye;for(const be of he)typeof be=="string"&&(typeof ye!="string"?ye=be:ye=(0,p.join)(ye,be));if(!(typeof ye!="string"||!(0,p.isAbsolute)(ye)||!(0,r.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return y.URI.file(ye)}onUnexpectedError(he){if(he){const ye={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const he=this.productService.win32AppUserModelId;d.isWindows&&he&&v.app.setAppUserModelId(he);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Re){this.logService.error(Re)}const ye=new i.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:ge,sharedProcessReady:Ie,sharedProcessClient:De}=this.setupSharedProcess(be),ke=await this.initServices(be,ge,Ie);if(this.environmentMainService.driverHandle){const Re=await(0,X.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Re)}this._register(ke.createInstance(n.ProxyAuthHandler)),ke.invokeFunction(Re=>this.initChannels(Re,ye,De));const Ae=ke.invokeFunction(Re=>this.openFirstWindow(Re,ye));ke.invokeFunction(Re=>this.afterWindowOpen(Re,ge)),this.environmentMainService.args.trace&&ke.invokeFunction(Re=>this.stopTracingEventually(Re,Ae))}async resolveMachineId(){let he=this.stateMainService.getItem(Se.machineIdKey);return(!he||d.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,h.getMachineId)(),this.stateMainService.setItem(Se.machineIdKey,he)),he}setupSharedProcess(he){const ye=this._register(this.mainInstantiationService.createInstance(se.SharedProcess,he,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Ie,"main")})(),ge=(async()=>(await ye.whenReady(),be))();return{sharedProcess:ye,sharedProcessReady:ge,sharedProcessClient:be}}async initServices(he,ye,be){const ge=new F.ServiceCollection;switch(process.platform){case"win32":ge.set(Te.IUpdateService,new U.SyncDescriptor(st.Win32UpdateService));break;case"linux":d.isLinuxSnap?ge.set(Te.IUpdateService,new U.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Te.IUpdateService,new U.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":ge.set(Te.IUpdateService,new U.SyncDescriptor(Ue.DarwinUpdateService));break}ge.set(re.IWindowsMainService,new U.SyncDescriptor(le.WindowsMainService,[he,this.userEnv])),ge.set(C.IDialogMainService,new U.SyncDescriptor(C.DialogMainService)),ge.set(O.ILaunchMainService,new U.SyncDescriptor(O.LaunchMainService)),ge.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(be.then(De=>De.getChannel("diagnostics"))))),ge.set(R.IIssueMainService,new U.SyncDescriptor(R.IssueMainService,[this.userEnv])),ge.set(te.IEncryptionMainService,new U.SyncDescriptor(te.EncryptionMainService,[he])),ge.set(T.IKeyboardLayoutMainService,new U.SyncDescriptor(T.KeyboardLayoutMainService)),ge.set(ie.INativeHostMainService,new U.SyncDescriptor(ie.NativeHostMainService,[ye])),ge.set(xe.IWebviewManagerService,new U.SyncDescriptor(G.WebviewMainService)),ge.set(ve.IWorkspacesService,new U.SyncDescriptor(Fe.WorkspacesMainService)),ge.set(We.IWorkspacesManagementMainService,new U.SyncDescriptor(We.WorkspacesManagementMainService)),ge.set(Me.IWorkspacesHistoryMainService,new U.SyncDescriptor(Me.WorkspacesHistoryMainService)),ge.set(x.IMenubarMainService,new U.SyncDescriptor(x.MenubarMainService)),ge.set(_.IExtensionUrlTrustService,new U.SyncDescriptor(q.ExtensionUrlTrustService)),ge.set(we.IStorageMainService,new U.SyncDescriptor(we.StorageMainService)),d.isWindows?ge.set(z.IExternalTerminalMainService,new U.SyncDescriptor($.WindowsExternalTerminalService)):d.isMacintosh?ge.set(z.IExternalTerminalMainService,new U.SyncDescriptor($.MacExternalTerminalService)):d.isLinux&&ge.set(z.IExternalTerminalMainService,new U.SyncDescriptor($.LinuxExternalTerminalService));const Ie=new m.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(l.IBackupMainService,Ie),ge.set(Ze.IURLService,new U.SyncDescriptor(Ye.NativeURLService)),(0,Le.getTelemetryLevel)(this.productService,this.environmentMainService)>=2){const De=(0,c.getDelayedChannel)(be.then(Ke=>Ke.getChannel("telemetryAppender"))),ke=new me.TelemetryAppenderClient(De),Ae=(0,Pe.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Re=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],$e={appender:ke,commonProperties:Ae,piiPaths:Re,sendErrorTelemetry:!0};ge.set(Se.ITelemetryService,new U.SyncDescriptor(Ee.TelemetryService,[$e]))}else ge.set(Se.ITelemetryService,Le.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(he,ye,be){const ge=c.ProxyChannel.fromService(he.get(O.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge),ye.registerChannel(D.UserConfigurationFileServiceId,c.ProxyChannel.fromService(new D.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ne.UpdateChannel(he.get(Te.IUpdateService));ye.registerChannel("update",Ie);const De=c.ProxyChannel.fromService(he.get(R.IIssueMainService));ye.registerChannel("issue",De);const ke=c.ProxyChannel.fromService(he.get(te.IEncryptionMainService));ye.registerChannel("encryption",ke);const Ae=c.ProxyChannel.fromService(he.get(ae.ISignService));ye.registerChannel("sign",Ae);const Re=c.ProxyChannel.fromService(he.get(T.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Re),this.nativeHostMainService=he.get(ie.INativeHostMainService);const $e=c.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",$e),be.then(He=>He.registerChannel("nativeHost",$e));const Ke=c.ProxyChannel.fromService(he.get(ve.IWorkspacesService));ye.registerChannel("workspaces",Ke);const et=c.ProxyChannel.fromService(he.get(x.IMenubarMainService));ye.registerChannel("menubar",et);const tt=c.ProxyChannel.fromService(he.get(Ze.IURLService));ye.registerChannel("url",tt);const ht=c.ProxyChannel.fromService(he.get(_.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",ht);const _e=c.ProxyChannel.fromService(he.get(xe.IWebviewManagerService));ye.registerChannel("webview",_e);const it=this._register(new fe.StorageDatabaseChannel(this.logService,he.get(we.IStorageMainService)));ye.registerChannel("storage",it),be.then(He=>He.registerChannel("storage",it));const nt=c.ProxyChannel.fromService(he.get(z.IExternalTerminalMainService));ye.registerChannel("externalTerminal",nt);const Xe=new V.LogLevelChannel(he.get(N.ILogService));ye.registerChannel("logLevel",Xe),be.then(He=>He.registerChannel("logLevel",Xe));const rt=new V.LoggerChannel(he.get(N.ILoggerService));ye.registerChannel("logger",rt),be.then(He=>He.registerChannel("logger",rt));const at=new A.ElectronExtensionHostDebugBroadcastChannel(he.get(re.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",at)}openFirstWindow(he,ye){const be=this.windowsMainService=he.get(re.IWindowsMainService),ge=he.get(Ze.IURLService),Ie=he.get(ie.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:y.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(De.push(Qe),!1):!0}),Ae=this,Re=this.environmentMainService,$e=this.productService;ge.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===$e.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:y.URI.parse(Oe.query).path,query:""})),Ae.shouldBlockURI(Oe))return!0;const vt=Ae.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=be.open({context:5,cli:{...Re.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(d.isMacintosh&&be.getWindowCount()===0){const[ft]=be.open({context:5,cli:{...Re.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ce.getRemoteAuthority)(Oe)});return await ft.ready(),ge.open(Oe,Qe)}return!1}});const Ke=this._register(new de.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new c.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),tt=new ot.URLHandlerRouter(et),ht=ye.getChannel("urlHandler",tt);ge.registerHandler(new ot.URLHandlerChannelClient(ht)),this._register(new ut.ElectronURLListener(ke,ge,be,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=(0,Y.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],He=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?y.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return De.length>0?be.open({context:nt,cli:_e,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!rt&&!at?be.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):it.length&&!Xe&&!rt&&!at?be.open({context:1,cli:_e,urisToOpen:it.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0}):be.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:He,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(he){return!!(he.authority===b.Schemas.file&&d.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,t.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===b.Schemas.file)return{fileUri:y.URI.file(he.fsPath)};if(he.authority===b.Schemas.vscodeRemote){const ye=he.path.indexOf(p.posix.sep,1);if(ye!==-1){const be=he.path.substring(1,ye),ge=he.path.substring(ye),Ie=y.URI.from({scheme:b.Schemas.vscodeRemote,authority:be,path:ge,query:he.query,fragment:he.fragment});return(0,ve.hasWorkspaceFileExtension)(ge)?{workspaceUri:Ie}:/:[\d]+$/.test(ge)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(he){try{if((0,L.statSync)(he).isDirectory())return{folderUri:y.URI.file(he)};if((0,ve.hasWorkspaceFileExtension)(he))return{workspaceUri:y.URI.file(he)}}catch(ye){}return{fileUri:y.URI.file(he)}}async afterWindowOpen(he,ye){this.lifecycleMainService.phase=3;let be=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const ge=he.get(Se.ITelemetryService);this._register(ye.onDidError(({type:ke,details:Ae})=>{let Re;switch(ke){case 1:Re="SharedProcess: detected unresponsive window";break;case 2:Re=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Re=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Re)),ge.publicLog2("sharedprocesserror",{type:ke,reason:Ae?.reason,code:Ae?.exitCode,visible:ye.isVisible(),shuttingdown:be})}));const Ie=this.productService.win32MutexName;if(d.isWindows&&Ie)try{const ke=K.__$__nodeRequire("windows-mutex").Mutex,Ae=new ke(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(ke){this.logService.error(ke)}v.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(ke,Ae)=>{Ae({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})});const De=he.get(Te.IUpdateService);(De instanceof st.Win32UpdateService||De instanceof Ge.LinuxUpdateService||De instanceof Ue.DarwinUpdateService)&&De.initialize(),(0,Q.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,w.stripComments)(Ae))["enable-crash-reporter"]===void 0){const $e=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof $e=="boolean"?$e:!0,et=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],tt=Ae.substring(0,Ae.length-2).concat(`,
`,et.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(tt))}}catch(ke){this.logService.error(ke)}}stopTracingEventually(he,ye){this.logService.info("Tracing: waiting for windows to get ready...");const be=he.get(C.IDialogMainService);let ge=!1;const Ie=async ke=>{if(ge)return;ge=!0;const Ae=await v.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Ae),buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,I.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Ie(!0),3e4);Promise.all(ye.map(ke=>ke.ready())).then(()=>{clearTimeout(De),Ie(!1)})}};Ce=ue([ee(2,j.IInstantiationService),ee(3,N.ILogService),ee(4,oe.IEnvironmentMainService),ee(5,B.ILifecycleMainService),ee(6,S.IConfigurationService),ee(7,pe.IStateMainService),ee(8,H.IFileService),ee(9,ne.IProductService)],Ce),e.CodeApplication=Ce}),define(J[242],Z([0,1,14,30,31,9,67,17,29,43,33,10,8,72,3,32,25,19,35,56,238,11,16,189,198,23,54,161,20,183,184,69,174,71,22,92,6,181,93,48,21,55,186,95,222,50,224,74,195,39,226,75,60,204]),function(K,e,v,L,k,M,E,r,f,w,t,P,b,p,d,g,I,y,u,h,s,c,i,a,n,o,l,m,S,D,A,W,C,X,te,oe,Y,Q,_,q,z,$,H,U,j,F,R,T,O,B,N,V,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(se){console.error(se.message),v.app.exit(1)}}async startup(){(0,r.setUnexpectedErrorHandler)(me=>console.error(me));const[se,ae,pe,fe,we,Pe,Se]=this.createServices();try{try{await this.initServices(pe,fe,we)}catch(me){throw this.handleStartupDataDirError(pe,Se.nameLong,me),me}await se.invokeFunction(async me=>{const Ee=me.get(Y.ILogService),Le=me.get(te.ILifecycleMainService),Te=me.get(S.IFileService),Ne=await this.claimInstance(Ee,pe,Le,se,Se,!0);return y.Promises.writeFile(pe.mainLockfile,String(process.pid)).catch(Ue=>{Ee.warn(`Error writing main lockfile: ${Ue.stack}`)}),Pe.logger=new _.SpdLogLogger("main",(0,b.join)(pe.logsPath,"main.log"),!0,Pe.getLevel()),(0,w.once)(Le.onWillShutdown)(Ue=>{Te.dispose(),fe.dispose(),Ue.join(y.Promises.unlink(pe.mainLockfile).catch(()=>{}))}),se.createInstance(s.CodeApplication,Ne,ae).startup()})}catch(me){se.invokeFunction(this.quit,me)}}createServices(){const se=new X.ServiceCollection,ae={_serviceBrand:void 0,...q.default};se.set(z.IProductService,ae);const pe=new o.EnvironmentMainService(this.resolveArgs(),ae),fe=this.patchEnvironment(pe);se.set(o.IEnvironmentMainService,pe);const we=new oe.BufferLogService,Pe=new Y.MultiplexLogService([new Y.ConsoleMainLogger((0,Y.getLogLevel)(pe)),we]);process.once("exit",()=>Pe.dispose()),se.set(Y.ILogService,Pe);const Se=new D.FileService(Pe);se.set(S.IFileService,Se);const me=new A.DiskFileSystemProvider(Pe);Se.registerProvider(P.Schemas.file,me),se.set(Y.ILoggerService,new Q.LoggerService(Pe,Se));const Ee=new a.ConfigurationService(pe.settingsResource,Se);se.set(i.IConfigurationService,Ee),se.set(te.ILifecycleMainService,new W.SyncDescriptor(te.LifecycleMainService));const Le=new N.StateMainService(pe,Pe,Se);return se.set(B.IStateMainService,Le),se.set(F.IRequestService,new W.SyncDescriptor(R.RequestMainService)),se.set(x.IThemeMainService,new W.SyncDescriptor(x.ThemeMainService)),se.set(T.ISignService,new W.SyncDescriptor(O.SignService)),se.set(U.ITunnelService,new W.SyncDescriptor(j.TunnelService)),se.set($.IProtocolMainService,new W.SyncDescriptor(H.ProtocolMainService)),[new C.InstantiationService(se,!0),fe,pe,Ee,Le,we,ae]}patchEnvironment(se){const ae={VSCODE_IPC_HOOK:se.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(pe=>{const fe=process.env[pe];typeof fe=="string"&&(ae[pe]=fe)}),Object.assign(process.env,ae),ae}initServices(se,ae,pe){return M.Promises.settled([Promise.all([se.extensionsPath,se.codeCachePath,se.logsPath,se.globalStorageHome.fsPath,se.workspaceStorageHome.fsPath,se.backupHome].map(fe=>fe?y.Promises.mkdir(fe,{recursive:!0}):void 0)),ae.initialize(),pe.init()])}async claimInstance(se,ae,pe,fe,we,Pe){let Se;try{(0,p.mark)("code/willStartMainServer"),Se=await(0,h.serve)(ae.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,w.once)(pe.onWillShutdown)(()=>Se.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,we.nameLong,me),me;let Ee;try{Ee=await(0,h.connect)(ae.mainIPCHandle,"main")}catch(Ne){if(!Pe||d.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,we.nameShort),(0,c.localize)(1,null),we.nameLong),Ne;try{(0,L.unlinkSync)(ae.mainIPCHandle)}catch(Ue){throw se.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(se,ae,pe,fe,we,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw se.error(Ne),Ee.dispose(),new Error(Ne)}let Le;!ae.args.wait&&!ae.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,we.nameShort),(0,c.localize)(3,null),we.nameLong)},1e4));const Te=u.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return fe.invokeFunction(async()=>{const Ne=new n.DiagnosticsService(V.NullTelemetryService,we),Ue=await Te.getMainProcessInfo(),Ge=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(Ue,Ge);throw console.log(Be),new r.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Te,se),se.trace("Sending env to running instance..."),await Te.start(ae.args,process.env),Ee.dispose(),Le&&clearTimeout(Le),new r.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw se.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new r.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(se,ae,pe){if(pe.code==="EACCES"||pe.code==="EPERM"){const fe=(0,k.coalesce)([se.userDataPath,se.extensionsPath,h.XDG_RUNTIME_DIR]).map(we=>(0,t.getPathLabel)(we,se));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,E.toErrorMessage)(pe),fe.join(`
`)),ae)}}showStartupWarningDialog(se,ae,pe){v.dialog.showMessageBoxSync({title:pe,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,c.localize)(6,null))],message:se,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(se,ae){if(d.isWindows){const pe=await se.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",pe);try{(await new Promise((fe,we)=>{K(["windows-foreground-love"],fe,we)})).allowSetForegroundWindow(pe)}catch(fe){ae.error(fe)}}}quit(se,ae){const pe=se.get(Y.ILogService),fe=se.get(te.ILifecycleMainService);let we=0;ae&&(ae.isExpected?ae.message&&pe.trace(ae.message):(we=1,ae.stack?pe.error(ae.stack):pe.error(`Startup error: ${ae.toString()}`))),fe.kill(we)}resolveArgs(){const se=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(se.wait&&!se.waitMarkerFilePath){const ae=(0,m.createWaitMarkerFile)(se.verbose);ae&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",ae),se.waitMarkerFilePath=ae)}return se}validatePaths(se){if(se["open-url"]&&(se._urls=se._,se._=[]),!se.remote){const ae=this.doValidatePaths(se._,se.goto);se._=ae}return se}doValidatePaths(se,ae){const pe=(0,g.cwd)(),fe=se.map(Se=>{let me=String(Se),Ee;ae&&(Ee=(0,f.parseLineAndColumnAware)(me),me=Ee.path),me&&(me=this.preparePath(pe,me));const Le=(0,f.sanitizeFilePath)(me,pe),Te=(0,b.basename)(Le);return Te&&!(0,f.isValidBasename)(Te)?null:ae&&Ee?(Ee.path=Le,this.toPath(Ee)):Le}),we=d.isWindows||d.isMacintosh,Pe=(0,k.distinct)(fe,Se=>Se&&we?Se.toLowerCase():Se||"");return(0,k.coalesce)(Pe)}preparePath(se,ae){return d.isWindows&&(ae=(0,I.rtrim)(ae,'"')),ae=(0,I.trim)((0,I.trim)(ae," "),"	"),d.isWindows&&(ae=(0,b.resolve)(se,ae),ae=(0,I.rtrim)(ae,".")),ae}toPath(se){const ae=[se.path];return typeof se.line=="number"&&ae.push(String(se.line)),typeof se.column=="number"&&ae.push(String(se.column)),ae.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/df115e761ae11cf87ca569ca1824b7257099553a/core/vs/code/electron-main/main.js.map
