/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/base/common/errors","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/strings","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/telemetry/common/telemetryService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ie=function($){for(var t=[],T=0,P=$.length;T<P;T++)t[T]=te[$[T]];return t};define(te[58],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function T(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=T}),define(te[46],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function T(D){return(R,c,d)=>{let g=null,I=null;if(typeof d.value=="function"?(g="value",I=d.value):typeof d.get=="function"&&(g="get",I=d.get),!I)throw new Error("not supported");d[g]=D(I,c)}}t.createDecorator=T;function P(D,R,c){let d=null,g=null;if(typeof c.value=="function"?(d="value",g=c.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",g=c.get),!g)throw new Error("not supported");const I=`$memoize$${R}`;c[d]=function(...f){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,f)}),this[I]}}t.memoize=P;function S(D,R,c){return T((d,g)=>{const I=`$debounce$${g}`,f=`$debounce$result$${g}`;return function(...v){this[f]||(this[f]=c?c():void 0),clearTimeout(this[I]),R&&(this[f]=R(this[f],...v),v=[this[f]]),this[I]=setTimeout(()=>{d.apply(this,v),this[f]=c?c():void 0},D)}})}t.debounce=S;function L(D,R,c){return T((d,g)=>{const I=`$throttle$timer$${g}`,f=`$throttle$result$${g}`,v=`$throttle$lastRun$${g}`,l=`$throttle$pending$${g}`;return function(...u){if(this[f]||(this[f]=c?c():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...u)),this[l])return;const p=this[v]+D;p<=Date.now()?(this[v]=Date.now(),d.apply(this,[this[f]]),this[f]=c?c():void 0):(this[l]=!0,this[I]=setTimeout(()=>{this[l]=!1,this[v]=Date.now(),d.apply(this,[this[f]]),this[f]=c?c():void 0},p-Date.now()))}})}t.throttle=L}),define(te[59],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var T;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(T=t.ScanError||(t.ScanError={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var L;(function(e){e.DEFAULT={allowTrailingComma:!0}})(L=t.ParseOptions||(t.ParseOptions={}));function D(e,n=!1){let i=0,s=e.length,a="",E=0,b=16,A=0;function w(ee){let G=0,Y=0;for(;G<ee;){const Z=e.charCodeAt(i);if(Z>=48&&Z<=57)Y=Y*16+Z-48;else if(Z>=65&&Z<=70)Y=Y*16+Z-65+10;else if(Z>=97&&Z<=102)Y=Y*16+Z-97+10;else break;i++,G++}return G<ee&&(Y=-1),Y}function C(ee){i=ee,a="",E=0,b=16,A=0}function U(){const ee=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&d(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&d(e.charCodeAt(i)))for(i++;i<e.length&&d(e.charCodeAt(i));)i++;else return A=3,e.substring(ee,i);let G=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&d(e.charCodeAt(i))){for(i++;i<e.length&&d(e.charCodeAt(i));)i++;G=i}else A=3;return e.substring(ee,G)}function V(){let ee="",G=i;for(;;){if(i>=s){ee+=e.substring(G,i),A=2;break}const Y=e.charCodeAt(i);if(Y===34){ee+=e.substring(G,i),i++;break}if(Y===92){if(ee+=e.substring(G,i),i++,i>=s){A=2;break}switch(e.charCodeAt(i++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const re=w(4);re>=0?ee+=String.fromCharCode(re):A=4;break;default:A=5}G=i;continue}if(Y>=0&&Y<=31)if(c(Y)){ee+=e.substring(G,i),A=2;break}else A=6;i++}return ee}function J(){if(a="",A=0,E=i,i>=s)return E=s,b=17;let ee=e.charCodeAt(i);if(R(ee)){do i++,a+=String.fromCharCode(ee),ee=e.charCodeAt(i);while(R(ee));return b=15}if(c(ee))return i++,a+=String.fromCharCode(ee),ee===13&&e.charCodeAt(i)===10&&(i++,a+=`
`),b=14;switch(ee){case 123:return i++,b=1;case 125:return i++,b=2;case 91:return i++,b=3;case 93:return i++,b=4;case 58:return i++,b=6;case 44:return i++,b=5;case 34:return i++,a=V(),b=10;case 47:const G=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<s&&!c(e.charCodeAt(i));)i++;return a=e.substring(G,i),b=12}if(e.charCodeAt(i+1)===42){i+=2;const Y=s-1;let Z=!1;for(;i<Y;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,Z=!0;break}i++}return Z||(i++,A=1),a=e.substring(G,i),b=13}return a+=String.fromCharCode(ee),i++,b=16;case 45:if(a+=String.fromCharCode(ee),i++,i===s||!d(e.charCodeAt(i)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=U(),b=11;default:for(;i<s&&ne(ee);)i++,ee=e.charCodeAt(i);if(E!==i){switch(a=e.substring(E,i),a){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return a+=String.fromCharCode(ee),i++,b=16}}function ne(ee){if(R(ee)||c(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ee;do ee=J();while(ee>=12&&ee<=15);return ee}return{setPosition:C,getPosition:()=>i,scan:n?se:J,getToken:()=>b,getTokenValue:()=>a,getTokenOffset:()=>E,getTokenLength:()=>i-E,getTokenError:()=>A}}t.createScanner=D;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var g;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(g||(g={}));function I(e,n){const i=[],s=new Object;let a;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function A(w,C,U,V){E.value=w,E.offset=C,E.length=U,E.type=V,E.colonOffset=void 0,a=E}try{h(e,{onObjectBegin:(w,C)=>{if(n<=w)throw s;a=void 0,b=n>w,i.push("")},onObjectProperty:(w,C,U)=>{if(n<C||(A(w,C,U,"property"),i[i.length-1]=w,n<=C+U))throw s},onObjectEnd:(w,C)=>{if(n<=w)throw s;a=void 0,i.pop()},onArrayBegin:(w,C)=>{if(n<=w)throw s;a=void 0,i.push(0)},onArrayEnd:(w,C)=>{if(n<=w)throw s;a=void 0,i.pop()},onLiteralValue:(w,C,U)=>{if(n<C||(A(w,C,U,r(w)),n<=C+U))throw s},onSeparator:(w,C,U)=>{if(n<=C)throw s;if(w===":"&&a&&a.type==="property")a.colonOffset=C,b=!1,a=void 0;else if(w===","){const V=i[i.length-1];typeof V=="number"?i[i.length-1]=V+1:(b=!0,i[i.length-1]=""),a=void 0}}})}catch(w){if(w!==s)throw w}return{path:i,previousNode:a,isAtPropertyKey:b,matches:w=>{let C=0;for(let U=0;C<w.length&&U<i.length;U++)if(w[C]===i[U]||w[C]==="*")C++;else if(w[C]!=="**")return!1;return C===w.length}}}t.getLocation=I;function f(e,n=[],i=L.DEFAULT){let s=null,a=[];const E=[];function b(w){Array.isArray(a)?a.push(w):s!==null&&(a[s]=w)}return h(e,{onObjectBegin:()=>{const w={};b(w),E.push(a),a=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{a=E.pop()},onArrayBegin:()=>{const w=[];b(w),E.push(a),a=w,s=null},onArrayEnd:()=>{a=E.pop()},onLiteralValue:b,onError:(w,C,U)=>{n.push({error:w,offset:C,length:U})}},i),a[0]}t.parse=f;function v(e,n=[],i=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){s.type==="property"&&(s.length=w-s.offset,s=s.parent)}function E(w){return s.children.push(w),w}h(e,{onObjectBegin:w=>{s=E({type:"object",offset:w,length:-1,parent:s,children:[]})},onObjectProperty:(w,C,U)=>{s=E({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:w,offset:C,length:U,parent:s})},onObjectEnd:(w,C)=>{s.length=w+C-s.offset,s=s.parent,a(w+C)},onArrayBegin:(w,C)=>{s=E({type:"array",offset:w,length:-1,parent:s,children:[]})},onArrayEnd:(w,C)=>{s.length=w+C-s.offset,s=s.parent,a(w+C)},onLiteralValue:(w,C,U)=>{E({type:r(w),offset:C,length:U,parent:s,value:w}),a(C+U)},onSeparator:(w,C,U)=>{s.type==="property"&&(w===":"?s.colonOffset=C:w===","&&a(C))},onError:(w,C,U)=>{n.push({error:w,offset:C,length:U})}},i);const A=s.children[0];return A&&delete A.parent,A}t.parseTree=v;function l(e,n){if(!e)return;let i=e;for(let s of n)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const E of i.children)if(Array.isArray(E.children)&&E.children[0].value===s){i=E.children[1],a=!0;break}if(!a)return}else{const a=s;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}t.findNodeAtLocation=l;function u(e){if(!e.parent||!e.parent.children)return[];const n=u(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;n.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&n.push(i)}return n}t.getNodePath=u;function p(e){switch(e.type){case"array":return e.children.map(p);case"object":const n=Object.create(null);for(let i of e.children){const s=i.children[1];s&&(n[i.children[0].value]=p(s))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=p;function m(e,n,i=!1){return n>=e.offset&&n<e.offset+e.length||i&&n===e.offset+e.length}t.contains=m;function y(e,n,i=!1){if(m(e,n,i)){const s=e.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=n;a++){const E=y(s[a],n,i);if(E)return E}return e}}t.findNodeAtOffset=y;function h(e,n,i=L.DEFAULT){const s=D(e,!1);function a(k){return k?()=>k(s.getTokenOffset(),s.getTokenLength()):()=>!0}function E(k){return k?F=>k(F,s.getTokenOffset(),s.getTokenLength()):()=>!0}const b=a(n.onObjectBegin),A=E(n.onObjectProperty),w=a(n.onObjectEnd),C=a(n.onArrayBegin),U=a(n.onArrayEnd),V=E(n.onLiteralValue),J=E(n.onSeparator),ne=a(n.onComment),se=E(n.onError),ee=i&&i.disallowComments,G=i&&i.allowTrailingComma;function Y(){for(;;){const k=s.scan();switch(s.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:ee||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(k){case 12:case 13:ee?Z(10):ne();break;case 16:Z(1);break;case 15:case 14:break;default:return k}}}function Z(k,F=[],N=[]){if(se(k),F.length+N.length>0){let M=s.getToken();for(;M!==17;){if(F.indexOf(M)!==-1){Y();break}else if(N.indexOf(M)!==-1)break;M=Y()}}}function re(k){const F=s.getTokenValue();return k?V(F):A(F),Y(),!0}function j(){switch(s.getToken()){case 11:let k=0;try{k=JSON.parse(s.getTokenValue()),typeof k!="number"&&(Z(2),k=0)}catch(F){Z(2)}V(k);break;case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return Y(),!0}function O(){return s.getToken()!==10?(Z(3,[],[2,5]),!1):(re(!1),s.getToken()===6?(J(":"),Y(),H()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function z(){b(),Y();let k=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(k||Z(4,[],[]),J(","),Y(),s.getToken()===2&&G)break}else k&&Z(6,[],[]);O()||Z(4,[],[2,5]),k=!0}return w(),s.getToken()!==2?Z(7,[2],[]):Y(),!0}function W(){C(),Y();let k=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(k||Z(4,[],[]),J(","),Y(),s.getToken()===4&&G)break}else k&&Z(6,[],[]);H()||Z(4,[],[4,5]),k=!0}return U(),s.getToken()!==4?Z(8,[4],[]):Y(),!0}function H(){switch(s.getToken()){case 3:return W();case 1:return z();case 10:return re(!0);default:return j()}}return Y(),s.getToken()===17?i.allowEmptyContent?!0:(Z(4,[],[]),!1):H()?(s.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}t.visit=h;function o(e,n){let i=D(e),s=[],a,E=0,b;do switch(b=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:E!==b&&s.push(e.substring(E,b)),n!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,n)),E=i.getPosition();break}while(a!==17);return s.join("")}t.stripComments=o;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r}),function(){function $(S){const L=[];typeof S=="number"&&L.push("code/timeOrigin",S);function D(c){L.push(c,Date.now())}function R(){const c=[];for(let d=0;d<L.length;d+=2)c.push({name:L[d],startTime:L[d+1]});return c}return{mark:D,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(S+D.startTime)});return L}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function T(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=T(P))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var T=t();for(var P in T)(typeof exports=="object"?exports:$)[P]=T[P]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function T(P){if(t[P])return t[P].exports;var S=t[P]={i:P,l:!1,exports:{}};return $[P].call(S.exports,S,S.exports,T),S.l=!0,S.exports}return T.m=$,T.c=t,T.d=function(P,S,L){T.o(P,S)||Object.defineProperty(P,S,{enumerable:!0,get:L})},T.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},T.t=function(P,S){if(1&S&&(P=T(P)),8&S||4&S&&typeof P=="object"&&P&&P.__esModule)return P;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:P}),2&S&&typeof P!="string")for(var D in P)T.d(L,D,function(R){return P[R]}.bind(null,D));return L},T.n=function(P){var S=P&&P.__esModule?function(){return P.default}:function(){return P};return T.d(S,"a",S),S},T.o=function(P,S){return Object.prototype.hasOwnProperty.call(P,S)},T.p="",T(T.s=0)}([function($,t,T){(function(P){var S;t=$.exports=N,S=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],c=t.src=[],d=0,g=d++;c[g]="0|[1-9]\\d*";var I=d++;c[I]="[0-9]+";var f=d++;c[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=d++;c[v]="("+c[g]+")\\.("+c[g]+")\\.("+c[g]+")";var l=d++;c[l]="("+c[I]+")\\.("+c[I]+")\\.("+c[I]+")";var u=d++;c[u]="(?:"+c[g]+"|"+c[f]+")";var p=d++;c[p]="(?:"+c[I]+"|"+c[f]+")";var m=d++;c[m]="(?:-("+c[u]+"(?:\\."+c[u]+")*))";var y=d++;c[y]="(?:-?("+c[p]+"(?:\\."+c[p]+")*))";var h=d++;c[h]="[0-9A-Za-z-]+";var o=d++;c[o]="(?:\\+("+c[h]+"(?:\\."+c[h]+")*))";var r=d++,e="v?"+c[v]+c[m]+"?"+c[o]+"?";c[r]="^"+e+"$";var n="[v=\\s]*"+c[l]+c[y]+"?"+c[o]+"?",i=d++;c[i]="^"+n+"$";var s=d++;c[s]="((?:<|>)?=?)";var a=d++;c[a]=c[I]+"|x|X|\\*";var E=d++;c[E]=c[g]+"|x|X|\\*";var b=d++;c[b]="[v=\\s]*("+c[E]+")(?:\\.("+c[E]+")(?:\\.("+c[E]+")(?:"+c[m]+")?"+c[o]+"?)?)?";var A=d++;c[A]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[y]+")?"+c[o]+"?)?)?";var w=d++;c[w]="^"+c[s]+"\\s*"+c[b]+"$";var C=d++;c[C]="^"+c[s]+"\\s*"+c[A]+"$";var U=d++;c[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=d++;c[V]="(?:~>?)";var J=d++;c[J]="(\\s*)"+c[V]+"\\s+",R[J]=new RegExp(c[J],"g");var ne=d++;c[ne]="^"+c[V]+c[b]+"$";var se=d++;c[se]="^"+c[V]+c[A]+"$";var ee=d++;c[ee]="(?:\\^)";var G=d++;c[G]="(\\s*)"+c[ee]+"\\s+",R[G]=new RegExp(c[G],"g");var Y=d++;c[Y]="^"+c[ee]+c[b]+"$";var Z=d++;c[Z]="^"+c[ee]+c[A]+"$";var re=d++;c[re]="^"+c[s]+"\\s*("+n+")$|^$";var j=d++;c[j]="^"+c[s]+"\\s*("+e+")$|^$";var O=d++;c[O]="(\\s*)"+c[s]+"\\s*("+n+"|"+c[b]+")",R[O]=new RegExp(c[O],"g");var z=d++;c[z]="^\\s*("+c[b]+")\\s+-\\s+("+c[b]+")\\s*$";var W=d++;c[W]="^\\s*("+c[A]+")\\s+-\\s+("+c[A]+")\\s*$";var H=d++;c[H]="(<|>)?=?\\s*\\*";for(var k=0;k<35;k++)S(k,c[k]),R[k]||(R[k]=new RegExp(c[k]));function F(x,q){if(x instanceof N)return x;if(typeof x!="string"||x.length>L||!(q?R[i]:R[r]).test(x))return null;try{return new N(x,q)}catch(_){return null}}function N(x,q){if(x instanceof N){if(x.loose===q)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof N))return new N(x,q);S("SemVer",x,q),this.loose=q;var _=x.trim().match(q?R[i]:R[r]);if(!_)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var ue=+oe;if(ue>=0&&ue<D)return ue}return oe}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}t.parse=F,t.valid=function(x,q){var _=F(x,q);return _?_.version:null},t.clean=function(x,q){var _=F(x.trim().replace(/^[=v]+/,""),q);return _?_.version:null},t.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(x){return S("SemVer.compare",this.version,this.loose,x),x instanceof N||(x=new N(x,this.loose)),this.compareMain(x)||this.comparePre(x)},N.prototype.compareMain=function(x){return x instanceof N||(x=new N(x,this.loose)),B(this.major,x.major)||B(this.minor,x.minor)||B(this.patch,x.patch)},N.prototype.comparePre=function(x){if(x instanceof N||(x=new N(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var q=0;do{var _=this.prerelease[q],oe=x.prerelease[q];if(S("prerelease compare",q,_,oe),_===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(_===void 0)return-1;if(_!==oe)return B(_,oe)}while(++q)},N.prototype.inc=function(x,q){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,q,_,oe){typeof _=="string"&&(oe=_,_=void 0);try{return new N(x,_).inc(q,oe).version}catch(ue){return null}},t.diff=function(x,q){if(le(x,q))return null;var _=F(x),oe=F(q);if(_.prerelease.length||oe.prerelease.length){for(var ue in _)if((ue==="major"||ue==="minor"||ue==="patch")&&_[ue]!==oe[ue])return"pre"+ue;return"prerelease"}for(var ue in _)if((ue==="major"||ue==="minor"||ue==="patch")&&_[ue]!==oe[ue])return ue},t.compareIdentifiers=B;var M=/^[0-9]+$/;function B(x,q){var _=M.test(x),oe=M.test(q);return _&&oe&&(x=+x,q=+q),_&&!oe?-1:oe&&!_?1:x<q?-1:x>q?1:0}function K(x,q,_){return new N(x,_).compare(new N(q,_))}function Q(x,q,_){return K(x,q,_)>0}function X(x,q,_){return K(x,q,_)<0}function le(x,q,_){return K(x,q,_)===0}function de(x,q,_){return K(x,q,_)!==0}function ce(x,q,_){return K(x,q,_)>=0}function Ee(x,q,_){return K(x,q,_)<=0}function we(x,q,_,oe){var ue;switch(q){case"===":typeof x=="object"&&(x=x.version),typeof _=="object"&&(_=_.version),ue=x===_;break;case"!==":typeof x=="object"&&(x=x.version),typeof _=="object"&&(_=_.version),ue=x!==_;break;case"":case"=":case"==":ue=le(x,_,oe);break;case"!=":ue=de(x,_,oe);break;case">":ue=Q(x,_,oe);break;case">=":ue=ce(x,_,oe);break;case"<":ue=X(x,_,oe);break;case"<=":ue=Ee(x,_,oe);break;default:throw new TypeError("Invalid operator: "+q)}return ue}function pe(x,q){if(x instanceof pe){if(x.loose===q)return x;x=x.value}if(!(this instanceof pe))return new pe(x,q);S("comparator",x,q),this.loose=q,this.parse(x),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(x,q){return B(q,x)},t.major=function(x,q){return new N(x,q).major},t.minor=function(x,q){return new N(x,q).minor},t.patch=function(x,q){return new N(x,q).patch},t.compare=K,t.compareLoose=function(x,q){return K(x,q,!0)},t.rcompare=function(x,q,_){return K(q,x,_)},t.sort=function(x,q){return x.sort(function(_,oe){return t.compare(_,oe,q)})},t.rsort=function(x,q){return x.sort(function(_,oe){return t.rcompare(_,oe,q)})},t.gt=Q,t.lt=X,t.eq=le,t.neq=de,t.gte=ce,t.lte=Ee,t.cmp=we,t.Comparator=pe;var Re={};function ve(x,q){if(x instanceof ve)return x.loose===q?x:new ve(x.raw,q);if(x instanceof pe)return new ve(x.value,q);if(!(this instanceof ve))return new ve(x,q);if(this.loose=q,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function be(x){return!x||x.toLowerCase()==="x"||x==="*"}function ze(x,q,_,oe,ue,De,me,Oe,Pe,Ce,ke,Ie,Le){return((q=be(_)?"":be(oe)?">="+_+".0.0":be(ue)?">="+_+"."+oe+".0":">="+q)+" "+(Oe=be(Pe)?"":be(Ce)?"<"+(+Pe+1)+".0.0":be(ke)?"<"+Pe+"."+(+Ce+1)+".0":Ie?"<="+Pe+"."+Ce+"."+ke+"-"+Ie:"<="+Oe)).trim()}function je(x,q){for(var _=0;_<x.length;_++)if(!x[_].test(q))return!1;if(q.prerelease.length){for(_=0;_<x.length;_++)if(S(x[_].semver),x[_].semver!==Re&&x[_].semver.prerelease.length>0){var oe=x[_].semver;if(oe.major===q.major&&oe.minor===q.minor&&oe.patch===q.patch)return!0}return!1}return!0}function Ue(x,q,_){try{q=new ve(q,_)}catch(oe){return!1}return q.test(x)}function We(x,q,_,oe){var ue,De,me,Oe,Pe;switch(x=new N(x,oe),q=new ve(q,oe),_){case">":ue=Q,De=Ee,me=X,Oe=">",Pe=">=";break;case"<":ue=X,De=ce,me=Q,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,q,oe))return!1;for(var Ce=0;Ce<q.set.length;++Ce){var ke=q.set[Ce],Ie=null,Le=null;if(ke.forEach(function(Fe){Fe.semver===Re&&(Fe=new pe(">=0.0.0")),Ie=Ie||Fe,Le=Le||Fe,ue(Fe.semver,Ie.semver,oe)?Ie=Fe:me(Fe.semver,Le.semver,oe)&&(Le=Fe)}),Ie.operator===Oe||Ie.operator===Pe||(!Le.operator||Le.operator===Oe)&&De(x,Le.semver)||Le.operator===Pe&&me(x,Le.semver))return!1}return!0}pe.prototype.parse=function(x){var q=this.loose?R[re]:R[j],_=x.match(q);if(!_)throw new TypeError("Invalid comparator: "+x);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new N(_[2],this.loose):this.semver=Re},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return S("Comparator.test",x,this.loose),this.semver===Re||(typeof x=="string"&&(x=new N(x,this.loose)),we(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,q){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new ve(x.value,q),Ue(this.value,_,q);if(x.operator==="")return _=new ve(this.value,q),Ue(x.semver,_,q);var oe=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ue=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,me=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Oe=we(this.semver,"<",x.semver,q)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Pe=we(this.semver,">",x.semver,q)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return oe||ue||De&&me||Oe||Pe},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(x){var q=this.loose;x=x.trim(),S("range",x,q);var _=q?R[W]:R[z];x=x.replace(_,ze),S("hyphen replace",x),x=x.replace(R[O],"$1$2$3"),S("comparator trim",x,R[O]),x=(x=(x=x.replace(R[J],"$1~")).replace(R[G],"$1^")).split(/\s+/).join(" ");var oe=q?R[re]:R[j],ue=x.split(" ").map(function(De){return function(me,Oe){return S("comp",me),me=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){S("caret",Ie,Le);var Fe=Le?R[Z]:R[Y];return Ie.replace(Fe,function(Ae,he,ge,ye,Se){var Te;return S("caret",Ie,Ae,he,ge,ye,Se),be(he)?Te="":be(ge)?Te=">="+he+".0.0 <"+(+he+1)+".0.0":be(ye)?Te=he==="0"?">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0":">="+he+"."+ge+".0 <"+(+he+1)+".0.0":Se?(S("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Te=he==="0"?ge==="0"?">="+he+"."+ge+"."+ye+Se+" <"+he+"."+ge+"."+(+ye+1):">="+he+"."+ge+"."+ye+Se+" <"+he+"."+(+ge+1)+".0":">="+he+"."+ge+"."+ye+Se+" <"+(+he+1)+".0.0"):(S("no pr"),Te=he==="0"?ge==="0"?">="+he+"."+ge+"."+ye+" <"+he+"."+ge+"."+(+ye+1):">="+he+"."+ge+"."+ye+" <"+he+"."+(+ge+1)+".0":">="+he+"."+ge+"."+ye+" <"+(+he+1)+".0.0"),S("caret return",Te),Te})}(ke,Ce)}).join(" ")}(me,Oe),S("caret",me),me=function(Pe,Ce){return Pe.trim().split(/\s+/).map(function(ke){return function(Ie,Le){var Fe=Le?R[se]:R[ne];return Ie.replace(Fe,function(Ae,he,ge,ye,Se){var Te;return S("tilde",Ie,Ae,he,ge,ye,Se),be(he)?Te="":be(ge)?Te=">="+he+".0.0 <"+(+he+1)+".0.0":be(ye)?Te=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0":Se?(S("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),Te=">="+he+"."+ge+"."+ye+Se+" <"+he+"."+(+ge+1)+".0"):Te=">="+he+"."+ge+"."+ye+" <"+he+"."+(+ge+1)+".0",S("tilde return",Te),Te})}(ke,Ce)}).join(" ")}(me,Oe),S("tildes",me),me=function(Pe,Ce){return S("replaceXRanges",Pe,Ce),Pe.split(/\s+/).map(function(ke){return function(Ie,Le){Ie=Ie.trim();var Fe=Le?R[C]:R[w];return Ie.replace(Fe,function(Ae,he,ge,ye,Se,Te){S("xRange",Ie,Ae,he,ge,ye,Se,Te);var Ve=be(ge),Me=Ve||be(ye),xe=Me||be(Se);return he==="="&&xe&&(he=""),Ve?Ae=he===">"||he==="<"?"<0.0.0":"*":he&&xe?(Me&&(ye=0),xe&&(Se=0),he===">"?(he=">=",Me?(ge=+ge+1,ye=0,Se=0):xe&&(ye=+ye+1,Se=0)):he==="<="&&(he="<",Me?ge=+ge+1:ye=+ye+1),Ae=he+ge+"."+ye+"."+Se):Me?Ae=">="+ge+".0.0 <"+(+ge+1)+".0.0":xe&&(Ae=">="+ge+"."+ye+".0 <"+ge+"."+(+ye+1)+".0"),S("xRange return",Ae),Ae})}(ke,Ce)}).join(" ")}(me,Oe),S("xrange",me),me=function(Pe,Ce){return S("replaceStars",Pe,Ce),Pe.trim().replace(R[H],"")}(me,Oe),S("stars",me),me}(De,q)}).join(" ").split(/\s+/);return this.loose&&(ue=ue.filter(function(De){return!!De.match(oe)})),ue=ue.map(function(De){return new pe(De,q)})},ve.prototype.intersects=function(x,q){if(!(x instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(oe){return x.set.some(function(ue){return ue.every(function(De){return oe.intersects(De,q)})})})})},t.toComparators=function(x,q){return new ve(x,q).set.map(function(_){return _.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new N(x,this.loose));for(var q=0;q<this.set.length;q++)if(je(this.set[q],x))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(x,q,_){var oe=null,ue=null;try{var De=new ve(q,_)}catch(me){return null}return x.forEach(function(me){De.test(me)&&(oe&&ue.compare(me)!==-1||(ue=new N(oe=me,_)))}),oe},t.minSatisfying=function(x,q,_){var oe=null,ue=null;try{var De=new ve(q,_)}catch(me){return null}return x.forEach(function(me){De.test(me)&&(oe&&ue.compare(me)!==1||(ue=new N(oe=me,_)))}),oe},t.validRange=function(x,q){try{return new ve(x,q).range||"*"}catch(_){return null}},t.ltr=function(x,q,_){return We(x,q,"<",_)},t.gtr=function(x,q,_){return We(x,q,">",_)},t.outside=We,t.prerelease=function(x,q){var _=F(x,q);return _&&_.prerelease.length?_.prerelease:null},t.intersects=function(x,q,_){return x=new ve(x,_),q=new ve(q,_),x.intersects(q)},t.coerce=function(x){if(x instanceof N)return x;if(typeof x!="string")return null;var q=x.match(R[U]);return q==null?null:F((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,T(1))},function($,t){var T,P,S=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function R(p){if(T===setTimeout)return setTimeout(p,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(p,0);try{return T(p,0)}catch(m){try{return T.call(null,p,0)}catch(y){return T.call(this,p,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch(p){T=L}try{P=typeof clearTimeout=="function"?clearTimeout:D}catch(p){P=D}})();var c,d=[],g=!1,I=-1;function f(){g&&c&&(g=!1,c.length?d=c.concat(d):I=-1,d.length&&v())}function v(){if(!g){var p=R(f);g=!0;for(var m=d.length;m;){for(c=d,d=[];++I<m;)c&&c[I].run();I=-1,m=d.length}c=null,g=!1,function(y){if(P===clearTimeout)return clearTimeout(y);if((P===D||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(y);try{P(y)}catch(h){try{return P.call(null,y)}catch(o){return P.call(this,y)}}}(p)}}function l(p,m){this.fun=p,this.array=m}function u(){}S.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)m[y-1]=arguments[y];d.push(new l(p,m)),d.length!==1||g||R(v)},l.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=u,S.addListener=u,S.once=u,S.off=u,S.removeListener=u,S.removeAllListeners=u,S.emit=u,S.prependListener=u,S.prependOnceListener=u,S.listeners=function(p){return[]},S.binding=function(p){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(p){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(te[37],ie([0,1,11,2]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=S;function L(h){const o=h;return o?S(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=L;function D(h,o){return new R(h,o)}t.newWriteableStream=D;class R{constructor(o,r){this.reducer=o,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(r=>r(o))}emitError(o){this.listeners.error.length===0?(0,T.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(r=>r(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,r){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(o,r){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const n=e.indexOf(r);n>=0&&e.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(h,o){const r=[];let e;for(;(e=h.read())!==null;)r.push(e);return o(r)}t.consumeReadable=c;function d(h,o,r){const e=[];let n;for(;(n=h.read())!==null&&e.length<r;)e.push(n);return n===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return h.read()}}}t.peekReadable=d;function g(h,o){return new Promise((r,e)=>{const n=[];I(h,{onData:i=>{o&&n.push(i)},onError:i=>{o?e(i):r(void 0)},onEnd:()=>{r(o?o(n):void 0)}})})}t.consumeStream=g;function I(h,o){h.on("error",r=>o.onError(r)),h.on("end",()=>o.onEnd()),h.on("data",r=>o.onData(r))}t.listenStream=I;function f(h,o){return new Promise((r,e)=>{const n=new P.DisposableStore,i=[],s=b=>{if(i.push(b),i.length>o)return n.dispose(),h.pause(),r({stream:h,buffer:i,ended:!1})},a=b=>e(b),E=()=>r({stream:h,buffer:i,ended:!0});n.add((0,P.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),n.add((0,P.toDisposable)(()=>h.removeListener("end",E))),h.on("end",E),n.add((0,P.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}t.peekStream=f;function v(h,o){const r=D(o);return r.end(h),r}t.toStream=v;function l(){const h=D(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=l;function u(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=u;function p(h,o,r){const e=D(r);return I(h,{onData:n=>e.write(o.data(n)),onError:n=>e.error(o.error?o.error(n):n),onEnd:()=>e.end()}),e}t.transform=p;function m(h,o,r){let e=!1;return{read:()=>{const n=o.read();return e?n:(e=!0,n!==null?r([h,n]):h)}}}t.prefixedReadable=m;function y(h,o,r){let e=!1;const n=D(r);return I(o,{onData:i=>e?n.write(i):(e=!0,n.write(r([h,i]))),onError:i=>n.error(i),onEnd:()=>{e||(e=!0,n.write(h)),n.end()}}),n}t.prefixedStream=y}),define(te[17],ie([0,1,37]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer!="undefined";let S,L;class D{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return P?new D(Buffer.allocUnsafe(s)):new D(new Uint8Array(s))}static wrap(s){return P&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new D(s)}static fromString(s,a){return!(a?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(s)):(S||(S=new TextEncoder),new D(S.encode(s)))}static concat(s,a){if(typeof a=="undefined"){a=0;for(let A=0,w=s.length;A<w;A++)a+=s[A].byteLength}const E=D.alloc(a);let b=0;for(let A=0,w=s.length;A<w;A++){const C=s[A];E.set(C,b),b+=C.byteLength}return E}toString(){return P?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(s,a){return new D(this.buffer.subarray(s,a))}set(s,a){s instanceof D?this.buffer.set(s.buffer,a):this.buffer.set(s,a)}readUInt32BE(s){return d(this.buffer,s)}writeUInt32BE(s,a){g(this.buffer,s,a)}readUInt32LE(s){return I(this.buffer,s)}writeUInt32LE(s,a){f(this.buffer,s,a)}readUInt8(s){return v(this.buffer,s)}writeUInt8(s,a){l(this.buffer,s,a)}}t.VSBuffer=D;function R(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0}t.readUInt16LE=R;function c(i,s,a){i[a+0]=s&255,s=s>>>8,i[a+1]=s&255}t.writeUInt16LE=c;function d(i,s){return i[s]*2**24+i[s+1]*2**16+i[s+2]*2**8+i[s+3]}t.readUInt32BE=d;function g(i,s,a){i[a+3]=s,s=s>>>8,i[a+2]=s,s=s>>>8,i[a+1]=s,s=s>>>8,i[a]=s}t.writeUInt32BE=g;function I(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0|i[s+2]<<16>>>0|i[s+3]<<24>>>0}t.readUInt32LE=I;function f(i,s,a){i[a+0]=s&255,s=s>>>8,i[a+1]=s&255,s=s>>>8,i[a+2]=s&255,s=s>>>8,i[a+3]=s&255}t.writeUInt32LE=f;function v(i,s){return i[s]}t.readUInt8=v;function l(i,s,a){i[a]=s}t.writeUInt8=l;function u(i){return T.consumeReadable(i,s=>D.concat(s))}t.readableToBuffer=u;function p(i){return T.toReadable(i)}t.bufferToReadable=p;function m(i){return T.consumeStream(i,s=>D.concat(s))}t.streamToBuffer=m;async function y(i){return i.ended?D.concat(i.buffer):D.concat([...i.buffer,await m(i.stream)])}t.bufferedStreamToBuffer=y;function h(i){return T.toStream(i,s=>D.concat(s))}t.bufferToStream=h;function o(i){return T.transform(i,{data:s=>typeof s=="string"?D.fromString(s):D.wrap(s)},s=>D.concat(s))}t.streamToBufferReadableStream=o;function r(i){return T.newWriteableStream(s=>D.concat(s),i)}t.newWriteableBufferStream=r;function e(i,s){return T.prefixedReadable(i,s,a=>D.concat(a))}t.prefixedBufferReadable=e;function n(i,s){return T.prefixedStream(i,s,a=>D.concat(a))}t.prefixedBufferStream=n}),define(te[18],ie([0,1,12]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.keys(u).forEach(m=>{u[m]&&typeof u[m]=="object"?p[m]=P(u[m]):p[m]=u[m]}),p}t.deepClone=P;function S(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const y in m)if(L.call(m,y)){const h=m[y];typeof h=="object"&&!Object.isFrozen(h)&&p.push(h)}}return u}t.deepFreeze=S;const L=Object.prototype.hasOwnProperty;function D(u,p){return R(u,p,new Set)}t.cloneAndChange=D;function R(u,p,m){if((0,T.isUndefinedOrNull)(u))return u;const y=p(u);if(typeof y!="undefined")return y;if((0,T.isArray)(u)){const h=[];for(const o of u)h.push(R(o,p,m));return h}if((0,T.isObject)(u)){if(m.has(u))throw new Error("Cannot clone recursive data-structure");m.add(u);const h={};for(let o in u)L.call(u,o)&&(h[o]=R(u[o],p,m));return m.delete(u),h}return u}function c(u,p,m=!0){return(0,T.isObject)(u)?((0,T.isObject)(p)&&Object.keys(p).forEach(y=>{y in u?m&&((0,T.isObject)(u[y])&&(0,T.isObject)(p[y])?c(u[y],p[y],m):u[y]=p[y]):u[y]=p[y]}),u):p}t.mixin=c;function d(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let m,y;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(m=0;m<u.length;m++)if(!d(u[m],p[m]))return!1}else{const h=[];for(y in u)h.push(y);h.sort();const o=[];for(y in p)o.push(y);if(o.sort(),!d(h,o))return!1;for(m=0;m<h.length;m++)if(!d(u[h[m]],p[h[m]]))return!1}return!0}t.equals=d;function g(u){const p=new Set;return JSON.stringify(u,(m,y)=>{if((0,T.isObject)(y)||Array.isArray(y)){if(p.has(y))return"[Circular]";p.add(y)}return y})}t.safeStringify=g;function I(u,p,m){const y=p(u);return typeof y=="undefined"?m:y}t.getOrDefault=I;function f(u,p){const m=Object.create(null);return!u||!p||Object.keys(p).forEach(h=>{const o=u[h],r=p[h];d(o,r)||(m[h]=r)}),m}t.distinct=f;function v(u,p){const m=p.toLowerCase(),y=Object.keys(u).find(h=>h.toLowerCase()===m);return y?u[y]:u[p]}t.getCaseInsensitive=v;function l(u,p){const m=Object.create(null);for(const y of Object.keys(u))p(y,u[y])&&(m[y]=u[y]);return m}t.filter=l}),define(te[60],ie([0,1,7]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function P(d){const g=d;return g&&typeof g.type=="string"&&typeof g.severity=="string"}t.isRemoteConsoleLog=P;function S(d){const g=[];let I;try{const f=JSON.parse(d.arguments),v=f[f.length-1];v&&v.__$stack&&(f.pop(),I=v.__$stack),g.push(...f)}catch(f){g.push("Unable to log remote console arguments",d.arguments)}return{args:g,stack:I}}t.parse=S;function L(d){if(typeof d!="string")return L(S(d).stack);const g=d;if(g){const I=D(g),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(f&&f.length===4)return{uri:T.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}t.getFirstFrame=L;function D(d){if(!d)return d;const g=d.indexOf(`
`);return g===-1?d:d.substring(0,g)}function R(d,g){const{args:I,stack:f}=S(d),v=typeof I[0]=="string"&&I.length===1;let l=D(f);l&&(l=`(${l.trim()})`);let u=[];if(typeof I[0]=="string"?l&&v?u=[`%c[${g}] %c${I[0]} %c${l}`,c("blue"),c(""),c("grey")]:u=[`%c[${g}] %c${I[0]}`,c("blue"),c(""),...I.slice(1)]:u=[`%c[${g}]%`,c("blue"),...I],l&&!v&&u.push(l),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,u)}t.log=R;function c(d){return`color: ${d}`}}),define(te[61],ie([0,1,17,21,7]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function L(g){return JSON.stringify(g,c)}t.stringify=L;function D(g){let I=JSON.parse(g);return I=d(I),I}t.parse=D;var R;(function(g){g[g.Uri=1]="Uri",g[g.Regexp=2]="Regexp",g[g.ScmResource=3]="ScmResource",g[g.ScmResourceGroup=4]="ScmResourceGroup",g[g.ScmProvider=5]="ScmProvider",g[g.CommentController=6]="CommentController",g[g.CommentThread=7]="CommentThread",g[g.CommentThreadReply=8]="CommentThreadReply",g[g.CommentNode=9]="CommentNode",g[g.CommentThreadNode=10]="CommentThreadNode",g[g.TimelineActionContext=11]="TimelineActionContext",g[g.NotebookCellActionContext=12]="NotebookCellActionContext",g[g.TestItemContext=13]="TestItemContext"})(R=t.MarshalledId||(t.MarshalledId={}));function c(g,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,P.regExpFlags)(I)}:I}function d(g,I=0){if(!g||I>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return S.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof T.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let f=0;f<g.length;++f)g[f]=d(g[f],I+1);else for(const f in g)Object.hasOwnProperty.call(g,f)&&(g[f]=d(g[f],I+1))}return g}t.revive=d}),define(te[62],ie([0,1,3,32,47,4,21]),function($,t,T,P,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const c="**",d="/",g="[/\\\\]",I="[^/\\\\]",f=/\//g;function v(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${g}|${I}+${g}|${g}${I}+)*?`}}function l(O,z){if(!O)return[];const W=[];let H=!1,k=!1,F="";for(const N of O){switch(N){case z:if(!H&&!k){W.push(F),F="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":k=!0;break;case"]":k=!1;break}F+=N}return F&&W.push(F),W}t.splitGlobAware=l;function u(O){if(!O)return"";let z="";const W=l(O,d);if(W.every(H=>H===c))z=".*";else{let H=!1;W.forEach((k,F)=>{if(k===c){H||(z+=v(2),H=!0);return}let N=!1,M="",B=!1,K="";for(const Q of k){if(Q!=="}"&&N){M+=Q;continue}if(B&&(Q!=="]"||!K)){let X;Q==="-"?X=Q:(Q==="^"||Q==="!")&&!K?X="^":Q===d?X="":X=D.escapeRegExpCharacters(Q),K+=X;continue}switch(Q){case"{":N=!0;continue;case"[":B=!0;continue;case"}":z+=`(?:${l(M,",").map(de=>u(de)).join("|")})`,N=!1,M="";break;case"]":z+="["+K+"]",B=!1,K="";break;case"?":z+=I;continue;case"*":z+=v(1);continue;default:z+=D.escapeRegExpCharacters(Q)}}F<W.length-1&&(W[F+1]!==c||F+2<W.length)&&(z+=g),H=!1})}return z}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),n=function(){return!1},i=function(){return null};function s(O,z){if(!O)return i;let W;typeof O!="string"?W=O.pattern:W=O,W=W.trim();const H=`${W}_${!!z.trimForExclusions}`;let k=e.get(H);if(k)return a(k,O);let F;if(p.test(W)){const N=W.substr(4);k=function(M,B){return typeof M=="string"&&M.endsWith(N)?W:null}}else(F=m.exec(E(W,z)))?k=b(F[1],W):(z.trimForExclusions?h:y).test(W)?k=A(W,z):(F=o.exec(E(W,z)))?k=w(F[1].substr(1),W,!0):(F=r.exec(E(W,z)))?k=w(F[1],W,!1):k=C(W);return e.set(H,k),a(k,O)}function a(O,z){return typeof z=="string"?O:function(W,H){return P.isEqualOrParent(W,z.base)?O(L.relative(z.base,W),H):null}}function E(O,z){return z.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function b(O,z){const W=`/${O}`,H=`\\${O}`,k=function(N,M){return typeof N!="string"?null:M?M===O?z:null:N===O||N.endsWith(W)||N.endsWith(H)?z:null},F=[O];return k.basenames=F,k.patterns=[z],k.allBasenames=F,k}function A(O,z){const W=j(O.slice(1,-1).split(",").map(M=>s(M,z)).filter(M=>M!==i),O),H=W.length;if(!H)return i;if(H===1)return W[0];const k=function(M,B){for(let K=0,Q=W.length;K<Q;K++)if(W[K](M,B))return O;return null},F=W.find(M=>!!M.allBasenames);F&&(k.allBasenames=F.allBasenames);const N=W.reduce((M,B)=>B.allPaths?M.concat(B.allPaths):M,[]);return N.length&&(k.allPaths=N),k}function w(O,z,W){const H=L.sep===L.posix.sep,k=H?O:O.replace(f,L.sep),F=L.sep+k,N=L.posix.sep+O,M=W?function(B,K){return typeof B=="string"&&(B===k||B.endsWith(F)||!H&&(B===O||B.endsWith(N)))?z:null}:function(B,K){return typeof B=="string"&&(B===k||!H&&B===O)?z:null};return M.allPaths=[(W?"*/":"./")+O],M}function C(O){try{const z=new RegExp(`^${u(O)}$`);return function(W){return z.lastIndex=0,typeof W=="string"&&z.test(W)?O:null}}catch(z){return i}}function U(O,z,W){return!O||typeof z!="string"?!1:V(O)(z,void 0,W)}t.match=U;function V(O,z={}){if(!O)return n;if(typeof O=="string"||ee(O)){const W=s(O,z);if(W===i)return n;const H=function(k,F){return!!W(k,F)};return W.allBasenames&&(H.allBasenames=W.allBasenames),W.allPaths&&(H.allPaths=W.allPaths),H}return Z(O,z)}t.parse=V;function J(O){if(!O)return;let z;return W=>(z||(z=(O()||Promise.resolve([])).then(H=>H?se(H):{})),z.then(H=>!!H[W]))}t.hasSiblingPromiseFn=J;function ne(O){if(!O)return;let z;return W=>{if(!z){const H=O();z=H?se(H):{}}return!!z[W]}}t.hasSiblingFn=ne;function se(O){const z={};for(const W of O)z[W]=!0;return z}function ee(O){const z=O;return z&&typeof z.base=="string"&&typeof z.pattern=="string"}t.isRelativePattern=ee;function G(O){return O.allBasenames||[]}t.getBasenameTerms=G;function Y(O){return O.allPaths||[]}t.getPathTerms=Y;function Z(O,z){const W=j(Object.getOwnPropertyNames(O).map(M=>re(M,O[M],z)).filter(M=>M!==i)),H=W.length;if(!H)return i;if(!W.some(M=>!!M.requiresSiblings)){if(H===1)return W[0];const M=function(Q,X){for(let le=0,de=W.length;le<de;le++){const ce=W[le](Q,X);if(ce)return ce}return null},B=W.find(Q=>!!Q.allBasenames);B&&(M.allBasenames=B.allBasenames);const K=W.reduce((Q,X)=>X.allPaths?Q.concat(X.allPaths):Q,[]);return K.length&&(M.allPaths=K),M}const k=function(M,B,K){let Q;for(let X=0,le=W.length;X<le;X++){const de=W[X];de.requiresSiblings&&K&&(B||(B=L.basename(M)),Q||(Q=B.substr(0,B.length-L.extname(M).length)));const ce=de(M,B,Q,K);if(ce)return ce}return null},F=W.find(M=>!!M.allBasenames);F&&(k.allBasenames=F.allBasenames);const N=W.reduce((M,B)=>B.allPaths?M.concat(B.allPaths):M,[]);return N.length&&(k.allPaths=N),k}function re(O,z,W){if(z===!1)return i;const H=s(O,W);if(H===i)return i;if(typeof z=="boolean")return H;if(z){const k=z.when;if(typeof k=="string"){const F=(N,M,B,K)=>{if(!K||!H(N,M))return null;const Q=k.replace("$(basename)",B),X=K(Q);return(0,T.isThenable)(X)?X.then(le=>le?O:null):X?O:null};return F.requiresSiblings=!0,F}}return H}function j(O,z){const W=O.filter(M=>!!M.basenames);if(W.length<2)return O;const H=W.reduce((M,B)=>{const K=B.basenames;return K?M.concat(K):M},[]);let k;if(z){k=[];for(let M=0,B=H.length;M<B;M++)k.push(z)}else k=W.reduce((M,B)=>{const K=B.patterns;return K?M.concat(K):M},[]);const F=function(M,B){if(typeof M!="string")return null;if(!B){let Q;for(Q=M.length;Q>0;Q--){const X=M.charCodeAt(Q-1);if(X===47||X===92)break}B=M.substr(Q)}const K=H.indexOf(B);return K!==-1?k[K]:null};F.basenames=H,F.patterns=k,F.allBasenames=H;const N=O.filter(M=>!M.basenames);return N.push(F),N}}),define(te[63],ie([0,1,32,8,4,9,19,21,7]),function($,t,T,P,S,L,D,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(s,a,E){if(typeof s=="string"&&(s=c.URI.file(s)),E){const A=E.getWorkspaceFolder(s);if(A){const w=E.getWorkspace().folders.length>1;let C;if((0,D.isEqual)(A.uri,s)?C="":C=(0,D.relativePath)(A.uri,s),w){const U=A.name?A.name:(0,D.basename)(A.uri);C=C?U+" \u2022 "+C:U}return C}}if(s.scheme!==P.Schemas.file&&s.scheme!==P.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(s.fsPath))return(0,S.normalize)(I(s.fsPath));let b=(0,S.normalize)(s.fsPath);return!L.isWindows&&a?.userHome&&(b=v(b,a.userHome.fsPath)),b}t.getPathLabel=d;function g(s){if(!s)return;typeof s=="string"&&(s=c.URI.file(s));const a=(0,D.basename)(s)||(s.scheme===P.Schemas.file?s.fsPath:s.path);return L.isWindows&&(0,T.isRootOrDriveLetter)(a)?I(a):a}t.getBaseLabel=g;function I(s){return(0,T.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=I;let f=Object.create(null);function v(s,a){if(L.isWindows||!s||!a)return s;let E=f.original===a?f.normalized:void 0;return E||(E=`${(0,R.rtrim)(a,S.posix.sep)}${S.posix.sep}`,f={original:a,normalized:E}),(L.isLinux?s.startsWith(E):(0,R.startsWithIgnoreCase)(s,E))&&(s=`~/${s.substr(E.length)}`),s}t.tildify=v;function l(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=l;const u="\u2026",p="\\\\",m="~";function y(s,a=S.sep){const E=new Array(s.length);let b=!1;for(let A=0;A<s.length;A++){let w=s[A];if(w===""){E[A]=`.${a}`;continue}if(!w){E[A]=w;continue}b=!0;let C="";w.indexOf(p)===0?(C=w.substr(0,w.indexOf(p)+p.length),w=w.substr(w.indexOf(p)+p.length)):w.indexOf(a)===0?(C=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(m)===0&&(C=w.substr(0,w.indexOf(m)+m.length),w=w.substr(w.indexOf(m)+m.length));const U=w.split(a);for(let V=1;b&&V<=U.length;V++)for(let J=U.length-V;b&&J>=0;J--){b=!1;let ne=U.slice(J,J+V).join(a);for(let se=0;!b&&se<s.length;se++)if(se!==A&&s[se]&&s[se].indexOf(ne)>-1){const ee=J+V===U.length,G=J>0&&s[se].indexOf(a)>-1?a+ne:ne,Y=s[se].endsWith(G);b=!ee||Y}if(!b){let se="";(U[0].endsWith(":")||C!=="")&&(J===1&&(J=0,V++,ne=U[0]+a+ne),J>0&&(se=U[0]+a),se=C+se),J>0&&(se=se+u+a),se=se+ne,J+V<U.length&&(se=se+a+u),E[A]=se}}b&&(E[A]=w)}return E}t.shorten=y;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(s,a=Object.create(null)){const E=[];let b=!1,A="";for(const w of s)if(w==="$"||b&&w==="{")A&&E.push({value:A,type:h.TEXT}),A="",b=!0;else if(w==="}"&&b){const C=a[A];if(typeof C=="string")C.length&&E.push({value:C,type:h.VARIABLE});else if(C){const U=E[E.length-1];(!U||U.type!==h.SEPARATOR)&&E.push({value:C.label,type:h.SEPARATOR})}A="",b=!1}else A+=w;return A&&!b&&E.push({value:A,type:h.TEXT}),E.filter((w,C)=>{if(w.type===h.SEPARATOR){const U=E[C-1],V=E[C+1];return[U,V].every(J=>J&&(J.type===h.VARIABLE||J.type===h.TEXT)&&J.value.length>0)}return!0}).map(w=>w.value).join("")}t.template=o;function r(s,a){return L.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):s.replace(/&&|&/g,E=>E==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(s,a){return L.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,""):L.isWindows?s.replace(/&&|&/g,E=>E==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=n;function i(s){const a=s.indexOf("/")!==-1?S.posix:S.win32,E=a.basename(s),b=a.dirname(s);return E.length?{name:E,parentPath:b}:{name:b,parentPath:""}}t.splitName=i}),define(te[48],ie([0,1,127]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class P{constructor(L="utf8"){this.stringDecoder=new T.StringDecoder(L),this.remaining=null}write(L){const D=[],R=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(R.length<1)return D;let c=0,d,g=c;for(;g<R.length;)if(d=R.charCodeAt(g),d===13||d===10){if(D.push(R.substring(c,g)),g++,g<R.length){const I=d;d=R.charCodeAt(g),(I===13&&d===10||I===10&&d===13)&&g++}c=g}else g++;return this.remaining=c<R.length?R.substr(c):null,D}end(){return this.remaining}}t.LineDecoder=P}),define(te[64],ie([0,1,38,4,21,10]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function D(g){const I=(0,P.dirname)(g);if(g===I)return g;const f=((0,P.basename)(g)||g).toLowerCase();try{const l=(0,L.readdirSync)(I).filter(u=>u.toLowerCase()===f);if(l.length===1){const u=D(I);if(u)return(0,P.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(f);if(u>=0){const p=D(I);if(p)return(0,P.join)(p,l[u])}}}catch(v){}return null}t.realcaseSync=D;async function R(g){try{return await L.Promises.realpath(g)}catch(I){const f=d(g);return await L.Promises.access(f,T.constants.R_OK),f}}t.realpath=R;function c(g){try{return T.realpathSync(g)}catch(I){const f=d(g);return T.accessSync(f,T.constants.R_OK),f}}t.realpathSync=c;function d(g){return(0,S.rtrim)((0,P.normalize)(g),P.sep)}}),define(te[65],ie([0,1,33,4,10]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,D=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class I{constructor(r,e,n){this.exePath=r,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:o=!1,findPreview:r=!1}={}){const e=f({useAlternateBitness:o});if(!e)return null;const n=P.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(n))return null;let i=-1,s=null;for(const b of await S.Promises.readdir(n)){let A=-1;if(r){const C=b.indexOf("-");if(C<0)continue;const U=b.substring(0,C);if(!L.test(U)||b.substring(C+1)!=="preview")continue;A=parseInt(U,10)}else{if(!L.test(b))continue;A=parseInt(b,10)}if(A<=i)continue;const w=P.join(n,b,"pwsh.exe");!await S.SymlinkSupport.existsFile(w)||(s=w,i=A)}if(!s)return null;const a=e.includes("x86")?" (x86)":"",E=r?" Preview":"";return new I(s,`PowerShell${E}${a}`,!0)}async function l({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const r=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=o?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await S.Promises.readdir(r))if(e.test(i)){const s=P.join(r,i,"pwsh.exe");return new I(s,n)}return null}function u(){const o=P.join(T.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function p(){const o=P.join(process.env.windir,d===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*m(){let o=await v();o&&(yield o),o=await v({useAlternateBitness:!0}),o&&(yield o),o=await l(),o&&(yield o),o=u(),o&&(yield o),o=await v({findPreview:!0}),o&&(yield o),o=await l({findPreview:!0}),o&&(yield o),o=await v({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=p(),o&&(yield o)}async function*y(){for await(const o of m())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=y;async function h(){for await(const o of y())return o;return null}t.getFirstAvailablePowerShellInstallation=h}),define(te[66],ie([0,1,38,32,2,128,4,9,10]),function($,t,T,P,S,L,D,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function d(f,v,l){return I({path:f,isDirectory:!1},v,l)}t.watchFile=d;function g(f,v,l){return I({path:f,isDirectory:!0},v,l)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function I(f,v,l){if(R.isMacintosh&&(0,P.isEqualOrParent)(f.path,"/Volumes/"))return l(`Refusing to watch ${f.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const u=(0,D.basename)(f.path),p=new Map;let m=!1,y=[(0,S.toDisposable)(()=>{p.forEach(h=>(0,S.dispose)(h)),p.clear()})];try{const h=(0,T.watch)(f.path);y.push((0,S.toDisposable)(()=>{h.removeAllListeners(),h.close()}));const o=new Set;f.isDirectory&&c.Promises.readdir(f.path).then(r=>r.forEach(e=>o.add(e))),h.on("error",(r,e)=>{m||l(`Failed to watch ${f.path} for changes using fs.watch() (${r}, ${e})`)}),h.on("change",(r,e)=>{if(m)return;let n="";if(e&&(n=e.toString(),R.isMacintosh&&(n=(0,L.normalizeNFC)(n))),!n||r!=="change"&&r!=="rename")return;const i=f.isDirectory?(0,D.join)(f.path,n):f.path;if(f.isDirectory)if(r==="rename"){const s=p.get(i);s&&(0,S.dispose)(s);const a=setTimeout(async()=>{p.delete(i);const E=await c.Promises.exists(i);if(m)return;let b;E?o.has(n)?b="changed":(b="added",o.add(n)):(o.delete(n),b="deleted"),v(b,i)},t.CHANGE_BUFFER_DELAY);p.set(i,(0,S.toDisposable)(()=>clearTimeout(a)))}else{let s;o.has(n)?s="changed":(s="added",o.add(n)),v(s,i)}else if(r==="rename"||n!==u){const s=setTimeout(async()=>{const a=await c.Promises.exists(i);m||(a?(v("changed",i),y=[I(f,v,l)]):v("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,S.dispose)(y),y=[(0,S.toDisposable)(()=>clearTimeout(s))]}else v("changed",i)})}catch(h){c.Promises.exists(f.path).then(o=>{o&&!m&&l(`Failed to watch ${f.path} for changes using fs.watch() (${h.toString()})`)})}return(0,S.toDisposable)(()=>{m=!0,y=(0,S.dispose)(y)})}});var fe=this&&this.__decorate||function($,t,T,P){var S=arguments.length,L=S<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,T):P,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,t,T,P);else for(var R=$.length-1;R>=0;R--)(D=$[R])&&(L=(S<3?D(L):S>3?D(t,T,L):D(t,T))||L);return S>3&&L&&Object.defineProperty(t,T,L),L};define(te[39],ie([0,1,22,3,17,25,46,11,13,2,61,21,12]),function($,t,T,P,S,L,D,R,c,d,g,I,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var v;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(v=t.RequestType||(t.RequestType={}));function l(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function p(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(m||(m={}));class y{constructor(O){this.buffer=O,this.pos=0}read(O){const z=this.buffer.slice(this.pos,this.pos+O);return this.pos+=z.byteLength,z}}class h{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(o||(o={}));function r(j){const O=S.VSBuffer.alloc(4);return O.writeUInt32BE(j,0),O}function e(j){return j.read(4).readUInt32BE(0)}function n(j){const O=S.VSBuffer.alloc(1);return O.writeUInt8(j,0),O}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object)},s=typeof Buffer!="undefined";function a(j,O){if(typeof O=="undefined")j.write(i.Undefined);else if(typeof O=="string"){const z=S.VSBuffer.fromString(O);j.write(i.String),j.write(r(z.byteLength)),j.write(z)}else if(s&&Buffer.isBuffer(O)){const z=S.VSBuffer.wrap(O);j.write(i.Buffer),j.write(r(z.byteLength)),j.write(z)}else if(O instanceof S.VSBuffer)j.write(i.VSBuffer),j.write(r(O.byteLength)),j.write(O);else if(Array.isArray(O)){j.write(i.Array),j.write(r(O.length));for(const z of O)a(j,z)}else{const z=S.VSBuffer.fromString(JSON.stringify(O));j.write(i.Object),j.write(r(z.byteLength)),j.write(z)}}function E(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(e(j)).toString();case o.Buffer:return j.read(e(j)).buffer;case o.VSBuffer:return j.read(e(j));case o.Array:{const z=e(j),W=[];for(let H=0;H<z;H++)W.push(E(j));return W}case o.Object:return JSON.parse(j.read(e(j)).toString())}}class b{constructor(O,z,W=null,H=1e3){this.protocol=O,this.ctx=z,this.logger=W,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(k=>this.onRawMessage(k)),this.sendResponse({type:200})}registerChannel(O,z){this.channels.set(O,z),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const z=this.send([O.type]);this.logger&&this.logger.logOutgoing(z,0,1,p(O.type));return}case 201:case 202:case 204:case 203:{const z=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(z,O.id,1,p(O.type),O.data);return}}}send(O,z=void 0){const W=new h;return a(W,O),a(W,z),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(z){return 0}}onRawMessage(O){const z=new y(O),W=E(z),H=E(z),k=W[0];switch(k){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${l(k)}: ${W[2]}.${W[3]}`,H),this.onPromise({type:k,id:W[1],channelName:W[2],name:W[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${l(k)}: ${W[2]}.${W[3]}`,H),this.onEventListen({type:k,id:W[1],channelName:W[2],name:W[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${l(k)}`),this.disposeActiveRequest({type:k,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${l(k)}`),this.disposeActiveRequest({type:k,id:W[1]})}}onPromise(O){const z=this.channels.get(O.channelName);if(!z){this.collectPendingRequest(O);return}const W=new L.CancellationTokenSource;let H;try{H=z.call(this.ctx,O.name,O.arg,W.token)}catch(N){H=Promise.reject(N)}const k=O.id;H.then(N=>{this.sendResponse({id:k,data:N,type:201}),this.activeRequests.delete(O.id)},N=>{N instanceof Error?this.sendResponse({id:k,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:k,data:N,type:203}),this.activeRequests.delete(O.id)});const F=(0,d.toDisposable)(()=>W.cancel());this.activeRequests.set(O.id,F)}onEventListen(O){const z=this.channels.get(O.channelName);if(!z){this.collectPendingRequest(O);return}const W=O.id,k=z.listen(this.ctx,O.name,O.arg)(F=>this.sendResponse({id:W,data:F,type:204}));this.activeRequests.set(O.id,k)}disposeActiveRequest(O){const z=this.activeRequests.get(O.id);z&&(z.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let z=this.pendingRequests.get(O.channelName);z||(z=[],this.pendingRequests.set(O.channelName,z));const W=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:O,timeoutTimer:W})}flushPendingRequests(O){const z=this.pendingRequests.get(O);if(z){for(const W of z)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}t.ChannelServer=b;var A;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(A=t.RequestInitiator||(t.RequestInitiator={}));class w{constructor(O,z=null){this.protocol=O,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=z}getChannel(O){const z=this;return{call(W,H,k){return z.isDisposed?Promise.reject(R.canceled()):z.requestPromise(O,W,H,k)},listen(W,H){return z.isDisposed?Promise.reject(R.canceled()):z.requestEvent(O,W,H)}}}requestPromise(O,z,W,H=L.CancellationToken.None){const k=this.lastRequestId++,N={id:k,type:100,channelName:O,name:z,arg:W};if(H.isCancellationRequested)return Promise.reject(R.canceled());let M;return new Promise((K,Q)=>{if(H.isCancellationRequested)return Q(R.canceled());const X=()=>{const Ee=we=>{switch(we.type){case 201:this.handlers.delete(k),K(we.data);break;case 202:this.handlers.delete(k);const pe=new Error(we.data.message);pe.stack=we.data.stack,pe.name=we.data.name,Q(pe);break;case 203:this.handlers.delete(k),Q(we.data);break}};this.handlers.set(k,Ee),this.sendRequest(N)};let le=null;this.state===m.Idle?X():(le=(0,P.createCancelablePromise)(Ee=>this.whenInitialized()),le.then(()=>{le=null,X()}));const de=()=>{le?(le.cancel(),le=null):this.sendRequest({id:k,type:101}),Q(R.canceled())},ce=H.onCancellationRequested(de);M=(0,d.combinedDisposable)((0,d.toDisposable)(de),ce),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(O,z,W){const H=this.lastRequestId++,F={id:H,type:102,channelName:O,name:z,arg:W};let N=null;const M=new c.Emitter({onFirstListenerAdd:()=>{N=(0,P.createCancelablePromise)(K=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(M),this.sendRequest(F)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(M),this.sendRequest({id:H,type:103}))}}),B=K=>M.fire(K.data);return this.handlers.set(H,B),M.event}sendRequest(O){switch(O.type){case 100:case 102:{const z=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(z,O.id,0,`${l(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const z=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(z,O.id,0,l(O.type));return}}}send(O,z=void 0){const W=new h;return a(W,O),a(W,z),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(z){return 0}}onBuffer(O){const z=new y(O),W=E(z),H=E(z),k=W[0];switch(k){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,p(k)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],0,p(k),H),this.onResponse({type:W[0],id:W[1],data:H})}}onResponse(O){if(O.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(O.id);z&&z(O)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}fe([D.memoize],w.prototype,"onDidInitializePromise",null),t.ChannelClient=w;class C{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:z,onDidClientDisconnect:W})=>{c.Event.once(z.onMessage)(k=>{const F=new y(k),N=E(F),M=new b(z,N),B=new w(z);this.channels.forEach((Q,X)=>M.registerChannel(X,Q));const K={channelServer:M,channelClient:B,ctx:N};this._connections.add(K),this._onDidAddConnection.fire(K),W(()=>{M.dispose(),B.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}get connections(){const O=[];return this._connections.forEach(z=>O.push(z)),O}getChannel(O,z){const W=this;return{call(H,k,F){let N;if((0,f.isFunction)(z)){let B=(0,T.getRandomElement)(W.connections.filter(z));N=B?Promise.resolve(B):c.Event.toPromise(c.Event.filter(W.onDidAddConnection,z))}else N=z.routeCall(W,H,k);const M=N.then(B=>B.channelClient.getChannel(O));return V(M).call(H,k,F)},listen(H,k){if((0,f.isFunction)(z))return W.getMulticastEvent(O,z,H,k);const F=z.routeEvent(W,H,k).then(N=>N.channelClient.getChannel(O));return V(F).listen(H,k)}}}getMulticastEvent(O,z,W,H){const k=this;let F=new d.DisposableStore;const N=new c.Emitter({onFirstListenerAdd:()=>{F=new d.DisposableStore;const M=new c.EventMultiplexer,B=new Map,K=X=>{const de=X.channelClient.getChannel(O).listen(W,H),ce=M.add(de);B.set(X,ce)},Q=X=>{const le=B.get(X);!le||(le.dispose(),B.delete(X))};k.connections.filter(z).forEach(K),c.Event.filter(k.onDidAddConnection,z)(K,void 0,F),k.onDidRemoveConnection(Q,void 0,F),M.event(N.fire,N,F),F.add(M)},onLastListenerRemove:()=>{F.dispose()}});return N.event}registerChannel(O,z){this.channels.set(O,z),this._connections.forEach(W=>{W.channelServer.registerChannel(O,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=C;class U{constructor(O,z,W=null){const H=new h;a(H,z),O.send(H.buffer),this.channelClient=new w(O,W),this.channelServer=new b(O,z,W)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,z){this.channelServer.registerChannel(O,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=U;function V(j){return{call(O,z,W){return j.then(H=>H.call(O,z,W))},listen(O,z){const W=new c.Relay;return j.then(H=>W.input=H.listen(O,z)),W.event}}}t.getDelayedChannel=V;function J(j){let O=!1;return{call(z,W,H){return O?j.call(z,W,H):(0,P.timeout)(0).then(()=>O=!0).then(()=>j.call(z,W,H))},listen(z,W){if(O)return j.listen(z,W);const H=new c.Relay;return(0,P.timeout)(0).then(()=>O=!0).then(()=>H.input=j.listen(z,W)),H.event}}}t.getNextTickChannel=J;class ne{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const z of O.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await c.Event.toPromise(O.onDidAddConnection),await this.route(O)}}t.StaticRouter=ne;var se;(function(j){function O(H,k){const F=H,N=k&&k.disableMarshalling,M=new Map;for(const B in F)W(B)&&M.set(B,c.Event.buffer(F[B],!0));return new class{listen(B,K){const Q=M.get(K);if(Q)return Q;throw new Error(`Event not found: ${K}`)}call(B,K,Q){const X=F[K];if(typeof X=="function"){if(!N&&Array.isArray(Q))for(let le=0;le<Q.length;le++)Q[le]=(0,g.revive)(Q[le]);return X.apply(F,Q)}throw new Error(`Method not found: ${K}`)}}}j.fromService=O;function z(H,k){const F=k&&k.disableMarshalling;return new Proxy({},{get(N,M){if(typeof M=="string")return k?.properties?.has(M)?k.properties.get(M):W(M)?H.listen(M):async function(...B){let K;k&&!(0,f.isUndefinedOrNull)(k.context)?K=[k.context,...B]:K=B;const Q=await H.call(M,K);return F?Q:(0,g.revive)(Q)};throw new Error(`Property not found: ${String(M)}`)}})}j.toService=z;function W(H){return H[0]==="o"&&H[1]==="n"&&I.isUpperAsciiLetter(H.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let O=j.toString();if(O!=="[object Object]")return O}return j}function Y(j){return Array.isArray(j)?j.map(G):G(j)}function Z(j,O,z,W,H,k,F){F=Y(F);const N=ee[H],M=N[W%N.length];let B=[`%c[${j}]%c[${String(O).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${k}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(k)?(B=B.concat(F),B.push(")")):B.push(F),console.log.apply(console,B)}t.logWithColors=Z;class re{constructor(O,z){this._outgoingPrefix=O,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,z,W,H,k){this._totalOutgoing+=O,Z(this._outgoingPrefix,this._totalOutgoing,O,z,W,H,k)}logIncoming(O,z,W,H,k){this._totalIncoming+=O,Z(this._incomingPrefix,this._totalIncoming,O,z,W,H,k)}}t.IPCLogger=re}),define(te[67],ie([0,1,3,13,2,12]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var D;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=t.StorageHint||(t.StorageHint={}));function R(I){const f=I;return f?.changed instanceof Map||f?.deleted instanceof Set}t.isStorageItemsChangeEvent=R;var c;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(c||(c={}));class d extends S.Disposable{constructor(f,v=Object.create(null)){super();this.database=f,this.options=v,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((v,l)=>this.accept(l,v)),f.deleted?.forEach(v=>this.accept(v,void 0))}accept(f,v){if(this.state===c.Closed)return;let l=!1;(0,L.isUndefinedOrNull)(v)?l=this.cache.delete(f):this.cache.get(f)!==v&&(this.cache.set(f,v),l=!0),l&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,v){const l=this.cache.get(f);return(0,L.isUndefinedOrNull)(l)?v:l}getBoolean(f,v){const l=this.get(f);return(0,L.isUndefinedOrNull)(l)?v:l==="true"}getNumber(f,v){const l=this.get(f);return(0,L.isUndefinedOrNull)(l)?v:parseInt(l,10)}async set(f,v){if(this.state===c.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(f);const l=String(v);if(this.cache.get(f)!==l)return this.cache.set(f,l),this.pendingInserts.set(f,l),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async delete(f){if(!(this.state===c.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((v,l)=>this.items.set(l,v)),f.delete&&f.delete.forEach(v=>this.items.delete(v))}async close(){}}t.InMemoryStorageDatabase=g}),define(te[68],ie([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(te[69],ie([0,1,68]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const P=60,S=P*60,L=S*24,D=L*7,R=L*30,c=L*365;function d(I,f){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,T.localize)(0,null,d(new Date().getTime()+v*1e3,!1));if(v<30)return(0,T.localize)(1,null);let l;return v<P?(l=v,f?l===1?(0,T.localize)(2,null,l):(0,T.localize)(3,null,l):l===1?(0,T.localize)(4,null,l):(0,T.localize)(5,null,l)):v<S?(l=Math.floor(v/P),f?l===1?(0,T.localize)(6,null,l):(0,T.localize)(7,null,l):l===1?(0,T.localize)(8,null,l):(0,T.localize)(9,null,l)):v<L?(l=Math.floor(v/S),f?l===1?(0,T.localize)(10,null,l):(0,T.localize)(11,null,l):l===1?(0,T.localize)(12,null,l):(0,T.localize)(13,null,l)):v<D?(l=Math.floor(v/L),f?l===1?(0,T.localize)(14,null,l):(0,T.localize)(15,null,l):l===1?(0,T.localize)(16,null,l):(0,T.localize)(17,null,l)):v<R?(l=Math.floor(v/D),f?l===1?(0,T.localize)(18,null,l):(0,T.localize)(19,null,l):l===1?(0,T.localize)(20,null,l):(0,T.localize)(21,null,l)):v<c?(l=Math.floor(v/R),f?l===1?(0,T.localize)(22,null,l):(0,T.localize)(23,null,l):l===1?(0,T.localize)(24,null,l):(0,T.localize)(25,null,l)):(l=Math.floor(v/c),f?l===1?(0,T.localize)(26,null,l):(0,T.localize)(27,null,l):l===1?(0,T.localize)(28,null,l):(0,T.localize)(29,null,l))}t.fromNow=d;function g(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=g}),define(te[70],ie([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(te[28],ie([0,1,22,12,70]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function L(d,g){return g&&(d.stack||d.stacktrace)?S.localize(0,null,R(d),D(d.stack)||D(d.stacktrace)):R(d)}function D(d){return Array.isArray(d)?d.join(`
`):d}function R(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?S.localize(1,null,d.message):d.message||S.localize(2,null)}function c(d=null,g=!1){if(!d)return S.localize(3,null);if(Array.isArray(d)){const I=T.coalesce(d),f=c(I[0],g);return I.length>1?S.localize(4,null,f,I.length):f}if(P.isString(d))return d;if(d.detail){const I=d.detail;if(I.error)return L(I.error,g);if(I.exception)return L(I.exception,g)}return d.stack?L(d,g):d.message?d.message:S.localize(5,null)}t.toErrorMessage=c}),define(te[71],ie([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(te[49],ie([0,1,34,32,8,18,4,9,29,12,48,10,71]),function($,t,T,P,S,L,D,R,c,d,g,I,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function v(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(o,r){if(R.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const n=T.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(i=>{n.once("error",s=>{i({success:!1,error:s})}),n.once("exit",(s,a)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?v(e.status):1})}else if(R.isLinux||R.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(n=>{T.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,s,a)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function u(o=c.env){return o.comspec||"cmd.exe"}t.getWindowsShell=u;class p{constructor(r,e,n,i){if(e!==void 0&&n!==void 0&&i!==void 0)this.cmd=r,this.args=e,this.shell=n,this.options=i;else{const s=r;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(c.env).forEach(a=>{s[a]=c.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(D.sep);return e!==-1&&(r=r.substring(e+1)),p.WellKnowCommands[r]?r:"other"}start(r){return R.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(c.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(e=>{let n,i;const s=new Promise((a,E)=>{n=a,i=E});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=T.exec(a,this.options,(E,b,A)=>{this.childProcess=null;const w=E;w&&w.killed?i({killed:this.terminateRequested,stdout:b.toString(),stderr:A.toString()}):this.handleExec(n,r,E,b,A)})}else{let a=null;const E=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,n,r,i);const A={terminated:this.terminateRequested};d.isNumber(b)&&(A.cmdCode=b),n(A)};if(this.shell&&R.isWindows){const b=L.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let A=!1,w=!1;const C=[];let U=this.ensureQuotes(this.cmd);C.push(U.value),A=U.quoted,this.args&&this.args.forEach(J=>{U=this.ensureQuotes(J),C.push(U.value),w=w&&U.quoted});const V=["/s","/c"];A?w?V.push('"'+C.join(" ")+'"'):C.length>1?V.push('"'+C[0]+'" '+C.slice(1).join(" ")):V.push('"'+C[0]+'"'):V.push(C.join(" ")),a=T.spawn(u(),V,b)}else this.cmd&&(a=T.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(d.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",b=>{this.childProcess=null,i({terminated:this.terminateRequested,error:b})}),a.pid&&(this.childProcess.on("close",E),this.handleSpawn(a,n,r,i,!0)))}return s})}handleClose(r,e,n,i){}ensureQuotes(r){return p.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,l(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!R.isWindows)return r(!1);const e=T.spawn(u(),["/s","/c"]);e.on("error",n=>r(!0)),e.on("exit",n=>r(!1))})}}t.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class m extends p{constructor(r,e,n,i){super(r,e,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,n,i,s){[i,s].forEach((a,E)=>{const b=new g.LineDecoder;b.write(a).forEach(C=>{e({line:C,source:E===0?0:1})});const w=b.end();w&&e({line:w,source:E===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,e,n,i,s){const a=new g.LineDecoder,E=new g.LineDecoder;r.stdout.on("data",b=>{a.write(b).forEach(w=>n({line:w,source:0}))}),r.stderr.on("data",b=>{E.write(b).forEach(w=>n({line:w,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=E}handleClose(r,e,n,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&n({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}t.LineProcess=m;function y(o){let r=[],e=!1;const n=function(i){if(e){r.push(i);return}(!o.send(i,a=>{if(a&&console.error(a),e=!1,r.length>0){const E=r.slice(0);r=[],E.forEach(b=>n(b))}})||R.isWindows)&&(e=!0)};return{send:n}}t.createQueuedSender=y;var h;(function(o){async function r(e,n,i){if(D.isAbsolute(e))return e;if(n===void 0&&(n=c.cwd()),D.dirname(e)!=="."||(i===void 0&&d.isString(c.env.PATH)&&(i=c.env.PATH.split(D.delimiter)),i===void 0||i.length===0))return D.join(n,e);async function a(E){if(await I.Promises.exists(E)){let b;try{b=await I.Promises.stat(E)}catch(A){A.message.startsWith("EACCES")&&(b=await I.Promises.lstat(E))}return b?!b.isDirectory():!1}return!1}for(let E of i){let b;if(D.isAbsolute(E)?b=D.join(E,e):b=D.join(n,E,e),await a(b))return b;let A=b+".com";if(await a(A)||(A=b+".exe",await a(A)))return A}return D.join(n,e)}o.findExecutable=r})(h=t.win32||(t.win32={}))}),define(te[72],ie([0,1,33,9,65,49]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function D(v,l){return v===1?P.isWindows?I():L.getWindowsShell(l):d(v,l)}t.getSystemShell=D;function R(v,l){return v===1?P.isWindows?f(l):L.getWindowsShell(l):d(v,l)}t.getSystemShellSync=R;let c=null;function d(v,l){if(P.isLinux&&v===2||P.isMacintosh&&v===3)return"/bin/bash";if(!c){let u;if(P.isWindows)u="/bin/bash";else{if(u=l.SHELL,!u)try{u=(0,T.userInfo)().shell}catch(p){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}c=u}return c}let g=null;async function I(){return g||(g=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),g}function f(v){if(g)return g;const l=P.isWindows&&parseFloat((0,T.release)())>=10,u=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${v.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?p:L.getWindowsShell(v)}}),define(te[50],ie([0,1,34,3,17,25,60,11,13,2,18,9,49,39]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends v.ChannelServer{constructor(m){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(h){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",y=>S.VSBuffer.wrap(Buffer.from(y,"base64")))},m);process.once("disconnect",()=>this.dispose())}}t.Server=l;class u{constructor(m,y){this.modulePath=m,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new P.Delayer(h),this.child=null,this._client=null}getChannel(m){const y=this;return{call(h,o,r){return y.requestPromise(m,h,o,r)},listen(h,o){return y.requestEvent(m,h,o)}}}requestPromise(m,y,h,o=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(m),e=(0,P.createCancelablePromise)(s=>r.call(y,h,s)),n=o.onCancellationRequested(()=>e.cancel()),i=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(i),e.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(m,y,h){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let o;const r=new c.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(m).listen(y,h)(r.fire,r),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,g.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),I.isMacintosh&&y.env&&delete y.env.DYLD_LIBRARY_PATH,this.child=(0,T.fork)(this.modulePath,m,y);const h=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,D.isRemoteConsoleLog)(a)){(0,D.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(S.VSBuffer.wrap(Buffer.from(a,"base64")))});const r=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&r.send(a.buffer.toString("base64")),n=h.event,i={send:e,onMessage:n};this._client=new v.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,E)=>{process.removeListener("exit",s),this.activeRequests.forEach(b=>(0,d.dispose)(b)),this.activeRequests.clear(),a!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+E),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:E})})}return this._client}getCachedChannel(m){let y=this.channels.get(m);return y||(y=this.client.getChannel(m),this.channels.set(m,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(te[73],ie([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(te[74],ie([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(te[75],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(te[76],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(te[77],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(te[78],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(te[79],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(te[80],ie([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(te[81],ie([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(te[82],ie([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(te[83],ie([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(te[84],ie([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(te[85],ie([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(te[86],ie([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(te[87],ie([0,1,69,46,8,4,29,19,7]),function($,t,T,P,S,L,D,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(l,u,p){this._args=l,this.paths=u,this.productService=p}get appRoot(){return(0,L.dirname)(S.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(c.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?c.URI.file((0,L.join)(l,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,L.resolve)(l):(0,L.normalize)((0,L.join)(S.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,L.resolve)(l):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,L.resolve)(l);const u=D.env.VSCODE_EXTENSIONS;if(u)return u;const p=D.env.VSCODE_PORTABLE;return p?(0,L.join)(p,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(u=>/^[^:/?#]+?:\/\//.test(u)?c.URI.parse(u):c.URI.file((0,L.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,L.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([P.memoize],d.prototype,"appRoot",null),fe([P.memoize],d.prototype,"userHome",null),fe([P.memoize],d.prototype,"userDataPath",null),fe([P.memoize],d.prototype,"appSettingsHome",null),fe([P.memoize],d.prototype,"tmpDir",null),fe([P.memoize],d.prototype,"userRoamingDataHome",null),fe([P.memoize],d.prototype,"settingsResource",null),fe([P.memoize],d.prototype,"userDataSyncHome",null),fe([P.memoize],d.prototype,"userDataSyncLogResource",null),fe([P.memoize],d.prototype,"sync",null),fe([P.memoize],d.prototype,"machineSettingsResource",null),fe([P.memoize],d.prototype,"globalStorageHome",null),fe([P.memoize],d.prototype,"workspaceStorageHome",null),fe([P.memoize],d.prototype,"keybindingsResource",null),fe([P.memoize],d.prototype,"keyboardLayoutResource",null),fe([P.memoize],d.prototype,"argvResource",null),fe([P.memoize],d.prototype,"snippetsHome",null),fe([P.memoize],d.prototype,"isExtensionDevelopment",null),fe([P.memoize],d.prototype,"untitledWorkspacesHome",null),fe([P.memoize],d.prototype,"installSourcePath",null),fe([P.memoize],d.prototype,"builtinExtensionsPath",null),fe([P.memoize],d.prototype,"extensionsPath",null),fe([P.memoize],d.prototype,"extensionDevelopmentLocationURI",null),fe([P.memoize],d.prototype,"extensionDevelopmentKind",null),fe([P.memoize],d.prototype,"extensionTestsLocationURI",null),fe([P.memoize],d.prototype,"debugExtensionHost",null),fe([P.memoize],d.prototype,"serviceMachineIdResource",null),fe([P.memoize],d.prototype,"telemetryLogResource",null),fe([P.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function g(v,l){return f(v["inspect-extensions"],v["inspect-brk-extensions"],5870,l,v.debugId)}t.parseExtensionHostPort=g;function I(v,l){return f(v["inspect-search"],v["inspect-brk-search"],5876,l)}t.parseSearchPort=I;function f(v,l,u,p,m){const h=Number(l||v)||(p?null:u),o=h?Boolean(!!l):!1;return{port:h,break:o,debugId:m}}}),function(){"use strict";function $(t,T,P,S){function L(R){const c=D(R),d=[c];return t.isAbsolute(c)||d.unshift(S),t.resolve(...d)}function D(R){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,P);const g=R["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(I,"AppData","Roaming")}break;case"darwin":d=t.join(T.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,P)}return{getUserDataPath:L}}if(typeof define=="function")define(te[88],ie([0,89,33,8,19,29]),function(t,T,P,S,L,D){const R=L.dirname(S.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(L.joinPath(R,"package.json").fsPath);return $(T,P,c.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),T=require("path"),P=require("os");module.exports=$(T,P,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[90],ie([0,1,33,87,88]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class L extends P.AbstractNativeEnvironmentService{constructor(R,c){super(R,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,S.getUserDataPath)(R)},c)}}t.NativeEnvironmentService=L}),define(te[91],ie([0,1,18]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function S(L,D){const R=c=>{if(typeof c!="string")return;const d=P.exec(c);if(!d)return;const g=D[d[1]]??c;return typeof g=="string"?g:typeof g.message=="string"?g.message:c};return(0,T.cloneAndChange)(L,R)}t.localizeManifest=S}),define(te[51],ie([0,1,81]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function L(f){return f=f.trim(),f==="*"||P.test(f)}t.isValidVersionStr=L;function D(f){if(!L(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=f.match(P);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}t.parseVersion=D;function R(f){if(!f)return null;let v=f.majorBase,l=f.majorMustEqual,u=f.minorBase,p=f.minorMustEqual,m=f.patchBase,y=f.patchMustEqual;f.hasCaret&&(v===0||(p=!1),y=!1);let h=0;if(f.preRelease){const o=S.exec(f.preRelease);if(o){const[,r,e,n]=o;h=Date.UTC(Number(r),Number(e)-1,Number(n))}}return{majorBase:v,majorMustEqual:l,minorBase:u,minorMustEqual:p,patchBase:m,patchMustEqual:y,isMinimum:f.hasGreaterEquals,notBefore:h}}t.normalizeVersion=R;function c(f,v,l){let u;typeof f=="string"?u=R(D(f)):u=f;let p;v instanceof Date?p=v.getTime():typeof v=="string"&&(p=new Date(v).getTime());let m;if(typeof l=="string"?m=R(D(l)):m=l,!u||!m)return!1;let y=u.majorBase,h=u.minorBase,o=u.patchBase,r=m.majorBase,e=m.minorBase,n=m.patchBase,i=m.notBefore,s=m.majorMustEqual,a=m.minorMustEqual,E=m.patchMustEqual;return m.isMinimum?y>r?!0:y<r?!1:h>e?!0:h<e||p&&p<i?!1:o>=n:(y===1&&r===0&&(!s||!a||!E)&&(r=1,e=0,n=0,s=!0,a=!1,E=!1),y<r?!1:y>r?!s:h<e?!1:h>e?!a:o<n?!1:o>n?!E:!(p&&p<i))}t.isValidVersion=c;function d(f,v,l,u){return l.isBuiltin||typeof l.main=="undefined"?!0:I(f,v,l.engines.vscode,u)}t.isValidExtensionVersion=d;function g(f,v,l){return f==="*"||I(v,l,f)}t.isEngineValid=g;function I(f,v,l,u=[]){let p=R(D(l));if(!p)return u.push(T.localize(0,null,l)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return u.push(T.localize(1,null,l)),!1}else if(!p.majorMustEqual)return u.push(T.localize(2,null,l)),!1;return c(f,v,p)?!0:(u.push(T.localize(3,null,f,l)),!1)}}),define(te[92],ie([0,1,2,8,39,50]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends T.Disposable{constructor(c,d,g,I){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new L.Client(P.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(te[93],ie([0,1,2,8,39,50]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends T.Disposable{constructor(c,d,g,I,f={}){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=I,this.watcherOptions=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new L.Client(P.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(te[94],ie([0,1,34,62,8,48]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class D{constructor(c,d,g,I,f){this.watchedFolder=c,this.eventCallback=g,this.logCallback=I,this.verboseLogging=f,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(v=>(0,P.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,T.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,c);const d=new L.LineDecoder;this.handle.stdout.on("data",g=>{const I=[];for(const f of d.write(g)){const v=f.split("|");if(v.length===2){const l=Number(v[0]),u=v[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(p=>p(u))){this.verboseLogging&&this.log(u);continue}I.push({type:D.changeTypeMap[l],path:u})}else this.log(v[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",g=>this.onError(g)),this.handle.stderr.on("data",g=>this.onError(g)),this.handle.on("exit",(g,I)=>this.onExit(g,I))}onError(c){this.error("process error: "+c.toString())}onExit(c,d){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${d})`),this.restartCounter<=D.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=D,D.MAX_RESTARTS=5,D.changeTypeMap=[0,1,2]}),define(te[95],ie([0,1,4,21,94]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class L{constructor(R,c,d,g){this.onDidFilesChange=c,this.onLogMessage=d,this.verboseLogging=g,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,P.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=L}),define(te[52],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class T{constructor(S,L=[],D=!1){this.ctor=S,this.staticArguments=L,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=T}),define(te[96],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class T{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}t.Node=T;class P{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let D of this._nodes.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const R=this.lookupOrInsertNode(L),c=this.lookupOrInsertNode(D);R.outgoing.set(this._hashFn(D),c),c.incoming.set(this._hashFn(L),R)}removeNode(L){const D=this._hashFn(L);this._nodes.delete(D);for(let R of this._nodes.values())R.outgoing.delete(D),R.incoming.delete(D)}lookupOrInsertNode(L){const D=this._hashFn(L);let R=this._nodes.get(D);return R||(R=new T(L),this._nodes.set(D,R)),R}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[D,R]of this._nodes)L.push(`${D}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,D]of this._nodes){const R=new Set([L]),c=this._findCycle(D,R);if(c)return c}}_findCycle(L,D){for(let[R,c]of L.outgoing){if(D.has(R))return[...D,R].join(" -> ");D.add(R);const d=this._findCycle(c,D);if(d)return d;D.delete(R)}}}t.Graph=P}),define(te[53],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,T.createDecorator)("downloadService")}),define(te[20],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,T.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,T.refineServiceDecorator)(t.IEnvironmentService)}),define(te[23],ie([0,1,8,9,29,76,15]),function($,t,T,P,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.CURRENT_TARGET_PLATFORM=t.getTargetPlatform=t.getTargetPlatformFromOS=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var R;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(R=t.TargetPlatform||(t.TargetPlatform={}));function c(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=c;function d(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=d;function g(o,r){let e;switch(o){case 1:e=3;break;case 3:e=2;break;case 2:e=1;break}return I(e,r)}t.getTargetPlatformFromOS=g;function I(o,r){switch(o){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=I,t.CURRENT_TARGET_PLATFORM=P.isWeb?"web":I(P.platform,S.arch);function f(o,r){return r==="web"&&!o.includes("web")}t.isNotWebExtensionInWebTargetPlatform=f;function v(o,r,e){if(f(r,e))return!1;if(o==="undefined"||o==="universal")return!0;if(o==="unknown")return!1;if(o===e)return!0;switch(e){case"win32-x64":return o==="win32-ia32";case"win32-arm64":return o==="win32-ia32";default:return!1}}t.isTargetPlatformCompatible=v;function l(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}t.isIExtensionIdentifier=l;var u;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=5]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(u=t.SortBy||(t.SortBy={}));var p;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(p=t.SortOrder||(t.SortOrder={}));var m;(function(o){o.Install="install",o.Uninstall="uninstall"})(m=t.StatisticType||(t.StatisticType={}));var y;(function(o){o[o.None=0]="None",o[o.Install=1]="Install",o[o.Update=2]="Update"})(y=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class h extends Error{constructor(r,e){super(r);this.code=e,this.name=e}}t.ExtensionManagementError=h,t.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,L.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,L.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(te[40],ie([0,1,21,15]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=S;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(D=t.ExtensionType||(t.ExtensionType={}));class R{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,f){if(typeof I=="undefined"||I===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof I=="string"||typeof f=="string"){let v=typeof I=="string"?I:I.value,l=typeof f=="string"?f:f.value;return T.equalsIgnoreCase(v,l)}return I._lower===f._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}t.ExtensionIdentifier=R;function c(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function d(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[24],ie([0,1,21,40]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(l,u){return l.uuid&&u.uuid?l.uuid===u.uuid:l.id===u.id?!0:(0,T.compareIgnoreCase)(l.id,u.id)===0}t.areSameExtensions=S;class L{constructor(u,p){this.version=p,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof L?S(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=L;function D(l,u){return`${l}.${u}`}t.getExtensionId=D;function R(l){return l.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function c(l,u){return R(D(l,u))}t.getGalleryExtensionId=c;function d(l,u){const p=[],m=y=>{for(const h of p)if(h.some(o=>S(u(o),u(y))))return h;return null};for(const y of l){const h=m(y);h?h.push(y):p.push([y])}return p}t.groupByExtension=d;function g(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=g;function I(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}t.getGalleryExtensionTelemetryData=I,t.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function f(l){const u=new Set;for(const p of l)p.malicious&&u.add(p.id.id);return u}t.getMaliciousExtensionsSet=f;function v(l,u){const p=[],m=u.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const y=m.shift();if(y&&p.every(h=>!S(h.identifier,{id:y}))){const h=l.filter(o=>S(o.identifier,{id:y}));h.length===1&&(p.push(h[0]),m.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}t.getExtensionDependencies=v});var ae=this&&this.__param||function($,t){return function(T,P){t(T,P,$)}};define(te[97],ie([0,1,25,11,63,8,41,7,77,23,24,40]),function($,t,T,P,S,L,D,R,c,d,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const f=y=>(0,c.localize)(0,null,y),v=(0,c.localize)(1,null,"ms-dotnettools.csharp");function l(y,h){return h?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function p(y){const h=u.exec(y);return h&&h[1]?[(0,g.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,g.adoptToGalleryExtensionId)(y),void 0]}t.getIdAndVersion=p;let m=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,r=console){let e=await this.extensionManagementService.getInstalled(1);const n=I.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(o&&o!==""){if(n.indexOf(o.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(E=>E.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){r.log("Possible Categories: "),n.forEach(s=>{r.log(s)});return}this.location&&r.log((0,c.localize)(2,null,this.location)),e=e.sort((s,a)=>s.identifier.id.localeCompare(a.identifier.id));let i;for(let s of e)i!==s.identifier.id&&(i=s.identifier.id,r.log(l(s.manifest,h)))}async installExtensions(h,o,r,e,n=console){const i=[],s=[];h.length&&n.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),E=(w,C)=>{const U=a.find(V=>(0,g.areSameExtensions)(V.identifier,{id:w}));if(U){if(!C&&!e)return n.log((0,c.localize)(5,null,w,U.manifest.version,w)),!1;if(C&&U.manifest.version===C)return n.log((0,c.localize)(6,null,`${w}@${C}`)),!1}return!0},b=[],A=[];for(const w of h)if(w instanceof R.URI)b.push(w);else{const[C,U]=p(w);E(C,U)&&A.push({id:C,version:U,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const w of o){const[C,U]=p(w);E(C,U)&&A.push({id:C,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(b.length&&await Promise.all(b.map(async w=>{try{const C=await this.installVSIX(w,{isBuiltin:!1,isMachineScoped:r},e,n);C&&s.push(C)}catch(C){n.error(C.message||C.stack||C),i.push(w.toString())}})),A.length){const w=await this.getGalleryExtensions(A);await Promise.all(A.map(async C=>{const U=w.get(C.id.toLowerCase());if(U)try{const V=await this.installFromGallery(C,U,a,e,n);V&&s.push(V)}catch(V){n.error(V.message||V.stack||V),i.push(C.id)}else n.error(`${f(C.version?`${C.id}@${C.version}`:C.id)}
${v}`),i.push(C.id)}))}if(i.length)throw new Error((0,c.localize)(7,null,i.join(", ")))}async installVSIX(h,o,r,e){const n=await this.extensionManagementService.getManifest(h);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,r,e))try{return await this.extensionManagementService.install(h,o),e.log((0,c.localize)(8,null,(0,S.getBaseLabel)(h))),n}catch(s){if((0,P.isPromiseCanceledError)(s))return e.log((0,c.localize)(9,null,(0,S.getBaseLabel)(h))),null;throw s}return null}async getGalleryExtensions(h){const o=new Map,r=await this.extensionGalleryService.getExtensions(h,T.CancellationToken.None);for(const e of r)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:r},e,n,i,s){const a=await this.extensionGalleryService.getManifest(e,T.CancellationToken.None);if(a&&!this.validateExtensionKind(a,s))return null;const E=n.find(b=>(0,g.areSameExtensions)(b.identifier,e.identifier));if(E){if(e.version===E.manifest.version)return s.log((0,c.localize)(10,null,o?`${h}@${o}`:h)),null;s.log((0,c.localize)(11,null,h,e.version))}try{return r.isBuiltin?s.log(o?(0,c.localize)(12,null,h,o):(0,c.localize)(13,null,h)):s.log(o?(0,c.localize)(14,null,h,o):(0,c.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...r,installGivenVersion:!!o}),s.log((0,c.localize)(16,null,h,e.version)),a}catch(b){if((0,P.isPromiseCanceledError)(b))return s.log((0,c.localize)(17,null,h)),null;throw b}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,r){const e={id:(0,g.getGalleryExtensionId)(h.publisher,h.name)},i=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,g.areSameExtensions)(e,s.identifier)&&(0,D.gt)(s.manifest.version,h.version));return i&&!o?(r.log((0,c.localize)(18,null,i.identifier.id,i.manifest.version,h.version)),!1):this.validateExtensionKind(h,r)}async uninstallExtensions(h,o,r=console){const e=async i=>{if(i instanceof R.URI){const s=await this.extensionManagementService.getManifest(i);return l(s)}return i},n=[];for(const i of h){const s=await e(i),E=(await this.extensionManagementService.getInstalled()).filter(b=>(0,g.areSameExtensions)(b.identifier,{id:s}));if(!E.length)throw new Error(`${this.notInstalled(s)}
${v}`);if(E.some(b=>b.type===0)){r.log((0,c.localize)(19,null,s));return}if(!o&&E.some(b=>b.isBuiltin)){r.log((0,c.localize)(20,null,s));return}r.log((0,c.localize)(21,null,s));for(const b of E)await this.extensionManagementService.uninstall(b),n.push(b);this.location?r.log((0,c.localize)(22,null,s,this.location)):r.log((0,c.localize)(23,null,s))}}async locateExtension(h,o=console){const r=await this.extensionManagementService.getInstalled();h.forEach(e=>{r.forEach(n=>{if(n.identifier.id===e&&n.location.scheme===L.Schemas.file){o.log(n.location.fsPath);return}})})}notInstalled(h){return this.location?(0,c.localize)(24,null,h,this.location):(0,c.localize)(25,null,h)}};m=fe([ae(0,d.IExtensionManagementService),ae(1,d.IExtensionGalleryService)],m),t.ExtensionManagementCLIService=m}),define(te[98],ie([0,1,2,4,10,40]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class D extends T.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(d.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=D}),define(te[99],ie([0,1,34,89,25,28,11,9,30,72,129]),function($,t,T,P,S,L,D,R,c,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function I(l,u,p){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):R.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,g.isLaunchedFromCli)(p)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,g.isLaunchedFromCli)(p)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=new Promise(async m=>{const y=new S.CancellationTokenSource,h=setTimeout(()=>{l.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),y.dispose(!0),m({})},1e4);try{const o=await v(l,y.token);m(o)}catch(o){(0,D.isPromiseCanceledError)(o)||l.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),m({})}finally{clearTimeout(h),y.dispose()}})),f)}t.resolveShellEnv=I;let f;async function v(l,u){const p=new Promise(async(m,y)=>{const h=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",o);const r=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(r+"(.*)"+r),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const i=await(0,d.getSystemShell)(R.OS,n);if(l.trace("getUnixShellEnvironment#shell",i),u.isCancellationRequested)return y(D.canceled);const s=P.basename(i);let a,E;/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' -p '''${r}'' + JSON.stringify(process.env) + ''${r}'''`,E=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${r}" + JSON.stringify(process.env) + "${r}"'`,E=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),a);const b=(0,T.spawn)(i,[...E,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(b.kill(),y(D.canceled))),b.on("error",C=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(C)),m({})});const A=[];b.stdout.on("data",C=>A.push(C));const w=[];b.stderr.on("data",C=>w.push(C)),b.on("close",(C,U)=>{const V=Buffer.concat(A).toString("utf8");l.trace("getUnixShellEnvironment#raw",V);const J=Buffer.concat(w).toString("utf8");if(J.trim()&&l.trace("getUnixShellEnvironment#stderr",J),C||U)return y(new Error(`Failed to get environment (code ${C}, signal ${U})`));const ne=e.exec(V),se=ne?ne[1]:"{}";try{const ee=JSON.parse(se);h?ee.ELECTRON_RUN_AS_NODE=h:delete ee.ELECTRON_RUN_AS_NODE,o?ee.ELECTRON_NO_ATTACH_CONSOLE=o:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ee),m(ee)}catch(ee){l.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ee)),y(ee)}})});try{return await p}catch(m){return l.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(m)),{}}}}),define(te[54],ie([0,1,9,7,16]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function L(c){return c.map(d=>({type:d.type,resource:P.URI.file(d.path)}))}t.toFileChanges=L;function D(c){const d=new R;for(const g of c)d.processEvent(g);return d.normalize()}t.normalizeFileChanges=D;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const g=this.mapPathToChange.get(d.path);if(g){const I=g.type,f=d.type;I===1&&f===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(g),1)):I===2&&f===1?g.type=0:I===1&&f===0||(g.type=f)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],g=[];return this.normalized.filter(I=>I.type!==2?(d.push(I),!1):!0).sort((I,f)=>I.path.length-f.path.length).filter(I=>g.some(f=>(0,S.isParent)(I.path,f,!T.isLinux))?!1:(g.push(I.path),!0)).concat(d)}}}),define(te[100],ie([0,1,3,2,4,64,10,66,54]),function($,t,T,P,S,L,D,R,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends P.Disposable{constructor(I,f,v,l){super();this.path=I,this.onDidFilesChange=f,this.onLogMessage=v,this.verboseLogging=l,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(R.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:f}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(f)try{v=await(0,L.realpath)(v)}catch(l){if(this.onError(l),f.dangling)return}I.isDirectory()?this._register((0,R.watchFolder)(v,(l,u)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(u))})},l=>this.onError(l))):this._register((0,R.watchFile)(v,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,c.normalizeFileChanges)(f);if(this.verboseLogging)for(const l of v)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(te[55],ie([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class T{constructor(...S){this._entries=new Map;for(let[L,D]of S)this.set(L,D)}set(S,L){const D=this._entries.get(S);return this._entries.set(S,L),D}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=T}),define(te[101],ie([0,1,3,11,52,96,15,55]),function($,t,T,P,S,L,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class d extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class g{constructor(l=new R.ServiceCollection,u=!1,p){this._activeInstantiations=new Set,this._services=l,this._strict=u,this._parent=p,this._services.set(D.IInstantiationService,this)}createChild(l){return new g(l,this._strict,this)}invokeFunction(l,...u){let p=f.traceInvocation(l),m=!1;try{return l({get:(h,o)=>{if(m)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(h,p);if(!r&&o!==D.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return r}},...u)}finally{m=!0,p.stop()}}createInstance(l,...u){let p,m;return l instanceof S.SyncDescriptor?(p=f.traceCreation(l.ctor),m=this._createInstance(l.ctor,l.staticArguments.concat(u),p)):(p=f.traceCreation(l),m=this._createInstance(l,u,p)),p.stop(),m}_createInstance(l,u=[],p){let m=D._util.getServiceDependencies(l).sort((o,r)=>o.index-r.index),y=[];for(const o of m){let r=this._getOrCreateServiceInstance(o.id,p);if(!r&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);y.push(r)}let h=m.length>0?m[0].index:u.length;if(u.length!==h){console.warn(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${u.length} static arguments`);let o=h-u.length;o>0?u=u.concat(new Array(o)):u=u.slice(0,h)}return new l(...[...u,...y])}_setServiceInstance(l,u){if(this._services.get(l)instanceof S.SyncDescriptor)this._services.set(l,u);else if(this._parent)this._parent._setServiceInstance(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let u=this._services.get(l);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):u}_getOrCreateServiceInstance(l,u){let p=this._getServiceInstanceOrDescriptor(l);return p instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,p,u.branch(l,!0)):(u.branch(l,!1),p)}_safeCreateAndCacheServiceInstance(l,u,p){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,u,p)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,u,p){const m=new L.Graph(o=>o.id.toString());let y=0;const h=[{id:l,desc:u,_trace:p}];for(;h.length;){const o=h.pop();if(m.lookupOrInsertNode(o),y++>1e3)throw new d(m);for(let r of D._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${l} depends on ${r.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const n={id:r.id,desc:e,_trace:o._trace.branch(r.id,!0)};m.insertEdge(o,n),h.push(n)}}}for(;;){const o=m.roots();if(o.length===0){if(!m.isEmpty())throw new d(m);break}for(const{data:r}of o){if(this._getServiceInstanceOrDescriptor(r.id)instanceof S.SyncDescriptor){const n=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,n)}m.removeNode(r)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,u,p=[],m,y){if(this._services.get(l)instanceof S.SyncDescriptor)return this._createServiceInstance(u,p,m,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,u,p,m,y);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(l,u=[],p,m){if(p){const y=new T.IdleValue(()=>this._createInstance(l,u,m));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let r=y.value,e=r[o];return typeof e!="function"||(e=e.bind(r),h[o]=e),e},set(h,o,r){return y.value[o]=r,!0}})}else return this._createInstance(l,u,m)}}t.InstantiationService=g;var I;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(I||(I={}));class f{constructor(l,u){this.type=l,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return c?new f(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(l){return c?new f(0,l.name):f._None}branch(l,u){let p=new f(2,l.toString());return this._dep.push([l,u,p]),p}stop(){let l=Date.now()-this._start;f._totals+=l;let u=!1;function p(y,h){let o=[],r=new Array(y+1).join("	");for(const[e,n,i]of h._dep)if(n&&i){u=!0,o.push(`${r}CREATES -> ${e}`);let s=p(y+1,i);s&&o.push(s)}else o.push(`${r}uses -> ${e}`);return o.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(l>2||u)&&console.log(m.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[56],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,T.createDecorator)("localizationsService");function P(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const L of S.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=P}),define(te[14],ie([0,1,28,13,2,9,15]),function($,t,T,P,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,D.createDecorator)("logService"),t.ILoggerService=(0,D.createDecorator)("loggerService");function R(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class d extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class g extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...n]))}debug(e,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...n]))}info(e,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...n]))}warn(e,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...n]))}error(e,...n){if(this.checkLogLevel(c.Error))if(e instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=e.stack,this.log(c.Error,this.format(i))}else this.log(c.Error,this.format([e,...n]))}critical(e,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...n]))}flush(){}format(e){let n="";for(let i=0;i<e.length;i++){let s=e[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}n+=(i>0?" ":"")+s}return n}}t.AbstractMessageLogger=g;class I extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!L.isWindows}trace(e,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...n):console.log(`[main ${R()}]`,e,...n))}debug(e,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...n):console.log(`[main ${R()}]`,e,...n))}info(e,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,e,...n):console.log(`[main ${R()}]`,e,...n))}warn(e,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,e,...n):console.warn(`[main ${R()}]`,e,...n))}error(e,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,e,...n):console.error(`[main ${R()}]`,e,...n))}critical(e,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,e,...n):console.error(`[main ${R()}]`,e,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=I;class f extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}t.ConsoleLogger=f;class v extends d{constructor(e,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=v;class l extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const i of this.logServices)i.trace(e,...n)}debug(e,...n){for(const i of this.logServices)i.debug(e,...n)}info(e,...n){for(const i of this.logServices)i.info(e,...n)}warn(e,...n){for(const i of this.logServices)i.warn(e,...n)}error(e,...n){for(const i of this.logServices)i.error(e,...n)}critical(e,...n){for(const i of this.logServices)i.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=l;class u extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}t.LogService=u;class p extends S.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let i=this.loggers.get(e.toString());return i||(i=this.doCreateLogger(e,n?.always?c.Trace:this.logLevel,n),this.loggers.set(e.toString(),i),n?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=p;class m{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}t.NullLogService=m;function y(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const e=h(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=y;function h(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=h;function o(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(te[102],ie([0,1,3,11,2,9,19,41,7,30,10,20,23,24,16,14]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends S.Disposable{constructor(h,o,r,e){super();this.fileService=o,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=c.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const r=this.getName(h),e=(0,D.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const n=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(h,n,o);try{await this.rename(n,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(n)}catch(s){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,n.path),i}}return e}async delete(h){}async rename(h,o,r){try{await g.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(L.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],r=[];for(const i of h.children){const s=this.parse(i.name);s&&r.push([s,i])}const e=(0,v.groupByExtension)(r,([i])=>i),n=[];for(const i of e)i.sort((s,a)=>R.rcompare(s[0].version,a[0].version)),o.push(...i.slice(1).map(s=>s[1].resource)),n.push(i[0][1]);n.sort((i,s)=>i.mtime-s.mtime),o.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(i=>i.resource)),await T.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new v.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(h){const o=p.exec(h);return o&&o[1]&&o[2]?new v.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};m=fe([ae(0,I.INativeEnvironmentService),ae(1,l.IFileService),ae(2,f.IExtensionGalleryService),ae(3,u.ILogService)],m),t.ExtensionsDownloader=m}),define(te[103],ie([0,1,34,3,28,13,2,8,4,10,20,14]),function($,t,T,P,S,L,D,R,c,d,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let f=class extends D.Disposable{constructor(l,u){super();this.environmentService=l,this.logService=u,this.processesLimiter=new P.Limiter(5)}async postUninstall(l){const u=this.parseScript(l,"uninstall");return u&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${p}`)))),d.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(l,u){const p=`vscode:${u}`;if(l.location.scheme===R.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[p]=="string"){const m=l.manifest.scripts[p].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${p} should be a node script`),null):{script:(0,c.join)(l.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(l,u,p,m,y){return new Promise((h,o)=>{const r=this.start(l,u,p,y);let e;const n=i=>{e&&(clearTimeout(e),e=null),i?o(i):h(void 0)};r.on("error",i=>{n((0,S.toErrorMessage)(i)||"Unknown")}),r.on("exit",(i,s)=>{n(i?`post-${u} process exited with code ${i}`:void 0)}),m&&(e=setTimeout(()=>{e=null,r.kill(),o("timed out")},5e3))})}start(l,u,p,m){const y={silent:!0,execArgv:void 0},h=(0,T.fork)(l,[`--type=extension-post-${u}`,...p],y);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=L.Event.fromNodeEventEmitter(h.stdout,"data"),r=L.Event.fromNodeEventEmitter(h.stderr,"data");o(i=>this.logService.info(m.identifier.id,m.manifest.version,`post-${u}`,i)),r(i=>this.logService.error(m.identifier.id,m.manifest.version,`post-${u}`,i));const e=L.Event.any(L.Event.map(o,i=>({data:`%c${i}`,format:[""]})),L.Event.map(r,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(e,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(m.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),h}getExtensionStoragePath(l){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};f=fe([ae(0,g.IEnvironmentService),ae(1,I.ILogService)],f),t.ExtensionsLifecycle=f}),define(te[104],ie([0,1,13,2,19,7,20,24,16,14]),function($,t,T,P,S,L,D,R,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let g=class extends P.Disposable{constructor(f,v,l,u){super();this.extensionsManagementService=f,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(y=>this.onInstallExtension(y))),this._register(f.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(f.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const p=L.URI.file(l.extensionsPath),m=new S.ExtUri(y=>!v.hasCapability(y,1024));this._register(v.watch(p)),this._register(T.Event.filter(v.onDidChangeFilesRaw,y=>y.changes.some(h=>this.doesChangeAffects(h,p,m)))(()=>this.onDidChange()))}doesChangeAffects(f,v,l){return l.isEqual(l.dirname(f.resource),v)?l.isEqual(f.resource,l.joinPath(v,".obsolete"))?!0:!(f.type!==1&&f.type!==2||l.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const v of f)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(v=>!(0,R.areSameExtensions)(v,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,R.areSameExtensions)(v,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),v=f.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,R.areSameExtensions)(p,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),l=this.installedExtensions.filter(u=>this.installingExtensions.some(p=>(0,R.areSameExtensions)(p,u))?!1:f.every(p=>!(0,R.areSameExtensions)(p.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=f.map(u=>u.identifier),(v.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:l})}}};g=fe([ae(1,c.IFileService),ae(2,D.INativeEnvironmentService),ae(3,d.ILogService)],g),t.ExtensionsWatcher=g}),define(te[105],ie([0,1,130,22,3,2,8,4,10,20,23,24,56,14]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let l=class extends L.Disposable{constructor(m,y,h){super();this.extensionManagementService=m,this.logService=h,this.cache=this._register(new u(y,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),y=["en",...Object.keys(m)];return(0,P.distinct)(y)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const y=await this.cache.getLanguagePacks();Object.keys(y).some(h=>y[h]&&y[h].extensions.some(o=>(0,I.areSameExtensions)(o.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(y);return!(0,P.equals)(Object.keys(m),Object.keys(h))}};l=fe([ae(0,g.IExtensionManagementService),ae(1,d.INativeEnvironmentService),ae(2,v.ILogService)],l),t.LocalizationsService=l;let u=class extends L.Disposable{constructor(m,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(y=>{Object.keys(y).forEach(h=>delete y[h]),this.createLanguagePacksFromExtensions(y,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...y){for(const h of y)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,h);Object.keys(m).forEach(h=>this.updateHash(m[h]))}createLanguagePacksFromExtension(m,y){const h=y.identifier,o=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const r of o)if(y.location.scheme===D.Schemas.file&&(0,f.isValidLocalization)(r)){let e=m[r.languageId];e||(e={hash:"",extensions:[],translations:{}},m[r.languageId]=e);let n=e.extensions.filter(i=>(0,I.areSameExtensions)(i.extensionIdentifier,h))[0];n?n.version=y.manifest.version:e.extensions.push({extensionIdentifier:h,version:y.manifest.version});for(const i of r.translations)e.translations[i.id]=(0,R.join)(y.location.fsPath,i.path)}}updateHash(m){if(m){const y=(0,T.createHash)("md5");for(const h of m.extensions)y.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);m.hash=y.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(y=m(h),h)).then(h=>{for(const r of Object.keys(h))h[r]||delete h[r];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),c.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>y,h=>this.logService.error(h))})}};u=fe([ae(0,d.INativeEnvironmentService),ae(1,v.ILogService)],u)}),define(te[106],ie([0,1,16,14]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(c,d,g,I){try{const f=await new Promise((v,l)=>{$(["spdlog"],v,l)});return f.setFlushOn(P.LogLevel.Trace),f.createAsyncRotatingLogger(c,d,g,I)}catch(f){console.error(f)}return null}function L(c,d,g,I){const f=$.__$__nodeRequire("spdlog");return f.setFlushOn(P.LogLevel.Trace),f.createRotatingLogger(c,d,g,I)}t.createRotatingLogger=L;function D(c,d,g){switch(d){case P.LogLevel.Trace:c.trace(g);break;case P.LogLevel.Debug:c.debug(g);break;case P.LogLevel.Info:c.info(g);break;case P.LogLevel.Warning:c.warn(g);break;case P.LogLevel.Error:c.error(g);break;case P.LogLevel.Critical:c.critical(g);break;default:throw new Error("Invalid log level")}}class R extends P.AbstractMessageLogger{constructor(d,g,I,f){super();this.name=d,this.filepath=g,this.rotating=I,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(v=>{this._logger&&this._logger.setLevel(v)}))}_createSpdLogLogger(){const d=this.rotating?6:1,g=30/d*T.ByteSize.MB;return S(this.name,this.filepath,g,d).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:f,message:v}of this.buffer)D(this._logger,f,v);this.buffer=[]}})}log(d,g){this._logger?D(this._logger,d,g):this.getLevel()<=d&&this.buffer.push({level:d,message:g})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(te[57],ie([0,1,17,11,83,16,35]),function($,t,T,P,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function R(I,f,v,l,u,p){let m;try{await c(I,f,v,l,u,p)}catch(y){m=y}finally{m&&u.errorTransformer&&(m=u.errorTransformer(m)),typeof m!="undefined"&&v.error(m),v.end()}}t.readFileIntoStream=R;async function c(I,f,v,l,u,p){d(p);const m=await I.open(f,{create:!1});try{d(p);let y=0,h=0,o=u&&typeof u.length=="number"?u.length:void 0,r=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,n=0;do h=await I.read(m,e,r.buffer,n,r.byteLength-n),e+=h,n+=h,y+=h,typeof o=="number"&&(o-=h),n===r.byteLength&&(await v.write(l(r)),r=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),n=0);while(h>0&&(typeof o!="number"||o>0)&&d(p)&&g(y,u));if(n>0){let i=n;typeof o=="number"&&(i=Math.min(n,o)),v.write(l(r.slice(0,i)))}}catch(y){throw(0,L.ensureFileSystemProviderError)(y)}finally{await I.close(m)}}function d(I){if(I.isCancellationRequested)throw(0,P.canceled)();return!0}function g(I,f){if(f?.limits){if(typeof f.limits.memory=="number"&&I>f.limits.memory)throw(0,L.createFileSystemProviderError)((0,S.localize)(0,null,D.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&I>f.limits.size)throw(0,L.createFileSystemProviderError)((0,S.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[107],ie([0,1,22,3,17,25,13,131,2,47,8,132,19,37,82,16,57,14]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v,l,u,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let y=class Ne extends c.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,r=>this._onDidFilesChange.fire(new u.FileChangesEvent(r,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,r=>this._onDidFilesChange.fire(new u.FileChangesEvent(r,!0)))),this.watchedResources=d.TernarySearchTree.forUris(r=>{const e=this.getProvider(r.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,r){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:r});const e=new c.DisposableStore;return e.add(r.onDidChangeFile(n=>this.onDidChangeFile(n,this.isPathCaseSensitive(r)))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:o}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:r}),this.provider.delete(o),(0,c.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){r.push(e)}}),!this.provider.has(o)&&await P.Promises.settled(r)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,r){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return R.Iterable.map(this.provider,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async withProvider(o){if(!(0,f.isAbsolutePath)(o))throw new u.FileOperationError((0,l.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const r=this.provider.get(o.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=(0,l.localize)(1,null,o.toString()),e}return r}async withReadProvider(o){const r=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r)||(0,u.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const r=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.doResolveFile(o,r)}catch(e){throw(0,u.toFileSystemProviderErrorCode)(e)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,l.localize)(2,null,this.resourceForError(o)),1):(0,u.ensureFileSystemProviderError)(e)}}async doResolveFile(o,r){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),i=r?.resolveTo,s=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,E=await e.stat(o);let b;return this.toFileStat(e,o,E,void 0,!!a,(A,w)=>{if(!b&&(b=d.TernarySearchTree.forUris(()=>!n),b.set(o,!0),i))for(const C of i)b.set(C,!0);return b.get(A.resource)||b.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&s?w===1:!1})}async toFileStat(o,r,e,n,i,s){const{providerExtUri:a}=this.getExtUri(o),E={resource:r,name:a.basename(r),isFile:(e.type&u.FileType.File)!=0,isDirectory:(e.type&u.FileType.Directory)!=0,isSymbolicLink:(e.type&u.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&u.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,u.etag)({mtime:e.mtime,size:e.size})};if(E.isDirectory&&s(E,n)){try{const b=await o.readdir(r),A=await P.Promises.settled(b.map(async([w,C])=>{try{const U=a.joinPath(r,w),V=i?await o.stat(U):{type:C};return await this.toFileStat(o,U,V,b.length,i,s)}catch(U){return this.logService.trace(U),null}}));E.children=(0,T.coalesce)(A)}catch(b){this.logService.trace(b),E.children=[]}return E}return E}async resolveAll(o){return P.Promises.settled(o.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const r=await this.withProvider(o);try{return!!await r.stat(o)}catch(e){return!1}}async canCreateFile(o,r){try{await this.doValidateCreateFile(o,r)}catch(e){return e}return!0}async doValidateCreateFile(o,r){if(!r?.overwrite&&await this.exists(o))throw new u.FileOperationError((0,l.localize)(3,null,this.resourceForError(o)),3,r)}async createFile(o,r=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,r);return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,n)),n}async writeFile(o,r,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,i.dirname(o));let a;if((0,u.hasReadWriteCapability)(n)&&!(r instanceof S.VSBuffer))if((0,v.isReadableStream)(r)){const E=await(0,v.peekStream)(r,3);E.ended?a=S.VSBuffer.concat(E.buffer):a=E}else a=(0,v.peekReadable)(r,E=>S.VSBuffer.concat(E),3);else a=r;!(0,u.hasOpenReadWriteCloseCapability)(n)||(0,u.hasReadWriteCapability)(n)&&a instanceof S.VSBuffer?await this.doWriteUnbuffered(n,o,e,a):await this.doWriteBuffered(n,o,e,a instanceof S.VSBuffer?(0,S.bufferToReadable)(a):a)}catch(s){throw new u.FileOperationError((0,l.localize)(4,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,r,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(r)));let i;try{i=await o.stat(r)}catch(s){return}if((i.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,l.localize)(6,null,this.resourceForError(r)),0,e);if(this.throwIfFileIsReadonly(r,i),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==u.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&e.mtime<i.mtime&&e.etag!==(0,u.etag)({mtime:e.mtime,size:i.size}))throw new u.FileOperationError((0,l.localize)(7,null),3,e);return i}async readFile(o,r){const e=await this.withReadProvider(o);return r?.atomic?this.doReadFileAtomic(e,o,r):this.doReadFile(e,o,r)}async doReadFileAtomic(o,r,e){return new Promise((n,i)=>{this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,r,e);n(s)}catch(s){i(s)}})})}async doReadFile(o,r,e){const n=await this.doReadFileStream(o,r,{...e,preferUnbuffered:!0});return{...n,value:await(0,S.streamToBuffer)(n.value)}}async readFileStream(o,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,r)}async doReadFileStream(o,r,e){const n=new L.CancellationTokenSource,i=this.validateReadFile(r,e).then(a=>a,a=>{throw n.cancel(),a});let s;try{return typeof e?.etag=="string"&&e.etag!==u.ETAG_DISABLED&&await i,!((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasFileReadStreamCapability)(o))||(0,u.hasReadWriteCapability)(o)&&e?.preferUnbuffered?s=this.readFileUnbuffered(o,r,e):(0,u.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,r,n.token,e):s=this.readFileBuffered(o,r,n.token,e),{...await i,value:s}}catch(a){s&&await(0,v.consumeStream)(s);const E=(0,l.localize)(8,null,this.resourceForError(r),(0,u.ensureFileSystemProviderError)(a).toString());throw a instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(E,a.stat,e):new u.FileOperationError(E,(0,u.toFileOperationResult)(a),e)}}readFileStreamed(o,r,e,n=Object.create(null)){const i=o.readFileStream(r,n,e);return(0,v.transform)(i,{data:s=>s instanceof S.VSBuffer?s:S.VSBuffer.wrap(s),error:s=>new u.FileOperationError((0,l.localize)(9,null,this.resourceForError(r),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),n)},s=>S.VSBuffer.concat(s))}readFileBuffered(o,r,e,n=Object.create(null)){const i=(0,S.newWriteableBufferStream)();return(0,p.readFileIntoStream)(o,r,i,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new u.FileOperationError((0,l.localize)(10,null,this.resourceForError(r),(0,u.ensureFileSystemProviderError)(s).toString()),(0,u.toFileOperationResult)(s),n)},e),i}readFileUnbuffered(o,r,e){const n=(0,v.newWriteableStream)(i=>S.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(r);typeof e?.position=="number"&&(i=i.slice(e.position)),typeof e?.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(r,i.byteLength,e),n.end(S.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(o,r){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new u.FileOperationError((0,l.localize)(11,null,this.resourceForError(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==u.ETAG_DISABLED&&r.etag===e.etag)throw new u.NotModifiedSinceFileOperationError((0,l.localize)(12,null),e,r);return this.validateReadFileLimits(o,e.size,r),e}validateReadFileLimits(o,r,e){if(e?.limits){let n;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&r>e.limits.size&&(n=7),typeof n=="number")throw new u.FileOperationError((0,l.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,r,e){return this.doCanMoveCopy(o,r,"move",e)}async canCopy(o,r,e){return this.doCanMoveCopy(o,r,"copy",e)}async doCanMoveCopy(o,r,e,n){if(o.toString()!==r.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(i,o,s,r,e,n)}catch(i){return i}return!0}async move(o,r,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,o,i,r,"move",!!e),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,s==="move"?2:3,a)),a}async copy(o,r,e){const n=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),s=await this.doMoveCopy(n,o,i,r,"copy",!!e),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,s==="copy"?3:2,a)),a}async doMoveCopy(o,r,e,n,i,s){if(r.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,r,e,n,i,s);if(a&&!E&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),i==="copy"){if(o===e&&(0,u.hasFileFolderCopyCapability)(o))await o.copy(r,n,{overwrite:s});else{const b=await this.resolve(r);b.isDirectory?await this.doCopyFolder(o,b,e,n):await this.doCopyFile(o,r,e,n)}return i}else return o===e?(await o.rename(r,n,{overwrite:s}),i):(await this.doMoveCopy(o,r,e,n,"copy",s),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(o,r,e,n){if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,r,e,n);if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,r,e,n);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,r,e,n);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,r,e,n)}async doCopyFolder(o,r,e,n){await e.mkdir(n),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async i=>{const s=this.getExtUri(e).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),e,s):this.doCopyFile(o,i.resource,e,s)}))}async doValidateMoveCopy(o,r,e,n,i,s){let a=!1;if(o===e){const{providerExtUri:b,isPathCaseSensitive:A}=this.getExtUri(o);if(A||(a=b.isEqual(r,n)),a&&i==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(r),this.resourceForError(n)));if(!a&&b.isEqualOrParent(n,r))throw new Error((0,l.localize)(15,null,this.resourceForError(r),this.resourceForError(n)))}const E=await this.exists(n);if(E&&!a){if(!s)throw new u.FileOperationError((0,l.localize)(16,null,this.resourceForError(r),this.resourceForError(n)),4);if(o===e){const{providerExtUri:b}=this.getExtUri(o);if(b.isEqualOrParent(r,n))throw new Error((0,l.localize)(17,null,this.resourceForError(r),this.resourceForError(n)))}}return{exists:E,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const r=this.isPathCaseSensitive(o);return{providerExtUri:r?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(r,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,e)),e}async mkdirp(o,r){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(r,n.dirname(r));)try{if(((await o.stat(r)).type&u.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(r)));break}catch(i){if((0,u.toFileSystemProviderErrorCode)(i)!==u.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(n.basename(r)),r=n.dirname(r)}for(let i=e.length-1;i>=0;i--){r=n.joinPath(r,e[i]);try{await o.mkdir(r)}catch(s){if((0,u.toFileSystemProviderErrorCode)(s)!==u.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,r){try{await this.doValidateDelete(o,r)}catch(e){return e}return!0}async doValidateDelete(o,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!r?.useTrash&&!(e.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(o)));let i;try{i=await e.stat(o)}catch(a){}if(i)this.throwIfFileIsReadonly(o,i);else throw new u.FileOperationError((0,l.localize)(20,null,this.resourceForError(o)),1);if(!!!r?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(o)))}return e}async del(o,r){const e=await this.doValidateDelete(o,r),n=!!r?.useTrash,i=!!r?.recursive;await e.delete(o,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new u.FileOperationEvent(o,1))}onDidChangeFile(o,r){this._onDidChangeFilesRaw.fire({changes:o});let e,n;{for(const i of o)this.watchedResources.has(i.resource)?(e||(e=[]),e.push(i)):(n||(n=[]),n.push(i));e&&this._onDidFilesChange.fire(new u.FileChangesEvent(e,!r))}if(n){const i=r?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(n)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${n[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,r={recursive:!1,excludes:[]}){const e=new c.DisposableStore;{let n=!1,i=()=>{n=!0};e.add((0,c.toDisposable)(()=>i())),this.doWatch(o,r).then(s=>{n?(0,c.dispose)(s):i=()=>(0,c.dispose)(s)},s=>this.logService.error(s))}return r.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,c.toDisposable)(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),e}async doWatch(o,r){const e=await this.withProvider(o),n=this.toWatchKey(e,o,r),i=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,r)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,i),i.count+=1,(0,c.toDisposable)(()=>{i.count--,i.count===0&&((0,c.dispose)(i.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,r,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,c.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,r,e,n){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(r,{create:!0,unlock:e?.unlock??!1});try{(0,v.isReadableStream)(n)||(0,v.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,i,n):await this.doWriteReadableBufferedQueued(o,i,n)}catch(s){throw(0,u.ensureFileSystemProviderError)(s)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,r,e){let n=0,i;if((0,v.isReadableBufferedStream)(e)){if(e.buffer.length>0){const s=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,r,s,s.byteLength,n,0),n+=s.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise(async(s,a)=>{(0,v.listenStream)(i,{onData:async E=>{i.pause();try{await this.doWriteBuffer(o,r,E,E.byteLength,n,0)}catch(b){return a(b)}n+=E.byteLength,setTimeout(()=>i.resume())},onError:E=>a(E),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,r,e){let n=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(o,r,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(o,r,e,n,i,s){let a=0;for(;a<n;)a+=await o.write(r,i+a,e.buffer,s+a,n-a)}async doWriteUnbuffered(o,r,e,n){return this.writeQueue.queueFor(r,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,r,e,n))}async doWriteUnbufferedQueued(o,r,e,n){let i;n instanceof S.VSBuffer?i=n:(0,v.isReadableStream)(n)?i=await(0,S.streamToBuffer)(n):(0,v.isReadableBufferedStream)(n)?i=await(0,S.bufferedStreamToBuffer)(n):i=(0,S.readableToBuffer)(n),await o.writeFile(r,i.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,r,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,r,e,n))}async doPipeBufferedQueued(o,r,e,n){let i,s;try{i=await o.open(r,{create:!1}),s=await e.open(n,{create:!0,unlock:!1});const a=S.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,b=0,A=0;do A=await o.read(i,E,a.buffer,b,a.byteLength-b),await this.doWriteBuffer(e,s,a,A,E,b),E+=A,b+=A,b===a.byteLength&&(b=0);while(A>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await P.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,r,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,r,e,n))}async doPipeUnbufferedQueued(o,r,e,n){return e.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,r,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,r,e,n))}async doPipeUnbufferedToBufferedQueued(o,r,e,n){const i=await e.open(n,{create:!0,unlock:!1});try{const s=await o.readFile(r);await this.doWriteBuffer(e,i,S.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,u.ensureFileSystemProviderError)(s)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(o,r,e,n){const i=await(0,S.streamToBuffer)(this.readFileBuffered(o,r,L.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,i)}throwIfFileSystemIsReadonly(o,r){if(o.capabilities&2048)throw new u.FileOperationError((0,l.localize)(22,null,this.resourceForError(r)),6);return o}throwIfFileIsReadonly(o,r){if((r.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,l.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===g.Schemas.file?o.fsPath:o.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=fe([ae(0,m.ILogService)],y),t.FileService=y}),define(te[108],ie([0,1,22,3,17,13,32,2,4,9,19,37,10,84,16,57,100,92,93,54,95,14]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v,l,u,p,m,y,h,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends R.Disposable{constructor(i,s){super();this.logService=i,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:a}=await f.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,a),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await f.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),a=[];return await Promise.all(s.map(async E=>{try{let b;E.isSymbolicLink()?b=(await this.stat((0,g.joinPath)(i,E.name))).type:b=this.toType(E),a.push([E.name,b])}catch(b){this.logService.trace(b)}})),a}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let a;return s?.dangling?a=l.FileType.Unknown:i.isFile()?a=l.FileType.File:i.isDirectory()?a=l.FileType.Directory:a=l.FileType.Unknown,s&&(a|=l.FileType.SymbolicLink),a}async readFile(i){try{const s=this.toFilePath(i);return await f.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(i,s,a){const E=(0,I.newWriteableStream)(b=>S.VSBuffer.concat(b.map(A=>S.VSBuffer.wrap(A))).buffer);return(0,u.readFileIntoStream)(this,i,E,b=>b.buffer,{...s,bufferSize:this.BUFFER_SIZE},a),E}async writeFile(i,s,a){let E;try{const b=this.toFilePath(i);if(!a.create||!a.overwrite){if(await f.Promises.exists(b)){if(!a.overwrite)throw(0,l.createFileSystemProviderError)((0,v.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,l.createFileSystemProviderError)((0,v.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(i,{create:!0,unlock:a.unlock}),await this.write(E,0,s,0,s.byteLength)}catch(b){throw await this.toFileSystemProviderWriteError(i,b)}finally{typeof E=="number"&&await this.close(E)}}async open(i,s){try{const a=this.toFilePath(i);if((0,l.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:A}=await f.SymlinkSupport.stat(a);A.mode&128||await f.Promises.chmod(a,A.mode|128)}catch(A){this.logService.trace(A)}let E;if((0,l.isFileOpenForWriteOptions)(s)){if(d.isWindows)try{await f.Promises.truncate(a,0),E="r+"}catch(A){A.code!=="ENOENT"&&this.logService.trace(A)}E||(E="w")}else E="r";const b=await f.Promises.open(a,E);return this.mapHandleToPos.set(b,0),(0,l.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(b,i),b}catch(a){throw(0,l.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,a):this.toFileSystemProviderError(a)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await f.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await f.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}}async read(i,s,a,E,b){const A=this.normalizePos(i,s);let w=null;try{const C=await f.Promises.read(i,a,E,b,A);return typeof C=="number"?w=C:w=C.bytesRead,w}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(i,A,w)}}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,a){const E=this.mapHandleToPos.get(i);typeof E=="number"&&(typeof s=="number"||(typeof a=="number"?this.mapHandleToPos.set(i,E+a):this.mapHandleToPos.delete(i)))}async write(i,s,a,E,b){return(0,P.retry)(()=>this.doWrite(i,s,a,E,b),100,3)}async doWrite(i,s,a,E,b){const A=this.normalizePos(i,s);let w=null;try{const C=await f.Promises.write(i,a,E,b,A);return typeof C=="number"?w=C:w=C.bytesWritten,w}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),C)}finally{this.updatePos(i,A,w)}}async mkdir(i){try{await f.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const a=this.toFilePath(i);await this.doDelete(a,s)}catch(a){throw this.toFileSystemProviderError(a)}}async doDelete(i,s){s.recursive?await f.Promises.rm(i,f.RimRafMode.MOVE):await f.Promises.unlink(i)}async rename(i,s,a){const E=this.toFilePath(i),b=this.toFilePath(s);if(E!==b)try{await this.validateTargetDeleted(i,s,"move",a.overwrite),await f.Promises.move(E,b)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,v.localize)(2,null,(0,c.basename)(E),(0,c.basename)((0,c.dirname)(b)),A.toString()))),this.toFileSystemProviderError(A)}}async copy(i,s,a){const E=this.toFilePath(i),b=this.toFilePath(s);if(E!==b)try{await this.validateTargetDeleted(i,s,"copy",a.overwrite),await f.Promises.copy(E,b,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,v.localize)(3,null,(0,c.basename)(E),(0,c.basename)((0,c.dirname)(b)),A.toString()))),this.toFileSystemProviderError(A)}}async validateTargetDeleted(i,s,a,E){const b=this.toFilePath(i),A=this.toFilePath(s);let w=!1;if(!!(this.capabilities&1024)||(w=(0,D.isEqual)(b,A,!0)),w&&a==="copy")throw(0,l.createFileSystemProviderError)((0,v.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!w&&await f.Promises.exists(A)){if(!E)throw(0,l.createFileSystemProviderError)((0,v.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(i,s){return s.recursive?this.watchRecursive(i,s.excludes):this.watchNonRecursive(i)}watchRecursive(i,s){const a={path:this.toFilePath(i),excludes:s},E=(0,T.insert)(this.recursiveFoldersToWatch,a);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof m.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,s;this.options?.watcher?.usePolling?(i=y.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?d.isWindows?i=o.FileWatcher:i=y.FileWatcher:i=m.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,a=>this._onDidChangeFile.fire((0,h.toFileChanges)(a)),a=>{a.type==="error"&&this._onDidWatchErrorOccur.fire(a.message),this.logService[a.type](a.message)},this.logService.getLevel()===r.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===r.LogLevel.Trace)}))}}watchNonRecursive(i){const s=new p.FileWatcher(this.toFilePath(i),E=>this._onDidChangeFile.fire((0,h.toFileChanges)(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===r.LogLevel.Trace),a=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===r.LogLevel.Trace)});return(0,R.combinedDisposable)(s,a)}toFilePath(i){return(0,c.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof l.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=l.FileSystemProviderErrorCode.NoPermissions;break;default:s=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let a=this.toFileSystemProviderError(s);if(i&&a.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:E}=await f.SymlinkSupport.stat(this.toFilePath(i));E.mode&128||(a=(0,l.createFileSystemProviderError)(s,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(E){this.logService.trace(E)}return a}dispose(){super.dispose(),(0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,R.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(te[42],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,T.createDecorator)("productService")}),define(te[26],ie([0,1,58,12]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(D,R){T.ok(P.isString(D)),T.ok(P.isObject(R)),T.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,R)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}t.Registry=new S}),define(te[109],ie([0,1,13,26]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[S(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new L;P.Registry.add(t.Extensions.JSONContribution,D)}),define(te[31],ie([0,1,13,12,74,109,26]),function($,t,T,P,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var R;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(R=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var c;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=D.Registry.as(L.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,h=!0){this.registerConfigurations([y],h)}registerConfigurations(y,h=!0){const o=[];y.forEach(r=>{o.push(...this.validateAndRegisterProperties(r,h,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(y){const h=[],o=r=>{if(r.properties)for(const e in r.properties)h.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,r.properties[e]);r.allOf&&r.allOf.forEach(e=>o(e))};for(const r of y){o(r);const e=this.configurationContributors.indexOf(r);e!==-1&&this.configurationContributors.splice(e,1)}d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(y){const h=[],o=[];for(const r of y)for(const e in r)if(h.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...r[e]};const n={type:"object",default:this.defaultValues[e],description:S.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};o.push(f(e)),this.configurationProperties[e]=n,this.defaultLanguageConfigurationOverridesNode.properties[e]=n}else{this.defaultValues[e]=r[e];const n=this.configurationProperties[e];n&&(this.updatePropertyDefaultValue(e,n),this.updateSchema(e,n))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(y){const h=[];for(const o of y)for(const r in o)if(h.push(r),delete this.defaultValues[r],t.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const h of y)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(y,h=!0,o,r=3){r=P.isUndefinedOrNull(y.scope)?r:y.scope;let e=[],n=y.properties;if(n)for(let s in n){if(h&&u(s)){delete n[s];continue}const a=n[s];if(this.updatePropertyDefaultValue(s,a),t.OVERRIDE_PROPERTY_PATTERN.test(s)?a.scope=void 0:(a.scope=P.isUndefinedOrNull(a.scope)?r:a.scope,a.restricted=P.isUndefinedOrNull(a.restricted)?!!o?.restrictedConfigurations?.includes(s):a.restricted),n[s].hasOwnProperty("included")&&!n[s].included){this.excludedConfigurationProperties[s]=n[s],delete n[s];continue}else this.configurationProperties[s]=n[s];!n[s].deprecationMessage&&n[s].markdownDeprecationMessage&&(n[s].deprecationMessage=n[s].markdownDeprecationMessage),e.push(s)}let i=y.allOf;if(i)for(let s of i)e.push(...this.validateAndRegisterProperties(s,h,o,r));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const h=o=>{let r=o.properties;if(r)for(const n in r)this.updateSchema(n,r[n]);let e=o.allOf;e&&e.forEach(h)};h(y)}updateSchema(y,h){switch(t.allSettings.properties[y]=h,h.scope){case 1:t.applicationSettings.properties[y]=h;break;case 2:t.machineSettings.properties[y]=h;break;case 6:t.machineOverridableSettings.properties[y]=h;break;case 3:t.windowSettings.properties[y]=h;break;case 4:t.resourceSettings.properties[y]=h;break;case 5:t.resourceSettings.properties[y]=h,this.resourceLanguageSettingsSchema.properties[y]=h;break}}removeFromSchema(y,h){switch(delete t.allSettings.properties[y],h.scope){case 1:delete t.applicationSettings.properties[y];break;case 2:delete t.machineSettings.properties[y];break;case 6:delete t.machineOverridableSettings.properties[y];break;case 3:delete t.windowSettings.properties[y];break;case 4:case 5:delete t.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const h=`[${y}]`,o={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),t.allSettings.properties[h]=o,t.applicationSettings.properties[h]=o,t.machineSettings.properties[h]=o,t.machineOverridableSettings.properties[h]=o,t.windowSettings.properties[h]=o,t.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,h){let o=this.defaultValues[y];P.isUndefined(o)&&(o=h.default),P.isUndefined(o)&&(o=v(h.type)),h.default=o}}const I="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function f(m){return m.substring(1,m.length-1)}t.overrideIdentifierFromKey=f;function v(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=v;const l=new g;D.Registry.add(t.Extensions.Configuration,l);function u(m){return m.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(m)?S.localize(5,null,m):l.getConfigurationProperties()[m]!==void 0?S.localize(6,null,m):null:S.localize(4,null)}t.validateProperty=u;function p(){const m=[],y=l.getConfigurationProperties();for(const h of Object.keys(y))m.push([h,y[h].scope]);return m.push(["launch",4]),m.push(["task",4]),m}t.getScopes=p}),define(te[27],ie([0,1,18,12,7,31,15,26]),function($,t,T,P,S,L,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,D.createDecorator)("configurationService");function c(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof S.URI)}t.isConfigurationOverrides=c;var d;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function g(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=g;function I(n,i){const s=i?n?i.keys.filter(U=>n.keys.indexOf(U)===-1):[...i.keys]:[],a=n?i?n.keys.filter(U=>i.keys.indexOf(U)===-1):[...n.keys]:[],E=[];if(i&&n){for(const U of n.keys)if(i.keys.indexOf(U)!==-1){const V=m(n.contents,U),J=m(i.contents,U);T.equals(V,J)||E.push(U)}}const b=[],A=U=>{const V={};for(const J of U)for(const ne of J.identifiers)V[r(ne)]=J;return V},w=i?A(i.overrides):{},C=n?A(n.overrides):{};if(Object.keys(w).length)for(const U of s){const V=w[U];V&&b.push([(0,L.overrideIdentifierFromKey)(U),V.keys])}if(Object.keys(C).length)for(const U of a){const V=C[U];V&&b.push([(0,L.overrideIdentifierFromKey)(U),V.keys])}if(Object.keys(w).length&&Object.keys(C).length)for(const U of E){const V=C[U],J=w[U];if(V&&J){const ne=I({contents:V.contents,keys:V.keys,overrides:[]},{contents:J.contents,keys:J.keys,overrides:[]});b.push([(0,L.overrideIdentifierFromKey)(U),[...ne.added,...ne.removed,...ne.updated]])}}return{added:s,removed:a,updated:E,overrides:b}}t.compare=I;function f(n,i){const s=[];for(const a of Object.keys(n))if(L.OVERRIDE_PROPERTY_PATTERN.test(a)){const E={};for(const b in n[a])E[b]=n[a][b];s.push({identifiers:[(0,L.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(E),contents:v(E,i)})}return s}t.toOverrides=f;function v(n,i){const s=Object.create(null);for(let a in n)l(s,a,n[a],i);return s}t.toValuesTree=v;function l(n,i,s,a){const E=i.split("."),b=E.pop();let A=n;for(let w=0;w<E.length;w++){let C=E[w],U=A[C];switch(typeof U){case"undefined":U=A[C]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${E.slice(0,w+1).join(".")} is ${JSON.stringify(U)}`);return}A=U}if(typeof A=="object"&&A!==null)try{A[b]=s}catch(w){a(`Ignoring ${i} as ${E.join(".")} is ${JSON.stringify(A)}`)}else a(`Ignoring ${i} as ${E.join(".")} is ${JSON.stringify(A)}`)}t.addToValueTree=l;function u(n,i){const s=i.split(".");p(n,s)}t.removeFromValueTree=u;function p(n,i){const s=i.shift();if(i.length===0){delete n[s];return}if(Object.keys(n).indexOf(s)!==-1){const a=n[s];typeof a=="object"&&!Array.isArray(a)&&(p(a,i),Object.keys(a).length===0&&delete n[s])}}function m(n,i,s){function a(A,w){let C=A;for(const U of w){if(typeof C!="object"||C===null)return;C=C[U]}return C}const E=i.split("."),b=a(n,E);return typeof b=="undefined"?s:b}t.getConfigurationValue=m;function y(n,i,s){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in n?P.isObject(n[a])&&P.isObject(i[a])?y(n[a],i[a],s):s&&(n[a]=i[a]):n[a]=i[a])})}t.merge=y;function h(){const n=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=h;function o(){const n=Object.create(null),i=R.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let s in i){let a=i[s].default;l(n,s,a,E=>console.error(`Conflict in default settings: ${E}`))}return n}t.getDefaultValues=o;function r(n){return`[${n}]`}t.keyFromOverrideIdentifier=r;function e(n,i,s){const a=n.inspect(i),E=n.inspect(s);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:a.defaultValue}t.getMigratedSettingValue=e}),define(te[110],ie([0,1,22,13,59,2,47,18,12,7,27,31,26]),function($,t,T,P,S,L,D,R,c,d,g,I,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class v{constructor(e={},n=[],i=[]){this._contents=e,this._keys=n,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,g.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const i=this.getContentsForOverrideIdentifer(n);return i?e?(0,g.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let i={};for(const s of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[s],E=n[s];E&&(typeof a=="object"&&typeof E=="object"?(a=R.deepClone(a),this.mergeContents(a,E)):a=E),i[s]=a}return new v(i,this.keys,this.overrides)}merge(...e){const n=R.deepClone(this.contents),i=R.deepClone(this.overrides),s=[...this.keys];for(const a of e){this.mergeContents(n,a.contents);for(const E of a.overrides){const[b]=i.filter(A=>T.equals(A.identifiers,E.identifiers));b?this.mergeContents(b.contents,E.contents):i.push(R.deepClone(E))}for(const E of a.keys)s.indexOf(E)===-1&&s.push(E)}return new v(n,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const i of Object.keys(n)){if(i in e&&c.isObject(e[i])&&c.isObject(n[i])){this.mergeContents(e[i],n[i]);continue}e[i]=R.deepClone(n[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?R.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,g.addToValueTree)(this.contents,e,n,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,g.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let i=0;i<n;i++)e.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=v;class l extends v{constructor(){const e=(0,g.getDefaultValues)(),n=(0,g.getConfigurationKeys)(),i=[];for(const s of Object.keys(e))I.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[(0,I.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(e[s]),contents:(0,g.toValuesTree)(e[s],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,n,i)}}t.DefaultConfigurationModel=l;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!c.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:i,keys:s,overrides:a,restricted:E}=this.doParseRaw(e,n);this._configurationModel=new v(i,s,a),this._restrictedConfigurations=E||[]}doParseContent(e){let n={},i=null,s=[],a=[],E=[];function b(w){Array.isArray(s)?s.push(w):i!==null&&(s[i]=w)}let A={onObjectBegin:()=>{let w={};b(w),a.push(s),s=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let w=[];b(w),a.push(s),s=w,i=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:b,onError:(w,C,U)=>{E.push({error:w,offset:C,length:U})}};if(e)try{S.visit(e,A),n=s[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return n}doParseRaw(e,n){const i=f.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,i,!0,n);e=s.raw;const a=(0,g.toValuesTree)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),E=Object.keys(e),b=(0,g.toOverrides)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:a,keys:E,overrides:b,restricted:s.restricted}}filter(e,n,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:e,restricted:[]};const a={},E=[];for(let b in e)if(I.OVERRIDE_PROPERTY_PATTERN.test(b)&&i){const A=this.filter(e[b],n,!1,s);a[b]=A.raw,E.push(...A.restricted)}else{const A=n[b],w=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&E.push(b),(w===void 0||s.scopes===void 0||s.scopes.includes(w))&&(s.skipRestricted&&A?.restricted||(a[b]=e[b]))}return{raw:a,restricted:E}}}t.ConfigurationModelParser=u;class p extends L.Disposable{constructor(e,n,i,s){super();this.userSettingsResource=e,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=p;class m{constructor(e,n,i=new v,s=new v,a=new D.ResourceMap,E=new v,b=new D.ResourceMap,A=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=E,this._memoryConfigurationByResource=b,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(e,n,i){return this.getConsolidateConfigurationModel(n,i).getValue(e)}updateValue(e,n,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new v,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(e):s.setValue(e,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,i){const s=this.getConsolidateConfigurationModel(n,i),a=this.getFolderConfigurationModelForResource(n.resource,i),E=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,b=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),A=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),w=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),C=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,V=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,J=n.overrideIdentifier?E.override(n.overrideIdentifier).getValue(e):E.getValue(e),ne=s.getValue(e),se=T.distinct(T.flatten(s.overrides.map(ee=>ee.identifiers))).filter(ee=>s.getOverrideValue(e,ee)!==void 0);return{defaultValue:b,userValue:A,userLocalValue:w,userRemoteValue:C,workspaceValue:U,workspaceFolderValue:V,memoryValue:J,value:ne,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:V!==void 0?{value:a?.freeze().getValue(e),override:n.overrideIdentifier?a?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:J!==void 0?{value:E.getValue(e),override:n.overrideIdentifier?E.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const i=n.filter(s=>I.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const a=(0,I.overrideIdentifierFromKey)(s),E=this._defaultConfiguration.getKeysForOverrideIdentifier(a),b=e.getKeysForOverrideIdentifier(a),A=[...b.filter(w=>E.indexOf(w)===-1),...E.filter(w=>b.indexOf(w)===-1),...E.filter(w=>!R.equals(this._defaultConfiguration.override(a).getValue(w),e.override(a).getValue(w)))];return[a,A]});return this.updateDefaultConfiguration(e),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:i,removed:s,overrides:a}=(0,g.compare)(this.localUserConfiguration,e),E=[...n,...i,...s];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:i,removed:s,overrides:a}=(0,g.compare)(this.remoteUserConfiguration,e);let E=[...n,...i,...s];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:i,removed:s,overrides:a}=(0,g.compare)(this.workspaceConfiguration,e);let E=[...n,...i,...s];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(e,n){const i=this.folderConfigurations.get(e),{added:s,updated:a,removed:E,overrides:b}=(0,g.compare)(i,n);let A=[...s,...a,...E];return(A.length||!i)&&this.updateFolderConfiguration(e,n),{keys:A,overrides:b}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:s,removed:a,overrides:E}=(0,g.compare)(n,void 0);return{keys:[...i,...s,...a],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let i=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const s=n.getFolder(e);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const a=this._memoryConfigurationByResource.get(e);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(n=i.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=i}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const i=n.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:i,overrides:s,keys:a}=this._folderConfigurations.get(n);return e.push([n,{contents:i,overrides:s,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((E,b)=>(E.set(d.URI.revive(b[0]),this.parseConfigurationModel(b[1])),E),new D.ResourceMap);return new m(n,i,new v,s,a,new v,new D.ResourceMap,!1)}static parseConfigurationModel(e){return new v(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=m;function y(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const s of r)s.keys.forEach(a=>e.add(a)),s.overrides.forEach(([a,E])=>{const b=(0,D.getOrSet)(n,a,new Set);E.forEach(A=>b.add(A))});const i=[];return n.forEach((s,a)=>i.push([a,[...s.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=y;class h{constructor(e,n,i,s){this.change=e,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(b=>a.add(b)),e.overrides.forEach(([,b])=>b.forEach(A=>a.add(A))),this.affectedKeys=[...a.values()];const E=new v;this.affectedKeys.forEach(b=>E.setValue(b,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!R.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let i=(0,g.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(e=e[s],!e)return!1;i=i[s]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,n,i,s){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=i,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=o}),define(te[111],ie([0,1,3,13,2,19,27,110,31,26]),function($,t,T,P,S,L,D,R,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class g extends S.Disposable{constructor(f,v){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,v){const l=typeof f=="string"?f:void 0,u=(0,D.isConfigurationOverrides)(f)?f:(0,D.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(l,u,void 0)}updateValue(f,v,l,u){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const v=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(l,v,1)}onDidDefaultConfigurationChange(f){const v=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(l,v,6)}trigger(f,v,l){const u=new R.ConfigurationChangeEvent(f,{data:v},this.configuration);u.source=l,u.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=g}),define(te[43],ie([0,1,17,85,31,15,26]),function($,t,T,P,S,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,L.createDecorator)("requestService");function R(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}t.isSuccess=R;function c(l){return l.res.statusCode===204}async function d(l){if(!R(l))throw new Error("Server returned "+l.res.statusCode);return c(l)?null:(await(0,T.streamToBuffer)(l.stream)).toString()}t.asText=d;async function g(l){if(!R(l))throw new Error("Server returned "+l.res.statusCode);if(c(l))return null;const p=(await(0,T.streamToBuffer)(l.stream)).toString();try{return JSON.parse(p)}catch(m){throw m.message+=`:
`+p,m}}t.asJson=g;function I(l){v(l)}t.updateProxyConfigurationsScope=I;let f;function v(l){const u=D.Registry.as(S.Extensions.Configuration);f&&u.deregisterConfigurations([f]),f={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},u.registerConfiguration(f)}v(2)}),define(te[112],ie([0,1,25,8,16,43]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let D=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,g=T.CancellationToken.None){if(c.scheme===P.Schemas.file||c.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const I={type:"GET",url:c.toString()},f=await this.requestService.request(I,g);if(f.res.statusCode===200)await this.fileService.writeFile(d,f.stream);else{const v=await(0,L.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${v}`)}}};D=fe([ae(0,L.IRequestService),ae(1,S.IFileService)],D),t.DownloadService=D}),define(te[113],ie([0,1,114,12]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(D,R){return D.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:D.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function L(D,R,c={}){const d=(0,T.parse)(D),g=c.proxyUrl||S(d,R);if(!g)return null;const I=(0,T.parse)(g);if(!/^https?:$/.test(I.protocol||""))return null;const f={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,P.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((v,l)=>{$(["http-proxy-agent"],v,l)}))(f):new(await new Promise((v,l)=>{$(["https-proxy-agent"],v,l)}))(f)}t.getProxyAgent=L}),define(te[115],ie([0,1,17,30]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(L,D,R){let c=R&&R.get("storage.serviceMachineId",0)||null;if(c)return c;try{const g=(await D.readFile(L.serviceMachineIdResource)).value.toString();c=(0,P.isUUID)(g)?g:null}catch(d){c=null}if(!c){c=(0,P.generateUuid)();try{await D.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(c))}catch(d){}}return R&&R.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=S}),define(te[116],ie([0,1,3,13,2,12,67,15]),function($,t,T,P,S,L,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,R.createDecorator)("storageService");var d;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var g;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(g=t.StorageScope||(t.StorageScope={}));var I;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(I=t.StorageTarget||(t.StorageTarget={}));class f extends S.Disposable{constructor(p={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,m){m===c?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:m,target:this.getKeyTargets(p)[m]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,m,y){return this.getStorage(m)?.get(p,y)}getBoolean(p,m,y){return this.getStorage(m)?.getBoolean(p,y)}getNumber(p,m,y){return this.getStorage(m)?.getNumber(p,y)}store(p,m,y,h){if((0,L.isUndefinedOrNull)(m)){this.remove(p,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,y,h),this.getStorage(y)?.set(p,m)})}remove(p,m){this.withPausedEmitters(()=>{this.updateKeyTarget(p,m,void 0),this.getStorage(m)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,m){const y=[],h=this.getKeyTargets(p);for(const o of Object.keys(h))h[o]===m&&y.push(o);return y}updateKeyTarget(p,m,y){const h=this.getKeyTargets(m);typeof y=="number"?h[p]!==y&&(h[p]=y,this.getStorage(m)?.set(c,JSON.stringify(h))):typeof h[p]=="number"&&(delete h[p],this.getStorage(m)?.set(c,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const m=this.get(c,p);if(m)try{return JSON.parse(m)}catch(y){}return Object.create(null)}isNew(p){return this.getBoolean(t.IS_NEW_KEY,p)===!0}async flush(p=d.NONE){this._onWillSaveState.fire({reason:p}),await T.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const p=this.getStorage(0)?.items??new Map,m=this.getStorage(1)?.items??new Map;return l(p,m,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends f{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}t.InMemoryStorageService=v;async function l(u,p,m,y){const h=a=>{try{return JSON.parse(a)}catch(E){return a}},o=new Map,r=new Map;u.forEach((a,E)=>{o.set(E,a),r.set(E,h(a))});const e=new Map,n=new Map;p.forEach((a,E)=>{e.set(E,a),n.set(E,h(a))}),console.group(`Storage: Global (path: ${m})`);let i=[];o.forEach((a,E)=>{i.push({key:E,value:a})}),console.table(i),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${y})`);let s=[];e.forEach((a,E)=>{s.push({key:E,value:a})}),console.table(s),console.groupEnd(),console.log(n)}t.logStorage=l}),define(te[117],ie([0,1,9,29,7,30]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function D(d){if(T.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function R(d,g,I,f,v,l,u,p,m,y){const h=Object.create(null);h["common.machineId"]=u,h.sessionID=(0,L.generateUuid)()+Date.now(),h.commitHash=v,h.version=l,h["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,T.PlatformToString)(T.platform),h["common.nodePlatform"]=P.platform,h["common.nodeArch"]=f,h["common.product"]=y||"desktop";const o=c(p||[]);o&&(h["common.msftInternal"]=o);let r=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),T.isLinuxSnap&&(h["common.snap"]="true");const n=D(I);n&&(h["common.platformDetail"]=n);try{const i=await d.readFile(S.URI.file(m));h["common.source"]=i.value.toString().slice(0,30)}catch(i){}return h}t.resolveCommonProperties=R;function c(d){const g=P.env.USERDNSDOMAIN;if(!g)return!1;const I=g.toLowerCase();return d.some(f=>I===f)}t.verifyMicrosoftInternalDomain=c}),define(te[36],ie([0,1,15]),function($,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,T.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(te[118],ie([0,1,22,3,25,11,13,2,9,7,75,23,24,14,35,36]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let p=class extends R.Disposable{constructor(r,e,n){super();this.galleryService=r,this.telemetryService=e,this.logService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(r,e={}){if(!this.galleryService.isEnabled())throw new Error(g.localize(0,null));try{r=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion)}catch(i){throw this.logService.error((0,L.getErrorMessage)(i)),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(r),void 0,i),i}if(!await this.canInstall(r)){const i=new I.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",r.identifier.id,i.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(r),void 0,i),i}const n=await this.galleryService.getManifest(r,S.CancellationToken.None);if(n===null){const i=new I.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",r.identifier.id,i.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(r),void 0,i),i}if(n.version!==r.version){const i=new I.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(i.message),y(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(r),void 0,i),i}return this.installExtension(n,r,e)}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(1,null));const e=await this.findGalleryExtension(r);if(!e)throw new Error(g.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,n){if(!d.URI.isUri(e)){let b=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(b)return this.logService.info("Extensions is already requested to install",e.identifier.id),b.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],s=[],a=this.createInstallExtensionTask(r,e,n);d.URI.isUri(e)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(a.identifier,r.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),i.push({task:a,manifest:r});let E=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const A=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:w,manifest:C}of A)if(E=E||!!C.extensionDependencies?.some(U=>(0,f.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(w.identifier,w.version).key()))this.logService.info("Extension is already requested to install",w.identifier.id);else{const U=this.createInstallExtensionTask(C,w,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(U.identifier,C.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:w}),this.logService.info("Installing extension:",U.identifier.id),i.push({task:U,manifest:C})}}catch(A){if(d.URI.isUri(a.source))(0,T.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,A.message),(0,T.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,A.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(A),A}const b=i.reduce((A,{task:w,manifest:C})=>(A.set(w.identifier.id.toLowerCase(),{task:w,manifest:C}),A),new Map);for(;b.size;){let A;const w=[...b.values()].filter(({manifest:C})=>!C.extensionDependencies?.some(U=>b.has(U.toLowerCase())));w.length?A=b.size===1?w:w.filter(({task:C})=>!(C===a&&!E)):(this.logService.info("Found extensions with circular dependencies",w.map(({task:C})=>C.identifier.id)),A=[...b.values()]),await this.joinAllSettled(A.map(async({task:C})=>{const U=new Date().getTime();try{const V=await C.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(V,C.source,n,S.CancellationToken.None))),!d.URI.isUri(C.source)&&(y(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-U,void 0),c.isWeb&&C.operation===1))try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch(J){}s.push({local:V,identifier:C.identifier,operation:C.operation,source:C.source})}catch(V){throw d.URI.isUri(C.source)||y(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-U,V),this.logService.error("Error while installing the extension:",C.identifier.id),this.logService.error(V),V}finally{b.delete(C.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:A})=>this.logService.info("Extension installed successfully:",A.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:A})=>(0,f.areSameExtensions)(A,a.identifier))[0].local}catch(b){if(i.forEach(({task:A})=>A.cancel()),s.length)try{const A=await Promise.allSettled(s.map(({local:w})=>this.createUninstallExtensionTask(w,{versionOnly:!0}).run()));for(let w=0;w<A.length;w++){const C=A[w],{identifier:U}=s[w];C.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,L.getErrorMessage)(C.reason))}}catch(A){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(A),s.map(({identifier:w})=>w.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,L.getErrorMessage)(b)),this._onDidInstallExtensions.fire(i.map(({task:A})=>({identifier:A.identifier,operation:1,source:A.source}))),b instanceof Error&&(b.name=b&&b.code?b.code:t.ERROR_UNKNOWN),b}finally{for(const{task:b,manifest:A}of i)if(!d.URI.isUri(b.source)){const w=new f.ExtensionIdentifierWithVersion(b.identifier,A.version).key();this.installingExtensions.delete(w)||this.logService.warn("Installation task is not found in the cache",w)}}}async joinAllSettled(r){const e=[],n=[],i=await Promise.allSettled(r);for(const s of i)s.status==="fulfilled"?e.push(s.value):n.push(s.reason);if(n.length)throw m(n);return e}async getAllDepsAndPackExtensionsToInstall(r,e,n){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const s=[r,...i.map(b=>b.identifier)],a=[],E=async(b,A)=>{const w=A.extensionDependencies||[],C=[...w];if(A.extensionPack){const U=n?i.find(V=>(0,f.areSameExtensions)(V.identifier,b)):void 0;for(const V of A.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(J=>(0,f.areSameExtensions)({id:J},{id:V}))||C.every(J=>!(0,f.areSameExtensions)({id:J},{id:V}))&&C.push(V)}if(C.length){const U=[...s,...a.map(J=>J.gallery.identifier)],V=C.filter(J=>U.every(ne=>!(0,f.areSameExtensions)(ne,{id:J})));if(V.length){const J=await this.galleryService.query({names:V,pageSize:C.length},S.CancellationToken.None);for(const ne of J.firstPage){if(U.find(Y=>(0,f.areSameExtensions)(Y,ne.identifier)))continue;if(!w.some(Y=>(0,f.areSameExtensions)({id:Y},ne.identifier))&&!await this.canInstall(ne)){this.logService.info("Skipping the packed extension as it cannot be installed",ne.identifier.id);continue}const ee=await this.checkAndGetCompatibleVersion(ne,!0),G=await this.galleryService.getManifest(ee,S.CancellationToken.None);if(G===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${ee.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:ee,manifest:G}),await E(ee.identifier,G)}}}};return await E(r,e),i=await this.getInstalled(),a.filter(b=>!i.some(A=>(0,f.areSameExtensions)(A.identifier,b.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e){if(await this.isMalicious(r))throw new I.ExtensionManagementError(g.localize(3,null,r.identifier.id),I.INSTALL_ERROR_MALICIOUS);let n=null;if(await this.galleryService.isExtensionCompatible(r,I.CURRENT_TARGET_PLATFORM)&&(n=r),!n&&e&&(n=await this.galleryService.getCompatibleExtension(r,I.CURRENT_TARGET_PLATFORM)),!n)throw new I.ExtensionManagementError(g.localize(4,null,r.identifier.id,l.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return n}async isMalicious(r){const e=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(e).has(r.identifier.id)}async unininstallExtension(r,e){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const i=(b,A)=>{const w=this.createUninstallExtensionTask(b,A);return this.uninstallingExtensions.set(w.extension.identifier.id.toLowerCase(),w),this.logService.info("Uninstalling extension:",b.identifier.id),this._onUninstallExtension.fire(b.identifier),w},s=(b,A)=>{A?this.logService.error("Failed to uninstall extension:",b.identifier.id,A.message):this.logService.info("Successfully uninstalled extension:",b.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(b),void 0,A),this._onDidUninstallExtension.fire({identifier:b.identifier,error:A?.code})},a=[],E=[];try{a.push(i(r,{}));const b=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const A=this.getAllPackExtensionsToUninstall(r,b);for(const w of A)this.uninstallingExtensions.has(w.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",w.identifier.id):a.push(i(w,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(a.map(A=>A.extension),b,r),await this.joinAllSettled(a.map(async A=>{try{if(await A.run(),await this.joinAllSettled(this.participants.map(w=>w.postUninstall(A.extension,e,S.CancellationToken.None))),A.extension.identifier.uuid)try{await this.galleryService.reportStatistic(A.extension.manifest.publisher,A.extension.manifest.name,A.extension.manifest.version,"uninstall")}catch(w){}s(A.extension)}catch(w){const C=w instanceof I.ExtensionManagementError?w:new I.ExtensionManagementError((0,L.getErrorMessage)(w),t.ERROR_UNKNOWN);throw s(A.extension,C),C}finally{E.push(A)}}))}catch(b){const A=b instanceof I.ExtensionManagementError?b:new I.ExtensionManagementError((0,L.getErrorMessage)(b),t.ERROR_UNKNOWN);for(const w of a){try{w.cancel()}catch(C){}E.includes(w)||s(w.extension,A)}throw A}finally{for(const b of a)this.uninstallingExtensions.delete(b.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",b.extension.identifier.id)}}checkForDependents(r,e,n){for(const i of r){const s=this.getDependents(i,e);if(s.length){const a=s.filter(E=>!r.some(b=>(0,f.areSameExtensions)(b.identifier,E.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(i,a,n))}}}getDependentsErrorMessage(r,e,n){return n===r?e.length===1?g.localize(5,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?g.localize(6,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):g.localize(7,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?g.localize(8,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?g.localize(9,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):g.localize(10,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const i=r.manifest.extensionPack?r.manifest.extensionPack:[];if(i.length){const s=e.filter(E=>!E.isBuiltin&&i.some(b=>(0,f.areSameExtensions)({id:b},E.identifier))),a=[];for(const E of s)a.push(...this.getAllPackExtensionsToUninstall(E,e,n));return[...s,...a]}return[]}getDependents(r,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(i=>(0,f.areSameExtensions)({id:i},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const e=await this.findGalleryExtensionById(r.identifier.uuid);return e||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};p=fe([ae(0,I.IExtensionGalleryService),ae(1,u.ITelemetryService),ae(2,v.ILogService)],p),t.AbstractExtensionManagementService=p;function m(o){const r=Array.isArray(o)?o:[o];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}t.joinErrors=m;function y(o,r,e,n,i){const s=i?i instanceof I.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(r,{...e,success:!i,duration:n,errorcode:s})}t.reportTelemetry=y;class h{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(r=>new Promise((e,n)=>{const i=r.onCancellationRequested(()=>{i.dispose(),n((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(te[119],ie([0,1,2,18,21,86,27,31,35,26]),function($,t,T,P,S,L,D,R,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let g=class{constructor(v,l){this._configurationService=l,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appender=v.appender,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,S.escapeRegExpCharacters)(u),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(u=>{const p=/^[a-f0-9]+$/i.test(u["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})})}setExperimentProperty(v,l){this._experimentProperties[v]=l}setEnabled(v){this._enabled=v}_updateUserOptIn(){const v=this._configurationService?.getValue(I);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const v=await this._commonProperties;let l=v.sessionID,u=v["common.instanceId"],p=v["common.machineId"],m=v["common.firstSessionDate"],y=v["common.msftInternal"];return{sessionId:l,instanceId:u,machineId:p,firstSessionDate:m,msftInternal:y}}dispose(){this._disposables.dispose()}publicLog(v,l,u){return this.isOptedIn?this._commonProperties.then(p=>{l=(0,P.mixin)(l,p),l=(0,P.mixin)(l,this._experimentProperties),l=(0,P.cloneAndChange)(l,m=>{if(typeof m=="string")return this._cleanupInfo(m,u)}),this._appender.log(v,l)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(v,l,u){return this.publicLog(v,l,u)}publicLogError(v,l){return this.sendErrorTelemetry?this.publicLog(v,l,!0):Promise.resolve(void 0)}publicLogError2(v,l){return this.publicLogError(v,l)}_cleanupInfo(v,l){let u=v;if(l){const p=[];for(let o of this._cleanupPatterns)for(;;){const r=o.exec(v);if(!r)break;p.push([r.index,o.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(u="";;){const o=y.exec(v);if(!o)break;!m.test(o[0])&&p.every(([r,e])=>o.index<r||o.index>=e)&&(u+=v.substring(h,o.index)+"<REDACTED: user-file-path>",h=y.lastIndex)}h<v.length&&(u+=v.substr(h))}for(let p of this._cleanupPatterns)u=u.replace(p,"");return u}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=fe([ae(1,D.IConfigurationService)],g),t.TelemetryService=g;const I="telemetry";d.Registry.as(R.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,L.localize)(2,null,c.default.nameLong,c.default.privacyStatementUrl):(0,L.localize)(1,null,c.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[44],ie([0,1,3,18,12,27]),function($,t,T,P,S,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.TelemetryLevel=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(p,m){return Promise.resolve(void 0)}publicLog2(p,m){return this.publicLog(p,m)}publicLogError(p,m){return Promise.resolve(void 0)}publicLogError2(p,m){return this.publicLogError(p,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class D{async publicLog(m,y,h){}async publicLogError(m,y,h){}}t.NullEndpointTelemetryService=D;function R(...p){return{log:(m,y)=>p.forEach(h=>h.log(m,y)),flush:()=>T.Promises.settled(p.map(m=>m.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(p,m){return m.onDidChangeConfiguration(y=>{y.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(y.source),configurationKeys:l(y.sourceConfig)})})}t.configurationTelemetry=c;var d;(function(p){p[p.NONE=0]="NONE",p[p.LOG=1]="LOG",p[p.USER=2]="USER"})(d=t.TelemetryLevel||(t.TelemetryLevel={}));function g(p,m){return m.disableTelemetry||!p.enableTelemetry?0:m.isBuilt?2:1}t.getTelemetryLevel=g;function I(p){const m=Object.create(null),y=Object.create(null),h=Object.create(null);v(p,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const r=h[o];typeof r=="number"?y[o]=r:typeof r=="boolean"?y[o]=r?1:0:typeof r=="string"?m[o]=r.substring(0,1023):typeof r!="undefined"&&r!==null&&(m[o]=r)}return{properties:m,measurements:y}}t.validateTelemetryData=I;function f(p){if(!p)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{p.indexOf(`${h}+`)===0&&(m=h)}),m}t.cleanRemoteAuthority=f;function v(p,m,y=0,h){if(!!p)for(let o of Object.getOwnPropertyNames(p)){const r=p[o],e=h?h+o:o;Array.isArray(r)?m[e]=(0,P.safeStringify)(r):r instanceof Date?m[e]=r.toISOString():(0,S.isObject)(r)?y<2?v(r,m,y+1,e+"."):m[e]=(0,P.safeStringify)(r):m[e]=r}}function l(p){if(!p)return[];const m=[];return u(m,"",p),m}function u(p,m,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(h=>u(p,m?`${m}.${h}`:h,y[h])):p.push(m)}}),define(te[120],ie([0,1,22,25,11,18,9,7,27,20,23,24,51,16,14,42,43,115,116,36,44]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v,l,u,p,m,y,h,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=void 0;var r;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(r||(r={}));function e(...k){return String(k.reduce((F,N)=>F|N,0))}var n;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class b{constructor(F=E){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,N=this.state.pageSize){return new b({...this.state,pageNumber:F,pageSize:N})}withFilter(F,...N){const M=[...this.state.criteria,...N.length?N.map(B=>({filterType:F,value:B})):[{filterType:F}]];return new b({...this.state,criteria:M})}withSortBy(F){return new b({...this.state,sortBy:F})}withSortOrder(F){return new b({...this.state,sortOrder:F})}withFlags(...F){return new b({...this.state,flags:F.reduce((N,M)=>N|M,0)})}withAssetTypes(...F){return new b({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:N,pageSize:M,sortBy:B,sortOrder:K,flags:Q,assetTypes:X}=this.state;return{filters:[{criteria:F,pageNumber:N,pageSize:M,sortBy:B,sortOrder:K}],assetTypes:X,flags:Q}}get searchText(){const F=this.state.criteria.filter(N=>N.filterType===n.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(k,F){const N=(k||[]).filter(M=>M.statisticName===F)[0];return N?N.value:0}function w(k){const F="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(M=>M.assetType.indexOf(F)===0).reduce((M,B)=>{const K=J(k,B.assetType);return K&&M.push([B.assetType.substring(F.length),K]),M},[])}function C(k){if(k.properties){const F=k.properties.filter(B=>B.key===i.Repository),N=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=F.filter(B=>N.test(B.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return J(k,i.Repository)}function U(k){return{uri:`${k.fallbackAssetUri}/${i.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${i.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function V(k){const F=J(k,i.Icon);if(F)return F;const N=g.DefaultIconPath;return{uri:N,fallbackUri:N}}function J(k,F){return k.files.filter(M=>M.assetType===F)[0]?{uri:`${k.assetUri}/${F}`,fallbackUri:`${k.fallbackAssetUri}/${F}`}:null}function ne(k,F){const N=k.properties?k.properties.filter(B=>B.key===F):[],M=N.length>0&&N[0].value;return M?M.split(",").map(B=>(0,I.adoptToGalleryExtensionId)(B)):[]}function se(k){const F=k.properties?k.properties.filter(N=>N.key===s.Engine):[];return F.length>0&&F[0].value||""}function ee(k){const F=k.properties?k.properties.filter(M=>M.key===s.LocalizedLanguages):[],N=F.length>0&&F[0].value||"";return N?N.split(","):[]}function G(k){return k.indexOf("preview")!==-1}function Y(k){return k.targetPlatform?(0,g.toTargetPlatform)(k.targetPlatform):"undefined"}function Z(k){const F=(0,T.distinct)(k.versions.map(Y)),N=!!k.tags?.includes(g.WEB_EXTENSION_TAG),M=F.indexOf("web");return N?M===-1&&F.push("web"):M!==-1&&F.splice(M,1),F}function re(k,F,N,M){const B=Z(k);let K=k.versions[0];return K=k.versions.find(Q=>Q.version===K.version&&(0,g.isTargetPlatformCompatible)(Y(Q),B,g.CURRENT_TARGET_PLATFORM))||K,j(k,K,B,F,N,M)}function j(k,F,N,M,B,K){const Q={manifest:J(F,i.Manifest),readme:J(F,i.Details),changelog:J(F,i.Changelog),license:J(F,i.License),repository:C(F),download:U(F),icon:V(F),coreTranslations:w(F)};return{identifier:{id:(0,I.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:F.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:A(k.statistics,"install"),rating:A(k.statistics,"averagerating"),ratingCount:A(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:N,assets:Q,properties:{dependencies:ne(F,s.Dependency),extensionPack:ne(F,s.ExtensionPack),engine:se(F),localizedLanguages:ee(F),targetPlatform:Y(F)},preview:G(k.flags),telemetryData:{index:(B.pageNumber-1)*B.pageSize+M,querySource:K}}}let O=class{constructor(F,N,M,B,K,Q,X,le){this.requestService=N,this.logService=M,this.environmentService=B,this.telemetryService=K,this.fileService=Q,this.productService=X,this.configurationService=le;const de=X.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=H(X.version,X,this.environmentService,this.configurationService,this.fileService,F)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,N){const M=[];let B=new b().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,F.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...F.map(({id:Q})=>Q.toLowerCase()));F.every(Q=>!Q.version)&&(B=B.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:K}=await this.queryGallery(B,P.CancellationToken.None);for(let Q=0;Q<K.length;Q++){const X=K[Q];if(!X.versions.length)continue;const le=(0,I.getGalleryExtensionId)(X.publisher.publisherName,X.extensionName),de=F.find(ce=>(0,I.areSameExtensions)(ce,{id:le}))?.version;if(de){const ce=X.versions.find(Ee=>Ee.version===de);ce&&M.push(j(X,ce,Z(X),Q,B))}else M.push(re(X,Q,B))}return M}async getCompatibleExtension(F,N){const M=(0,g.isIExtensionIdentifier)(F)?null:F;if(M){if((0,g.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,N))return null;if(await this.isExtensionCompatible(M,N))return M}const{id:B,uuid:K}=M?M.identifier:F;let Q=new b().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");K?Q=Q.withFilter(n.ExtensionId,K):Q=Q.withFilter(n.ExtensionName,B);const{galleryExtensions:X}=await this.queryGallery(Q,P.CancellationToken.None),[le]=X;if(!le||!le.versions.length)return null;const de=Z(le);if((0,g.isNotWebExtensionInWebTargetPlatform)(de,N))return null;for(let ce of le.versions){if(!se(ce)){const Ee=await this.getEngine(ce);ce={...ce,properties:[...ce.properties||[],{key:s.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(ce,de,N))return j(le,ce,de,0,Q)}return null}async isExtensionCompatible(F,N){if(!(0,g.isTargetPlatformCompatible)(F.properties.targetPlatform,F.allTargetPlatforms,N))return!1;let M=F.properties.engine;if(!M){const B=await this.getManifest(F,P.CancellationToken.None);if(!B)throw new Error("Manifest was not found");M=B.engines.vscode}return(0,f.isEngineValid)(M,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(F,N,M){if(!(0,g.isTargetPlatformCompatible)(Y(F),N,M))return!1;const B=await this.getEngine(F);return(0,f.isEngineValid)(B,this.productService.version,this.productService.date)}async query(F,N){const M=P.CancellationToken.isCancellationToken(F)?{}:F,B=P.CancellationToken.isCancellationToken(F)?F:N;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let K=M.text||"";const Q=(0,L.getOrDefault)(M,we=>we.pageSize,50);let X=new b().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,Q).withFilter(n.Target,"Microsoft.VisualStudio.Code");K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,pe,Re)=>(X=X.withFilter(n.Category,Re||pe),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,pe,Re)=>(X=X.withFilter(n.Tag,Re||pe),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(n.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),X=X.withFilter(n.SearchText,K)),X=X.withSortBy(0)):M.ids?X=X.withFilter(n.ExtensionId,...M.ids):M.names?X=X.withFilter(n.ExtensionName,...M.names):X=X.withSortBy(4),typeof M.sortBy=="number"&&(X=X.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(X=X.withSortOrder(M.sortOrder));const{galleryExtensions:le,total:de}=await this.queryGallery(X,B),ce=le.map((we,pe)=>re(we,pe,X,M.source)),Ee=async(we,pe)=>{if(pe.isCancellationRequested)throw(0,S.canceled)();const Re=X.withPage(we+1),{galleryExtensions:ve}=await this.queryGallery(Re,pe);return ve.map((be,ze)=>re(be,ze,Re,M.source))};return{firstPage:ce,total:de,pageSize:X.pageSize,getPage:Ee}}async queryGallery(F,N){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,r.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,e(r.Unpublished));const M=await this.commonHeadersPromise,B=JSON.stringify(F.raw),K={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},Q=new Date().getTime();let X,le,de=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:B,headers:K},N),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:de};const ce=await(0,p.asJson)(X);if(ce){const Ee=ce.results[0],we=Ee.extensions,pe=Ee.resultMetadata&&Ee.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return de=pe&&pe.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:de}}return{galleryExtensions:[],total:de}}catch(ce){throw le=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-Q,success:!!X&&(0,p.isSuccess)(X),responseBodySize:X?.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:le?(0,S.isPromiseCanceledError)(le)?"canceled":(0,S.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(F,N,M,B){if(!this.isEnabled())return;const K=D.isWeb?this.api(`/itemName/${F}.${N}/version/${M}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${N}/${M}/stats?statType=${B}`),Q=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.commonHeadersPromise,Accept:Q};try{await this.requestService.request({type:"POST",url:K,headers:le},P.CancellationToken.None)}catch(de){}}async download(F,N,M){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const B=(0,I.getGalleryExtensionTelemetryData)(F),K=new Date().getTime(),Q=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...B,duration:ce}),X=M===1?"install":M===2?"update":"",le=X?{uri:`${F.assets.download.uri}${R.URI.parse(F.assets.download.uri).query?"&":"?"}${X}=true`,fallbackUri:`${F.assets.download.fallbackUri}${R.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${X}=true`}:F.assets.download,de=await this.getAsset(le);await this.fileService.writeFile(N,de.stream),Q(new Date().getTime()-K)}async getReadme(F,N){if(F.assets.readme){const M=await this.getAsset(F.assets.readme,{},N);return await(0,p.asText)(M)||""}return""}async getManifest(F,N){if(F.assets.manifest){const M=await this.getAsset(F.assets.manifest,{},N),B=await(0,p.asText)(M);return B?JSON.parse(B):null}return null}async getManifestFromRawExtensionVersion(F,N){const M=J(F,i.Manifest);if(!M)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},K=await this.getAsset(M,{headers:B});return await(0,p.asJson)(K)}async getCoreTranslation(F,N){const M=F.assets.coreTranslations.filter(B=>B[0]===N.toUpperCase())[0];if(M){const B=await this.getAsset(M[1]),K=await(0,p.asText)(B);return K?JSON.parse(K):null}return null}async getChangelog(F,N){if(F.assets.changelog){const M=await this.getAsset(F.assets.changelog,{},N);return await(0,p.asText)(M)||""}return""}async getAllCompatibleVersions(F,N){let M=new b().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?M=M.withFilter(n.ExtensionId,F.identifier.uuid):M=M.withFilter(n.ExtensionName,F.identifier.id);const{galleryExtensions:B}=await this.queryGallery(M,P.CancellationToken.None);if(!B.length)return[];const K=Z(B[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(K,N))return[];const Q=[];for(const X of B[0].versions)try{await this.isRawExtensionVersionCompatible(X,K,N)&&Q.push({version:X.version,date:X.lastUpdated})}catch(le){}return Q}async getAsset(F,N={},M=P.CancellationToken.None){const B=await this.commonHeadersPromise,K={type:"GET"},Q={...B,...N.headers||{}};N={...N,...K,headers:Q};const X=F.uri,le=F.fallbackUri,de={...N,url:X};try{const ce=await this.requestService.request(de,M);if(ce.res.statusCode===200)return ce;const Ee=await(0,p.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${Ee}`)}catch(ce){if((0,S.isPromiseCanceledError)(ce))throw ce;const Ee=(0,S.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:Ee});const we={...N,url:le};return this.requestService.request(we,M)}}async getEngine(F){let N=se(F);if(!N){const M=await this.getManifestFromRawExtensionVersion(F,P.CancellationToken.None);if(!M)throw new Error("Manifest was not found");N=M.engines.vscode}return N}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const N=await(0,p.asJson)(F),M=new Map;if(N)for(const B of N.malicious){const K=M.get(B)||{id:{id:B},malicious:!0,slow:!1};K.malicious=!0,M.set(B,K)}return[...M.values()]}};O=fe([ae(1,p.IRequestService),ae(2,l.ILogService),ae(3,d.IEnvironmentService),ae(4,h.ITelemetryService),ae(5,v.IFileService),ae(6,u.IProductService),ae(7,c.IConfigurationService)],O);let z=class extends O{constructor(F,N,M,B,K,Q,X,le){super(F,N,M,B,K,Q,X,le)}};z=fe([ae(0,y.IStorageService),ae(1,p.IRequestService),ae(2,l.ILogService),ae(3,d.IEnvironmentService),ae(4,h.ITelemetryService),ae(5,v.IFileService),ae(6,u.IProductService),ae(7,c.IConfigurationService)],z),t.ExtensionGalleryService=z;let W=class extends O{constructor(F,N,M,B,K,Q,X){super(void 0,F,N,M,B,K,Q,X)}};W=fe([ae(0,p.IRequestService),ae(1,l.ILogService),ae(2,d.IEnvironmentService),ae(3,h.ITelemetryService),ae(4,v.IFileService),ae(5,u.IProductService),ae(6,c.IConfigurationService)],W),t.ExtensionGalleryServiceWithNoStorageService=W;async function H(k,F,N,M,B,K){const Q={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},X=await(0,m.getServiceMachineId)(N,B,K);return(0,o.getTelemetryLevel)(F,N)>=2&&M.getValue("telemetry.enableTelemetry")===!0&&(Q["X-Market-User-Id"]=X),Q}t.resolveMarketplaceHeaders=H}),define(te[121],ie([0,1,11,18,44]),function($,t,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function L(R){const c=await new Promise((g,I)=>{$(["applicationinsights"],g,I)});let d;return c.defaultClient?(d=new c.TelemetryClient(R),d.channel.setUseDiskRetryCaching(!0)):(c.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=c.defaultClient),R.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class D{constructor(c,d,g){this._eventPrefix=c,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof g=="function"?this._aiClient=g():this._aiClient=g,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient)),this._asyncAIClient.then(d=>{c(d)},d=>{(0,T.onUnexpectedError)(d),console.error(d)})}}log(c,d){!this._aiClient||(d=(0,P.mixin)(d,this._defaultData),d=(0,S.validateTelemetryData)(d),this._withAIClient(g=>g.trackEvent({name:this._eventPrefix+"/"+c,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=D}),define(te[122],ie([0,1,4,10]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(L,D){const R=Object.create(null),c=(g,I)=>{const f=JSON.parse(g);R[I]=f};if(D){const g=[],I=await P.Promises.readdir(D);for(const v of I)try{(await P.Promises.stat((0,T.join)(D,v))).isDirectory()&&g.push(v)}catch{}const f=[];for(const v of g)(await P.Promises.readdir((0,T.join)(D,v))).filter(u=>u==="telemetry.json").length===1&&f.push(v);for(const v of f){const l=(await P.Promises.readFile((0,T.join)(D,v,"telemetry.json"))).toString();c(l,v)}}let d=(await P.Promises.readFile((0,T.join)(L,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await P.Promises.readFile((0,T.join)(L,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(R,null,4)}t.buildTelemetryMessage=S}),define(te[45],ie([0,1,38,3,4,12,10,73,133,134]),function($,t,T,P,S,L,D,R,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class g extends Error{constructor(e,n){let i=n.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=n}}t.ExtractError=g;function I(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,i)=>n+i,e&61440)}function f(r){if(r instanceof g)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new g(e,r)}function v(r,e,n,i,s,a){const E=S.dirname(e),b=S.join(i,E);if(!b.startsWith(i))return Promise.reject(new Error(R.localize(0,null,e)));const A=S.join(i,e);let w;return a.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(D.Promises.mkdir(b,{recursive:!0})).then(()=>new Promise((C,U)=>{if(!a.isCancellationRequested)try{w=(0,T.createWriteStream)(A,{mode:n}),w.once("close",()=>C()),w.once("error",U),r.once("error",U),r.pipe(w)}catch(V){U(V)}}))}function l(r,e,n,i){let s=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{s.cancel(),r.close()}),new Promise((E,b)=>{const A=new P.Sequencer,w=C=>{C.isCancellationRequested||(a++,r.readEntry())};r.once("error",b),r.once("close",()=>s.then(()=>{i.isCancellationRequested||r.entryCount===a?E():b(new g("Incomplete",new Error(R.localize(1,null,a,r.entryCount))))},b)),r.readEntry(),r.on("entry",C=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(C.fileName)){w(i);return}const U=C.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(U)){const ne=S.join(e,U);s=(0,P.createCancelablePromise)(se=>D.Promises.mkdir(ne,{recursive:!0}).then(()=>w(se)).then(void 0,b));return}const V=p(r,C),J=I(C);s=(0,P.createCancelablePromise)(ne=>A.queue(()=>V.then(se=>v(se,U,J,e,n,ne).then(()=>w(ne)))).then(null,b))})})}function u(r,e=!1){return new Promise((n,i)=>{(0,c.open)(r,e?{lazyEntries:!0}:void 0,(s,a)=>{s?i(f(s)):n((0,L.assertIsDefined)(a))})})}function p(r,e){return new Promise((n,i)=>{r.openReadStream(e,(s,a)=>{s?i(f(s)):n((0,L.assertIsDefined)(a))})})}function m(r,e){return new Promise((n,i)=>{const s=new d.ZipFile;e.forEach(E=>{E.contents?s.addBuffer(typeof E.contents=="string"?Buffer.from(E.contents,"utf8"):E.contents,E.path):E.localPath&&s.addFile(E.localPath,E.path)}),s.end();const a=(0,T.createWriteStream)(r);s.outputStream.pipe(a),s.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>n(r))})}t.zip=m;function y(r,e,n={},i){const s=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=u(r,!0);return n.overwrite&&(a=a.then(E=>D.Promises.rm(e).then(()=>E))),a.then(E=>l(E,e,{sourcePathRegex:s},i))}t.extract=y;function h(r,e){return u(r).then(n=>new Promise((i,s)=>{n.on("entry",a=>{a.fileName===e&&p(n,a).then(E=>i(E),E=>s(E))}),n.once("close",()=>s(new Error(R.localize(2,null,e))))}))}function o(r,e){return h(r,e).then(n=>new Promise((i,s)=>{const a=[];n.once("error",s),n.on("data",E=>a.push(E)),n.on("end",()=>i(Buffer.concat(a)))}))}t.buffer=o}),define(te[123],ie([0,1,45,79]),function($,t,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(L){return(0,T.buffer)(L,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(R){throw new Error((0,P.localize)(0,null))}})}t.getManifest=S}),define(te[124],ie([0,1,22,3,11,2,8,4,9,19,41,7,30,10,45,80,20,23,24,91,16,14,42]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v,l,u,p,m,y,h,o,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",i="scanningUser",s="extracting",a="deleting",E="renaming";let b=class extends L.Disposable{constructor(w,C,U,V,J){super();this.beforeRemovingExtension=w,this.fileService=C,this.logService=U,this.environmentService=V,this.productService=J,this._devSystemExtensionsPath=null,this.systemExtensionsPath=V.builtinExtensionsPath,this.extensionsPath=V.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const C=[];(w===null||w===0)&&C.push(this.scanSystemExtensions().then(null,U=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(U).message,n)))),(w===null||w===1)&&C.push(this.scanUserExtensions(!0).then(null,U=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(U).message,i))));try{const U=await Promise.all(C);return(0,T.flatten)(U)}catch(U){throw this.joinErrors(U)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[C,U]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return U=U.filter(V=>!C[new y.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version).key()]),w&&(U=(0,y.groupByExtension)(U,J=>J.identifier).map(J=>J.sort((ne,se)=>g.rcompare(ne.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",U.length),U}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,C,U,V){const J=w.key(),ne=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),se=R.join(this.extensionsPath,J);try{await v.Promises.rm(se)}catch(G){try{await v.Promises.rm(se)}catch(Y){}throw new m.ExtensionManagementError((0,u.localize)(0,null,se,w.id),a)}await this.extractAtLocation(w,C,ne,V);let ee=await this.scanExtension(I.URI.file(ne),1);if(!ee)throw new Error((0,u.localize)(1,null,ne));await this.storeMetadata(ee,{...U,installedTimestamp:Date.now()});try{await this.rename(w,ne,se,Date.now()+2*60*1e3),this.logService.info("Renamed to",se)}catch(G){try{await v.Promises.rm(ne)}catch(Y){}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(G)}. Deleted from extracted location`,ne),G}try{ee=await this.scanExtension(I.URI.file(se),1)}catch(G){}if(ee)return ee;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,C){return this.setMetadata(w,C),await this.storeMetadata(w,{...C,installedTimestamp:w.installedTimestamp}),w}async storeMetadata(w,C){C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.installedTimestamp=C.installedTimestamp||void 0;const U=R.join(w.location.fsPath,"package.json"),V=await v.Promises.readFile(U,"utf8"),{manifest:J}=await this.parseManifest(V);return J.__metadata=C,await v.Promises.writeFile(U,JSON.stringify(J,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const C=w.map(U=>new y.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version));await this.withUninstalledExtensions(U=>{C.forEach(V=>U[V.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(V=>delete V[w.key()]);const U=(await this.scanExtensions(1)).find(V=>new y.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version).equals(w))||null;return U?(await this.storeMetadata(U,{installedTimestamp:Date.now()}),this.scanExtension(U.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(V){if(V.code!=="ENOENT")throw V}let U={};if(C)try{U=JSON.parse(C)}catch(V){}return w&&(w(U),Object.keys(U).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await v.Promises.rm(this.uninstalledPath)),U})}async removeExtension(w,C){this.logService.trace(`Deleting ${C} extension from disk`,w.identifier.id,w.location.fsPath),await v.Promises.rm(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new y.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,C,U,V){this.logService.trace(`Started extracting the extension from ${C} to ${U}`);try{await v.Promises.rm(U)}catch(J){throw new m.ExtensionManagementError(this.joinErrors(J).message,a)}try{await(0,l.extract)(C,U,{sourcePath:"extension",overwrite:!0},V),this.logService.info(`Extracted extension to ${U}:`,w.id)}catch(J){try{await v.Promises.rm(U)}catch(ne){}throw new m.ExtensionManagementError(J.message,J instanceof l.ExtractError&&J.type?J.type:s)}}async rename(w,C,U,V){try{await v.Promises.rename(C,U)}catch(J){if(c.isWindows&&J&&J.code==="EPERM"&&Date.now()<V)return this.logService.info(`Failed renaming ${C} to ${U} with 'EPERM' error. Trying again...`,w.id),this.rename(w,C,U,V);throw new m.ExtensionManagementError(J.message||(0,u.localize)(3,null,C,U),J.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const C=this.scanDevSystemExtensions(),[U,V]=await Promise.all([w,C]);return[...U,...V]}async scanExtensionsInDir(w,C){const U=new P.Limiter(10),V=await this.fileService.resolve(I.URI.file(w));return V.children?(await Promise.all(V.children.filter(ne=>ne.isDirectory).map(ne=>U.queue(async()=>C===1&&(0,d.basename)(ne.resource).indexOf(".")===0?null:this.scanExtension(ne.resource,C))))).filter(ne=>ne&&ne.identifier):[]}async scanExtension(w,C){try{const U=await this.fileService.resolve(w);if(U.children){const{manifest:V,metadata:J}=await this.readManifest(w.fsPath),ne=U.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,se=U.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource,ee={id:(0,y.getGalleryExtensionId)(V.publisher,V.name)},G={type:C,identifier:ee,manifest:V,location:w,readmeUrl:ne,changelogUrl:se,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:C===0};return J&&(this.setMetadata(G,J),G.installedTimestamp=J.installedTimestamp),G}}catch(U){C!==0&&this.logService.trace(U)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(U=>w.some(V=>(0,y.areSameExtensions)(U.identifier,{id:V})))}else return[]}setMetadata(w,C){w.publisherDisplayName=C.publisherDisplayName||null,w.publisherId=C.publisherId||null,w.identifier.uuid=C.id,w.isMachineScoped=!!C.isMachineScoped,w.isBuiltin=w.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),U=new Set;for(const ne of C)w[new y.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version).key()]||U.add(ne.identifier.id.toLowerCase());const V=(0,y.groupByExtension)(C,ne=>ne.identifier);await P.Promises.settled(V.map(async ne=>{const se=ne.sort((ee,G)=>g.rcompare(ee.manifest.version,G.manifest.version))[0];U.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const J=C.filter(ne=>w[new y.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version).key()]);await P.Promises.settled(J.map(ne=>this.removeUninstalledExtension(ne)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),C=[],U=(0,y.groupByExtension)(w,V=>V.identifier);C.push(...(0,T.flatten)(U.map(V=>V.sort((J,ne)=>g.rcompare(J.manifest.version,ne.manifest.version)).slice(1)))),await P.Promises.settled(C.map(V=>this.removeExtension(V,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const C=Array.isArray(w)?w:[w];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((U,V)=>new Error(`${U.message}${U.message?",":""}${V instanceof Error?V.message:V}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(D.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const C=[v.Promises.readFile(R.join(w,"package.json"),"utf8").then(ne=>this.parseManifest(ne)),v.Promises.readFile(R.join(w,"package.nls.json"),"utf8").then(void 0,ne=>ne.code!=="ENOENT"?Promise.reject(ne):"{}").then(ne=>JSON.parse(ne))],[{manifest:U,metadata:V},J]=await Promise.all(C);return{manifest:(0,h.localizeManifest)(U,J),metadata:V}}parseManifest(w){return new Promise((C,U)=>{try{const V=JSON.parse(w),J=V.__metadata||null;C({manifest:V,metadata:J})}catch(V){U(new Error((0,u.localize)(4,null)))}})}};b=fe([ae(1,o.IFileService),ae(2,r.ILogService),ae(3,p.INativeEnvironmentService),ae(4,e.IProductService)],b),t.ExtensionsScanner=b}),define(te[125],ie([0,1,28,8,4,9,19,41,7,30,10,45,78,53,20,118,23,24,102,103,123,98,124,104,51,16,15,14,35,36]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v,l,u,p,m,y,h,o,r,e,n,i,s,a,E,b,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const w="unsetUninstalled",C="downloading";let U=class extends u.AbstractExtensionManagementService{constructor(G,Y,Z,re,j,O,z){super(G,Y,Z);this.environmentService=re,this.downloadService=j;const W=this._register(O.createInstance(h.ExtensionsLifecycle));this.extensionsScanner=this._register(O.createInstance(e.ExtensionsScanner,k=>W.postUninstall(k))),this.manifestCache=this._register(new r.ExtensionsManifestCache(re,this)),this.extensionsDownloader=this._register(O.createInstance(y.ExtensionsDownloader));const H=this._register(new n.ExtensionsWatcher(this,z,re,Z));this._register(H.onDidChangeExtensionsByAnotherSource(({added:k,removed:F})=>{k.length&&this._onDidInstallExtensions.fire(k.map(N=>({identifier:N.identifier,operation:0,local:N}))),F.forEach(N=>this._onDidUninstallExtension.fire({identifier:N}))}))}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const Y=await this.collectFiles(G),Z=await(0,I.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)()).fsPath,Y);return c.URI.file(Z)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const Y=await this.downloadVsix(G),Z=S.resolve(Y.fsPath);return(0,o.getManifest)(Z)}getInstalled(G=null){return this.extensionsScanner.scanExtensions(G)}async canInstall(G){return!0}async install(G,Y={}){this.logService.trace("ExtensionManagementService#install",G.toString());const Z=await this.downloadVsix(G),re=await(0,o.getManifest)(S.resolve(Z.fsPath));if(re.engines&&re.engines.vscode&&!(0,i.isEngineValid)(re.engines.vscode,b.default.version,b.default.date))throw new Error(f.localize(0,null,(0,m.getGalleryExtensionId)(re.publisher,re.name),b.default.version));return this.installExtension(re,Z,Y)}async updateMetadata(G,Y){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},...Y}),this.manifestCache.invalidate(),G}async updateExtensionScope(G,Y){return this.logService.trace("ExtensionManagementService#updateExtensionScope",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},isMachineScoped:Y}),this.manifestCache.invalidate(),G}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(G){if(G.scheme===P.Schemas.file)return G;const Y=(0,D.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)());return await this.downloadService.download(G,Y),Y}createInstallExtensionTask(G,Y,Z){return c.URI.isUri(Y)?new ne(G,Y,Z,this.galleryService,this.extensionsScanner,this.logService):new J(Y,Z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(G,Y){return new se(G,Y,this.extensionsScanner)}async collectFiles(G){const Y=async re=>{let j=await g.Promises.readdir(re);j=j.map(W=>S.join(re,W));const O=await Promise.all(j.map(W=>g.Promises.stat(W)));let z=Promise.resolve([]);return O.forEach((W,H)=>{const k=j[H];W.isFile()&&(z=z.then(F=>[...F,k])),W.isDirectory()&&(z=z.then(F=>Y(k).then(N=>[...F,...N])))}),z};return(await Y(G.location.fsPath)).map(re=>({path:`extension/${S.relative(G.location.fsPath,re)}`,localPath:re}))}};U=fe([ae(0,p.IExtensionGalleryService),ae(1,A.ITelemetryService),ae(2,E.ILogService),ae(3,l.INativeEnvironmentService),ae(4,v.IDownloadService),ae(5,a.IInstantiationService),ae(6,s.IFileService)],U),t.ExtensionManagementService=U;class V extends u.AbstractExtensionTask{constructor(G,Y,Z,re){super();this.identifier=G,this.source=Y,this.extensionsScanner=Z,this.logService=re,this._operation=1}get operation(){return this._operation}async installExtension(G,Y){try{const Z=await this.unsetUninstalledAndGetLocal(G.identifierWithVersion);if(Z)return G.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Z,G.metadata):Z}catch(Z){throw L.isMacintosh?new p.ExtensionManagementError(f.localize(1,null),w):new p.ExtensionManagementError(f.localize(2,null),w)}return this.extract(G,Y)}async unsetUninstalledAndGetLocal(G){if(!await this.isUninstalled(G))return null;this.logService.trace("Removing the extension from uninstalled list:",G.id);const Z=await this.extensionsScanner.setInstalled(G);return this.logService.info("Removed the extension from uninstalled list:",G.id),Z}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.key()]}async extract({zipPath:G,identifierWithVersion:Y,metadata:Z},re){let j=await this.extensionsScanner.extractUserExtension(Y,G,Z,re);return this.logService.info("Extracting completed.",Y.id),j}}class J extends V{constructor(G,Y,Z,re,j){super(G.identifier,G,re,j);this.gallery=G,this.options=Y,this.extensionsDownloader=Z}async doRun(G){const Z=(await this.extensionsScanner.scanExtensions(null)).find(O=>(0,m.areSameExtensions)(O.identifier,this.gallery.identifier));Z&&(this._operation=2);const re=await this.downloadInstallableExtension(this.gallery,this._operation);re.metadata.isMachineScoped=this.options.isMachineScoped||Z?.isMachineScoped,re.metadata.isBuiltin=this.options.isBuiltin||Z?.isBuiltin;const j=await this.installExtension(re,G);Z&&R.neq(Z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Z);try{await this.extensionsDownloader.delete(c.URI.file(re.zipPath))}catch(O){}return j}async downloadInstallableExtension(G,Y){const Z={id:G.identifier.uuid,publisherId:G.publisherId,publisherDisplayName:G.publisherDisplayName};let re;try{this.logService.trace("Started downloading extension:",G.identifier.id),re=(await this.extensionsDownloader.downloadExtension(G,Y)).fsPath,this.logService.info("Downloaded extension:",G.identifier.id,re)}catch(j){throw new p.ExtensionManagementError((0,u.joinErrors)(j).message,C)}try{const j=await(0,o.getManifest)(re);return{zipPath:re,identifierWithVersion:new m.ExtensionIdentifierWithVersion(G.identifier,j.version),metadata:Z}}catch(j){throw new p.ExtensionManagementError((0,u.joinErrors)(j).message,u.INSTALL_ERROR_VALIDATING)}}}class ne extends V{constructor(G,Y,Z,re,j,O){super({id:(0,m.getGalleryExtensionId)(G.publisher,G.name)},Y,j,O);this.manifest=G,this.location=Y,this.options=Z,this.galleryService=re}async doRun(G){const Y=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),re=(await this.extensionsScanner.scanExtensions(1)).find(O=>(0,m.areSameExtensions)(this.identifier,O.identifier)),j=await this.getMetadata(this.identifier.id,G);if(j.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||re?.isBuiltin,re)if(this._operation=2,Y.equals(new m.ExtensionIdentifierWithVersion(re.identifier,re.manifest.version)))try{await this.extensionsScanner.removeExtension(re,"existing")}catch(O){throw new Error(f.localize(3,null,this.manifest.displayName||this.manifest.name))}else R.gt(re.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(re);else{const O=await this.unsetUninstalledAndGetLocal(Y);if(O)try{await this.extensionsScanner.removeExtension(O,"existing")}catch(z){throw new Error(f.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:S.resolve(this.location.fsPath),identifierWithVersion:Y,metadata:j},G)}async getMetadata(G,Y){try{const Z=(await this.galleryService.query({names:[G],pageSize:1},Y)).firstPage[0];if(Z)return{id:Z.identifier.uuid,publisherDisplayName:Z.publisherDisplayName,publisherId:Z.publisherId}}catch(Z){}return{}}}class se extends u.AbstractExtensionTask{constructor(G,Y,Z){super();this.extension=G,this.options=Y,this.extensionsScanner=Z}async doRun(G){const Y=[],Z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const re=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);Y.push(...Z.filter(j=>re.equals(new m.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else Y.push(...Z.filter(re=>(0,m.areSameExtensions)(re.identifier,this.extension.identifier)));if(!Y.length)throw new Error(f.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...Y),this.options.remove)for(const re of Y)try{G.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(re)}catch(j){throw new Error(f.localize(6,null,(0,T.toErrorMessage)(j)))}}}}),define(te[126],ie([0,1,114,17,11,2,12,27,20,99,14,113,135]),function($,t,T,P,S,L,D,R,c,d,g,I,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let v=class extends L.Disposable{constructor(u,p,m){super();this.environmentService=p,this.logService=m,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,p){this.logService.trace("RequestService#request",u.url);const{proxyUrl:m,strictSSL:y}=this,h={...process.env,...await(0,d.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=u.agent?u.agent:await(0,I.getProxyAgent)(u.url||"",h,{proxyUrl:m,strictSSL:y});return u.agent=o,u.strictSSL=y,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,p)}async getNodeRequest(u){return((0,T.parse)(u.url).protocol==="https:"?await new Promise((y,h)=>{$(["https"],y,h)}):await new Promise((y,h)=>{$(["http"],y,h)})).request}_request(u,p){return new Promise(async(m,y)=>{let h;const o=(0,T.parse)(u.url),r=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(e.auth=u.user+":"+u.password),h=r(e,n=>{const i=(0,D.isNumber)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...u,url:n.headers.location,followRedirects:i-1},p).then(m,y);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,f.createGunzip)())),m({res:n,stream:(0,P.streamToBufferReadableStream)(s)})}}),h.on("error",y),u.timeout&&h.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&h.write(u.data),h.end(),p.onCancellationRequested(()=>{h.abort(),y((0,S.canceled)())})})}async resolveProxy(u){}};v=fe([ae(0,R.IConfigurationService),ae(1,c.INativeEnvironmentService),ae(2,g.ILogService)],v),t.RequestService=v}),define(te[136],ie([0,1,38,137,33,3,17,28,11,2,8,4,29,7,10,27,111,53,112,20,90,120,23,97,125,16,107,108,52,101,55,56,105,14,106,35,42,43,126,117,36,119,44,121,122]),function($,t,T,P,S,L,D,R,c,d,g,I,f,v,l,u,p,m,y,h,o,r,e,n,i,s,a,E,b,A,w,C,U,V,J,ne,se,ee,G,Y,Z,re,j,O,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class W extends d.Disposable{constructor(F){super();this.argv=F,(0,P.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[F,N]=await this.initServices();return F.invokeFunction(async M=>{const B=M.get(V.ILogService),K=M.get(s.IFileService),Q=M.get(h.INativeEnvironmentService),X=M.get(e.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(Q,X,K),(0,L.raceTimeout)((0,j.combinedAppender)(...N).flush(),1e3)})}async initServices(){const F=new w.ServiceCollection,N={_serviceBrand:void 0,...ne.default};F.set(se.IProductService,N);const M=new o.NativeEnvironmentService(this.argv,N);F.set(h.INativeEnvironmentService,M),await Promise.all([M.appSettingsHome.fsPath,M.extensionsPath].map(Ee=>Ee?l.Promises.mkdir(Ee,{recursive:!0}):void 0));const B=(0,V.getLogLevel)(M),K=[];K.push(new J.SpdLogLogger("cli",(0,I.join)(M.logsPath,"cli.log"),!0,B)),B===V.LogLevel.Trace&&K.push(new V.ConsoleLogger(B));const Q=this._register(new V.MultiplexLogService(K));F.set(V.ILogService,Q);const X=this._register(new a.FileService(Q));F.set(s.IFileService,X);const le=this._register(new E.DiskFileSystemProvider(Q));X.registerProvider(g.Schemas.file,le);const de=this._register(new p.ConfigurationService(M.settingsResource,X));F.set(u.IConfigurationService,de),await de.initialize(),F.set(ee.IRequestService,new b.SyncDescriptor(G.RequestService)),F.set(m.IDownloadService,new b.SyncDescriptor(y.DownloadService)),F.set(e.IExtensionManagementService,new b.SyncDescriptor(i.ExtensionManagementService)),F.set(e.IExtensionGalleryService,new b.SyncDescriptor(r.ExtensionGalleryServiceWithNoStorageService)),F.set(e.IExtensionManagementCLIService,new b.SyncDescriptor(n.ExtensionManagementCLIService)),F.set(C.ILocalizationsService,new b.SyncDescriptor(U.LocalizationsService));const ce=[];if((0,j.getTelemetryLevel)(N,M)>=2){N.aiConfig&&N.aiConfig.asimovKey&&ce.push(new O.AppInsightsAppender("monacoworkbench",null,N.aiConfig.asimovKey));const{appRoot:Ee,extensionsPath:we,installSourcePath:pe}=M,Re={appender:(0,j.combinedAppender)(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let ve;try{const be=await l.Promises.readFile((0,I.join)(M.userDataPath,"storage.json"));ve=JSON.parse(be.toString())[Z.machineIdKey]}catch(be){be.code!=="ENOENT"&&Q.error(be)}return(0,Y.resolveCommonProperties)(X,(0,S.release)(),(0,S.hostname)(),process.arch,N.commit,N.version,ve,N.msftInternalDomains,pe)})(),piiPaths:[Ee,we]};F.set(Z.ITelemetryService,new b.SyncDescriptor(re.TelemetryService,[Re]))}else F.set(Z.ITelemetryService,j.NullTelemetryService);return[new A.InstantiationService(F),ce]}registerErrorHandler(F){(0,c.setUnexpectedErrorHandler)(N=>{const M=(0,R.toErrorMessage)(N,!0);!M||F.error(`[uncaught exception in CLI]: ${M}`)}),process.on("uncaughtException",N=>(0,c.onUnexpectedError)(N)),process.on("unhandledRejection",N=>(0,c.onUnexpectedError)(N))}async doRun(F,N,M){if(this.argv["install-source"])return this.setInstallSource(F,M,this.argv["install-source"]);if(this.argv["list-extensions"])return N.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return N.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return N.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return N.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,z.buildTelemetryMessage)(F.appRoot,F.extensionsPath))}asExtensionIdOrVSIX(F){return F.map(N=>/\.vsix$/i.test(N)?v.URI.file((0,I.isAbsolute)(N)?N:(0,I.join)((0,f.cwd)(),N)):N)}async setInstallSource(F,N,M){await N.writeFile(v.URI.file(F.installSourcePath),D.VSBuffer.fromString(M.slice(0,30)))}}async function H(k){const F=new W(k);try{await F.run()}finally{F.dispose()}}t.main=H})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/df115e761ae11cf87ca569ca1824b7257099553a/core/vs/code/node/cliProcessMain.js.map
