/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ie){for(var e=[],c=0,M=ie.length;c<M;c++)e[c]=be[ie[c]];return e};define(be[40],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(M,_){if(!M)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=c}),define(be[51],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function M(t){const y=[];for(let n in t)c.call(t,n)&&y.push(t[n]);return y}e.values=M;function _(t,y){for(let n in t)if(c.call(t,n)&&y({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=_;function A(t,y){const n=Object.create(null);for(const h of t){const s=y(h);let d=n[s];d||(d=n[s]=[]),d.push(h)}return n}e.groupBy=A;function R(t){const y=Object.create(null);return t&&t.forEach((n,h)=>{y[h]=n}),y}e.fromMap=R;function I(t,y){const n=[],h=[];for(let s of t)y.has(s)||n.push(s);for(let s of y)t.has(s)||h.push(s);return{removed:n,added:h}}e.diffSets=I;function D(t,y){const n=[],h=[];for(let[s,d]of t)y.has(s)||n.push(d);for(let[s,d]of y)t.has(s)||h.push(d);return{removed:n,added:h}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(y,n){let h=this.map.get(y);h||(h=new Set,this.map.set(y,h)),h.add(n)}delete(y,n){const h=this.map.get(y);!h||(h.delete(n),h.size===0&&this.map.delete(y))}forEach(y,n){const h=this.map.get(y);!h||h.forEach(n)}}e.SetMap=P}),define(be[52],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(R){return(I,D,P)=>{let t=null,y=null;if(typeof P.value=="function"?(t="value",y=P.value):typeof P.get=="function"&&(t="get",y=P.get),!y)throw new Error("not supported");P[t]=R(y,D)}}e.createDecorator=c;function M(R,I,D){let P=null,t=null;if(typeof D.value=="function"?(P="value",t=D.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",t=D.get),!t)throw new Error("not supported");const y=`$memoize$${I}`;D[P]=function(...n){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[y]}}e.memoize=M;function _(R,I,D){return c((P,t)=>{const y=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...h){this[n]||(this[n]=D?D():void 0),clearTimeout(this[y]),I&&(this[n]=I(this[n],...h),h=[this[n]]),this[y]=setTimeout(()=>{P.apply(this,h),this[n]=D?D():void 0},R)}})}e.debounce=_;function A(R,I,D){return c((P,t)=>{const y=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,h=`$throttle$lastRun$${t}`,s=`$throttle$pending$${t}`;return function(...d){if(this[n]||(this[n]=D?D():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),I&&(this[n]=I(this[n],...d)),this[s])return;const v=this[h]+R;v<=Date.now()?(this[h]=Date.now(),P.apply(this,[this[n]]),this[n]=D?D():void 0):(this[s]=!0,this[y]=setTimeout(()=>{this[s]=!1,this[h]=Date.now(),P.apply(this,[this[n]]),this[n]=D?D():void 0},v-Date.now()))}})}e.throttle=A}),define(be[13],Ee([0,1,16]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(q,le=0){return q[q.length-(1+le)]}e.tail=M;function _(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=_;function A(q,le,se=(ve,Fe)=>ve===Fe){if(q===le)return!0;if(!q||!le||q.length!==le.length)return!1;for(let ve=0,Fe=q.length;ve<Fe;ve++)if(!se(q[ve],le[ve]))return!1;return!0}e.equals=A;function R(q,le,se){let ve=0,Fe=q.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Ne=se(q[Me],le);if(Ne<0)ve=Me+1;else if(Ne>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=R;function I(q,le){let se=0,ve=q.length;if(ve===0)return 0;for(;se<ve;){const Fe=Math.floor((se+ve)/2);le(q[Fe])?ve=Fe:se=Fe+1}return se}e.findFirstInSorted=I;function D(q,le,se){if(q=q|0,q>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Ne=[];for(let Qe of le){const ze=se(Qe,ve);ze<0?Fe.push(Qe):ze>0?Me.push(Qe):Ne.push(Qe)}return q<Fe.length?D(q,Fe,se):q<Fe.length+Ne.length?Ne[0]:D(q-(Fe.length+Ne.length),Me,se)}e.quickSelect=D;function P(q,le){const se=[];let ve;for(const Fe of q.slice(0).sort(le))!ve||le(ve[0],Fe)!==0?(ve=[Fe],se.push(ve)):ve.push(Fe);return se}e.groupBy=P;function t(q,le,se){const ve=[];function Fe(Qe,ze,qe){if(ze===0&&qe.length===0)return;const x=ve[ve.length-1];x&&x.start+x.deleteCount===Qe?(x.deleteCount+=ze,x.toInsert.push(...qe)):ve.push({start:Qe,deleteCount:ze,toInsert:qe})}let Me=0,Ne=0;for(;;){if(Me===q.length){Fe(Me,0,le.slice(Ne));break}if(Ne===le.length){Fe(Me,q.length-Me,[]);break}const Qe=q[Me],ze=le[Ne],qe=se(Qe,ze);qe===0?(Me+=1,Ne+=1):qe<0?(Fe(Me,1,[]),Me+=1):qe>0&&(Fe(Me,0,[ze]),Ne+=1)}return ve}e.sortedDiff=t;function y(q,le,se){const ve=t(q,le,se),Fe=[],Me=[];for(const Ne of ve)Fe.push(...q.slice(Ne.start,Ne.start+Ne.deleteCount)),Me.push(...Ne.toInsert);return{removed:Fe,added:Me}}e.delta=y;function n(q,le,se){if(se===0)return[];const ve=q.slice(0,se).sort(le);return s(q,le,ve,se,q.length),ve}e.top=n;function h(q,le,se,ve,Fe){return se===0?Promise.resolve([]):new Promise((Me,Ne)=>{(async()=>{const Qe=q.length,ze=q.slice(0,se).sort(le);for(let qe=se,x=Math.min(se+ve,Qe);qe<Qe;qe=x,x=Math.min(x+ve,Qe)){if(qe>se&&await new Promise(Y=>setTimeout(Y)),Fe&&Fe.isCancellationRequested)throw(0,c.canceled)();s(q,le,ze,qe,x)}return ze})().then(Me,Ne)})}e.topAsync=h;function s(q,le,se,ve,Fe){for(const Me=se.length;ve<Fe;ve++){const Ne=q[ve];if(le(Ne,se[Me-1])<0){se.pop();const Qe=I(se,ze=>le(Ne,ze)<0);se.splice(Qe,0,Ne)}}}function d(q){return q.filter(le=>!!le)}e.coalesce=d;function v(q){let le=0;for(let se=0;se<q.length;se++)q[se]&&(q[le]=q[se],le+=1);q.length=le}e.coalesceInPlace=v;function k(q,le,se){q.splice(se,0,q.splice(le,1)[0])}e.move=k;function E(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=E;function o(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=o;function p(q,le){if(!le)return q.filter((ve,Fe)=>q.indexOf(ve)===Fe);const se=Object.create(null);return q.filter(ve=>{const Fe=le(ve);return se[Fe]?!1:(se[Fe]=!0,!0)})}e.distinct=p;function C(q){const le=new Set;return q.filter(se=>le.has(se)?!1:(le.add(se),!0))}e.distinctES6=C;function i(q){const le=Object.create(null);return se=>{const ve=q(se);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=i;function l(q,le){for(let se=q.length-1;se>=0;se--){const ve=q[se];if(le(ve))return se}return-1}e.lastIndex=l;function r(q,le){return q.length>0?q[0]:le}e.firstOrDefault=r;function a(q,le,se=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(q.length,le.length);Fe<Me&&se(q[Fe],le[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=a;function w(q){return[].concat(...q)}e.flatten=w;function f(q,le){let se=typeof le=="number"?q:0;typeof le=="number"?se=q:(se=0,le=q);const ve=[];if(se<=le)for(let Fe=se;Fe<le;Fe++)ve.push(Fe);else for(let Fe=se;Fe>le;Fe--)ve.push(Fe);return ve}e.range=f;function m(q,le,se){return q.reduce((ve,Fe)=>(ve[le(Fe)]=se?se(Fe):Fe,ve),Object.create(null))}e.index=m;function S(q,le){return q.push(le),()=>T(q,le)}e.insert=S;function T(q,le){const se=q.indexOf(le);if(se>-1)return q.splice(se,1),le}e.remove=T;function g(q,le,se){const ve=q.slice(0,le),Fe=q.slice(le);return ve.concat(se,Fe)}e.arrayInsert=g;function b(q,le){let se;if(typeof le=="number"){let ve=le;se=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else se=Math.random;for(let ve=q.length-1;ve>0;ve-=1){const Fe=Math.floor(se()*(ve+1)),Me=q[ve];q[ve]=q[Fe],q[Fe]=Me}}e.shuffle=b;function u(q,le){const se=q.indexOf(le);se>-1&&(q.splice(se,1),q.unshift(le))}e.pushToStart=u;function F(q,le){const se=q.indexOf(le);se>-1&&(q.splice(se,1),q.push(le))}e.pushToEnd=F;function O(q,le){return Array.isArray(q)?q.map(le):le(q)}e.mapArrayOrNot=O;function j(q){return Array.isArray(q)?q:[q]}e.asArray=j;function Q(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=Q;function W(q,le){for(const se of q){const ve=le(se);if(ve!==void 0)return ve}}e.mapFind=W;function K(q,le,se){const ve=U(q,le),Fe=q.length,Me=se.length;q.length=Fe+Me;for(let Ne=Fe-1;Ne>=ve;Ne--)q[Ne+Me]=q[Ne];for(let Ne=0;Ne<Me;Ne++)q[Ne+ve]=se[Ne]}e.insertInto=K;function $(q,le,se,ve){const Fe=U(q,le),Me=q.splice(Fe,se);return K(q,Fe,ve),Me}e.splice=$;function U(q,le){return le<0?Math.max(le+q.length,0):Math.min(le,q.length)}function H(q,le){let se=Number.MAX_SAFE_INTEGER,ve=0;return q.forEach((Fe,Me)=>{const Ne=le(Fe);Ne<se&&(se=Ne,ve=Me)}),ve}e.minIndex=H;function G(q,le){let se=Number.MIN_SAFE_INTEGER,ve=0;return q.forEach((Fe,Me)=>{const Ne=le(Fe);Ne>se&&(se=Ne,ve=Me)}),ve}e.maxIndex=G;class ue{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let se=this.firstIdx;for(;se<this.items.length&&le(this.items[se]);)se++;const ve=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ve}takeFromEndWhile(le){let se=this.lastIdx;for(;se>=0&&le(this.items[se]);)se--;const ve=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ve}}e.ArrayQueue=ue}),define(be[53],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(be[102],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(i,l=!1){let r=0,a=i.length,w="",f=0,m=16,S=0;function T(Q){let W=0,K=0;for(;W<Q;){const $=i.charCodeAt(r);if($>=48&&$<=57)K=K*16+$-48;else if($>=65&&$<=70)K=K*16+$-65+10;else if($>=97&&$<=102)K=K*16+$-97+10;else break;r++,W++}return W<Q&&(K=-1),K}function g(Q){r=Q,w="",f=0,m=16,S=0}function b(){const Q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&P(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&P(i.charCodeAt(r)))for(r++;r<i.length&&P(i.charCodeAt(r));)r++;else return S=3,i.substring(Q,r);let W=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&P(i.charCodeAt(r))){for(r++;r<i.length&&P(i.charCodeAt(r));)r++;W=r}else S=3;return i.substring(Q,W)}function u(){let Q="",W=r;for(;;){if(r>=a){Q+=i.substring(W,r),S=2;break}const K=i.charCodeAt(r);if(K===34){Q+=i.substring(W,r),r++;break}if(K===92){if(Q+=i.substring(W,r),r++,r>=a){S=2;break}switch(i.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const U=T(4);U>=0?Q+=String.fromCharCode(U):S=4;break;default:S=5}W=r;continue}if(K>=0&&K<=31)if(D(K)){Q+=i.substring(W,r),S=2;break}else S=6;r++}return Q}function F(){if(w="",S=0,f=r,r>=a)return f=a,m=17;let Q=i.charCodeAt(r);if(I(Q)){do r++,w+=String.fromCharCode(Q),Q=i.charCodeAt(r);while(I(Q));return m=15}if(D(Q))return r++,w+=String.fromCharCode(Q),Q===13&&i.charCodeAt(r)===10&&(r++,w+=`
`),m=14;switch(Q){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,w=u(),m=10;case 47:const W=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<a&&!D(i.charCodeAt(r));)r++;return w=i.substring(W,r),m=12}if(i.charCodeAt(r+1)===42){r+=2;const K=a-1;let $=!1;for(;r<K;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,S=1),w=i.substring(W,r),m=13}return w+=String.fromCharCode(Q),r++,m=16;case 45:if(w+=String.fromCharCode(Q),r++,r===a||!P(i.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=b(),m=11;default:for(;r<a&&O(Q);)r++,Q=i.charCodeAt(r);if(f!==r){switch(w=i.substring(f,r),w){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return w+=String.fromCharCode(Q),r++,m=16}}function O(Q){if(I(Q)||D(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let Q;do Q=F();while(Q>=12&&Q<=15);return Q}return{setPosition:g,getPosition:()=>r,scan:l?j:F,getToken:()=>m,getTokenValue:()=>w,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>S}}e.createScanner=R;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function D(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function y(i,l){const r=[],a=new Object;let w;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function S(T,g,b,u){f.value=T,f.offset=g,f.length=b,f.type=u,f.colonOffset=void 0,w=f}try{o(i,{onObjectBegin:(T,g)=>{if(l<=T)throw a;w=void 0,m=l>T,r.push("")},onObjectProperty:(T,g,b)=>{if(l<g||(S(T,g,b,"property"),r[r.length-1]=T,l<=g+b))throw a},onObjectEnd:(T,g)=>{if(l<=T)throw a;w=void 0,r.pop()},onArrayBegin:(T,g)=>{if(l<=T)throw a;w=void 0,r.push(0)},onArrayEnd:(T,g)=>{if(l<=T)throw a;w=void 0,r.pop()},onLiteralValue:(T,g,b)=>{if(l<g||(S(T,g,b,C(T)),l<=g+b))throw a},onSeparator:(T,g,b)=>{if(l<=g)throw a;if(T===":"&&w&&w.type==="property")w.colonOffset=g,m=!1,w=void 0;else if(T===","){const u=r[r.length-1];typeof u=="number"?r[r.length-1]=u+1:(m=!0,r[r.length-1]=""),w=void 0}}})}catch(T){if(T!==a)throw T}return{path:r,previousNode:w,isAtPropertyKey:m,matches:T=>{let g=0;for(let b=0;g<T.length&&b<r.length;b++)if(T[g]===r[b]||T[g]==="*")g++;else if(T[g]!=="**")return!1;return g===T.length}}}e.getLocation=y;function n(i,l=[],r=A.DEFAULT){let a=null,w=[];const f=[];function m(T){Array.isArray(w)?w.push(T):a!==null&&(w[a]=T)}return o(i,{onObjectBegin:()=>{const T={};m(T),f.push(w),w=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{w=f.pop()},onArrayBegin:()=>{const T=[];m(T),f.push(w),w=T,a=null},onArrayEnd:()=>{w=f.pop()},onLiteralValue:m,onError:(T,g,b)=>{l.push({error:T,offset:g,length:b})}},r),w[0]}e.parse=n;function h(i,l=[],r=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(T){a.type==="property"&&(a.length=T-a.offset,a=a.parent)}function f(T){return a.children.push(T),T}o(i,{onObjectBegin:T=>{a=f({type:"object",offset:T,length:-1,parent:a,children:[]})},onObjectProperty:(T,g,b)=>{a=f({type:"property",offset:g,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:T,offset:g,length:b,parent:a})},onObjectEnd:(T,g)=>{a.length=T+g-a.offset,a=a.parent,w(T+g)},onArrayBegin:(T,g)=>{a=f({type:"array",offset:T,length:-1,parent:a,children:[]})},onArrayEnd:(T,g)=>{a.length=T+g-a.offset,a=a.parent,w(T+g)},onLiteralValue:(T,g,b)=>{f({type:C(T),offset:g,length:b,parent:a,value:T}),w(g+b)},onSeparator:(T,g,b)=>{a.type==="property"&&(T===":"?a.colonOffset=g:T===","&&w(g))},onError:(T,g,b)=>{l.push({error:T,offset:g,length:b})}},r);const S=a.children[0];return S&&delete S.parent,S}e.parseTree=h;function s(i,l){if(!i)return;let r=i;for(let a of l)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let w=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===a){r=f.children[1],w=!0;break}if(!w)return}else{const w=a;if(r.type!=="array"||w<0||!Array.isArray(r.children)||w>=r.children.length)return;r=r.children[w]}return r}e.findNodeAtLocation=s;function d(i){if(!i.parent||!i.parent.children)return[];const l=d(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;l.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&l.push(r)}return l}e.getNodePath=d;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":const l=Object.create(null);for(let r of i.children){const a=r.children[1];a&&(l[r.children[0].value]=v(a))}return l;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function k(i,l,r=!1){return l>=i.offset&&l<i.offset+i.length||r&&l===i.offset+i.length}e.contains=k;function E(i,l,r=!1){if(k(i,l,r)){const a=i.children;if(Array.isArray(a))for(let w=0;w<a.length&&a[w].offset<=l;w++){const f=E(a[w],l,r);if(f)return f}return i}}e.findNodeAtOffset=E;function o(i,l,r=A.DEFAULT){const a=R(i,!1);function w(se){return se?()=>se(a.getTokenOffset(),a.getTokenLength()):()=>!0}function f(se){return se?ve=>se(ve,a.getTokenOffset(),a.getTokenLength()):()=>!0}const m=w(l.onObjectBegin),S=f(l.onObjectProperty),T=w(l.onObjectEnd),g=w(l.onArrayBegin),b=w(l.onArrayEnd),u=f(l.onLiteralValue),F=f(l.onSeparator),O=w(l.onComment),j=f(l.onError),Q=r&&r.disallowComments,W=r&&r.allowTrailingComma;function K(){for(;;){const se=a.scan();switch(a.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:Q||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(se){case 12:case 13:Q?$(10):O();break;case 16:$(1);break;case 15:case 14:break;default:return se}}}function $(se,ve=[],Fe=[]){if(j(se),ve.length+Fe.length>0){let Me=a.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){K();break}else if(Fe.indexOf(Me)!==-1)break;Me=K()}}}function U(se){const ve=a.getTokenValue();return se?u(ve):S(ve),K(),!0}function H(){switch(a.getToken()){case 11:let se=0;try{se=JSON.parse(a.getTokenValue()),typeof se!="number"&&($(2),se=0)}catch(ve){$(2)}u(se);break;case 7:u(null);break;case 8:u(!0);break;case 9:u(!1);break;default:return!1}return K(),!0}function G(){return a.getToken()!==10?($(3,[],[2,5]),!1):(U(!1),a.getToken()===6?(F(":"),K(),le()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ue(){m(),K();let se=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(se||$(4,[],[]),F(","),K(),a.getToken()===2&&W)break}else se&&$(6,[],[]);G()||$(4,[],[2,5]),se=!0}return T(),a.getToken()!==2?$(7,[2],[]):K(),!0}function q(){g(),K();let se=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(se||$(4,[],[]),F(","),K(),a.getToken()===4&&W)break}else se&&$(6,[],[]);le()||$(4,[],[4,5]),se=!0}return b(),a.getToken()!==4?$(8,[4],[]):K(),!0}function le(){switch(a.getToken()){case 3:return q();case 1:return ue();case 10:return U(!0);default:return H()}}return K(),a.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):le()?(a.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=o;function p(i,l){let r=R(i),a=[],w,f=0,m;do switch(m=r.getPosition(),w=r.scan(),w){case 12:case 13:case 17:f!==m&&a.push(i.substring(f,m)),l!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,l)),f=r.getPosition();break}while(w!==17);return a.join("")}e.stripComments=p;function C(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(be[103],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(_){this.executor=_,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(_){this._error=_}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(_){return new c(()=>_(this.getValue()))}}e.Lazy=c}),function(ie,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ie=typeof globalThis!="undefined"?globalThis:ie||self,ie.marked=e())}(this,function(){"use strict";function ie(Pe,ye){for(var De=0;De<ye.length;De++){var Z=ye[De];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Pe,Z.key,Z)}}function e(Pe,ye,De){return ye&&ie(Pe.prototype,ye),De&&ie(Pe,De),Pe}function c(Pe,ye){if(!!Pe){if(typeof Pe=="string")return M(Pe,ye);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Pe,ye)}}function M(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var De=0,Z=new Array(ye);De<ye;De++)Z[De]=Pe[De];return Z}function _(Pe,ye){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=c(Pe))||ye&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var Z=0;return function(){return Z>=Pe.length?{done:!0}:{done:!1,value:Pe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Pe){A.exports.defaults=Pe}A.exports={defaults:R(),getDefaults:R,changeDefaults:I};var D=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(ye){return n[ye]};function s(Pe,ye){if(ye){if(D.test(Pe))return Pe.replace(P,h)}else if(t.test(Pe))return Pe.replace(y,h);return Pe}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Pe){return Pe.replace(d,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var k=/(^|[^\[])\^/g;function E(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var De={replace:function(ce,ge){return ge=ge.source||ge,ge=ge.replace(k,"$1"),Pe=Pe.replace(ce,ge),De},getRegex:function(){return new RegExp(Pe,ye)}};return De}var o=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(Pe,ye,De){if(Pe){var Z;try{Z=decodeURIComponent(v(De)).replace(o,"").toLowerCase()}catch(ce){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!p.test(De)&&(De=w(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ce){return null}return De}var i={},l=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(Pe,ye){i[" "+Pe]||(l.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=T(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Pe.replace(r,"$1")+ye:ye.charAt(0)==="/"?De?ye:Pe.replace(a,"$1")+ye:Pe+ye}var f={exec:function(){}};function m(Pe){for(var ye=1,De,Z;ye<arguments.length;ye++){De=arguments[ye];for(Z in De)Object.prototype.hasOwnProperty.call(De,Z)&&(Pe[Z]=De[Z])}return Pe}function S(Pe,ye){var De=Pe.replace(/\|/g,function(ge,me,Ie){for(var Be=!1,Le=me;--Le>=0&&Ie[Le]==="\\";)Be=!Be;return Be?"|":" |"}),Z=De.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function T(Pe,ye,De){var Z=Pe.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ge=Pe.charAt(Z-ce-1);if(ge===ye&&!De)ce++;else if(ge!==ye&&De)ce++;else break}return Pe.substr(0,Z-ce)}function g(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var De=Pe.length,Z=0,ce=0;ce<De;ce++)if(Pe[ce]==="\\")ce++;else if(Pe[ce]===ye[0])Z++;else if(Pe[ce]===ye[1]&&(Z--,Z<0))return ce;return-1}function b(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function u(Pe,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Pe),ye>>=1,Pe+=Pe;return De+Pe}var F={escape:s,unescape:v,edit:E,cleanUrl:C,resolveUrl:w,noopTest:f,merge:m,splitCells:S,rtrim:T,findClosingBracket:g,checkSanitizeDeprecation:b,repeatString:u},O=A.exports.defaults,j=F.rtrim,Q=F.splitCells,W=F.escape,K=F.findClosingBracket;function $(Pe,ye,De,Z){var ce=ye.href,ge=ye.title?W(ye.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){Z.state.inLink=!0;var Ie={type:"link",raw:De,href:ce,title:ge,text:me,tokens:Z.inlineTokens(me,[])};return Z.state.inLink=!1,Ie}else return{type:"image",raw:De,href:ce,title:ge,text:W(me)}}function U(Pe,ye){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return ye;var Z=De[1];return ye.split(`
`).map(function(ce){var ge=ce.match(/^\s+/);if(ge===null)return ce;var me=ge[0];return me.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var H=function(){function Pe(De){this.options=De||O}var ye=Pe.prototype;return ye.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},ye.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ge=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:j(ge,`
`)}}},ye.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ge=ce[0],me=U(ge,ce[3]||"");return{type:"code",raw:ge,lang:ce[2]?ce[2].trim():ce[2],text:me}}},ye.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ge=ce[2].trim();if(/#$/.test(ge)){var me=j(ge,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ge=me.trim())}var Ie={type:"heading",raw:ce[0],depth:ce[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},ye.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ge=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ge,me,Ie,Be,Le,je,Xe,ne,pe,re,B=ce[1].trim(),Ce=B.length>1,Se={type:"list",raw:"",ordered:Ce,start:Ce?+B.slice(0,-1):"",loose:!1,items:[]};B=Ce?"\\d{1,9}\\"+B.slice(-1):"\\"+B,this.options.pedantic&&(B=Ce?B:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+B+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(ce=Ge.exec(Z)));){pe=ce[2].split(`
`),this.options.pedantic?(Be=2,re=pe[0].trimLeft()):(Be=ce[2].search(/[^ ]/),Be=ce[1].length+(Be>4?1:Be),re=pe[0].slice(Be-ce[1].length)),je=!1,ge=ce[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=ce[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<pe.length;Le++){if(ne=pe[Le],this.options.pedantic&&(ne=ne.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(ne)){ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}if(!je){ne.trim()||(je=!0),ne.search(/[^ ]/)>=Be?re+=`
`+ne.slice(Be):re+=`
`+ne;continue}if(ne.search(/[^ ]/)>=Be||!ne.trim()){re+=`
`+ne.slice(Be);continue}else{ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}}Se.loose||(Xe?Se.loose=!0:/\n *\n *$/.test(ge)&&(Xe=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(re),me&&(Ie=me[0]!=="[ ] ",re=re.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!me,checked:Ie,loose:!1,text:re}),Se.raw+=ge,Z=Z.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=re.trimRight(),Se.raw=Se.raw.trimRight();var it=Se.items.length;for(Le=0;Le<it;Le++)this.lexer.state.top=!1,Se.items[Le].tokens=this.lexer.blockTokens(Se.items[Le].text,[]),Se.items[Le].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Le].loose=!0);return Se}},ye.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ge={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ce[0]):W(ce[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ge=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ce[0],href:ce[2],title:ce[3]}}},ye.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ge={type:"table",header:Q(ce[1]).map(function(Xe){return{text:Xe}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ce[0];var me=ge.align.length,Ie,Be,Le,je;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(me=ge.rows.length,Ie=0;Ie<me;Ie++)ge.rows[Ie]=Q(ge.rows[Ie],ge.header.length).map(function(Xe){return{text:Xe}});for(me=ge.header.length,Be=0;Be<me;Be++)ge.header[Be].tokens=[],this.lexer.inlineTokens(ge.header[Be].text,ge.header[Be].tokens);for(me=ge.rows.length,Be=0;Be<me;Be++)for(je=ge.rows[Be],Le=0;Le<je.length;Le++)je[Le].tokens=[],this.lexer.inlineTokens(je[Le].text,je[Le].tokens);return ge}}},ye.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce){var ge={type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ge={type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce){var ge={type:"text",raw:ce[0],text:ce[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:W(ce[1])}},ye.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):W(ce[0]):ce[0]}},ye.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ge=ce[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var me=j(ge.slice(0,-1),"\\");if((ge.length-me.length)%2==0)return}else{var Ie=K(ce[2],"()");if(Ie>-1){var Be=ce[0].indexOf("!")===0?5:4,Le=Be+ce[1].length+Ie;ce[2]=ce[2].substring(0,Ie),ce[0]=ce[0].substring(0,Le).trim(),ce[3]=""}}var je=ce[2],Xe="";if(this.options.pedantic){var ne=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);ne&&(je=ne[1],Xe=ne[3])}else Xe=ce[3]?ce[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(ge)?je=je.slice(1):je=je.slice(1,-1)),$(ce,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ye.reflink=function(Z,ce){var ge;if((ge=this.rules.inline.reflink.exec(Z))||(ge=this.rules.inline.nolink.exec(Z))){var me=(ge[2]||ge[1]).replace(/\s+/g," ");if(me=ce[me.toLowerCase()],!me||!me.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return $(ge,me,ge[0],this.lexer)}},ye.emStrong=function(Z,ce,ge){ge===void 0&&(ge="");var me=this.rules.inline.emStrong.lDelim.exec(Z);if(!!me&&!(me[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var Be=me[0].length-1,Le,je,Xe=Be,ne=0,pe=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+Be);(me=pe.exec(ce))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(je=Le.length,me[3]||me[4]){Xe+=je;continue}else if((me[5]||me[6])&&Be%3&&!((Be+je)%3)){ne+=je;continue}if(Xe-=je,!(Xe>0)){if(je=Math.min(je,je+Xe+ne),Math.min(Be,je)%2){var re=Z.slice(1,Be+me.index+je);return{type:"em",raw:Z.slice(0,Be+me.index+je+1),text:re,tokens:this.lexer.inlineTokens(re,[])}}var B=Z.slice(2,Be+me.index+je-1);return{type:"strong",raw:Z.slice(0,Be+me.index+je+1),text:B,tokens:this.lexer.inlineTokens(B,[])}}}}}},ye.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ge=ce[2].replace(/\n/g," "),me=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return me&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=W(ge,!0),{type:"codespan",raw:ce[0],text:ge}}},ye.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},ye.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2],[])}},ye.autolink=function(Z,ce){var ge=this.rules.inline.autolink.exec(Z);if(ge){var me,Ie;return ge[2]==="@"?(me=W(this.options.mangle?ce(ge[1]):ge[1]),Ie="mailto:"+me):(me=W(ge[1]),Ie=me),{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.url=function(Z,ce){var ge;if(ge=this.rules.inline.url.exec(Z)){var me,Ie;if(ge[2]==="@")me=W(this.options.mangle?ce(ge[0]):ge[0]),Ie="mailto:"+me;else{var Be;do Be=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(Be!==ge[0]);me=W(ge[0]),ge[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.inlineText=function(Z,ce){var ge=this.rules.inline.text.exec(Z);if(ge){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):W(ge[0]):ge[0]:me=W(this.options.smartypants?ce(ge[0]):ge[0]),{type:"text",raw:ge[0],text:me}}},Pe}(),G=F.noopTest,ue=F.edit,q=F.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=ue(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=ue(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=ue(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=ue(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=ue(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=ue(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=q({},le),le.gfm=q({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=ue(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=q({},le.normal,{html:ue(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:ue(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=ue(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=ue(le._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=ue(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=ue(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=ue(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=ue(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=ue(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=ue(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=ue(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=ue(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=q({},se),se.pedantic=q({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ue(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:ue(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=q({},se.normal,{escape:ue(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=ue(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=q({},se.gfm,{br:ue(se.br).replace("{2,}","*").getRegex(),text:ue(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:se},Fe=H,Me=A.exports.defaults,Ne=ve.block,Qe=ve.inline,ze=F.repeatString;function qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Pe){var ye="",De,Z,ce=Pe.length;for(De=0;De<ce;De++)Z=Pe.charCodeAt(De),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var Y=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Ne.normal,inline:Qe.normal};this.options.pedantic?(Z.block=Ne.pedantic,Z.inline=Qe.pedantic):this.options.gfm&&(Z.block=Ne.gfm,this.options.breaks?Z.inline=Qe.breaks:Z.inline=Qe.gfm),this.tokenizer.rules=Z}Pe.lex=function(Z,ce){var ge=new Pe(ce);return ge.lex(Z)},Pe.lexInline=function(Z,ce){var ge=new Pe(ce);return ge.inlineTokens(Z)};var ye=Pe.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ye.blockTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var me,Ie,Be,Le;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Xe){return(me=Xe.call({lexer:ge},Z,ce))?(Z=Z.substring(me.raw.length),ce.push(me),!0):!1}))){if(me=this.tokenizer.space(Z)){Z=Z.substring(me.raw.length),me.type&&ce.push(me);continue}if(me=this.tokenizer.code(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me);continue}if(me=this.tokenizer.fences(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.heading(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.hr(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.blockquote(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.list(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.html(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.def(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.lheading(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Xe=Infinity,ne=Z.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(re){pe=re.call({lexer:this},ne),typeof pe=="number"&&pe>=0&&(Xe=Math.min(Xe,pe))}),Xe<Infinity&&Xe>=0&&(Be=Z.substring(0,Xe+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Be))){Ie=ce[ce.length-1],Le&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me),Le=Be.length!==Z.length,Z=Z.substring(me.raw.length);continue}if(me=this.tokenizer.text(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(me);continue}if(Z){var je="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,ce},ye.inline=function(Z,ce){this.inlineQueue.push({src:Z,tokens:ce})},ye.inlineTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]);var me,Ie,Be,Le=Z,je,Xe,ne;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)pe.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,je.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Xe||(ne=""),Xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(B){return(me=B.call({lexer:ge},Z,ce))?(Z=Z.substring(me.raw.length),ce.push(me),!0):!1}))){if(me=this.tokenizer.escape(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.tag(Z)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(me=this.tokenizer.link(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(me.raw.length),Ie=ce[ce.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(me=this.tokenizer.emStrong(Z,Le,ne)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.codespan(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.br(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.del(Z)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(me=this.tokenizer.autolink(Z,x)){Z=Z.substring(me.raw.length),ce.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(Z,x))){Z=Z.substring(me.raw.length),ce.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var B=Infinity,Ce=Z.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(Ge){Se=Ge.call({lexer:this},Ce),typeof Se=="number"&&Se>=0&&(B=Math.min(B,Se))}),B<Infinity&&B>=0&&(Be=Z.substring(0,B+1))}(),me=this.tokenizer.inlineText(Be,qe)){Z=Z.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(ne=me.raw.slice(-1)),Xe=!0,Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ce.push(me);continue}if(Z){var re="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return ce},e(Pe,null,[{key:"rules",get:function(){return{block:Ne,inline:Qe}}}]),Pe}(),ee=A.exports.defaults,ae=F.cleanUrl,V=F.escape,oe=function(){function Pe(De){this.options=De||ee}var ye=Pe.prototype;return ye.code=function(Z,ce,ge){var me=(ce||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(Z,me);Ie!=null&&Ie!==Z&&(ge=!0,Z=Ie)}return Z=Z.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+V(me,!0)+'">'+(ge?Z:V(Z,!0))+`</code></pre>
`:"<pre><code>"+(ge?Z:V(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,ce,ge,me){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+me.slug(ge)+'">'+Z+"</h"+ce+`>
`:"<h"+ce+">"+Z+"</h"+ce+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,ce,ge){var me=ce?"ol":"ul",Ie=ce&&ge!==1?' start="'+ge+'"':"";return"<"+me+Ie+`>
`+Z+"</"+me+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,ce){var ge=ce.header?"th":"td",me=ce.align?"<"+ge+' align="'+ce.align+'">':"<"+ge+">";return me+Z+"</"+ge+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,ce,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<a href="'+V(Z)+'"';return ce&&(me+=' title="'+ce+'"'),me+=">"+ge+"</a>",me},ye.image=function(Z,ce,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<img src="'+Z+'" alt="'+ge+'"';return ce&&(me+=' title="'+ce+'"'),me+=this.options.xhtml?"/>":">",me},ye.text=function(Z){return Z},Pe}(),fe=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,ce,ge){return""+ge},ye.image=function(Z,ce,ge){return""+ge},ye.br=function(){return""},Pe}(),Ae=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,ce){var ge=Z,me=0;if(this.seen.hasOwnProperty(ge)){me=this.seen[Z];do me++,ge=Z+"-"+me;while(this.seen.hasOwnProperty(ge))}return ce||(this.seen[Z]=me,this.seen[ge]=0),ge},ye.slug=function(Z,ce){ce===void 0&&(ce={});var ge=this.serialize(Z);return this.getNextSafeSlug(ge,ce.dryrun)},Pe}(),xe=oe,$e=fe,we=Ae,Ze=A.exports.defaults,z=F.unescape,J=function(){function Pe(De){this.options=De||Ze,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new we}Pe.parse=function(Z,ce){var ge=new Pe(ce);return ge.parse(Z)},Pe.parseInline=function(Z,ce){var ge=new Pe(ce);return ge.parseInline(Z)};var ye=Pe.prototype;return ye.parse=function(Z,ce){ce===void 0&&(ce=!0);var ge="",me,Ie,Be,Le,je,Xe,ne,pe,re,B,Ce,Se,Ge,We,it,mt,vt,nt,ot,lt=Z.length;for(me=0;me<lt;me++){if(B=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(ot=this.options.extensions.renderers[B.type].call({parser:this},B),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(B.type))){ge+=ot||"";continue}switch(B.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(B.tokens),B.depth,z(this.parseInline(B.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(B.text,B.lang,B.escaped);continue}case"table":{for(pe="",ne="",Le=B.header.length,Ie=0;Ie<Le;Ie++)ne+=this.renderer.tablecell(this.parseInline(B.header[Ie].tokens),{header:!0,align:B.align[Ie]});for(pe+=this.renderer.tablerow(ne),re="",Le=B.rows.length,Ie=0;Ie<Le;Ie++){for(Xe=B.rows[Ie],ne="",je=Xe.length,Be=0;Be<je;Be++)ne+=this.renderer.tablecell(this.parseInline(Xe[Be].tokens),{header:!1,align:B.align[Be]});re+=this.renderer.tablerow(ne)}ge+=this.renderer.table(pe,re);continue}case"blockquote":{re=this.parse(B.tokens),ge+=this.renderer.blockquote(re);continue}case"list":{for(Ce=B.ordered,Se=B.start,Ge=B.loose,Le=B.items.length,re="",Ie=0;Ie<Le;Ie++)it=B.items[Ie],mt=it.checked,vt=it.task,We="",it.task&&(nt=this.renderer.checkbox(mt),Ge?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=nt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=nt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:nt}):We+=nt),We+=this.parse(it.tokens,Ge),re+=this.renderer.listitem(We,vt,mt);ge+=this.renderer.list(re,Ce,Se);continue}case"html":{ge+=this.renderer.html(B.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(B.tokens));continue}case"text":{for(re=B.tokens?this.parseInline(B.tokens):B.text;me+1<lt&&Z[me+1].type==="text";)B=Z[++me],re+=`
`+(B.tokens?this.parseInline(B.tokens):B.text);ge+=ce?this.renderer.paragraph(re):re;continue}default:{var Rt='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Rt);return}else throw new Error(Rt)}}}return ge},ye.parseInline=function(Z,ce){ce=ce||this.renderer;var ge="",me,Ie,Be,Le=Z.length;for(me=0;me<Le;me++){if(Ie=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=Be||"";continue}switch(Ie.type){case"escape":{ge+=ce.text(Ie.text);break}case"html":{ge+=ce.html(Ie.text);break}case"link":{ge+=ce.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ce));break}case"image":{ge+=ce.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ce.strong(this.parseInline(Ie.tokens,ce));break}case"em":{ge+=ce.em(this.parseInline(Ie.tokens,ce));break}case"codespan":{ge+=ce.codespan(Ie.text);break}case"br":{ge+=ce.br();break}case"del":{ge+=ce.del(this.parseInline(Ie.tokens,ce));break}case"text":{ge+=ce.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ge},Pe}(),he=Y,Oe=J,Ve=H,tt=oe,ut=fe,ht=Ae,St=F.merge,Pt=F.checkSanitizeDeprecation,dt=F.escape,bt=A.exports.getDefaults,ft=A.exports.changeDefaults,Et=A.exports.defaults;function Ye(Pe,ye,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=St({},Ye.defaults,ye||{}),Pt(ye),De){var Z=ye.highlight,ce;try{ce=he.lex(Pe,ye)}catch(Be){return De(Be)}var ge=function(Le){var je;if(!Le)try{ye.walkTokens&&Ye.walkTokens(ce,ye.walkTokens),je=Oe.parse(ce,ye)}catch(Xe){Le=Xe}return ye.highlight=Z,Le?De(Le):De(null,je)};if(!Z||Z.length<3||(delete ye.highlight,!ce.length))return ge();var me=0;Ye.walkTokens(ce,function(Be){Be.type==="code"&&(me++,setTimeout(function(){Z(Be.text,Be.lang,function(Le,je){if(Le)return ge(Le);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),me--,me===0&&ge()})},0))}),me===0&&ge();return}try{var Ie=he.lex(Pe,ye);return ye.walkTokens&&Ye.walkTokens(Ie,ye.walkTokens),Oe.parse(Ie,ye)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Be.message+"",!0)+"</pre>";throw Be}}Ye.options=Ye.setOptions=function(Pe){return St(Ye.defaults,Pe),ft(Ye.defaults),Ye},Ye.getDefaults=bt,Ye.defaults=Et,Ye.use=function(){for(var Pe=this,ye=arguments.length,De=new Array(ye),Z=0;Z<ye;Z++)De[Z]=arguments[Z];var ce=St.apply(void 0,[{}].concat(De)),ge=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;De.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var je=ge.renderers?ge.renderers[Le.name]:null;je?ge.renderers[Le.name]=function(){for(var Xe=arguments.length,ne=new Array(Xe),pe=0;pe<Xe;pe++)ne[pe]=arguments[pe];var re=Le.renderer.apply(this,ne);return re===!1&&(re=je.apply(this,ne)),re}:ge.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Le.level]?ge[Le.level].unshift(Le.tokenizer):ge[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ge.startBlock?ge.startBlock.push(Le.start):ge.startBlock=[Le.start]:Le.level==="inline"&&(ge.startInline?ge.startInline.push(Le.start):ge.startInline=[Le.start]))}Le.childTokens&&(ge.childTokens[Le.name]=Le.childTokens)})),Ie.renderer&&function(){var Le=Ye.defaults.renderer||new tt,je=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,Ce=new Array(B),Se=0;Se<B;Se++)Ce[Se]=arguments[Se];var Ge=Ie.renderer[pe].apply(Le,Ce);return Ge===!1&&(Ge=re.apply(Le,Ce)),Ge}};for(var Xe in Ie.renderer)je(Xe);ce.renderer=Le}(),Ie.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new Ve,je=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,Ce=new Array(B),Se=0;Se<B;Se++)Ce[Se]=arguments[Se];var Ge=Ie.tokenizer[pe].apply(Le,Ce);return Ge===!1&&(Ge=re.apply(Le,Ce)),Ge}};for(var Xe in Ie.tokenizer)je(Xe);ce.tokenizer=Le}(),Ie.walkTokens){var Be=Ye.defaults.walkTokens;ce.walkTokens=function(Le){Ie.walkTokens.call(Pe,Le),Be&&Be(Le)}}me&&(ce.extensions=ge),Ye.setOptions(ce)})},Ye.walkTokens=function(Pe,ye){for(var De=function(){var me=ce.value;switch(ye(me),me.type){case"table":{for(var Ie=_(me.header),Be;!(Be=Ie()).done;){var Le=Be.value;Ye.walkTokens(Le.tokens,ye)}for(var je=_(me.rows),Xe;!(Xe=je()).done;)for(var ne=Xe.value,pe=_(ne),re;!(re=pe()).done;){var B=re.value;Ye.walkTokens(B.tokens,ye)}break}case"list":{Ye.walkTokens(me.items,ye);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(Ce){Ye.walkTokens(me[Ce],ye)}):me.tokens&&Ye.walkTokens(me.tokens,ye)}},Z=_(Pe),ce;!(ce=Z()).done;)De()},Ye.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=St({},Ye.defaults,ye||{}),Pt(ye);try{var De=he.lexInline(Pe,ye);return ye.walkTokens&&Ye.walkTokens(De,ye.walkTokens),Oe.parseInline(De,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Z.message+"",!0)+"</pre>";throw Z}},Ye.Parser=Oe,Ye.parser=Oe.parse,Ye.Renderer=tt,Ye.TextRenderer=ut,Ye.Lexer=he,Ye.lexer=he.lex,Ye.Tokenizer=Ve,Ye.Slugger=ht,Ye.parse=Ye;var Ct=Ye;return Ct}),define(be[75],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(R,I,D){return Math.min(Math.max(R,I),D)}e.clamp=c;function M(R,I){return(I+R%I)%I}e.rot=M;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class A{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function ie(_){const A=[];typeof _=="number"&&A.push("code/timeOrigin",_);function R(D){A.push(D,Date.now())}function I(){const D=[];for(let P=0;P<A.length;P+=2)D.push({name:A[P],startTime:A[P+1]});return D}return{mark:R,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(_+R.startTime)});return A}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function c(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=c(M))}(),define(be[34],Ee([0,1,3]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(y){const n=this._icons.get(y.id);n?y.description?n.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const _=new M;e.iconRegistry=_;function A(t,y){return new I(t,y)}e.registerCodicon=A;function R(t){return t?t.replace(/\$\((.*?)\)/g,(y,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=R;class I{constructor(y,n,h){this.id=y,this.definition=n,this.description=h,_.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function D(t,y){const n=["codicon","codicon-"+t];return y&&n.push("codicon-modifier-"+y),n}e.getClassNamesArray=D;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(d){if(d instanceof I)return["codicon","codicon-"+d.id];const v=y.exec(d.id);if(!v)return n(I.error);let[,k,E]=v;const o=["codicon","codicon-"+k];return E&&o.push("codicon-modifier-"+E.substr(1)),o}t.asClassNameArray=n;function h(d){return n(d).join(" ")}t.asClassName=h;function s(d){return"."+n(d).join(".")}t.asCSSSelector=s})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(be[104],Ee([0,1,16,6]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(o){const p=o;return p?[p.on,p.pause,p.resume,p.destroy].every(C=>typeof C=="function"):!1}e.isReadableStream=_;function A(o){const p=o;return p?_(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=A;function R(o,p){return new I(o,p)}e.newWriteableStream=R;class I{constructor(p,C){this.reducer=p,this.options=C,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(C=>this.pendingWritePromises.push(C))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(C=>C(p))}emitError(p){this.listeners.error.length===0?(0,c.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(C=>C(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,C){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(C),this.resume();break;case"end":this.listeners.end.push(C),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(C),this.state.flowing&&this.flowErrors();break}}removeListener(p,C){if(this.state.destroyed)return;let i;switch(p){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const l=i.indexOf(C);l>=0&&i.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const C=[...this.pendingWritePromises];this.pendingWritePromises.length=0,C.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(o,p){const C=[];let i;for(;(i=o.read())!==null;)C.push(i);return p(C)}e.consumeReadable=D;function P(o,p,C){const i=[];let l;for(;(l=o.read())!==null&&i.length<C;)i.push(l);return l===null&&i.length>0?p(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l!="undefined"){const r=l;return l=void 0,r}return o.read()}}}e.peekReadable=P;function t(o,p){return new Promise((C,i)=>{const l=[];y(o,{onData:r=>{p&&l.push(r)},onError:r=>{p?i(r):C(void 0)},onEnd:()=>{C(p?p(l):void 0)}})})}e.consumeStream=t;function y(o,p){o.on("error",C=>p.onError(C)),o.on("end",()=>p.onEnd()),o.on("data",C=>p.onData(C))}e.listenStream=y;function n(o,p){return new Promise((C,i)=>{const l=new M.DisposableStore,r=[],a=m=>{if(r.push(m),r.length>p)return l.dispose(),o.pause(),C({stream:o,buffer:r,ended:!1})},w=m=>i(m),f=()=>C({stream:o,buffer:r,ended:!0});l.add((0,M.toDisposable)(()=>o.removeListener("error",w))),o.on("error",w),l.add((0,M.toDisposable)(()=>o.removeListener("end",f))),o.on("end",f),l.add((0,M.toDisposable)(()=>o.removeListener("data",a))),o.on("data",a)})}e.peekStream=n;function h(o,p){const C=R(p);return C.end(o),C}e.toStream=h;function s(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=s;function d(o){let p=!1;return{read:()=>p?null:(p=!0,o)}}e.toReadable=d;function v(o,p,C){const i=R(C);return y(o,{onData:l=>i.write(p.data(l)),onError:l=>i.error(p.error?p.error(l):l),onEnd:()=>i.end()}),i}e.transform=v;function k(o,p,C){let i=!1;return{read:()=>{const l=p.read();return i?l:(i=!0,l!==null?C([o,l]):o)}}}e.prefixedReadable=k;function E(o,p,C){let i=!1;const l=R(C);return y(p,{onData:r=>i?l.write(r):(i=!0,l.write(C([o,r]))),onError:r=>l.error(r),onEnd:()=>{i||(i=!0,l.write(o)),l.end()}}),l}e.prefixedStream=E}),define(be[23],Ee([0,1,104]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let _,A;class R{constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}static alloc(a){return M?new R(Buffer.allocUnsafe(a)):new R(new Uint8Array(a))}static wrap(a){return M&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new R(a)}static fromString(a,w){return!(w?.dontUseNodeBuffer||!1)&&M?new R(Buffer.from(a)):(_||(_=new TextEncoder),new R(_.encode(a)))}static concat(a,w){if(typeof w=="undefined"){w=0;for(let S=0,T=a.length;S<T;S++)w+=a[S].byteLength}const f=R.alloc(w);let m=0;for(let S=0,T=a.length;S<T;S++){const g=a[S];f.set(g,m),m+=g.byteLength}return f}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(a,w){return new R(this.buffer.subarray(a,w))}set(a,w){a instanceof R?this.buffer.set(a.buffer,w):this.buffer.set(a,w)}readUInt32BE(a){return P(this.buffer,a)}writeUInt32BE(a,w){t(this.buffer,a,w)}readUInt32LE(a){return y(this.buffer,a)}writeUInt32LE(a,w){n(this.buffer,a,w)}readUInt8(a){return h(this.buffer,a)}writeUInt8(a,w){s(this.buffer,a,w)}}e.VSBuffer=R;function I(r,a){return r[a+0]<<0>>>0|r[a+1]<<8>>>0}e.readUInt16LE=I;function D(r,a,w){r[w+0]=a&255,a=a>>>8,r[w+1]=a&255}e.writeUInt16LE=D;function P(r,a){return r[a]*2**24+r[a+1]*2**16+r[a+2]*2**8+r[a+3]}e.readUInt32BE=P;function t(r,a,w){r[w+3]=a,a=a>>>8,r[w+2]=a,a=a>>>8,r[w+1]=a,a=a>>>8,r[w]=a}e.writeUInt32BE=t;function y(r,a){return r[a+0]<<0>>>0|r[a+1]<<8>>>0|r[a+2]<<16>>>0|r[a+3]<<24>>>0}e.readUInt32LE=y;function n(r,a,w){r[w+0]=a&255,a=a>>>8,r[w+1]=a&255,a=a>>>8,r[w+2]=a&255,a=a>>>8,r[w+3]=a&255}e.writeUInt32LE=n;function h(r,a){return r[a]}e.readUInt8=h;function s(r,a,w){r[w]=a}e.writeUInt8=s;function d(r){return c.consumeReadable(r,a=>R.concat(a))}e.readableToBuffer=d;function v(r){return c.toReadable(r)}e.bufferToReadable=v;function k(r){return c.consumeStream(r,a=>R.concat(a))}e.streamToBuffer=k;async function E(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await k(r.stream)])}e.bufferedStreamToBuffer=E;function o(r){return c.toStream(r,a=>R.concat(a))}e.bufferToStream=o;function p(r){return c.transform(r,{data:a=>typeof a=="string"?R.fromString(a):R.wrap(a)},a=>R.concat(a))}e.streamToBufferReadableStream=p;function C(r){return c.newWriteableStream(a=>R.concat(a),r)}e.newWriteableBufferStream=C;function i(r,a){return c.prefixedReadable(r,a,w=>R.concat(w))}e.prefixedBufferReadable=i;function l(r,a){return c.prefixedStream(r,a,w=>R.concat(w))}e.prefixedBufferStream=l}),define(be[35],Ee([0,1,9]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(M||(M={})),function(_){const A="error",R="warning",I="warn",D="info",P="ignore";function t(n){return n?c.equalsIgnoreCase(A,n)?_.Error:c.equalsIgnoreCase(R,n)||c.equalsIgnoreCase(I,n)?_.Warning:c.equalsIgnoreCase(D,n)?_.Info:_.Ignore:_.Ignore}_.fromValue=t;function y(n){switch(n){case _.Error:return A;case _.Warning:return R;case _.Info:return D;default:return P}}_.toString=y}(M||(M={})),e.default=M}),define(be[41],Ee([0,1,17,26,9,10]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function I(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=I;function D(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=D;function P(r,a=c.posix.sep){if(!r)return"";const w=r.length,f=r.charCodeAt(0);if(R(f)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let S=3;const T=S;for(;S<w&&!R(r.charCodeAt(S));S++);if(T!==S&&!R(r.charCodeAt(S+1))){for(S+=1;S<w;S++)if(R(r.charCodeAt(S)))return r.slice(0,S+1).replace(/[\\/]/g,a)}}return a}else if(k(f)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<w;m++)if(R(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=P;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let w=2;const f=w;for(;w<r.length&&(a=r.charCodeAt(w),a!==92);w++);return!(f===w||(a=r.charCodeAt(w+1),isNaN(a)||a===92))}e.isUNC=t;const y=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(r,a=M.isWindows){const w=a?y:n;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=s;function d(r,a,w){const f=r===a;return!w||f?f:!r||!a?!1:(0,_.equalsIgnoreCase)(r,a)}e.isEqual=d;function v(r,a,w,f=c.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(w){if(!(0,_.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let S=a.length;return a.charAt(a.length-1)===f&&S--,r.charAt(S)===f}return a.charAt(a.length-1)!==f&&(a+=f),r.indexOf(a)===0}e.isEqualOrParent=v;function k(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=k;function E(r,a){return M.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(a,r)),r=(0,c.normalize)(r),M.isWindows?(r=(0,_.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,_.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=E;function o(r){const a=(0,c.normalize)(r);return M.isWindows?r.length>3?!1:p(a)&&(r.length===2||a.charCodeAt(2)===92):a===c.posix.sep}e.isRootOrDriveLetter=o;function p(r){return M.isWindows?k(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function C(r){return p(r)?r[0]:void 0}e.getDriveLetter=C;function i(r,a,w){return a.length>r.length?-1:r===a?0:(w&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=i;function l(r){const a=r.split(":");let w,f,m;if(a.forEach(S=>{const T=Number(S);(0,A.isNumber)(T)?f===void 0?f=T:m===void 0&&(m=T):w=w?[w,S].join(":"):S}),!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(be[22],Ee([0,1,10]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const v=Array.isArray(d)?[]:{};return Object.keys(d).forEach(k=>{d[k]&&typeof d[k]=="object"?v[k]=M(d[k]):v[k]=d[k]}),v}e.deepClone=M;function _(d){if(!d||typeof d!="object")return d;const v=[d];for(;v.length>0;){const k=v.shift();Object.freeze(k);for(const E in k)if(A.call(k,E)){const o=k[E];typeof o=="object"&&!Object.isFrozen(o)&&v.push(o)}}return d}e.deepFreeze=_;const A=Object.prototype.hasOwnProperty;function R(d,v){return I(d,v,new Set)}e.cloneAndChange=R;function I(d,v,k){if((0,c.isUndefinedOrNull)(d))return d;const E=v(d);if(typeof E!="undefined")return E;if((0,c.isArray)(d)){const o=[];for(const p of d)o.push(I(p,v,k));return o}if((0,c.isObject)(d)){if(k.has(d))throw new Error("Cannot clone recursive data-structure");k.add(d);const o={};for(let p in d)A.call(d,p)&&(o[p]=I(d[p],v,k));return k.delete(d),o}return d}function D(d,v,k=!0){return(0,c.isObject)(d)?((0,c.isObject)(v)&&Object.keys(v).forEach(E=>{E in d?k&&((0,c.isObject)(d[E])&&(0,c.isObject)(v[E])?D(d[E],v[E],k):d[E]=v[E]):d[E]=v[E]}),d):v}e.mixin=D;function P(d,v){if(d===v)return!0;if(d==null||v===null||v===void 0||typeof d!=typeof v||typeof d!="object"||Array.isArray(d)!==Array.isArray(v))return!1;let k,E;if(Array.isArray(d)){if(d.length!==v.length)return!1;for(k=0;k<d.length;k++)if(!P(d[k],v[k]))return!1}else{const o=[];for(E in d)o.push(E);o.sort();const p=[];for(E in v)p.push(E);if(p.sort(),!P(o,p))return!1;for(k=0;k<o.length;k++)if(!P(d[o[k]],v[o[k]]))return!1}return!0}e.equals=P;function t(d){const v=new Set;return JSON.stringify(d,(k,E)=>{if((0,c.isObject)(E)||Array.isArray(E)){if(v.has(E))return"[Circular]";v.add(E)}return E})}e.safeStringify=t;function y(d,v,k){const E=v(d);return typeof E=="undefined"?k:E}e.getOrDefault=y;function n(d,v){const k=Object.create(null);return!d||!v||Object.keys(v).forEach(o=>{const p=d[o],C=v[o];P(p,C)||(k[o]=C)}),k}e.distinct=n;function h(d,v){const k=v.toLowerCase(),E=Object.keys(d).find(o=>o.toLowerCase()===k);return E?d[E]:d[v]}e.getCaseInsensitive=h;function s(d,v){const k=Object.create(null);for(const E of Object.keys(d))v(E,d[E])&&(k[E]=d[E]);return k}e.filter=s});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[20],Ee([0,1,13,9,2]),function(ie,e,c,M,_){"use strict";var A,R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(l,r,a){let w=l.get(r);return w===void 0&&(w=a,l.set(r,w)),w}e.getOrSet=D;function P(l){const r=[];return l.forEach((a,w)=>{r.push(`${w} => ${a}`)}),`Map(${l.size}) {${r.join(", ")}}`}e.mapToString=P;function t(l){const r=[];return l.forEach(a=>{r.push(a)}),`Set(${l.size}) {${r.join(", ")}}`}e.setToString=t;class y{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),w=this._value.charCodeAt(this._pos);return a-w}value(){return this._value[this._pos]}}e.StringIterator=y;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class h{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var s;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(s||(s={}));class d{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class k{constructor(r){this._iter=r}static forUris(r=()=>!1){return new k(new d(r))}static forPaths(){return new k(new h)}static forStrings(){return new k(new y)}static forConfigKeys(){return new k(new n)}clear(){this._root=void 0}set(r,a){const w=this._iter.reset(r);let f;for(this._root||(this._root=new v,this._root.segment=w.value()),f=this._root;;){const S=w.cmp(f.segment);if(S>0)f.left||(f.left=new v,f.left.segment=w.value()),f=f.left;else if(S<0)f.right||(f.right=new v,f.right.segment=w.value()),f=f.right;else if(w.hasNext())w.next(),f.mid||(f.mid=new v,f.mid.segment=w.value()),f=f.mid;else break}const m=f.value;return f.value=a,f.key=r,m}fill(r,a){const w=a.slice(0);(0,c.shuffle)(w);for(let f of w)this.set(f,r)}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let w=this._root;for(;w;){const f=a.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(a.hasNext())a.next(),w=w.mid;else break}return w}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const w=this._iter.reset(r),f=[];let m=this._root;for(;m;){const S=w.cmp(m.segment);if(S>0)f.push([1,m]),m=m.left;else if(S<0)f.push([-1,m]),m=m.right;else if(w.hasNext())w.next(),f.push([0,m]),m=m.mid;else{for(a?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;f.length>0&&m.isEmpty();){let[T,g]=f.pop();switch(T){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}m=g}break}}}findSubstr(r){const a=this._iter.reset(r);let w=this._root,f;for(;w;){const m=a.cmp(w.segment);if(m>0)w=w.left;else if(m<0)w=w.right;else if(a.hasNext())a.next(),f=w.value||f,w=w.mid;else break}return w&&w.value||f}findSuperstr(r){const a=this._iter.reset(r);let w=this._root;for(;w;){const f=a.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(a.hasNext())a.next(),w=w.mid;else return w.mid?this._entries(w.mid):void 0}}forEach(r){for(const[a,w]of this)r(w,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const a=[r];for(;a.length>0;){const w=a.pop();w&&(w.value&&(yield[w.key,w.value]),w.left&&a.push(w.left),w.mid&&a.push(w.mid),w.right&&a.push(w.right))}}}e.TernarySearchTree=k;class E{constructor(r,a){this[A]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=a??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),a),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[w,f]of this.map)r(f,_.URI.parse(w),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield _.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[_.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[_.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=l=>l.toString();var o;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class p{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const w=this._map.get(r);if(!!w)return a!==0&&this.touch(w,a),w.value}set(r,a,w=0){let f=this._map.get(r);if(f)f.value=a,w!==0&&this.touch(f,w);else{switch(f={key:r,value:a,next:void 0,previous:void 0},w){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(r,f),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const w=this._state;let f=this._head;for(;f;){if(a?r.bind(a)(f.value,f.key,this):r(f.value,f.key,this),this._state!==w)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,a=this._state;let w=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const m={value:w.key,done:!1};return w=w.next,m}else return{value:void 0,done:!0}}};return f}values(){const r=this,a=this._state;let w=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const m={value:w.value,done:!1};return w=w.next,m}else return{value:void 0,done:!0}}};return f}entries(){const r=this,a=this._state;let w=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(w){const m={value:[w.key,w.value],done:!1};return w=w.next,m}else return{value:void 0,done:!0}}};return f}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,w=this.size;for(;a&&w>r;)this._map.delete(a.key),a=a.next,w--;this._head=a,this._size=w,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,w=r.previous;if(!a||!w)throw new Error("Invalid list");a.previous=w,w.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const w=r.next,f=r.previous;r===this._tail?(f.next=void 0,this._tail=f):(w.previous=f,f.next=w),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const w=r.next,f=r.previous;r===this._head?(w.previous=void 0,this._head=w):(w.previous=f,f.next=w),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,w)=>{r.push([w,a])}),r}fromJSON(r){this.clear();for(const[a,w]of r)this.set(a,w)}}e.LinkedMap=p;class C extends p{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=C;class i{constructor(r){I.set(this,void 0),Je(this,I,r,"f")}get size(){return Te(this,I,"f").size}forEach(r,a){Te(this,I,"f").forEach(r,a)}get(r){return Te(this,I,"f").get(r)}has(r){return Te(this,I,"f").has(r)}entries(){return Te(this,I,"f").entries()}keys(){return Te(this,I,"f").keys()}values(){return Te(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Te(this,I,"f").entries()}}e.ReadonlyMapView=i}),define(be[105],Ee([0,1,20,9]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...V){return function(oe,fe){for(let Ae=0,xe=V.length;Ae<xe;Ae++){const $e=V[Ae](oe,fe);if($e)return $e}return null}}e.or=_,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(V,oe,fe){if(!fe||fe.length<oe.length)return null;let Ae;return V?Ae=M.startsWithIgnoreCase(fe,oe):Ae=fe.indexOf(oe)===0,Ae?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(V,oe){const fe=oe.toLowerCase().indexOf(V.toLowerCase());return fe===-1?null:[{start:fe,end:fe+V.length}]}e.matchesContiguousSubString=R;function I(V,oe){return D(V.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=I;function D(V,oe,fe,Ae){if(fe===V.length)return[];if(Ae===oe.length)return null;if(V[fe]===oe[Ae]){let xe=null;return(xe=D(V,oe,fe+1,Ae+1))?k({start:Ae,end:Ae+1},xe):null}return D(V,oe,fe,Ae+1)}function P(V){return 97<=V&&V<=122}function t(V){return 65<=V&&V<=90}e.isUpper=t;function y(V){return 48<=V&&V<=57}function n(V){return V===32||V===9||V===10||V===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(V=>h.add(V.charCodeAt(0)));function s(V){return n(V)||h.has(V)}function d(V,oe){return V===oe||s(V)&&s(oe)}function v(V){return P(V)||t(V)||y(V)}function k(V,oe){return oe.length===0?oe=[V]:V.end===oe[0].start?oe[0].start=V.start:oe.unshift(V),oe}function E(V,oe){for(let fe=oe;fe<V.length;fe++){const Ae=V.charCodeAt(fe);if(t(Ae)||y(Ae)||fe>0&&!v(V.charCodeAt(fe-1)))return fe}return V.length}function o(V,oe,fe,Ae){if(fe===V.length)return[];if(Ae===oe.length)return null;if(V[fe]!==oe[Ae].toLowerCase())return null;{let xe=null,$e=Ae+1;for(xe=o(V,oe,fe+1,Ae+1);!xe&&($e=E(oe,$e))<oe.length;)xe=o(V,oe,fe+1,$e),$e++;return xe===null?null:k({start:Ae,end:Ae+1},xe)}}function p(V){let oe=0,fe=0,Ae=0,xe=0,$e=0;for(let he=0;he<V.length;he++)$e=V.charCodeAt(he),t($e)&&oe++,P($e)&&fe++,v($e)&&Ae++,y($e)&&xe++;const we=oe/V.length,Ze=fe/V.length,z=Ae/V.length,J=xe/V.length;return{upperPercent:we,lowerPercent:Ze,alphaPercent:z,numericPercent:J}}function C(V){const{upperPercent:oe,lowerPercent:fe}=V;return fe===0&&oe>.6}function i(V){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ae,numericPercent:xe}=V;return fe>.2&&oe<.8&&Ae>.6&&xe<.2}function l(V){let oe=0,fe=0,Ae=0,xe=0;for(let $e=0;$e<V.length;$e++)Ae=V.charCodeAt($e),t(Ae)&&oe++,P(Ae)&&fe++,n(Ae)&&xe++;return(oe===0||fe===0)&&xe===0?V.length<=30:oe<=5}function r(V,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!l(V)||oe.length>60)return null;const fe=p(oe);if(!i(fe)){if(!C(fe))return null;oe=oe.toLowerCase()}let Ae=null,xe=0;for(V=V.toLowerCase();xe<oe.length&&(Ae=o(V,oe,0,xe))===null;)xe=E(oe,xe+1);return Ae}e.matchesCamelCase=r;function a(V,oe,fe=!1){if(!oe||oe.length===0)return null;let Ae=null,xe=0;for(V=V.toLowerCase(),oe=oe.toLowerCase();xe<oe.length&&(Ae=w(V,oe,0,xe,fe))===null;)xe=f(oe,xe+1);return Ae}e.matchesWords=a;function w(V,oe,fe,Ae,xe){if(fe===V.length)return[];if(Ae===oe.length)return null;if(d(V.charCodeAt(fe),oe.charCodeAt(Ae))){let $e=null,we=Ae+1;if($e=w(V,oe,fe+1,Ae+1,xe),!xe)for(;!$e&&(we=f(oe,we))<oe.length;)$e=w(V,oe,fe+1,we,xe),we++;return $e===null?null:k({start:Ae,end:Ae+1},$e)}else return null}function f(V,oe){for(let fe=oe;fe<V.length;fe++)if(s(V.charCodeAt(fe))||fe>0&&s(V.charCodeAt(fe-1)))return fe;return V.length}const m=_(e.matchesPrefix,r,R),S=_(e.matchesPrefix,r,I),T=new c.LRUCache(1e4);function g(V,oe,fe=!1){if(typeof V!="string"||typeof oe!="string")return null;let Ae=T.get(V);Ae||(Ae=new RegExp(M.convertSimple2RegExpPattern(V),"i"),T.set(V,Ae));const xe=Ae.exec(oe);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?S(V,oe):m(V,oe)}e.matchesFuzzy=g;function b(V,oe){const fe=Qe(V,V.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return fe?F(fe):null}e.matchesFuzzy2=b;function u(V,oe,fe,Ae,xe,$e){const we=Math.min(13,V.length);for(;fe<we;fe++){const Ze=Qe(V,oe,fe,Ae,xe,$e,!1);if(Ze)return Ze}return[0,$e]}e.anyScore=u;function F(V){if(typeof V=="undefined")return[];const oe=[],fe=V[1];for(let Ae=V.length-1;Ae>1;Ae--){const xe=V[Ae]+fe,$e=oe[oe.length-1];$e&&$e.end===xe?$e.end=xe+1:oe.push({start:xe,end:xe+1})}return oe}e.createMatches=F;const O=128;function j(){const V=[],oe=[];for(let fe=0;fe<=O;fe++)oe[fe]=0;for(let fe=0;fe<=O;fe++)V.push(oe.slice(0));return V}function Q(V){const oe=[];for(let fe=0;fe<=V;fe++)oe[fe]=0;return oe}const W=Q(2*O),K=Q(2*O),$=j(),U=j(),H=j(),G=!1;function ue(V,oe,fe,Ae,xe){function $e(Ze,z,J=" "){for(;Ze.length<z;)Ze=J+Ze;return Ze}let we=` |   |${Ae.split("").map(Ze=>$e(Ze,3)).join("|")}
`;for(let Ze=0;Ze<=fe;Ze++)Ze===0?we+=" |":we+=`${oe[Ze-1]}|`,we+=V[Ze].slice(0,xe+1).map(z=>$e(z.toString(),3)).join("|")+`
`;return we}function q(V,oe,fe,Ae){V=V.substr(oe),fe=fe.substr(Ae),console.log(ue(U,V,V.length,fe,fe.length)),console.log(ue(H,V,V.length,fe,fe.length)),console.log(ue($,V,V.length,fe,fe.length))}function le(V,oe){if(oe<0||oe>=V.length)return!1;const fe=V.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(fe)}}function se(V,oe){if(oe<0||oe>=V.length)return!1;switch(V.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ve(V,oe,fe){return oe[V]!==fe[V]}function Fe(V,oe,fe,Ae,xe,$e,we=!1){for(;oe<fe&&xe<$e;)V[oe]===Ae[xe]&&(we&&(W[oe]=xe),oe+=1),xe+=1;return oe===fe}e.isPatternInWord=Fe;var Me;(function(V){V[V.Diag=1]="Diag",V[V.Left=2]="Left",V[V.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Ne;(function(V){V.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}V.isDefault=oe})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Qe(V,oe,fe,Ae,xe,$e,we){const Ze=V.length>O?O:V.length,z=Ae.length>O?O:Ae.length;if(fe>=Ze||$e>=z||Ze-fe>z-$e||!Fe(oe,fe,Ze,xe,$e,z,!0))return;ze(Ze,z,fe,$e,oe,xe);let J=1,he=1,Oe=fe,Ve=$e;const tt=[!1];for(J=1,Oe=fe;Oe<Ze;J++,Oe++){const dt=W[Oe],bt=K[Oe],ft=Oe+1<Ze?K[Oe+1]:z;for(he=dt-$e+1,Ve=dt;Ve<ft;he++,Ve++){let Et=Number.MIN_SAFE_INTEGER,Ye=!1;Ve<=bt&&(Et=qe(V,oe,Oe,fe,Ae,xe,Ve,z,$e,$[J-1][he-1]===0,tt));let Ct=0;Et!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Ct=Et+U[J-1][he-1]);const Pe=Ve>dt,ye=Pe?U[J][he-1]+($[J][he-1]>0?-5:0):0,De=Ve>dt+1&&$[J][he-1]>0,Z=De?U[J][he-2]+($[J][he-2]>0?-5:0):0;if(De&&(!Pe||Z>=ye)&&(!Ye||Z>=Ct))U[J][he]=Z,H[J][he]=3,$[J][he]=0;else if(Pe&&(!Ye||ye>=Ct))U[J][he]=ye,H[J][he]=2,$[J][he]=0;else if(Ye)U[J][he]=Ct,H[J][he]=1,$[J][he]=$[J-1][he-1]+1;else throw new Error("not possible")}}if(G&&q(V,fe,Ae,$e),!tt[0]&&!we)return;J--,he--;const ut=[U[J][he],$e];let ht=0,St=0;for(;J>=1;){let dt=he;do{const bt=H[J][dt];if(bt===3)dt=dt-2;else if(bt===2)dt=dt-1;else break}while(dt>=1);ht>1&&oe[fe+J-1]===xe[$e+he-1]&&!ve(dt+$e-1,Ae,xe)&&ht+1>$[J][dt]&&(dt=he),dt===he?ht++:ht=1,St||(St=dt),J--,he=dt-1,ut.push(he)}z===Ze&&(ut[0]+=2);const Pt=St-Ze;return ut[0]-=Pt,ut}e.fuzzyScore=Qe;function ze(V,oe,fe,Ae,xe,$e){let we=V-1,Ze=oe-1;for(;we>=fe&&Ze>=Ae;)xe[we]===$e[Ze]&&(K[we]=Ze,we--),Ze--}function qe(V,oe,fe,Ae,xe,$e,we,Ze,z,J,he){if(oe[fe]!==$e[we])return Number.MIN_SAFE_INTEGER;let Oe=1,Ve=!1;return we===fe-Ae?Oe=V[fe]===xe[we]?7:5:ve(we,xe,$e)&&(we===0||!ve(we-1,xe,$e))?(Oe=V[fe]===xe[we]?7:5,Ve=!0):le($e,we)&&(we===0||!le($e,we-1))?Oe=5:(le($e,we-1)||se($e,we-1))&&(Oe=5,Ve=!0),Oe>1&&fe===Ae&&(he[0]=!0),Ve||(Ve=ve(we,xe,$e)||le($e,we-1)||se($e,we-1)),fe===Ae?we>z&&(Oe-=Ve?3:5):J?Oe+=Ve?2:0:Oe+=Ve?0:1,we+1===Ze&&(Oe-=Ve?3:5),Oe}function x(V,oe,fe,Ae,xe,$e,we){return ee(V,oe,fe,Ae,xe,$e,!0,we)}e.fuzzyScoreGracefulAggressive=x;function Y(V,oe,fe,Ae,xe,$e,we){return ee(V,oe,fe,Ae,xe,$e,!1,we)}e.fuzzyScoreGraceful=Y;function ee(V,oe,fe,Ae,xe,$e,we,Ze){let z=Qe(V,oe,fe,Ae,xe,$e,Ze);if(z&&!we)return z;if(V.length>=3){const J=Math.min(7,V.length-1);for(let he=fe+1;he<J;he++){const Oe=ae(V,he);if(Oe){const Ve=Qe(Oe,Oe.toLowerCase(),fe,Ae,xe,$e,Ze);Ve&&(Ve[0]-=3,(!z||Ve[0]>z[0])&&(z=Ve))}}}return z}function ae(V,oe){if(oe+1>=V.length)return;const fe=V[oe],Ae=V[oe+1];if(fe!==Ae)return V.slice(0,oe)+Ae+fe+V.slice(oe+2)}}),define(be[106],Ee([0,1,34,105,9]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function I(d){return d.replace(R,(v,k)=>k?v:`\\${v}`)}e.escapeIcons=I;const D=new RegExp(`\\\\${A.source}`,"g");function P(d){return d.replace(D,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function y(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(t,(v,k,E,o)=>E?v:k||o||"")}e.stripIcons=y;function n(d){const v=d.indexOf(e.iconStartMarker);return v===-1?{text:d}:h(d,v)}e.parseLabelWithIcons=n;function h(d,v){const k=[];let E="";function o(f){if(f){E+=f;for(const m of f)k.push(i)}}let p=-1,C="",i=0,l,r,a=v;const w=d.length;for(o(d.substr(0,v));a<w;)l=d[a],r=d[a+1],l===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(p=a,o(C),C=e.iconStartMarker,a++):l===")"&&p!==-1?(i+=a-p+1,p=-1,C=""):p!==-1?/^[a-z0-9\-]$/i.test(l)?C+=l:(o(C),p=-1,C=""):o(l),a++;return o(C),{text:E,iconOffsets:k}}function s(d,v,k=!1){const{text:E,iconOffsets:o}=v;if(!o||o.length===0)return(0,M.matchesFuzzy)(d,E,k);const p=(0,_.ltrim)(E," "),C=E.length-p.length,i=(0,M.matchesFuzzy)(d,p,k);if(i)for(const l of i){const r=o[l.start+C]+C;l.start+=r,l.end+=r}return i}e.matchesFuzzyIconAware=s}),define(be[76],Ee([0,1,16,106]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(h="",s=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(h,s=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(h):h).replace(/([ \t]+)/g,(d,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,s){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=A;function R(n){return I(n)?!n.value:Array.isArray(n)?n.every(R):!0}e.isEmptyMarkdownString=R;function I(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function D(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=D;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function y(n){const h=[],s=n.split("|").map(v=>v.trim());n=s[0];const d=s[1];if(d){const v=/height=(\d+)/.exec(d),k=/width=(\d+)/.exec(d),E=v?v[1]:"",o=k?k[1]:"",p=isFinite(parseInt(o)),C=isFinite(parseInt(E));p&&h.push(`width="${o}"`),C&&h.push(`height="${E}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=y}),define(be[54],Ee([0,1,23,9,2]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,D)}e.stringify=A;function R(t){let y=JSON.parse(t);return y=P(y),y}e.parse=R;var I;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function D(t,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,M.regExpFlags)(y)}:y}function P(t,y=0){if(!t||y>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return _.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof c.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],y+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],y+1))}return t}e.revive=P}),define(be[11],Ee([0,1,26,2]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var _;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(_=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,t){this._hosts[D]=P,this._ports[D]=t}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const y=this._ports[P],n=this._connectionTokens[P];let h=`path=${encodeURIComponent(D.path)}`;return typeof n=="string"&&(h+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:c.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${t}:${y}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new A;class R{asBrowserUri(D,P){const t=this.toUri(D,P);return t.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===_.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${_.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?t.with({scheme:_.vscodeFileResource,authority:t.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(D,P){const t=this.toUri(D,P);return t.scheme===_.vscodeFileResource?t.with({scheme:_.file,authority:t.authority!==R.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(D,P){return M.URI.isUri(D)?D:M.URI.parse(P.toUrl(D))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(be[24],Ee([0,1,41,11,17,26,9,2]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,I.uriToFsPath)(h,!0)}e.originalFSPath=D;class P{constructor(s){this._ignorePathCasing=s}compare(s,d,v=!1){return s===d?0:(0,R.compare)(this.getComparisonKey(s,v),this.getComparisonKey(d,v))}isEqual(s,d,v=!1){return s===d?!0:!s||!d?!1:this.getComparisonKey(s,v)===this.getComparisonKey(d,v)}getComparisonKey(s,d=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,d,v=!1){if(s.scheme===d.scheme){if(s.scheme===M.Schemas.file)return c.isEqualOrParent(D(s),D(d),this._ignorePathCasing(s))&&s.query===d.query&&(v||s.fragment===d.fragment);if((0,e.isEqualAuthority)(s.authority,d.authority))return c.isEqualOrParent(s.path,d.path,this._ignorePathCasing(s),"/")&&s.query===d.query&&(v||s.fragment===d.fragment)}return!1}joinPath(s,...d){return I.URI.joinPath(s,...d)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return _.posix.basename(s.path)}extname(s){return _.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let d;return s.scheme===M.Schemas.file?d=I.URI.file(_.dirname(D(s))).path:(d=_.posix.dirname(s.path),s.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),d="/")),s.with({path:d})}normalizePath(s){if(!s.path.length)return s;let d;return s.scheme===M.Schemas.file?d=I.URI.file(_.normalize(D(s))).path:d=_.posix.normalize(s.path),s.with({path:d})}relativePath(s,d){if(s.scheme!==d.scheme||!(0,e.isEqualAuthority)(s.authority,d.authority))return;if(s.scheme===M.Schemas.file){const E=_.relative(D(s),D(d));return A.isWindows?c.toSlashes(E):E}let v=s.path||"/",k=d.path||"/";if(this._ignorePathCasing(s)){let E=0;for(const o=Math.min(v.length,k.length);E<o&&!(v.charCodeAt(E)!==k.charCodeAt(E)&&v.charAt(E).toLowerCase()!==k.charAt(E).toLowerCase());E++);v=k.substr(0,E)+v.substr(E)}return _.posix.relative(v,k)}resolvePath(s,d){if(s.scheme===M.Schemas.file){const v=I.URI.file(_.resolve(D(s),d));return s.with({authority:v.authority,path:v.path})}return d=c.toPosixPath(d),s.with({path:_.posix.resolve(s.path,d)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,d){return s===d||(0,R.equalsIgnoreCase)(s,d)}hasTrailingPathSeparator(s,d=_.sep){if(s.scheme===M.Schemas.file){const v=D(s);return v.length>c.getRoot(v).length&&v[v.length-1]===d}else{const v=s.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,d=_.sep){return(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,d=_.sep){let v=!1;if(s.scheme===M.Schemas.file){const k=D(s);v=k!==void 0&&k.length===c.getRoot(k).length&&k[k.length-1]===d}else{d="/";const k=s.path;v=k.length===1&&k.charCodeAt(k.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path+"/"}):s}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(h=>h.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(h,s){const d=[];for(let v=0;v<h.length;v++){const k=s(h[v]);h.some((E,o)=>o===v?!1:(0,e.isEqualOrParent)(k,s(E)))||d.push(h[v])}return d}e.distinctParents=t;var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function s(d){const v=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(o=>{const[p,C]=o.split(":");p&&C&&v.set(p,C)});const E=d.path.substring(0,d.path.indexOf(";"));return E&&v.set(h.META_DATA_MIME,E),v}h.parseMetaData=s})(y=e.DataUri||(e.DataUri={}));function n(h,s,d){if(s){let v=h.path;return v&&v[0]!==_.posix.sep&&(v=_.posix.sep+v),h.with({scheme:d,authority:s,path:v})}return h.with({scheme:d})}e.toLocalResource=n}),define(be[14],Ee([0,1,21,16,3,6,24]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I($){return!!$&&typeof $.then=="function"}e.isThenable=I;function D($){const U=new c.CancellationTokenSource,H=$(U.token),G=new Promise((ue,q)=>{const le=U.token.onCancellationRequested(()=>{le.dispose(),U.dispose(),q((0,M.canceled)())});Promise.resolve(H).then(se=>{le.dispose(),U.dispose(),ue(se)},se=>{le.dispose(),U.dispose(),q(se)})});return new class{cancel(){U.cancel()}then(ue,q){return G.then(ue,q)}catch(ue){return this.then(void 0,ue)}finally(ue){return G.finally(ue)}}}e.createCancelablePromise=D;function P($,U,H){return Promise.race([$,new Promise(G=>U.onCancellationRequested(()=>G(H)))])}e.raceCancellation=P;async function t($){let U=-1;const H=$.map((ue,q)=>ue.then(le=>(U=q,le))),G=await Promise.race(H);return $.forEach((ue,q)=>{q!==U&&ue.cancel()}),G}e.raceCancellablePromises=t;function y($,U,H){let G;const ue=setTimeout(()=>{G?.(void 0),H?.()},U);return Promise.race([$.finally(()=>clearTimeout(ue)),new Promise(q=>G=q)])}e.raceTimeout=y;function n($){return new Promise((U,H)=>{const G=$();I(G)?G.then(U,H):U(G)})}e.asPromise=n;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(H,H).then(G)})}return new Promise((H,G)=>{this.queuedPromise.then(H,G)})}return this.activePromise=U(),new Promise((H,G)=>{this.activePromise.then(ue=>{this.activePromise=null,H(ue)},ue=>{this.activePromise=null,G(ue)})})}}e.Throttler=h;class s{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=s;class d{constructor(){this.promiseMap=new Map}queue(U,H){const ue=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(U)===ue&&this.promiseMap.delete(U)});return this.promiseMap.set(U,ue),ue}}e.SequencerByKey=d;class v{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,H=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,ue)=>{this.doResolve=G,this.doReject=ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class k{constructor(U){this.delayer=new v(U),this.throttler=new h}trigger(U,H){return this.delayer.trigger(()=>this.throttler.queue(U),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=k;class E{constructor(){this._isOpen=!1,this._promise=new Promise((U,H)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class o extends E{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function p($,U){return U?new Promise((H,G)=>{const ue=setTimeout(()=>{q.dispose(),H()},$),q=U.onCancellationRequested(()=>{clearTimeout(ue),q.dispose(),G((0,M.canceled)())})}):D(H=>p($,H))}e.timeout=p;function C($,U=0){const H=setTimeout($,U);return(0,A.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=C;function i($){const U=[];let H=0;const G=$.length;function ue(){return H<G?$[H++]():null}function q(le){le!=null&&U.push(le);const se=ue();return se?se.then(q):Promise.resolve(U)}return Promise.resolve(null).then(q)}e.sequence=i;function l($,U=G=>!!G,H=null){let G=0;const ue=$.length,q=()=>{if(G>=ue)return Promise.resolve(H);const le=$[G++];return Promise.resolve(le()).then(ve=>U(ve)?Promise.resolve(ve):q())};return q()}e.first=l;function r($,U=G=>!!G,H=null){if($.length===0)return Promise.resolve(H);let G=$.length;const ue=()=>{G=-1;for(const q of $)q.cancel?.()};return new Promise((q,le)=>{for(const se of $)se.then(ve=>{--G>=0&&U(ve)?(ue(),q(ve)):G===0&&q(H)}).catch(ve=>{--G>=0&&(ue(),le(ve))})})}e.firstParallel=r;class a{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((H,G)=>{this.outstandingPromises.push({factory:U,c:H,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const H=U.factory();H.then(U.c,U.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class w extends a{constructor(){super(1)}}e.Queue=w;class f{constructor(){this.queues=new Map}queueFor(U,H=R.extUri){const G=H.getComparisonKey(U);let ue=this.queues.get(G);return ue||(ue=new w,_.Event.once(ue.onFinished)(()=>{ue?.dispose(),this.queues.delete(G)}),this.queues.set(G,ue)),ue}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=f;class m{constructor(U,H){this._token=-1,typeof U=="function"&&typeof H=="number"&&this.setIfNotSet(U,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},H)}setIfNotSet(U,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},H))}}e.TimeoutTimer=m;class S{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,H){this.cancel(),this._token=setInterval(()=>{U()},H)}}e.IntervalTimer=S;class T{constructor(U,H){this.timeoutToken=-1,this.runner=U,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class g{constructor(U,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class b extends T{constructor(U,H){super(U,H);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=b;class u extends A.Disposable{constructor(U,H,G,ue){super();this.maxWorkChunkSize=U,this.maxPendingWork=H,this.throttleDelay=G,this.handler=ue,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=u,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const H=setTimeout(()=>U($));let G=!1;return{dispose(){G||(G=!0,clearTimeout(H))}}}}else e.runWhenIdle=($,U)=>{const H=requestIdleCallback($,typeof U=="number"?{timeout:U}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(H))}}}}();class F{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function O($,U,H){let G;for(let ue=0;ue<H;ue++)try{return await $()}catch(q){G=q,await p(U)}throw G}e.retry=O;class j{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,H,G){return this._pending={taskId:U,cancel:()=>G?.(),promise:H},H.then(()=>this.donePending(U),()=>this.donePending(U)),H}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let H,G;const ue=new Promise((q,le)=>{H=q,G=le});this._next={run:U,promise:ue,promiseResolve:H,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=j;class Q{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,H)=>{this.completeCallback=U,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(H=>{this.completeCallback(U),this.resolved=!0,H()})}error(U){return new Promise(H=>{this.errorCallback(U),this.rejected=!0,H()})}cancel(){new Promise(U=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=W;var K;(function($){async function U(H){let G;const ue=await Promise.all(H.map(q=>q.then(le=>le,le=>{G||(G=le)})));if(typeof G!="undefined")throw G;return ue}$.settled=U})(K=e.Promises||(e.Promises={}))}),define(be[107],Ee([0,1,14,17]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new c.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(T,g,b=!1){const u=T||"",F=g||"",O=_.value.collator.compare(u,F);return _.value.collatorIsNumeric&&O===0&&u!==F?u<F?-1:1:O}e.compareFileNames=I;function D(T,g){const b=A.value.collator;return T=T||"",g=g||"",C(b,T,g)}e.compareFileNamesDefault=D;function P(T,g){const b=A.value.collator;return T=T||"",g=g||"",a(T,g)||C(b,T,g)}e.compareFileNamesUpper=P;function t(T,g){const b=A.value.collator;return T=T||"",g=g||"",r(T,g)||C(b,T,g)}e.compareFileNamesLower=t;function y(T,g){return T=T||"",g=g||"",T===g?0:T<g?-1:1}e.compareFileNamesUnicode=y;function n(T,g,b=!1){b||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase());const[u,F]=o(T),[O,j]=o(g);return u!==O?u<O?-1:1:F===j?0:F<j?-1:1}e.noIntlCompareFileNames=n;function h(T,g){const[b,u]=o(T),[F,O]=o(g);let j=_.value.collator.compare(u,O);if(j===0){if(_.value.collatorIsNumeric&&u!==O)return u<O?-1:1;if(j=_.value.collator.compare(b,F),_.value.collatorIsNumeric&&j===0&&b!==F)return b<F?-1:1}return j}e.compareFileExtensions=h;function s(T,g){T=T||"",g=g||"";const b=p(T),u=p(g),F=A.value.collator,O=R.value.collator;return C(O,b,u)||C(F,T,g)}e.compareFileExtensionsDefault=s;function d(T,g){T=T||"",g=g||"";const b=p(T),u=p(g),F=A.value.collator,O=R.value.collator;return C(O,b,u)||a(T,g)||C(F,T,g)}e.compareFileExtensionsUpper=d;function v(T,g){T=T||"",g=g||"";const b=p(T),u=p(g),F=A.value.collator,O=R.value.collator;return C(O,b,u)||r(T,g)||C(F,T,g)}e.compareFileExtensionsLower=v;function k(T,g){T=T||"",g=g||"";const b=p(T).toLowerCase(),u=p(g).toLowerCase();return b!==u?b<u?-1:1:T!==g?T<g?-1:1:0}e.compareFileExtensionsUnicode=k;const E=/^(.*?)(\.([^.]*))?$/;function o(T,g=!1){const b=T?E.exec(T):[];let u=[b&&b[1]||"",b&&b[3]||""];return g&&(!u[0]&&u[1]||u[0]&&u[0].charAt(0)===".")&&(u=[u[0]+"."+u[1],""]),u}function p(T){const g=T?E.exec(T):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function C(T,g,b){let u=T.compare(g,b);return u!==0?u:g.length!==b.length?g.length<b.length?-1:1:0}function i(T){const g=T.charAt(0);return g.toLocaleUpperCase()!==g}function l(T){const g=T.charAt(0);return g.toLocaleLowerCase()!==g}function r(T,g){return i(T)&&l(g)?-1:l(T)&&i(g)?1:0}function a(T,g){return l(T)&&i(g)?-1:i(T)&&l(g)?1:0}function w(T,g,b=!1){return b||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase()),T===g?0:T<g?-1:1}function f(T,g,b=!1){const u=T.split(M.sep),F=g.split(M.sep),O=u.length-1,j=F.length-1;let Q,W;for(let K=0;;K++){if(Q=O===K,W=j===K,Q&&W)return I(u[K],F[K],b);if(Q)return-1;if(W)return 1;const $=w(u[K],F[K],b);if($!==0)return $}}e.comparePaths=f;function m(T,g,b){const u=T.toLowerCase(),F=g.toLowerCase(),O=S(T,g,b);if(O)return O;const j=u.endsWith(b),Q=F.endsWith(b);if(j!==Q)return j?-1:1;const W=I(u,F);return W!==0?W:u.localeCompare(F)}e.compareAnything=m;function S(T,g,b){const u=T.toLowerCase(),F=g.toLowerCase(),O=u.startsWith(b),j=F.startsWith(b);if(O!==j)return O?-1:1;if(O&&j){if(u.length<F.length)return-1;if(u.length>F.length)return 1}return 0}e.compareByPrefix=S}),define(be[27],Ee([0,1,14,41,20,17,9]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const D="**",P="/",t="[/\\\\]",y="[^/\\\\]",n=/\//g;function h(G){switch(G){case 0:return"";case 1:return`${y}*?`;default:return`(?:${t}|${y}+${t}|${t}${y}+)*?`}}function s(G,ue){if(!G)return[];const q=[];let le=!1,se=!1,ve="";for(const Fe of G){switch(Fe){case ue:if(!le&&!se){q.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":se=!0;break;case"]":se=!1;break}ve+=Fe}return ve&&q.push(ve),q}e.splitGlobAware=s;function d(G){if(!G)return"";let ue="";const q=s(G,P);if(q.every(le=>le===D))ue=".*";else{let le=!1;q.forEach((se,ve)=>{if(se===D){le||(ue+=h(2),le=!0);return}let Fe=!1,Me="",Ne=!1,Qe="";for(const ze of se){if(ze!=="}"&&Fe){Me+=ze;continue}if(Ne&&(ze!=="]"||!Qe)){let qe;ze==="-"?qe=ze:(ze==="^"||ze==="!")&&!Qe?qe="^":ze===P?qe="":qe=R.escapeRegExpCharacters(ze),Qe+=qe;continue}switch(ze){case"{":Fe=!0;continue;case"[":Ne=!0;continue;case"}":ue+=`(?:${s(Me,",").map(Y=>d(Y)).join("|")})`,Fe=!1,Me="";break;case"]":ue+="["+Qe+"]",Ne=!1,Qe="";break;case"?":ue+=y;continue;case"*":ue+=h(1);continue;default:ue+=R.escapeRegExpCharacters(ze)}}ve<q.length-1&&(q[ve+1]!==D||ve+2<q.length)&&(ue+=t),le=!1})}return ue}const v=/^\*\*\/\*\.[\w\.-]+$/,k=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new _.LRUCache(1e4),l=function(){return!1},r=function(){return null};function a(G,ue){if(!G)return r;let q;typeof G!="string"?q=G.pattern:q=G,q=q.trim();const le=`${q}_${!!ue.trimForExclusions}`;let se=i.get(le);if(se)return w(se,G);let ve;if(v.test(q)){const Fe=q.substr(4);se=function(Me,Ne){return typeof Me=="string"&&Me.endsWith(Fe)?q:null}}else(ve=k.exec(f(q,ue)))?se=m(ve[1],q):(ue.trimForExclusions?o:E).test(q)?se=S(q,ue):(ve=p.exec(f(q,ue)))?se=T(ve[1].substr(1),q,!0):(ve=C.exec(f(q,ue)))?se=T(ve[1],q,!1):se=g(q);return i.set(le,se),w(se,G)}function w(G,ue){return typeof ue=="string"?G:function(q,le){return M.isEqualOrParent(q,ue.base)?G(A.relative(ue.base,q),le):null}}function f(G,ue){return ue.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function m(G,ue){const q=`/${G}`,le=`\\${G}`,se=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===G?ue:null:Fe===G||Fe.endsWith(q)||Fe.endsWith(le)?ue:null},ve=[G];return se.basenames=ve,se.patterns=[ue],se.allBasenames=ve,se}function S(G,ue){const q=H(G.slice(1,-1).split(",").map(Me=>a(Me,ue)).filter(Me=>Me!==r),G),le=q.length;if(!le)return r;if(le===1)return q[0];const se=function(Me,Ne){for(let Qe=0,ze=q.length;Qe<ze;Qe++)if(q[Qe](Me,Ne))return G;return null},ve=q.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=q.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function T(G,ue,q){const le=A.sep===A.posix.sep,se=le?G:G.replace(n,A.sep),ve=A.sep+se,Fe=A.posix.sep+G,Me=q?function(Ne,Qe){return typeof Ne=="string"&&(Ne===se||Ne.endsWith(ve)||!le&&(Ne===G||Ne.endsWith(Fe)))?ue:null}:function(Ne,Qe){return typeof Ne=="string"&&(Ne===se||!le&&Ne===G)?ue:null};return Me.allPaths=[(q?"*/":"./")+G],Me}function g(G){try{const ue=new RegExp(`^${d(G)}$`);return function(q){return ue.lastIndex=0,typeof q=="string"&&ue.test(q)?G:null}}catch(ue){return r}}function b(G,ue,q){return!G||typeof ue!="string"?!1:u(G)(ue,void 0,q)}e.match=b;function u(G,ue={}){if(!G)return l;if(typeof G=="string"||Q(G)){const q=a(G,ue);if(q===r)return l;const le=function(se,ve){return!!q(se,ve)};return q.allBasenames&&(le.allBasenames=q.allBasenames),q.allPaths&&(le.allPaths=q.allPaths),le}return $(G,ue)}e.parse=u;function F(G){if(!G)return;let ue;return q=>(ue||(ue=(G()||Promise.resolve([])).then(le=>le?j(le):{})),ue.then(le=>!!le[q]))}e.hasSiblingPromiseFn=F;function O(G){if(!G)return;let ue;return q=>{if(!ue){const le=G();ue=le?j(le):{}}return!!ue[q]}}e.hasSiblingFn=O;function j(G){const ue={};for(const q of G)ue[q]=!0;return ue}function Q(G){const ue=G;return ue&&typeof ue.base=="string"&&typeof ue.pattern=="string"}e.isRelativePattern=Q;function W(G){return G.allBasenames||[]}e.getBasenameTerms=W;function K(G){return G.allPaths||[]}e.getPathTerms=K;function $(G,ue){const q=H(Object.getOwnPropertyNames(G).map(Me=>U(Me,G[Me],ue)).filter(Me=>Me!==r)),le=q.length;if(!le)return r;if(!q.some(Me=>!!Me.requiresSiblings)){if(le===1)return q[0];const Me=function(ze,qe){for(let x=0,Y=q.length;x<Y;x++){const ee=q[x](ze,qe);if(ee)return ee}return null},Ne=q.find(ze=>!!ze.allBasenames);Ne&&(Me.allBasenames=Ne.allBasenames);const Qe=q.reduce((ze,qe)=>qe.allPaths?ze.concat(qe.allPaths):ze,[]);return Qe.length&&(Me.allPaths=Qe),Me}const se=function(Me,Ne,Qe){let ze;for(let qe=0,x=q.length;qe<x;qe++){const Y=q[qe];Y.requiresSiblings&&Qe&&(Ne||(Ne=A.basename(Me)),ze||(ze=Ne.substr(0,Ne.length-A.extname(Me).length)));const ee=Y(Me,Ne,ze,Qe);if(ee)return ee}return null},ve=q.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=q.reduce((Me,Ne)=>Ne.allPaths?Me.concat(Ne.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function U(G,ue,q){if(ue===!1)return r;const le=a(G,q);if(le===r)return r;if(typeof ue=="boolean")return le;if(ue){const se=ue.when;if(typeof se=="string"){const ve=(Fe,Me,Ne,Qe)=>{if(!Qe||!le(Fe,Me))return null;const ze=se.replace("$(basename)",Ne),qe=Qe(ze);return(0,c.isThenable)(qe)?qe.then(x=>x?G:null):qe?G:null};return ve.requiresSiblings=!0,ve}}return le}function H(G,ue){const q=G.filter(Me=>!!Me.basenames);if(q.length<2)return G;const le=q.reduce((Me,Ne)=>{const Qe=Ne.basenames;return Qe?Me.concat(Qe):Me},[]);let se;if(ue){se=[];for(let Me=0,Ne=le.length;Me<Ne;Me++)se.push(ue)}else se=q.reduce((Me,Ne)=>{const Qe=Ne.patterns;return Qe?Me.concat(Qe):Me},[]);const ve=function(Me,Ne){if(typeof Me!="string")return null;if(!Ne){let ze;for(ze=Me.length;ze>0;ze--){const qe=Me.charCodeAt(ze-1);if(qe===47||qe===92)break}Ne=Me.substr(ze)}const Qe=le.indexOf(Ne);return Qe!==-1?se[Qe]:null};ve.basenames=le,ve.patterns=se,ve.allBasenames=le;const Fe=G.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(be[77],Ee([0,1,41,11,17,26,24,9,2]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(a,w,f){if(typeof a=="string"&&(a=D.URI.file(a)),f){const S=f.getWorkspaceFolder(a);if(S){const T=f.getWorkspace().folders.length>1;let g;if((0,R.isEqual)(S.uri,a)?g="":g=(0,R.relativePath)(S.uri,a),T){const b=S.name?S.name:(0,R.basename)(S.uri);g=g?b+" \u2022 "+g:b}return g}}if(a.scheme!==M.Schemas.file&&a.scheme!==M.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(a.fsPath))return(0,_.normalize)(y(a.fsPath));let m=(0,_.normalize)(a.fsPath);return!A.isWindows&&w?.userHome&&(m=h(m,w.userHome.fsPath)),m}e.getPathLabel=P;function t(a){if(!a)return;typeof a=="string"&&(a=D.URI.file(a));const w=(0,R.basename)(a)||(a.scheme===M.Schemas.file?a.fsPath:a.path);return A.isWindows&&(0,c.isRootOrDriveLetter)(w)?y(w):w}e.getBaseLabel=t;function y(a){return(0,c.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=y;let n=Object.create(null);function h(a,w){if(A.isWindows||!a||!w)return a;let f=n.original===w?n.normalized:void 0;return f||(f=`${(0,I.rtrim)(w,_.posix.sep)}${_.posix.sep}`,n={original:w,normalized:f}),(A.isLinux?a.startsWith(f):(0,I.startsWithIgnoreCase)(a,f))&&(a=`~/${a.substr(f.length)}`),a}e.tildify=h;function s(a,w){return a.replace(/^~($|\/|\\)/,`${w}$1`)}e.untildify=s;const d="\u2026",v="\\\\",k="~";function E(a,w=_.sep){const f=new Array(a.length);let m=!1;for(let S=0;S<a.length;S++){let T=a[S];if(T===""){f[S]=`.${w}`;continue}if(!T){f[S]=T;continue}m=!0;let g="";T.indexOf(v)===0?(g=T.substr(0,T.indexOf(v)+v.length),T=T.substr(T.indexOf(v)+v.length)):T.indexOf(w)===0?(g=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length)):T.indexOf(k)===0&&(g=T.substr(0,T.indexOf(k)+k.length),T=T.substr(T.indexOf(k)+k.length));const b=T.split(w);for(let u=1;m&&u<=b.length;u++)for(let F=b.length-u;m&&F>=0;F--){m=!1;let O=b.slice(F,F+u).join(w);for(let j=0;!m&&j<a.length;j++)if(j!==S&&a[j]&&a[j].indexOf(O)>-1){const Q=F+u===b.length,W=F>0&&a[j].indexOf(w)>-1?w+O:O,K=a[j].endsWith(W);m=!Q||K}if(!m){let j="";(b[0].endsWith(":")||g!=="")&&(F===1&&(F=0,u++,O=b[0]+w+O),F>0&&(j=b[0]+w),j=g+j),F>0&&(j=j+d+w),j=j+O,F+u<b.length&&(j=j+w+d),f[S]=j}}m&&(f[S]=T)}return f}e.shorten=E;var o;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function p(a,w=Object.create(null)){const f=[];let m=!1,S="";for(const T of a)if(T==="$"||m&&T==="{")S&&f.push({value:S,type:o.TEXT}),S="",m=!0;else if(T==="}"&&m){const g=w[S];if(typeof g=="string")g.length&&f.push({value:g,type:o.VARIABLE});else if(g){const b=f[f.length-1];(!b||b.type!==o.SEPARATOR)&&f.push({value:g.label,type:o.SEPARATOR})}S="",m=!1}else S+=T;return S&&!m&&f.push({value:S,type:o.TEXT}),f.filter((T,g)=>{if(T.type===o.SEPARATOR){const b=f[g-1],u=f[g+1];return[b,u].every(F=>F&&(F.type===o.VARIABLE||F.type===o.TEXT)&&F.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=p;function C(a,w){return A.isMacintosh||w?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function i(a,w){return A.isMacintosh||w?a.replace(/\(&&\w\)|&&/g,""):A.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function l(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=l;function r(a){const w=a.indexOf("/")!==-1?_.posix:_.win32,f=w.basename(a),m=w.dirname(a);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=r}),define(be[78],Ee([0,1,27,11,17,24,9]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(a){a.text="text/plain",a.binary="application/octet-stream",a.unknown="application/unknown",a.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let D=[],P=[],t=[];function y(a,w=!1){const f=n(a);D.push(f),f.userConfigured?t.push(f):P.push(f),w&&!f.userConfigured&&D.forEach(m=>{m.mime===f.mime||m.userConfigured||(f.extension&&m.extension===f.extension&&console.warn(`Overwriting extension <<${f.extension}>> to now point to mime <<${f.mime}>>`),f.filename&&m.filename===f.filename&&console.warn(`Overwriting filename <<${f.filename}>> to now point to mime <<${f.mime}>>`),f.filepattern&&m.filepattern===f.filepattern&&console.warn(`Overwriting filepattern <<${f.filepattern}>> to now point to mime <<${f.mime}>>`),f.firstline&&m.firstline===f.firstline&&console.warn(`Overwriting firstline <<${f.firstline}>> to now point to mime <<${f.mime}>>`))})}e.registerTextMime=y;function n(a){return{id:a.id,mime:a.mime,filename:a.filename,extension:a.extension,filepattern:a.filepattern,firstline:a.firstline,userConfigured:a.userConfigured,filenameLowercase:a.filename?a.filename.toLowerCase():void 0,extensionLowercase:a.extension?a.extension.toLowerCase():void 0,filepatternLowercase:a.filepattern?(0,c.parse)(a.filepattern.toLowerCase()):void 0,filepatternOnPath:a.filepattern?a.filepattern.indexOf(_.posix.sep)>=0:!1}}function h(a){a?(D=D.filter(w=>!w.userConfigured),t=[]):(D=[],P=[],t=[])}e.clearTextMimes=h;function s(a,w){let f;if(a)switch(a.scheme){case M.Schemas.file:f=a.fsPath;break;case M.Schemas.data:f=A.DataUri.parseMetaData(a).get(A.DataUri.META_DATA_LABEL);break;default:f=a.path}if(!f)return[I.unknown];f=f.toLowerCase();const m=(0,_.basename)(f),S=d(f,m,t);if(S)return[S,I.text];const T=d(f,m,P);if(T)return[T,I.text];if(w){const g=v(w);if(g)return[g,I.text]}return[I.unknown]}e.guessMimeTypes=s;function d(a,w,f){let m=null,S=null,T=null;for(let g=f.length-1;g>=0;g--){const b=f[g];if(w===b.filenameLowercase){m=b;break}if(b.filepattern&&(!S||b.filepattern.length>S.filepattern.length)){const u=b.filepatternOnPath?a:w;b.filepatternLowercase?.(u)&&(S=b)}b.extension&&(!T||b.extension.length>T.extension.length)&&w.endsWith(b.extensionLowercase)&&(T=b)}return m?m.mime:S?S.mime:T?T.mime:null}function v(a){if((0,R.startsWithUTF8BOM)(a)&&(a=a.substr(1)),a.length>0)for(let w=D.length-1;w>=0;w--){const f=D[w];if(!f.firstline)continue;const m=a.match(f.firstline);if(m&&m.length>0)return f.mime}return null}function k(a){return a?typeof a=="string"?a===I.binary||a===I.text||a===I.unknown:a.length===1&&k(a[0]):!0}e.isUnspecific=k;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(a){const w=(0,_.extname)(a),f=E[w.toLowerCase()];return f!==void 0?f:C(a)}e.getMediaOrTextMime=p;function C(a){const w=(0,_.extname)(a);return o[w.toLowerCase()]}e.getMediaMime=C;function i(a){for(const w in o)if(o[w]===a)return w}e.getExtensionForMimeType=i;const l=/^(.+)\/(.+?)(;.+)?$/;function r(a,w){const f=l.exec(a);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:w?void 0:a}e.normalizeMimeType=r}),define(be[108],Ee([0,1,2]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class _{constructor(y){this._uriTransformer=y}transformIncoming(y){const n=this._uriTransformer.transformIncoming(y);return n===y?y:M(c.URI.from(n))}transformOutgoing(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:M(c.URI.from(n))}transformOutgoingURI(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:c.URI.from(n)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,y,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof c.URI)return y.transformOutgoing(t);for(let h in t)if(Object.hasOwnProperty.call(t,h)){const s=A(t[h],y,n+1);s!==null&&(t[h]=s)}}return null}function R(t,y){const n=A(t,y,0);return n===null?t:n}e.transformOutgoingURIs=R;function I(t,y,n,h){if(!t||h>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?c.URI.revive(y.transformIncoming(t)):y.transformIncoming(t);for(let s in t)if(Object.hasOwnProperty.call(t,s)){const d=I(t[s],y,n,h+1);d!==null&&(t[s]=d)}}return null}function D(t,y){const n=I(t,y,!1,0);return n===null?t:n}e.transformIncomingURIs=D;function P(t,y){const n=I(t,y,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(be[36],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(D){return c.test(D)}e.isUUID=M;const _=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function I(){R(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let D=0,P="";return P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+="-",P+=A[_[D++]],P+=A[_[D++]],P+="-",P+=A[_[D++]],P+=A[_[D++]],P+="-",P+=A[_[D++]],P+=A[_[D++]],P+="-",P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P+=A[_[D++]],P}e.generateUuid=I}),define(be[109],Ee([0,1,226]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class _ extends c.CharacterClassifier{constructor(I){super(0);for(let D=0,P=I.length;D<P;D++)this.set(I.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=_;function A(R){let I={};return D=>(I.hasOwnProperty(D)||(I[D]=R(D)),I[D])}e.getMapForWordSeparators=A(R=>new _(R))}),define(be[79],Ee([0,1,22]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var _;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(_=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class P{constructor(v,k){this._findMatchBrand=void 0,this.range=v,this.matches=k}}e.FindMatch=P;var t;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None"})(y=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class h{constructor(v,k,E,o,p,C){this.identifier=v,this.range=k,this.text=E,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=p,this._isTracked=C}}e.ValidAnnotatedEditOperation=h;class s{constructor(v,k,E){this.reverseEdits=v,this.changes=k,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=s}),define(be[110],Ee([0,1,9,109,111,42,79]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class D{constructor(o,p,C,i){this.searchString=o,this.isRegex=p,this.matchCase=C,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=P(this.searchString):o=this.searchString.indexOf(`
`)>=0;let p=null;try{p=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(i){return null}if(!p)return null;let C=!this.isRegex&&!o;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new t(p,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}e.SearchParams=D;function P(E){if(!E||E.length===0)return!1;for(let o=0,p=E.length;o<p;o++)if(E.charCodeAt(o)===92){if(o++,o>=p)break;const i=E.charCodeAt(o);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(o,p,C){this.regex=o,this.wordSeparators=p,this.simpleSearch=C}}e.SearchData=t;function y(E,o,p){if(!p)return new R.FindMatch(E,null);let C=[];for(let i=0,l=o.length;i<l;i++)C[i]=o[i];return new R.FindMatch(E,C)}e.createFindMatch=y;class n{constructor(o){let p=[],C=0;for(let i=0,l=o.length;i<l;i++)o.charCodeAt(i)===10&&(p[C++]=i);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(o){const p=this._lineFeedsOffsets;let C=0,i=p.length-1;if(i===-1||o<=p[0])return 0;for(;C<i;){const l=C+((i-C)/2>>0);p[l]>=o?i=l-1:p[l+1]>=o?(C=l,i=l):C=l+1}return C+1}}class h{static findMatches(o,p,C,i,l){const r=p.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(o,C,new k(r.wordSeparators,r.regex),i,l):this._doFindMatchesLineByLine(o,C,r,i,l):[]}static _getMultilineMatchRange(o,p,C,i,l,r){let a,w=0;i?(w=i.findLineFeedCountBeforeOffset(l),a=p+l+w):a=p+l;let f;if(i){let g=i.findLineFeedCountBeforeOffset(l+r.length)-w;f=a+r.length+g}else f=a+r.length;const m=o.getPositionAt(a),S=o.getPositionAt(f);return new A.Range(m.lineNumber,m.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(o,p,C,i,l){const r=o.getOffsetAt(p.getStartPosition()),a=o.getValueInRange(p,1),w=o.getEOL()===`\r
`?new n(a):null,f=[];let m=0,S;for(C.reset(0);S=C.next(a);)if(f[m++]=y(this._getMultilineMatchRange(o,r,a,w,S.index,S[0]),S,i),m>=l)return f;return f}static _doFindMatchesLineByLine(o,p,C,i,l){const r=[];let a=0;if(p.startLineNumber===p.endLineNumber){const f=o.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return a=this._findMatchesInLine(C,f,p.startLineNumber,p.startColumn-1,a,r,i,l),r}const w=o.getLineContent(p.startLineNumber).substring(p.startColumn-1);a=this._findMatchesInLine(C,w,p.startLineNumber,p.startColumn-1,a,r,i,l);for(let f=p.startLineNumber+1;f<p.endLineNumber&&a<l;f++)a=this._findMatchesInLine(C,o.getLineContent(f),f,0,a,r,i,l);if(a<l){const f=o.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);a=this._findMatchesInLine(C,f,p.endLineNumber,0,a,r,i,l)}return r}static _findMatchesInLine(o,p,C,i,l,r,a,w){const f=o.wordSeparators;if(!a&&o.simpleSearch){const T=o.simpleSearch,g=T.length,b=p.length;let u=-g;for(;(u=p.indexOf(T,u+g))!==-1;)if((!f||v(f,p,b,u,g))&&(r[l++]=new R.FindMatch(new A.Range(C,u+1+i,C,u+1+g+i),null),l>=w))return l;return l}const m=new k(o.wordSeparators,o.regex);let S;m.reset(0);do if(S=m.next(p),S&&(r[l++]=y(new A.Range(C,S.index+1+i,C,S.index+1+S[0].length+i),S,a),l>=w))return l;while(S);return l}static findNextMatch(o,p,C,i){const l=p.parseSearchRequest();if(!l)return null;const r=new k(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindNextMatchMultiline(o,C,r,i):this._doFindNextMatchLineByLine(o,C,r,i)}static _doFindNextMatchMultiline(o,p,C,i){const l=new _.Position(p.lineNumber,1),r=o.getOffsetAt(l),a=o.getLineCount(),w=o.getValueInRange(new A.Range(l.lineNumber,l.column,a,o.getLineMaxColumn(a)),1),f=o.getEOL()===`\r
`?new n(w):null;C.reset(p.column-1);let m=C.next(w);return m?y(this._getMultilineMatchRange(o,r,w,f,m.index,m[0]),m,i):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(o,new _.Position(1,1),C,i):null}static _doFindNextMatchLineByLine(o,p,C,i){const l=o.getLineCount(),r=p.lineNumber,a=o.getLineContent(r),w=this._findFirstMatchInLine(C,a,r,p.column,i);if(w)return w;for(let f=1;f<=l;f++){const m=(r+f-1)%l,S=o.getLineContent(m+1),T=this._findFirstMatchInLine(C,S,m+1,1,i);if(T)return T}return null}static _findFirstMatchInLine(o,p,C,i,l){o.reset(i-1);const r=o.next(p);return r?y(new A.Range(C,r.index+1,C,r.index+1+r[0].length),r,l):null}static findPreviousMatch(o,p,C,i){const l=p.parseSearchRequest();if(!l)return null;const r=new k(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindPreviousMatchMultiline(o,C,r,i):this._doFindPreviousMatchLineByLine(o,C,r,i)}static _doFindPreviousMatchMultiline(o,p,C,i){const l=this._doFindMatchesMultiline(o,new A.Range(1,1,p.lineNumber,p.column),C,i,10*I);if(l.length>0)return l[l.length-1];const r=o.getLineCount();return p.lineNumber!==r||p.column!==o.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(o,new _.Position(r,o.getLineMaxColumn(r)),C,i):null}static _doFindPreviousMatchLineByLine(o,p,C,i){const l=o.getLineCount(),r=p.lineNumber,a=o.getLineContent(r).substring(0,p.column-1),w=this._findLastMatchInLine(C,a,r,i);if(w)return w;for(let f=1;f<=l;f++){const m=(l+r-f-1)%l,S=o.getLineContent(m+1),T=this._findLastMatchInLine(C,S,m+1,i);if(T)return T}return null}static _findLastMatchInLine(o,p,C,i){let l=null,r;for(o.reset(0);r=o.next(p);)l=y(new A.Range(C,r.index+1,C,r.index+1+r[0].length),r,i);return l}}e.TextModelSearch=h;function s(E,o,p,C,i){if(C===0)return!0;const l=o.charCodeAt(C-1);if(E.get(l)!==0||l===13||l===10)return!0;if(i>0){const r=o.charCodeAt(C);if(E.get(r)!==0)return!0}return!1}function d(E,o,p,C,i){if(C+i===p)return!0;const l=o.charCodeAt(C+i);if(E.get(l)!==0||l===13||l===10)return!0;if(i>0){const r=o.charCodeAt(C+i-1);if(E.get(r)!==0)return!0}return!1}function v(E,o,p,C,i){return s(E,o,p,C,i)&&d(E,o,p,C,i)}e.isValidMatch=v;class k{constructor(o,p){this._wordSeparators=o,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const p=o.length;let C;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(C=this._searchRegex.exec(o),!C))return null;const i=C.index,l=C[0].length;if(i===this._prevMatchStartIndex&&l===this._prevMatchLength){if(l===0){c.getNextCodePoint(o,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=l,!this._wordSeparators||v(this._wordSeparators,o,p,i,l))return C}while(C);return null}}e.Searcher=k}),define(be[112],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class M{constructor(I){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let D=0,P=I.notIn.length;D<P;D++)switch(I.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=M;class _{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=_;function A(R,I,D){R.has(I)?R.get(I).push(D):R.set(I,[D])}}),define(be[55],Ee([0,1,27,17]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(A,R,I,D){if(Array.isArray(A)){let P=0;for(const t of A){const y=_(t,R,I,D);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof A=="string")return D?A==="*"?5:A===I?10:0:0;if(A){const{language:P,pattern:t,scheme:y,hasAccessToAllModels:n}=A;if(!D&&!n)return 0;let h=0;if(y)if(y===R.scheme)h=10;else if(y==="*")h=5;else return 0;if(P)if(P===I)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(t){let s;if(typeof t=="string"?s=t:s={...t,base:(0,M.normalize)(t.base)},s===R.fsPath||(0,c.match)(s,R.fsPath))h=10;else return 0}return h}else return 0}}e.score=_}),define(be[113],Ee([0,1,3,6]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class _{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,I){return this._map.set(R,I),this.fire([R]),(0,M.toDisposable)(()=>{this._map.get(R)===I&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,I){let D=null,P=!1;return this._promises.set(R,I.then(t=>{this._promises.delete(R),!(P||!t)&&(D=this.register(R,t))})),(0,M.toDisposable)(()=>{P=!0,D&&D.dispose()})}getPromise(R){const I=this.get(R);if(I)return Promise.resolve(I);const D=this._promises.get(R);return D?D.then(P=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=_}),define(be[80],Ee([0,1,23,26]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(_||(_={}));function A(y){for(let n=0,h=y.length;n<h;n+=4){const s=y[n+0],d=y[n+1],v=y[n+2],k=y[n+3];y[n+0]=k,y[n+1]=v,y[n+2]=d,y[n+3]=s}}function R(y){const n=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return M.isLittleEndian()||A(n),c.VSBuffer.wrap(n)}function I(y){const n=y.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const h=new Uint8Array(n.byteLength);return h.set(n),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(y){const n=new Uint32Array(P(y));let h=0;if(n[h++]=y.id,y.type==="full")n[h++]=1,n[h++]=y.data.length,n.set(y.data,h),h+=y.data.length;else{n[h++]=2,n[h++]=y.deltas.length;for(const s of y.deltas)n[h++]=s.start,n[h++]=s.deleteCount,s.data?(n[h++]=s.data.length,n.set(s.data,h),h+=s.data.length):n[h++]=0}return R(n)}e.encodeSemanticTokensDto=D;function P(y){let n=0;if(n+=1+1,y.type==="full")n+=1+y.data.length;else{n+=1,n+=(1+1+1)*y.deltas.length;for(const h of y.deltas)h.data&&(n+=h.data.length)}return n}function t(y){const n=I(y);let h=0;const s=n[h++];if(n[h++]===1){const E=n[h++],o=n.subarray(h,h+E);return h+=E,{id:s,type:"full",data:o}}const v=n[h++];let k=[];for(let E=0;E<v;E++){const o=n[h++],p=n[h++],C=n[h++];let i;C>0&&(i=n.subarray(h,h+C),h+=C),k[E]={start:o,deleteCount:p,data:i}}return{id:s,type:"delta",deltas:k}}e.decodeSemanticTokensDto=t}),define(be[114],Ee([18,19]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(be[56],Ee([0,1,13,10,114]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,t){return t&&(P.stack||P.stacktrace)?_.localize(0,null,I(P),R(P.stack)||R(P.stacktrace)):I(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?_.localize(1,null,P.message):P.message||_.localize(2,null)}function D(P=null,t=!1){if(!P)return _.localize(3,null);if(Array.isArray(P)){const y=c.coalesce(P),n=D(y[0],t);return y.length>1?_.localize(4,null,n,y.length):n}if(M.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return A(y.error,t);if(y.exception)return A(y.exception,t)}return P.stack?A(P,t):P.message?P.message:_.localize(5,null)}e.toErrorMessage=D}),define(be[115],Ee([18,19]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(be[116],Ee([0,1,115,26,117]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=R;class I{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,he){this._values[J]=he}}e.ValidatedEditorOptions=I;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(J,he,Oe,Ve){this.id=J,this.name=he,this.defaultValue=Oe,this.schema=Ve}compute(J,he,Oe){return Oe}}class t{constructor(J,he=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(J){return this.defaultValue}}class y{constructor(J,he,Oe,Ve){this.id=J,this.name=he,this.defaultValue=Oe,this.schema=Ve}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,he,Oe){return Oe}}function n(z,J){return typeof z=="undefined"?J:z==="false"?!1:Boolean(z)}e.boolean=n;class h extends y{constructor(J,he,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Oe),super(J,he,Oe,Ve)}validate(J){return n(J,this.defaultValue)}}class s extends y{constructor(J,he,Oe,Ve,tt,ut=void 0){typeof ut!="undefined"&&(ut.type="integer",ut.default=Oe,ut.minimum=Ve,ut.maximum=tt),super(J,he,Oe,ut),this.minimum=Ve,this.maximum=tt}static clampedInt(J,he,Oe,Ve){if(typeof J=="undefined")return he;let tt=parseInt(J,10);return isNaN(tt)?he:(tt=Math.max(Oe,tt),tt=Math.min(Ve,tt),tt|0)}validate(J){return s.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class d extends y{constructor(J,he,Oe,Ve,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Oe),super(J,he,Oe,tt),this.validationFn=Ve}static clamp(J,he,Oe){return J<he?he:J>Oe?Oe:J}static float(J,he){if(typeof J=="number")return J;if(typeof J=="undefined")return he;const Oe=parseFloat(J);return isNaN(Oe)?he:Oe}validate(J){return this.validationFn(d.float(J,this.defaultValue))}}class v extends y{static string(J,he){return typeof J!="string"?he:J}constructor(J,he,Oe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Oe),super(J,he,Oe,Ve)}validate(J){return v.string(J,this.defaultValue)}}function k(z,J,he){return typeof z!="string"||he.indexOf(z)===-1?J:z}e.stringSet=k;class E extends y{constructor(J,he,Oe,Ve,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ve,tt.default=Oe),super(J,he,Oe,tt),this._allowedValues=Ve}validate(J){return k(J,this.defaultValue,this._allowedValues)}}class o extends P{constructor(J,he,Oe,Ve,tt,ut,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=tt,ht.default=Ve),super(J,he,Oe,ht),this._allowedValues=tt,this._convert=ut}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function p(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class C extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,he,Oe){return Oe===0?J.accessibilitySupport:Oe}}class i extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertSpace:n(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(z){switch(z){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function f(z){switch(z){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class m extends t{constructor(){super(127,[65,32])}compute(J,he,Oe){const Ve=["monaco-editor"];return he.get(32)&&Ve.push(he.get(32)),J.extraEditorClassName&&Ve.push(J.extraEditorClassName),he.get(65)==="default"?Ve.push("mouse-default"):he.get(65)==="copy"&&Ve.push("mouse-copy"),he.get(100)&&Ve.push("showUnused"),he.get(125)&&Ve.push("showDeprecated"),Ve.join(" ")}}class S extends h{constructor(){super(31,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,he,Oe){return Oe&&J.emptySelectionClipboard}}class T extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{cursorMoveOnType:n(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":k(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":k(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(he.loop,this.defaultValue.loop)}}}class g extends P{constructor(){super(43,"fontLigatures",g.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?g.OFF:J==="true"?g.ON:J:Boolean(J)?g.ON:g.OFF}}e.EditorFontLigatures=g,g.OFF='"liga" off, "calt" off',g.ON='"liga" on, "calt" on';class b extends t{constructor(){super(42)}compute(J,he,Oe){return J.fontInfo}}class u extends y{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let he=d.float(J,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(he,6,100)}compute(J,he,Oe){return J.fontInfo.fontSize}}class F extends P{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(s.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class O extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Oe,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Oe,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Oe,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Oe,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Oe,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{multiple:k(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??k(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??k(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??k(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??k(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??k(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),delay:s.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:n(he.sticky,this.defaultValue.sticky)}}}var Q;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(Q=e.RenderMinimap||(e.RenderMinimap={}));class W extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(J,he,Oe){return W.computeLayout(he,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const he=J.height/J.lineHeight,Oe=J.scrollBeyondLastLine?he-1:0,Ve=(J.viewLineCount+Oe)/(J.pixelRatio*J.height),tt=Math.floor(J.viewLineCount/Ve);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Oe,desiredRatio:Ve,minimapLineCount:tt}}static _computeMinimapLayout(J,he){const Oe=J.outerWidth,Ve=J.outerHeight,tt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const ut=he.stableMinimapLayoutInput,ht=ut&&J.outerHeight===ut.outerHeight&&J.lineHeight===ut.lineHeight&&J.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&J.pixelRatio===ut.pixelRatio&&J.scrollBeyondLastLine===ut.scrollBeyondLastLine&&J.minimap.enabled===ut.minimap.enabled&&J.minimap.side===ut.minimap.side&&J.minimap.size===ut.minimap.size&&J.minimap.showSlider===ut.minimap.showSlider&&J.minimap.renderCharacters===ut.minimap.renderCharacters&&J.minimap.maxColumn===ut.minimap.maxColumn&&J.minimap.scale===ut.minimap.scale&&J.verticalScrollbarWidth===ut.verticalScrollbarWidth&&J.isViewportWrapping===ut.isViewportWrapping,St=J.lineHeight,Pt=J.typicalHalfwidthCharacterWidth,dt=J.scrollBeyondLastLine,bt=J.minimap.renderCharacters;let ft=tt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Et=J.minimap.maxColumn,Ye=J.minimap.size,Ct=J.minimap.side,Pe=J.verticalScrollbarWidth,ye=J.viewLineCount,De=J.remainingWidth,Z=J.isViewportWrapping,ce=bt?2:3;let ge=Math.floor(tt*Ve);const me=ge/tt;let Ie=!1,Be=!1,Le=ce*ft,je=ft/tt,Xe=1;if(Ye==="fill"||Ye==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:We,desiredRatio:it,minimapLineCount:mt}=W.computeContainedMinimapLineCount({viewLineCount:ye,scrollBeyondLastLine:dt,height:Ve,lineHeight:St,pixelRatio:tt});if(ye/mt>1)Ie=!0,Be=!0,ft=1,Le=1,je=ft/tt;else{let nt=!1,ot=ft+1;if(Ye==="fit"){const lt=Math.ceil((ye+We)*Le);Z&&ht&&De<=he.stableFitRemainingWidth?(nt=!0,ot=he.stableFitMaxMinimapScale):nt=lt>ge}if(Ye==="fill"||nt){Ie=!0;const lt=ft;Le=Math.min(St*tt,Math.max(1,Math.floor(1/it))),Z&&ht&&De<=he.stableFitRemainingWidth&&(ot=he.stableFitMaxMinimapScale),ft=Math.min(ot,Math.max(1,Math.floor(Le/ce))),ft>lt&&(Xe=Math.min(2,ft/lt)),je=ft/tt/Xe,ge=Math.ceil(Math.max(Ge,ye+We)*Le),Z?(he.stableMinimapLayoutInput=J,he.stableFitRemainingWidth=De,he.stableFitMaxMinimapScale=ft):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const ne=Math.floor(Et*je),pe=Math.min(ne,Math.max(0,Math.floor((De-Pe-2)*je/(Pt+je)))+e.MINIMAP_GUTTER_WIDTH);let re=Math.floor(tt*pe);const B=re/tt;re=Math.floor(re*Xe);const Ce=bt?1:2,Se=Ct==="left"?0:Oe-pe-Pe;return{renderMinimap:Ce,minimapLeft:Se,minimapWidth:pe,minimapHeightIsEditorHeight:Ie,minimapIsSampling:Be,minimapScale:ft,minimapLineHeight:Le,minimapCanvasInnerWidth:re,minimapCanvasInnerHeight:ge,minimapCanvasOuterWidth:B,minimapCanvasOuterHeight:me}}static computeLayout(J,he){const Oe=he.outerWidth|0,Ve=he.outerHeight|0,tt=he.lineHeight|0,ut=he.lineNumbersDigitCount|0,ht=he.typicalHalfwidthCharacterWidth,St=he.maxDigitWidth,Pt=he.pixelRatio,dt=he.viewLineCount,bt=J.get(122),ft=bt==="inherit"?J.get(121):bt,Et=ft==="inherit"?J.get(117):ft,Ye=J.get(120),Ct=J.get(2),Pe=he.isDominatedByLongLines,ye=J.get(48),De=J.get(59).renderType!==0,Z=J.get(60),ce=J.get(94),ge=J.get(64),me=J.get(92),Ie=me.verticalScrollbarSize,Be=me.verticalHasArrows,Le=me.arrowSize,je=me.horizontalScrollbarSize,Xe=J.get(57),ne=J.get(36);let pe;if(typeof Xe=="string"&&/^\d+(\.\d+)?ch$/.test(Xe)){const Ot=parseFloat(Xe.substr(0,Xe.length-2));pe=s.clampedInt(Ot*ht,0,0,1e3)}else pe=s.clampedInt(Xe,0,0,1e3);ne&&(pe+=16);let re=0;if(De){const Ot=Math.max(ut,Z);re=Math.round(Ot*St)}let B=0;ye&&(B=tt);let Ce=0,Se=Ce+B,Ge=Se+re,We=Ge+pe;const it=Oe-B-re-pe;let mt=!1,vt=!1,nt=-1;Ct!==2&&(ft==="inherit"&&Pe?(mt=!0,vt=!0):Et==="on"||Et==="bounded"?vt=!0:Et==="wordWrapColumn"&&(nt=Ye));const ot=W._computeMinimapLayout({outerWidth:Oe,outerHeight:Ve,lineHeight:tt,typicalHalfwidthCharacterWidth:ht,pixelRatio:Pt,scrollBeyondLastLine:ce,minimap:ge,verticalScrollbarWidth:Ie,viewLineCount:dt,remainingWidth:it,isViewportWrapping:vt},he.memory||new D);ot.renderMinimap!==0&&ot.minimapLeft===0&&(Ce+=ot.minimapWidth,Se+=ot.minimapWidth,Ge+=ot.minimapWidth,We+=ot.minimapWidth);const lt=it-ot.minimapWidth,Rt=Math.max(1,Math.floor((lt-Ie-2)/ht)),_t=Be?Le:0;return vt&&(nt=Math.max(1,Rt),Et==="bounded"&&(nt=Math.min(nt,Ye))),{width:Oe,height:Ve,glyphMarginLeft:Ce,glyphMarginWidth:B,lineNumbersLeft:Se,lineNumbersWidth:re,decorationsLeft:Ge,decorationsWidth:pe,contentLeft:We,contentWidth:lt,minimap:ot,viewportColumn:Rt,isWordWrapMinified:mt,isViewportWrapping:vt,wrappingColumn:nt,verticalScrollbarWidth:Ie,horizontalScrollbarHeight:je,overviewRuler:{top:_t,width:Ie,height:Ve-2*_t,right:0}}}}e.EditorLayoutInfoComputer=W;class K extends P{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class $ extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(he.fontFamily,this.defaultValue.fontFamily)}}}class U extends d{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>d.clamp(J,0,150),{markdownDescription:c.localize(46,null)})}compute(J,he,Oe){return J.fontInfo.lineHeight}}class H extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(48,null),c.localize(49,null),c.localize(50,null)],default:J.size,description:c.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),size:k(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:k(he.side,this.defaultValue.side,["right","left"]),showSlider:k(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(he.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(he.scale,1,1,3),maxColumn:s.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(z){return z==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ue extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{top:s.clampedInt(he.top,0,0,1e3),bottom:s.clampedInt(he.bottom,0,0,1e3)}}}class q extends P{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),cycle:n(he.cycle,this.defaultValue.cycle)}}}class le extends t{constructor(){super(128)}compute(J,he,Oe){return J.pixelRatio}}class se extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(61,null)},comments:{type:"boolean",default:J.comments,description:c.localize(62,null)},other:{type:"boolean",default:J.other,description:c.localize(63,null)}}}],default:J,description:c.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const he=J,Oe={other:n(he.other,this.defaultValue.other),comments:n(he.comments,this.defaultValue.comments),strings:n(he.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var ve;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(65,null),c.localize(66,null),c.localize(67,null),c.localize(68,null)],default:"on",description:c.localize(69,null)})}validate(J){let he=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(he=4,Oe=J):J==="interval"?he=3:J==="relative"?he=2:J==="on"?he=1:he=0),{renderType:he,renderFn:Oe}}}function Me(z){const J=z.get(87);return J==="editable"?z.get(80):J!=="on"}e.filterValidationDecorations=Me;class Ne extends P{constructor(){const J=[],he={type:"number",description:c.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:c.localize(71,null),format:"color-hex"}}}]},default:J,description:c.localize(72,null)})}validate(J){if(Array.isArray(J)){let he=[];for(let Oe of J)if(typeof Oe=="number")he.push({column:s.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const Ve=Oe;he.push({column:s.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return he.sort((Oe,Ve)=>Oe.column-Ve.column),he}return this.defaultValue}}function Qe(z,J){if(typeof z!="string")return J;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)],default:"auto",description:c.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)],default:"auto",description:c.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J,Oe=s.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=s.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(he.vertical,this.defaultValue.vertical),horizontal:Qe(he.horizontal,this.defaultValue.horizontal),useShadows:n(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:s.clampedInt(he.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:s.clampedInt(he.verticalSliderSize,Ve,0,1e3),scrollByPage:n(he.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[c.localize(85,null),c.localize(86,null),c.localize(87,null)],default:J.mode,description:c.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),mode:k(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(89,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class Y extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(90,null),c.localize(91,null)],default:J.insertMode,description:c.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[c.localize(100,null),c.localize(101,null),c.localize(102,null)],default:J.previewMode,description:c.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertMode:k(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(he.showIcons,this.defaultValue.showIcons),showStatusBar:n(he.showStatusBar,this.defaultValue.showStatusBar),preview:n(he.preview,this.defaultValue.preview),previewMode:k(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(he.showMethods,this.defaultValue.showMethods),showFunctions:n(he.showFunctions,this.defaultValue.showFunctions),showConstructors:n(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(he.showDeprecated,this.defaultValue.showDeprecated),showFields:n(he.showFields,this.defaultValue.showFields),showVariables:n(he.showVariables,this.defaultValue.showVariables),showClasses:n(he.showClasses,this.defaultValue.showClasses),showStructs:n(he.showStructs,this.defaultValue.showStructs),showInterfaces:n(he.showInterfaces,this.defaultValue.showInterfaces),showModules:n(he.showModules,this.defaultValue.showModules),showProperties:n(he.showProperties,this.defaultValue.showProperties),showEvents:n(he.showEvents,this.defaultValue.showEvents),showOperators:n(he.showOperators,this.defaultValue.showOperators),showUnits:n(he.showUnits,this.defaultValue.showUnits),showValues:n(he.showValues,this.defaultValue.showValues),showConstants:n(he.showConstants,this.defaultValue.showConstants),showEnums:n(he.showEnums,this.defaultValue.showEnums),showEnumMembers:n(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(he.showKeywords,this.defaultValue.showKeywords),showWords:n(he.showWords,this.defaultValue.showWords),showColors:n(he.showColors,this.defaultValue.showColors),showFiles:n(he.showFiles,this.defaultValue.showFiles),showReferences:n(he.showReferences,this.defaultValue.showReferences),showFolders:n(he.showFolders,this.defaultValue.showFolders),showTypeParameters:n(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(he.showSnippets,this.defaultValue.showSnippets),showUsers:n(he.showUsers,this.defaultValue.showUsers),showIssues:n(he.showIssues,this.defaultValue.showIssues)}}}class ee extends P{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(136,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends t{constructor(){super(129,[80])}compute(J,he,Oe){return he.get(80)?!0:J.tabFocusMode}}var V;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(V=e.WrappingIndent||(e.WrappingIndent={}));function oe(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends t{constructor(){super(131,[130])}compute(J,he,Oe){const Ve=he.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const Ae="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?xe:M.isLinux?$e:Ae,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function we(z){return e.editorOptionsRegistry[z.id]=z,z}var Ze;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.bracketPairColorization=12]="bracketPairColorization",z[z.codeLens=13]="codeLens",z[z.codeLensFontFamily=14]="codeLensFontFamily",z[z.codeLensFontSize=15]="codeLensFontSize",z[z.colorDecorators=16]="colorDecorators",z[z.columnSelection=17]="columnSelection",z[z.comments=18]="comments",z[z.contextmenu=19]="contextmenu",z[z.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",z[z.cursorBlinking=21]="cursorBlinking",z[z.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",z[z.cursorStyle=23]="cursorStyle",z[z.cursorSurroundingLines=24]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",z[z.cursorWidth=26]="cursorWidth",z[z.disableLayerHinting=27]="disableLayerHinting",z[z.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",z[z.domReadOnly=29]="domReadOnly",z[z.dragAndDrop=30]="dragAndDrop",z[z.emptySelectionClipboard=31]="emptySelectionClipboard",z[z.extraEditorClassName=32]="extraEditorClassName",z[z.fastScrollSensitivity=33]="fastScrollSensitivity",z[z.find=34]="find",z[z.fixedOverflowWidgets=35]="fixedOverflowWidgets",z[z.folding=36]="folding",z[z.foldingStrategy=37]="foldingStrategy",z[z.foldingHighlight=38]="foldingHighlight",z[z.foldingImportsByDefault=39]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=41]="fontFamily",z[z.fontInfo=42]="fontInfo",z[z.fontLigatures=43]="fontLigatures",z[z.fontSize=44]="fontSize",z[z.fontWeight=45]="fontWeight",z[z.formatOnPaste=46]="formatOnPaste",z[z.formatOnType=47]="formatOnType",z[z.glyphMargin=48]="glyphMargin",z[z.gotoLocation=49]="gotoLocation",z[z.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",z[z.hover=52]="hover",z[z.inDiffEditor=53]="inDiffEditor",z[z.inlineSuggest=54]="inlineSuggest",z[z.letterSpacing=55]="letterSpacing",z[z.lightbulb=56]="lightbulb",z[z.lineDecorationsWidth=57]="lineDecorationsWidth",z[z.lineHeight=58]="lineHeight",z[z.lineNumbers=59]="lineNumbers",z[z.lineNumbersMinChars=60]="lineNumbersMinChars",z[z.linkedEditing=61]="linkedEditing",z[z.links=62]="links",z[z.matchBrackets=63]="matchBrackets",z[z.minimap=64]="minimap",z[z.mouseStyle=65]="mouseStyle",z[z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=67]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",z[z.multiCursorModifier=69]="multiCursorModifier",z[z.multiCursorPaste=70]="multiCursorPaste",z[z.occurrencesHighlight=71]="occurrencesHighlight",z[z.overviewRulerBorder=72]="overviewRulerBorder",z[z.overviewRulerLanes=73]="overviewRulerLanes",z[z.padding=74]="padding",z[z.parameterHints=75]="parameterHints",z[z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",z[z.quickSuggestions=78]="quickSuggestions",z[z.quickSuggestionsDelay=79]="quickSuggestionsDelay",z[z.readOnly=80]="readOnly",z[z.renameOnType=81]="renameOnType",z[z.renderControlCharacters=82]="renderControlCharacters",z[z.renderIndentGuides=83]="renderIndentGuides",z[z.renderFinalNewline=84]="renderFinalNewline",z[z.renderLineHighlight=85]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=87]="renderValidationDecorations",z[z.renderWhitespace=88]="renderWhitespace",z[z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",z[z.roundedSelection=90]="roundedSelection",z[z.rulers=91]="rulers",z[z.scrollbar=92]="scrollbar",z[z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=94]="scrollBeyondLastLine",z[z.scrollPredominantAxis=95]="scrollPredominantAxis",z[z.selectionClipboard=96]="selectionClipboard",z[z.selectionHighlight=97]="selectionHighlight",z[z.selectOnLineNumbers=98]="selectOnLineNumbers",z[z.showFoldingControls=99]="showFoldingControls",z[z.showUnused=100]="showUnused",z[z.snippetSuggestions=101]="snippetSuggestions",z[z.smartSelect=102]="smartSelect",z[z.smoothScrolling=103]="smoothScrolling",z[z.stickyTabStops=104]="stickyTabStops",z[z.stopRenderingLineAfter=105]="stopRenderingLineAfter",z[z.suggest=106]="suggest",z[z.suggestFontSize=107]="suggestFontSize",z[z.suggestLineHeight=108]="suggestLineHeight",z[z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",z[z.suggestSelection=110]="suggestSelection",z[z.tabCompletion=111]="tabCompletion",z[z.tabIndex=112]="tabIndex",z[z.unusualLineTerminators=113]="unusualLineTerminators",z[z.useShadowDOM=114]="useShadowDOM",z[z.useTabStops=115]="useTabStops",z[z.wordSeparators=116]="wordSeparators",z[z.wordWrap=117]="wordWrap",z[z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=120]="wordWrapColumn",z[z.wordWrapOverride1=121]="wordWrapOverride1",z[z.wordWrapOverride2=122]="wordWrapOverride2",z[z.wrappingIndent=123]="wrappingIndent",z[z.wrappingStrategy=124]="wrappingStrategy",z[z.showDeprecated=125]="showDeprecated",z[z.inlayHints=126]="inlayHints",z[z.editorClassName=127]="editorClassName",z[z.pixelRatio=128]="pixelRatio",z[z.tabFocusMode=129]="tabFocusMode",z[z.layoutInfo=130]="layoutInfo",z[z.wrappingInfo=131]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(137,null)})),acceptSuggestionOnEnter:we(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(138,null),""],markdownDescription:c.localize(139,null)})),accessibilitySupport:we(new C),accessibilityPageSize:we(new s(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(140,null)})),ariaLabel:we(new v(4,"ariaLabel",c.localize(141,null))),autoClosingBrackets:we(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(142,null),c.localize(143,null),""],description:c.localize(144,null)})),autoClosingDelete:we(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(145,null),""],description:c.localize(146,null)})),autoClosingOvertype:we(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(147,null),""],description:c.localize(148,null)})),autoClosingQuotes:we(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(149,null),c.localize(150,null),""],description:c.localize(151,null)})),autoIndent:we(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[c.localize(152,null),c.localize(153,null),c.localize(154,null),c.localize(155,null),c.localize(156,null)],description:c.localize(157,null)})),automaticLayout:we(new h(10,"automaticLayout",!1)),autoSurround:we(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(158,null),c.localize(159,null),c.localize(160,null),""],description:c.localize(161,null)})),bracketPairColorization:we(new x),stickyTabStops:we(new h(104,"stickyTabStops",!1,{description:c.localize(162,null)})),codeLens:we(new h(13,"codeLens",!0,{description:c.localize(163,null)})),codeLensFontFamily:we(new v(14,"codeLensFontFamily","",{description:c.localize(164,null)})),codeLensFontSize:we(new s(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(165,null)})),colorDecorators:we(new h(16,"colorDecorators",!0,{description:c.localize(166,null)})),columnSelection:we(new h(17,"columnSelection",!1,{description:c.localize(167,null)})),comments:we(new i),contextmenu:we(new h(19,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new h(20,"copyWithSyntaxHighlighting",!0,{description:c.localize(168,null)})),cursorBlinking:we(new o(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:c.localize(169,null)})),cursorSmoothCaretAnimation:we(new h(22,"cursorSmoothCaretAnimation",!1,{description:c.localize(170,null)})),cursorStyle:we(new o(23,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:c.localize(171,null)})),cursorSurroundingLines:we(new s(24,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(172,null)})),cursorSurroundingLinesStyle:we(new E(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(173,null),c.localize(174,null)],description:c.localize(175,null)})),cursorWidth:we(new s(26,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(176,null)})),disableLayerHinting:we(new h(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new h(28,"disableMonospaceOptimizations",!1)),domReadOnly:we(new h(29,"domReadOnly",!1)),dragAndDrop:we(new h(30,"dragAndDrop",!0,{description:c.localize(177,null)})),emptySelectionClipboard:we(new S),extraEditorClassName:we(new v(32,"extraEditorClassName","")),fastScrollSensitivity:we(new d(33,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:c.localize(178,null)})),find:we(new T),fixedOverflowWidgets:we(new h(35,"fixedOverflowWidgets",!1)),folding:we(new h(36,"folding",!0,{description:c.localize(179,null)})),foldingStrategy:we(new E(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(180,null),c.localize(181,null)],description:c.localize(182,null)})),foldingHighlight:we(new h(38,"foldingHighlight",!0,{description:c.localize(183,null)})),foldingImportsByDefault:we(new h(39,"foldingImportsByDefault",!1,{description:c.localize(184,null)})),unfoldOnClickAfterEndOfLine:we(new h(40,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(185,null)})),fontFamily:we(new v(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(186,null)})),fontInfo:we(new b),fontLigatures2:we(new g),fontSize:we(new u),fontWeight:we(new F),formatOnPaste:we(new h(46,"formatOnPaste",!1,{description:c.localize(187,null)})),formatOnType:we(new h(47,"formatOnType",!1,{description:c.localize(188,null)})),glyphMargin:we(new h(48,"glyphMargin",!0,{description:c.localize(189,null)})),gotoLocation:we(new O),hideCursorInOverviewRuler:we(new h(50,"hideCursorInOverviewRuler",!1,{description:c.localize(190,null)})),highlightActiveIndentGuide:we(new h(51,"highlightActiveIndentGuide",!0,{description:c.localize(191,null)})),hover:we(new j),inDiffEditor:we(new h(53,"inDiffEditor",!1)),letterSpacing:we(new d(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>d.clamp(z,-5,20),{description:c.localize(192,null)})),lightbulb:we(new K),lineDecorationsWidth:we(new y(57,"lineDecorationsWidth",10)),lineHeight:we(new U),lineNumbers:we(new Fe),lineNumbersMinChars:we(new s(60,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new h(61,"linkedEditing",!1,{description:c.localize(193,null)})),links:we(new h(62,"links",!0,{description:c.localize(194,null)})),matchBrackets:we(new E(63,"matchBrackets","always",["always","near","never"],{description:c.localize(195,null)})),minimap:we(new H),mouseStyle:we(new E(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new d(66,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:c.localize(196,null)})),mouseWheelZoom:we(new h(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(197,null)})),multiCursorMergeOverlapping:we(new h(68,"multiCursorMergeOverlapping",!0,{description:c.localize(198,null)})),multiCursorModifier:we(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[c.localize(199,null),c.localize(200,null)],markdownDescription:c.localize(201,null)})),multiCursorPaste:we(new E(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(202,null),c.localize(203,null)],markdownDescription:c.localize(204,null)})),occurrencesHighlight:we(new h(71,"occurrencesHighlight",!0,{description:c.localize(205,null)})),overviewRulerBorder:we(new h(72,"overviewRulerBorder",!0,{description:c.localize(206,null)})),overviewRulerLanes:we(new s(73,"overviewRulerLanes",3,0,3)),padding:we(new ue),parameterHints:we(new q),peekWidgetDefaultFocus:we(new E(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(207,null),c.localize(208,null)],description:c.localize(209,null)})),definitionLinkOpensInPeek:we(new h(77,"definitionLinkOpensInPeek",!1,{description:c.localize(210,null)})),quickSuggestions:we(new se),quickSuggestionsDelay:we(new s(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(211,null)})),readOnly:we(new h(80,"readOnly",!1)),renameOnType:we(new h(81,"renameOnType",!1,{description:c.localize(212,null),markdownDeprecationMessage:c.localize(213,null)})),renderControlCharacters:we(new h(82,"renderControlCharacters",!1,{description:c.localize(214,null)})),renderIndentGuides:we(new h(83,"renderIndentGuides",!0,{description:c.localize(215,null)})),renderFinalNewline:we(new h(84,"renderFinalNewline",!0,{description:c.localize(216,null)})),renderLineHighlight:we(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(217,null)],description:c.localize(218,null)})),renderLineHighlightOnlyWhenFocus:we(new h(86,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(219,null)})),renderValidationDecorations:we(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(220,null),c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),revealHorizontalRightPadding:we(new s(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new h(90,"roundedSelection",!0,{description:c.localize(224,null)})),rulers:we(new Ne),scrollbar:we(new ze),scrollBeyondLastColumn:we(new s(93,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(225,null)})),scrollBeyondLastLine:we(new h(94,"scrollBeyondLastLine",!0,{description:c.localize(226,null)})),scrollPredominantAxis:we(new h(95,"scrollPredominantAxis",!0,{description:c.localize(227,null)})),selectionClipboard:we(new h(96,"selectionClipboard",!0,{description:c.localize(228,null),included:M.isLinux})),selectionHighlight:we(new h(97,"selectionHighlight",!0,{description:c.localize(229,null)})),selectOnLineNumbers:we(new h(98,"selectOnLineNumbers",!0)),showFoldingControls:we(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),showUnused:we(new h(100,"showUnused",!0,{description:c.localize(233,null)})),showDeprecated:we(new h(125,"showDeprecated",!0,{description:c.localize(234,null)})),inlayHints:we(new $),snippetSuggestions:we(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),smartSelect:we(new ee),smoothScrolling:we(new h(103,"smoothScrolling",!1,{description:c.localize(240,null)})),stopRenderingLineAfter:we(new s(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new Y),inlineSuggest:we(new qe),suggestFontSize:we(new s(107,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(241,null)})),suggestLineHeight:we(new s(108,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(242,null)})),suggestOnTriggerCharacters:we(new h(109,"suggestOnTriggerCharacters",!0,{description:c.localize(243,null)})),suggestSelection:we(new E(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(244,null),c.localize(245,null),c.localize(246,null)],description:c.localize(247,null)})),tabCompletion:we(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(248,null),c.localize(249,null),c.localize(250,null)],description:c.localize(251,null)})),tabIndex:we(new s(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new E(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(252,null),c.localize(253,null),c.localize(254,null)],description:c.localize(255,null)})),useShadowDOM:we(new h(114,"useShadowDOM",!0)),useTabStops:we(new h(115,"useTabStops",!0,{description:c.localize(256,null)})),wordSeparators:we(new v(116,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:c.localize(257,null)})),wordWrap:we(new E(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(258,null),c.localize(259,null),c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),wordWrapBreakAfterCharacters:we(new v(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new v(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new s(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(263,null)})),wordWrapOverride1:we(new E(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new E(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new o(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],oe,{enumDescriptions:[c.localize(264,null),c.localize(265,null),c.localize(266,null),c.localize(267,null)],description:c.localize(268,null)})),wrappingStrategy:we(new E(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),editorClassName:we(new m),pixelRatio:we(new le),tabFocusMode:we(new ae),layoutInfo:we(new W),wrappingInfo:we(new fe)}}),define(be[118],Ee([18,19]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[119],Ee([18,19]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[120],Ee([18,19]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(be[121],Ee([18,19]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(be[122],Ee([18,19]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(be[123],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[124],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[125],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(be[126],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[127],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[128],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[129],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[130],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(be[131],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(be[132],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[133],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[134],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[135],Ee([18,19]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[136],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var M;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var _;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[137],Ee([0,1,119]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function R(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=n.match(M);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=R;function I(n){if(!n)return null;let h=n.majorBase,s=n.majorMustEqual,d=n.minorBase,v=n.minorMustEqual,k=n.patchBase,E=n.patchMustEqual;n.hasCaret&&(h===0||(v=!1),E=!1);let o=0;if(n.preRelease){const p=_.exec(n.preRelease);if(p){const[,C,i,l]=p;o=Date.UTC(Number(C),Number(i)-1,Number(l))}}return{majorBase:h,majorMustEqual:s,minorBase:d,minorMustEqual:v,patchBase:k,patchMustEqual:E,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=I;function D(n,h,s){let d;typeof n=="string"?d=I(R(n)):d=n;let v;h instanceof Date?v=h.getTime():typeof h=="string"&&(v=new Date(h).getTime());let k;if(typeof s=="string"?k=I(R(s)):k=s,!d||!k)return!1;let E=d.majorBase,o=d.minorBase,p=d.patchBase,C=k.majorBase,i=k.minorBase,l=k.patchBase,r=k.notBefore,a=k.majorMustEqual,w=k.minorMustEqual,f=k.patchMustEqual;return k.isMinimum?E>C?!0:E<C?!1:o>i?!0:o<i||v&&v<r?!1:p>=l:(E===1&&C===0&&(!a||!w||!f)&&(C=1,i=0,l=0,a=!0,w=!1,f=!1),E<C?!1:E>C?!a:o<i?!1:o>i?!w:p<l?!1:p>l?!f:!(v&&v<r))}e.isValidVersion=D;function P(n,h,s,d){return s.isBuiltin||typeof s.main=="undefined"?!0:y(n,h,s.engines.vscode,d)}e.isValidExtensionVersion=P;function t(n,h,s){return n==="*"||y(h,s,n)}e.isEngineValid=t;function y(n,h,s,d=[]){let v=I(R(s));if(!v)return d.push(c.localize(0,null,s)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return d.push(c.localize(1,null,s)),!1}else if(!v.majorMustEqual)return d.push(c.localize(2,null,s)),!1;return D(n,h,v)?!0:(d.push(c.localize(3,null,n,s)),!1)}}),define(be[81],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(_,A=[],R=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=c}),define(be[57],Ee([0,1,81]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function _(R,I,D){I instanceof c.SyncDescriptor||(I=new c.SyncDescriptor(I,[],D)),M.push([R,I])}e.registerSingleton=_;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[138],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=c;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const I=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(R);I.outgoing.set(this._hashFn(R),D),D.incoming.set(this._hashFn(A),I)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(let I of this._nodes.values())I.outgoing.delete(R),I.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let I=this._nodes.get(R);return I||(I=new c(A),this._nodes.set(R,I)),I}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[R,I]of this._nodes)A.push(`${R}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,R]of this._nodes){const I=new Set([A]),D=this._findCycle(R,I);if(D)return D}}_findCycle(A,R){for(let[I,D]of A.outgoing){if(R.has(I))return[...R,I].join(" -> ");R.add(I);const P=this._findCycle(D,R);if(P)return P;R.delete(I)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(c=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function M(I,D,P,t){D[c.DI_TARGET]===D?D[c.DI_DEPENDENCIES].push({id:I,index:P,optional:t}):(D[c.DI_DEPENDENCIES]=[{id:I,index:P,optional:t}],D[c.DI_TARGET]=D)}function _(I){if(c.serviceIds.has(I))return c.serviceIds.get(I);const D=function(P,t,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(D,P,y,!1)};return D.toString=()=>I,c.serviceIds.set(I,D),D}e.createDecorator=_;function A(I){return I}e.refineServiceDecorator=A;function R(I){return function(D,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(I,D,t,!0)}}e.optional=R}),define(be[139],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function M(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[140],Ee([0,1,3,58,6,20,75,55,139]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(P):!!d.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(v,k){let E={selector:v,provider:k,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,_.toDisposable)(()=>{if(E){let o=this._entries.indexOf(E);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const k=[];for(let E of this._entries)E._score>0&&k.push(E.provider);return k}ordered(v){const k=[];return this._orderedForEach(v,E=>k.push(E.provider)),k}orderedGroups(v){const k=[];let E,o;return this._orderedForEach(v,p=>{E&&o===p._score?E.push(p.provider):(o=p._score,E=[p.provider],k.push(E))}),k}_orderedForEach(v,k){if(!!v){this._updateScores(v);for(const E of this._entries)E._score>0&&k(E)}}_updateScores(v){let k={uri:v.uri.toString(),language:v.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===k.language&&this._lastCandidate.uri===k.uri)){this._lastCandidate=k;for(let E of this._entries)if(E._score=(0,I.score)(E.selector,v.uri,v.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(v)),P(E.selector)&&E._score>0){for(let o of this._entries)o._score=0;E._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(v,k){return v._score<k._score?1:v._score>k._score?-1:v._time<k._time?1:v._time>k._time?-1:0}}e.LanguageFeatureRegistry=t;const y=new WeakMap;let n=0;function h(d){let v=y.get(d);return v===void 0&&(v=++n,y.set(d,v)),v}class s{constructor(v,k,E=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=k,this.max=E,this._cache=new A.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((k,E)=>(0,M.doHash)(h(E),k),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const k=this._key(v),E=this._cache.get(k);return this._clamp(E?.value)}update(v,k){const E=this._key(v);let o=this._cache.get(E);return o||(o=new R.MovingAverage,this._cache.set(E,o)),o.update(k),this.get(v)}}e.LanguageFeatureRequestDelays=s}),define(be[59],Ee([0,1,2,42,140,113,34]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class D{constructor(b,u){this.language=b,this.id=u}}e.LanguageIdentifier=D;var P;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var y;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(y=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let u=this.getForeground(b),F="mtk"+u,O=this.getFontStyle(b);return O&1&&(F+=" mtki"),O&2&&(F+=" mtkb"),O&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(b,u){const F=this.getForeground(b),O=this.getFontStyle(b);let j=`color: ${u[F]};`;return O&1&&(j+="font-style: italic;"),O&2&&(j+="font-weight: bold;"),O&4&&(j+="text-decoration: underline;"),j}}e.TokenMetadata=h;var s;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(b){const u=g[b];let F=u&&R.iconRegistry.get(u);return F||(console.info("No codicon found for CompletionItemKind "+b),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(b,u){let F=g[b];return typeof F=="undefined"&&!u&&(F=9),F}}();var d;(function(g){g[g.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var C;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(C=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(g){return g&&c.URI.isUri(g.uri)&&M.Range.isIRange(g.range)&&(M.Range.isIRange(g.originSelectionRange)||M.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=i;var l;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(l=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var a;(function(g){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const u=new Map;u.set(0,"file"),u.set(1,"module"),u.set(2,"namespace"),u.set(3,"package"),u.set(4,"class"),u.set(5,"method"),u.set(6,"property"),u.set(7,"field"),u.set(8,"constructor"),u.set(9,"enum"),u.set(10,"interface"),u.set(11,"function"),u.set(12,"variable"),u.set(13,"constant"),u.set(14,"string"),u.set(15,"number"),u.set(16,"boolean"),u.set(17,"array"),u.set(18,"object"),u.set(19,"key"),u.set(20,"null"),u.set(21,"enum-member"),u.set(22,"struct"),u.set(23,"event"),u.set(24,"operator"),u.set(25,"type-parameter");function F(Q){return b.get(Q)}g.fromString=F;function O(Q){return u.get(Q)}g.toString=O;function j(Q,W){const K=u.get(Q);let $=K&&R.iconRegistry.get("symbol-"+K);return $||(console.info("No codicon found for SymbolKind "+Q),$=R.Codicon.symbolProperty),`${W?"inline":"block"} ${$.classNames}`}g.toCssClassName=j})(a=e.SymbolKinds||(e.SymbolKinds={}));class w{constructor(b){this.value=b}}e.FoldingRangeKind=w,w.Comment=new w("comment"),w.Imports=new w("imports"),w.Region=new w("region");var f;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var S;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(S=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new _.LanguageFeatureRegistry,e.RenameProviderRegistry=new _.LanguageFeatureRegistry,e.CompletionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new _.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new _.LanguageFeatureRegistry,e.HoverProviderRegistry=new _.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new _.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new _.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new _.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new _.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new _.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.LinkProviderRegistry=new _.LanguageFeatureRegistry,e.ColorProviderRegistry=new _.LanguageFeatureRegistry,e.SelectionRangeRegistry=new _.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var T;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[43],Ee([0,1,26,9,4]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=c.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",c.isMacintosh),R.set("isLinux",c.isLinux),R.set("isWindows",c.isWindows),R.set("isWeb",c.isWeb),R.set("isMacNative",c.isMacintosh&&!c.isWeb),R.set("isEdge",A.indexOf("Edg/")>=0),R.set("isFirefox",A.indexOf("Firefox")>=0),R.set("isChrome",A.indexOf("Chrome")>=0),R.set("isSafari",A.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var D;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return y.INSTANCE}static true(){return n.INSTANCE}static has(u){return h.create(u)}static equals(u,F){return s.create(u,F)}static notEquals(u,F){return k.create(u,F)}static regex(u,F){return l.create(u,F)}static in(u,F){return d.create(u,F)}static not(u){return E.create(u)}static and(...u){return a.create(u,null)}static or(...u){return w.create(u,null,!0)}static greater(u,F){return o.create(u,F)}static less(u,F){return C.create(u,F)}static deserialize(u,F=!1){if(!!u)return this._deserializeOrExpression(u,F)}static _deserializeOrExpression(u,F){let O=u.split("||");return w.create(O.map(j=>this._deserializeAndExpression(j,F)),null,!0)}static _deserializeAndExpression(u,F){let O=u.split("&&");return a.create(O.map(j=>this._deserializeOne(j,F)),null)}static _deserializeOne(u,F){if(u=u.trim(),u.indexOf("!=")>=0){let O=u.split("!=");return k.create(O[0].trim(),this._deserializeValue(O[1],F))}if(u.indexOf("==")>=0){let O=u.split("==");return s.create(O[0].trim(),this._deserializeValue(O[1],F))}if(u.indexOf("=~")>=0){let O=u.split("=~");return l.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(u.indexOf(" in ")>=0){let O=u.split(" in ");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const O=u.split(">=");return p.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const O=u.split(">");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const O=u.split("<=");return i.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const O=u.split("<");return C.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(u)?E.create(u.substr(1).trim()):h.create(u)}static _deserializeValue(u,F){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let O=/^'([^']*)'$/.exec(u);return O?O[1].trim():u}static _deserializeRegexValue(u,F){if((0,M.isFalsyOrWhitespace)(u)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=u.indexOf("/"),j=u.lastIndexOf("/");if(O===j||O<0){if(F)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let Q=u.slice(O+1,j),W=u[j+1]==="i"?"i":"";try{return new RegExp(Q,W)}catch(K){if(F)throw new Error(`bad regexp-value '${u}', parse error: ${K}`);return console.warn(`bad regexp-value '${u}', parse error: ${K}`),null}}}e.ContextKeyExpr=P;function t(b,u){return b.cmp(u)}class y{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class n{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class h{constructor(u,F){this.key=u,this.negated=F,this.type=2}static create(u,F=null){const O=R.get(u);return typeof O=="boolean"?O?n.INSTANCE:y.INSTANCE:new h(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:m(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class s{constructor(u,F,O){this.key=u,this.value=F,this.negated=O,this.type=4}static create(u,F,O=null){if(typeof F=="boolean")return F?h.create(u,O):E.create(u,O);const j=R.get(u);return typeof j=="boolean"?F===(j?"true":"false")?n.INSTANCE:y.INSTANCE:new s(u,F,O)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class d{constructor(u,F){this.key=u,this.valueKey=F,this.type=10,this.negated=null}static create(u,F){return new d(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const F=u.getValue(this.valueKey),O=u.getValue(this.key);return Array.isArray(F)?F.indexOf(O)>=0:typeof O=="string"&&typeof F=="object"&&F!==null?I.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=d;class v{constructor(u){this._actual=u,this.type=11}static create(u){return new v(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new v(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class k{constructor(u,F,O){this.key=u,this.value=F,this.negated=O,this.type=5}static create(u,F,O=null){if(typeof F=="boolean")return F?E.create(u,O):h.create(u,O);const j=R.get(u);return typeof j=="boolean"?F===(j?"true":"false")?y.INSTANCE:n.INSTANCE:new k(u,F,O)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class E{constructor(u,F){this.key=u,this.negated=F,this.type=3}static create(u,F=null){const O=R.get(u);return typeof O=="boolean"?O?y.INSTANCE:n.INSTANCE:new E(u,F)}cmp(u){return u.type!==this.type?this.type-u.type:m(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=E;class o{constructor(u,F,O){this.key=u,this.value=F,this.negated=O,this.type=12}static create(u,F,O=null){return new o(u,F,O)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class p{constructor(u,F,O){this.key=u,this.value=F,this.negated=O,this.type=13}static create(u,F,O=null){return new p(u,F,O)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=p;class C{constructor(u,F,O){this.key=u,this.value=F,this.negated=O,this.type=14}static create(u,F,O=null){return new C(u,F,O)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=C;class i{constructor(u,F,O){this.key=u,this.value=F,this.negated=O,this.type=15}static create(u,F,O=null){return new i(u,F,O)}cmp(u){return u.type!==this.type?this.type-u.type:S(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class l{constructor(u,F){this.key=u,this.regexp=F,this.type=7,this.negated=null}static create(u,F){return new l(u,F)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const F=this.regexp?this.regexp.source:"",O=u.regexp?u.regexp.source:"";return F<O?-1:F>O?1:0}equals(u){if(u.type===this.type){const F=this.regexp?this.regexp.source:"",O=u.regexp?u.regexp.source:"";return this.key===u.key&&F===O}return!1}evaluate(u){let F=u.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=l;class r{constructor(u){this._actual=u,this.type=8}static create(u){return new r(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new r(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class a{constructor(u,F){this.expr=u,this.negated=F,this.type=6}static create(u,F){return a._normalizeArr(u,F)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const j=t(this.expr[F],u.expr[F]);if(j!==0)return j}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(u.expr[F]))return!1;return!0}return!1}evaluate(u){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(u))return!1;return!0}static _normalizeArr(u,F){const O=[];let j=!1;for(const Q of u)if(!!Q){if(Q.type===1){j=!0;continue}if(Q.type===0)return y.INSTANCE;if(Q.type===6){O.push(...Q.expr);continue}O.push(Q)}if(O.length===0&&j)return n.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(t);for(let Q=1;Q<O.length;Q++)O[Q-1].equals(O[Q])&&(O.splice(Q,1),Q--);if(O.length===1)return O[0];for(;O.length>1;){const Q=O[O.length-1];if(Q.type!==9)break;O.pop();const W=O.pop(),K=O.length===0,$=w.create(Q.expr.map(U=>a.create([U,W],null)),null,K);$&&(O.push($),O.sort(t))}return O.length===1?O[0]:new a(O,F)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let F of this.expr)u.push(...F.keys());return u}map(u){return new a(this.expr.map(F=>F.map(u)),null)}negate(){if(!this.negated){const u=[];for(let F of this.expr)u.push(F.negate());this.negated=w.create(u,this,!0)}return this.negated}}class w{constructor(u,F){this.expr=u,this.negated=F,this.type=9}static create(u,F,O){return w._normalizeArr(u,F,O)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const j=t(this.expr[F],u.expr[F]);if(j!==0)return j}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(u.expr[F]))return!1;return!0}return!1}evaluate(u){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(u))return!0;return!1}static _normalizeArr(u,F,O){let j=[],Q=!1;if(u){for(let W=0,K=u.length;W<K;W++){const $=u[W];if(!!$){if($.type===0){Q=!0;continue}if($.type===1)return n.INSTANCE;if($.type===9){j=j.concat($.expr);continue}j.push($)}}if(j.length===0&&Q)return y.INSTANCE;j.sort(t)}if(j.length!==0){if(j.length===1)return j[0];for(let W=1;W<j.length;W++)j[W-1].equals(j[W])&&(j.splice(W,1),W--);if(j.length===1)return j[0];if(O){for(let W=0;W<j.length;W++)for(let K=W+1;K<j.length;K++)T(j[W],j[K])&&(j.splice(K,1),K--);if(j.length===1)return j[0]}return new w(j,F)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let F of this.expr)u.push(...F.keys());return u}map(u){return new w(this.expr.map(F=>F.map(u)),null)}negate(){if(!this.negated){let u=[];for(let F of this.expr)u.push(F.negate());for(;u.length>1;){const F=u.shift(),O=u.shift(),j=[];for(const W of g(F))for(const K of g(O))j.push(a.create([W,K],null));const Q=u.length===0;u.unshift(w.create(j,null,Q))}this.negated=u[0]}return this.negated}}class f extends h{constructor(u,F,O){super(u,null);this._defaultValue=F,typeof O=="object"?f._info.push({...O,key:u}):O!==!0&&f._info.push({key:u,description:O,type:F!=null?typeof F:void 0})}static all(){return f._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return s.create(this.key,u)}notEqualsTo(u){return k.create(this.key,u)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(b,u){return b<u?-1:b>u?1:0}function S(b,u,F,O){return b<F?-1:b>F?1:u<O?-1:u>O?1:0}function T(b,u){if(u.type===6&&b.type!==9&&b.type!==6){for(const j of u.expr)if(b.equals(j))return!0}const F=b.negate(),O=g(F).concat(g(u));O.sort(t);for(let j=0;j<O.length;j++){const W=O[j].negate();for(let K=j+1;K<O.length;K++){const $=O[K];if(W.equals($))return!0}}return!1}e.implies=T;function g(b){return b.type===9?b.expr:[b]}}),define(be[141],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(be[25],Ee([0,1,9,4]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=_;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class I{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,n){if(typeof y=="undefined"||y===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof y=="string"||typeof n=="string"){let h=typeof y=="string"?y:y.value,s=typeof n=="string"?n:n.value;return c.equalsIgnoreCase(h,s)}return y._lower===n._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=I;function D(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[142],Ee([0,1,9,25]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(s,d){return s.uuid&&d.uuid?s.uuid===d.uuid:s.id===d.id?!0:(0,c.compareIgnoreCase)(s.id,d.id)===0}e.areSameExtensions=_;class A{constructor(d,v){this.version=v,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof A?_(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=A;function R(s,d){return`${s}.${d}`}e.getExtensionId=R;function I(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(s,d){return I(R(s,d))}e.getGalleryExtensionId=D;function P(s,d){const v=[],k=E=>{for(const o of v)if(o.some(p=>_(d(p),d(E))))return o;return null};for(const E of s){const o=k(E);o?o.push(E):v.push([E])}return v}e.groupByExtension=P;function t(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function y(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(s){const d=new Set;for(const v of s)v.malicious&&d.add(v.id.id);return d}e.getMaliciousExtensionsSet=n;function h(s,d){const v=[],k=d.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const E=k.shift();if(E&&v.every(o=>!_(o.identifier,{id:E}))){const o=s.filter(p=>_(p.identifier,{id:E}));o.length===1&&(v.push(o[0]),k.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=h}),define(be[60],Ee([0,1,20,17,9,10,2,120,4]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var y;(function(W){W[W.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var n;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=h;function s(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=s;function d(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function v(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=v;var k;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(K,$){super(K);this.code=$}}e.FileSystemProviderError=E;function o(W,K){const $=new E(W.toString(),K);return C($,K),$}e.createFileSystemProviderError=o;function p(W){return W||o((0,I.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=p;function C(W,K){return W.name=K?`${K} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=C;function i(W){if(!W)return k.Unknown;if(W instanceof E)return W.code;const K=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!K)return k.Unknown;switch(K[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=i;function l(W){if(W instanceof S)return W.fileOperationResult;switch(i(W)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor(K,$,U){this.resource=K,this.operation=$,this.target=U}isOperation(K){return this.operation===K}}e.FileOperationEvent=a;var w;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(w=e.FileChangeType||(e.FileChangeType={}));class f{constructor(K,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of K)switch(U.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(()=>$)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(()=>$)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(()=>$)),this.deleted.set(U.resource,U);break}}contains(K,...$){return this.doContains(K,{includeChildren:!1},...$)}affects(K,...$){return this.doContains(K,{includeChildren:!0},...$)}doContains(K,$,...U){if(!K)return!1;const H=U.length>0;return!!((!H||U.includes(1))&&(this.added?.get(K)||$.includeChildren&&this.added?.findSuperstr(K))||(!H||U.includes(0))&&(this.updated?.get(K)||$.includeChildren&&this.updated?.findSuperstr(K))||(!H||U.includes(2))&&(this.deleted?.findSubstr(K)||$.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function m(W,K,$){return!W||!K||W===K||K.length>W.length?!1:(K.charAt(K.length-1)!==M.sep&&(K+=M.sep),$?(0,_.startsWithIgnoreCase)(W,K):W.indexOf(K)===0)}e.isParent=m;class S extends Error{constructor(K,$,U){super(K);this.fileOperationResult=$,this.options=U}}e.FileOperationError=S;class T extends S{constructor(K,$,U){super(K,2,U);this.stat=$}}e.NotModifiedSinceFileOperationError=T;var g;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var b;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(b=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=u;async function F(W,K){if(!K.canHandleResource(R.URI.from({scheme:W.scheme})))return new Promise($=>{const U=K.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===W.scheme&&H.added&&(U.dispose(),$())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(K){return(0,A.isNumber)(K)||(K=0),K<O.KB?(0,I.localize)(1,null,K.toFixed(0)):K<O.MB?(0,I.localize)(2,null,(K/O.KB).toFixed(2)):K<O.GB?(0,I.localize)(3,null,(K/O.MB).toFixed(2)):K<O.TB?(0,I.localize)(4,null,(K/O.GB).toFixed(2)):(0,I.localize)(5,null,(K/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var j;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function Q(W){return{maxFileSize:W===0?300*O.MB:16*O.GB,maxHeapSize:W===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=Q}),define(be[61],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(..._){this._entries=new Map;for(let[A,R]of _)this.set(A,R)}set(_,A){const R=this._entries.get(_);return this._entries.set(_,A),R}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=c}),define(be[143],Ee([0,1,14,16,81,138,4,61]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class t{constructor(s=new I.ServiceCollection,d=!1,v){this._activeInstantiations=new Set,this._services=s,this._strict=d,this._parent=v,this._services.set(R.IInstantiationService,this)}createChild(s){return new t(s,this._strict,this)}invokeFunction(s,...d){let v=n.traceInvocation(s),k=!1;try{return s({get:(o,p)=>{if(k)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const C=this._getOrCreateServiceInstance(o,v);if(!C&&p!==R.optional)throw new Error(`[invokeFunction] unknown service '${o}'`);return C}},...d)}finally{k=!0,v.stop()}}createInstance(s,...d){let v,k;return s instanceof _.SyncDescriptor?(v=n.traceCreation(s.ctor),k=this._createInstance(s.ctor,s.staticArguments.concat(d),v)):(v=n.traceCreation(s),k=this._createInstance(s,d,v)),v.stop(),k}_createInstance(s,d=[],v){let k=R._util.getServiceDependencies(s).sort((p,C)=>p.index-C.index),E=[];for(const p of k){let C=this._getOrCreateServiceInstance(p.id,v);if(!C&&this._strict&&!p.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${p.id}.`);E.push(C)}let o=k.length>0?k[0].index:d.length;if(d.length!==o){console.warn(`[createInstance] First service dependency of ${s.name} at position ${o+1} conflicts with ${d.length} static arguments`);let p=o-d.length;p>0?d=d.concat(new Array(p)):d=d.slice(0,o)}return new s(...[...d,...E])}_setServiceInstance(s,d){if(this._services.get(s)instanceof _.SyncDescriptor)this._services.set(s,d);else if(this._parent)this._parent._setServiceInstance(s,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let d=this._services.get(s);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):d}_getOrCreateServiceInstance(s,d){let v=this._getServiceInstanceOrDescriptor(s);return v instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,v,d.branch(s,!0)):(d.branch(s,!1),v)}_safeCreateAndCacheServiceInstance(s,d,v){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,d,v)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,d,v){const k=new A.Graph(p=>p.id.toString());let E=0;const o=[{id:s,desc:d,_trace:v}];for(;o.length;){const p=o.pop();if(k.lookupOrInsertNode(p),E++>1e3)throw new P(k);for(let C of R._util.getServiceDependencies(p.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(C.id);if(!i&&!C.optional&&console.warn(`[createInstance] ${s} depends on ${C.id} which is NOT registered.`),i instanceof _.SyncDescriptor){const l={id:C.id,desc:i,_trace:p._trace.branch(C.id,!0)};k.insertEdge(p,l),o.push(l)}}}for(;;){const p=k.roots();if(p.length===0){if(!k.isEmpty())throw new P(k);break}for(const{data:C}of p){if(this._getServiceInstanceOrDescriptor(C.id)instanceof _.SyncDescriptor){const l=this._createServiceInstanceWithOwner(C.id,C.desc.ctor,C.desc.staticArguments,C.desc.supportsDelayedInstantiation,C._trace);this._setServiceInstance(C.id,l)}k.removeNode(C)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,d,v=[],k,E){if(this._services.get(s)instanceof _.SyncDescriptor)return this._createServiceInstance(d,v,k,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,d,v,k,E);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(s,d=[],v,k){if(v){const E=new c.IdleValue(()=>this._createInstance(s,d,k));return new Proxy(Object.create(null),{get(o,p){if(p in o)return o[p];let C=E.value,i=C[p];return typeof i!="function"||(i=i.bind(C),o[p]=i),i},set(o,p,C){return E.value[p]=C,!0}})}else return this._createInstance(s,d,k)}}e.InstantiationService=t;var y;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(y||(y={}));class n{constructor(s,d){this.type=s,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return D?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return D?new n(0,s.name):n._None}branch(s,d){let v=new n(2,s.toString());return this._dep.push([s,d,v]),v}stop(){let s=Date.now()-this._start;n._totals+=s;let d=!1;function v(E,o){let p=[],C=new Array(E+1).join("	");for(const[i,l,r]of o._dep)if(l&&r){d=!0,p.push(`${C}CREATES -> ${i}`);let a=v(E+1,r);a&&p.push(a)}else p.push(`${C}uses -> ${i}`);return p.join(`
`)}let k=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||d)&&console.log(k.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,56,3,6,26,4]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...l){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([i,...l]))}debug(i,...l){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([i,...l]))}info(i,...l){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([i,...l]))}warn(i,...l){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([i,...l]))}error(i,...l){if(this.checkLogLevel(D.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([i,...l]))}critical(i,...l){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([i,...l]))}flush(){}format(i){let l="";for(let r=0;r<i.length;r++){let a=i[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch(w){}l+=(r>0?" ":"")+a}return l}}e.AbstractMessageLogger=t;class y extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...l){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...l):console.log(`[main ${I()}]`,i,...l))}debug(i,...l){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...l):console.log(`[main ${I()}]`,i,...l))}info(i,...l){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...l):console.log(`[main ${I()}]`,i,...l))}warn(i,...l){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...l):console.warn(`[main ${I()}]`,i,...l))}error(i,...l){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...l):console.error(`[main ${I()}]`,i,...l))}critical(i,...l){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...l):console.error(`[main ${I()}]`,i,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...l){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",i,...l)}debug(i,...l){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...l)}info(i,...l){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",i,...l)}warn(i,...l){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",i,...l)}error(i,...l){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",i,...l)}critical(i,...l){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...l)}dispose(){}flush(){}}e.ConsoleLogger=n;class h extends P{constructor(i,l=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(l)}trace(i,...l){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(i),...l])}debug(i,...l){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(i),...l])}info(i,...l){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(i),...l])}warn(i,...l){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(i),...l])}error(i,...l){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(i),...l])}critical(i,...l){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(i),...l])}extractMessage(i){return typeof i=="string"?i:(0,c.toErrorMessage)(i,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class s extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const l of this.logServices)l.setLevel(i);super.setLevel(i)}trace(i,...l){for(const r of this.logServices)r.trace(i,...l)}debug(i,...l){for(const r of this.logServices)r.debug(i,...l)}info(i,...l){for(const r of this.logServices)r.info(i,...l)}warn(i,...l){for(const r of this.logServices)r.warn(i,...l)}error(i,...l){for(const r of this.logServices)r.error(i,...l)}critical(i,...l){for(const r of this.logServices)r.critical(i,...l)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=s;class d extends _.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...l){this.logger.trace(i,...l)}debug(i,...l){this.logger.debug(i,...l)}info(i,...l){this.logger.info(i,...l)}warn(i,...l){this.logger.warn(i,...l)}error(i,...l){this.logger.error(i,...l)}critical(i,...l){this.logger.critical(i,...l)}flush(){this.logger.flush()}}e.LogService=d;class v extends _.Disposable{constructor(i,l){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(l(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,l){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,l?.always?D.Trace:this.logLevel,l),this.loggers.set(i.toString(),r),l?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class k{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return D.Info}trace(i,...l){}debug(i,...l){}info(i,...l){}warn(i,...l){}error(i,...l){}critical(i,...l){}dispose(){}flush(){}}e.NullLogService=k;function E(C){if(C.verbose)return D.Trace;if(typeof C.logLevel=="string"){const i=o(C.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function o(C){switch(C){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=o;function p(C){switch(C){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=p}),define(be[82],Ee([0,1,35,121,4]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(s,d){return d-s}D.compare=P;const t=Object.create(null);t[D.Error]=(0,M.localize)(0,null),t[D.Warning]=(0,M.localize)(1,null),t[D.Info]=(0,M.localize)(2,null);function y(s){return t[s]||""}D.toString=y;function n(s){switch(s){case c.default.Error:return D.Error;case c.default.Warning:return D.Warning;case c.default.Info:return D.Info;case c.default.Ignore:return D.Hint}}D.fromSeverity=n;function h(s){switch(s){case D.Error:return c.default.Error;case D.Warning:return c.default.Warning;case D.Info:return c.default.Info;case D.Hint:return c.default.Ignore}}D.toSeverity=h}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const P="";function t(n){return y(n,!0)}D.makeKey=t;function y(n,h){let s=[P];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(P),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(P),n.severity!==void 0&&n.severity!==null?s.push(R.toString(n.severity)):s.push(P),n.message&&h?s.push(n.message.replace("\xA6","\\\xA6")):s.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(P),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(P),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(P),s.push(P),s.join("\xA6")}D.makeKeyOptionalMessage=y})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(be[144],Ee([0,1,3,35,4]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,_.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=D}),define(be[145],Ee([0,1,6,9,2,4]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function R(I,D){return _.URI.isUri(I)?(0,M.equalsIgnoreCase)(I.scheme,D):(0,M.startsWithIgnoreCase)(I,D+":")}e.matchesScheme=R});var Ue=this&&this.__decorate||function(ie,e,c,M){var _=arguments.length,A=_<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,c):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,c,M);else for(var I=ie.length-1;I>=0;I--)(R=ie[I])&&(A=(_<3?R(A):_>3?R(e,c,A):R(e,c))||A);return _>3&&A&&Object.defineProperty(e,c,A),A},He=this&&this.__param||function(ie,e){return function(c,M){e(c,M,ie)}};define(be[146],Ee([0,1,14,21,6,4]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var R;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends _.Disposable{constructor(y,n){super();this.deferred=new c.DeferredPromise,n.withProgress(y,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};D=Ue([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends _.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(y){this.stop();const n=++this.currentOperationId,h=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:h.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,40,10]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(R,I){c.ok(M.isString(R)),c.ok(M.isObject(I)),c.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,I)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new _}),define(be[83],Ee([0,1,3,28]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[_(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;M.Registry.add(e.Extensions.JSONContribution,R)}),define(be[62],Ee([0,1,3,10,118,83,28]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=R.Registry.as(A.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new c.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new c.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,o=!0){this.registerConfigurations([E],o)}registerConfigurations(E,o=!0){const p=[];E.forEach(C=>{p.push(...this.validateAndRegisterProperties(C,o,C.extensionInfo)),this.configurationContributors.push(C),this.registerJSONConfiguration(C)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(E){const o=[],p=C=>{if(C.properties)for(const i in C.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,C.properties[i]);C.allOf&&C.allOf.forEach(i=>p(i))};for(const C of E){p(C);const i=this.configurationContributors.indexOf(C);i!==-1&&this.configurationContributors.splice(i,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(E){const o=[],p=[];for(const C of E)for(const i in C)if(o.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...C[i]};const l={type:"object",default:this.defaultValues[i],description:_.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};p.push(n(i)),this.configurationProperties[i]=l,this.defaultLanguageConfigurationOverridesNode.properties[i]=l}else{this.defaultValues[i]=C[i];const l=this.configurationProperties[i];l&&(this.updatePropertyDefaultValue(i,l),this.updateSchema(i,l))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(E){const o=[];for(const p of E)for(const C in p)if(o.push(C),delete this.defaultValues[C],e.OVERRIDE_PROPERTY_PATTERN.test(C))delete this.configurationProperties[C],delete this.defaultLanguageConfigurationOverridesNode.properties[C];else{const i=this.configurationProperties[C];i&&(this.updatePropertyDefaultValue(C,i),this.updateSchema(C,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const o of E)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,o=!0,p,C=3){C=M.isUndefinedOrNull(E.scope)?C:E.scope;let i=[],l=E.properties;if(l)for(let a in l){if(o&&d(a)){delete l[a];continue}const w=l[a];if(this.updatePropertyDefaultValue(a,w),e.OVERRIDE_PROPERTY_PATTERN.test(a)?w.scope=void 0:(w.scope=M.isUndefinedOrNull(w.scope)?C:w.scope,w.restricted=M.isUndefinedOrNull(w.restricted)?!!p?.restrictedConfigurations?.includes(a):w.restricted),l[a].hasOwnProperty("included")&&!l[a].included){this.excludedConfigurationProperties[a]=l[a],delete l[a];continue}else this.configurationProperties[a]=l[a];!l[a].deprecationMessage&&l[a].markdownDeprecationMessage&&(l[a].deprecationMessage=l[a].markdownDeprecationMessage),i.push(a)}let r=E.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,p,C));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const o=p=>{let C=p.properties;if(C)for(const l in C)this.updateSchema(l,C[l]);let i=p.allOf;i&&i.forEach(o)};o(E)}updateSchema(E,o){switch(e.allSettings.properties[E]=o,o.scope){case 1:e.applicationSettings.properties[E]=o;break;case 2:e.machineSettings.properties[E]=o;break;case 6:e.machineOverridableSettings.properties[E]=o;break;case 3:e.windowSettings.properties[E]=o;break;case 4:e.resourceSettings.properties[E]=o;break;case 5:e.resourceSettings.properties[E]=o,this.resourceLanguageSettingsSchema.properties[E]=o;break}}removeFromSchema(E,o){switch(delete e.allSettings.properties[E],o.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const o=`[${E}]`,p={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,p),e.allSettings.properties[o]=p,e.applicationSettings.properties[o]=p,e.machineSettings.properties[o]=p,e.machineOverridableSettings.properties[o]=p,e.windowSettings.properties[o]=p,e.resourceSettings.properties[o]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,o){let p=this.defaultValues[E];M.isUndefined(p)&&(p=o.default),M.isUndefined(p)&&(p=h(o.type)),o.default=p}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function n(k){return k.substring(1,k.length-1)}e.overrideIdentifierFromKey=n;function h(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const s=new t;R.Registry.add(e.Extensions.Configuration,s);function d(k){return k.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(k)?_.localize(5,null,k):s.getConfigurationProperties()[k]!==void 0?_.localize(6,null,k):null:_.localize(4,null)}e.validateProperty=d;function v(){const k=[],E=s.getConfigurationProperties();for(const o of Object.keys(E))k.push([o,E[o].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=v}),define(be[84],Ee([0,1,22,10,2,62,4,28]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function D(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof _.URI)}e.isConfigurationOverrides=D;var P;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function y(l,r){const a=r?l?r.keys.filter(b=>l.keys.indexOf(b)===-1):[...r.keys]:[],w=l?r?l.keys.filter(b=>r.keys.indexOf(b)===-1):[...l.keys]:[],f=[];if(r&&l){for(const b of l.keys)if(r.keys.indexOf(b)!==-1){const u=k(l.contents,b),F=k(r.contents,b);c.equals(u,F)||f.push(b)}}const m=[],S=b=>{const u={};for(const F of b)for(const O of F.identifiers)u[C(O)]=F;return u},T=r?S(r.overrides):{},g=l?S(l.overrides):{};if(Object.keys(T).length)for(const b of a){const u=T[b];u&&m.push([(0,A.overrideIdentifierFromKey)(b),u.keys])}if(Object.keys(g).length)for(const b of w){const u=g[b];u&&m.push([(0,A.overrideIdentifierFromKey)(b),u.keys])}if(Object.keys(T).length&&Object.keys(g).length)for(const b of f){const u=g[b],F=T[b];if(u&&F){const O=y({contents:u.contents,keys:u.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});m.push([(0,A.overrideIdentifierFromKey)(b),[...O.added,...O.removed,...O.updated]])}}return{added:a,removed:w,updated:f,overrides:m}}e.compare=y;function n(l,r){const a=[];for(const w of Object.keys(l))if(A.OVERRIDE_PROPERTY_PATTERN.test(w)){const f={};for(const m in l[w])f[m]=l[w][m];a.push({identifiers:[(0,A.overrideIdentifierFromKey)(w).trim()],keys:Object.keys(f),contents:h(f,r)})}return a}e.toOverrides=n;function h(l,r){const a=Object.create(null);for(let w in l)s(a,w,l[w],r);return a}e.toValuesTree=h;function s(l,r,a,w){const f=r.split("."),m=f.pop();let S=l;for(let T=0;T<f.length;T++){let g=f[T],b=S[g];switch(typeof b){case"undefined":b=S[g]=Object.create(null);break;case"object":break;default:w(`Ignoring ${r} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(b)}`);return}S=b}if(typeof S=="object"&&S!==null)try{S[m]=a}catch(T){w(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(S)}`)}else w(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=s;function d(l,r){const a=r.split(".");v(l,a)}e.removeFromValueTree=d;function v(l,r){const a=r.shift();if(r.length===0){delete l[a];return}if(Object.keys(l).indexOf(a)!==-1){const w=l[a];typeof w=="object"&&!Array.isArray(w)&&(v(w,r),Object.keys(w).length===0&&delete l[a])}}function k(l,r,a){function w(S,T){let g=S;for(const b of T){if(typeof g!="object"||g===null)return;g=g[b]}return g}const f=r.split("."),m=w(l,f);return typeof m=="undefined"?a:m}e.getConfigurationValue=k;function E(l,r,a){Object.keys(r).forEach(w=>{w!=="__proto__"&&(w in l?M.isObject(l[w])&&M.isObject(r[w])?E(l[w],r[w],a):a&&(l[w]=r[w]):l[w]=r[w])})}e.merge=E;function o(){const l=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=o;function p(){const l=Object.create(null),r=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let a in r){let w=r[a].default;s(l,a,w,f=>console.error(`Conflict in default settings: ${f}`))}return l}e.getDefaultValues=p;function C(l){return`[${l}]`}e.keyFromOverrideIdentifier=C;function i(l,r,a){const w=l.inspect(r),f=l.inspect(a);return typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:w.defaultValue}e.getMigratedSettingValue=i}),define(be[147],Ee([0,1,13,3,102,6,20,22,10,2,84,62,28]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(i={},l=[],r=[]){this._contents=i,this._keys=l,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,l){const r=this.getContentsForOverrideIdentifer(l);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.keys;return[]}override(i){const l=this.getContentsForOverrideIdentifer(i);if(!l||typeof l!="object"||!Object.keys(l).length)return this;let r={};for(const a of c.distinct([...Object.keys(this.contents),...Object.keys(l)])){let w=this.contents[a],f=l[a];f&&(typeof w=="object"&&typeof f=="object"?(w=I.deepClone(w),this.mergeContents(w,f)):w=f),r[a]=w}return new h(r,this.keys,this.overrides)}merge(...i){const l=I.deepClone(this.contents),r=I.deepClone(this.overrides),a=[...this.keys];for(const w of i){this.mergeContents(l,w.contents);for(const f of w.overrides){const[m]=r.filter(S=>c.equals(S.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):r.push(I.deepClone(f))}for(const f of w.keys)a.indexOf(f)===-1&&a.push(f)}return new h(l,a,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,l){for(const r of Object.keys(l)){if(r in i&&D.isObject(i[r])&&D.isObject(l[r])){this.mergeContents(i[r],l[r]);continue}i[r]=I.deepClone(l[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const l of this.overrides)if(l.identifiers.indexOf(i)!==-1)return l.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,l){this.addKey(i),(0,t.addToValueTree)(this.contents,i,l,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let l=this.keys.length;for(let r=0;r<l;r++)i.indexOf(this.keys[r])===0&&(l=r);this.keys.splice(l,1,i)}removeKey(i){let l=this.keys.indexOf(i);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=h;class s extends h{constructor(){const i=(0,t.getDefaultValues)(),l=(0,t.getConfigurationKeys)(),r=[];for(const a of Object.keys(i))y.OVERRIDE_PROPERTY_PATTERN.test(a)&&r.push({identifiers:[(0,y.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(i[a]),contents:(0,t.toValuesTree)(i[a],w=>console.error(`Conflict in default settings file: ${w}`))});super(i,l,r)}}e.DefaultConfigurationModel=s;class d{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,l){if(!D.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,l)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,l){this._raw=i;const{contents:r,keys:a,overrides:w,restricted:f}=this.doParseRaw(i,l);this._configurationModel=new h(r,a,w),this._restrictedConfigurations=f||[]}doParseContent(i){let l={},r=null,a=[],w=[],f=[];function m(T){Array.isArray(a)?a.push(T):r!==null&&(a[r]=T)}let S={onObjectBegin:()=>{let T={};m(T),w.push(a),a=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{a=w.pop()},onArrayBegin:()=>{let T=[];m(T),w.push(a),a=T,r=null},onArrayEnd:()=>{a=w.pop()},onLiteralValue:m,onError:(T,g,b)=>{f.push({error:T,offset:g,length:b})}};if(i)try{_.visit(i,S),l=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return l}doParseRaw(i,l){const r=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.filter(i,r,!0,l);i=a.raw;const w=(0,t.toValuesTree)(i,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),f=Object.keys(i),m=(0,t.toOverrides)(i,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:w,keys:f,overrides:m,restricted:a.restricted}}filter(i,l,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[]};const w={},f=[];for(let m in i)if(y.OVERRIDE_PROPERTY_PATTERN.test(m)&&r){const S=this.filter(i[m],l,!1,a);w[m]=S.raw,f.push(...S.restricted)}else{const S=l[m],T=S?typeof S.scope!="undefined"?S.scope:3:void 0;S?.restricted&&f.push(m),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&(a.skipRestricted&&S?.restricted||(w[m]=i[m]))}return{raw:w,restricted:f}}}e.ConfigurationModelParser=d;class v extends A.Disposable{constructor(i,l,r,a){super();this.userSettingsResource=i,this.scopes=l,this.fileService=a,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class k{constructor(i,l,r=new h,a=new h,w=new R.ResourceMap,f=new h,m=new R.ResourceMap,S=!0){this._defaultConfiguration=i,this._localUserConfiguration=l,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=w,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,l,r){return this.getConsolidateConfigurationModel(l,r).getValue(i)}updateValue(i,l,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new h,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,l===void 0?a.removeValue(i):a.setValue(i,l),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,l,r){const a=this.getConsolidateConfigurationModel(l,r),w=this.getFolderConfigurationModelForResource(l.resource,r),f=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,m=l.overrideIdentifier?this._defaultConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),S=l.overrideIdentifier?this.userConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),T=l.overrideIdentifier?this.localUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),g=l.overrideIdentifier?this.remoteUserConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),b=r?l.overrideIdentifier?this._workspaceConfiguration.freeze().override(l.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,u=w?l.overrideIdentifier?w.freeze().override(l.overrideIdentifier).getValue(i):w.freeze().getValue(i):void 0,F=l.overrideIdentifier?f.override(l.overrideIdentifier).getValue(i):f.getValue(i),O=a.getValue(i),j=c.distinct(c.flatten(a.overrides.map(Q=>Q.identifiers))).filter(Q=>a.getOverrideValue(i,Q)!==void 0);return{defaultValue:m,userValue:S,userLocalValue:T,userRemoteValue:g,workspaceValue:b,workspaceFolderValue:u,memoryValue:F,value:O,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspace:b!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:l.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,workspaceFolder:u!==void 0?{value:w?.freeze().getValue(i),override:l.overrideIdentifier?w?.freeze().getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:f.getValue(i),override:l.overrideIdentifier?f.getOverrideValue(i,l.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(i){const l=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,l){this._folderConfigurations.set(i,l),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,l){const r=l.filter(a=>y.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const w=(0,y.overrideIdentifierFromKey)(a),f=this._defaultConfiguration.getKeysForOverrideIdentifier(w),m=i.getKeysForOverrideIdentifier(w),S=[...m.filter(T=>f.indexOf(T)===-1),...f.filter(T=>m.indexOf(T)===-1),...f.filter(T=>!I.equals(this._defaultConfiguration.override(w).getValue(T),i.override(w).getValue(T)))];return[w,S]});return this.updateDefaultConfiguration(i),{keys:l,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:l,updated:r,removed:a,overrides:w}=(0,t.compare)(this.localUserConfiguration,i),f=[...l,...r,...a];return f.length&&this.updateLocalUserConfiguration(i),{keys:f,overrides:w}}compareAndUpdateRemoteUserConfiguration(i){const{added:l,updated:r,removed:a,overrides:w}=(0,t.compare)(this.remoteUserConfiguration,i);let f=[...l,...r,...a];return f.length&&this.updateRemoteUserConfiguration(i),{keys:f,overrides:w}}compareAndUpdateWorkspaceConfiguration(i){const{added:l,updated:r,removed:a,overrides:w}=(0,t.compare)(this.workspaceConfiguration,i);let f=[...l,...r,...a];return f.length&&this.updateWorkspaceConfiguration(i),{keys:f,overrides:w}}compareAndUpdateFolderConfiguration(i,l){const r=this.folderConfigurations.get(i),{added:a,updated:w,removed:f,overrides:m}=(0,t.compare)(r,l);let S=[...a,...w,...f];return(S.length||!r)&&this.updateFolderConfiguration(i,l),{keys:S,overrides:m}}compareAndDeleteFolderConfiguration(i){const l=this.folderConfigurations.get(i);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:w,overrides:f}=(0,t.compare)(l,void 0);return{keys:[...r,...a,...w],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,l){let r=this.getConsolidatedConfigurationModelForResource(i,l);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},l){let r=this.getWorkspaceConsolidatedConfiguration();if(l&&i){const a=l.getFolder(i);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const w=this._memoryConfigurationByResource.get(i);w&&(r=r.merge(w))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let l=this._foldersConsolidatedConfigurations.get(i);if(!l){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(i);a?(l=r.merge(a),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(i,l)):l=r}return l}getFolderConfigurationModelForResource(i,l){if(l&&i){const r=l.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,l)=>{const{contents:r,overrides:a,keys:w}=this._folderConfigurations.get(l);return i.push([l,{contents:r,overrides:a,keys:w}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>i.add(l)),this.userConfiguration.freeze().keys.forEach(l=>i.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>i.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>l.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>l.add(a))),[...l.values()]}static parse(i){const l=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),a=this.parseConfigurationModel(i.workspace),w=i.folders.reduce((f,m)=>(f.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new R.ResourceMap);return new k(l,r,new h,a,w,new h,new R.ResourceMap,!1)}static parseConfigurationModel(i){return new h(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=k;function E(...C){if(C.length===0)return{keys:[],overrides:[]};if(C.length===1)return C[0];const i=new Set,l=new Map;for(const a of C)a.keys.forEach(w=>i.add(w)),a.overrides.forEach(([w,f])=>{const m=(0,R.getOrSet)(l,w,new Set);f.forEach(S=>m.add(S))});const r=[];return l.forEach((a,w)=>r.push([w,[...a.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=E;class o{constructor(i,l,r,a){this.change=i,this.previous=l,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const w=new Set;i.keys.forEach(m=>w.add(m)),i.overrides.forEach(([,m])=>m.forEach(S=>w.add(S))),this.affectedKeys=[...w.values()];const f=new h;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=k.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(l){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,l,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(i,l,this.currentWorkspace);return!I.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(i,l){let r=(0,t.toValuesTree)({[l]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(i=i[a],!i)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=o;class p extends o{constructor(i,l,r,a){super({keys:i.allKeys(),overrides:[]},void 0,i,l);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=p}),define(be[85],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(R,I=M.Unknown,D){super(R);this._message=R,this._code=I,this._detail=D,this.isHandled=I===M.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(R){return R instanceof _&&R._code===M.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof _&&R._code===M.NoResolverFound}static isHandled(R){return R instanceof _&&R.isHandled}}e.RemoteAuthorityResolverError=_}),define(be[86],Ee([0,1,11]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===c.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function _(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=_;function A(P){return P.scheme!==c.Schemas.file&&P.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function R(P){if(P.folders.length)return P.folders.every(t=>A(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&A(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=R;function I(P){return R(P)?.scheme}e.getVirtualWorkspaceScheme=I;function D(P){return R(P)!==void 0}e.isVirtualWorkspace=D}),define(be[148],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var M;(function(s){s.Shell="terminal.integrated.shell.",s.ShellArgs="terminal.integrated.shellArgs.",s.DefaultProfile="terminal.integrated.defaultProfile.",s.Profiles="terminal.integrated.profiles."})(M=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var _;(function(s){s.ShellLinux="terminal.integrated.shell.linux",s.ShellMacOs="terminal.integrated.shell.osx",s.ShellWindows="terminal.integrated.shell.windows",s.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",s.AutomationShellLinux="terminal.integrated.automationShell.linux",s.AutomationShellMacOs="terminal.integrated.automationShell.osx",s.AutomationShellWindows="terminal.integrated.automationShell.windows",s.ShellArgsLinux="terminal.integrated.shellArgs.linux",s.ShellArgsMacOs="terminal.integrated.shellArgs.osx",s.ShellArgsWindows="terminal.integrated.shellArgs.windows",s.ProfilesWindows="terminal.integrated.profiles.windows",s.ProfilesMacOs="terminal.integrated.profiles.osx",s.ProfilesLinux="terminal.integrated.profiles.linux",s.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",s.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",s.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",s.UseWslProfiles="terminal.integrated.useWslProfiles",s.TabsEnabled="terminal.integrated.tabs.enabled",s.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",s.TabsHideCondition="terminal.integrated.tabs.hideCondition",s.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",s.TabsShowActions="terminal.integrated.tabs.showActions",s.TabsLocation="terminal.integrated.tabs.location",s.TabsFocusMode="terminal.integrated.tabs.focusMode",s.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",s.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",s.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",s.CopyOnSelection="terminal.integrated.copyOnSelection",s.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",s.FontFamily="terminal.integrated.fontFamily",s.FontSize="terminal.integrated.fontSize",s.LetterSpacing="terminal.integrated.letterSpacing",s.LineHeight="terminal.integrated.lineHeight",s.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",s.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",s.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",s.BellDuration="terminal.integrated.bellDuration",s.FontWeight="terminal.integrated.fontWeight",s.FontWeightBold="terminal.integrated.fontWeightBold",s.CursorBlinking="terminal.integrated.cursorBlinking",s.CursorStyle="terminal.integrated.cursorStyle",s.CursorWidth="terminal.integrated.cursorWidth",s.Scrollback="terminal.integrated.scrollback",s.DetectLocale="terminal.integrated.detectLocale",s.DefaultLocation="terminal.integrated.defaultLocation",s.GpuAcceleration="terminal.integrated.gpuAcceleration",s.RightClickBehavior="terminal.integrated.rightClickBehavior",s.Cwd="terminal.integrated.cwd",s.ConfirmOnExit="terminal.integrated.confirmOnExit",s.ConfirmOnKill="terminal.integrated.confirmOnKill",s.EnableBell="terminal.integrated.enableBell",s.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",s.AllowChords="terminal.integrated.allowChords",s.AllowMnemonics="terminal.integrated.allowMnemonics",s.EnvMacOs="terminal.integrated.env.osx",s.EnvLinux="terminal.integrated.env.linux",s.EnvWindows="terminal.integrated.env.windows",s.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",s.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",s.ShowExitAlert="terminal.integrated.showExitAlert",s.SplitCwd="terminal.integrated.splitCwd",s.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",s.WordSeparators="terminal.integrated.wordSeparators",s.TitleMode="terminal.integrated.titleMode",s.EnableFileLinks="terminal.integrated.enableFileLinks",s.UnicodeVersion="terminal.integrated.unicodeVersion",s.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",s.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",s.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",s.LocalEchoStyle="terminal.integrated.localEchoStyle",s.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",s.CustomGlyphs="terminal.integrated.customGlyphs",s.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",s.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",s.InheritEnv="terminal.integrated.inheritEnv",s.ShowLinkHover="terminal.integrated.showLinkHover"})(_=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(s){s.CommandPrompt="cmd",s.PowerShell="pwsh",s.Wsl="wsl",s.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var R;(function(s){s[s.Api=0]="Api",s[s.Process=1]="Process",s[s.Sequence=2]="Sequence"})(R=e.TitleEventSource||(e.TitleEventSource={}));var I;(function(s){s.LocalPty="localPty",s.PtyHost="ptyHost",s.Log="log",s.Heartbeat="heartbeat"})(I=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,c.createDecorator)("ptyService");var D;(function(s){s[s.BeatInterval=5e3]="BeatInterval",s[s.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",s[s.SecondWaitMultiplier=1]="SecondWaitMultiplier",s[s.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(D=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(s){s[s.Panel=1]="Panel",s[s.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var t;(function(s){s.TerminalView="view",s.Editor="editor"})(t=e.TerminalLocationString||(e.TerminalLocationString={}));var y;(function(s){s[s.GraceTime=6e4]="GraceTime",s[s.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var n;(function(s){s[s.HighWatermarkChars=1e5]="HighWatermarkChars",s[s.LowWatermarkChars=5e3]="LowWatermarkChars",s[s.CharCountAckSize=5e3]="CharCountAckSize"})(n=e.FlowControlConstants||(e.FlowControlConstants={}));var h;(function(s){s.GitBash="Git Bash",s.Pwsh="PowerShell"})(h=e.ProfileSource||(e.ProfileSource={}))}),define(be[149],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,A,R=5){let I;return I=A(D=>{const P=typeof D=="string"?D:D.data;let t=this._terminalBufferMap.get(_);if(t){t.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(_),R);t={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(_),I.dispose()}},this._terminalBufferMap.set(_,t)}),I}stopBuffering(_){const A=this._terminalBufferMap.get(_);A&&A.dispose()}flushBuffer(_){const A=this._terminalBufferMap.get(_);A&&(this._terminalBufferMap.delete(_),this._callback(_,A.data.join("")))}}e.TerminalDataBufferer=c}),define(be[150],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(be[44],Ee([0,1,34,3,6,4,28,150]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var D;(function(v){function k(E){return E&&typeof E=="object"&&typeof E.id=="string"}v.isThemeColor=k})(D=e.ThemeColor||(e.ThemeColor={}));function P(v){return{id:v}}e.themeColorFromId=P;var t;(function(v){function k(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color=="undefined"||D.isThemeColor(l.color))}v.isThemeIcon=k;const E=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function o(l){const r=E.exec(l);if(!r)return;let[,a]=r;return{id:a}}v.fromString=o;function p(l,r){let a=l.id;const w=a.lastIndexOf("~");return w!==-1&&(a=a.substring(0,w)),r&&(a=`${a}~${r}`),{id:a}}v.modify=p;function C(l,r){return l.id===r.id&&l.color?.id===r.color?.id}v.isEqual=C;function i(l,r){return{id:l.id,color:r?P(r):void 0}}v.asThemeIcon=i,v.asClassNameArray=c.CSSIcon.asClassNameArray,v.asClassName=c.CSSIcon.asClassName,v.asCSSSelector=c.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function y(v){switch(v){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(k){return this.themingParticipants.push(k),this.onThemingParticipantAddedEmitter.fire(k),(0,_.toDisposable)(()=>{const E=this.themingParticipants.indexOf(k);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new n;R.Registry.add(e.Extensions.ThemingContribution,h);function s(v){return h.onColorThemeChange(v)}e.registerThemingParticipant=s;class d extends _.Disposable{constructor(k){super();this.themeService=k,this.theme=k.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(k){this.theme=k,this.updateStyles()}updateStyles(){}getColor(k,E){let o=this.theme.getColor(k);return o&&E&&(o=E(o,this.theme)),o?o.toString():null}}e.Themable=d}),define(be[151],Ee([0,1,14,34,3,122,83,28,44]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(k,E,o,p){const C=this.iconsById[k];if(C){if(o&&!C.description){C.description=o,this.iconSchema.properties[k].markdownDescription=`${o} $(${k})`;const r=this.iconReferenceSchema.enum.indexOf(k);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=o),this._onDidChange.fire()}return C}let i={id:k,description:o,defaults:E,deprecationMessage:p};this.iconsById[k]=i;let l={$ref:"#/definitions/icons"};return p&&(l.deprecationMessage=p),o&&(l.markdownDescription=`${o}: $(${k})`),this.iconSchema.properties[k]=l,this.iconReferenceSchema.enum.push(k),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:k}}deregisterIcon(k){delete this.iconsById[k],delete this.iconSchema.properties[k];const E=this.iconReferenceSchema.enum.indexOf(k);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(k=>this.iconsById[k])}getIcon(k){return this.iconsById[k]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(k,E){const o=this.iconFontsById[k];if(o)return o;let p={id:k,definition:E};return this.iconFontsById[k]=p,this._onDidChange.fire(),p}deregisterIconFont(k){delete this.iconFontsById[k]}getIconFonts(){return Object.keys(this.iconFontsById).map(k=>this.iconFontsById[k])}getIconFont(k){return this.iconFontsById[k]}toString(){const k=(C,i)=>C.id.localeCompare(i.id),E=C=>{for(;D.ThemeIcon.isThemeIcon(C.defaults);)C=this.iconsById[C.defaults.id];return`codicon codicon-${C?C.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.iconsById).map(C=>this.iconsById[C]);for(const C of p.filter(i=>!!i.description).sort(k))o.push(`|<i class="${E(C)}"></i>|${C.id}|${D.ThemeIcon.isThemeIcon(C.defaults)?C.defaults.id:C.id}|${C.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const C of p.filter(i=>!D.ThemeIcon.isThemeIcon(i.defaults)).sort(k))o.push(`|<i class="${E(C)}"></i>|${C.id}|`);return o.join(`
`)}}const t=new P;I.Registry.add(e.Extensions.IconContribution,t);function y(v,k,E,o){return t.registerIcon(v,k,E,o)}e.registerIcon=y;function n(){return t}e.getIconRegistry=n;function h(){for(const v of M.iconRegistry.all)t.registerIcon(v.id,v.definition,v.description);M.iconRegistry.onDidRegister(v=>t.registerIcon(v.id,v.definition,v.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let s=I.Registry.as(R.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,t.getIconSchema());const d=new c.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=y("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=y("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=y("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=D.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[45],Ee([0,1,20,24,2,4]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var R;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function I(n){const h=n;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=I;function D(n){const h=n;return!!(h&&typeof h=="object"&&_.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(h,s,d,v){this._id=h,this._configuration=d,this._ignorePathCasing=v,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class t{constructor(h,s){this.raw=s,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,M.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function y(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=y}),define(be[63],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const A=this._idPool++;return this._data.set(A,_),this.logDebugInfo(),A}get(_,A){return this._data.has(_)?this._data.get(_)[A]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(I=>{const D=this._providerInfo.get(I.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(I,D){D===null?this._providerInfo.delete(I):this._providerInfo.set(I,D)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(be[152],Ee([0,1,14]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(R,I,D){this._deferredPromises=new Map,this._id=R,this._shared=I,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const y of P.values())y.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,I){let D=this._value[R];return typeof D=="undefined"&&(D=I),D}update(R,I){this._value[R]=I;let D=this._deferredPromises.get(R);if(D!==void 0)return D.p;const P=new c.DeferredPromise;return this._deferredPromises.set(R,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class _ extends M{constructor(R,I){super(R.identifier.value,!0,I);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=_}),define(be[153],Ee([0,1,3,2,15]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(I,D){this._logService=I,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,D,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(I)).acceptModelChanged(D.value,P)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,D);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(I));P.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};A=Ue([He(0,_.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[12],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[154],Ee([0,1,25,3]),function(ie,e,c,M){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(I,D){_.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(I.identifier),Je(this,_,D,"f"),Te(this,_,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(I){return Te(this,_,"f").get(this._id,I)}store(I,D){return Te(this,_,"f").store(this._id,I,D)}delete(I){return Te(this,_,"f").delete(this._id,I)}}e.ExtensionSecrets=A,_=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(be[46],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,_=(E,o)=>{const p={controllerId:o};return M.set(E,p),p};e.createPrivateApiFor=_;const A=E=>M.get(E);e.getPrivateApiFor=A;const R=(E,o,p,C)=>{let i=p;return{enumerable:!0,configurable:!1,get(){return i},set(l){if(!C(i,l)){const r=i;i=l,E.listener?.({op:3,key:o,value:l,previous:r})}}}},I=(E,o)=>E===o,D={range:(E,o)=>E===o?!0:!E||!o?!1:E.isEqual(o),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(E,o)=>!(E.length!==o.length||E.some(p=>!o.find(C=>p.id===C.id)))},P=Object.keys(D),t=(E,o)=>({range:R(E,"range",void 0,D.range),label:R(E,"label",o,D.label),description:R(E,"description",void 0,D.description),canResolveChildren:R(E,"canResolveChildren",!1,D.canResolveChildren),busy:R(E,"busy",!1,D.busy),error:R(E,"error",void 0,D.error),tags:R(E,"tags",[],D.tags)}),y=(E,o)=>{const p=new Map;for(const C of P)D[C](E[C],o[C])||p.set(C,o[C]);return p};e.diffTestItems=y;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class h extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class s extends Error{constructor(o,p,C){super(`TestItem with ID "${o}" is from controller "${p}" and cannot be added as a child of an item from controller "${C}".`)}}e.MixedTestItemController=s;const d=E=>{const o=(0,e.getPrivateApiFor)(E);let p=new Map;return{get size(){return p.size},forEach(C,i){for(const l of p.values())C.call(i,l,this)},replace(C){const i=new Map,l=new Set(p.keys()),r={op:4,ops:[]};for(const a of C){if(!(a instanceof v))throw new h(a.id);const w=(0,e.getPrivateApiFor)(a).controllerId;if(w!==o.controllerId)throw new s(a.id,w,o.controllerId);if(i.has(a.id))throw new n(a.id);i.set(a.id,a),l.delete(a.id),r.ops.push({op:0,item:a})}for(const a of l.keys())r.ops.push({op:1,id:a});o.listener?.(r),p=i},add(C){if(!(C instanceof v))throw new h(C.id);p.set(C.id,C),o.listener?.({op:0,item:C})},delete(C){p.delete(C)&&o.listener?.({op:1,id:C})},get(C){return p.get(C)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class v{constructor(o,p,C,i){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const l=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof k?void 0:l.parent}},children:{value:d(this),enumerable:!0,writable:!1},...t(l,C)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class k extends v{constructor(o,p){super(o,o,p,void 0)}}e.TestItemRootImpl=k}),define(be[64],Ee([0,1,4,3,12]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(I){function D(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}I.fromApiTunnel=D;function P(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}I.fromServiceTunnel=P})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let R=class{constructor(D){this.onDidChangeTunnels=new M.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,t,y,n){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ue([He(0,_.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[7],Ee([0,1,13,16,76,20,78,10,2,36,60,85]),function(ie,e,c,M,_,A,R,I,D,P,t,y){"use strict";var n,h,s,d,v,k,E,o,p,C,i,l,r,a,w,f,m,S,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function b(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let u=v=class{constructor(L){n.set(this,void 0),Je(this,n,L,"f")}static from(...L){let te=L;return new v(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Te(this,n,"f")=="function"&&(Te(this,n,"f").call(this),Je(this,n,void 0,"f"))}};n=new WeakMap,u=v=Ue([b],u),e.Disposable=u;let F=k=class{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(L){if(!L)return!1;if(L instanceof k)return!0;let{line:te,character:_e}=L;return typeof te=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&te===0?this:new k(this.line+_e,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),_e===this.line&&te===this.character?this:new k(_e,te)}toJSON(){return{line:this.line,character:this.character}}};F=k=Ue([b],F),e.Position=F;let O=E=class{constructor(L,te,_e,Ke){let et,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(L,te),st=new F(_e,Ke)):L instanceof F&&te instanceof F&&(et=L,st=te),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(L){return L instanceof E?!0:L?F.isPosition(L.start)&&F.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof E?this.contains(L._start)&&this.contains(L._end):L instanceof F?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=F.Max(L.start,this._start),_e=F.Min(L.end,this._end);if(!te.isAfter(_e))return new E(te,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=F.Min(L.start,this._start),_e=F.Max(L.end,this.end);return new E(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return L?F.isPosition(L)?_e=L:(_e=L.start||this.start,te=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new E(_e,te)}toJSON(){return[this.start,this.end]}};O=E=Ue([b],O),e.Range=O;let j=o=class extends O{constructor(L,te,_e,Ke){let et,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(et=new F(L,te),st=new F(_e,Ke)):L instanceof F&&te instanceof F&&(et=L,st=te),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(L){return L instanceof o?!0:L?O.isRange(L)&&F.isPosition(L.anchor)&&F.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};j=o=Ue([b],j),e.Selection=j;class Q{constructor(L,te,_e){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=Q;class W extends Error{constructor(L,te=y.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable(L,te){return new W(L,y.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new W(L,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var K;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var $;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let U=p=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof p?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new p(L,te)}static insert(L,te){return p.replace(new O(L,L),te)}static delete(L){return p.replace(L,"")}static setEndOfLine(L){const te=new p(new O(new F(0,0),new F(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!O.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};U=p=Ue([b],U),e.TextEdit=U;var H;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,_e,Ke){this._edits.push({_type:1,from:L,to:te,options:_e,metadata:Ke})}createFile(L,te,_e){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:_e})}deleteFile(L,te,_e){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(L,te,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,_e,Ke,et){let st,at,yt=[],At;if(zt.isNotebookRange(te)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(Ke)?(st=te.start,at=te.end,yt=_e,At=Ke):typeof te=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(Ke)&&(st=te,at=_e,yt=Ke,At=et),st===void 0||at===void 0)throw new Error("Invalid arguments");(st!==at||yt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:at-st,cells:yt,metadata:At})}replaceNotebookCellMetadata(L,te,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:L,edit:{editType:8,index:te,metadata:_e}})}replace(L,te,_e,Ke){this._edits.push({_type:2,uri:L,edit:new U(te,_e),metadata:Ke})}insert(L,te,_e,Ke){this.replace(L,new O(te,te),_e,Ke)}delete(L,te,_e){this.replace(L,te,"",_e)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&te.push(_e.edit);return te}entries(){const L=new A.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=L.get(te.uri);_e||(_e=[te.uri,[]],L.set(te.uri,_e)),_e[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Ue([b],G),e.WorkspaceEdit=G;let ue=C=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof C?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=C._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const _e=new C;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=C._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const _e=L.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const _e=new C;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ue=C=Ue([b],ue),e.SnippetString=ue;var q;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(q=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let se=i=class{constructor(L,te){if(this.uri=L,te)if(te instanceof O)this.range=te;else if(te instanceof F)this.range=new O(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?O.isRange(L.range)&&D.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};se=i=Ue([b],se),e.Location=se;let ve=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};ve=Ue([b],ve),e.DiagnosticRelatedInformation=ve;let Fe=class{constructor(L,te,_e=le.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,c.equals)(L.tags,te.tags)&&(0,c.equals)(L.relatedInformation,te.relatedInformation,ve.isEqual)}};Fe=Ue([b],Fe),e.Diagnostic=Fe;let Me=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};Me=Ue([b],Me),e.Hover=Me;var Ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(L,te=Ne.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};Qe=Ue([b],Qe),e.DocumentHighlight=Qe;var ze;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var qe;(function(N){N[N.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let x=l=class{constructor(L,te,_e,Ke,et){this.name=L,this.kind=te,this.containerName=et,typeof _e=="string"&&(this.containerName=_e),Ke instanceof se?this.location=Ke:_e instanceof O&&(this.location=new se(Ke,_e)),l.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};x=l=Ue([b],x),e.SymbolInformation=x;let Y=r=class{constructor(L,te,_e,Ke,et){this.name=L,this.detail=te,this.kind=_e,this.range=Ke,this.selectionRange=et,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};Y=r=Ue([b],Y),e.DocumentSymbol=Y;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(L,te){this.title=L,this.kind=te}};ae=Ue([b],ae),e.CodeAction=ae;let V=a=class{constructor(L){this.value=L}append(L){return new a(this.value?this.value+a.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+a.sep)}};V.sep=".",V=a=Ue([b],V),e.CodeActionKind=V,V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll");let oe=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ue([b],oe),e.SelectionRange=oe;class fe{constructor(L,te,_e,Ke,et,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=fe;class Ae{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Ae;class xe{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=xe;var $e;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let we=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};we=Ue([b],we),e.CodeLens=we;let Ze=w=class{constructor(L,te=!1){h.set(this,void 0),Je(this,h,new _.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Te(this,h,"f").value}set value(L){Te(this,h,"f").value=L}get isTrusted(){return Te(this,h,"f").isTrusted}set isTrusted(L){Te(this,h,"f").isTrusted=L}get supportThemeIcons(){return Te(this,h,"f").supportThemeIcons}set supportThemeIcons(L){Te(this,h,"f").supportThemeIcons=L}get supportHtml(){return Te(this,h,"f").supportHtml}set supportHtml(L){Te(this,h,"f").supportHtml=L}appendText(L){return Te(this,h,"f").appendText(L),this}appendMarkdown(L){return Te(this,h,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Te(this,h,"f").appendCodeblock(te??"",L),this}};h=new WeakMap,Ze=w=Ue([b],Ze),e.MarkdownString=Ze;let z=class{constructor(L,te){this.label=L,this.documentation=te}};z=Ue([b],z),e.ParameterInformation=z;let J=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};J=Ue([b],J),e.SignatureInformation=J;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=Ue([b],he),e.SignatureHelp=he;var Oe;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(L,te,_e){this.text=L,this.position=te,this.kind=_e}};tt=Ue([b],tt),e.InlayHint=tt;var ut;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ht;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ht=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(N){N[N.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Pt=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ht[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pt=Ue([b],Pt),e.CompletionItem=Pt;let dt=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};dt=Ue([b],dt),e.CompletionList=dt;let bt=class{constructor(L,te,_e){this.text=L,this.range=te,this.command=_e}};bt=Ue([b],bt),e.InlineSuggestion=bt;let ft=class{constructor(L){this.items=L}};ft=Ue([b],ft),e.InlineSuggestions=ft;var Et;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Z;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Z=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ce;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(L,te){if(te&&!D.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=te}};ge=Ue([b],ge),e.DocumentLink=ge;let me=class{constructor(L,te,_e,Ke){this.red=L,this.green=te,this.blue=_e,this.alpha=Ke}};me=Ue([b],me),e.Color=me;let Ie=class{constructor(L,te){if(te&&!(te instanceof me))throw(0,M.illegalArgument)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=te}};Ie=Ue([b],Ie),e.ColorInformation=Ie;let Be=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Be=Ue([b],Be),e.ColorPresentation=Be;var Le;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var je;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Xe{constructor(L,te,_e){if(this.startIndex=L,this.length=te,this.tooltip=_e,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Xe;var ne;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=pe;var re;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var B;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(B=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=f=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Ce.Clean=new f("clean","Clean"),Ce.Build=new f("build","Build"),Ce.Rebuild=new f("rebuild","Rebuild"),Ce.Test=new f("test","Test"),Ce=f=Ue([b],Ce),e.TaskGroup=Ce;function Se(N){let L="";for(let te=0;te<N.length;te++)L+=N[te].replace(/,/g,",,")+",";return L}let Ge=class{constructor(L,te,_e){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return Se(L)}};Ge=Ue([b],Ge),e.ProcessExecution=Ge;let We=class{constructor(L,te,_e){if(this._args=[],Array.isArray(te)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=te,this._options=_e}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return Se(L)}};We=Ue([b],We),e.ShellExecution=We;var it;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class vt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=vt;let nt=m=class{constructor(L,te,_e,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=L;let at;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=Ke,at=et,this.__deprecated=!0):te===mt.Global||te===mt.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,at=st):(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=et,at=st),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(m.EmptyType===te||m.ProcessType===te||m.ShellType===te||m.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};nt.ExtensionCallbackType="customExecution",nt.ProcessType="process",nt.ShellType="shell",nt.EmptyType="$empty",nt=m=Ue([b],nt),e.Task=nt;var ot;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ot=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(L,te=Rt.None){this.collapsibleState=te,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};lt=Ue([b],lt),e.TreeItem=lt;var Rt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Rt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(L,te){this.id=L,this.color=te}};_t=Ue([b],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Ot=class{constructor(L){this.id=L}};Ot=Ue([b],Ot),e.ThemeColor=Ot;var di;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(di=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(L,te){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=D.URI.file(L),this.base=L):D.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};kt=Ue([b],kt),e.RelativePattern=kt;let $t=class{constructor(L,te,_e,Ke){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=Ue([b],$t),e.Breakpoint=$t;let Zt=class extends $t{constructor(L,te,_e,Ke,et){super(te,_e,Ke,et);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};Zt=Ue([b],Zt),e.SourceBreakpoint=Zt;let gt=class extends $t{constructor(L,te,_e,Ke,et){super(te,_e,Ke,et);this.functionName=L}};gt=Ue([b],gt),e.FunctionBreakpoint=gt;let Kt=class extends $t{constructor(L,te,_e,Ke,et,st,at){super(Ke,et,st,at);if(!te)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=_e}};Kt=Ue([b],Kt),e.DataBreakpoint=Kt;let Vt=class{constructor(L,te,_e){this.command=L,this.args=te||[],this.options=_e}};Vt=Ue([b],Vt),e.DebugAdapterExecutable=Vt;let ei=class{constructor(L,te){this.port=L,this.host=te}};ei=Ue([b],ei),e.DebugAdapterServer=ei;let ti=class{constructor(L){this.path=L}};ti=Ue([b],ti),e.DebugAdapterNamedPipeServer=ti;let It=class{constructor(L){this.implementation=L}};It=Ue([b],It),e.DebugAdapterInlineImplementation=It;let Qt=class{constructor(L,te){this.range=L,this.expression=te}};Qt=Ue([b],Qt),e.EvaluatableExpression=Qt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,te){this.range=L,this.text=te}};Wt=Ue([b],Wt),e.InlineValueText=Wt;let Ht=class{constructor(L,te,_e=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=_e}};Ht=Ue([b],Ht),e.InlineValueVariableLookup=Ht;let ct=class{constructor(L,te){this.range=L,this.expression=te}};ct=Ue([b],ct),e.InlineValueEvaluatableExpression=ct;let ii=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};ii=Ue([b],ii),e.InlineValueContext=ii;var Nt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let xt=S=class extends Error{constructor(L,te=t.FileSystemProviderErrorCode.Unknown,_e){super(D.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new S(L,t.FileSystemProviderErrorCode.FileExists,S.FileExists)}static FileNotFound(L){return new S(L,t.FileSystemProviderErrorCode.FileNotFound,S.FileNotFound)}static FileNotADirectory(L){return new S(L,t.FileSystemProviderErrorCode.FileNotADirectory,S.FileNotADirectory)}static FileIsADirectory(L){return new S(L,t.FileSystemProviderErrorCode.FileIsADirectory,S.FileIsADirectory)}static NoPermissions(L){return new S(L,t.FileSystemProviderErrorCode.NoPermissions,S.NoPermissions)}static Unavailable(L){return new S(L,t.FileSystemProviderErrorCode.Unavailable,S.Unavailable)}};xt=S=Ue([b],xt),e.FileSystemError=xt;let Yt=class{constructor(L,te,_e){this.start=L,this.end=te,this.kind=_e}};Yt=Ue([b],Yt),e.FoldingRange=Yt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=fi;function ni(N){return typeof N=="undefined"||(0,I.isStringArray)(N)}class ri{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,_e=L.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,_e=L.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,_e,Ke,et){if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(L,te,_e,Ke,et);if(O.isRange(L)&&typeof te=="string"&&ni(_e))return this._push(L,te,_e);throw(0,M.illegalArgument)()}_push(L,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,et=L.start.character,st=L.end.character-L.start.character,at=this._tokenTypeStrToInt.get(te);let yt=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);yt|=1<<Ft>>>0}this._pushEncoded(Ke,et,st,at,yt)}_pushEncoded(L,te,_e,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<yt;Lt++){let Bt=this._data[5*Lt],ui=this._data[5*Lt+1];Bt===0?(Bt=At,ui+=Ft):Bt+=At,this._data[5*Lt]=Bt,this._data[5*Lt+1]=ui,At=Bt,Ft=ui}}let st=L,at=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(at-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=at,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const _e=L.length/5|0;for(let at=0;at<_e;at++)te[at]=at;te.sort((at,yt)=>{const At=L[5*at],Ft=L[5*yt];if(At===Ft){const Lt=L[5*at+1],Bt=L[5*yt+1];return Lt-Bt}return At-Ft});const Ke=new Uint32Array(L.length);let et=0,st=0;for(let at=0;at<_e;at++){const yt=5*te[at],At=L[yt+0],Ft=L[yt+1],Lt=L[yt+2],Bt=L[yt+3],ui=L[yt+4],xi=At-et,qi=xi===0?Ft-st:Ft,ci=5*at;Ke[ci+0]=xi,Ke[ci+1]=qi,Ke[ci+2]=Lt,Ke[ci+3]=Bt,Ke[ci+4]=ui,et=At,st=Ft}return Ke}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(ri._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=ri;class jt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=jt;class si{constructor(L,te,_e){this.start=L,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=si;class _i{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var qt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(qt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new _t("arrow-left")},Jt=Ue([b],Jt),e.QuickInputButtons=Jt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,te,_e){this.badge=L,this.tooltip=te,this.color=_e}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let oi=class{constructor(L){this.kind=L}};oi=Ue([b],oi),e.ColorTheme=oi;var ai;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(ai=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof zt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,_e=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(_e=L.end),te===this._start&&_e===this._end?this:new zt(te,_e)}}e.NotebookRange=zt;class Mt{constructor(L,te,_e,Ke,et,st,at){this.kind=L,this.value=te,this.languageId=_e,this.mime=Ke,this.outputs=et??[],this.metadata=st,this.executionSummary=at,Mt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Mt.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Mt;class Re{constructor(L){this.cells=L}}e.NotebookData=Re;class Tt{constructor(L,te){this.data=L,this.mime=te;const _e=(0,R.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Tt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Tt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Tt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Tt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Tt(L,te)}static text(L,te=R.Mimes.text){const _e=Te(Tt,s,"f",d).encode(String(L));return new Tt(_e,te)}static json(L,te="application/json"){const _e=JSON.stringify(L,void 0,"	");return Tt.text(_e,te)}}e.NotebookCellOutputItem=Tt,s=Tt,d={value:new TextEncoder};class Gt{constructor(L,te,_e){this.items=Gt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,P.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(L){return L instanceof Gt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,I.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const _e=new Set,Ke=new Set;for(let et=0;et<L.length;et++){const st=L[et],at=(0,R.normalizeMimeType)(st.mime);if(!_e.has(at)){_e.add(at);continue}Ke.add(et),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ke.size===0?L:L.filter((et,st)=>!Ke.has(st))}}e.NotebookCellOutput=Gt;var pt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(L,te=[]){this.uri=L,this.provides=(0,c.asArray)(te)}}e.NotebookRendererScript=Pi;let li=class{constructor(L,te){this.label=L,this.timestamp=te}};li=Ue([b],li),e.TimelineItem=li;var Ai;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ti;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ti=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Ri;class Fi{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(L,te,_e){this.include=L,this.exclude=te,this.profile=_e}};X=Ue([b],X),e.TestRunRequest=X;let de=T=class{constructor(L){this.message=L}static diff(L,te,_e){const Ke=new T(L);return Ke.expectedOutput=te,Ke.actualOutput=_e,Ke}};de=T=Ue([b],de),e.TestMessage=de;let ke=class{constructor(L){this.id=L}};ke=Ue([b],ke),e.TestTag=ke;let rt=class{constructor(L,te){this.covered=L,this.total=te}};rt=Ue([b],rt),e.CoveredCount=rt;let wt=g=class{constructor(L,te,_e,Ke){this.uri=L,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(L,te){const _e=new rt(0,0),Ke=new rt(0,0),et=new rt(0,0);for(const at of te)if("branches"in at){_e.total+=1,_e.covered+=at.executionCount>0?1:0;for(const yt of at.branches)Ke.total+=1,Ke.covered+=yt.executionCount>0?1:0}else et.total+=1,et.covered+=at.executionCount>0?1:0;const st=new g(L,_e,Ke.total>0?Ke:void 0,et.total>0?et:void 0);return st.detailedCoverage=te,st}};wt=g=Ue([b],wt),e.FileCoverage=wt;let Dt=class{constructor(L,te,_e=[]){this.executionCount=L,this.location=te,this.branches=_e}};Dt=Ue([b],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(L,te){this.executionCount=L,this.location=te}};Oi=Ue([b],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(L,te){this.executionCount=L,this.location=te}};Ni=Ue([b],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(L,te,_e,Ke,et,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=et,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,40,11,9,227,117,7,13]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(s,d){d?P.set(s,d):P.delete(s)}e.setWordDefinitionFor=t;function y(s){return P.get(s)}e.getWordDefinitionFor=y;class n extends A.MirrorTextModel{constructor(d,v,k,E,o,p,C,i){super(v,k,E,o);this._proxy=d,this._languageId=p,this._isDirty=C,this._notebook=i,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,D.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===M.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(v){return v?d._getTextInRange(v):d.getText()},get eol(){return d._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(v){return d._lineAt(v)},offsetAt(v){return d._offsetAt(v)},positionAt(v){return d._positionAt(v)},validateRange(v){return d._validateRange(v)},validatePosition(v){return d._validatePosition(v)},getWordRangeAtPosition(v,k){return d._getWordRangeAtPosition(v,k)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,c.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,c.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const v=this._validateRange(d);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const k=this._eol,E=v.start.line,o=v.end.line,p=[];p.push(this._lines[E].substring(v.start.character));for(let C=E+1;C<o;C++)p.push(this._lines[C]);return p.push(this._lines[o].substring(0,v.end.character)),p.join(k)}_lineAt(d){let v;if(d instanceof I.Position?v=d.line:typeof d=="number"&&(v=d),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new h(v,this._lines[v],v===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(d),k=this._lines[v.index].length;return new I.Position(v.index,Math.min(v.remainder,k))}_validateRange(d){if(!(d instanceof I.Range))throw new Error("Invalid argument");const v=this._validatePosition(d.start),k=this._validatePosition(d.end);return v===d.start&&k===d.end?d:new I.Range(v.line,v.character,k.line,k.character)}_validatePosition(d){if(!(d instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:v,character:k}=d,E=!1;if(v<0)v=0,k=0,E=!0;else if(v>=this._lines.length)v=this._lines.length-1,k=this._lines[v].length,E=!0;else{const o=this._lines[v].length;k<0?(k=0,E=!0):k>o&&(k=o,E=!0)}return E?new I.Position(v,k):d}_getWordRangeAtPosition(d,v){const k=this._validatePosition(d);if(!v)v=y(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const E=(0,R.getWordAtText)(k.character+1,(0,R.ensureValidWordDefinition)(v),this._lines[k.line],0);if(E)return new I.Range(k.line,E.startColumn-1,k.line,E.endColumn-1)}}e.ExtHostDocumentData=n;class h{constructor(d,v,k){this._line=d,this._text=v,this._isLastLine=k}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(be[155],Ee([0,1,7,3,228,6,55,20,2,36]),function(ie,e,c,M,_,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,h,s,d){this._notebook=s,this._selector=d,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(k=>{const E=this._cellUris.get(k.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=k=>{k===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(k=>v(k.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const n=[],h=[];for(const s of this._notebook.getCells())s.kind===c.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),h.push(s.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(n){if(!n){let E="";for(const o of this._cells)E+=o.document.getText()+`
`;return E=E.slice(0,-1),E}if(n.isEmpty)return"";const h=this.locationAt(n.start),s=this.locationAt(n.end),d=this._cellUris.get(h.uri),v=this._cellUris.get(s.uri);if(d===void 0||v===void 0)return"";if(d===v)return this._cells[d].document.getText(new c.Range(h.range.start,s.range.end));const k=[this._cells[d].document.getText(new c.Range(h.range.start,new c.Position(this._cells[d].document.lineCount,0)))];for(let E=d+1;E<v;E++)k.push(this._cells[E].document.getText());return k.push(this._cells[v].document.getText(new c.Range(new c.Position(0,0),s.range.end))),k.join(`
`)}offsetAt(n){const h=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(h.index-1),d=this._cells[h.index].document.offsetAt(n.with(h.remainder));return s+d}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),d=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(d)}const h=this._cellUris.get(n.uri);if(h!==void 0){const s=this._cellLines.getPrefixSum(h-1);return new c.Position(s+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const h=this._cellLines.getIndexOf(n.start.line);let s=h;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const d=new c.Position(h.remainder,n.start.character),v=new c.Position(s.remainder,n.end.character),k=new c.Range(d,v),E=this._cells[h.index];return new c.Location(E.document.uri,E.document.validateRange(k))}contains(n){return this._cellUris.has(n)}validateRange(n){const h=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(h,s)}validatePosition(n){const h=this._cellLines.getIndexOf(n.line),s=new c.Position(h.remainder,n.character),d=this._cells[h.index].document.validatePosition(s),v=this._cellLines.getPrefixSum(h.index-1);return new c.Position(v+d.line,d.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[156],Ee([0,1,7,12,3]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(I){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?c.ColorThemeKind.Light:I==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ue([He(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[65],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=M}),define(be[157],Ee([0,1,23]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function _(I,D){if(D.serializeBuffersForPostMessage){const P=new M,t=(h,s)=>{if(s instanceof ArrayBuffer){const d=P.add(s);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(s)){const d=A(s);if(d){const v=P.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:d,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},y=JSON.stringify(I,t),n=P.buffers.map(h=>{const s=new Uint8Array(h);return c.VSBuffer.wrap(s)});return{message:y,buffers:n}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=_;function A(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(I,D){const P=D.map(n=>{const h=new ArrayBuffer(n.byteLength);return new Uint8Array(h).set(n.buffer),h}),t=D.length?(n,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const s=h,{index:d}=s,v=P[d];if(s.view)switch(s.view.type){case 1:return new Int8Array(v,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return h}:void 0;return{message:JSON.parse(I,t),arrayBuffers:P}}e.deserializeWebviewMessage=R}),define(be[158],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(M){function _(R){const I={items:new Map};return R.types.forEach((D,P)=>{I.items.set(D,{asString:async()=>R.items[P].asString})}),I}M.toITreeDataTransfer=_;async function A(R){const I={types:[],items:[]},D=Array.from(R.items.entries());for(const P of D)I.types.push(P[0]),I.items.push({asString:await P[1].asString()});return I}M.toTreeDataTransferDTO=A})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[66],Ee([0,1,11,2]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(I,D){return I.scheme===c.Schemas.http||I.scheme===c.Schemas.https?I:(D&&D.authority&&D.isRemote&&I.scheme===c.Schemas.file&&(I=M.URI.from({scheme:c.Schemas.vscodeRemote,authority:D.authority,path:I.path})),M.URI.from({scheme:c.Schemas.https,authority:`${I.scheme}+${A(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=_;function A(I){return I.replace(/./g,D=>{const P=D.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?D:"-"+P.toString(16).padStart(4,"0")})}function R(I){return I.replace(/-([0-9a-f]{4})/g,(D,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=R}),define(be[159],Ee([0,1,3,6,66]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(I,D,P){this._proxy=I,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const t=D.getVisibleTextEditors();for(const y of this._insets.values())t.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,P,t,y){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===I){n=o;break}if(!n)throw new Error("not a visible editor");const h=this,s=this._handlePool++,d=new c.Emitter,v=new c.Emitter,k=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,_.asWebviewUri)(o,h._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(o){this._options=o,h._proxy.$setOptions(s,o)}get options(){return this._options}set html(o){this._html=o,h._proxy.$setHtml(s,o)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(o){return h._proxy.$postMessage(s,o)}},E=new class{constructor(){this.editor=I,this.line=D,this.height=P,this.webview=k,this.onDidDispose=v.event}dispose(){h._insets.has(s)&&(h._insets.delete(s),h._proxy.$disposeEditorInset(s),v.fire(),v.dispose(),d.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,D+1,P,t||{},y.identifier,y.extensionLocation),this._insets.set(s,{editor:I,inset:E,onDidReceiveMessage:d}),E}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=A}),define(be[160],Ee([0,1,130,10,2,6,4,43,28,13,11]),function(ie,e,c,M,_,A,R,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,c.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(12,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(13,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(14,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(15,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,c.localize)(17,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,c.localize)(18,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,c.localize)(19,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(20,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,c.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function y(b){if(o(b))return!1;const u=b;return _.URI.isUri(u?.resource)}e.isResourceEditorInput=y;function n(b){if(o(b))return!1;const u=b;return u?.original!==void 0&&u.modified!==void 0}e.isResourceDiffEditorInput=n;function h(b){if(o(b))return!1;const u=b;return u?.primary!==void 0&&u.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function s(b){if(o(b))return!1;const u=b;return u?u.resource===void 0||u.resource.scheme===t.Schemas.untitled||u.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=s;var d;(function(b){b[b.SHORT=0]="SHORT",b[b.MEDIUM=1]="MEDIUM",b[b.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var v;(function(b){b[b.EXPLICIT=1]="EXPLICIT",b[b.AUTO=2]="AUTO",b[b.FOCUS_CHANGE=3]="FOCUS_CHANGE",b[b.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var k;(function(b){b[b.None=0]="None",b[b.Readonly=2]="Readonly",b[b.Untitled=4]="Untitled",b[b.Singleton=8]="Singleton",b[b.RequiresTrust=16]="RequiresTrust",b[b.CanSplitInGroup=32]="CanSplitInGroup"})(k=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends A.Disposable{}e.AbstractEditorInput=E;function o(b){return b instanceof E}e.isEditorInput=o;function p(b){const u=b;return _.URI.isUri(u?.preferredResource)}function C(b){const u=b;return o(u?.primary)&&o(u?.secondary)}e.isSideBySideEditorInput=C;function i(b){const u=b;return o(u?.modified)&&o(u?.original)}e.isDiffEditorInput=i;function l(b){return o(b?.editor)}e.isEditorInputWithOptions=l;function r(b){const u=b;return l(b)&&u?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function a(b){const u=b;return typeof u?.groupId=="number"&&o(u.editor)}e.isEditorIdentifier=a;var w;(function(b){b[b.PRIMARY=1]="PRIMARY",b[b.SECONDARY=2]="SECONDARY",b[b.BOTH=3]="BOTH"})(w=e.SideBySideEditor||(e.SideBySideEditor={}));class f{getOriginalUri(u,F){if(!u)return;if(F?.supportSideBySide){const{primary:j,secondary:Q}=this.getSideEditors(u);if(j&&Q){if(F?.supportSideBySide===w.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:F.filterByScheme})};u=F.supportSideBySide===w.PRIMARY?j:Q}}if(n(u)||h(u))return;const O=p(u)?u.preferredResource:u.resource;return!O||!F||!F.filterByScheme?O:this.filterUri(O,F.filterByScheme)}getSideEditors(u){return C(u)||h(u)?{primary:u.primary,secondary:u.secondary}:i(u)||n(u)?{primary:u.modified,secondary:u.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(u,F){if(!u)return;if(F?.supportSideBySide){const{primary:j,secondary:Q}=this.getSideEditors(u);if(j&&Q){if(F?.supportSideBySide===w.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:F.filterByScheme})};u=F.supportSideBySide===w.PRIMARY?j:Q}}if(n(u)||h(u))return;const O=u.resource;return!O||!F||!F.filterByScheme?O:this.filterUri(O,F.filterByScheme)}filterUri(u,F){if(Array.isArray(F)){if(F.some(O=>u.scheme===O))return u}else if(F===u.scheme)return u}}e.EditorResourceAccessor=new f;var m;(function(b){b[b.LEFT=0]="LEFT",b[b.RIGHT=1]="RIGHT"})(m=e.CloseDirection||(e.CloseDirection={}));class S{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(u){const F=this.instantiationService=u.get(R.IInstantiationService);for(const[O,j]of this.editorSerializerConstructors)this.createEditorSerializer(O,j,F);this.editorSerializerConstructors.clear()}createEditorSerializer(u,F,O){const j=O.createInstance(F);this.editorSerializerInstances.set(u,j)}registerFileEditorFactory(u){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=u}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(u,F){if(this.editorSerializerConstructors.has(u)||this.editorSerializerInstances.has(u))throw new Error(`A editor serializer with type ID '${u}' was already registered.`);return this.instantiationService?this.createEditorSerializer(u,F,this.instantiationService):this.editorSerializerConstructors.set(u,F),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(u),this.editorSerializerInstances.delete(u)})}getEditorSerializer(u){return this.editorSerializerInstances.get(typeof u=="string"?u:u.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new S);async function T(b,u){if(!b||!b.length)return[];const F=await Promise.all(b.map(async O=>{const j=_.URI.revive(O.fileUri);if(!j||(await u.activateProvider(j.scheme),!u.canHandleResource(j)))return;const Q=typeof O.exists=="boolean"?O.exists:await u.exists(j);if(!Q&&O.openOnlyIfExists)return;const W={selection:Q?O.selection:void 0,pinned:!0,override:O.editorOverrideId};let K;return Q?K={resource:j,options:W}:K={resource:j,options:W,forceUntitled:!0},K}));return(0,P.coalesce)(F)}e.pathsToEditors=T;var g;(function(b){b[b.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",b[b.SEQUENTIAL=1]="SEQUENTIAL"})(g=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[161],Ee([0,1,3,43,131,4,6,20,28,13,51,22,34,151]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",n.Codicon.window,(0,_.localize)(0,null));var s;(function(w){w.ViewContainersRegistry="workbench.registry.view.containers",w.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var d;(function(w){w[w.Sidebar=0]="Sidebar",w[w.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(w){switch(w){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function k(w){return`viewContainer.${w}.enabled`}e.getEnabledViewContainerContextKey=k;class E extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(f,m,S){const T=this.get(f.id);if(T)return T;const g=f;return g.openCommandActionDescriptor=S?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,I.getOrSet)(this.viewContainers,m,[]).push(g),S?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:m}),g}deregisterViewContainer(f){for(const m of this.viewContainers.keys()){const S=this.viewContainers.get(m),T=S?.indexOf(f);if(T!==-1){S?.splice(T,1),S.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:m});return}}}get(f){return this.all.filter(m=>m.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(S=>S?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===f)}}D.Registry.add(s.ViewContainersRegistry,new E);var o;(function(w){w.Open="2_open",w.Debug="4_debug",w.SCM="5_scm",w.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function p(w,f){const m=w.group??o.More,S=f.group??o.More;return m!==S?m.localeCompare(S):(w.order??5)-(f.order??5)}class C extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(f,m){this.registerViews2([{views:f,viewContainer:m}])}registerViews2(f){f.forEach(({views:m,viewContainer:S})=>this.addViews(m,S)),this._onViewsRegistered.fire(f)}deregisterViews(f,m){const S=this.removeViews(f,m);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:m})}moveViews(f,m){for(const S of this._views.keys())if(S!==m){const T=this.removeViews(f,S);T.length&&(this.addViews(T,m),this._onDidChangeContainer.fire({views:T,from:S,to:m}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const m of this._viewContainers){const S=(this._views.get(m)||[]).filter(T=>T.id===f)[0];if(S)return S}return null}getViewContainer(f){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(T=>T.id===f)[0])return m;return null}registerViewWelcomeContent(f,m){return this._viewWelcomeContents.add(f,m),this._onDidChangeViewWelcomeContent.fire(f),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(f,m),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,m){const S=new Map;for(const[T,g]of m)this._viewWelcomeContents.add(f,g),S.set(T,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(f,g),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),S}getViewWelcomeContent(f){const m=[];return this._viewWelcomeContents.forEach(f,S=>m.push(S)),m.sort(p)}addViews(f,m){let S=this._views.get(m);S||(S=[],this._views.set(m,S),this._viewContainers.push(m));for(const T of f){if(this.getView(T.id)!==null)throw new Error((0,_.localize)(1,null,T.id));S.push(T)}}removeViews(f,m){const S=this._views.get(m);if(!S)return[];const T=[],g=[];for(const b of S)f.includes(b)?T.push(b):g.push(b);return T.length&&(g.length?this._views.set(m,g):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),T}}D.Registry.add(s.ViewsRegistry,new C),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,_.localize)(2,null));function i(w){return`view.${w}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var l;(function(w){w[w.Default=0]="Default",w[w.Expand=1]="Expand"})(l=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(w){w[w.None=0]="None",w[w.Collapsed=1]="Collapsed",w[w.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(f,m){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,f),this._hasResolve=!!m,this.resolve=async S=>{if(m&&!this.resolved){const T=await m(S);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[162],Ee([0,1,3,14,132]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,P,t){const y={command:I};if(D&&Object.keys(D).length>0&&(y.arguments=D),this.internalSend("request",y),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const h=this.pendingRequests.get(y.seq);if(h){this.pendingRequests.delete(y.seq);const s={type:"response",seq:0,request_seq:y.seq,success:!1,command:I,message:(0,_.localize)(0,null,t,I)};h(s)}},t)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,M.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const D=I,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,P)=>I.set(P,D)),await(0,M.timeout)(500),I.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[163],Ee([0,1,9,2,17,22,11]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(r,a,w){return r.replace(I,function(f,m){return a&&m.length>0&&m[0]!=="_"?f:w&&w.hasOwnProperty(m)?w[m]:f})}e.formatPII=D;function P(r){const a={};for(const w of Object.keys(r))w.startsWith("!")||(a[w]=r[w]);return a}e.filterExceptionsFromTelemetry=P;function t(r){return r.configuration.request==="attach"&&!y(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function y(r){let a=r.configuration.type;if(!!a)return a==="vslsShare"&&(a=r.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(a,"extensionhost")||(0,c.equalsIgnoreCase)(a,"pwa-extensionhost")?r:r.parentSession?y(r.parentSession):void 0}e.getExtensionHostDebugSession=y;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function h(r,a,w){let f,m=0,S=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,T=null;for(;T=S.exec(r);){let g=T.index+1,b=g+T[0].length;if(g<=a&&b>=w){f=T[0],m=g;break}}if(f){let g=/\w+/g,b=null;for(;(b=g.exec(f))&&!(b.index+1+m+b[0].length>=w););b&&(f=f.substring(0,g.lastIndex))}return f?{start:m,end:m+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(r){return!!(r&&r.match(s))}e.isUri=d;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(d(r.path))return M.URI.parse(r.path);if((0,_.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function k(r){if(typeof r.path=="object"){const a=M.URI.revive(r.path);if(a)return a.scheme===R.Schemas.file?a.fsPath:a.toString()}return r.path}function E(r,a){const w=a?v:k,f=(0,A.deepClone)(r);return p(f,(m,S)=>{m&&S&&(S.path=w(S))}),f}e.convertToDAPaths=E;function o(r,a){const w=a?v:k,f=(0,A.deepClone)(r);return p(f,(m,S)=>{!m&&S&&(S.path=w(S))}),f}e.convertToVSCPaths=o;function p(r,a){switch(r.type){case"event":const w=r;switch(w.event){case"output":a(!1,w.body.source);break;case"loadedSource":a(!1,w.body.source);break;case"breakpoint":a(!1,w.body.breakpoint.source);break;default:break}break;case"request":const f=r;switch(f.command){case"setBreakpoints":a(!0,f.arguments.source);break;case"breakpointLocations":a(!0,f.arguments.source);break;case"source":a(!0,f.arguments.source);break;case"gotoTargets":a(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(S=>a(!1,S));break;default:break}break;case"response":const m=r;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(S=>a(!1,S.source));break;case"loadedSources":m.body.sources.forEach(S=>a(!1,S));break;case"scopes":m.body.scopes.forEach(S=>a(!1,S.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(S=>a(!1,S.source));break;case"setBreakpoints":m.body.breakpoints.forEach(S=>a(!1,S.source));break;default:break}break}}function C(r){return r.filter(a=>!a.presentation?.hidden).sort((a,w)=>a.presentation?w.presentation?a.presentation.group?w.presentation.group?a.presentation.group!==w.presentation.group?a.presentation.group.localeCompare(w.presentation.group):i(a.presentation.order,w.presentation.order):-1:w.presentation.group?1:i(a.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.getVisibleAndSorted=C;function i(r,a){return typeof r!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:r-a}async function l(r,a){const w=r.getValue("debug.saveBeforeStart",{overrideIdentifier:a.activeTextEditorMode});if(w!=="none"&&(await a.saveAll(),w==="allEditorsInActiveGroup")){const f=a.activeEditorPane;f&&await a.save({editor:f.input,groupId:f.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=l}),define(be[89],Ee([0,1,27,78,11,17,26,43]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var v;(function(g){g.scheme=_.Schemas.vscodeNotebookCell;const b=/^ch(\d{7,})/;function u(W,K){return W.with({scheme:g.scheme,fragment:`ch${K.toString().padStart(7,"0")}${W.scheme!==_.Schemas.file?W.scheme:""}`})}g.generate=u;function F(W){if(W.scheme!==g.scheme)return;const K=b.exec(W.fragment);return K?{handle:Number(K[1]),notebook:W.with({scheme:W.fragment.substr(K[0].length)||_.Schemas.file,fragment:null})}:void 0}g.parse=F;function O(W){if(W.scheme!==_.Schemas.vscodeNotebookCellMetadata)return;const K=b.exec(W.fragment);return K?{handle:Number(K[1]),notebook:W.with({scheme:W.fragment.substr(K[0].length)||_.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=O;function j(W,K,$){return W.with({scheme:$,fragment:`ch${K.toString().padStart(7,"0")}${W.scheme!==_.Schemas.file?W.scheme:""}`})}g.generateCellUri=j;function Q(W,K){if(W.scheme!==K)return;const $=b.exec(W.fragment);return $?{handle:Number($[1]),notebook:W.with({scheme:W.fragment.substr($[0].length)||_.Schemas.file,fragment:null})}:void 0}g.parseCellUri=Q})(v=e.CellUri||(e.CellUri={}));const k=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(g){return k.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function o(g){return k.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function p(g){return k.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=p;function C(g,b){return R.isWindows&&(g=g.replace(/\//g,"\\"),b=b.replace(/\//g,"\\")),c.match(g,b)}function i(g,b,u){let F=0;for(let O=0;O<b.length;O++){if(C(b[O],g))return F;F++}for(let O=0;O<u.length;O++){if(C(u[O],g))return F;F++}return F}function l(g,b,u){return g.sort((F,O)=>i(F,b,u)-i(O,b,u))}e.sortMimeTypes=l;function r(g,b,u,F=(O,j)=>O===j){const O=[];function j(K,$,U){if($===0&&U.length===0)return;const H=O[O.length-1];H&&H.start+H.deleteCount===K?(H.deleteCount+=$,H.toInsert.push(...U)):O.push({start:K,deleteCount:$,toInsert:U})}let Q=0,W=0;for(;;){if(Q===g.length){j(Q,0,b.slice(W));break}if(W===b.length){j(Q,g.length-Q,[]);break}const K=g[Q],$=b[W];if(F(K,$)){Q+=1,W+=1;continue}u($)?(j(Q,1,[]),Q+=1):(j(Q,0,[$]),W+=1)}return O}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(g){g.default="default",g.option="option"})(a=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function w(g){const b=g;return!!((typeof b.include=="string"||c.isRelativePattern(b.include))&&(typeof b.exclude=="string"||c.isRelativePattern(b.exclude)))}e.isDocumentExcludePattern=w;function f(g,b,u){if(Array.isArray(g.viewType)&&g.viewType.indexOf(b)>=0||g.viewType===b)return!0;if(g.filenamePattern){let F=w(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,O=w(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(c.match(F,(0,A.basename)(u.fsPath).toLowerCase()))return!(O&&c.match(O,(0,A.basename)(u.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class m{constructor(b){this.textModel=b}getElements(){const b=new Int32Array(this.textModel.cells.length);for(let u=0;u<this.textModel.cells.length;u++)b[u]=this.textModel.cells[u].getHashValue();return b}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var S;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(S=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(b){return`${T._prefix}${b}`}static parse(b){if(b.startsWith(T._prefix))return b.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(be[164],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState",_[_.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(be[165],Ee([0,1,134,4,43]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[166],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=c;function M(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var M;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var A;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&(y.item=y.item?Object.assign(y.item,n.item):n.item)};e.applyTestItemUpdate=R;var I;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var D;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,h){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const h=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const d=s[1];if(d.parent){if(this.items.has(d.parent)){const v=this.items.get(d.parent);v.children.add(d.item.extId);const k=this.createItem(d,v);this.items.set(d.item.extId,k),h.add(k)}}else{const v=this.createItem(d);this.roots.add(v),this.items.set(d.item.extId,v),h.add(v)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=s[1],v=this.items.get(d.extId);if(!v)break;d.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,d),h.update(v);break}case 2:{const d=this.items.get(s[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const v=[[s[1]]];for(;v.length;)for(const k of v.pop()){const E=this.items.get(k);E&&(v.push(E.children),this.items.delete(k),h.remove(E,E!==d),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}h.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(be[67],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(A){A.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class _{constructor(R,I=R.length){if(this.path=R,this.viewEnd=I,R.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,I,D=R.parent){if(R.id===I)return new _([I]);let P=[R.id];for(let t=D;t&&t.id!==I;t=t.parent)P.push(t.id);return P.push(I),new _(P.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new _(R.split("\0"))}static join(R,I){return new _([...R.path,I])}static joinToString(R,I){return R.toString()+"\0"+I}static compare(R,I){return R===I?0:I.startsWith(R+"\0")?2:R.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new _(this.path,R)}compare(R){if(typeof R=="string")return _.compare(this.toString(),R);for(let I=0;I<R.viewEnd&&I<this.viewEnd;I++)if(R.path[I]!==this.path[I])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=_}),define(be[167],Ee([0,1,17,91,10,22,26,77,135]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,n,h){this._contributedVariables=new Map,this._context=y,this._labelService=n,h&&(this._envVariablesPromise=h.then(s=>this.prepareEnv(s)))}prepareEnv(y){if(R.isWindows){const n=Object.create(null);return Object.keys(y).forEach(h=>{n[h.toLowerCase()]=y[h]}),n}return y}resolveWithEnvironment(y,n,h){return this.recursiveResolve(this.prepareEnv(y),n?n.uri:void 0,h)}async resolveAsync(y,n){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,n)}async resolveAnyBase(y,n,h,s){const d=A.deepClone(n);return R.isWindows&&d.windows?Object.keys(d.windows).forEach(v=>d[v]=d.windows[v]):R.isMacintosh&&d.osx?Object.keys(d.osx).forEach(v=>d[v]=d.osx[v]):R.isLinux&&d.linux&&Object.keys(d.linux).forEach(v=>d[v]=d.linux[v]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,d,h,s)}async resolveAnyAsync(y,n,h){return this.resolveAnyBase(y,n,h)}async resolveAnyMap(y,n,h){const s=new Map;return{newConfig:await this.resolveAnyBase(y,n,h,s),resolvedVariables:s}}resolveWithInteractionReplace(y,n,h,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,n,h,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,n){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,n)}recursiveResolve(y,n,h,s,d){if(_.isString(h))return this.resolveString(y,n,h,s,d);if(_.isArray(h))return h.map(v=>this.recursiveResolve(y,n,v,s,d));if(_.isObject(h)){let v=Object.create(null);return Object.keys(h).forEach(k=>{const E=this.resolveString(y,n,k,s,d);v[E]=this.recursiveResolve(y,n,h[k],s,d)}),v}return h}resolveString(y,n,h,s,d){return h.replace(P.VARIABLE_REGEXP,(k,E)=>{if(E.includes(P.VARIABLE_LHS))return k;let o=this.evaluateSingleVariable(y,k,E,n,s);return d&&d.set(E,o),o!==k&&_.isString(o)&&o.match(P.VARIABLE_REGEXP)&&(o=this.resolveString(y,n,o,s,d)),o})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,n,h,s,d){let v;const k=h.split(":");k.length>1&&(h=k[0],v=k[1]);const E=()=>{const C=this._context.getFilePath();if(C)return C;throw new Error((0,D.localize)(0,null,n))},o=()=>{const C=E();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,D.localize)(1,null,n,c.basename(C)))},p=()=>{if(v){const C=this._context.getFolderUri(v);if(C)return C;throw new Error((0,D.localize)(2,null,n,v))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,n)):new Error((0,D.localize)(4,null,n))};switch(h){case"env":if(v){if(y){const C=y[R.isWindows?v.toLowerCase():v];if(_.isString(C))return C}return""}throw new Error((0,D.localize)(5,null,n));case"config":if(v){const C=this._context.getConfigurationValue(s,v);if(_.isUndefinedOrNull(C))throw new Error((0,D.localize)(6,null,n,v));if(_.isObject(C))throw new Error((0,D.localize)(7,null,n,v));return C}throw new Error((0,D.localize)(8,null,n));case"command":return this.resolveFromMap(n,v,d,"command");case"input":return this.resolveFromMap(n,v,d,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return s||v?(0,I.normalizeDriveLetter)(this.fsPath(p())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(p()));case"lineNumber":const C=this._context.getLineNumber();if(C)return C;throw new Error((0,D.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,D.localize)(10,null,n));case"file":return E();case"fileWorkspaceFolder":return o();case"relativeFile":return s||v?c.relative(this.fsPath(p()),E()):E();case"relativeFileDirname":const l=c.dirname(E());if(s||v){const f=c.relative(this.fsPath(p()),l);return f.length===0?".":f}return l;case"fileDirname":return c.dirname(E());case"fileExtname":return c.extname(E());case"fileBasename":return c.basename(E());case"fileBasenameNoExtension":const r=c.basename(E());return r.slice(0,r.length-c.extname(r).length);case"fileDirnameBasename":return c.basename(c.dirname(E()));case"execPath":const a=this._context.getExecPath();return a||n;case"execInstallFolder":const w=this._context.getAppRoot();return w||n;case"pathSeparator":return c.sep;default:try{const f=v?`${h}:${v}`:h;return this.resolveFromMap(n,f,d,void 0)}catch(f){return n}}}}resolveFromMap(y,n,h,s){if(n&&h){const d=s===void 0?h[n]:h[s+":"+n];if(typeof d=="string")return d;throw new Error((0,D.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,160]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var _;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var A;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var I;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function P(d){const v=d;return(0,M.isEditorInput)(v?.editor)&&(0,M.isEditorInput)(v?.replacement)}e.isEditorReplacement=P;var t;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.GROUP_LOCKED=2]="GROUP_LOCKED",d[d.EDITOR_OPEN=3]="EDITOR_OPEN",d[d.EDITOR_CLOSE=4]="EDITOR_CLOSE",d[d.EDITOR_MOVE=5]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=7]="EDITOR_LABEL",d[d.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",d[d.EDITOR_PIN=9]="EDITOR_PIN",d[d.EDITOR_STICKY=10]="EDITOR_STICKY",d[d.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(y=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function h(d){const v=d;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=h;function s(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(be[168],Ee([0,1,4,92]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(A){const R=A;return typeof A=="number"||(0,M.isEditorGroup)(R)}e.isPreferredGroup=_}),define(be[8],Ee([0,1,13,23,76,229,54,22,10,2,42,59,136,82,46,89,67,168,7]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ne){function pe(B){const{selectionStartLineNumber:Ce,selectionStartColumn:Se,positionLineNumber:Ge,positionColumn:We}=B,it=new E.Position(Ce-1,Se-1),mt=new E.Position(Ge-1,We-1);return new E.Selection(it,mt)}ne.to=pe;function re(B){const{anchor:Ce,active:Se}=B;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}ne.from=re})(o=e.Selection||(e.Selection={}));var p;(function(ne){function pe(B){if(!B)return;const{start:Ce,end:Se}=B;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}ne.from=pe;function re(B){if(!B)return;const{startLineNumber:Ce,startColumn:Se,endLineNumber:Ge,endColumn:We}=B;return new E.Range(Ce-1,Se-1,Ge-1,We-1)}ne.to=re})(p=e.Range||(e.Range={}));var C;(function(ne){function pe(re){switch(re){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}ne.to=pe})(C=e.TokenType||(e.TokenType={}));var i;(function(ne){function pe(B){return new E.Position(B.lineNumber-1,B.column-1)}ne.to=pe;function re(B){return{lineNumber:B.line+1,column:B.character+1}}ne.from=re})(i=e.Position||(e.Position={}));var l;(function(ne){function pe(B){switch(B){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}ne.from=pe;function re(B){switch(B){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}ne.to=re})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ne){function pe(B){let Ce;return B.code&&((0,D.isString)(B.code)||(0,D.isNumber)(B.code)?Ce=String(B.code):Ce={value:String(B.code.value),target:B.code.target}),{...p.from(B.range),message:B.message,source:B.source,code:Ce,severity:w.from(B.severity),relatedInformation:B.relatedInformation&&B.relatedInformation.map(a.from),tags:Array.isArray(B.tags)?(0,c.coalesce)(B.tags.map(l.from)):void 0}}ne.from=pe;function re(B){const Ce=new E.Diagnostic(p.to(B),B.message,w.to(B.severity));return Ce.source=B.source,Ce.code=(0,D.isString)(B.code)?B.code:B.code?.value,Ce.relatedInformation=B.relatedInformation&&B.relatedInformation.map(a.to),Ce.tags=B.tags&&(0,c.coalesce)(B.tags.map(l.to)),Ce}ne.to=re})(r=e.Diagnostic||(e.Diagnostic={}));var a;(function(ne){function pe(B){return{...p.from(B.location.range),message:B.message,resource:B.location.uri}}ne.from=pe;function re(B){return new E.DiagnosticRelatedInformation(new E.Location(B.resource,p.to(B)),B.message)}ne.to=re})(a=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(ne){function pe(B){switch(B){case E.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}ne.from=pe;function re(B){switch(B){case h.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}ne.to=re})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var f;(function(ne){function pe(B){return typeof B=="number"&&B>=E.ViewColumn.One?B-1:B===E.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}ne.from=pe;function re(B){if(typeof B=="number"&&B>=0)return B+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=re})(f=e.ViewColumn||(e.ViewColumn={}));function m(ne){return typeof ne.range!="undefined"}function S(ne){return ne.length===0?!0:!!m(ne[0])}e.isDecorationOptionsArr=S;var T;(function(ne){function pe(We){return We.map(ne.from)}ne.fromMany=pe;function re(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function B(We){let it;if(re(We)){const{language:ot,value:lt}=We;it={value:"```"+ot+`
`+lt+"\n```\n"}}else E.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml}:typeof We=="string"?it={value:We}:it={value:""};const mt=Object.create(null);it.uris=mt;const vt=ot=>{try{let lt=P.URI.parse(ot,!0);lt=lt.with({query:Ce(lt.query,mt)}),mt[ot]=lt}catch(lt){}return""},nt=new A.Renderer;return nt.link=vt,nt.image=ot=>vt(_.parseHrefAndDimensions(ot).href),A(it.value,{renderer:nt}),it}ne.from=B;function Ce(We,it){if(!We)return We;let mt;try{mt=(0,R.parse)(We)}catch(nt){}if(!mt)return We;let vt=!1;return mt=(0,I.cloneAndChange)(mt,nt=>{if(P.URI.isUri(nt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ot]=nt,vt=!0,ot}else return}),vt?JSON.stringify(mt):We}function Se(We){const it=new E.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it.supportHtml=We.supportHtml,it}ne.to=Se;function Ge(We){if(!!We)return typeof We=="string"?We:ne.from(We)}ne.fromStrict=Ge})(T=e.MarkdownString||(e.MarkdownString={}));function g(ne){return S(ne)?ne.map(pe=>({range:p.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?T.fromMany(pe.hoverMessage):pe.hoverMessage?T.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ne.map(pe=>({range:p.from(pe)}))}e.fromRangeOrRangeWithMessage=g;function b(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?P.URI.file(ne):ne}e.pathOrURIToURI=b;var u;(function(ne){function pe(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?b(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ne.from=pe})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ne){function pe(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?b(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?u.from(re.before):void 0,after:re.after?u.from(re.after):void 0}}ne.from=pe})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ne){function pe(re){if(typeof re=="undefined")return re;switch(re){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=pe})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(ne){function pe(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?O.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?F.from(re.light):void 0,dark:re.dark?F.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?b(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?u.from(re.before):void 0,after:re.after?u.from(re.after):void 0}}ne.from=pe})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Q;(function(ne){function pe(B){return{text:B.newText,eol:B.newEol&&he.from(B.newEol),range:p.from(B.range)}}ne.from=pe;function re(B){const Ce=new E.TextEdit(p.to(B.range),B.text);return Ce.newEol=typeof B.eol=="undefined"?void 0:he.to(B.eol),Ce}ne.to=re})(Q=e.TextEdit||(e.TextEdit={}));var W;(function(ne){function pe(B,Ce,Se){const Ge={edits:[]};if(B instanceof E.WorkspaceEdit)for(let We of B._allEntries())if(We._type===1)Ge.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const it=Ce?.getDocument(We.uri);Ge.edits.push({_type:2,resource:We.uri,edit:Q.from(We.edit),modelVersionId:it?.version,metadata:We.metadata})}else We._type===3?Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Et.from)}});return Ge}ne.from=pe;function re(B){const Ce=new E.WorkspaceEdit;for(const Se of B.edits)Se.edit?Ce.replace(P.URI.revive(Se.resource),p.to(Se.edit.range),Se.edit.text):Ce.renameFile(P.URI.revive(Se.oldUri),P.URI.revive(Se.newUri),Se.options);return Ce}ne.to=re})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var K;(function(ne){const pe=Object.create(null);pe[E.SymbolKind.File]=0,pe[E.SymbolKind.Module]=1,pe[E.SymbolKind.Namespace]=2,pe[E.SymbolKind.Package]=3,pe[E.SymbolKind.Class]=4,pe[E.SymbolKind.Method]=5,pe[E.SymbolKind.Property]=6,pe[E.SymbolKind.Field]=7,pe[E.SymbolKind.Constructor]=8,pe[E.SymbolKind.Enum]=9,pe[E.SymbolKind.Interface]=10,pe[E.SymbolKind.Function]=11,pe[E.SymbolKind.Variable]=12,pe[E.SymbolKind.Constant]=13,pe[E.SymbolKind.String]=14,pe[E.SymbolKind.Number]=15,pe[E.SymbolKind.Boolean]=16,pe[E.SymbolKind.Array]=17,pe[E.SymbolKind.Object]=18,pe[E.SymbolKind.Key]=19,pe[E.SymbolKind.Null]=20,pe[E.SymbolKind.EnumMember]=21,pe[E.SymbolKind.Struct]=22,pe[E.SymbolKind.Event]=23,pe[E.SymbolKind.Operator]=24,pe[E.SymbolKind.TypeParameter]=25;function re(Ce){return typeof pe[Ce]=="number"?pe[Ce]:6}ne.from=re;function B(Ce){for(const Se in pe)if(pe[Se]===Ce)return Number(Se);return E.SymbolKind.Property}ne.to=B})(K=e.SymbolKind||(e.SymbolKind={}));var $;(function(ne){function pe(B){switch(B){case E.SymbolTag.Deprecated:return 1}}ne.from=pe;function re(B){switch(B){case 1:return E.SymbolTag.Deprecated}}ne.to=re})($=e.SymbolTag||(e.SymbolTag={}));var U;(function(ne){function pe(B){return{name:B.name,kind:K.from(B.kind),tags:B.tags&&B.tags.map($.from),containerName:B.containerName,location:le.from(B.location)}}ne.from=pe;function re(B){const Ce=new E.SymbolInformation(B.name,K.to(B.kind),B.containerName,le.to(B.location));return Ce.tags=B.tags&&B.tags.map($.to),Ce}ne.to=re})(U=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(ne){function pe(B){const Ce={name:B.name||"!!MISSING: name!!",detail:B.detail,range:p.from(B.range),selectionRange:p.from(B.selectionRange),kind:K.from(B.kind),tags:B.tags?.map($.from)??[]};return B.children&&(Ce.children=B.children.map(pe)),Ce}ne.from=pe;function re(B){const Ce=new E.DocumentSymbol(B.name,B.detail,K.to(B.kind),p.to(B.range),p.to(B.selectionRange));return(0,c.isNonEmptyArray)(B.tags)&&(Ce.tags=B.tags.map($.to)),B.children&&(Ce.children=B.children.map(re)),Ce}ne.to=re})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(ne){function pe(B){const Ce=new E.CallHierarchyItem(K.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),p.to(B.range),p.to(B.selectionRange));return Ce._sessionId=B._sessionId,Ce._itemId=B._itemId,Ce}ne.to=pe;function re(B,Ce,Se){if(Ce=Ce??B._sessionId,Se=Se??B._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,name:B.name,detail:B.detail,kind:K.from(B.kind),uri:B.uri,range:p.from(B.range),selectionRange:p.from(B.selectionRange),tags:B.tags?.map($.from)}}ne.from=re})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(ne){function pe(re){return new E.CallHierarchyIncomingCall(G.to(re.from),re.fromRanges.map(B=>p.to(B)))}ne.to=pe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(ne){function pe(re){return new E.CallHierarchyOutgoingCall(G.to(re.to),re.fromRanges.map(B=>p.to(B)))}ne.to=pe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(ne){function pe(B){return{range:B.range&&p.from(B.range),uri:B.uri}}ne.from=pe;function re(B){return new E.Location(P.URI.revive(B.uri),p.to(B.range))}ne.to=re})(le=e.location||(e.location={}));var se;(function(ne){function pe(B){const Ce=B,Se=B;return{originSelectionRange:Ce.originSelectionRange?p.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Se.uri,range:p.from(Ce.targetRange?Ce.targetRange:Se.range),targetSelectionRange:Ce.targetSelectionRange?p.from(Ce.targetSelectionRange):void 0}}ne.from=pe;function re(B){return{targetUri:P.URI.revive(B.uri),targetRange:p.to(B.range),targetSelectionRange:B.targetSelectionRange?p.to(B.targetSelectionRange):void 0,originSelectionRange:B.originSelectionRange?p.to(B.originSelectionRange):void 0}}ne.to=re})(se=e.DefinitionLink||(e.DefinitionLink={}));var ve;(function(ne){function pe(B){return{range:p.from(B.range),contents:T.fromMany(B.contents)}}ne.from=pe;function re(B){return new E.Hover(B.contents.map(T.to),p.to(B.range))}ne.to=re})(ve=e.Hover||(e.Hover={}));var Fe;(function(ne){function pe(B){return{range:p.from(B.range),expression:B.expression}}ne.from=pe;function re(B){return new E.EvaluatableExpression(p.to(B.range),B.expression)}ne.to=re})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Me;(function(ne){function pe(B){if(B instanceof E.InlineValueText)return{type:"text",range:p.from(B.range),text:B.text};if(B instanceof E.InlineValueVariableLookup)return{type:"variable",range:p.from(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};if(B instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(B.range),expression:B.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=pe;function re(B){switch(B.type){case"text":return{range:p.to(B.range),text:B.text};case"variable":return{range:p.to(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};case"expression":return{range:p.to(B.range),expression:B.expression}}}ne.to=re})(Me=e.InlineValue||(e.InlineValue={}));var Ne;(function(ne){function pe(B){return{frameId:B.frameId,stoppedLocation:p.from(B.stoppedLocation)}}ne.from=pe;function re(B){return new E.InlineValueContext(B.frameId,p.to(B.stoppedLocation))}ne.to=re})(Ne=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(ne){function pe(B){return{range:p.from(B.range),kind:B.kind}}ne.from=pe;function re(B){return new E.DocumentHighlight(p.to(B.range),B.kind)}ne.to=re})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ne){function pe(re){switch(re){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}ne.to=pe})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(ne){function pe(re){return{triggerKind:ze.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ne.to=pe})(qe=e.CompletionContext||(e.CompletionContext={}));var x;(function(ne){function pe(B){switch(B){case E.CompletionItemTag.Deprecated:return 1}}ne.from=pe;function re(B){switch(B){case 1:return E.CompletionItemTag.Deprecated}}ne.to=re})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(ne){const pe=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function re(Se){return pe.get(Se)??9}ne.from=re;const B=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Ce(Se){return B.get(Se)??E.CompletionItemKind.Property}ne.to=Ce})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ne){function pe(re,B){const Ce=new E.CompletionItem(re.label);return Ce.insertText=re.insertText,Ce.kind=Y.to(re.kind),Ce.tags=re.tags?.map(x.to),Ce.detail=re.detail,Ce.documentation=_.isMarkdownString(re.documentation)?T.to(re.documentation):re.documentation,Ce.sortText=re.sortText,Ce.filterText=re.filterText,Ce.preselect=re.preselect,Ce.commitCharacters=re.commitCharacters,t.Range.isIRange(re.range)?Ce.range=p.to(re.range):typeof re.range=="object"&&(Ce.range={inserting:p.to(re.range.insert),replacing:p.to(re.range.replace)}),Ce.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Ce.insertText=new E.SnippetString(re.insertText):(Ce.insertText=re.insertText,Ce.textEdit=Ce.range instanceof E.Range?new E.TextEdit(Ce.range,Ce.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Ce.additionalTextEdits=re.additionalTextEdits.map(Se=>Q.to(Se))),Ce.command=B&&re.command?B.fromInternal(re.command):void 0,Ce}ne.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ne){function pe(B){return{label:B.label,documentation:B.documentation?T.fromStrict(B.documentation):void 0}}ne.from=pe;function re(B){return{label:B.label,documentation:_.isMarkdownString(B.documentation)?T.to(B.documentation):B.documentation}}ne.to=re})(ae=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(ne){function pe(B){return{label:B.label,documentation:B.documentation?T.fromStrict(B.documentation):void 0,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.from):[],activeParameter:B.activeParameter}}ne.from=pe;function re(B){return{label:B.label,documentation:_.isMarkdownString(B.documentation)?T.to(B.documentation):B.documentation,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.to):[],activeParameter:B.activeParameter}}ne.to=re})(V=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(ne){function pe(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(V.from):[]}}ne.from=pe;function re(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(V.to):[]}}ne.to=re})(oe=e.SignatureHelp||(e.SignatureHelp={}));var fe;(function(ne){function pe(B){return{text:B.text,position:i.from(B.position),kind:Ae.from(B.kind??E.InlayHintKind.Other),whitespaceBefore:B.whitespaceBefore,whitespaceAfter:B.whitespaceAfter}}ne.from=pe;function re(B){const Ce=new E.InlayHint(B.text,i.to(B.position),Ae.to(B.kind));return Ce.whitespaceAfter=B.whitespaceAfter,Ce.whitespaceBefore=B.whitespaceBefore,Ce}ne.to=re})(fe=e.InlayHint||(e.InlayHint={}));var Ae;(function(ne){function pe(B){return B}ne.from=pe;function re(B){return B}ne.to=re})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var xe;(function(ne){function pe(B){return{range:p.from(B.range),url:B.target,tooltip:B.tooltip}}ne.from=pe;function re(B){let Ce;if(B.url)try{Ce=typeof B.url=="string"?P.URI.parse(B.url,!0):P.URI.revive(B.url)}catch(Se){}return new E.DocumentLink(p.to(B.range),Ce)}ne.to=re})(xe=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ne){function pe(B){const Ce=new E.ColorPresentation(B.label);return B.textEdit&&(Ce.textEdit=Q.to(B.textEdit)),B.additionalTextEdits&&(Ce.additionalTextEdits=B.additionalTextEdits.map(Se=>Q.to(Se))),Ce}ne.to=pe;function re(B){return{label:B.label,textEdit:B.textEdit?Q.from(B.textEdit):void 0,additionalTextEdits:B.additionalTextEdits?B.additionalTextEdits.map(Ce=>Q.from(Ce)):void 0}}ne.from=re})($e=e.ColorPresentation||(e.ColorPresentation={}));var we;(function(ne){function pe(B){return new E.Color(B[0],B[1],B[2],B[3])}ne.to=pe;function re(B){return[B.red,B.green,B.blue,B.alpha]}ne.from=re})(we=e.Color||(e.Color={}));var Ze;(function(ne){function pe(B){return{range:p.from(B.range)}}ne.from=pe;function re(B){return new E.SelectionRange(p.to(B.range))}ne.to=re})(Ze=e.SelectionRange||(e.SelectionRange={}));var z;(function(ne){function pe(re){switch(re){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}ne.to=pe})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(ne){function pe(B){switch(B){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=pe;function re(B){switch(B){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}ne.to=re})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var he;(function(ne){function pe(B){if(B===E.EndOfLine.CRLF)return 1;if(B===E.EndOfLine.LF)return 0}ne.from=pe;function re(B){if(B===1)return E.EndOfLine.CRLF;if(B===0)return E.EndOfLine.LF}ne.to=re})(he=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(ne){function pe(re){if(typeof re=="object")return re.viewId;switch(re){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=pe})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(ne){function pe(re){const B={start:re.start+1,end:re.end+1};return re.kind&&(B.kind=tt.from(re.kind)),B}ne.from=pe})(Ve=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ne){function pe(re){if(re)switch(re){case E.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}ne.from=pe})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ut;(function(ne){function pe(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?p.from(re.selection):void 0,override:typeof re.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=pe})(ut=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ht;(function(ne){function pe(B){return B instanceof E.RelativePattern||typeof B=="string"?B:re(B)?new E.RelativePattern(B.base,B.pattern):B}ne.from=pe;function re(B){const Ce=B;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(ht=e.GlobPattern||(e.GlobPattern={}));var St;(function(ne){function pe(re){if(re){if(Array.isArray(re))return re.map(pe);if(typeof re=="string")return re;{const B=re;return{language:B.language,scheme:B.scheme,pattern:typeof B.pattern=="undefined"?void 0:ht.from(B.pattern),exclusive:B.exclusive}}}else return}ne.from=pe})(St=e.LanguageSelector||(e.LanguageSelector={}));var Pt;(function(ne){function pe(B){return{start:B.start,end:B.end}}ne.from=pe;function re(B){return new E.NotebookRange(B.start,B.end)}ne.to=re})(Pt=e.NotebookRange||(e.NotebookRange={}));var dt;(function(ne){function pe(B){return{timing:typeof B.runStartTime=="number"&&typeof B.runEndTime=="number"?{startTime:B.runStartTime,endTime:B.runEndTime}:void 0,executionOrder:B.executionOrder,success:B.lastRunSuccess}}ne.to=pe;function re(B){return{lastRunSuccess:B.success,runStartTime:B.timing?.startTime,runEndTime:B.timing?.endTime,executionOrder:B.executionOrder}}ne.from=re})(dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var bt;(function(ne){function pe(B){switch(B){case E.NotebookCellKind.Markup:return d.CellKind.Markup;case E.NotebookCellKind.Code:default:return d.CellKind.Code}}ne.from=pe;function re(B){switch(B){case d.CellKind.Markup:return E.NotebookCellKind.Markup;case d.CellKind.Code:default:return E.NotebookCellKind.Code}}ne.to=re})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ne){function pe(B){const Ce={metadata:B.metadata??Object.create(null),cells:[]};for(let Se of B.cells)E.NotebookCellData.validate(Se),Ce.cells.push(Et.from(Se));return Ce}ne.from=pe;function re(B){const Ce=new E.NotebookData(B.cells.map(Et.to));return(0,D.isEmptyObject)(B.metadata)||(Ce.metadata=B.metadata),Ce}ne.to=re})(ft=e.NotebookData||(e.NotebookData={}));var Et;(function(ne){function pe(B){return{cellKind:bt.from(B.kind),language:B.languageId,mime:B.mime,source:B.value,metadata:B.metadata,internalMetadata:dt.from(B.executionSummary??{}),outputs:B.outputs?B.outputs.map(Ct.from):[]}}ne.from=pe;function re(B){return new E.NotebookCellData(bt.to(B.cellKind),B.source,B.language,B.mime,B.outputs?B.outputs.map(Ct.to):void 0,B.metadata,B.internalMetadata?dt.to(B.internalMetadata):void 0)}ne.to=re})(Et=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(ne){function pe(B){return{mime:B.mime,valueBytes:M.VSBuffer.wrap(B.data)}}ne.from=pe;function re(B){return new E.NotebookCellOutputItem(B.valueBytes.buffer,B.mime)}ne.to=re})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ne){function pe(B){return{outputId:B.id,items:B.items.map(Ye.from),metadata:B.metadata}}ne.from=pe;function re(B){const Ce=B.items.map(Ye.to);return new E.NotebookCellOutput(Ce,B.outputId,B.metadata)}ne.to=re})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(ne){function pe(Se){if(Se!=null){if(Se instanceof E.RelativePattern||typeof Se=="string")return Se;if(Ce(Se))return new E.RelativePattern(Se.base,Se.pattern);if(B(Se))return{include:ht.from(Se.include)||void 0,exclude:ht.from(Se.exclude)||void 0}}}ne.from=pe;function re(Se){return typeof Se=="string"?Se:Ce(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}ne.to=re;function B(Se){const Ge=Se,We=ht.from(Ge.include);if(!(We&&We instanceof E.RelativePattern||typeof We=="string"))return!1;const it=ht.from(Ge.exclude);return!!(it&&it instanceof E.RelativePattern||typeof it=="string")}function Ce(Se){const Ge=Se;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ne){function pe(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?u.from(re.top):void 0}}ne.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var De;(function(ne){function pe(re,B,Ce){const Se=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:B.toInternal(Se,Ce),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ne.from=pe})(De=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(ne){function pe(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ne.from=pe})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ce;(function(ne){function pe(B){return{uri:B.uri,provides:B.provides}}ne.from=pe;function re(B){return new E.NotebookRendererScript(P.URI.revive(B.uri),B.provides)}ne.to=re})(ce=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ne){function pe(B){return{message:T.fromStrict(B.message)||"",type:0,expected:B.expectedOutput,actual:B.actualOutput,location:B.location?le.from(B.location):void 0}}ne.from=pe;function re(B){const Ce=new E.TestMessage(typeof B.message=="string"?B.message:T.to(B.message));return Ce.actualOutput=B.actual,Ce.expectedOutput=B.expected,Ce.location=B.location?le.to(B.location):void 0,Ce}ne.to=re})(ge=e.TestMessage||(e.TestMessage={}));var me;(function(ne){let pe;(function(re){re.Delimiter="\0"})(pe||(pe={})),ne.namespace=(re,B)=>re+"\0"+B,ne.denamespace=re=>{const B=re.indexOf("\0");return{ctrlId:re.slice(0,B),tagId:re.slice(B+1)}}})(me=e.TestTag||(e.TestTag={}));var Ie;(function(ne){function pe(Se){const Ge=(0,s.getPrivateApiFor)(Se).controllerId;return{extId:v.TestId.fromExtHostTestItem(Se,Ge).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>me.namespace(Ge,We.id)),range:p.from(Se.range)||null,description:Se.description||null,error:Se.error&&T.fromStrict(Se.error)||null}}ne.from=pe;function re(Se){return{id:v.TestId.fromString(Se.extId).localId,label:Se.label,uri:P.URI.revive(Se.uri),tags:(Se.tags||[]).map(Ge=>{const{tagId:We}=me.denamespace(Ge);return new E.TestTag(We)}),range:p.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}ne.toPlain=re;function B(Se){const Ge=v.TestId.fromString(Se.extId),We=new s.TestItemImpl(Ge.controllerId,Ge.localId,Se.label,P.URI.revive(Se.uri));return We.range=p.to(Se.range||void 0),We.description=Se.description||void 0,We}function Ce(Se){let Ge;for(const We of Se.tests){const it=B(We.item);(0,s.getPrivateApiFor)(it).parent=Ge,Ge=it}return Ge}ne.toItemFromContext=Ce})(Ie=e.TestItem||(e.TestItem={})),function(ne){function pe(B){return{id:B.id}}ne.from=pe;function re(B){return new E.TestTag(B.id)}ne.to=re}(me=e.TestTag||(e.TestTag={}));var Be;(function(ne){const pe=(B,Ce)=>{const Se={...Ie.toPlain(B.item),parent:void 0,taskStates:B.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(We=>We.type===0).map(ge.to)})),children:B.children.map(Ge=>Ce.get(Ge)).filter(D.isDefined).map(Ge=>pe(Ge,Ce))};for(const Ge of Se.children)Ge.parent=Se;return Se};function re(B){const Ce=[],Se=new Map;for(const Ge of B.items)Se.set(Ge.item.extId,Ge),B.request.targets.some(We=>We.controllerId===Ge.controllerId&&We.testIds.includes(Ge.item.extId))&&Ce.push(Ge);return{completedAt:B.completedAt,results:Ce.map(Ge=>pe(Ge,Se))}}ne.to=re})(Be=e.TestResults||(e.TestResults={}));var Le;(function(ne){function pe(Se){return{covered:Se.covered,total:Se.covered}}function re(Se){return"line"in Se?i.from(Se):p.from(Se)}function B(Se){return"branches"in Se?{count:Se.executionCount,location:re(Se.location),type:1,branches:Se.branches.length?Se.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&re(Ge.location)})):void 0}:{type:0,count:Se.executionCount,location:re(Se.location)}}ne.fromDetailed=B;function Ce(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(B)}}ne.fromFile=Ce})(Le=e.TestCoverage||(e.TestCoverage={}));var je;(function(ne){function pe(re){switch(re){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}ne.to=pe})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Xe;(function(ne){function pe(B){const Ce=new E.TypeHierarchyItem(K.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),p.to(B.range),p.to(B.selectionRange));return Ce._sessionId=B._sessionId,Ce._itemId=B._itemId,Ce}ne.to=pe;function re(B,Ce,Se){if(Ce=Ce??B._sessionId,Se=Se??B._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,kind:K.from(B.kind),name:B.name,detail:B.detail??"",uri:B.uri,range:p.from(B.range),selectionRange:p.from(B.selectionRange),tags:B.tags?.map($.from)}}ne.from=re})(Xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[169],Ee([0,1,2,16,7,8,230]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(P,t,y,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=y,this._thresholds=n,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,y,n)=>{const s={dispose:this._callbacks.push([t,y,P])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(P,t){const y=c.URI.revive(P);let n=!1;const h=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let d of[...this._callbacks]){if(n)break;const v=this._documents.getDocument(y),k=await this._deliverEventAsyncAndBlameBadListeners(d,{document:v,reason:A.TextDocumentSaveReason.to(t)});s.push(k)}}finally{clearTimeout(h)}return s}_deliverEventAsyncAndBlameBadListeners([P,t,y],n){const h=this._badListeners.get(P);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,t,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const d=this._badListeners.get(P);this._badListeners.set(P,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,y,n){const h=[],s=Date.now(),{document:d,reason:v}=n,{version:k}=d,E=Object.freeze({document:d,reason:v,waitUntil(o){if(Object.isFrozen(h))throw(0,M.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(o))}});try{t.apply(y,[E])}catch(o){return Promise.reject(o)}return Object.freeze(h),new Promise((o,p)=>{const C=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(C),o(i)}).catch(i=>{clearTimeout(C),p(i)})}).then(o=>{const p={edits:[]};for(const C of o)if(Array.isArray(C)&&C.every(i=>i instanceof _.TextEdit))for(const{newText:i,newEol:l,range:r}of C)p.edits.push({_type:2,resource:d.uri,edit:{range:r&&A.Range.from(r),text:i,eol:l&&A.EndOfLine.from(l)}});if(p.edits.length!==0)return k===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(be[68],Ee([0,1,8,2,3,4]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class R{constructor(){this._onDidChangeTabs=new _.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new _.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(D){let P=-1;this._tabs=D.map((y,n)=>{y.isActive&&(P=n);let h;if(y.resource){const s=y.resource;s.primary||s.secondary?h={primary:M.URI.revive(s.primary),secondary:M.URI.revive(s.secondary)}:h=M.URI.revive(y.resource)}return Object.freeze({label:y.label,viewColumn:c.ViewColumn.to(y.viewColumn),resource:h,editorId:y.editorId,isActive:y.isActive})});const t=this._activeTab;this._activeTab=P===-1?void 0:this._tabs[P],this._activeTab!==t&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=R}),define(be[170],Ee([0,1,3,27,2,8,7]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(t,y,n,h,s){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),h&&(this._config+=2),s&&(this._config+=4);const d=(0,M.parse)(y),v=t(k=>{if(!n)for(let E of k.created){const o=_.URI.revive(E);d(o.fsPath)&&this._onDidCreate.fire(o)}if(!h)for(let E of k.changed){const o=_.URI.revive(E);d(o.fsPath)&&this._onDidChange.fire(o)}if(!s)for(let E of k.deleted){const o=_.URI.revive(E);d(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(t,y,n){this._logService=y,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,y,n,h){return new I(this._onFileSystemEvent.event,t,y,n,h)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,y){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(n=>({oldUri:_.URI.revive(n.source),newUri:_.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(n=>_.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:y.map(n=>_.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,y){return(n,h,s)=>{const d=function(k){n.call(h,k)};return d.extension=t,y.event(d,void 0,s)}}async $onWillRunFileOperation(t,y,n,h){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(s=>({oldUri:_.URI.revive(s.source),newUri:_.URI.revive(s.target)}))},n,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(s=>_.URI.revive(s.target))},n,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(s=>_.URI.revive(s.target))},n,h)}}async _fireWillEvent(t,y,n,h){const s=new Set,d=[];if(await t.fireAsync(y,h,async(k,E)=>{const o=Date.now(),p=await Promise.resolve(k);p instanceof R.WorkspaceEdit&&(d.push(p),s.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),h.isCancellationRequested||d.length===0)return;const v={edits:[]};for(let k of d){let{edits:E}=A.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(E)}return{edit:v,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=D}),define(be[171],Ee([0,1,11,22,2,8,7,89]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(n,h,s,d){this.start=n,this.deletedCount=h,this.deletedItems=s,this.items=d}static asApiEvents(n){return n.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(s=>s.apiCell)}))}}class P{constructor(n,h,s){this.notebook=n,this._extHostDocument=h,this._cellData=s,this.handle=s.handle,this.uri=_.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,h,s){const d=s.map(A.NotebookCellOutputItem.to),v=this._outputs.find(k=>k.id===n);v&&(h||(v.items.length=0),v.items.push(...d))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,h,s,d,v,k){this._proxy=n,this._textDocumentsAndEditors=h,this._textDocuments=s,this._emitter=d,this.uri=v,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=k.viewType,this._metadata=Object.freeze(k.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,k.cells]],!0),this._versionId=k.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(h){return h=n._validateIndex(h),n._cells[h].apiCell},getCells(h){return(h?n._getCells(h):n._cells).map(d=>d.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,h){this._versionId=n.versionId,this._isDirty=h;for(const s of n.rawEvents)s.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===I.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let h=n.start|0,s=n.end|0;return h<0&&(h=0),s>this._cells.length&&(s=this._cells.length),n.with({start:h,end:s})}_getCells(n){n=this._validateRange(n);const h=[];for(let s=n.start;s<n.end;s++)h.push(this._cells[s]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,h){if(this._disposed)return;const s=[],d=[],v=[];n.reverse().forEach(k=>{const o=k[2].map(i=>{const l=new P(this,this._textDocumentsAndEditors,i);return h||d.push(P.asModelAddData(this.apiNotebook,i)),l}),p=new D(k[0],k[1],[],o),C=this._cells.splice(k[0],k[1],...o);for(const i of C)v.push(i.uri),p.deletedItems.push(i.apiCell);s.push(p)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:v}),h||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(s)}))}_moveCell(n,h){const s=this._cells.splice(n,1);this._cells.splice(h,0,...s);const d=[new D(n,1,s.map(v=>v.apiCell),[]),new D(h,0,[],s)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(d)}))}_setCellOutputs(n,h){const s=this._cells[n];s.setOutputs(h),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,h,s,d){const v=this._cells[n];v.setOutputItems(h,s,d),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(n,h){const s=this._cells[n];s.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(s.uri,h)}_changeCellMime(n,h){const s=this._cells[n];s.apiCell.mime=h}_changeCellMetadata(n,h){const s=this._cells[n],d=s.apiCell.metadata;s.setMetadata(h);const v=s.apiCell.metadata;(0,M.equals)(d,v)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,h){const s=this._cells[n],d=s.internalMetadata;if(s.setInternalMetadata(h),d.runState!==h.runState){const v=h.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:v}))}}getCellFromApiCell(n){return this._cells.find(h=>h.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(h=>h.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:P})}replaceCells(D,P,t){this._throwIfFinalized(),!(D===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:D,count:P-D,cells:t.map(M.NotebookCellData.from)})}}class R{constructor(D,P,t,y,n,h){this.id=D,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=y,this._viewColumn=h}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(P){if(!Array.isArray(P)||!P.every(c.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");D._selections=P,D._trySetSelections(P)},get visibleRanges(){return D._visibleRanges},revealRange(P,t){D._proxy.$tryRevealRange(D.id,M.NotebookRange.from(P),t??c.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(P){const t=new A(this.document.version);return P(t),D._applyEdit(t.finalize())},setDecorations(P,t){return D.setDecorations(P,t)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(M.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let y=0;y<D.cellEdits.length;y++){if(t<0){P.push(D.cellEdits[y]),t++;continue}const h=P[t],s=D.cellEdits[y];if(h.editType===1&&s.editType===1&&h.index===s.index){h.cells.push(...D.cellEdits[y].cells),h.count+=D.cellEdits[y].count;continue}P.push(D.cellEdits[y]),t++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,P)}setDecorations(D,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return P.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),D.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(be[172],Ee([0,1,8,146,125,21,52]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(y){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=y}withProgress(y,n,h){const s=this._handles++,{title:d,location:v,cancellable:k}=n,E={label:(0,_.localize)(0,null,y.displayName||y.name),id:y.identifier.value};return this._proxy.$startProgress(s,{location:c.ProgressLocation.from(v),title:d,source:E,cancellable:k},y),this._withProgress(s,h,!!k)}_withProgress(y,n,h){let s;h&&(s=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(y,s));const d=k=>{this._proxy.$progressEnd(k),this._mapHandleToCancellationSource.delete(k),s&&s.dispose()};let v;try{v=n(new P(this._proxy,y),h&&s?s.token:A.CancellationToken.None)}catch(k){throw d(y),k}return v.then(k=>d(y),k=>d(y)),v}$acceptProgressCanceled(y){const n=this._mapHandleToCancellationSource.get(y);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(y))}}e.ExtHostProgress=I;function D(t,y){return t.message=y.message,typeof y.increment=="number"&&(typeof t.increment=="number"?t.increment+=y.increment:t.increment=y.increment),t}class P extends M.Progress{constructor(y,n){super(h=>this.throttledReport(h));this._proxy=y,this._handle=n}throttledReport(y){this._proxy.$progressReport(this._handle,y)}}Ue([(0,R.throttle)(100,(t,y)=>D(t,y),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,40,16,53,8,7]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(n,h,s){const d=I._Keys.nextId();n.$registerTextEditorDecorationType(h.identifier,d,A.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:d,dispose(){n.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=I,I._Keys=new _.IdGenerator("TextEditorDecorationType");class D{constructor(n,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,h){this._throwIfFinalized();let s=null;if(n instanceof R.Position)s=new R.Range(n,n);else if(n instanceof R.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,h,!1)}insert(n,h){this._throwIfFinalized(),this._pushEdit(new R.Range(n,n),h,!0)}delete(n){this._throwIfFinalized();let h=null;if(n instanceof R.Range)h=n;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(n,h,s){const d=this._document.validateRange(n);this._collectedEdits.push({range:d,text:h,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==R.EndOfLine.LF&&n!==R.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=D;class P{constructor(n,h,s,d){this._proxy=n,this._id=h,this._accept(s),this._logService=d;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(k){v._setTabSize(k)},get insertSpaces(){return v._insertSpaces},set insertSpaces(k){v._setInsertSpaces(k)},get cursorStyle(){return v._cursorStyle},set cursorStyle(k){v._setCursorStyle(k)},get lineNumbers(){return v._lineNumbers},set lineNumbers(k){v._setLineNumbers(k)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const h=Math.floor(n);return h>0?h:null}if(typeof n=="string"){const h=parseInt(n,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(n){const h=this._validateTabSize(n);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const h=this._validateInsertSpaces(n);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const h={};let s=!1;if(typeof n.tabSize!="undefined"){const d=this._validateTabSize(n.tabSize);d==="auto"?(s=!0,h.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,s=!0,h.tabSize=d)}if(typeof n.insertSpaces!="undefined"){const d=this._validateInsertSpaces(n.insertSpaces);d==="auto"?(s=!0,h.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,s=!0,h.insertSpaces=d)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,h.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,h.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(n){n.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,h,s,d,v,k,E,o){this.id=n,this._proxy=h,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new P(this._proxy,this.id,k,s),this._visibleRanges=E,this._viewColumn=o;const p=this;this.value=Object.freeze({get document(){return d.getValue()},set document(C){throw(0,M.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(C){if(!(C instanceof R.Selection))throw(0,M.illegalArgument)("selection");p._selections=[C],p._trySetSelection()},get selections(){return p._selections},set selections(C){if(!Array.isArray(C)||C.some(i=>!(i instanceof R.Selection)))throw(0,M.illegalArgument)("selections");p._selections=C,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(C){throw(0,M.readonly)("visibleRanges")},get options(){return p._options.value},set options(C){p._disposed||p._options.assign(C)},get viewColumn(){return p._viewColumn},set viewColumn(C){throw(0,M.readonly)("viewColumn")},edit(C,i={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new D(d.getValue(),i);return C(l),p._applyEdit(l)},insertSnippet(C,i,l={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=p._selections.map(a=>A.Range.from(a));else if(i instanceof R.Position){const{lineNumber:a,column:w}=A.Position.from(i);r=[{startLineNumber:a,startColumn:w,endLineNumber:a,endColumn:w}]}else if(i instanceof R.Range)r=[A.Range.from(i)];else{r=[];for(const a of i)if(a instanceof R.Range)r.push(A.Range.from(a));else{const{lineNumber:w,column:f}=A.Position.from(a);r.push({startLineNumber:w,startColumn:f,endLineNumber:w,endColumn:f})}}return h.$tryInsertSnippet(n,C.value,r,l)},setDecorations(C,i){const l=i.length===0;l&&!p._hasDecorationsForKey.has(C.key)||(l?p._hasDecorationsForKey.delete(C.key):p._hasDecorationsForKey.add(C.key),p._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return h.$trySetDecorations(n,C.key,A.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let a=0,w=i.length;a<w;a++){const f=i[a];r[4*a]=f.start.line+1,r[4*a+1]=f.start.character+1,r[4*a+2]=f.end.line+1,r[4*a+3]=f.end.character+1}return h.$trySetDecorationsFast(n,C.key,r)}}))},revealRange(C,i){p._runOnProxy(()=>h.$tryRevealRange(n,A.Range.from(C),i||R.TextEditorRevealType.Default))},show(C){h.$tryShowEditor(n,A.ViewColumn.from(C))},hide(){h.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const h=n.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const s=h.edits.map(v=>v.range);s.sort((v,k)=>v.end.line===k.end.line?v.end.character===k.end.character?v.start.line===k.start.line?v.start.character-k.start.character:v.start.line-k.start.line:v.end.character-k.end.character:v.end.line-k.end.line);for(let v=0,k=s.length-1;v<k;v++){const E=s[v].end;if(s[v+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=h.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,d,{setEndOfLine:typeof h.setEndOfLine=="number"?A.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=t}),define(be[173],Ee([0,1,128,24,2,3,6,161,14,7,10,13,8,21,158]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(E,o){if((0,t.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let p;return Array.isArray(E.highlights)&&(p=E.highlights.filter(C=>C.length===2&&typeof C[0]=="number"&&typeof C[1]=="number"),p=p.length?p:void 0),{label:E.label,highlights:p}}}class v{constructor(o,p,C){this._proxy=o,this.commands=p,this.logService=C,this.treeViews=new Map;function i(l){return l&&l.$treeViewId&&l.$treeItemHandle}p.registerArgumentProcessor({processArgument:l=>i(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(r=>i(r)?this.convertArgument(r):r):l})}registerTreeDataProvider(o,p,C){const i=this.createTreeView(o,{treeDataProvider:p},C);return{dispose:()=>i.dispose()}}createTreeView(o,p,C){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=p.dragAndDropController!==void 0,l=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(o,p,C);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(a){r.message=a},get title(){return r.title},set title(a){r.title=a},get description(){return r.description},set description(a){r.description=a},reveal:(a,w)=>r.reveal(a,w),dispose:async()=>{await l,this.treeViews.delete(o),r.dispose()}}}$getChildren(o,p){const C=this.treeViews.get(o);return C?C.getChildren(p):Promise.reject(new Error((0,c.localize)(0,null,o)))}async $onDrop(o,p,C){const i=this.treeViews.get(o);if(!i)return Promise.reject(new Error((0,c.localize)(1,null,o)));const l=s.TreeDataTransferConverter.toITreeDataTransfer(p);if(l.items.has(I.TREE_ITEM_DATA_TRANSFER_TYPE)){const a=JSON.parse(await l.items.get(I.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(w=>i.getExtensionElement(w)).filter(w=>!!w);a.length>0?l.items.set(I.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(a)}):l.items.delete(I.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(l,C)}async $hasResolve(o){const p=this.treeViews.get(o);if(!p)throw new Error((0,c.localize)(2,null,o));return p.hasResolve}$resolve(o,p,C){const i=this.treeViews.get(o);if(!i)throw new Error((0,c.localize)(3,null,o));return i.resolveTreeItem(p,C)}$setExpanded(o,p,C){const i=this.treeViews.get(o);if(!i)throw new Error((0,c.localize)(4,null,o));i.setExpanded(p,C)}$setSelection(o,p){const C=this.treeViews.get(o);if(!C)throw new Error((0,c.localize)(5,null,o));C.setSelection(p)}$setVisible(o,p){const C=this.treeViews.get(o);if(!C)throw new Error((0,c.localize)(6,null,o));C.setVisible(p)}createExtHostTreeView(o,p,C){const i=new k(o,p,this._proxy,this.commands.converter,this.logService,C);return this.treeViews.set(o,i),i}convertArgument(o){const p=this.treeViews.get(o.$treeViewId);return p?p.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=v;class k extends R.Disposable{constructor(o,p,C,i,l,r){super();if(this.viewId=o,this.proxy=C,this.commands=i,this.logService=l,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,r.contributes&&r.contributes.views)for(const f in r.contributes.views)for(const m of r.contributes.views[f])m.id===o&&(this._title=m.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let a,w;this._register(A.Event.debounce(this._onDidChangeData.event,(f,m)=>(f||(f={message:!1,elements:[]}),m.element!==!1&&(a||(a=new Promise(S=>w=S),this.refreshPromise=this.refreshPromise.then(()=>a)),Array.isArray(m.element)?f.elements.push(...m.element):f.elements.push(m.element)),m.message&&(f.message=!0),f),200,!0)(({message:f,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const S=w;return a=null,this.refresh(m).then(()=>S())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const p=o?this.getExtensionElement(o):void 0;if(o&&!p)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let C=this.getChildrenNodes(o);return C||(C=await this.fetchChildrenNodes(p)),C?C.map(i=>i.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,p){p=p||{select:!0,focus:!1};const C=(0,t.isUndefinedOrNull)(p.select)?!0:p.select,i=(0,t.isUndefinedOrNull)(p.focus)?!1:p.focus,l=(0,t.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(r=>this.resolveTreeNode(o,r[r.length-1]).then(a=>this.proxy.$reveal(this.viewId,{item:a.item,parentChain:r.map(w=>w.item)},{select:C,focus:i,expand:l})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:C,focus:i,expand:l})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,p){const C=this.getExtensionElement(o);C&&(p?this._onDidExpandElement.fire(Object.freeze({element:C})):this._onDidCollapseElement.fire(Object.freeze({element:C})))}setSelection(o){(0,y.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,p){const C=this.getExtensionElement(p);if(!!C)return(0,D.asPromise)(()=>this.dndController?.onDrop(o,C))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,p){if(!this.dataProvider.resolveTreeItem)return;const C=this.elements.get(o);if(C){const i=this.nodes.get(C);if(i){const l=await this.dataProvider.resolveTreeItem(i.extensionItem,C,p)??i.extensionItem;return i.item.tooltip=this.getTooltip(l.tooltip),i.item.command=this.getCommand(i.disposableStore,l.command),i.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(p=>p?this.resolveUnknownParentChain(p).then(C=>this.resolveTreeNode(p,C[C.length-1]).then(i=>(C.push(i),C))):Promise.resolve([]))}resolveParent(o){const p=this.nodes.get(o);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,p){const C=this.nodes.get(o);return C?Promise.resolve(C):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(i=>this.createHandle(o,i,p,!0)).then(i=>this.getChildren(p?p.item.handle:void 0).then(()=>{const l=this.getExtensionElement(i);if(l){const r=this.nodes.get(l);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(o){if(o){let p;if(typeof o=="string"){const C=this.getExtensionElement(o);p=C?this.nodes.get(C):void 0}else p=o;return p&&p.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const p=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const C=o?this.nodes.get(o):void 0,i=await this.dataProvider.getChildren(o);if(p.token.isCancellationRequested)return;const l=await Promise.all((0,y.coalesce)(i||[]).map(async r=>{const a=await this.dataProvider.getTreeItem(r);return a&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(r,a,C):null}));return p.token.isCancellationRequested?void 0:(0,y.coalesce)(l)}finally{p.dispose()}}refresh(o){if(o.some(C=>!C))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const C=this.getHandlesToRefresh(o);if(C.length)return this.refreshHandles(C)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const p=new Set,C=o.map(l=>this.nodes.get(l));for(const l of C)if(l&&!p.has(l.item.handle)){let r=l;for(;r&&r.parent&&C.findIndex(a=>r&&r.parent&&a&&a.item.handle===r.parent.item.handle)===-1;){const a=this.elements.get(r.parent.item.handle);r=a?this.nodes.get(a):void 0}r&&!r.parent&&p.add(l.item.handle)}const i=[];return p.forEach(l=>{const r=this.elements.get(l);if(r){const a=this.nodes.get(r);a&&(!a.parent||!p.has(a.parent.item.handle))&&i.push(l)}}),i}refreshHandles(o){const p={};return Promise.all(o.map(C=>this.refreshNode(C).then(i=>{i&&(p[C]=i.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(o){const p=this.getExtensionElement(o);if(p){const C=this.nodes.get(p);if(C)return this.clearChildren(p),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(i=>{if(i){const l=this.createTreeNode(p,i,C.parent);return this.updateNodeCache(p,l,C,C.parent),C.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,p,C){const i=this.createTreeNode(o,p,C);if(p.id&&this.elements.has(i.item.handle))throw new Error((0,c.localize)(7,null,p.id));return this.addNodeToCache(o,i),this.addNodeToParentCache(i,C),i}getTooltip(o){return P.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,p){return p?this.commands.toInternal(p,o):void 0}createTreeNode(o,p,C){const i=new R.DisposableStore,l=this.createHandle(o,p,C),r=this.getLightIconPath(p);return{item:{handle:l,parentHandle:C?C.item.handle:void 0,label:d(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(i,p.command),contextValue:p.contextValue,icon:r,iconDark:this.getDarkIconPath(p)||r,themeIcon:this.getThemeIcon(p),collapsibleState:(0,t.isUndefinedOrNull)(p.collapsibleState)?P.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:C,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(o){return o.iconPath instanceof P.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:p,label:C,resourceUri:i},l,r){if(p)return`${k.ID_HANDLE_PREFIX}/${p}`;const a=d(C,this.extension),w=l?l.item.handle:k.LABEL_HANDLE_PREFIX;let f=a?a.label:i?(0,M.basename)(i):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const m=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,S=this.getChildrenNodes(l)||[];let T,g=0;do{if(T=`${w}/${g}:${f}`,r||!this.elements.has(T)||m===T)break;g++}while(g<=S.length);return T}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon))return typeof o.iconPath=="string"||_.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return _.URI.isUri(o)?o:_.URI.file(o)}addNodeToCache(o,p){this.elements.set(p.item.handle,o),this.nodes.set(o,p)}updateNodeCache(o,p,C,i){this.elements.delete(p.item.handle),this.nodes.delete(o),p.item.handle!==C.item.handle&&this.elements.delete(C.item.handle),this.addNodeToCache(o,p);const l=this.getChildrenNodes(i)||[],r=l.filter(a=>a.item.handle===C.item.handle)[0];r&&l.splice(l.indexOf(r),1,p)}addNodeToParentCache(o,p){p?(p.children||(p.children=[]),p.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const p=this.nodes.get(o);if(p){if(p.children)for(const C of p.children){const i=this.elements.get(C.item.handle);i&&this.clear(i)}p.children=void 0}}else this.clearAll()}clear(o){const p=this.nodes.get(o);if(p){if(p.children)for(const C of p.children){const i=this.elements.get(C.item.handle);i&&this.clear(i)}this.nodes.delete(o),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}k.LABEL_HANDLE_PREFIX="0",k.ID_HANDLE_PREFIX="1"}),define(be[174],Ee([0,1,14,3,6,10,46,8,90,67]),function(ie,e,c,M,_,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends _.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const h=this.diff[this.diff.length-1];if(h&&n[0]===1){if(h[0]===1&&h[1].extId===n[1].extId){(0,D.applyTestItemUpdate)(h[1],n[1]);return}if(h[0]===0&&h[1].item.extId===n[1].extId){(0,D.applyTestItemUpdate)(h[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,h){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||h>s.expandLevels)&&(s.expandLevels=h),s.expand===1){const d=this.resolveChildren(s);return d.isOpen()?this.expandChildren(s,h-1):d.wait().then(()=>this.expandChildren(s,h-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,h-1)):this.expandChildren(s,h-1)}}dispose(){for(const n of this.tree.values())(0,R.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,h){switch(h.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,h.id));break;case 0:this.upsertItem(h.item,n);break;case 4:for(const E of h.ops)this.onTestItemEvent(n,E);break;case 3:const{key:s,value:d,previous:v}=h,k=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(d,v,k);break;case"range":this.pushDiff([1,{extId:k,item:{range:I.Range.from(d)}}]);break;case"error":this.pushDiff([1,{extId:k,item:{error:I.MarkdownString.fromStrict(d)||null}}]);break;default:this.pushDiff([1,{extId:k,item:{[s]:d??null}}]);break}break;default:(0,A.assertNever)(h)}}upsertItem(n,h){if(!(n instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=P.TestId.fromExtHostTestItem(n,this.root.id,h?.actual),d=(0,R.getPrivateApiFor)(n);d.parent&&d.parent!==h?.actual&&d.parent.children.delete(n.id);let v=this.tree.get(s.toString());if(!v){v={fullId:s,actual:n,parent:h?s.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(n,h),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:I.TestItem.from(n)}]),this.connectItemAndChildren(n,v,h);return}if(v.actual===n){this.connectItem(n,v,h);return}const k=v.actual.children,E=v.actual,o=(0,R.diffTestItems)(E,n);(0,R.getPrivateApiFor)(E).listener=void 0,v.actual=n,v.expand=0;for(const[p,C]of o)this.onTestItemEvent(v,{op:3,key:p,value:C,previous:E[p]});this.connectItemAndChildren(n,v,h);for(const p of k)n.children.get(p.id)||this.removeItem(P.TestId.joinToString(s,p.id))}diffTagRefs(n,h,s){const d=new Set(h.map(v=>v.id));for(const v of n)d.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:s,item:{tags:n.map(v=>I.TestTag.namespace(this.controllerId,v.id))}}]),d.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const h=this.tags.get(n.id);h?h.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const h=this.tags.get(n);h&&!--h.refCount&&(this.tags.delete(n),this.pushDiff([6,I.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,h){(0,R.getPrivateApiFor)(n).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(n,h,s){this.setItemParent(n,s);const d=(0,R.getPrivateApiFor)(n);d.parent=s?.actual,d.listener=v=>this.onTestItemEvent(h,v),this.updateExpandability(h)}connectItemAndChildren(n,h,s){this.connectItem(n,h,s);for(const d of n.children)this.upsertItem(d,h)}updateExpandability(n){let h;this._resolveHandler?n.resolveBarrier?h=n.resolveBarrier.isOpen()?3:2:h=n.actual.canResolveChildren?1:0:h=0,h!==n.expand&&(n.expand=h,this.pushDiff([1,{extId:n.fullId.toString(),expand:h}]),h===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,h){if(h<0)return;const s=[];for(const d of n.actual.children){const v=this.expand(P.TestId.joinToString(n.fullId,d.id),h);(0,c.isThenable)(v)&&s.push(v)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const v=new c.Barrier;return v.open(),v}n.expand=2,this.pushExpandStateUpdate(n);const h=n.resolveBarrier=new c.Barrier,s=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=v.stack||v.message||String(v))};let d;try{d=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(v){s(v)}return(0,c.isThenable)(d)?d.catch(s).then(()=>{h.open(),this.updateExpandability(n)}):(h.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const h=this.tree.get(n);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[h];for(;s.length;){const d=s.pop();if(!!d){(0,R.getPrivateApiFor)(d.actual).listener=void 0;for(const v of d.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(d.fullId.toString());for(const v of d.actual.children)s.push(this.tree.get(P.TestId.joinToString(d.fullId,v.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[175],Ee([0,1,4,141]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(M.IEnvironmentService)}),define(be[176],Ee([0,1,25,3,17]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class R{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let y of t.activationEvents)y==="onUri"&&(y=`onUri:${c.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(t)}}keepOnly(t){const y=new Set;t.forEach(n=>y.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>y.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,y){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=R._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(n.map(h=>h.identifier)),y.length>0){const h=new Set;y.forEach(s=>h.add(c.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!h.has(c.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,k){this.addNode(v),this.addNode(k),this._arcs.has(v)?this._arcs.get(v).push(k):this._arcs.set(v,[k])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,k){const E=y.getArcs(v);for(let o=0;o<E.length;o++)if(!k.has(E[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let v of t){const k=c.ExtensionIdentifier.toKey(v.identifier);if(n.set(k,v),v.extensionDependencies)for(let E of v.extensionDependencies){const o=c.ExtensionIdentifier.toKey(E);y.addArc(k,o)}}let h=new Set;y.getNodes().filter(v=>y.getArcs(v).length===0).forEach(v=>h.add(v));let s=y.getNodes().filter(v=>!h.has(v)),d;do{d=!1;for(let v=0;v<s.length;v++){const k=s[v];y.hasOnlyGoodArcs(k,h)&&(s.splice(v,1),v--,h.add(k),d=!0)}}while(d);return s.map(v=>n.get(v))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const y=this._activationMap.get(t);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const y=this._extensionsMap.get(c.ExtensionIdentifier.toKey(t));return y||void 0}}e.ExtensionDescriptionRegistry=R;var I;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(I||(I={}));function D(P,t){const y=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(y!==n)return y-n;const h=_.posix.basename(P.extensionLocation.path),s=_.posix.basename(t.extensionLocation.path);return h<s?-1:h>s?1:0}}),define(be[177],Ee([0,1,23]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function A(I){const D=c.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function R(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=R}),define(be[30],Ee([0,1,3,2,4,25,142]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var I;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class D{constructor(p){this.dependency=p}}e.MissingExtensionDependency=D;var P;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));function t(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=t;class y{constructor(p,C,i,l){this.codeLoadingTime=p,this.activateCallTime=C,this.activateResolvedTime=i,this.activationReason=l}}e.ActivationTimes=y;class n{constructor(p,C){this.description=p,this.value=C}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var h;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function s(o){o.enableProposedApi||d(o)}e.checkProposedApiEnabled=s;function d(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=d;function v(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=v;function k(o,p){return{identifier:new A.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!p,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=k;class E{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(p){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(p){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(p,C){return Promise.resolve()}_onWillActivateExtension(p){}_onDidActivateExtension(p,C,i,l,r){}_onDidActivateExtensionError(p,C){}_onExtensionRuntimeError(p,C){}_onExtensionHostExit(p){}}e.NullExtensionService=E}),define(be[178],Ee([0,1,25,30,15]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class R{constructor(s,d,v,k){this.startup=s,this.codeLoadingTime=d,this.activateCallTime=v,this.activateResolvedTime=k}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class I{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,d){return s===-1||d===-1?-1:d-s}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class D{constructor(s,d,v,k,E,o){this.activationFailed=s,this.activationFailedError=d,this.activationTimes=v,this.module=k,this.exports=E,this.subscriptions=o}}e.ActivatedExtension=D;class P extends D{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends D{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class y extends D{constructor(s){super(!0,s,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=y;let n=class{constructor(s,d,v,k,E){this._logService=E,this._registry=s,this._resolvedExtensionsSet=new Set,d.forEach(o=>this._resolvedExtensionsSet.add(c.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,v.forEach(o=>this._hostExtensionsMap.set(c.ExtensionIdentifier.toKey(o),o)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const d=c.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(d)}getActivatedExtension(s){const d=c.ExtensionIdentifier.toKey(s),v=this._activatedExtensions.get(d);if(!v)throw new Error("Extension `"+s.value+"` is not known or not activated");return v}activateByEvent(s,d){if(this._alreadyActivatedEvents[s])return A;const v=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(v.map(k=>({id:k.identifier,reason:{startup:d,extensionId:k.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,d){const v=this._registry.getExtensionDescription(s);if(!v)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:v.identifier,reason:d}])}_handleActivateRequest(s,d,v){if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(s.id))){d[c.ExtensionIdentifier.toKey(s.id)]=s;return}const k=this._registry.getExtensionDescription(s.id);if(!k){const p=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,p,new M.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(s.id),new y(p));return}const E=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let o=!0;for(let p=0,C=E.length;p<C;p++){const i=E[p];if(this._resolvedExtensionsSet.has(c.ExtensionIdentifier.toKey(i)))continue;const l=this._activatedExtensions.get(c.ExtensionIdentifier.toKey(i));if(l&&!l.activationFailed)continue;if(l&&l.activationFailed){const f=k.displayName||k.identifier.value,m=this._registry.getExtensionDescription(i),S=m&&m.displayName||i,T=new Error(`Cannot activate the '${f}' extension because its dependency '${S}' failed to activate`);T.detail=l.activationFailedError,this._host.onExtensionActivationError(k.identifier,T,null),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(k.identifier),new y(T));return}if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(i))){o=!1,d[c.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(c.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){o=!1,d[c.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:s.reason};continue}const a=k.displayName||k.identifier.value,w=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(k.identifier,w,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(k.identifier),new y(w));return}o?d[c.ExtensionIdentifier.toKey(k.identifier)]=s:v.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(E=>!this._activatedExtensions.has(c.ExtensionIdentifier.toKey(E.id))),s.length===0))return Promise.resolve(void 0);const d=Object.create(null),v=[];for(let E=0,o=s.length;E<o;E++)this._handleActivateRequest(s[E],d,v);for(let E=0,o=v.length;E<o;E++){const p=c.ExtensionIdentifier.toKey(v[E].id);d[p]&&delete d[p]}const k=Object.keys(d).map(E=>d[E]);return v.length===0?Promise.all(k.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(k).then(E=>this._activateExtensions(v))}_activateExtension(s,d){const v=c.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const k=this._activatingExtensions.get(v);if(k)return k;const E=this._host.actualActivateExtension(s,d).then(void 0,o=>{const p=new Error;return o&&o.name&&(p.name=o.name),o&&o.message?p.message=`Activating extension '${s.value}' failed: ${o.message}.`:p.message=`Activating extension '${s.value}' failed: ${o}.`,o&&o.stack&&(p.stack=o.stack),this._host.onExtensionActivationError(s,p,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(o),new y(o)}).then(o=>{this._activatedExtensions.set(v,o),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,E),E}};n=Ue([He(4,_.ILogService)],n),e.ExtensionsActivator=n}),define(be[179],Ee([0,1,16]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,c.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[47],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const M=[];function _(D){const P=new c(!0,D);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=_;function A(D){const P=new c(!1,D);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=A;function R(D){return M[D].sid}e.getStringIdentifierForProxy=R;class I{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=I}),define(be[5],Ee([0,1,54,2,47]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var R;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function p(i,l){return Object.defineProperty(i,o.name,{value:l,enumerable:!0}),i}o.mixin=p;function C(i){return i[o.name]}o.of=C})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(p){return p._id=h._n++,p}}e.IdObject=h,h._n=0;var s;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function k(o){if(o&&o.edits)for(const p of o.edits)typeof p.resource=="object"?p.resource=M.URI.revive(p.resource):(p.newUri=M.URI.revive(p.newUri),p.oldUri=M.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,c.revive)(p.metadata));return o}e.reviveWorkspaceEditDto=k;var E;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,_.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,_.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,_.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,_.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(I){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,P){return this._proxy.$setPassword(I,D,P)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,15,5,12]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(_.MainContext.MainThreadTelemetry)}report(D,P,t){const y=this.getUsageKey(D,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};R=Ue([He(0,A.IExtHostRpcService),He(1,M.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,P){}})}),define(be[180],Ee([0,1,3,5,7,25]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,P,t,y={}){const n=A.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(n)||[],s=[...t].sort().join(" ");let d=h.find(v=>v.scopes===s);if(d)return d.result;{const v=this._getSession(D,n,P,t,y);d={scopes:s,result:v},h.push(d),this._inFlightRequests.set(n,h);try{await v}finally{const k=h.findIndex(E=>E.scopes===s);k>-1&&(h.splice(k),this._inFlightRequests.set(n,h))}return v}}async _getSession(D,P,t,y,n={}){await this._proxy.$ensureProvider(t);const h=D.displayName||D.name;return this._proxy.$getSession(t,y,P,h,n)}async removeSession(D,P){const t=this._authenticationProviders.get(D);return t?t.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,t,y){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:t,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===D)||this._providers.push({id:D,label:P});const n=t.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(D,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,P,y?.supportsMultipleAccounts??!1),new _.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(D);const h=this._providers.findIndex(s=>s.id===D);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const t=this._authenticationProviders.get(D);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(be[181],Ee([0,1,5,12,8]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=_.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=Ue([He(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[182],Ee([0,1,5]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const R=A.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(I){return R.$writeText(I)}})}}e.ExtHostClipboard=M}),define(be[48],Ee([0,1,10,7,8,22,5,13,15,54,42,111,2,6,4,12,46]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let k=class{constructor(l,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=l.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new E(this,a=>{const w=this._apiCommands.get(a);return w?.result===p.Void?w:void 0},r),this._argumentProcessors=[{processArgument(a){return(0,P.revive)(a)}},{processArgument(a){return(0,A.cloneAndChange)(a,function(w){if(t.Range.isIRange(w))return _.Range.to(w);if(y.Position.isIPosition(w))return _.Position.to(w);if(t.Range.isIRange(w.range)&&n.URI.isUri(w.uri))return _.location.to(w);if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const r=this.registerCommand(!1,l.id,async(...a)=>{const w=l.args.map((m,S)=>{if(!m.validate(a[S]))throw new Error(`Invalid argument '${m.name}' when running '${l.id}', received: ${a[S]}`);return m.convert(a[S])}),f=await this.executeCommand(l.internalId,...w);return l.result.convert(f,a,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new M.Disposable(()=>{r.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,r,a,w,f){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:a,thisArg:w,description:f}),l&&this._proxy.$registerCommand(r),new M.Disposable(()=>{this._commands.delete(r)&&l&&this._proxy.$unregisterCommand(r)})}executeCommand(l,...r){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,r,!0)}async _doExecuteCommand(l,r,a){if(this._commands.has(l))return this._executeContributedCommand(l,r);{const w=(0,A.cloneAndChange)(r,function(f){if(f instanceof M.Position)return _.Position.from(f);if(f instanceof M.Range)return _.Range.from(f);if(f instanceof M.Location)return _.location.from(f);if(M.NotebookRange.isNotebookRange(f))return _.NotebookRange.from(f);if(!Array.isArray(f))return f});try{const f=await this._proxy.$executeCommand(l,w,a);return(0,P.revive)(f)}catch(f){if(f instanceof Error&&f.message==="$executeCommand:retry")return this._doExecuteCommand(l,r,!1);throw f}}}async _executeContributedCommand(l,r){const a=this._commands.get(l);if(!a)throw new Error("Unknown command");let{callback:w,thisArg:f,description:m}=a;if(m)for(let S=0;S<m.args.length;S++)try{(0,c.validateConstraint)(r[S],m.args[S].constraint)}catch(T){throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${m.args[S].name}' - ${m.args[S].description}`)}try{return await w.apply(f,r)}catch(S){if(l===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...r);T&&(l=T.command)}throw this._logService.error(S,l),new Error(`Running the contributed command: '${l}' failed.`)}}$executeContributedCommand(l,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(r=r.map(a=>this._argumentProcessors.reduce((w,f)=>f.processArgument(w),a)),this._executeContributedCommand(l,r)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),this._proxy.$getCommands().then(r=>(l&&(r=r.filter(a=>a[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(let[r,a]of this._commands){let{description:w}=a;w&&(l[r]=w)}return Promise.resolve(l)}};k=Ue([He(0,d.IExtHostRpcService),He(1,D.ILogService)],k),e.ExtHostCommands=k,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class E{constructor(l,r,a){this._commands=l,this._lookupApiCommand=r,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,r){if(!l)return;const a={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return a;const w=this._lookupApiCommand(l.command);if(w)a.id=w.internalId,a.arguments=w.args.map((f,m)=>f.convert(l.arguments&&l.arguments[m]));else if((0,I.isNonEmptyArray)(l.arguments)){const f=++this._cachIdPool;this._cache.set(f,l),r.add((0,h.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),a.$ident=f,a.id=this.delegatingCommandId,a.arguments=[f],this._logService.trace("CommandsConverter#CREATE",l.command,f)}return a}fromInternal(l){const r=R.ObjectIdentifier.of(l);return typeof r=="number"?this._cache.get(r):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const r=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=E;class o{constructor(l,r,a,w){this.name=l,this.description=r,this.validate=a,this.convert=w}optional(){return new o(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,r){return new o(l??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),o.Position=new o("position","A position in a text document",i=>M.Position.isPosition(i),_.Position.from),o.Range=new o("range","A range in a text document",i=>M.Range.isRange(i),_.Range.from),o.Selection=new o("selection","A selection in a text document",i=>M.Selection.isSelection(i),_.Selection.from),o.Number=new o("number","",i=>typeof i=="number",i=>i),o.String=new o("string","",i=>typeof i=="string",i=>i),o.CallHierarchyItem=new o("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,_.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,_.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",i=>i instanceof v.TestItemImpl,_.TestItem.from);class p{constructor(l,r){this.description=l,this.convert=r}}e.ApiCommandResult=p,p.Void=new p("no result",i=>i);class C{constructor(l,r,a,w,f){this.id=l,this.internalId=r,this.description=a,this.args=w,this.result=f}}e.ApiCommand=C}),define(be[183],Ee([0,1,8,7,59,48,13,80]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(c.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,R.isFalsyOrEmpty)(n))return;class s extends M.SymbolInformation{static to(v){const k=new s(v.name,c.SymbolKind.to(v.kind),v.containerName||"",new M.Location(h[0],c.Range.to(v.range)));return k.detail=v.detail,k.range=k.location.range,k.selectionRange=c.Range.to(v.selectionRange),k.children=v.children?v.children.map(s.to):[],k}}return n.map(s.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(c.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(c.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>M.Position.isPosition(h)),n=>n.map(c.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let s;for(const d of h.reverse())s=new M.SelectionRange(c.Range.to(d),s);return s}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const h=[];if(Array.isArray(n))for(let s of n)h.push(...s[1].map(c.WorkspaceSymbol.to));return h})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,I.decodeSemanticTokensDto)(n);if(h.type==="full")return new M.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,I.decodeSemanticTokensDto)(n);if(h.type==="full")return new M.SemanticTokens(h.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,s)=>{if(!n)return new M.CompletionList([]);const d=n.suggestions.map(v=>c.CompletionItem.to(v,s));return new M.CompletionList(d,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,s)=>t(d=>new M.CodeLens(c.Range.to(d.range),d.command&&s.fromInternal(d.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,s)=>t(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(d.command)}else{const v=new M.CodeAction(d.title,d.kind?new M.CodeActionKind(d.kind):void 0);return d.edit&&(v.edit=c.WorkspaceEdit.to(d.edit)),d.command&&(v.command=s.fromInternal(d.command)),v.isPreferred=d.isPreferred,v}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new M.ColorInformation(c.Range.to(h.range),c.Color.to(h.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,c.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>c.NotebookExclusiveDocumentPattern.to(h))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class P{static register(h){D.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=P;function t(n){return h=>{if(Array.isArray(h))return h.map(n)}}function y(n){if(!Array.isArray(n))return;const h=[];for(const s of n)_.isLocationLink(s)?h.push(c.DefinitionLink.to(s)):h.push(c.location.to(s));return h}}),define(be[184],Ee([0,1,14,52,3,6,2,59,25,8,7,5]),function(ie,e,c,M,_,A,R,I,D,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(h,s,d){const v=h.getProxy(y.MainContext.MainThreadComments);class k{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const w=this._commentControllers.get(a.handle);return w||a}else if(a&&a.$mid===7){const w=this._commentControllers.get(a.commentControlHandle);if(!w)return a;const f=w.getCommentThread(a.commentThreadHandle);return f||a}else if(a&&a.$mid===8){const w=this._commentControllers.get(a.thread.commentControlHandle);if(!w)return a;const f=w.getCommentThread(a.thread.commentThreadHandle);return f?{thread:f,text:a.text}:a}else if(a&&a.$mid===9){const w=this._commentControllers.get(a.thread.commentControlHandle);if(!w)return a;const f=w.getCommentThread(a.thread.commentThreadHandle);if(!f)return a;let m=a.commentUniqueId,S=f.getCommentByUniqueId(m);return S||a}else if(a&&a.$mid===10){const w=this._commentControllers.get(a.thread.commentControlHandle);if(!w)return a;const f=w.getCommentThread(a.thread.commentThreadHandle);if(!f)return a;let m=a.text,S=a.commentUniqueId,T=f.getCommentByUniqueId(S);return T?(T.body=m,T):a}return a}})}createCommentController(a,w,f){const m=k.handlePool++,S=new o(a,m,w,f);this._commentControllers.set(S.handle,S);const T=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(a.identifier))||[];return T.push(S),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(a.identifier),T),S.value}$createCommentThreadTemplate(a,w,f){const m=this._commentControllers.get(a);!m||m.$createCommentThreadTemplate(w,f)}async $updateCommentThreadTemplate(a,w,f){const m=this._commentControllers.get(a);!m||m.$updateCommentThreadTemplate(w,f)}$deleteCommentThread(a,w){const f=this._commentControllers.get(a);f&&f.$deleteCommentThread(w)}$provideCommentingRanges(a,w,f){const m=this._commentControllers.get(a);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const S=d.getDocument(R.URI.revive(w));return(0,c.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(S,f)).then(T=>T?T.map(g=>P.Range.from(g)):void 0)}$toggleReaction(a,w,f,m,S){const T=this._commentControllers.get(a);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const g=T.getCommentThread(w);if(g){const b=g.getCommentByUniqueId(m.uniqueIdInThread);if(T!==void 0&&b&&T.reactionHandler)return T.reactionHandler(b,i(S))}return Promise.resolve(void 0)})}dispose(){}}k.handlePool=0;class E{constructor(a,w,f,m,S,T,g){this._commentControllerHandle=w,this._id=f,this._uri=m,this._range=S,this._comments=T,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${a}.${this.handle}`),v.$createCommentThread(w,this.handle,this._id,this._uri,P.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(w,this.handle)}});const b=this;this.value={get uri(){return b.uri},get range(){return b.range},set range(u){b.range=u},get comments(){return b.comments},set comments(u){b.comments=u},get collapsibleState(){return b.collapsibleState},set collapsibleState(u){b.collapsibleState=u},get canReply(){return b.canReply},set canReply(u){b.canReply=u},get contextValue(){return b.contextValue},set contextValue(u){b.contextValue=u},get label(){return b.label},set label(u){b.label=u},dispose:()=>{b.dispose()}}}set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const a=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),w={};a("range")&&(w.range=P.Range.from(this._range)),a("label")&&(w.label=this.label),a("contextValue")&&(w.contextValue=this.contextValue),a("comments")&&(w.comments=this._comments.map(f=>p(this,f,this._commentsMap))),a("collapsibleState")&&(w.collapseState=l(this._collapseState)),a("canReply")&&(w.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,w)}getCommentByUniqueId(a){for(let w of this._commentsMap){let f=w[0],m=w[1];if(a===m)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose())}}E._handlePool=0,Ue([(0,M.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(a,w,f,m){this._extension=a,this._handle=w,this._id=f,this._label=m,this._threads=new Map,v.$registerCommentController(this.handle,f,m);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(T){S.options=T},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(T){S.commentingRangeProvider=T},get reactionHandler(){return S.reactionHandler},set reactionHandler(T){S.reactionHandler=T},createCommentThread(T,g,b){return S.createCommentThread(T,g,b).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(a,w,f,m){if(typeof a=="string"){const S=new E(this.id,this.handle,a,w,f,m,this._extension.identifier);return this._threads.set(S.handle,S),S}else{const S=new E(this.id,this.handle,void 0,a,w,f,this._extension.identifier);return this._threads.set(S.handle,S),S}}$createCommentThreadTemplate(a,w){const f=new E(this.id,this.handle,void 0,R.URI.revive(a),P.Range.to(w),[],this._extension.identifier);return f.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(a,w){let f=this._threads.get(a);f&&(f.range=P.Range.to(w))}$deleteCommentThread(a){let w=this._threads.get(a);w&&w.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._localDisposables.forEach(a=>a.dispose())}}function p(r,a,w){let f=w.get(a);f||(f=++r.commentHandle,w.set(a,f));const m=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:f,body:P.MarkdownString.from(a.body),userName:a.author.name,userIconPath:m,label:a.label,commentReactions:a.reactions?a.reactions.map(S=>C(S)):void 0}}function C(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function l(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new k}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,12,15,13,9,17]),function(ie,e,c,M,_,A,R,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class vi{constructor(h,s){this._logService=s,this._provider=new Map,this._proxy=h.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,s){const d=vi._handlePool++;this._provider.set(d,{provider:h,extensionId:s}),this._proxy.$registerDecorationProvider(d,s.value);const v=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(d,null);return}let E=(0,D.asArray)(k);if(E.length<=vi._maxEventSize){this._proxy.$onDidChange(d,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,E.length);const o=E.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),p=(0,D.groupBy)(o,(i,l)=>i.rank-l.rank||(0,P.compare)(i.uri.path,l.uri.path));let C=[];e:for(let i of p){let l;for(let r of i){let a=(0,t.dirname)(r.uri.path);if(l!==a&&(l=a,C.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(d,C)});return new _.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(h,s,d){if(!this._provider.has(h))return Object.create(null);const v=Object.create(null),{provider:k,extensionId:E}=this._provider.get(h);return await Promise.all(s.map(async o=>{try{const{uri:p,id:C}=o,i=await Promise.resolve(k.provideFileDecoration(c.URI.revive(p),d));if(!i)return;try{_.FileDecoration.validate(i),v[C]=[i.propagate,i.tooltip,i.badge,i.color]}catch(l){this._logService.warn(`INVALID decoration from extension '${E.value}': ${l}`)}}catch(p){this._logService.error(p)}})),v}};y._handlePool=0,y._maxEventSize=250,y=Ue([He(0,R.IExtHostRpcService),He(1,I.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[185],Ee([0,1,123,82,2,5,7,8,3,15,20,37]),function(ie,e,c,M,_,A,R,I,D,P,t,y){"use strict";var n,h,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(E,o,p,C,i,l){this._name=E,this._owner=o,this._maxDiagnosticsPerFile=p,n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Je(this,s,new t.ResourceMap(r=>C.getComparisonKey(r)),"f"),Je(this,n,i,"f"),Je(this,h,l,"f")}dispose(){this._isDisposed||(Te(this,h,"f").fire([...Te(this,s,"f").keys()]),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner),Te(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(E,o){if(!E){this.clear();return}this._checkDisposed();let p=[];if(_.URI.isUri(E)){if(!o){this.delete(E);return}Te(this,s,"f").set(E,o.slice()),p=[E]}else if(Array.isArray(E)){p=[];let i;E=[...E].sort(d._compareIndexedTuplesByUri);for(const l of E){const[r,a]=l;if((!i||r.toString()!==i.toString())&&(i&&Te(this,s,"f").get(i).length===0&&Te(this,s,"f").delete(i),i=r,p.push(r),Te(this,s,"f").set(r,[])),a){const w=Te(this,s,"f").get(r);w&&w.push(...a)}else{const w=Te(this,s,"f").get(r);w&&(w.length=0)}}}if(Te(this,h,"f").fire(p),!Te(this,n,"f"))return;const C=[];for(let i of p){let l=[];const r=Te(this,s,"f").get(i);if(r)if(r.length>this._maxDiagnosticsPerFile){l=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let w=0;w<4;w++)for(let f of r)if(f.severity===a[w]&&l.push(I.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;l.push({severity:M.MarkerSeverity.Info,message:(0,c.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=r.map(a=>I.Diagnostic.from(a));C.push([i,l])}Te(this,n,"f").$changeMany(this._owner,C)}delete(E){this._checkDisposed(),Te(this,h,"f").fire([E]),Te(this,s,"f").delete(E),Te(this,n,"f")&&Te(this,n,"f").$changeMany(this._owner,[[E,void 0]])}clear(){this._checkDisposed(),Te(this,h,"f").fire([...Te(this,s,"f").keys()]),Te(this,s,"f").clear(),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner)}forEach(E,o){this._checkDisposed();for(let p of Te(this,s,"f").keys())E.apply(o,[p,this.get(p),this])}get(E){this._checkDisposed();const o=Te(this,s,"f").get(E);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(E){return this._checkDisposed(),Array.isArray(Te(this,s,"f").get(E))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(E,o){return E[0].toString()<o[0].toString()?-1:E[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=d,n=new WeakMap,h=new WeakMap,s=new WeakMap;let v=class Xt{constructor(E,o,p){this._logService=o,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:C=>C.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,Xt._mapper),this._proxy=E.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(E){const o=new t.ResourceMap;for(const p of E)o.set(p,p);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(E,o){const{_collections:p,_proxy:C,_onDidChangeDiagnostics:i,_logService:l,_fileSystemInfoService:r}=this,a=new class{$changeMany(m,S){C.$changeMany(m,S),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",E.value,m,S.length===0?"CLEARING":S)}$clear(m){C.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",E.value,m)}dispose(){C.dispose()}};let w;if(!o)o="_generated_diagnostic_collection_name_#"+Xt._idPool++,w=o;else if(!p.has(o))w=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do w=o+Xt._idPool++;while(p.has(w))}return new class extends d{constructor(){super(o,w,Xt._maxDiagnosticsPerFile,r.extUri,a,i);p.set(w,this)}dispose(){super.dispose(),p.delete(w)}}}getDiagnostics(E){if(E)return this._getDiagnostics(E);{const o=new Map,p=[];for(const C of this._collections.values())C.forEach((i,l)=>{let r=o.get(i.toString());typeof r=="undefined"&&(r=p.length,o.set(i.toString(),r),p.push([i,[]])),p[r][1]=p[r][1].concat(...l)});return p}}_getDiagnostics(E){let o=[];for(let p of this._collections.values())p.has(E)&&(o=o.concat(p.get(E)));return o}$acceptMarkersChange(E){if(!this._mirrorCollection){const o="_generated_mirror",p=new d(o,o,Xt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,p),this._mirrorCollection=p}for(const[o,p]of E)this._mirrorCollection.set(_.URI.revive(o),p.map(I.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=Ue([He(1,P.ILogService),He(2,y.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(be[186],Ee([0,1,2,5]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(R){this._proxy=R.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(I=>I?I.map(D=>c.URI.revive(D)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(I=>I?c.URI.revive(I):void 0)}}e.ExtHostDialogs=_}),define(be[187],Ee([0,1,16,2,7,5,11,21,9]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,n,h){this._documentsAndEditors=n,this._logService=h,this._documentContentProviders=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,n){if(Object.keys(R.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const h=P._handlePool++;this._documentContentProviders.set(h,n),this._proxy.$registerTextContentProvider(h,y);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(d=>{if(d.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(h,d).then(v=>{if(!v&&typeof v!="string")return;const k=this._documentsAndEditors.getDocument(d);if(!k)return;const E=(0,D.splitLines)(v);if(!k.equalLines(E))return this._proxy.$onVirtualDocumentChange(d,v)},c.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(y,n){const h=this._documentContentProviders.get(y);return h?Promise.resolve(h.provideTextDocumentContent(M.URI.revive(n),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(be[188],Ee([0,1,3,6,2,5,88,8,10,22,7]),function(ie,e,c,M,_,A,R,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(h,s){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const v of d)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const v of d)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const s=this._documentsAndEditors.getDocument(h);if(s)return s}getDocument(h){const s=this.getDocumentData(h);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return s.document}ensureDocumentData(h){const s=this._documentsAndEditors.getDocument(h);if(s)return Promise.resolve(s);let d=this._documentLoader.get(h.toString());return d||(d=this._proxy.$tryOpenDocument(h).then(v=>{this._documentLoader.delete(h.toString());const k=_.URI.revive(v);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(k))},v=>(this._documentLoader.delete(h.toString()),Promise.reject(v))),this._documentLoader.set(h.toString(),d)),d}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(s=>_.URI.revive(s))}$acceptModelModeChanged(h,s){const d=_.URI.revive(h),v=this._documentsAndEditors.getDocument(d);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(s),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(h){const s=_.URI.revive(h),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(h,s){const d=_.URI.revive(h),v=this._documentsAndEditors.getDocument(d);if(!v)throw new Error("unknown document");v._acceptIsDirty(s),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,s,d){const v=_.URI.revive(h),k=this._documentsAndEditors.getDocument(v);if(!k)throw new Error("unknown document");k._acceptIsDirty(d),k.onEvents(s);let E;s.isUndoing?E=t.TextDocumentChangeReason.Undo:s.isRedoing&&(E=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:k.document,contentChanges:s.changes.map(o=>({range:I.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:E}))}setWordDefinitionFor(h,s){(0,R.setWordDefinitionFor)(h,s)}}e.ExtHostDocuments=y}),define(be[49],Ee([0,1,40,3,6,2,4,5,88,12,94,8,15,20,11,231,103]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class k{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(p,C){this._extHostRpc=p,this._logService=C,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const C=[],i=[],l=[];if(p.removedDocuments)for(const r of p.removedDocuments){const a=A.URI.revive(r),w=this._documents.get(a);w?.unref()&&(this._documents.delete(a),C.push(w.value))}if(p.addedDocuments)for(const r of p.addedDocuments){const a=A.URI.revive(r.uri);let w=this._documents.get(a);if(w&&a.scheme!==s.Schemas.vscodeNotebookCell&&a.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);w||(w=new k(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(a,w),i.push(w.value)),w.ref()}if(p.removedEditors)for(const r of p.removedEditors){const a=this._editors.get(r);this._editors.delete(r),a&&l.push(a)}if(p.addedEditors)for(const r of p.addedEditors){const a=A.URI.revive(r.documentUri);c.ok(this._documents.has(a),`document '${a}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const w=this._documents.get(a).value,f=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>w.document),r.selections.map(y.Selection.to),r.options,r.visibleRanges.map(m=>y.Range.to(m)),typeof r.editorPosition=="number"?y.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}p.newActiveEditor!==void 0&&(c.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,_.dispose)(C),(0,_.dispose)(l),p.removedDocuments&&this._onDidRemoveDocuments.fire(C),p.addedDocuments&&this._onDidAddDocuments.fire(i),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const C=this._editors.get(this._activeEditorId);return p?C:C?.value}allEditors(){return[...this._editors.values()]}};E=Ue([He(0,P.IExtHostRpcService),He(1,n.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[189],Ee([0,1,2,5,6,7,8,232,9,23]),function(ie,e,c,M,_,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const s=this._schemes.indexOf(h);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),s=[];let d,v,k=14,E=14;for(const o of h){let p=d?(0,D.commonPrefixLength)(d,o):0;for(p===0?v=1:v=E;p<o.length;p++)p+1===o.length?(k=E,E=9):E+=1,s.push([v,o.toUpperCase().charCodeAt(p),E]),s.push([v,o.toLowerCase().charCodeAt(p),E]),v=E;d=o,E=k}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new I.StateMachine(s)}}provideDocumentLinks(h){this._initStateMachine();const s=[],d=I.LinkComputer.computeLinks({getLineContent(v){return h.lineAt(v-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const v of d){const k=R.DocumentLink.to(v);k.target&&s.push(k)}return s}}class y{constructor(h,s){this._extHostLanguageFeatures=s,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,s,d,v={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const k=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(k,d);let E=2;v.isCaseSensitive&&(E+=1024),v.isReadonly&&(E+=2048),typeof d.copy=="function"&&(E+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(k,s,E).catch(p=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${s}`),console.error(p)});const o=d.onDidChangeFile(p=>{const C=[];for(const i of p){let{uri:l,type:r}=i;if(l.scheme!==s)continue;let a;switch(r){case A.FileChangeType.Changed:a=0;break;case A.FileChangeType.Created:a=1;break;case A.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}C.push({resource:l,type:a})}this._proxy.$onFileSystemChange(k,C)});return(0,_.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(h){const{type:s,ctime:d,mtime:v,size:k,permissions:E}=h;return{type:s,ctime:d,mtime:v,size:k,permissions:E}}$stat(h,s){return Promise.resolve(this._getFsProvider(h).stat(c.URI.revive(s))).then(d=>y._asIStat(d))}$readdir(h,s){return Promise.resolve(this._getFsProvider(h).readDirectory(c.URI.revive(s)))}$readFile(h,s){return Promise.resolve(this._getFsProvider(h).readFile(c.URI.revive(s))).then(d=>P.VSBuffer.wrap(d))}$writeFile(h,s,d,v){return Promise.resolve(this._getFsProvider(h).writeFile(c.URI.revive(s),d.buffer,v))}$delete(h,s,d){return Promise.resolve(this._getFsProvider(h).delete(c.URI.revive(s),d))}$rename(h,s,d,v){return Promise.resolve(this._getFsProvider(h).rename(c.URI.revive(s),c.URI.revive(d),v))}$copy(h,s,d,v){const k=this._getFsProvider(h);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(c.URI.revive(s),c.URI.revive(d),v))}$mkdir(h,s){return Promise.resolve(this._getFsProvider(h).createDirectory(c.URI.revive(s)))}$watch(h,s,d,v){const k=this._getFsProvider(h).watch(c.URI.revive(d),v);this._watches.set(s,k)}$unwatch(h,s){const d=this._watches.get(s);d&&(d.dispose(),this._watches.delete(s))}$open(h,s,d){const v=this._getFsProvider(h);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(c.URI.revive(s),d))}$close(h,s){const d=this._getFsProvider(h);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(s))}$read(h,s,d,v){const k=this._getFsProvider(h);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(v);return Promise.resolve(k.read(s,d,E.buffer,0,v)).then(o=>E.slice(0,o))}$write(h,s,d,v){const k=this._getFsProvider(h);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(s,d,v.buffer,0,v.byteLength))}_getFsProvider(h){const s=this._fsProvider.get(h);if(!s){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return s}}e.ExtHostFileSystem=y}),define(be[71],Ee([0,1,5,60,7,23,4,12,37]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(y,n){const h=y.getProxy(c.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return h.$stat(s).catch(Ut._handleError)},readDirectory(s){return h.$readdir(s).catch(Ut._handleError)},createDirectory(s){return h.$mkdir(s).catch(Ut._handleError)},async readFile(s){return h.$readFile(s).then(d=>d.buffer).catch(Ut._handleError)},writeFile(s,d){return h.$writeFile(s,A.VSBuffer.wrap(d)).catch(Ut._handleError)},delete(s,d){return h.$delete(s,{recursive:!1,useTrash:!1,...d}).catch(Ut._handleError)},rename(s,d,v){return h.$rename(s,d,{overwrite:!1,...v}).catch(Ut._handleError)},copy(s,d,v){return h.$copy(s,d,{overwrite:!1,...v}).catch(Ut._handleError)},isWritableFileSystem(s){const d=n.getCapabilities(s);if(typeof d=="number")return!(d&2048)}})}static _handleError(y){if(!(y instanceof Error))throw new _.FileSystemError(String(y));if(y.name==="ENOPRO")throw _.FileSystemError.Unavailable(y.message);switch(y.name){case M.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(y.message);case M.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(y.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(y.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(y.message);case M.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(y.message);case M.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(y.message);default:throw new _.FileSystemError(y.message,y.name)}}};P=Ue([He(0,I.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(be[190],Ee([0,1,2,48]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(R,I,D,P){this._extHostNotebooks=I,this._textDocumentsAndEditors=D,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new M.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new M.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new M.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new M.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:c.URI.revive(y.notebookUri),inputUri:c.URI.revive(y.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(y.notebookUri),inputUri:c.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(R,I,D,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],modeId:D,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=_}),define(be[191],Ee([0,1,6,5]),function(ie,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(R){this._handlePool=0,this._proxy=R.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,R),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=_}),define(be[192],Ee([0,1,2,22,8,7,5,9,42,13,10,233,6,80,53,63,193,16,3]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentSymbols(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentSymbols(ee,Y);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(_.DocumentSymbol.from):o._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((ae,V)=>{let oe=ae.location.range.start.compareTo(V.location.range.start);return oe===0&&(oe=V.location.range.end.compareTo(ae.location.range.end)),oe});const Y=[],ee=[];for(const ae of x){const V={name:ae.name||"!!MISSING: name!!",kind:_.SymbolKind.from(ae.kind),tags:ae.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:_.Range.from(ae.location.range),selectionRange:_.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(V),Y.push(V);break}const oe=ee[ee.length-1];if(D.Range.containsRange(oe.range,V.range)&&!D.Range.equalsRange(oe.range,V.range)){oe.children&&oe.children.push(V),ee.push(V);break}ee.pop()}}return Y}}class p{constructor(x,Y,ee){this._documents=x,this._commands=Y,this._provider=ee,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideCodeLenses(ee,Y);if(!ae||Y.isCancellationRequested)return;const V=this._cache.add(ae),oe=new n.DisposableStore;this._disposables.set(V,oe);const fe={cacheId:V,lenses:[]};for(let Ae=0;Ae<ae.length;Ae++)fe.lenses.push({cacheId:[V,Ae],range:_.Range.from(ae[Ae].range),command:this._commands.toInternal(ae[Ae].command,oe)});return fe}async resolveCodeLens(x,Y){const ee=x.cacheId&&this._cache.get(...x.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,Y),ae||(ae=ee),Y.isCancellationRequested)return;const V=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!V)return x.command=this._commands.toInternal(ae.command??p._badCmd,V),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}p._badCmd={command:"missing",title:"!!MISSING: command!!"};function C(qe){return Array.isArray(qe)?qe.map(_.DefinitionLink.from):qe?[_.DefinitionLink.from(qe)]:[]}class i{constructor(x,Y){this._documents=x,this._provider=Y}async provideDefinition(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.provideDefinition(ae,V,ee);return C(oe)}}class l{constructor(x,Y){this._documents=x,this._provider=Y}async provideDeclaration(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.provideDeclaration(ae,V,ee);return C(oe)}}class r{constructor(x,Y){this._documents=x,this._provider=Y}async provideImplementation(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.provideImplementation(ae,V,ee);return C(oe)}}class a{constructor(x,Y){this._documents=x,this._provider=Y}async provideTypeDefinition(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.provideTypeDefinition(ae,V,ee);return C(oe)}}class w{constructor(x,Y){this._documents=x,this._provider=Y}async provideHover(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.provideHover(ae,V,ee);if(!(!oe||(0,P.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(V)),oe.range||(oe.range=new A.Range(V,V)),_.Hover.from(oe)}}class f{constructor(x,Y){this._documents=x,this._provider=Y}async provideEvaluatableExpression(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.provideEvaluatableExpression(ae,V,ee);if(oe)return _.EvaluatableExpression.from(oe)}}class m{constructor(x,Y){this._documents=x,this._provider=Y}async provideInlineValues(x,Y,ee,ae){const V=this._documents.getDocument(x),oe=await this._provider.provideInlineValues(V,_.Range.to(Y),_.InlineValueContext.to(ee),ae);if(Array.isArray(oe))return oe.map(fe=>_.InlineValue.from(fe))}}class S{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentHighlights(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.provideDocumentHighlights(ae,V,ee);if(Array.isArray(oe))return oe.map(_.DocumentHighlight.from)}}class T{constructor(x,Y){this._documents=x,this._provider=Y}async provideLinkedEditingRanges(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.provideLinkedEditingRanges(ae,V,ee);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,P.coalesce)(oe.ranges.map(_.Range.from)),wordPattern:oe.wordPattern}}}class g{constructor(x,Y){this._documents=x,this._provider=Y}async provideReferences(x,Y,ee,ae){const V=this._documents.getDocument(x),oe=_.Position.to(Y),fe=await this._provider.provideReferences(V,oe,ee,ae);if(Array.isArray(fe))return fe.map(_.location.from)}}class b{constructor(x,Y,ee,ae,V,oe,fe){this._documents=x,this._commands=Y,this._diagnostics=ee,this._provider=ae,this._logService=V,this._extension=oe,this._apiDeprecation=fe,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,Y,ee,ae){const V=this._documents.getDocument(x),oe=y.Selection.isISelection(Y)?_.Selection.to(Y):_.Range.to(Y),fe=[];for(const z of this._diagnostics.getDiagnostics(x))if(oe.intersection(z.range)&&fe.push(z)>b._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:_.CodeActionTriggerKind.to(ee.trigger)},xe=await this._provider.provideCodeActions(V,oe,Ae,ae);if(!(0,P.isNonEmptyArray)(xe)||ae.isCancellationRequested)return;const $e=this._cache.add(xe),we=new n.DisposableStore;this._disposables.set($e,we);const Ze=[];for(let z=0;z<xe.length;z++){const J=xe[z];!J||(b._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,we)})):(Ae.only&&(J.kind?Ae.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[$e,z],title:J.title,command:J.command&&this._commands.toInternal(J.command,we),diagnostics:J.diagnostics&&J.diagnostics.map(_.Diagnostic.from),edit:J.edit&&_.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:$e,actions:Ze}}async resolveCodeAction(x,Y){const[ee,ae]=x,V=this._cache.get(ee,ae);if(!V||b._isCommand(V)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(V,Y)??V;return oe?.edit?_.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}b._maxCodeActionsPerFile=1e3;class u{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentFormattingEdits(x,Y,ee){const ae=this._documents.getDocument(x),V=await this._provider.provideDocumentFormattingEdits(ae,Y,ee);if(Array.isArray(V))return V.map(_.TextEdit.from)}}class F{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentRangeFormattingEdits(x,Y,ee,ae){const V=this._documents.getDocument(x),oe=_.Range.to(Y),fe=await this._provider.provideDocumentRangeFormattingEdits(V,oe,ee,ae);if(Array.isArray(fe))return fe.map(_.TextEdit.from)}}class O{constructor(x,Y){this._documents=x,this._provider=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,Y,ee,ae,V){const oe=this._documents.getDocument(x),fe=_.Position.to(Y),Ae=await this._provider.provideOnTypeFormattingEdits(oe,fe,ee,ae,V);if(Array.isArray(Ae))return Ae.map(_.TextEdit.from)}}class j{constructor(x,Y){this._provider=x,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,Y){const ee=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(x,Y);if((0,P.isNonEmptyArray)(ae))for(const V of ae){if(!V)continue;if(!V.name){this._logService.warn("INVALID SymbolInformation, lacks name",V);continue}const oe=R.IdObject.mixin(_.WorkspaceSymbol.from(V));this._symbolCache.set(oe._id,V),ee.symbols.push(oe)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(x,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ee=this._symbolCache.get(x._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,Y);return ae&&(0,M.mixin)(x,_.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(x){const Y=this._resultCache.get(x);if(Y){for(let[ee,ae]=Y;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(x)}}}class Q{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._logService=ee}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,Y,ee,ae){const V=this._documents.getDocument(x),oe=_.Position.to(Y);try{const fe=await this._provider.provideRenameEdits(V,oe,ee,ae);return fe?_.WorkspaceEdit.from(fe):void 0}catch(fe){const Ae=Q._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(x,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(x),V=_.Position.to(Y);try{const oe=await this._provider.prepareRename(ae,V,ee);let fe,Ae;if(A.Range.isRange(oe)?(fe=oe,Ae=ae.getText(oe)):(0,t.isObject)(oe)&&(fe=oe.range,Ae=oe.placeholder),!fe||!Ae)return;if(fe.start.line>V.line||fe.end.line<V.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(fe),text:Ae}}catch(oe){const fe=Q._asMessage(oe);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class W{constructor(x,Y){this.resultId=x,this.tokens=Y}}class K{constructor(x,Y){this._documents=x,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,Y,ee){const ae=this._documents.getDocument(x),V=Y!==0?this._previousResults.get(Y):null;let oe=typeof V?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,V.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return V&&this._previousResults.delete(Y),oe?(oe=K._fixProvidedSemanticTokens(oe),this._send(K._convertToEdits(V,oe),oe)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return K._isSemanticTokens(x)?K._isCorrectSemanticTokens(x)?x:new A.SemanticTokens(new Uint32Array(x.data),x.resultId):K._isSemanticTokensEdits(x)?K._isCorrectSemanticTokensEdits(x)?x:new A.SemanticTokensEdits(x.edits.map(Y=>new A.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Y of x.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Y){if(!K._isSemanticTokens(Y)||!x||!x.tokens)return Y;const ee=x.tokens,ae=ee.length,V=Y.data,oe=V.length;let fe=0;const Ae=Math.min(ae,oe);for(;fe<Ae&&ee[fe]===V[fe];)fe++;if(fe===ae&&fe===oe)return new A.SemanticTokensEdits([],Y.resultId);let xe=0;const $e=Ae-fe;for(;xe<$e&&ee[ae-xe-1]===V[oe-xe-1];)xe++;return new A.SemanticTokensEdits([{start:fe,deleteCount:ae-fe-xe,data:V.subarray(fe,oe-xe)}],Y.resultId)}_send(x,Y){if(K._isSemanticTokens(x)){const ee=this._nextResultId++;return this._previousResults.set(ee,new W(x.resultId,x.data)),(0,h.encodeSemanticTokensDto)({id:ee,type:"full",data:x.data})}if(K._isSemanticTokensEdits(x)){const ee=this._nextResultId++;return K._isSemanticTokens(Y)?this._previousResults.set(ee,new W(Y.resultId,Y.data)):this._previousResults.set(ee,new W(x.resultId)),(0,h.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(x.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=K;class ${constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentRangeSemanticTokens(x,Y,ee){const ae=this._documents.getDocument(x),V=await this._provider.provideDocumentRangeSemanticTokens(ae,_.Range.to(Y),ee);return V?this._send(V):null}_send(x){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=$;class U{constructor(x,Y,ee,ae,V){this._documents=x,this._commands=Y,this._provider=ee,this._apiDeprecation=ae,this._extension=V,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Y,ee,ae){const V=this._documents.getDocument(x),oe=_.Position.to(Y),fe=V.getWordRangeAtPosition(oe)||new A.Range(oe,oe),Ae=fe.with({end:oe}),xe=new v.StopWatch(!0),$e=await this._provider.provideCompletionItems(V,oe,ae,_.CompletionContext.to(ee));if(!$e||ae.isCancellationRequested)return;const we=Array.isArray($e)?new A.CompletionList($e):$e,Ze=U.supportsResolving(this._provider)?this._cache.add(we.items):this._cache.add([]),z=new n.DisposableStore;this._disposables.set(Ze,z);const J=[],he={x:Ze,b:J,a:{replace:_.Range.from(fe),insert:_.Range.from(Ae)},c:we.isIncomplete||void 0,d:xe.elapsed()};for(let Oe=0;Oe<we.items.length;Oe++){const Ve=we.items[Oe],tt=this._convertCompletionItem(Ve,[Ze,Oe],Ae,fe);J.push(tt)}return he}async resolveCompletionItem(x,Y){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...x);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,Y);if(!!ae)return this._convertCompletionItem(ae,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Y,ee,ae){const V=this._disposables.get(Y[0]);if(!V)throw Error("DisposableStore is missing...");const oe={x:Y,a:x.label,b:x.kind!==void 0?_.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(_.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(x.command,V)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=x.textEdit.newText):typeof x.insertText=="string"?oe.h=x.insertText:x.insertText instanceof A.SnippetString&&(oe.h=x.insertText.value,oe.i|=4);let fe;return x.textEdit?fe=x.textEdit.range:x.range&&(fe=x.range),A.Range.isRange(fe)?oe.j=_.Range.from(fe):fe&&(!ee?.isEqual(fe.inserting)||!ae?.isEqual(fe.replacing))&&(oe.j={insert:_.Range.from(fe.inserting),replace:_.Range.from(fe.replacing)}),oe}}class H{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._commands=ee,this._cache=new d.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,Y,ee,ae){const V=this._documents.getDocument(x),oe=_.Position.to(Y),fe=await this._provider.provideInlineCompletionItems(V,oe,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:_.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!fe||ae.isCancellationRequested)return;const Ae=(0,t.isArray)(fe)?{items:fe}:fe,xe=this._cache.add(Ae.items);let $e;return{pid:xe,items:Ae.items.map((we,Ze)=>{let z;return we.command&&($e||($e=new n.DisposableStore,this._disposables.set(xe,$e)),z=this._commands.toInternal(we.command,$e)),{text:we.text,range:we.range?_.Range.from(we.range):void 0,command:z,idx:Ze}})}}disposeCompletions(x){this._cache.delete(x);const Y=this._disposables.get(x);Y&&Y.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,Y){const ee=this._cache.get(x,Y);ee&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let Y=G.map.get(x);return Y||(Y=new G,G.map.set(x,Y)),Y}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=G,G.map=new WeakMap;class ue{constructor(x,Y){this._documents=x,this._provider=Y,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(x,Y,ee,ae){const V=this._documents.getDocument(x),oe=_.Position.to(Y),fe=this.reviveContext(ee),Ae=await this._provider.provideSignatureHelp(V,oe,ae,fe);if(Ae){const xe=this._cache.add([Ae]);return{..._.SignatureHelp.from(Ae),id:xe}}}reviveContext(x){let Y;if(x.activeSignatureHelp){const ee=_.SignatureHelp.to(x.activeSignatureHelp),ae=this._cache.get(x.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return{...x,activeSignatureHelp:Y}}releaseSignatureHelp(x){this._cache.delete(x)}}class q{constructor(x,Y){this._documents=x,this._provider=Y}async provideInlayHints(x,Y,ee){const ae=this._documents.getDocument(x),V=await this._provider.provideInlayHints(ae,_.Range.to(Y),ee);return V?{hints:V.map(_.InlayHint.from)}:void 0}}class le{constructor(x,Y){this._documents=x,this._provider=Y,this._cache=new d.Cache("DocumentLink")}async provideLinks(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentLinks(ee,Y);if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(_.DocumentLink.from)};{const V=this._cache.add(ae),oe={links:[],id:V};for(let fe=0;fe<ae.length;fe++){if(!le._validateLink(ae[fe]))continue;const Ae=_.DocumentLink.from(ae[fe]);Ae.cacheId=[V,fe],oe.links.push(Ae)}return oe}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,Y){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...x);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,Y);if(!(!ae||!le._validateLink(ae)))return _.DocumentLink.from(ae)}releaseLinks(x){this._cache.delete(x)}}class se{constructor(x,Y){this._documents=x,this._provider=Y}async provideColors(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentColors(ee,Y);return Array.isArray(ae)?ae.map(oe=>({color:_.Color.from(oe.color),range:_.Range.from(oe.range)})):[]}async provideColorPresentations(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Range.to(Y.range),oe=_.Color.to(Y.color),fe=await this._provider.provideColorPresentations(oe,{document:ae,range:V},ee);if(!!Array.isArray(fe))return fe.map(_.ColorPresentation.from)}}class ve{constructor(x,Y){this._documents=x,this._provider=Y}async provideFoldingRanges(x,Y,ee){const ae=this._documents.getDocument(x),V=await this._provider.provideFoldingRanges(ae,Y,ee);if(!!Array.isArray(V))return V.map(_.FoldingRange.from)}}class Fe{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._logService=ee}async provideSelectionRanges(x,Y,ee){const ae=this._documents.getDocument(x),V=Y.map(_.Position.to),oe=await this._provider.provideSelectionRanges(ae,V,ee);if(!(0,P.isNonEmptyArray)(oe))return[];if(oe.length!==V.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<V.length;Ae++){const xe=[];fe.push(xe);let $e=V[Ae],we=oe[Ae];for(;;){if(!we.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(_.SelectionRange.from(we)),!we.parent)break;$e=we.range,we=we.parent}}return fe}}class Me{constructor(x,Y){this._documents=x,this._provider=Y,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.prepareCallHierarchy(ae,V,ee);if(!oe)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(oe)?oe.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,oe)]}async provideCallsTo(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!V)return V.map(oe=>({from:this._cacheAndConvertItem(x,oe.from),fromRanges:oe.fromRanges.map(fe=>_.Range.from(fe))}))}async provideCallsFrom(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!V)return V.map(oe=>({to:this._cacheAndConvertItem(x,oe.to),fromRanges:oe.fromRanges.map(fe=>_.Range.from(fe))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Y){const ee=this._cache.get(x),ae=_.CallHierarchyItem.from(Y,x,ee.size.toString(36));return ee.set(ae._itemId,Y),ae}_itemFromCache(x,Y){return this._cache.get(x)?.get(Y)}}class Ne{constructor(x,Y){this._documents=x,this._provider=Y,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(x,Y,ee){const ae=this._documents.getDocument(x),V=_.Position.to(Y),oe=await this._provider.prepareTypeHierarchy(ae,V,ee);if(!oe)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(oe)?oe.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,oe)]}async provideSupertypes(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!V)return V.map(oe=>this._cacheAndConvertItem(x,oe))}async provideSubtypes(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!V)return V.map(oe=>this._cacheAndConvertItem(x,oe))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Y){const ee=this._cache.get(x),ae=_.TypeHierarchyItem.from(Y,x,ee.size.toString(36));return ee.set(ae._itemId,Y),ae}_itemFromCache(x,Y){return this._cache.get(x)?.get(Y)}}class Qe{constructor(x,Y){this.adapter=x,this.extension=Y}}class ze{constructor(x,Y,ee,ae,V,oe,fe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=x.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=V,this._logService=oe,this._apiDeprecation=fe}_transformDocumentSelector(x){return(0,P.coalesce)((0,P.asArray)(x).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:_.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new A.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return ze._handlePool++}_withAdapter(x,Y,ee,ae,V=!1){const oe=this._adapter.get(x);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Y){let fe;oe.extension&&(fe=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Y.name}'`));const Ae=ee(oe.adapter,oe.extension),xe=oe.extension;return xe&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),$e=>{V&&$e instanceof k.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error($e))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Qe(x,Y)),ee}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Y,ee,ae){const V=this._addNewAdapter(new o(this._documents,ee),x),oe=ae&&ae.label||ze._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(V,this._transformDocumentSelector(Y),oe),this._createDisposable(V)}$provideDocumentSymbols(x,Y,ee){return this._withAdapter(x,o,ae=>ae.provideDocumentSymbols(c.URI.revive(Y),ee),void 0)}registerCodeLensProvider(x,Y,ee){const ae=this._nextHandle(),V=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new p(this._documents,this._commands.converter,ee),x)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),V);let oe=this._createDisposable(ae);if(V!==void 0){const fe=ee.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(V));oe=A.Disposable.from(oe,fe)}return oe}$provideCodeLenses(x,Y,ee){return this._withAdapter(x,p,ae=>ae.provideCodeLenses(c.URI.revive(Y),ee),void 0)}$resolveCodeLens(x,Y,ee){return this._withAdapter(x,p,ae=>ae.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(x,Y){this._withAdapter(x,p,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(x,Y,ee){const ae=this._addNewAdapter(new i(this._documents,ee),x);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(x,Y,ee,ae){return this._withAdapter(x,i,V=>V.provideDefinition(c.URI.revive(Y),ee,ae),[])}registerDeclarationProvider(x,Y,ee){const ae=this._addNewAdapter(new l(this._documents,ee),x);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(x,Y,ee,ae){return this._withAdapter(x,l,V=>V.provideDeclaration(c.URI.revive(Y),ee,ae),[])}registerImplementationProvider(x,Y,ee){const ae=this._addNewAdapter(new r(this._documents,ee),x);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(x,Y,ee,ae){return this._withAdapter(x,r,V=>V.provideImplementation(c.URI.revive(Y),ee,ae),[])}registerTypeDefinitionProvider(x,Y,ee){const ae=this._addNewAdapter(new a(this._documents,ee),x);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(x,Y,ee,ae){return this._withAdapter(x,a,V=>V.provideTypeDefinition(c.URI.revive(Y),ee,ae),[])}registerHoverProvider(x,Y,ee,ae){const V=this._addNewAdapter(new w(this._documents,ee),x);return this._proxy.$registerHoverProvider(V,this._transformDocumentSelector(Y)),this._createDisposable(V)}$provideHover(x,Y,ee,ae){return this._withAdapter(x,w,V=>V.provideHover(c.URI.revive(Y),ee,ae),void 0)}registerEvaluatableExpressionProvider(x,Y,ee,ae){const V=this._addNewAdapter(new f(this._documents,ee),x);return this._proxy.$registerEvaluatableExpressionProvider(V,this._transformDocumentSelector(Y)),this._createDisposable(V)}$provideEvaluatableExpression(x,Y,ee,ae){return this._withAdapter(x,f,V=>V.provideEvaluatableExpression(c.URI.revive(Y),ee,ae),void 0)}registerInlineValuesProvider(x,Y,ee,ae){const V=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new m(this._documents,ee),x);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Y),V);let fe=this._createDisposable(oe);if(V!==void 0){const Ae=ee.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(V));fe=A.Disposable.from(fe,Ae)}return fe}$provideInlineValues(x,Y,ee,ae,V){return this._withAdapter(x,m,oe=>oe.provideInlineValues(c.URI.revive(Y),ee,ae,V),void 0)}registerDocumentHighlightProvider(x,Y,ee){const ae=this._addNewAdapter(new S(this._documents,ee),x);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(x,Y,ee,ae){return this._withAdapter(x,S,V=>V.provideDocumentHighlights(c.URI.revive(Y),ee,ae),void 0)}registerLinkedEditingRangeProvider(x,Y,ee){const ae=this._addNewAdapter(new T(this._documents,ee),x);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(x,Y,ee,ae){return this._withAdapter(x,T,async V=>{const oe=await V.provideLinkedEditingRanges(c.URI.revive(Y),ee,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?ze._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Y,ee){const ae=this._addNewAdapter(new g(this._documents,ee),x);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(x,Y,ee,ae,V){return this._withAdapter(x,g,oe=>oe.provideReferences(c.URI.revive(Y),ee,ae,V),void 0)}registerCodeActionProvider(x,Y,ee,ae){const V=new n.DisposableStore,oe=this._addNewAdapter(new b(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Y),{providedKinds:ae?.providedCodeActionKinds?.map(fe=>fe.value),documentation:ae?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,V)}))},ze._extLabel(x),Boolean(ee.resolveCodeAction)),V.add(this._createDisposable(oe)),V}$provideCodeActions(x,Y,ee,ae,V){return this._withAdapter(x,b,oe=>oe.provideCodeActions(c.URI.revive(Y),ee,ae,V),void 0)}$resolveCodeAction(x,Y,ee){return this._withAdapter(x,b,ae=>ae.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(x,Y){this._withAdapter(x,b,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(x,Y,ee){const ae=this._addNewAdapter(new u(this._documents,ee),x);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(x,Y,ee,ae){return this._withAdapter(x,u,V=>V.provideDocumentFormattingEdits(c.URI.revive(Y),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(x,Y,ee){const ae=this._addNewAdapter(new F(this._documents,ee),x);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(x,Y,ee,ae,V){return this._withAdapter(x,F,oe=>oe.provideDocumentRangeFormattingEdits(c.URI.revive(Y),ee,ae,V),void 0)}registerOnTypeFormattingEditProvider(x,Y,ee,ae){const V=this._addNewAdapter(new O(this._documents,ee),x);return this._proxy.$registerOnTypeFormattingSupport(V,this._transformDocumentSelector(Y),ae,x.identifier),this._createDisposable(V)}$provideOnTypeFormattingEdits(x,Y,ee,ae,V,oe){return this._withAdapter(x,O,fe=>fe.provideOnTypeFormattingEdits(c.URI.revive(Y),ee,ae,V,oe),void 0)}registerWorkspaceSymbolProvider(x,Y){const ee=this._addNewAdapter(new j(Y,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(x,Y,ee){return this._withAdapter(x,j,ae=>ae.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(x,Y,ee){return this._withAdapter(x,j,ae=>ae.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(x,Y){this._withAdapter(x,j,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(x,Y,ee){const ae=this._addNewAdapter(new Q(this._documents,ee,this._logService),x);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),Q.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(x,Y,ee,ae,V){return this._withAdapter(x,Q,oe=>oe.provideRenameEdits(c.URI.revive(Y),ee,ae,V),void 0)}$resolveRenameLocation(x,Y,ee,ae){return this._withAdapter(x,Q,V=>V.resolveRenameLocation(c.URI.revive(Y),ee,ae),void 0)}registerDocumentSemanticTokensProvider(x,Y,ee,ae){const V=this._nextHandle(),oe=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(V,new Qe(new K(this._documents,ee),x)),this._proxy.$registerDocumentSemanticTokensProvider(V,this._transformDocumentSelector(Y),ae,oe);let fe=this._createDisposable(V);if(oe){const Ae=ee.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));fe=A.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens(x,Y,ee,ae){return this._withAdapter(x,K,V=>V.provideDocumentSemanticTokens(c.URI.revive(Y),ee,ae),null,!0)}$releaseDocumentSemanticTokens(x,Y){this._withAdapter(x,K,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(x,Y,ee,ae){const V=this._addNewAdapter(new $(this._documents,ee),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(V,this._transformDocumentSelector(Y),ae),this._createDisposable(V)}$provideDocumentRangeSemanticTokens(x,Y,ee,ae){return this._withAdapter(x,$,V=>V.provideDocumentRangeSemanticTokens(c.URI.revive(Y),ee,ae),null,!0)}registerCompletionItemProvider(x,Y,ee,ae){const V=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(V,this._transformDocumentSelector(Y),ae,U.supportsResolving(ee),`${x.identifier.value}(${ae.join("")})`),this._createDisposable(V)}$provideCompletionItems(x,Y,ee,ae,V){return this._withAdapter(x,U,oe=>oe.provideCompletionItems(c.URI.revive(Y),ee,ae,V),void 0)}$resolveCompletionItem(x,Y,ee){return this._withAdapter(x,U,ae=>ae.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(x,Y){this._withAdapter(x,U,ee=>ee.releaseCompletionItems(Y),void 0)}registerInlineCompletionsProvider(x,Y,ee){const ae=this._addNewAdapter(new H(this._documents,ee,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideInlineCompletions(x,Y,ee,ae,V){return this._withAdapter(x,H,oe=>oe.provideInlineCompletions(c.URI.revive(Y),ee,ae,V),void 0)}$handleInlineCompletionDidShow(x,Y,ee){this._withAdapter(x,H,async ae=>{ae.handleDidShowCompletionItem(Y,ee)},void 0)}$freeInlineCompletionsList(x,Y){this._withAdapter(x,H,async ee=>{ee.disposeCompletions(Y)},void 0)}registerSignatureHelpProvider(x,Y,ee,ae){const V=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new ue(this._documents,ee),x);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Y),V),this._createDisposable(oe)}$provideSignatureHelp(x,Y,ee,ae,V){return this._withAdapter(x,ue,oe=>oe.provideSignatureHelp(c.URI.revive(Y),ee,ae,V),void 0)}$releaseSignatureHelp(x,Y){this._withAdapter(x,ue,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(x,Y,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,V=this._addNewAdapter(new q(this._documents,ee),x);this._proxy.$registerInlayHintsProvider(V,this._transformDocumentSelector(Y),ae);let oe=this._createDisposable(V);if(ae!==void 0){const fe=ee.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ae));oe=A.Disposable.from(oe,fe)}return oe}$provideInlayHints(x,Y,ee,ae){return this._withAdapter(x,q,V=>V.provideInlayHints(c.URI.revive(Y),ee,ae),void 0)}registerDocumentLinkProvider(x,Y,ee){const ae=this._addNewAdapter(new le(this._documents,ee),x);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(x,Y,ee){return this._withAdapter(x,le,ae=>ae.provideLinks(c.URI.revive(Y),ee),void 0)}$resolveDocumentLink(x,Y,ee){return this._withAdapter(x,le,ae=>ae.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(x,Y){this._withAdapter(x,le,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(x,Y,ee){const ae=this._addNewAdapter(new se(this._documents,ee),x);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(x,Y,ee){return this._withAdapter(x,se,ae=>ae.provideColors(c.URI.revive(Y),ee),[])}$provideColorPresentations(x,Y,ee,ae){return this._withAdapter(x,se,V=>V.provideColorPresentations(c.URI.revive(Y),ee,ae),void 0)}registerFoldingRangeProvider(x,Y,ee){const ae=this._nextHandle(),V=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new ve(this._documents,ee),x)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),V);let oe=this._createDisposable(ae);if(V!==void 0){const fe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(V));oe=A.Disposable.from(oe,fe)}return oe}$provideFoldingRanges(x,Y,ee,ae){return this._withAdapter(x,ve,V=>V.provideFoldingRanges(c.URI.revive(Y),ee,ae),void 0)}registerSelectionRangeProvider(x,Y,ee){const ae=this._addNewAdapter(new Fe(this._documents,ee,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(x,Y,ee,ae){return this._withAdapter(x,Fe,V=>V.provideSelectionRanges(c.URI.revive(Y),ee,ae),[])}registerCallHierarchyProvider(x,Y,ee){const ae=this._addNewAdapter(new Me(this._documents,ee),x);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(x,Y,ee,ae){return this._withAdapter(x,Me,V=>Promise.resolve(V.prepareSession(c.URI.revive(Y),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(x,Y,ee,ae){return this._withAdapter(x,Me,V=>V.provideCallsTo(Y,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(x,Y,ee,ae){return this._withAdapter(x,Me,V=>V.provideCallsFrom(Y,ee,ae),void 0)}$releaseCallHierarchy(x,Y){this._withAdapter(x,Me,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}registerTypeHierarchyProvider(x,Y,ee){const ae=this._addNewAdapter(new Ne(this._documents,ee),x);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareTypeHierarchy(x,Y,ee,ae){return this._withAdapter(x,Ne,V=>Promise.resolve(V.prepareSession(c.URI.revive(Y),ee,ae)),void 0)}$provideTypeHierarchySupertypes(x,Y,ee,ae){return this._withAdapter(x,Ne,V=>V.provideSupertypes(Y,ee,ae),void 0)}$provideTypeHierarchySubtypes(x,Y,ee,ae){return this._withAdapter(x,Ne,V=>V.provideSubtypes(Y,ee,ae),void 0)}$releaseTypeHierarchy(x,Y){this._withAdapter(x,Ne,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,I.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:ze._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?ze._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?ze._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:ze._serializeRegExp(x.beforeText),afterText:x.afterText?ze._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?ze._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(ze._serializeOnEnterRule)}setLanguageConfiguration(x,Y,ee){let{wordPattern:ae}=ee;if(ae&&(0,I.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const V=this._nextHandle(),oe={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ze._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ze._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ze._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(V,Y,oe),this._createDisposable(V)}$setWordDefinitions(x){for(const Y of x)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(be[194],Ee([0,1,5,8,7,35,14,6]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(t,y,n){this._documents=y,this._commands=n,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,y){await this._proxy.$changeLanguage(t,y);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,y){const n=t.version,h=M.Position.from(y),s=await this._proxy.$tokensAtPosition(t.uri,h),d={type:_.StandardTokenType.Other,range:t.getWordRangeAtPosition(y)??new _.Range(y.line,y.character,y.line,y.character)};if(!s)return d;const v={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!v.range.contains(y)||n!==t.version?d:v}createLanguageStatusItem(t,y,n){const h=this._handlePool++,s=this._proxy,d=this._ids,v=`${t.identifier.value}/${y}`;if(d.has(v))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);d.add(v);const k={selector:n,id:y,name:t.displayName??t.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let E,o=new I.DisposableStore;const p=()=>{E?.dispose(),E=(0,R.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(h,{id:v,name:k.name??t.displayName??t.name,source:t.displayName??t.name,selector:k.selector,label:k.text,detail:k.detail??"",severity:k.severity===_.LanguageStatusSeverity.Error?A.default.Error:k.severity===_.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:k.command&&this._commands.toInternal(k.command,o),accessibilityInfo:k.accessibilityInformation})},0)},C={dispose(){o.dispose(),E?.dispose(),s.$removeLanguageStatus(h),d.delete(v)},get id(){return k.id},get name(){return k.name},set name(i){k.name=i,p()},get selector(){return k.selector},set selector(i){k.selector=i,p()},get text(){return k.text},set text(i){k.text=i,p()},get detail(){return k.detail},set detail(i){k.detail=i,p()},get severity(){return k.severity},set severity(i){k.severity=i,p()},get accessibilityInformation(){return k.accessibilityInformation},set accessibilityInformation(i){k.accessibilityInformation=i,p()},get command(){return k.command},set command(i){k.command=i,p()}};return p(),C}}e.ExtHostLanguages=D}),define(be[195],Ee([0,1,5,15,30]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(I){return I&&I.title}let R=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(c.MainContext.MainThreadMessageService)}showMessage(D,P,t,y,n){const h={extension:D};let s;typeof y=="string"||A(y)?s=[y,...n]:(h.modal=y?.modal,h.useCustom=y?.useCustom,h.detail=y?.detail,s=n),h.useCustom&&(0,_.checkProposedApiEnabled)(D);const d=[];for(let v=0;v<s.length;v++){const k=s[v];if(typeof k=="string")d.push({title:k,handle:v,isCloseAffordance:!1});else if(typeof k=="object"){let{title:E,isCloseAffordance:o}=k;d.push({title:E,isCloseAffordance:!!o,handle:v})}else this._logService.warn("Invalid message item:",k)}return this._proxy.$showMessage(P,t,h,d).then(v=>{if(typeof v=="number")return s[v]})}};R=Ue([He(1,M.ILogService)],R),e.ExtHostMessageService=R}),define(be[196],Ee([0,1,23,3,58,6,20,9,10,2,63,5,8,7,47,171,93]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{constructor(o,p,C,i,l){this._textDocumentsAndEditors=C,this._textDocuments=i,this._extensionStoragePaths=l,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const a=r.notebookEditor?.notebookUri,w=r.cell.handle,m=this._documents.get(a)?.getCell(w);if(m)return m.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const p=this._editors.get(o);if(!p)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(o){for(const[p,C]of this._editors)if(C.apiEditor===o)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,p){const C=this._documents.get(o);if(!C&&!p)throw new Error(`NO notebook document for '${o}'`);return C}_getProviderData(o){const p=this._notebookContentProviders.get(o);if(!p)throw new Error(`NO provider for '${o}'`);return p}registerNotebookContentProvider(o,p,C,i,l){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:o,provider:C});let r;return C.onDidChangeNotebookContentOptions&&(r=C.onDidChangeNotebookContentOptions(()=>{const a=n.NotebookDocumentContentOptions.from(C.options);this._notebookProxy.$updateNotebookProviderOptions(p,a)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},p,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(o,l)),new h.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(o,p){if(!p)return;const C=p.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(p.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:p.displayName,filenamePattern:C,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,p,C){const i=k._notebookStatusBarItemProviderHandlePool++,l=typeof C.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,l,p);let r;return l!==void 0&&(r=C.onDidChangeCellStatusBarItems(a=>this._notebookProxy.$emitCellStatusBarEvent(l))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,l),r&&r.dispose()})}async createNotebookDocument(o){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return P.URI.revive(p)}async openNotebookDocument(o){const p=this._documents.get(o);if(p)return p.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(o),i=this._documents.get(P.URI.revive(C));return(0,D.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(o,p){P.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let C;typeof p=="object"?C={position:n.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(n.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:C={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,C),l=i&&this._editors.get(i)?.apiEditor;if(l)return l;throw i?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,p,C,i){const l=this._notebookStatusBarItemProviders.get(o),r=P.URI.revive(p),a=this._documents.get(r);if(!a||!l)return;const w=a.getCellFromIndex(C);if(!w)return;const f=await l.provideCellStatusBarItems(w.apiCell,i);if(!f)return;const m=new A.DisposableStore,S=this._statusBarCache.add([m]),g=(Array.isArray(f)?f:[f]).map(b=>n.NotebookStatusBarItem.from(b,this._commandsConverter,m));return{cacheId:S,items:g}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,p,C,i,l){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,C),this._notebookProxy.$registerNotebookSerializer(r,{id:o.identifier,location:o.extensionLocation},p,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(o,l)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(o,p,C){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const l=await i.deserializeNotebook(p.buffer,C);return new s.SerializableObjectWithBuffers(n.NotebookData.from(l))}async $notebookToData(o,p,C){const i=this._notebookSerializer.get(o);if(!i)throw new Error("NO serializer found");const l=await i.serializeNotebook(n.NotebookData.to(p.value),C);return c.VSBuffer.wrap(l)}async $openNotebook(o,p,C,i,l){const{provider:r}=this._getProviderData(o),a=await r.openNotebook(P.URI.revive(p),{backupId:C,untitledDocumentData:i?.buffer},l);return new s.SerializableObjectWithBuffers({metadata:a.metadata??Object.create(null),cells:a.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,p,C){const i=this.getNotebookDocument(P.URI.revive(p)),{provider:l}=this._getProviderData(o);return await l.saveNotebook(i.apiNotebook,C),!0}async $saveNotebookAs(o,p,C,i){const l=this.getNotebookDocument(P.URI.revive(p)),{provider:r}=this._getProviderData(o);return await r.saveNotebookAs(P.URI.revive(C),l.apiNotebook,i),!0}async $backupNotebook(o,p,C){const i=this.getNotebookDocument(P.URI.revive(p)),l=this._getProviderData(o),r=this._extensionStoragePaths.workspaceValue(l.extension)??this._extensionStoragePaths.globalValue(l.extension),a=String((0,_.hash)([i.uri.toString(),this._backupIdPool++])),w=P.URI.joinPath(r,a),f=await l.provider.backupNotebook(i.apiNotebook,{destination:w},C);return i.updateBackup(f),f.id}_createExtHostEditor(o,p,C){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const i=new v.ExtHostNotebookEditor(p,this._notebookEditorsProxy,o,C.visibleRanges.map(n.NotebookRange.to),C.selections.map(n.NotebookRange.to),typeof C.viewColumn=="number"?n.ViewColumn.to(C.viewColumn):void 0);this._editors.set(p,i)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const C of o.value.removedDocuments){const i=P.URI.revive(C),l=this._documents.get(i);l&&(l.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(l.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(o.value.addedDocuments){const C=[];for(const i of o.value.addedDocuments){const l=P.URI.revive(i.uri);if(this._documents.has(l))throw new Error(`adding EXISTING notebook ${l} `);const r=this,a=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(w){r._onDidChangeNotebookCells.fire(w)},emitCellOutputsChange(w){r._onDidChangeCellOutputs.fire(w)},emitCellMetadataChange(w){r._onDidChangeCellMetadata.fire(w)},emitCellExecutionStateChange(w){r._onDidChangeCellExecutionState.fire(w)}},l,i);C.push(...i.cells.map(w=>d.ExtHostCell.asModelAddData(a.apiNotebook,w))),this._documents.get(l)?.dispose(),this._documents.set(l,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(o.value.addedEditors)for(const C of o.value.addedEditors){if(this._editors.has(C.id))return;const i=P.URI.revive(C.documentUri),l=this._documents.get(i);l&&this._createExtHostEditor(l,C.id,C)}const p=[];if(o.value.removedEditors)for(const C of o.value.removedEditors){const i=this._editors.get(C);i&&(this._editors.delete(C),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),p.push(i))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const C=new Set;this._visibleNotebookEditors.forEach(i=>C.add(i.id));for(const i of this._editors.values()){const l=C.has(i.id);i._acceptVisibility(l)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(be[197],Ee([0,1,3,53,15,5,12,8]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(y,n){const h=D._Keys.nextId();y.$registerNotebookEditorDecorationType(h,I.NotebookDecorationRenderOptions.from(n)),this.value={key:h,dispose(){y.$removeNotebookEditorDecorationType(h)}}}}D._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(y,n,h){this._logService=y,this._extHostRpc=n,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new D(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,n);const h=this._notebooksAndEditors.getEditorById(y);n.visibleRanges&&h._acceptVisibleRanges(n.visibleRanges.ranges.map(I.NotebookRange.to)),n.selections&&h._acceptSelections(n.selections.selections.map(I.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const n in y)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(I.ViewColumn.to(y[n]))}};P=Ue([He(0,_.ILogService),He(1,R.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(be[198],Ee([0,1,13,14,21,3,6,20,2,25,15,5,8,7,66,164,30,47]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(l,r,a,w){this._initData=r,this._extHostNotebook=a,this._logService=w,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=l.getProxy(y.MainContext.MainThreadNotebookKernels)}createNotebookController(l,r,a,w,f,m){for(let G of this._kernelData.values())if(G.controller.id===r&&P.ExtensionIdentifier.equals(l.identifier,G.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const S=this._handlePool++,T=this;this._logService.trace(`NotebookController[${S}], CREATED by ${l.identifier.value}, ${r}`);const g=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${l.identifier}'`);let b=!1;const u=new R.DisposableStore,F=new A.Emitter,O=new A.Emitter,j={id:`${l.identifier.value}/${r}`,notebookType:a,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:w||l.identifier.value,preloads:m?m.map(n.NotebookRendererScript.from):[]};let Q=f??g,W;this._proxy.$addKernel(S,j).catch(G=>{console.log(G),b=!0});let K=0;const $=()=>{if(b)return;const G=++K;Promise.resolve().then(()=>{G===K&&this._proxy.$updateKernel(S,j)})},U=new I.ResourceMap,H={get id(){return r},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return j.label},set label(G){j.label=G??l.displayName??l.name,$()},get detail(){return j.detail??""},set detail(G){j.detail=G,$()},get description(){return j.description??""},set description(G){j.description=G,$()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(G){j.supportedLanguages=G,$()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(G){j.supportsExecutionOrder=G,$()},get rendererScripts(){return j.preloads?j.preloads.map(n.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(G){Q=G??g},get interruptHandler(){return W},set interruptHandler(G){W=G,j.supportsInterrupt=Boolean(G),$()},createNotebookCellExecution(G){if(b)throw new Error("notebook controller is DISPOSED");if(!U.has(G.notebook.uri))throw T._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(U.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${G.notebook.uri.toString()}`);return T._createNotebookCellExecution(G)},dispose:()=>{b||(this._logService.trace(`NotebookController[${S}], DISPOSED`),b=!0,this._kernelData.delete(S),u.dispose(),F.dispose(),O.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(G,ue){T._proxy.$updateNotebookPriority(S,G.uri,ue)},onDidReceiveMessage:O.event,postMessage(G,ue){return(0,v.checkProposedApiEnabled)(l),T._proxy.$postMessage(S,ue&&T._extHostNotebook.getIdByEditor(ue),G)},asWebviewUri(G){return(0,v.checkProposedApiEnabled)(l),(0,s.asWebviewUri)(G,T._initData.remote)}};return this._kernelData.set(S,{extensionId:l.identifier,controller:H,onDidReceiveMessage:O,onDidChangeSelection:F,associatedNotebooks:U}),H}$acceptNotebookAssociation(l,r,a){const w=this._kernelData.get(l);if(w){const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));a?w.associatedNotebooks.set(f.uri,!0):w.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,f.uri.toString(),a),w.onDidChangeSelection.fire({selected:a,notebook:f.apiNotebook})}}async $executeCells(l,r,a){const w=this._kernelData.get(l);if(!w)return;const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(r)),m=[];for(let S of a){const T=f.getCell(S);T&&m.push(T.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,f.uri.toString(),m.length),await w.controller.executeHandler.call(w.controller,m,f.apiNotebook,w.controller)}catch(S){this._logService.error(`NotebookController[${l}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(l,r,a){const w=this._kernelData.get(l);if(!w)return;const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(r));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,f.apiNotebook);else for(let m of a){const S=f.getCell(m);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,r,a){const w=this._kernelData.get(l);if(!w)return;const f=this._extHostNotebook.getEditorById(r);w.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:a}))}_createNotebookCellExecution(l){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const w=new p(a.notebook,a,this._proxy);this._activeExecutions.set(a.uri,w);const f=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),f.dispose(),this._activeExecutions.delete(a.uri))});return w.asApiObject()}};E=Ue([He(3,t.ILogService)],E),e.ExtHostNotebookKernels=E;var o;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(o||(o={}));class p extends R.Disposable{constructor(l,r,a){super();this._document=l,this._cell=r,this._proxy=a,this._handle=p.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new C(10,w=>this.update(w)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(l){await this._collector.addItem(l)}async update(l){const r=Array.isArray(l)?l:[l];return this._proxy.$updateExecutions(new k.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(l){let r=this._cell;if(l&&(r=this._document.getCellFromApiCell(l)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(l){return l.map(r=>{const a=h.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return a===r.items?n.NotebookCellOutput.from(r):n.NotebookCellOutput.from({items:a,id:r.id,metadata:r.metadata})})}async updateOutputs(l,r,a){const w=this.cellIndexToHandle(r),f=this.validateAndConvertOutputs((0,c.asArray)(l));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:w,append:a,outputs:f})}async updateOutputItems(l,r,a){return l=h.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(l),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:l.map(n.NotebookCellOutputItem.from),outputId:r.id,append:a})}asApiObject(){const l=this;return Object.freeze({get token(){return l._tokenSource.token},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(a){l._executionOrder=a,l.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionHandle:l._handle,executionOrder:l._executionOrder}])},start(a){if(l._state===o.Resolved||l._state===o.Started)throw new Error("Cannot call start again");l._state=o.Started,l._onDidChangeState.fire(),l.update({editType:d.CellExecutionUpdateType.ExecutionState,executionHandle:l._handle,runStartTime:a})},end(a,w){if(l._state===o.Resolved)throw new Error("Cannot call resolve twice");l._state=o.Resolved,l._onDidChangeState.fire(),l.updateSoon({editType:d.CellExecutionUpdateType.Complete,executionHandle:l._handle,runEndTime:w,lastRunSuccess:a}),l._collector.flush(),l._proxy.$removeExecution(l._handle)},clearOutput(a){return l.verifyStateForOutput(),l.updateOutputs([],a,!1)},appendOutput(a,w){return l.verifyStateForOutput(),l.updateOutputs(a,w,!0)},replaceOutput(a,w){return l.verifyStateForOutput(),l.updateOutputs(a,w,!1)},appendOutputItems(a,w){return l.verifyStateForOutput(),l.updateOutputItems(a,w,!0)},replaceOutputItems(a,w){return l.verifyStateForOutput(),l.updateOutputItems(a,w,!1)}})}}p.HANDLE=0;class C{constructor(l,r){this.delay=l,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(l){return this.batch.push(l),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const l=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>l.complete())}}}),define(be[199],Ee([0,1,3,5,93]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(I,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,D,P){const t=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(D)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(I,D){if(!I.contributes?.notebookRenderer?.some(n=>n.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const P=!!I.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,h,s)=>{const d=P?n:v=>{const k={};t.set(k,v.editor),n({editor:k,message:v.message})};return this.getOrCreateEmitterFor(D).event(d,h,s)},postMessage:(n,h)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,h]=[h,n]);const s=P?h:t.get(h),d=s&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(d?.id,D,n)}}}getOrCreateEmitterFor(I){let D=this._rendererMessageEmitters.get(I);return D||(D=new c.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,D),D)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,23,4,12]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends _.Disposable{constructor(s,d,v,k,E){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=E,this._id=E.$register(this.name,d,v,k),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?A.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(d=>this._proxy.$clear(d,s))}show(s,d){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof s=="boolean"?s:d)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(s,d,v){super(s,!1,void 0,d,v)}append(s){super.append(s),this._id.then(d=>this._proxy.$append(d,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends D{constructor(s,d,v){super(s,!0,d,void 0,v)}append(s){throw new Error("Not supported")}}class y{constructor(s,d){this.name=s,this._channel=d}append(s){this._channel.then(d=>d.append(s))}appendLine(s){this._channel.then(d=>d.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,d){this._channel.then(v=>v.show(s,d))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=y;let n=class{constructor(s){this._proxy=s.getProxy(c.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s,d){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new P(s,d.identifier.value,this._proxy)}createOutputChannelFromLogFile(s,d){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new t(s,d,this._proxy)}};n=Ue([He(0,I.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(be[200],Ee([0,1,14,21,3,6,5,2,7,16,13,35,44]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(s,d,v){const k=s.getProxy(R.MainContext.MainThreadQuickOpen);class E{constructor(f,m){this._sessions=new Map,this._instances=0,this._workspace=f,this._commands=m}showQuickPick(f,m,S,T=M.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(f),b=++this._instances,u=k.$show(b,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},T),F={},O=u.then(()=>F);return Promise.race([O,g]).then(j=>{if(j!==F)return g.then(Q=>{const W=[];for(let K=0;K<Q.length;K++){const $=Q[K];let U,H,G,ue,q;typeof $=="string"?U=$:(U=$.label,H=$.description,G=$.detail,ue=$.picked,q=$.alwaysShow),W.push({label:U,description:H,handle:K,detail:G,picked:ue,alwaysShow:q})}return S&&typeof S.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{S.onDidSelectItem(Q[K])}),k.$setItems(b,W),u.then(K=>{if(typeof K=="number")return Q[K];if(Array.isArray(K))return K.map($=>Q[$])})})}).then(void 0,j=>{if(!(0,P.isPromiseCanceledError)(j))return k.$setError(b,j),Promise.reject(j)})}$onItemSelected(f){this._onDidSelectItem&&this._onDidSelectItem(f)}showInput(f,m=M.CancellationToken.None){return this._validateInput=f?f.validateInput:void 0,k.$input(f,typeof this._validateInput=="function",m).then(void 0,S=>{if(!(0,P.isPromiseCanceledError)(S))return Promise.reject(S)})}$validateInput(f){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(f)):Promise.resolve(void 0)}async showWorkspaceFolderPick(f,m=M.CancellationToken.None){const S=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!S)return;const T=await this._workspace.getWorkspaceFolders2();if(!!T)return T.find(g=>g.uri.toString()===S.uri.toString())}createQuickPick(f,m){const S=new r(f,m,()=>this._sessions.delete(S._id));return this._sessions.set(S._id,S),S}createInputBox(f){const m=new a(f,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(f,m){const S=this._sessions.get(f);S&&S._fireDidChangeValue(m)}$onDidAccept(f){const m=this._sessions.get(f);m&&m._fireDidAccept()}$onDidChangeActive(f,m){const S=this._sessions.get(f);S instanceof r&&S._fireDidChangeActive(m)}$onDidChangeSelection(f,m){const S=this._sessions.get(f);S instanceof r&&S._fireDidChangeSelection(m)}$onDidTriggerButton(f,m){const S=this._sessions.get(f);S&&S._fireDidTriggerButton(m)}$onDidTriggerItemButton(f,m,S){const T=this._sessions.get(f);T instanceof r&&T._fireDidTriggerItemButton(m,S)}$onDidHide(f){const m=this._sessions.get(f);m&&m._fireDidHide()}}class o{constructor(f,m){this._extensionId=f,this._onDidDispose=m,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(f){this._title=f,this.update({title:f})}get step(){return this._steps}set step(f){this._steps=f,this.update({step:f})}get totalSteps(){return this._totalSteps}set totalSteps(f){this._totalSteps=f,this.update({totalSteps:f})}get enabled(){return this._enabled}set enabled(f){this._enabled=f,this.update({enabled:f})}get busy(){return this._busy}set busy(f){this._busy=f,this.update({busy:f})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(f){this._ignoreFocusOut=f,this.update({ignoreFocusOut:f})}get value(){return this._value}set value(f){this._value=f,this.update({value:f})}get placeholder(){return this._placeholder}set placeholder(f){this._placeholder=f,this.update({placeholder:f})}get buttons(){return this._buttons}set buttons(f){this._buttons=f.slice(),this._handlesToButtons.clear(),f.forEach((m,S)=>{const T=m===D.QuickInputButtons.Back?-1:S;this._handlesToButtons.set(T,m)}),this.update({buttons:f.map((m,S)=>({...l(m),tooltip:m.tooltip,handle:m===D.QuickInputButtons.Back?-1:S}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(f){this._value=f,this._onDidChangeValueEmitter.fire(f)}_fireDidTriggerButton(f){const m=this._handlesToButtons.get(f);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),k.$dispose(this._id))}update(f){if(!this._disposed){for(const m of Object.keys(f)){const S=f[m];this._pendingUpdate[m]=S===void 0?null:S}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){k.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function p(w){if(w instanceof D.ThemeIcon)return{id:w.id};const f=i(w),m=C(w);return{dark:typeof f=="string"?I.URI.file(f):f,light:typeof m=="string"?I.URI.file(m):m}}function C(w){return typeof w=="object"&&"light"in w?w.light:w}function i(w){return typeof w=="object"&&"dark"in w?w.dark:w}function l(w){const f=p(w.iconPath);let m,S;return"id"in f?S=n.ThemeIcon.asClassName(f):m=f,{iconPath:m,iconClass:S}}class r extends o{constructor(f,m,S){super(f,S);this.enableProposedApi=m,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(f){this._items=f.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),f.forEach((m,S)=>{this._handlesToItems.set(S,m),this._itemsToHandles.set(m,S)}),this.update({items:f.map((m,S)=>({label:m.label,description:m.description,handle:S,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons&&this.enableProposedApi?m.buttons.map((T,g)=>({...l(T),tooltip:T.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(f){this._canSelectMany=f,this.update({canSelectMany:f})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(f){this._matchOnDescription=f,this.update({matchOnDescription:f})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(f){this._matchOnDetail=f,this.update({matchOnDetail:f})}get sortByLabel(){return this._sortByLabel}set sortByLabel(f){this._sortByLabel=f,this.update({sortByLabel:f})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(f){this._keepScrollPosition=f,this.update({keepScrollPosition:f})}get activeItems(){return this._activeItems}set activeItems(f){this._activeItems=f.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(f){this._selectedItems=f.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(f){const m=(0,t.coalesce)(f.map(S=>this._handlesToItems.get(S)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(f){const m=(0,t.coalesce)(f.map(S=>this._handlesToItems.get(S)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(f,m){const S=this._handlesToItems.get(f);if(!S||!S.buttons||!S.buttons.length)return;const T=S.buttons[m];T&&this._onDidTriggerItemButtonEmitter.fire({button:T,item:S})}}class a extends o{constructor(f,m){super(f,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(f){this._password=f,this.update({password:f})}get prompt(){return this._prompt}set prompt(f){this._prompt=f,this.update({prompt:f})}get validationMessage(){return this._validationMessage}set validationMessage(f){this._validationMessage=f,this.update({validationMessage:f,severity:f?y.default.Error:y.default.Ignore})}}return new E(d,v)}e.createExtHostQuickOpen=h}),define(be[201],Ee([0,1,2,3,52,6,14,5,13,107,15,25,30,44,8]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(f){if(f)return typeof f.iconPath=="string"?c.URI.file(f.iconPath):c.URI.isUri(f.iconPath)||h.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function v(f,m){if(!f.iconPath&&!m.iconPath)return 0;if(f.iconPath){if(!m.iconPath)return 1}else return-1;const S=typeof f.iconPath=="string"?f.iconPath:c.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,T=typeof m.iconPath=="string"?m.iconPath:c.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,P.comparePaths)(S,T)}function k(f,m){let S=0;if(f.strikeThrough!==m.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==m.faded)return f.faded?1:-1;if(f.tooltip!==m.tooltip)return(f.tooltip||"").localeCompare(m.tooltip||"");if(S=v(f,m),S!==0)return S;if(f.light&&m.light)S=v(f.light,m.light);else{if(f.light)return 1;if(m.light)return-1}if(S!==0)return S;if(f.dark&&m.dark)S=v(f.dark,m.dark);else{if(f.dark)return 1;if(m.dark)return-1}return S}function E(f,m){if(f.command!==m.command)return f.command<m.command?-1:1;if(f.title!==m.title)return f.title<m.title?-1:1;if(f.tooltip!==m.tooltip){if(f.tooltip!==void 0&&m.tooltip!==void 0)return f.tooltip<m.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(f.arguments===m.arguments)return 0;if(f.arguments)if(m.arguments){if(f.arguments.length!==m.arguments.length)return f.arguments.length-m.arguments.length}else return 1;else return-1;for(let S=0;S<f.arguments.length;S++){const T=f.arguments[S],g=m.arguments[S];if(T!==g)return T<g?-1:1}return 0}function o(f,m){let S=(0,P.comparePaths)(f.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(S!==0)return S;if(f.command&&m.command)S=E(f.command,m.command);else{if(f.command)return 1;if(m.command)return-1}if(S!==0)return S;if(f.decorations&&m.decorations)S=k(f.decorations,m.decorations);else{if(f.decorations)return 1;if(m.decorations)return-1}return S}function p(f,m){for(let S=0;S<f.length;S++)if(f[S]!==m[S])return!1;return!0}function C(f,m){return f.command===m.command&&f.title===m.title&&f.tooltip===m.tooltip&&(f.arguments&&m.arguments?p(f.arguments,m.arguments):f.arguments===m.arguments)}function i(f,m){return(0,D.equals)(f,m,C)}class l{constructor(m,S,T){this._extension=m,this._proxy=S,this._sourceControlHandle=T,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,n.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,S){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,S)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=l;class r{constructor(m,S,T,g,b){this._proxy=m,this._commands=S,this._sourceControlHandle=T,this._id=g,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,S){const T=this._resourceStatesCommandsMap.get(m);return T?(0,R.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(o),T=(0,D.sortedDiff)(this._resourceSnapshot,m,o).map(u=>{const F=u.toInsert.map(O=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,O);const Q=O.resourceUri;let W;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const ve=new A.DisposableStore;W=this._commands.converter.toInternal(O.command,ve),this._resourceStatesDisposablesMap.set(j,ve)}else this._resourceStatesCommandsMap.set(j,O.command);const K=d(O.decorations),$=O.decorations&&d(O.decorations.light)||K,U=O.decorations&&d(O.decorations.dark)||K,H=[$,U],G=O.decorations&&O.decorations.tooltip||"",ue=O.decorations&&!!O.decorations.strikeThrough,q=O.decorations&&!!O.decorations.faded,le=O.contextValue||"";return{rawResource:[j,Q,H,G,ue,q,le,W],handle:j}});return{start:u.start,deleteCount:u.deleteCount,toInsert:F}}),g=T.map(({start:u,deleteCount:F,toInsert:O})=>[u,F,O.map(j=>j.rawResource)]),b=T.reverse();for(const{start:u,deleteCount:F,toInsert:O}of b){const j=O.map(W=>W.handle),Q=this._handlesSnapshot.splice(u,F,...j);for(const W of Q)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=m,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class a{constructor(m,S,T,g,b,u){this._proxy=S,this._commands=T,this._id=g,this._label=b,this._rootUri=u,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=a._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new l(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,b,u)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=m;const S=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:S})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&i(this._statusBarCommands,m))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=m;const S=(m||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(m,S){const T=new r(this._proxy,this._commands,this.handle,m,S),g=M.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,g),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const m=[],S=[];for(const[T,g]of this.createdResourceGroups){g.dispose();const b=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});M.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),b.dispose(),this._groups.delete(T.handle),this._proxy.$unregisterGroup(this.handle,T.handle)}),m.push([T.handle,T.id,T.label,T.features]);const u=T._takeResourceStateSnapshot();u.length>0&&S.push([T.handle,u]),this._groups.set(T.handle,T)}this._proxy.$registerGroups(this.handle,m,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(S=>{const T=S._takeResourceStateSnapshot();T.length!==0&&m.push([S.handle,T])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}a._handlePool=0,Ue([(0,_.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),Ue([(0,_.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let w=class Bi{constructor(m,S,T){this._commands=S,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=m.getProxy(I.MainContext.MainThreadSCM),this._telemetry=m.getProxy(I.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const b=this._sourceControls.get(g.sourceControlHandle);if(!b)return g;const u=b.getResourceGroup(g.groupHandle);return u?u.getResourceState(g.handle):g}else if(g&&g.$mid===4){const b=this._sourceControls.get(g.sourceControlHandle);return b?b.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const b=this._sourceControls.get(g.handle);return b||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,S,T,g){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,S,T,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const b=Bi._handlePool++,u=new a(m,this._proxy,this._commands,S,T,g);this._sourceControls.set(b,u);const F=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(m.identifier))||[];return F.push(u),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(m.identifier),F),u}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const S=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(m.identifier)),T=S&&S[S.length-1];return T&&T.inputBox}$provideOriginalResource(m,S,T){const g=c.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,g.toString());const b=this._sourceControls.get(m);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>b.quickDiffProvider.provideOriginalResource(g,T)).then(u=>u||null)}$onInputBoxValueChange(m,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const T=this._sourceControls.get(m);return T&&T.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(m,S,T,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,S,T);const b=this._sourceControls.get(m);if(!b)return Promise.resolve(void 0);const u=b.getResourceGroup(S);return u?u.$executeResourceCommand(T,g):Promise.resolve(void 0)}$validateInput(m,S,T){this.logService.trace("ExtHostSCM#$validateInput",m);const g=this._sourceControls.get(m);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>g.inputBox.validateInput(S,T)).then(b=>{if(!b)return Promise.resolve(void 0);const u=s.MarkdownString.fromStrict(b.message);return u?Promise.resolve([u,b.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};w._handlePool=0,w=Ue([He(2,t.ILogService)],w),e.ExtHostSCM=w});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[202],Ee([0,1,7,5,126,6,8]),function(ie,e,c,M,_,A,R){"use strict";var I,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(h,s,d,v,k=c.StatusBarAlignment.Left,E){I.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Je(this,I,h,"f"),Je(this,D,s,"f"),this._entryId=P.ID_GEN++,this._extension=d,this._id=v,this._alignment=k,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!P.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Te(this,D,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Te(this,D,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let s;this._name?s=this._name:s=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const v=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,I,"f").$setEntry(this._entryId,h,s,this._text,v,this._command?.internal,d,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,I=new WeakMap,D=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const s={message:h};return this._messages.unshift(s),this._update(),new c.Disposable(()=>{const d=this._messages.indexOf(s);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class y{constructor(h,s){this._proxy=h.getProxy(M.MainContext.MainThreadStatusBar),this._commands=s,this._statusMessage=new t(this)}createStatusBarEntry(h,s,d,v){return new P(this._proxy,this._commands,h,s,d,v)}setStatusBarMessage(h,s){const d=this._statusMessage.setMessage(h);let v;return typeof s=="number"?v=setTimeout(()=>d.dispose(),s):typeof s!="undefined"&&s.then(()=>d.dispose(),()=>d.dispose()),new c.Disposable(()=>{d.dispose(),clearTimeout(v)})}}e.ExtHostStatusBar=y}),define(be[72],Ee([0,1,5,3,4]),function(ie,e,c,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(I){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}getValue(I,D,P){return this._proxy.$getValue(I,D).then(t=>t||P)}setValue(I,D,P){return this._proxy.$setValue(I,D,P)}$acceptValue(I,D,P){this._onDidChangeStorage.fire({shared:I,key:D,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(be[73],Ee([0,1,4,29,15,71,2]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let I=class{constructor(P,t,y){this._logService=t,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return R.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return R.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return R.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=Ue([He(0,M.IExtHostInitDataService),He(1,_.ILogService),He(2,A.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(be[38],Ee([0,1,3,5,4,2,12,6,7,127,16,166,21,36,148,149,44,10]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class E{constructor(f,m,S,T){this._proxy=f,this._id=m,this._creationOptions=S,this._name=T,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const g=this;this.value={get name(){return g._name||""},get processId(){return g._pidPromise},get creationOptions(){return g._creationOptions},get exitStatus(){return g._exitStatus},get state(){return g._state},sendText(b,u=!0){g._checkDisposed(),g._proxy.$sendText(g._id,b,u)},show(b){g._checkDisposed(),g._proxy.$show(g._id,b)},hide(){g._checkDisposed(),g._proxy.$hide(g._id)},dispose(){g._disposed||(g._disposed=!0,g._proxy.$dispose(g._id))},get dimensions(){if(!(g._cols===void 0||g._rows===void 0))return{columns:g._cols,rows:g._rows}}}}async create(f,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,k.withNullAsUndefined)(f.shellPath),shellArgs:(0,k.withNullAsUndefined)(f.shellArgs),cwd:(0,k.withNullAsUndefined)(f.cwd),env:(0,k.withNullAsUndefined)(f.env),icon:(0,k.withNullAsUndefined)(r(f.iconPath)),color:v.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,k.withNullAsUndefined)(f.message),strictEnv:(0,k.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,k.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,k.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,k.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this._serializeParentTerminal(f.location,m?.resolvedExtHostIdentifier,m?.location)})}async createExtensionTerminal(f,m,S,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:S,color:v.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(f,m)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,m,S){return typeof f=="object"&&"parentTerminal"in f?m?{parentTerminal:m}:void 0:(S&&(f=S),f)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,m){return f===this._cols&&m===this._rows||f===0||m===0?!1:(this._cols=f,this._rows=m,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=E;class o{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new c.Emitter,this._onProcessTitleChanged=new c.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new c.Emitter,this._onProcessShellTypeChanged=new c.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput&&this._pty.handleInput(f)}resize(f,m){this._pty.setDimensions&&this._pty.setDimensions({columns:f,rows:m})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose&&this._pty.onDidClose((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(m=>this._onProcessOverrideDimensions.fire(m&&{cols:m.columns,rows:m.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(m=>this._onProcessTitleChanged.fire(m)),this._pty.open(f||void 0),this._pty.setDimensions&&f&&this._pty.setDimensions(f),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=o;let p=1,C=class extends I.Disposable{constructor(f,m){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=m.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[S,T]of this._terminalProcesses)T.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,m){const S=new E(this._proxy,(0,h.generateUuid)(),f,f.name),T=new o(f.pty);return S.createExtensionTerminal(this._resolveLocation(f.location),m?.resolvedExtHostIdentifier,r(f.iconPath),a(f.color)).then(g=>{const b=this._setupExtHostProcessListeners(g,T);this._terminalProcessDisposables[g]=b}),this._terminals.push(S),S.value}_resolveLocation(f){return typeof f=="object"&&"viewColumn"in f&&f.viewColumn!==void 0?{viewColumn:f.viewColumn,preserveFocus:f.preserveFocus}:typeof f=="object"&&"parentTerminal"in f?void 0:(f===s.TerminalLocation.Editor||f===s.TerminalLocation.Panel,f)}attachPtyToTerminal(f,m){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const T=new o(m),g=this._setupExtHostProcessListeners(f,T);this._terminalProcessDisposables[f]=g}async $acceptActiveTerminalChanged(f){const m=this._activeTerminal;if(f===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const S=this._getTerminalById(f);S&&(this._activeTerminal=S,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,m){const S=this._getTerminalById(f);S&&this._onDidWriteTerminalData.fire({terminal:S.value,data:m})}async $acceptTerminalDimensions(f,m,S){const T=this._getTerminalById(f);T&&T.setDimensions(m,S)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(f,m,S){this._terminalProcesses.get(f)?.resize(m,S)}async $acceptTerminalTitleChange(f,m){const S=this._getTerminalById(f);S&&(S.name=m)}async $acceptTerminalClosed(f,m){const S=this._getTerminalObjectIndexById(this._terminals,f);if(S!==null){const T=this._terminals.splice(S,1)[0];T.setExitCode(m),this._onDidCloseTerminal.fire(T.value)}}$acceptTerminalOpened(f,m,S,T){if(m){const u=this._getTerminalObjectIndexById(this._terminals,m);if(u!==null){this._terminals[u]._id=f,this._onDidOpenTerminal.fire(this.terminals[u]),this._terminals[u].isOpen=!0;return}}const g={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:A.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},b=new E(this._proxy,f,g,S);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(f,m){const S=this._getTerminalById(f);S&&S._setProcessId(m)}async $startExtensionTerminal(f,m){const S=this._getTerminalById(f);if(!S)return{message:(0,P.localize)(0,null,f)};S.isOpen||await new Promise(g=>{const b=this.onDidOpenTerminal(async u=>{u===S.value&&(b.dispose(),g())})});const T=this._terminalProcesses.get(f);T?T.startSendingEvents(m):this._extensionTerminalAwaitingStart[f]={initialDimensions:m}}_setupExtHostProcessListeners(f,m){const S=new I.DisposableStore;S.add(m.onProcessReady(g=>this._proxy.$sendProcessReady(f,g.pid,g.cwd))),S.add(m.onProcessTitleChanged(g=>this._proxy.$sendProcessTitle(f,g))),this._bufferer.startBuffering(f,m.onProcessData),S.add(m.onProcessExit(g=>this._onProcessExit(f,g))),m.onProcessOverrideDimensions&&S.add(m.onProcessOverrideDimensions(g=>this._proxy.$sendOverrideDimensions(f,g))),this._terminalProcesses.set(f,m);const T=this._extensionTerminalAwaitingStart[f];return T&&m instanceof o&&(m.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),S}$acceptProcessAckDataEvent(f,m){this._terminalProcesses.get(f)?.acknowledgeDataEvent(m)}$acceptProcessInput(f,m){this._terminalProcesses.get(f)?.input(m)}$acceptTerminalInteraction(f){const m=this._getTerminalById(f);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire(m.value)}$acceptProcessResize(f,m,S){try{this._terminalProcesses.get(f)?.resize(m,S)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(f,m){this._terminalProcesses.get(f)?.shutdown(m)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(m=>this._proxy.$sendProcessInitialCwd(f,m))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(m=>this._proxy.$sendProcessCwd(f,m))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,m,S){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,S),this._proxy.$registerProfileProvider(m,f.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}async $createContributedProfileTerminal(f,m){const S=new n.CancellationTokenSource().token,T=await this._profileProviders.get(f)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,m);return}this.createTerminalFromOptions(T.options,m)}}async $provideLinks(f,m){const S=this._getTerminalById(f);if(!S)return[];this._terminalLinkCache.delete(f);const T=this._terminalLinkCancellationSource.get(f);T&&T.dispose(!0);const g=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,g);const b=[],u={terminal:S.value,line:m},F=[];for(const Q of this._linkProviders)F.push(new Promise(async W=>{g.token.onCancellationRequested(()=>W({provider:Q,links:[]}));const K=await Q.provideTerminalLinks(u,g.token)||[];g.token.isCancellationRequested||W({provider:Q,links:K})}));const O=await Promise.all(F);if(g.token.isCancellationRequested)return[];const j=new Map;for(const Q of O)Q&&Q.links.length>0&&b.push(...Q.links.map(W=>{const K={id:p++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return j.set(K.id,{provider:Q.provider,link:W}),K}));return this._terminalLinkCache.set(f,j),b}$activateLink(f,m){const S=this._terminalLinkCache.get(f)?.get(m);!S||S.provider.handleTerminalLink(S.link)}_onProcessExit(f,m){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const S=this._terminalProcessDisposables[f];S&&(S.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,m)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,m){const S=this._getTerminalObjectIndexById(f,m);return S!==null?f[S]:null}_getTerminalObjectIndexById(f,m){let S=null;return f.some((T,g)=>T._id===m?(S=g,!0):!1),S}getEnvironmentVariableCollection(f){let m=this._environmentVariableCollections.get(f.identifier.value);return m||(m=new i,this._setEnvironmentVariableCollection(f.identifier.value,m)),m}_syncEnvironmentVariableCollection(f,m){const S=(0,y.serializeEnvironmentVariableCollection)(m.map);this._proxy.$setEnvironmentVariableCollection(f,m.persistent,S.length===0?void 0:S)}$initEnvironmentVariableCollections(f){f.forEach(m=>{const S=m[0],T=new i(m[1]);this._setEnvironmentVariableCollection(S,T)})}$acceptDefaultProfile(f,m){this._defaultProfile=f,this._defaultAutomationProfile=m}_setEnvironmentVariableCollection(f,m){this._environmentVariableCollections.set(f,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,m)})}};C=Ue([He(1,R.IExtHostRpcService)],C),e.BaseExtHostTerminalService=C;class i{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,m){this._setIfDiffers(f,{value:m,type:D.EnvironmentVariableMutatorType.Replace})}append(f,m){this._setIfDiffers(f,{value:m,type:D.EnvironmentVariableMutatorType.Append})}prepend(f,m){this._setIfDiffers(f,{value:m,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,m){const S=this.map.get(f);(!S||S.value!==m.value||S.type!==m.type)&&(this.map.set(f,m),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,m){this.map.forEach((S,T)=>f.call(m,T,S,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let l=class extends C{constructor(f){super(!1,f)}createTerminal(f,m,S){throw new t.NotSupportedError}createTerminalFromOptions(f,m){throw new t.NotSupportedError}};l=Ue([He(0,R.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l;function r(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function a(w){return v.ThemeColor.isThemeColor(w)?w:void 0}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[203],Ee([0,1,13,23,21,3,234,58,6,22,10,36,5,12,46,8,7,174,90,67]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E,o){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let C=class{constructor(u,F){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=u.getProxy(n.MainContext.MainThreadTesting),this.observer=new S(this.proxy),this.runTracker=new l(this.proxy),F.registerArgumentProcessor({processArgument:O=>O?.$mid===13?d.TestItem.toItemFromContext(O):O})}createTestController(u,F){if(this.controllers.has(u))throw new Error(`Attempt to insert a duplicate controller with ID "${u}"`);const O=new D.DisposableStore,j=O.add(new k.SingleUseTestCollection(u));j.root.label=F;const Q=new Map,W=this.proxy,K={items:j.root.children,get label(){return F},set label(U){F=U,j.root.label=U,W.$updateControllerLabel(u,F)},get id(){return u},createRunProfile:(U,H,G,ue,q)=>{let le=(0,I.hash)(U);for(;Q.has(le);)le++;const se=new T(this.proxy,u,le,U,H,G,ue,q);return Q.set(le,se),se},createTestItem(U,H,G){return new s.TestItemImpl(u,U,H,G)},createTestRun:(U,H,G=!0)=>this.runTracker.createTestRun(u,j,U,H,G),set resolveHandler(U){j.resolveHandler=U},get resolveHandler(){return j.resolveHandler},dispose:()=>{O.dispose()}};K.createRunConfiguration=K.createRunProfile,W.$registerTestController(u,F),O.add((0,D.toDisposable)(()=>W.$unregisterTestController(u)));const $={controller:K,collection:j,profiles:Q};return this.controllers.set(u,$),O.add((0,D.toDisposable)(()=>this.controllers.delete(u))),O.add(j.onDidGenerateDiff(U=>W.$publishDiff(u,U))),K}createTestObserver(){return this.observer.checkout()}async runTests(u,F=_.CancellationToken.None){const O=r(u);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.controllers.get(O.controllerId);if(!j)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:u.include?.map(Q=>Q.id)??[j.collection.root.id],profileGroup:g[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:u.exclude?.map(Q=>Q.id)},F)}$provideFileCoverage(u,F,O){return(0,c.mapFind)(this.runTracker.trackers,Q=>Q.id===u?Q.getCoverage(F):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(u,F,O,j){return(0,c.mapFind)(this.runTracker.trackers,W=>W.id===u?W.getCoverage(F):void 0)?.resolveFileCoverage(O,j)??Promise.resolve([])}$configureRunProfile(u,F){this.controllers.get(u)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(u){this.results=Object.freeze(u.map(F=>(0,P.deepFreeze)(d.TestResults.to(F))).concat(this.results).sort((F,O)=>O.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(u,F){const O=this.controllers.get(o.TestId.fromString(u).controllerId)?.collection;O&&(await O.expand(u,F<0?Infinity:F),O.flushDiff())}$acceptDiff(u){this.observer.applyDiff(u)}async $runControllerTests(u,F){const O=this.controllers.get(u.controllerId);if(!O)return;const{collection:j,profiles:Q}=O,W=Q.get(u.profileId);if(!W)return;const K=u.testIds.map(G=>j.tree.get(G)).filter(t.isDefined),$=u.excludeExtIds.map(G=>O.collection.tree.get(G)).filter(t.isDefined).filter(G=>K.some(ue=>ue.fullId.compare(G.fullId)===2));if(!K.length)return;const U=new v.TestRunRequest(K.some(G=>G.actual instanceof s.TestItemRootImpl)?void 0:K.map(G=>G.actual),$.map(G=>G.actual),W),H=this.runTracker.prepareForMainThreadTestRun(U,a.fromInternal(u,O.collection),F);try{await W.runHandler(U,F)}finally{H.isRunning&&!F.isCancellationRequested&&await A.Event.toPromise(H.onEnd),H.dispose()}}$cancelExtensionTestRun(u){u===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(u)}};C=Ue([He(0,h.IExtHostRpcService)],C),e.ExtHostTesting=C;class i extends D.Disposable{constructor(u,F,O){super();this.dto=u,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:j}of this.tasks.values())j.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(u){return this.tasks.get(u)?.coverage}createRun(u){const F=this.dto.id,O=this.dto.controllerId,j=(0,y.generateUuid)(),Q=new w(this.proxy,F,j),W=H=>(G,...ue)=>{if($){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(G)||(this.ensureTestIsKnown(G),H(G,...ue))},K=(H,G)=>{const ue=G instanceof Array?G.map(d.TestMessage.from):[d.TestMessage.from(G)];if(H.uri&&H.range){const q={range:d.Range.from(H.range),uri:H.uri};for(const le of ue)le.location=le.location||q}this.proxy.$appendTestMessagesInRun(F,j,o.TestId.fromExtHostTestItem(H,O).toString(),ue)};let $=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:u,get coverageProvider(){return Q.coverageProvider},set coverageProvider(H){Q.coverageProvider=H},enqueued:W(H=>{this.proxy.$updateTestStateInRun(F,j,o.TestId.fromExtHostTestItem(H,O).toString(),1)}),skipped:W(H=>{this.proxy.$updateTestStateInRun(F,j,o.TestId.fromExtHostTestItem(H,O).toString(),5)}),started:W(H=>{this.proxy.$updateTestStateInRun(F,j,o.TestId.fromExtHostTestItem(H,O).toString(),2)}),errored:W((H,G,ue)=>{K(H,G),this.proxy.$updateTestStateInRun(F,j,o.TestId.fromExtHostTestItem(H,O).toString(),6,ue)}),failed:W((H,G,ue)=>{K(H,G),this.proxy.$updateTestStateInRun(F,j,o.TestId.fromExtHostTestItem(H,O).toString(),4,ue)}),passed:W((H,G)=>{this.proxy.$updateTestStateInRun(F,j,o.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString(),3,G)}),appendOutput:(H,G,ue)=>{$||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(F,j,M.VSBuffer.fromString(H),G&&d.location.from(G),ue&&o.TestId.fromExtHostTestItem(ue,O).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(F,j),this.tasks.delete(j),this.isRunning||this.dispose())}};return this.tasks.set(j,{run:U,coverage:Q}),this.proxy.$startedTestRunTask(F,{id:j,name:u,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(u){if(!(u instanceof s.TestItemImpl))throw new s.InvalidTestItemError(u.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(u,this.dto.controllerId).toString()))return;const F=[],O=this.dto.colllection.root;for(;;){const j=d.TestItem.from(u);if(F.unshift(j),this.sharedTestIds.has(j.extId)||(this.sharedTestIds.add(j.extId),u===O))break;u=u.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class l{constructor(u){this.proxy=u,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(u,F,O){return this.getTracker(u,F,O)}cancelRunById(u){for(const F of this.tracked.values())if(F.id===u){F.dispose();return}}cancelAllRuns(){for(const u of this.tracked.values())u.dispose()}createTestRun(u,F,O,j,Q){const W=this.tracked.get(O);if(W)return W.createRun(j);const K=a.fromPublic(u,F,O,Q),$=r(O);this.proxy.$startedExtensionTestRun({controllerId:u,profile:$&&{group:g[$.kind],id:$.profileId},exclude:O.exclude?.map(H=>H.id)??[],id:K.id,include:O.include?.map(H=>H.id)??[F.root.id],persist:Q});const U=this.getTracker(O,K);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),U.createRun(j)}getTracker(u,F,O){const j=new i(F,this.proxy,O);return this.tracked.set(u,j),j.onEnd(()=>this.tracked.delete(u)),j}}e.TestRunCoordinator=l;const r=b=>{if(!!b.profile){if(!(b.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return b.profile}};class a{constructor(u,F,O,j,Q,W){this.controllerId=u,this.id=F,this.isPersisted=Q,this.colllection=W,this.includePrefix=O.map(K=>K+"\0"),this.excludePrefix=j.map(K=>K+"\0")}static fromPublic(u,F,O,j){return new a(u,(0,y.generateUuid)(),O.include?.map(Q=>o.TestId.fromExtHostTestItem(Q,u).toString())??[u],O.exclude?.map(Q=>o.TestId.fromExtHostTestItem(Q,u).toString())??[],j,F)}static fromInternal(u,F){return new a(u.controllerId,u.runId,u.testIds,u.excludeExtIds,!0,F)}isIncluded(u){const F=o.TestId.fromExtHostTestItem(u,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(F===O||F.startsWith(O))return!1;for(const O of this.includePrefix)if(F===O||F.startsWith(O))return!0;return!1}}e.TestRunDto=a;class w{constructor(u,F,O){this.proxy=u,this.runId=F,this.taskId=O}set coverageProvider(u){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!u||(this._coverageProvider=u,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(u){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(u))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(u,F){const O=await this.fileCoverage;let j=O?.[u];return!this._coverageProvider||!O||!j?[]:(j.detailedCoverage||(j=O[u]=await this._coverageProvider.resolveFileCoverage?.(j,F)??j),j.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class f extends E.IncrementalChangeCollector{constructor(u){super();this.emitter=u,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(u){this.added.add(u)}update(u){Object.assign(u.revived,d.TestItem.toPlain(u.item)),this.added.has(u)||this.updated.add(u)}remove(u){if(this.added.has(u)){this.added.delete(u);return}if(this.updated.delete(u),u.parent&&this.alreadyRemoved.has(u.parent)){this.alreadyRemoved.add(u.item.extId);return}this.removed.add(u)}getChangeEvent(){const{added:u,updated:F,removed:O}=this;return{get added(){return[...u].map(j=>j.revived)},get updated(){return[...F].map(j=>j.revived)},get removed(){return[...O].map(j=>j.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(u){return this.items.get(u)}getMirroredTestDataByReference(u){return this.items.get(u.id)}createItem(u,F){return{...u,revived:d.TestItem.toPlain(u.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=m;class S{constructor(u){this.proxy=u}checkout(){this.current||(this.current=this.createObserverData());const u=this.current;return u.observers++,{onDidChangeTest:u.tests.onDidChangeTests,get tests(){return[...u.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--u.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(u){return this.current?.tests.getMirroredTestDataByReference(u)}applyDiff(u){this.current?.tests.apply(u)}createObserverData(){const u=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:u}}}class T{constructor(u,F,O,j,Q,W,K=!1,$=void 0){this.controllerId=F,this.profileId=O,this._label=j,this.kind=Q,this.runHandler=W,this._isDefault=K,this._tag=$,p.set(this,void 0),Je(this,p,u,"f");const U=g[Q];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);Te(this,p,"f").$publishTestRunProfile({profileId:O,controllerId:F,tag:$?d.TestTag.namespace(this.controllerId,$.id):null,label:j,group:U,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(u){u!==this._label&&(this._label=u,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:u}))}get isDefault(){return this._isDefault}set isDefault(u){u!==this._isDefault&&(this._isDefault=u,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:u}))}get tag(){return this._tag}set tag(u){u?.id!==this._tag?.id&&(this._tag=u,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:u?d.TestTag.namespace(this.controllerId,u.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(u){u!==this._configureHandler&&(this._configureHandler=u,Te(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!u}))}dispose(){Te(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=T,p=new WeakMap;const g={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(be[204],Ee([0,1,3,13,5,94,8,7]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(t,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const y=this._extHostDocumentsAndEditors.allEditors();return t?y:y.map(n=>n.value)}async showTextDocument(t,y,n){let h;typeof y=="number"?h={position:R.ViewColumn.from(y),preserveFocus:n}:typeof y=="object"?h={position:R.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?R.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:h={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(t.uri,h),d=s&&this._extHostDocumentsAndEditors.getEditor(s);if(d)return d.value;throw s?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,y){return new A.TextEditorDecorationType(this._proxy,t,y).value}$acceptEditorPropertiesChanged(t,y){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(y.options&&n._acceptOptions(y.options),y.selections){const h=y.selections.selections.map(R.Selection.to);n._acceptSelections(h)}if(y.visibleRanges){const h=M.coalesce(y.visibleRanges.map(R.Range.to));n._acceptVisibleRanges(h)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...y.options,lineNumbers:R.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const h=I.TextEditorSelectionChangeKind.fromValue(y.selections.source),s=y.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:h})}if(y.visibleRanges){const h=M.coalesce(y.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:h})}}$acceptEditorPositionData(t){for(const y in t){const n=this._extHostDocumentsAndEditors.getEditor(y);if(!n)throw new Error("Unknown text editor");const h=R.ViewColumn.to(t[y]);n.value.viewColumn!==h&&(n._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:h}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=D}),define(be[205],Ee([0,1,2,4,5,6,7]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class I{constructor(t,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const h=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(D(h))?.get(n.handle)}return n}})}async $getTimeline(t,y,n,h,s){return this._providers.get(t)?.provideTimeline(c.URI.revive(y),n,h,s)}registerTimelineProvider(t,y,n,h){const s=new A.DisposableStore,d=this.convertTimelineItem(y.id,h,s).bind(this);let v;y.onDidChange&&(v=y.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:y.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:t,onDidChange:void 0,async provideTimeline(E,o,p,C){C?.resetCache&&(s.clear(),k.get(y.id)?.clear());const i=await y.provideTimeline(E,o,p);if(i==null)return;const l=d(E,C);return{...i,source:y.id,items:i.items.map(l)}},dispose(){for(const E of k.values())E.get(y.id)?.clear();v?.dispose(),s.dispose()}})}convertTimelineItem(t,y,n){return(h,s)=>{let d;if(s?.cacheResults){let v=this._itemsBySourceAndUriMap.get(t);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(t,v));const k=D(h);d=v.get(k),d===void 0&&(d=new Map,v.set(k,d))}return v=>{const{iconPath:k,...E}=v,o=`${t}|${v.id??v.timestamp}`;d?.set(o,v);let p,C,i;return v.iconPath&&(k instanceof R.ThemeIcon?i={id:k.id,color:k.color}:c.URI.isUri(k)?(p=k,C=k):{light:p,dark:C}=k),{...E,id:E.id??void 0,handle:o,source:t,command:v.command?y.toInternal(v.command,n):void 0,icon:p,iconDark:C,themeIcon:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=I;function D(P){return P?.toString()}}),define(be[206],Ee([0,1,6,11,2,5]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,t,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=y.schemes.find(h=>!R.supportedSchemes.has(h));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,y.schemes,D,y.label),(0,c.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,t){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener with id: ${D}`);const n=_.URI.revive(P);return y.canOpenExternalUri(n,t)}async $openUri(D,P,t){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener id: '${D}'`);return y.openExternalUri(_.URI.revive(P.resolvedUri),{sourceUri:_.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[207],Ee([0,1,5,2,6,16,25]),function(ie,e,c,M,_,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(R.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=I.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(P)),this.handlers.set(y,t),this._proxy.$registerUriHandler(y,P),(0,_.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,t){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=I,I.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[50],Ee([0,1,3,2,137,157,66,5]),function(ie,e,c,M,_,A,R,I){"use strict";var D,P,t,y,n,h,s,d,v,k,E,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(m,S,T,g,b,u,F){D.set(this,void 0),P.set(this,void 0),t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),h.set(this,void 0),s.set(this,""),d.set(this,void 0),v.set(this,!1),k.set(this,!1),E.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new c.Emitter),this._onDidDispose=Te(this,o,"f").event,Je(this,D,m,"f"),Je(this,P,S,"f"),Je(this,d,T,"f"),Je(this,y,g,"f"),Je(this,n,b,"f"),Je(this,h,u,"f"),Je(this,E,C(u),"f"),Je(this,t,F,"f")}dispose(){Je(this,v,!0,"f"),Te(this,o,"f").fire(),Te(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Je(this,k,!0,"f"),(0,R.asWebviewUri)(m,Te(this,y,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,s,"f")}set html(m){this.assertNotDisposed(),Te(this,s,"f")!==m&&(Je(this,s,m,"f"),!Te(this,k,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Je(this,k,!0,"f"),Te(this,t,"f").report("Webview vscode-resource: uris",Te(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,P,"f").$setHtml(Te(this,D,"f"),m))}get options(){return this.assertNotDisposed(),Te(this,d,"f")}set options(m){this.assertNotDisposed(),Te(this,P,"f").$setOptions(Te(this,D,"f"),r(Te(this,h,"f"),Te(this,n,"f"),m)),Je(this,d,m,"f")}async postMessage(m){if(Te(this,v,"f"))return!1;const S=(0,A.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Te(this,E,"f")});return Te(this,P,"f").$postMessage(Te(this,D,"f"),S.message,...S.buffers)}assertNotDisposed(){if(Te(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,D=new WeakMap,P=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,d=new WeakMap,v=new WeakMap,k=new WeakMap,E=new WeakMap,o=new WeakMap;function C(f){try{const m=(0,_.normalizeVersion)((0,_.parseVersion)(f.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=C;class i{constructor(m,S,T,g,b){this.initData=S,this.workspace=T,this._logService=g,this._deprecationService=b,this._webviews=new Map,this._webviewProxy=m.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(m,S,...T){const g=this.getWebview(m);if(g){const{message:b}=(0,A.deserializeWebviewMessage)(S,T);g._onMessageEmitter.fire(b)}}$onMissingCsp(m,S){this._logService.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,S,T){const g=new p(m,this._webviewProxy,a(S),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(m,g),g._onDidDispose(()=>{this._webviews.delete(m)}),g}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=i;function l(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=l;function r(f,m,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||w(f,m)}}e.serializeWebviewOptions=r;function a(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(m=>M.URI.from(m))}}e.reviveOptions=a;function w(f,m){return[...(m?.getWorkspaceFolders()||[]).map(S=>S.uri),f.extensionLocation]}}),define(be[208],Ee([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(i,l){this.document=i,this._storagePath=l,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,l){await this.getEdit(i).undo(),l||this.disposeBackup()}async redo(i,l){await this.getEdit(i).redo(),l||this.disposeBackup()}disposeEdits(i){for(const l of i)this._edits.delete(l)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=p(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const l=this._edits.get(i,0);if(!l)throw new Error("No edit found");return l}}class s{constructor(){this._documents=new Map}get(i,l){return this._documents.get(this.key(i,l))}add(i,l,r){const a=this.key(i,l.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${i} resource:${l.uri}`);const w=new h(l,r);return this._documents.set(a,w),w}delete(i,l){const r=this.key(i,l.uri);this._documents.delete(r)}key(i,l){return`${i}@@@${l}`}}var d;(function(C){C[C.Text=0]="Text",C[C.Custom=1]="Custom"})(d||(d={}));class v{constructor(){this._providers=new Map}addTextProvider(i,l,r){return this.add(0,i,l,r)}addCustomProvider(i,l,r){return this.add(1,i,l,r)}get(i){return this._providers.get(i)}add(i,l,r,a){if(this._providers.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this._providers.set(l,{type:i,extension:r,provider:a}),new n.Disposable(()=>this._providers.delete(l))}}class k{constructor(i,l,r,a,w){this._extHostDocuments=l,this._extensionStoragePaths=r,this._extHostWebview=a,this._extHostWebviewPanels=w,this._editorProviders=new v,this._documents=new s,this._proxy=i.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,l,r,a){const w=new _.DisposableStore;return E(r)?(w.add(this._editorProviders.addTextProvider(l,i,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),l,a.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(w.add(this._editorProviders.addCustomProvider(l,i,r)),this.supportEditing(r)&&w.add(r.onDidChangeCustomDocument(f=>{const m=this.getCustomDocumentEntry(l,f.document.uri);if(o(f)){const S=m.addEdit(f);this._proxy.$onDidEdit(f.document.uri,l,S,f.label)}else this._proxy.$onContentChange(f.document.uri,l)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),l,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(w,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(l)}))}async $createCustomDocument(i,l,r,a,w){const f=this._editorProviders.get(l);if(!f)throw new Error(`No provider found for '${l}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${l}'`);const m=I.URI.revive(i),S=await f.provider.openCustomDocument(m,{backupId:r,untitledDocumentData:a?.buffer},w);let T;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(l,S,T),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(i,l){const r=this._editorProviders.get(l);if(!r)throw new Error(`No provider found for '${l}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${l}'`);const a=I.URI.revive(i),{document:w}=this.getCustomDocumentEntry(l,a);this._documents.delete(l,w),w.dispose()}async $resolveWebviewEditor(i,l,r,a,w,f){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);const S=D.ViewColumn.to(w),T=this._extHostWebview.createNewWebview(l,a.webviewOptions,m.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(l,r,a.title,S,a.panelOptions,T),b=I.URI.revive(i);switch(m.type){case 1:{const{document:u}=this.getCustomDocumentEntry(r,b);return m.provider.resolveCustomEditor(u,g,f)}case 0:{const u=this._extHostDocuments.getDocument(b);return m.provider.resolveCustomTextEditor(u,g,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,l,r){this.getCustomDocumentEntry(l,i).disposeEdits(r)}async $onMoveCustomEditor(i,l,r){const a=this._editorProviders.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const w=this._extHostWebviewPanels.getWebviewPanel(i);if(!w)throw new Error("No webview found");const f=I.URI.revive(l),m=this._extHostDocuments.getDocument(f);await a.provider.moveCustomTextEditor(m,w,c.CancellationToken.None)}async $undo(i,l,r,a){return this.getCustomDocumentEntry(l,i).undo(r,a)}async $redo(i,l,r,a){return this.getCustomDocumentEntry(l,i).redo(r,a)}async $revert(i,l,r){const a=this.getCustomDocumentEntry(l,i);await this.getCustomEditorProvider(l).revertCustomDocument(a.document,r),a.disposeBackup()}async $onSave(i,l,r){const a=this.getCustomDocumentEntry(l,i);await this.getCustomEditorProvider(l).saveCustomDocument(a.document,r),a.disposeBackup()}async $onSaveAs(i,l,r,a){const w=this.getCustomDocumentEntry(l,i);return this.getCustomEditorProvider(l).saveCustomDocumentAs(w.document,I.URI.revive(r),a)}async $backup(i,l,r){const a=this.getCustomDocumentEntry(l,i),f=await this.getCustomEditorProvider(l).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},r);return a.updateBackup(f),f.id}getCustomDocumentEntry(i,l){const r=this._documents.get(i,I.URI.revive(l));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=k;function E(C){return typeof C.resolveCustomTextEditor=="function"}function o(C){return typeof C.undo=="function"&&typeof C.redo=="function"}function p(C){const i=C.scheme===A.Schemas.file||C.scheme===A.Schemas.untitled?C.fsPath:C.toString();return(0,M.hash)(i)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[209],Ee([0,1,3,6,2,36,8,50,5,7]),function(ie,e,c,M,_,A,R,I,D,P){"use strict";var t,y,n,h,s,d,v,k,E,o,p,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends M.Disposable{constructor(f,m,S,T,g,b,u){super();t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),d.set(this,void 0),v.set(this,void 0),k.set(this,void 0),E.set(this,!0),o.set(this,!0),p.set(this,!1),C.set(this,this._register(new c.Emitter)),this.onDidDispose=Te(this,C,"f").event,i.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Te(this,i,"f").event,Je(this,t,f,"f"),Je(this,y,m,"f"),Je(this,n,S,"f"),Je(this,s,b,"f"),Je(this,k,g,"f"),Je(this,d,T,"f"),Je(this,h,u,"f")}dispose(){Te(this,p,"f")||(Je(this,p,!0,"f"),Te(this,C,"f").fire(),Te(this,y,"f").$disposeWebview(Te(this,t,"f")),Te(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,h,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,d,"f")}set title(f){this.assertNotDisposed(),Te(this,d,"f")!==f&&(Je(this,d,f,"f"),Te(this,y,"f").$setTitle(Te(this,t,"f"),f))}get iconPath(){return this.assertNotDisposed(),Te(this,v,"f")}set iconPath(f){this.assertNotDisposed(),Te(this,v,"f")!==f&&(Je(this,v,f,"f"),Te(this,y,"f").$setIconPath(Te(this,t,"f"),_.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Te(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,k,"f")=="number"&&Te(this,k,"f")<0))return Te(this,k,"f")}get active(){return this.assertNotDisposed(),Te(this,o,"f")}get visible(){return this.assertNotDisposed(),Te(this,E,"f")}_updateViewState(f){Te(this,p,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Je(this,o,f.active,"f"),Je(this,E,f.visible,"f"),Je(this,k,f.viewColumn,"f"),Te(this,i,"f").fire({webviewPanel:this}))}reveal(f,m){this.assertNotDisposed(),Te(this,y,"f").$reveal(Te(this,t,"f"),{viewColumn:f?R.ViewColumn.from(f):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Te(this,p,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,y=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,d=new WeakMap,v=new WeakMap,k=new WeakMap,E=new WeakMap,o=new WeakMap,p=new WeakMap,C=new WeakMap,i=new WeakMap;class r{constructor(f,m,S){this.webviews=m,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(f,m,S,T,g={}){const b=typeof T=="object"?T.viewColumn:T,u={viewColumn:R.ViewColumn.from(b),preserveFocus:typeof T=="object"&&!!T.preserveFocus},F=(0,I.shouldSerializeBuffersForPostMessage)(f),O=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(f),O,m,{title:S,panelOptions:a(g),webviewOptions:(0,I.serializeWebviewOptions)(f,this.workspace,g),serializeBuffersForPostMessage:F},u);const j=this.webviews.createNewWebview(O,g,f);return this.createNewWebviewPanel(O,m,S,b,g,j)}$onDidChangeWebviewPanelViewStates(f){const m=Object.keys(f);m.sort((S,T)=>{const g=f[S],b=f[T];return g.active?1:b.active?-1:+g.visible-+b.visible});for(const S of m){const T=this.getWebviewPanel(S);if(!T)continue;const g=f[S];T._updateViewState({active:g.active,visible:g.visible,viewColumn:R.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,m,S){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:S,extension:f}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(f)}),new P.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(f,m,S,T){const g=this._serializers.get(m);if(!g)throw new Error(`No serializer found for '${m}'`);const{serializer:b,extension:u}=g,F=this.webviews.createNewWebview(f,S.webviewOptions,u),O=this.createNewWebviewPanel(f,m,S.title,T,S.panelOptions,F);await b.deserializeWebviewPanel(O,S.state)}createNewWebviewPanel(f,m,S,T,g,b){const u=new l(f,this._proxy,m,S,T,g,b);return this._webviewPanels.set(f,u),u}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function a(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[210],Ee([0,1,3,6,50,5,7]),function(ie,e,c,M,_,A,R){"use strict";var I,D,P,t,y,n,h,s,d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class k extends M.Disposable{constructor(p,C,i,l,r,a){super();I.set(this,void 0),D.set(this,void 0),P.set(this,void 0),t.set(this,void 0),y.set(this,!1),n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),d.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Te(this,d,"f").event,v.set(this,this._register(new c.Emitter)),this.onDidDispose=Te(this,v,"f").event,Je(this,P,i,"f"),Je(this,h,l,"f"),Je(this,I,p,"f"),Je(this,D,C,"f"),Je(this,t,r,"f"),Je(this,n,a,"f")}dispose(){Te(this,y,"f")||(Je(this,y,!0,"f"),Te(this,v,"f").fire(),Te(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,h,"f")}set title(p){this.assertNotDisposed(),Te(this,h,"f")!==p&&(Je(this,h,p,"f"),Te(this,D,"f").$setWebviewViewTitle(Te(this,I,"f"),p))}get description(){return this.assertNotDisposed(),Te(this,s,"f")}set description(p){this.assertNotDisposed(),Te(this,s,"f")!==p&&(Je(this,s,p,"f"),Te(this,D,"f").$setWebviewViewDescription(Te(this,I,"f"),p))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,t,"f")}get viewType(){return Te(this,P,"f")}_setVisible(p){p===Te(this,n,"f")||Te(this,y,"f")||(Je(this,n,p,"f"),Te(this,d,"f").fire())}show(p){this.assertNotDisposed(),Te(this,D,"f").$show(Te(this,I,"f"),!!p)}assertNotDisposed(){if(Te(this,y,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,P=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,d=new WeakMap,v=new WeakMap;class E{constructor(p,C){this._extHostWebview=C,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,C,i,l){if(this._viewProviders.has(C))throw new Error(`View provider for '${C}' already registered`);return this._viewProviders.set(C,{provider:i,extension:p}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(p),C,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(C),this._proxy.$unregisterWebviewViewProvider(C)})}async $resolveWebviewView(p,C,i,l,r){const a=this._viewProviders.get(C);if(!a)throw new Error(`No view provider found for '${C}'`);const{provider:w,extension:f}=a,m=this._extHostWebview.createNewWebview(p,{},f),S=new k(p,this._proxy,C,i,m,!0);this._webviewViews.set(p,S),await w.resolveWebviewView(S,{state:l},r)}async $onDidChangeWebviewViewVisibility(p,C){this.getWebviewView(p)._setVisible(C)}async $disposeWebviewView(p){const C=this.getWebviewView(p);this._webviewViews.delete(p),C.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const C=this._webviewViews.get(p);if(!C)throw new Error("No webview found");return C}}e.ExtHostWebviewViews=E}),define(be[97],Ee([0,1,3,5,2,11,9,4,12]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(y){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=y.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,n){let h;if(typeof y=="string"){h=y;try{y=_.URI.parse(y)}catch(s){return Promise.reject(`Invalid uri - '${y}'`)}}return(0,R.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,h,n)}async asExternalUri(y,n){if((0,R.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(y,n);return _.URI.from(h)}};P.InitialState={focused:!0},P=Ue([He(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(be[211],Ee([0,1,15,5,29,12]),function(ie,e,c,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends c.AbstractLogger{constructor(D,P){super();this._proxy=D.getProxy(M.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...P){this.getLevel()<=c.LogLevel.Trace&&this._proxy.$log(this._logFile,c.LogLevel.Trace,Array.from(arguments))}debug(D,...P){this.getLevel()<=c.LogLevel.Debug&&this._proxy.$log(this._logFile,c.LogLevel.Debug,Array.from(arguments))}info(D,...P){this.getLevel()<=c.LogLevel.Info&&this._proxy.$log(this._logFile,c.LogLevel.Info,Array.from(arguments))}warn(D,...P){this.getLevel()<=c.LogLevel.Warning&&this._proxy.$log(this._logFile,c.LogLevel.Warning,Array.from(arguments))}error(D,...P){this.getLevel()<=c.LogLevel.Error&&this._proxy.$log(this._logFile,c.LogLevel.Error,Array.from(arguments))}critical(D,...P){this.getLevel()<=c.LogLevel.Critical&&this._proxy.$log(this._logFile,c.LogLevel.Critical,Array.from(arguments))}flush(){}};R=Ue([He(0,A.IExtHostRpcService),He(1,_.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(be[212],Ee([0,1,14,23,21,16,3,6,108,179,47]),function(ie,e,c,M,_,A,R,I,D,P,t){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(g,b){try{return JSON.stringify(g,b)}catch(u){return"null"}}const h="$$ref$$",s={[h]:-1};class d{constructor(b,u){this.jsonString=b,this.referencedBuffers=u}}function v(g,b=null,u=!1){const F=[];return{jsonString:(u?n:JSON.stringify)(g,(j,Q)=>{if(typeof Q=="undefined")return s;if(typeof Q=="object"){if(Q instanceof M.VSBuffer){const W=F.push(Q)-1;return{[h]:W}}if(b)return b(j,Q)}return Q}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=v;function k(g,b,u){return JSON.parse(g,(F,O)=>{if(O){const j=O[h];if(typeof j=="number")return b[j];if(u&&O.$mid===1)return u.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=k;function E(g,b){return JSON.stringify(g,b)}function o(g){return g?(b,u)=>u&&u.$mid===1?g.transformOutgoing(u):u:null}var p;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var C;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(C=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},l=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends I.Disposable{constructor(b,u=null,F=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=b,this._logger=u,this._uriTransformer=F,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,j=t.ProxyIdentifier.count;O<j;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(b=>{this._pendingRPCReplies[b].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(b){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(b){this._unresponsiveTime=Date.now()+a.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(b){this._responsiveState!==b&&(this._responsiveState=b,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(b){return this._uriTransformer?(0,D.transformIncomingURIs)(b,this._uriTransformer):b}getProxy(b){const{nid:u,sid:F}=b;return this._proxies[u]||(this._proxies[u]=this._createProxy(u,F)),this._proxies[u]}_createProxy(b,u){let F={get:(O,j)=>(typeof j=="string"&&!O[j]&&j.charCodeAt(0)===36&&(O[j]=(...Q)=>this._remoteCall(b,j,Q)),j===r?u:O[j])};return new Proxy(Object.create(null),F)}set(b,u){return this._locals[b.nid]=u,u}assertRegistered(b){for(let u=0,F=b.length;u<F;u++){const O=b[u];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(b){if(this._isDisposed)return;const u=b.byteLength,F=w.read(b,0),O=F.readUInt8(),j=F.readUInt32();switch(O){case 1:case 2:{let{rpcId:Q,method:W,args:K}=m.deserializeRequestJSONArgs(F);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(u,j,Q,W,K,O===2);break}case 3:case 4:{let{rpcId:Q,method:W,args:K}=m.deserializeRequestMixedArgs(F);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(u,j,Q,W,K,O===4);break}case 5:{this._logger&&this._logger.logIncoming(u,j,0,"ack"),this._onDidReceiveAcknowledge(j);break}case 6:{this._receiveCancel(u,j);break}case 7:{this._receiveReply(u,j,void 0);break}case 9:{let Q=m.deserializeReplyOKJSON(F);this._uriTransformer&&(Q=(0,D.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveReply(u,j,Q);break}case 10:{const Q=m.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(u,j,Q);break}case 8:{let Q=m.deserializeReplyOKVSBuffer(F);this._receiveReply(u,j,Q);break}case 11:{let Q=m.deserializeReplyErrError(F);this._uriTransformer&&(Q=(0,D.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveReplyErr(u,j,Q);break}case 12:{this._receiveReplyErr(u,j,void 0);break}default:console.error("received unexpected message"),console.error(b)}}_receiveRequest(b,u,F,O,j,Q){this._logger&&this._logger.logIncoming(b,u,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(F)}.${O}(`,j);const W=String(u);let K,$;if(Q){const H=new _.CancellationTokenSource;j.push(H.token),K=this._invokeHandler(F,O,j),$=()=>H.cancel()}else K=this._invokeHandler(F,O,j),$=i;this._cancelInvokedHandlers[W]=$;const U=m.serializeAcknowledged(u);this._logger&&this._logger.logOutgoing(U.byteLength,u,1,"ack"),this._protocol.send(U),K.then(H=>{delete this._cancelInvokedHandlers[W];const G=m.serializeReplyOK(u,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,u,1,"reply:",H),this._protocol.send(G)},H=>{delete this._cancelInvokedHandlers[W];const G=m.serializeReplyErr(u,H);this._logger&&this._logger.logOutgoing(G.byteLength,u,1,"replyErr:",H),this._protocol.send(G)})}_receiveCancel(b,u){this._logger&&this._logger.logIncoming(b,u,1,"receiveCancel");const F=String(u);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(b,u,F){this._logger&&this._logger.logIncoming(b,u,0,"receiveReply:",F);const O=String(u);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const j=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],j.resolveOk(F)}_receiveReplyErr(b,u,F){this._logger&&this._logger.logIncoming(b,u,0,"receiveReplyErr:",F);const O=String(u);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const j=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let Q;F&&(F.$isError?(Q=new Error,Q.name=F.name,Q.message=F.message,Q.stack=F.stack):Q=F),j.resolveErr(Q)}_invokeHandler(b,u,F){try{return Promise.resolve(this._doInvokeHandler(b,u,F))}catch(O){return Promise.reject(O)}}_doInvokeHandler(b,u,F){const O=this._locals[b];if(!O)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(b));let j=O[u];if(typeof j!="function")throw new Error("Unknown method "+u+" on actor "+(0,t.getStringIdentifierForProxy)(b));return j.apply(O,F)}_remoteCall(b,u,F){if(this._isDisposed)return Promise.reject(A.canceled());let O=null;if(F.length>0&&_.CancellationToken.isCancellationToken(F[F.length-1])&&(O=F.pop()),O&&O.isCancellationRequested)return Promise.reject(A.canceled());const j=m.serializeRequestArguments(F,this._uriReplacer),Q=++this._lastMessageId,W=String(Q),K=new P.LazyPromise;O&&O.onCancellationRequested(()=>{const U=m.serializeCancel(Q);this._logger&&this._logger.logOutgoing(U.byteLength,Q,0,"cancel"),this._protocol.send(m.serializeCancel(Q))}),this._pendingRPCReplies[W]=K,this._onWillSendRequest(Q);const $=m.serializeRequest(Q,b,u,j,!!O);return this._logger&&this._logger.logOutgoing($.byteLength,Q,0,`request: ${(0,t.getStringIdentifierForProxy)(b)}.${u}(`,F),this._protocol.send($),K}}e.RPCProtocol=a,y=l,a.UNRESPONSIVE_TIME=3*1e3;class w{constructor(b,u){this._buff=b,this._offset=u}static alloc(b,u,F){let O=new w(M.VSBuffer.alloc(F+1+4),0);return O.writeUInt8(b),O.writeUInt32(u),O}static read(b,u){return new w(b,u)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(b){this._buff.writeUInt8(b,this._offset),this._offset+=1}readUInt8(){const b=this._buff.readUInt8(this._offset);return this._offset+=1,b}writeUInt32(b){this._buff.writeUInt32BE(b,this._offset),this._offset+=4}readUInt32(){const b=this._buff.readUInt32BE(this._offset);return this._offset+=4,b}static sizeShortString(b){return 1+b.byteLength}writeShortString(b){this._buff.writeUInt8(b.byteLength,this._offset),this._offset+=1,this._buff.set(b,this._offset),this._offset+=b.byteLength}readShortString(){const b=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,F}static sizeLongString(b){return 4+b.byteLength}writeLongString(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readLongString(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,F}writeBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}static sizeVSBuffer(b){return 4+b.byteLength}writeVSBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readVSBuffer(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+b);return this._offset+=b,u}static sizeMixedArray(b){let u=0;u+=1;for(let F=0,O=b.length;F<O;F++){const j=b[F];switch(u+=1,j.type){case 1:u+=this.sizeLongString(j.value);break;case 2:u+=this.sizeVSBuffer(j.value);break;case 3:u+=this.sizeUInt8(),u+=this.sizeLongString(j.value);for(let Q=0;Q<j.buffers.length;++Q)u+=this.sizeVSBuffer(j.buffers[Q]);break;case 4:break}}return u}writeMixedArray(b){this._buff.writeUInt8(b.length,this._offset),this._offset+=1;for(let u=0,F=b.length;u<F;u++){const O=b[u];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt8(O.buffers.length),this.writeLongString(O.value);for(let j=0;j<O.buffers.length;++j)this.writeBuffer(O.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const b=this._buff.readUInt8(this._offset);this._offset+=1;let u=new Array(b);for(let F=0;F<b;F++)switch(this.readUInt8()){case 1:u[F]=this.readLongString();break;case 2:u[F]=this.readVSBuffer();break;case 3:const j=this.readUInt8(),Q=this.readLongString(),W=[];for(let K=0;K<j;++K)W.push(this.readVSBuffer());u[F]=new t.SerializableObjectWithBuffers(k(Q,W,null));break;case 4:u[F]=void 0;break}return u}}var f;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(f||(f={}));class m{static _useMixedArgSerialization(b){for(let u=0,F=b.length;u<F;u++)if(b[u]instanceof M.VSBuffer||b[u]instanceof t.SerializableObjectWithBuffers||typeof b[u]=="undefined")return!0;return!1}static serializeRequestArguments(b,u){if(this._useMixedArgSerialization(b)){const F=[];for(let O=0,j=b.length;O<j;O++){const Q=b[O];if(Q instanceof M.VSBuffer)F[O]={type:2,value:Q};else if(typeof Q=="undefined")F[O]={type:4};else if(Q instanceof t.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:K}=v(Q.value,u);F[O]={type:3,value:M.VSBuffer.fromString(W),buffers:K}}else F[O]={type:1,value:M.VSBuffer.fromString(E(Q,u))}}return{type:1,args:F}}return{type:0,args:E(b,u)}}static serializeRequest(b,u,F,O,j){switch(O.type){case 0:return this._requestJSONArgs(b,u,F,O.args,j);case 1:return this._requestMixedArgs(b,u,F,O.args,j)}}static _requestJSONArgs(b,u,F,O,j){const Q=M.VSBuffer.fromString(F),W=M.VSBuffer.fromString(O);let K=0;K+=w.sizeUInt8(),K+=w.sizeShortString(Q),K+=w.sizeLongString(W);let $=w.alloc(j?2:1,b,K);return $.writeUInt8(u),$.writeShortString(Q),$.writeLongString(W),$.buffer}static deserializeRequestJSONArgs(b){const u=b.readUInt8(),F=b.readShortString(),O=b.readLongString();return{rpcId:u,method:F,args:JSON.parse(O)}}static _requestMixedArgs(b,u,F,O,j){const Q=M.VSBuffer.fromString(F);let W=0;W+=w.sizeUInt8(),W+=w.sizeShortString(Q),W+=w.sizeMixedArray(O);let K=w.alloc(j?4:3,b,W);return K.writeUInt8(u),K.writeShortString(Q),K.writeMixedArray(O),K.buffer}static deserializeRequestMixedArgs(b){const u=b.readUInt8(),F=b.readShortString(),O=b.readMixedArray(),j=new Array(O.length);for(let Q=0,W=O.length;Q<W;Q++){const K=O[Q];typeof K=="string"?j[Q]=JSON.parse(K):j[Q]=K}return{rpcId:u,method:F,args:j}}static serializeAcknowledged(b){return w.alloc(5,b,0).buffer}static serializeCancel(b){return w.alloc(6,b,0).buffer}static serializeReplyOK(b,u,F){if(typeof u=="undefined")return this._serializeReplyOKEmpty(b);if(u instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(b,u);if(u instanceof t.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:j}=v(u.value,F,!0);return this._serializeReplyOKJSONWithBuffers(b,O,j)}else return this._serializeReplyOKJSON(b,n(u,F))}static _serializeReplyOKEmpty(b){return w.alloc(7,b,0).buffer}static _serializeReplyOKVSBuffer(b,u){let F=0;F+=w.sizeVSBuffer(u);let O=w.alloc(8,b,F);return O.writeVSBuffer(u),O.buffer}static deserializeReplyOKVSBuffer(b){return b.readVSBuffer()}static _serializeReplyOKJSON(b,u){const F=M.VSBuffer.fromString(u);let O=0;O+=w.sizeLongString(F);let j=w.alloc(9,b,O);return j.writeLongString(F),j.buffer}static _serializeReplyOKJSONWithBuffers(b,u,F){const O=M.VSBuffer.fromString(u);let j=0;j+=w.sizeUInt8(),j+=w.sizeLongString(O);for(const W of F)j+=w.sizeVSBuffer(W);let Q=w.alloc(10,b,j);Q.writeUInt8(F.length),Q.writeLongString(O);for(const W of F)Q.writeBuffer(W);return Q.buffer}static deserializeReplyOKJSON(b){const u=b.readLongString();return JSON.parse(u)}static deserializeReplyOKJSONWithBuffers(b,u){const F=b.readUInt8(),O=b.readLongString(),j=[];for(let Q=0;Q<F;++Q)j.push(b.readVSBuffer());return new t.SerializableObjectWithBuffers(k(O,j,u))}static serializeReplyErr(b,u){return u?this._serializeReplyErrEror(b,u):this._serializeReplyErrEmpty(b)}static _serializeReplyErrEror(b,u){const F=M.VSBuffer.fromString(n(A.transformErrorForSerialization(u),null));let O=0;O+=w.sizeLongString(F);let j=w.alloc(11,b,O);return j.writeLongString(F),j.buffer}static deserializeReplyErrError(b){const u=b.readLongString();return JSON.parse(u)}static _serializeReplyErrEmpty(b){return w.alloc(12,b,0).buffer}}var S;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(S||(S={}));var T;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(T||(T={}))}),define(be[213],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(A){const R=I=>{self.removeEventListener("message",R);const D=I.data;Object.defineProperties(self,{postMessage:{value(P,t){D.postMessage(P,t)}},onmessage:{get(){return D.onmessage},set(P){D.onmessage=P}}}),D.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(A,R,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${c})('${R}'))`,P=new Blob([D],{type:"application/javascript"}),t=URL.createObjectURL(P),y=new MessageChannel,n=t,h={type:"_newWorker",id:n,port:y.port2,url:t,options:I};A(h,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};y.port1.postMessage(s),URL.revokeObjectURL(t),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(s){y.port1.onmessage=s}},onmessageerror:{get(){return y.port1.onmessageerror},set(s){y.port1.onmessageerror=s}}}),y.port1.addEventListener("messageerror",s=>{const d=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(d)}),y.port1.addEventListener("message",s=>{const d=new MessageEvent("message",{data:s.data});this.dispatchEvent(d)}),y.port1.start()}}e.NestedWorker=M}),define(be[214],Ee([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(be[215],Ee([0,1,11,17,26,2,4,86,45,175,214]),function(ie,e,c,M,_,A,R,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let y=class $i{constructor(h,s,d,v){this.localUserHome=h,this.remoteAgentService=s,this.environmentService=d,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||_.OS)(),this.resolveUserHome=(async()=>{const k=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=k?.userHome||h})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,s){if(h.remoteAuthority)return c.Schemas.vscodeRemote;const d=(0,I.getVirtualWorkspaceScheme)(s.getWorkspace());if(d)return d;const v=s.getWorkspace().folders[0];if(v)return v.uri.scheme;const k=s.getWorkspace().configuration;return k?k.scheme:c.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?M.win32:M.posix)}async fileURI(h){let s="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const v=h.indexOf("/",2);v===-1?(s=h.substring(2),h="/"):(s=h.substring(2,v),h=h.substring(v)||"/")}return A.URI.from({scheme:c.Schemas.file,authority:s,path:h,query:"",fragment:""})}};y=Ue([He(1,t.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,D.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(be[98],Ee([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(R,I){this.line=R,this.character=I}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,I){return new c(0,0)}with(R){return new c(0,0)}}e.Position=c;class M{constructor(R,I,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(R,I),this.end=new c(D,P)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.Range=M;var _;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[39],Ee([0,1,13,27,22,41,9,4,17,16,98,10]),function(ie,e,c,M,_,A,R,I,D,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",h=" characters skipped \u27EB",s=(n.length+h.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var d;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function k(U){return!!U.preview}e.resultIsMatch=k;function E(U){return!!U.resource}e.isFileMatch=E;function o(U){return!!U.message}e.isProgressMessage=o;var p;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class C{constructor(H){this.resource=H,this.results=[]}}e.FileMatch=C;class i{constructor(H,G,ue){this.ranges=G;const q=Array.isArray(G)?G:[G];if(ue&&ue.matchLines===1&&l(q)){H=(0,R.getNLines)(H,ue.matchLines);let le="",se=0,ve=0;const Fe=Math.floor(ue.charsPerLine/5),Me=[];for(const Ne of q){const Qe=Math.max(Ne.startColumn-Fe,0),ze=Ne.startColumn+ue.charsPerLine;if(Qe>ve+Fe+s){const qe=n+(Qe-ve)+h;le+=qe+H.slice(Qe,ze),se+=Qe-(ve+qe.length)}else le+=H.slice(ve,ze);Me.push(new a(0,Ne.startColumn-se,Ne.endColumn-se)),ve=ze}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(G)?G[0].startLineNumber:G.startLineNumber;this.preview={text:H,matches:(0,c.mapArrayOrNot)(G,se=>new r(se.startLineNumber-le,se.startColumn,se.endLineNumber-le,se.endColumn))}}}}e.TextSearchMatch=i;function l(U){const H=U[0].startLineNumber;for(const G of U)if(G.startLineNumber!==H||G.endLineNumber!==H)return!1;return!0}class r{constructor(H,G,ue,q){this.startLineNumber=H,this.startColumn=G,this.endLineNumber=ue,this.endColumn=q}}e.SearchRange=r;class a extends r{constructor(H,G,ue){super(H,G,H,ue)}}e.OneLineRange=a;var w;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(w=e.SearchSortOrder||(e.SearchSortOrder={}));function f(U,H=!0){const G=U&&U.files&&U.files.exclude,ue=H&&U&&U.search&&U.search.exclude;if(!G&&!ue)return;if(!G||!ue)return G||ue;let q=Object.create(null);return q=_.mixin(q,_.deepClone(G)),q=_.mixin(q,_.deepClone(ue),!0),q}e.getExcludes=f;function m(U,H){return U.excludePattern&&M.match(U.excludePattern,H)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&M.match(U.includePattern,H)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(G=>{const ue=G.folder.fsPath;if(A.isEqualOrParent(H,ue)){const q=D.relative(ue,H);return!G.includePattern||!!M.match(G.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var S;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(S=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(H,G){super(H);this.code=G}}e.SearchError=T;function g(U){const H=U.message;if((0,P.isPromiseCanceledError)(U))return new T(H,S.canceled);try{const G=JSON.parse(H);return new T(G.message,G.code)}catch(G){return new T(H,S.other)}}e.deserializeSearchError=g;function b(U){const H={message:U.message,code:U.code};return new Error(JSON.stringify(H))}e.serializeSearchError=b;function u(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=u;function F(U){return U.type==="success"}e.isSerializedSearchSuccess=F;function O(U){return!!U.path}e.isSerializedFileMatch=O;function j(U,H){const G=U.searchPath?U.searchPath:U.relativePath;return(0,R.fuzzyContains)(G,H)}e.isFilePatternMatch=j;class Q{constructor(H){this.path=H,this.results=[]}addMatch(H){this.results.push(H)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Q;function W(U,H){const G={...U||{},...H||{}};return Object.keys(G).filter(ue=>{const q=G[ue];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=W;class K{constructor(H,G){this._parsedIncludeExpression=null,this._excludeExpression={...H.excludePattern||{},...G.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let ue=H.includePattern;G.includePattern&&(ue?ue={...ue,...G.includePattern}:ue=G.includePattern),ue&&(this._parsedIncludeExpression=M.parse(ue))}includedInQuerySync(H,G,ue){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(H,G,ue)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(H,G,ue))}includedInQuery(H,G,ue){const q=this._parsedExcludeExpression(H,G,ue),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(H,G,ue):!0;return(0,y.isPromise)(q)?q.then(se=>se?!1:le()):le()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=K;function $(U){for(const H in U)if(typeof U[H]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,13,14,21,3,20,11,75,24,9,10,2,129,4,15,144,45,37,29,12,7,39,5]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E,o,p,C,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(b,u,F){return new P.ExtUri(O=>m(O,F)).isEqual(b,u)}function a(b,u,F){return r(b.uri,u.uri,F)?0:(0,t.compare)(b.uri.toString(),u.uri.toString())}function w(b,u,F){return b.index!==u.index?b.index<u.index?-1:1:r(b.uri,u.uri,F)?(0,t.compare)(b.name,u.name):(0,t.compare)(b.uri.toString(),u.uri.toString())}function f(b,u,F,O){const j=b.slice(0).sort((W,K)=>F(W,K,O)),Q=u.slice(0).sort((W,K)=>F(W,K,O));return(0,c.delta)(j,Q,(W,K)=>F(W,K,O))}function m(b,u){const F=u.getCapabilities(b.scheme);return!(F&&F&1024)}class S extends k.Workspace{constructor(u,F,O,j,Q,W){super(u,O.map(K=>new k.WorkspaceFolder(K)),j,W);this._name=F,this._isUntitled=Q,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(W),O.forEach(K=>{this._workspaceFolders.push(K),this._structure.set(K.uri,K)})}static toExtHostWorkspace(u,F,O,j){if(!u)return{workspace:null,added:[],removed:[]};const{id:Q,name:W,folders:K,configuration:$,isUntitled:U}=u,H=[],G=F;F?K.forEach((se,ve)=>{const Fe=n.URI.revive(se.uri),Me=S._findFolder(O||F,Fe,j);Me?(Me.name=se.name,Me.index=se.index,H.push(Me)):H.push({uri:Fe,name:se.name,index:ve})}):H.push(...K.map(({uri:se,name:ve,index:Fe})=>({uri:n.URI.revive(se),name:ve,index:Fe}))),H.sort((se,ve)=>se.index<ve.index?-1:1);const ue=new S(Q,W,H,$?n.URI.revive($):null,!!U,se=>m(se,j)),{added:q,removed:le}=f(G?G.workspaceFolders:[],ue.workspaceFolders,a,j);return{workspace:ue,added:q,removed:le}}static _findFolder(u,F,O){for(let j=0;j<u.folders.length;j++){const Q=u.workspaceFolders[j];if(r(Q.uri,F,O))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(u,F){return F&&this._structure.get(u)&&(u=(0,P.dirname)(u)),this._structure.findSubstr(u)}resolveWorkspaceFolder(u){return this._structure.get(u)}}let T=class{constructor(u,F,O,j){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=O,this._requestIdProvider=new D.Counter,this._barrier=new M.Barrier,this._proxy=u.getProxy(l.MainContext.MainThreadWorkspace),this._messageService=u.getProxy(l.MainContext.MainThreadMessageService);const Q=F.workspace;this._confirmedWorkspace=Q?new S(Q.id,Q.name,[],Q.configuration?n.URI.revive(Q.configuration):null,!!Q.isUntitled,W=>m(W,O)):void 0}$initializeWorkspace(u,F){this._trusted=F,this.$acceptWorkspaceData(u),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:I.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(u,F,O,...j){const Q=[];if(Array.isArray(j)&&j.forEach(H=>{n.URI.isUri(H.uri)&&!Q.some(G=>r(G.uri,H.uri,this._extHostFileSystemInfo))&&Q.push({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[F,O].some(H=>typeof H!="number"||H<0)||O===0&&Q.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+O>W.length)return!1;const K=W.slice(0);K.splice(F,O,...Q.map(H=>({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<K.length;H++){const G=K[H];if(K.some((ue,q)=>q!==H&&r(G.uri,ue.uri,this._extHostFileSystemInfo)))return!1}K.forEach((H,G)=>H.index=G);const{added:$,removed:U}=f(W,K,w,this._extHostFileSystemInfo);if($.length===0&&U.length===0)return!1;if(this._proxy){const H=u.displayName||u.name;this._proxy.$updateWorkspaceFolders(H,F,O,Q).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,h.localize)(0,null,H,G.toString()),{extension:u},[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(u,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(u,F)}async getWorkspaceFolder2(u,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(u,F)}async resolveWorkspaceFolder(u){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(u)}getPath(){if(!this._actualWorkspace)return;const{folders:u}=this._actualWorkspace;if(u.length!==0)return u[0].uri.fsPath}getRelativePath(u,F){let O,j="";if(typeof u=="string"?(O=n.URI.file(u),j=u):typeof u!="undefined"&&(O=u,j=u.fsPath),!O)return j;const Q=this.getWorkspaceFolder(O,!0);if(!Q)return j;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let W=(0,P.relativePath)(Q.uri,O);return F&&Q.name&&(W=`${Q.name}/${W}`),W}trySetWorkspaceFolders(u){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:u,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(u){const{workspace:F,added:O,removed:j}=S.toExtHostWorkspace(u,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:j}))}findFiles(u,F,O,j,Q=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let W;if(F===null?W=!1:F&&(typeof F=="string"?W=F:W=F.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:$}=g(u);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(K),(0,y.withUndefinedAsNull)($),(0,y.withUndefinedAsNull)(W),(0,y.withUndefinedAsNull)(O),Q).then(U=>Array.isArray(U)?U.map(H=>n.URI.revive(H)):[])}async findTextInFiles(u,F,O,j,Q=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),K=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:$,folder:U}=g(F.include),H=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,G={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:K,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:$,excludePattern:H},ue=!1;if(this._activeSearchCallbacks[W]=q=>{if(ue)return;const le=n.URI.revive(q.resource);q.results.forEach(se=>{(0,i.resultIsMatch)(se)?O({uri:le,preview:{text:se.preview.text,matches:(0,c.mapArrayOrNot)(se.preview.matches,ve=>new C.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,c.mapArrayOrNot)(se.ranges,ve=>new C.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):O({uri:le,text:se.text,lineNumber:se.lineNumber})})},Q.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(u,(0,y.withUndefinedAsNull)(U),G,W,Q);return delete this._activeSearchCallbacks[W],q||{}}catch(q){throw delete this._activeSearchCallbacks[W],q}}$handleTextSearchResult(u,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](u)}saveAll(u){return this._proxy.$saveAll(u)}resolveProxy(u){return this._proxy.$resolveProxy(u)}get trusted(){return this._trusted}requestWorkspaceTrust(u){return this._proxy.$requestWorkspaceTrust(u)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=Ue([He(0,p.IExtHostRpcService),He(1,o.IExtHostInitDataService),He(2,E.IExtHostFileSystemInfo),He(3,d.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function g(b){let u,F;return b&&(typeof b=="string"?u=b:(u=b.pattern,F=b.baseFolder||n.URI.file(b.base))),{includePattern:u,folder:F}}}),define(be[32],Ee([0,1,22,3,31,5,7,147,62,10,14,4,12,15,2]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(l,r){if(r){const a=r.split(".");let w=l;for(let f=0;w&&f<a.length;f++)w=w[a[f]];return w}}function v(l){return l instanceof s.URI}function k(l){return l&&l.uri instanceof s.URI&&l.languageId&&typeof l.languageId=="string"}function E(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function o(l){return l&&l.uri instanceof s.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function p(l){if(v(l))return{resource:l};if(k(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(E(l))return{overrideIdentifier:l.languageId};if(o(l))return{resource:l.uri};if(l===null)return{resource:null}}let C=class{constructor(r,a,w){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=w,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(r,a))}};C=Ue([He(0,n.IExtHostRpcService),He(1,_.IExtHostWorkspace),He(2,h.ILogService)],C),e.ExtHostConfiguration=C;class i{constructor(r,a,w,f){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=a,this._configuration=I.Configuration.parse(w),this._configurationScopes=this._toMap(w.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,a){const w={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,w))}getConfiguration(r,a,w){const f=p(a)||{},m=this._toReadonlyValue(r?d(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,w?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(g){return typeof d(m,g)!="undefined"},get:(g,b)=>{this._validateConfigurationAccess(r?`${r}.${g}`:g,f,w?.identifier);let u=d(m,g);if(typeof u=="undefined")u=b;else{let F;const O=(j,Q)=>{let W;const K=()=>{F=F||(0,c.deepClone)(m),W=W||d(F,Q)};return(0,P.isObject)(j)?new Proxy(j,{get:($,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return K(),()=>W;if(F)return W=W||d(F,Q),W[U];const H=$[U];return typeof U=="string"?O(H,`${Q}.${U}`):H},set:($,U,H)=>(K(),W&&(W[U]=H),!0),deleteProperty:($,U)=>(K(),W&&delete W[U],!0),defineProperty:($,U,H)=>(K(),W&&Object.defineProperty(W,U,H),!0)}):j};u=O(u,g)}return u},update:(g,b,u,F)=>{g=r?`${r}.${g}`:g;const O=S(u);return b!==void 0?this._proxy.$updateConfigurationOption(O,g,b,f,F):this._proxy.$removeConfigurationOption(O,g,f,F)},inspect:g=>{g=r?`${r}.${g}`:g;const b=(0,c.deepClone)(this._configuration.inspect(g,f,this._extHostWorkspace.workspace));if(b)return{key:g,defaultValue:b.default?.value,globalValue:b.user?.value,workspaceValue:b.workspace?.value,workspaceFolderValue:b.workspaceFolder?.value,defaultLanguageValue:b.default?.override,globalLanguageValue:b.user?.override,workspaceLanguageValue:b.workspace?.override,workspaceFolderLanguageValue:b.workspaceFolder?.override,languageIds:b.overrideIdentifiers}}};return typeof m=="object"&&(0,c.mixin)(T,m,!1),Object.freeze(T)}_toReadonlyValue(r){const a=w=>(0,P.isObject)(w)?new Proxy(w,{get:(f,m)=>a(f[m]),set:(f,m,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(f,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(f,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return a(r)}_validateConfigurationAccess(r,a,w){const f=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),m=w?`[${w.value}] `:"";if(f===4){typeof a?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){a?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,a){const w=new I.ConfigurationChangeEvent(r,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,m)=>w.affectsConfiguration(f,p(m))})}_toMap(r){return r.reduce((a,w)=>(a.set(w[0],w[1]),a),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[99],Ee([0,1,2,14,3,5,7,31,49,32,21,38,12,29,4,11,26,15,70,165,16]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E,o,p){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(Q){function W($){if($!=null)return $}Q.from=W;function K($){if($!=null)return $}Q.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var l;(function(Q){function W($){if($!=null)return $}Q.from=W;function K($){if($!=null)return $}Q.to=K})(l=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(Q){function W($){if($!=null)return $}Q.from=W;function K($){if($!=null)return $}Q.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(Q){function W(U){if(U){const H=U;return H&&!!H.process}else return!1}Q.is=W;function K(U){if(U==null)return;const H={process:U.process,args:U.args};return U.options&&(H.options=r.from(U.options)),H}Q.from=K;function $(U){if(U!=null)return new R.ProcessExecution(U.process,U.args,U.options)}Q.to=$})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var w;(function(Q){function W($){if($!=null)return $}Q.from=W;function K($){if($!=null)return $}Q.to=K})(w=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(Q){function W(U){if(U){const H=U;return H&&(!!H.commandLine||!!H.command)}else return!1}Q.is=W;function K(U){if(U==null)return;const H={};return U.commandLine!==void 0?H.commandLine=U.commandLine:(H.command=U.command,H.args=U.args),U.options&&(H.options=w.from(U.options)),H}Q.from=K;function $(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.ShellExecution(U.commandLine,U.options):new R.ShellExecution(U.command,U.args?U.args:[],U.options)}Q.to=$})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(Q){function W(U){if(U){let H=U;return H&&H.customExecution==="customExecution"}else return!1}Q.is=W;function K(U){return{customExecution:"customExecution"}}Q.from=K;function $(U,H){return H.get(U)}Q.to=$})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(Q){function W(K,$){let U;return K.scope!==void 0&&typeof K.scope!="number"?U=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===R.TaskScope.Workspace&&$&&$.workspaceFile?U=$.workspaceFile:U=o.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:U}}Q.from=W})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(Q){function W(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}Q.from=W})(T=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(Q){function W(U,H){if(U==null)return[];const G=[];for(let ue of U){const q=K(ue,H);q&&G.push(q)}return G}Q.fromMany=W;function K(U,H){if(U==null)return;let G;U.execution instanceof R.ProcessExecution?G=a.from(U.execution):U.execution instanceof R.ShellExecution?G=f.from(U.execution):U.execution&&U.execution instanceof R.CustomExecution&&(G=m.from(U.execution));const ue=i.from(U.definition);let q;return U.scope?typeof U.scope=="number"?q=U.scope:q=U.scope.uri:q=R.TaskScope.Workspace,!ue||!q?void 0:{_id:U._id,definition:ue,name:U.name,source:{extensionId:H.identifier.value,label:U.source,scope:q},execution:G,isBackground:U.isBackground,group:T.from(U.group),presentationOptions:l.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}Q.from=K;async function $(U,H,G){if(U==null)return;let ue;a.is(U.execution)?ue=a.to(U.execution):f.is(U.execution)?ue=f.to(U.execution):m.is(U.execution)&&(ue=m.to(U._id,G));const q=i.to(U.definition);let le;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?le=U.source.scope:le=await H.resolveWorkspaceFolder(c.URI.revive(U.source.scope)):le=R.TaskScope.Workspace),!q||!le)return;const se=new R.Task(q,le,U.name,U.source.label,ue,U.problemMatchers);return U.isBackground!==void 0&&(se.isBackground=U.isBackground),U.group!==void 0&&(se.group=R.TaskGroup.from(U.group._id),se.group&&(se.group=new R.TaskGroup(se.group.id,se.group.label),U.group.isDefault&&(se.group.isDefault=U.group.isDefault))),U.presentationOptions&&(se.presentationOptions=l.to(U.presentationOptions)),U._id&&(se._id=U._id),U.detail&&(se.detail=U.detail),se}Q.to=$})(g=e.TaskDTO||(e.TaskDTO={}));var b;(function(Q){function W($){return $}Q.from=W;function K($){if(!!$)return Object.assign(Object.create(null),$)}Q.to=K})(b=e.TaskFilterDTO||(e.TaskFilterDTO={}));class u{constructor(W,K,$){this._id=K,this._task=$,C.set(this,void 0),Je(this,C,W,"f")}get task(){return this._task}terminate(){Te(this,C,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}C=new WeakMap;var F;(function(Q){function W(K){return{id:K._id,task:void 0}}Q.from=W})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(W,K,$,U,H,G,ue,q){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=U,this._configurationService=H,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ue,this._deprecationService=q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,K,$){if(!$)return new R.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:K,provider:$,extension:W}),this._proxy.$registerTaskProvider(U,K),new R.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(W,K){this._proxy.$registerTaskSystem(W,K)}fetchTasks(W){return this._proxy.$fetchTasks(b.from(W)).then(async K=>{const $=[];for(let U of K){const H=await g.to(U,this._workspaceProvider,this._providedCustomExecutions2);H&&$.push(H)}return $})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(K=>W.push(K)),W}terminateTask(W){if(!(W instanceof u))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,K,$){const U=this._providedCustomExecutions2.get(W.id);if(U){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,U),this._terminalService.attachPtyToTerminal(K,await U.callback($))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const K=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const K=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:K,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const K=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:W.exitCode})}$provideTasks(W,K){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));const U=[],H=(0,M.asPromise)(()=>$.provider.provideTasks(t.CancellationToken.None)).then(G=>this.provideTasksInternal(K,U,$,G));return new Promise(G=>{H.then(ue=>{Promise.all(U).then(()=>{G(ue)})})})}async $resolveTask(W,K){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));if(K.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${$.type}].`);const U=await g.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const H=await $.provider.resolveTask(U,t.CancellationToken.None);if(!H)return;this.checkDeprecation(H,$);const G=g.from(H,$.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(G.execution)&&await this.addCustomExecution(G,H,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,K,$){const U=await this._proxy.$createTaskId(W);!$&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,K.execution)}async getTaskExecution(W,K){if(typeof W=="string"){const H=this._taskExecutionPromises.get(W);if(!H)throw new Error("Unexpected: The specified task is missing an execution");return H}let $=this._taskExecutionPromises.get(W.id);if($)return $;const U=new Promise(async(H,G)=>{const ue=K||await g.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);ue?H(new u(this,W.id,ue)):G("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,U),U.then(H=>(this._taskExecutions.set(W.id,H),H),H=>Promise.reject(H))}checkDeprecation(W,K){W._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let $=this._notProvidedCustomExecutions.values(),U=$.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=$.next()}};O=Ue([He(0,n.IExtHostRpcService),He(1,h.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,k.ILogService),He(7,E.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let j=class extends O{constructor(W,K,$,U,H,G,ue,q){super(W,K,$,U,H,G,ue,q);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(W,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const $=g.from(K,W);if($===void 0)throw new Error("Task is not valid");if(m.is($.execution))await this.addCustomExecution($,K,!1);else throw new p.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution($),K);return this._proxy.$executeTask($).catch(H=>{throw new Error(H)}),U}provideTasksInternal(W,K,$,U){const H=[];if(U)for(let G of U){this.checkDeprecation(G,$),(!G.definition||!W[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const ue=g.from(G,$.extension);ue&&m.is(ue.execution)?(H.push(ue),K.push(this.addCustomExecution(ue,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:H,extension:$.extension}}async resolveTaskInternal(W){if(m.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,K,$){}};j=Ue([He(0,n.IExtHostRpcService),He(1,h.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,k.ILogService),He(7,E.IExtHostApiDeprecationService)],j),e.WorkerExtHostTask=j,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(be[216],Ee([0,1,13,51,27,77,20,11,17,24,9,10,2,110,133,84,45,92,215,39]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(S,T,g,b){this.configurationService=S,this.workspaceContextService=T,this.editorGroupsService=g,this.pathService=b}text(S,T,g={}){S=this.getContentPattern(S,g);const b=this.configurationService.getValue(),u=T&&T.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(T?.map(v.toWorkspaceFolder),g),type:2,contentPattern:S,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:b.search.usePCRE2||u||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(S,T){const g=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const b={...S,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(S,T)&&(b.isCaseSensitive=!0),this.isMultiline(S)&&(b.isMultiline=!0),b}file(S,T={}){return{...this.commonQuery(S,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(S,T){return S?(S=Array.isArray(S)?S.map(a):a(S),T?this.parseSearchPaths(S):{pattern:i(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],T={}){const g=this.handleIncludeExclude(T.includePattern,T.expandPatterns),b=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),u=S.length>1,F=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,T,b)):S.map(Q=>this.getFolderQueryForRoot(Q,T,b,u))).filter(Q=>!!Q),O={_reason:T._reason,folderQueries:F,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:b.pattern,includePattern:g.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const W=c.coalesce(c.flatten(this.editorGroupsService.groups.map($=>$.editors.map(U=>U.resource)))).filter($=>(0,o.pathIncludedInQuery)(O,$.fsPath)),K=this.commonQueryFromFileList(W);return{...O,...K}}const j=T.extraFileResources&&T.extraFileResources.filter(Q=>(0,o.pathIncludedInQuery)(O,Q.fsPath));return O.extraFileResources=j&&j.length?j:void 0,O}commonQueryFromFileList(S){const T=[],g=new R.ResourceMap,b={};let u=!1;return S.forEach(F=>{if(F.scheme===I.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(F)){const j=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:D.dirname(F.fsPath)});let Q=g.get(j);Q||(u=!0,Q={folder:j,includePattern:{}},T.push(Q),g.set(j,Q));const W=D.relative(j.fsPath,F.fsPath);(0,y.assertIsDefined)(Q.includePattern)[W.replace(/\\/g,"/")]=!0}else F.fsPath&&(u=!0,b[F.fsPath]=!0)}),{folderQueries:T,includePattern:b,usingSearchPaths:!0,excludePattern:u?void 0:{"**/*":!0}}}isCaseSensitive(S,T){if(T.isSmartCase){if(S.isRegExp){if(t.containsUppercaseCharacter(S.pattern,!0))return!0}else if(t.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,h.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const T=K=>D.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),b=(Array.isArray(S)?S:l(S)).map(K=>{const $=this.pathService.resolvedUserHome;return $?(0,A.untildify)(K,$.scheme===I.Schemas.file?$.fsPath:$.path):K}),u=M.groupBy(b,K=>T(K)?"searchPaths":"exprSegments"),F=(u.exprSegments||[]).map(K=>t.rtrim(K,"/")).map(K=>t.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),r(K))),O={},j=this.expandSearchPathPatterns(u.searchPaths||[]);j&&j.length&&(O.searchPaths=j);const Q=c.flatten(F),W=i(...Q);return W&&(O.pattern=W),O}getExcludesForFolder(S,T){return T.disregardExcludeSettings?void 0:(0,o.getExcludes)(S,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const T=c.flatten(S.map(b=>{let{pathPortion:u,globPortion:F}=C(b);F&&(F=w(F));const O=this.expandOneSearchPath(u);return c.flatten(O.map(j=>this.resolveOneSearchPathPattern(j,F)))})),g=new Map;return T.forEach(b=>{const u=b.searchPath.toString(),F=g.get(u);F?b.pattern&&(F.pattern=F.pattern||{},F.pattern[b.pattern]=!0):g.set(u,{searchPath:b.searchPath,pattern:b.pattern?i(b.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(S){if(D.isAbsolute(S)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==I.Schemas.file?[{searchPath:T[0].uri.with({path:S})}]:[{searchPath:n.URI.file(D.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=a(S),S.startsWith("../")||S===".."){const b=D.posix.resolve(T.path,S);return[{searchPath:T.with({path:b})}]}const g=w(S);return[{searchPath:T,pattern:g}]}else{if(S==="./"||S===".\\")return[];{const T=S.replace(/^\.[\/\\]/,""),b=this.workspaceContextService.getWorkspace().folders.map(u=>{const F=T.match(new RegExp(`^${t.escapeRegExpCharacters(u.name)}(?:/(.*)|$)`));return F?{match:F,folder:u}:null}).filter(y.isDefined);if(b.length)return b.map(u=>{const F=u.match[1];return{searchPath:u.folder.uri,pattern:F&&w(F)}});{const u=S.match(/\.[\/\\](.+)[\/\\]?/),F=u?u[1]:S,O=s.localize(0,null,F);throw new Error(O)}}}}resolveOneSearchPathPattern(S,T){const g=S.pattern&&T?`${S.pattern}/${T}`:S.pattern||T,b=[{searchPath:S.searchPath,pattern:g}];return g&&!g.endsWith("**")&&b.push({searchPath:S.searchPath,pattern:g+"/**"}),b}getFolderQueryForSearchPath(S,T,g){const b=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(S.searchPath),T,g,!1);return b?{...b,includePattern:S.pattern}:null}getFolderQueryForRoot(S,T,g,b){let u;const F=n.URI.isUri(S)?S:S.uri;if(g.searchPaths){const K=g.searchPaths.filter($=>(0,P.isEqual)($.searchPath,F))[0];if(K&&!K.pattern)return null;K&&(u=K.pattern)}const O=this.configurationService.getValue({resource:F}),Q={...this.getExcludesForFolder(O,T)||{},...u||{}},W=n.URI.isUri(S)?(0,P.basename)(S):S.name;return{folder:F,folderName:b?W:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!O.search.followSymlinks}}};p=Ue([He(0,d.IConfigurationService),He(1,v.IWorkspaceContextService),He(2,k.IEditorGroupsService),He(3,E.IPathService)],p),e.QueryBuilder=p;function C(m){const S=m.match(/[\*\{\}\(\)\[\]\?]/);if(S){const T=S.index,g=m.substr(0,T).match(/[/|\\][^/\\]*$/);if(g){let b=m.substr(0,g.index);return b.match(/[/\\]/)||(b+="/"),{pathPortion:b,globPortion:m.substr((g.index||0)+1)}}}return{pathPortion:m}}function i(...m){return m.length?m.reduce((S,T)=>(S[T]=!0,S),Object.create(null)):void 0}function l(m){return _.splitGlobAware(m,",").map(S=>S.trim()).filter(S=>!!S.length)}function r(m){return[`**/${m}/**`,`**/${m}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function a(m){return m.replace(/\\/g,"/")}function w(m){return a(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(m,S){m=c.distinct(m,b=>b.toString());const T=[],g=S.getWorkspace();return m&&m.forEach(b=>{let u;if(S.getWorkbenchState()===2)u=(0,P.relativePath)(g.folders[0].uri,b),u&&u!=="."&&(u="./"+u);else{const F=S.getWorkspaceFolder(b);if(F){const O=F.name;if(g.folders.filter(Q=>Q.name===O).length===1){const Q=(0,P.relativePath)(F.uri,b);Q===""?u=`./${F.name}`:u=`./${F.name}/${Q}`}else u=b.fsPath}}u&&T.push(u)}),T}e.resolveResourcesForSearchIncludes=f}),define(be[217],Ee([0,1,24,2,21,16,4,216,39,45]),function(ie,e,c,M,_,A,R,I,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function y(d,v){const k=v.activationEvents;if(!k)return Promise.resolve(void 0);const E=[],o=[];for(const a of k)if(/^workspaceContains:/.test(a)){const w=a.substr("workspaceContains:".length);w.indexOf("*")>=0||w.indexOf("?")>=0||d.forceUsingSearch?o.push(w):E.push(w)}if(E.length===0&&o.length===0)return Promise.resolve(void 0);let p;const C=new Promise((a,w)=>{p=a}),i=a=>p({activationEvent:a}),l=Promise.all(E.map(a=>n(d,a,i))).then(()=>{}),r=h(d,v.identifier,o,i);return Promise.all([l,r]).then(()=>{p(void 0)}),C}e.checkActivateWorkspaceContainsExtension=y;async function n(d,v,k){for(const E of d.folders)if(await d.exists(c.joinPath(M.URI.revive(E),v))){k(`workspaceContains:${v}`);return}}async function h(d,v,k,E){if(k.length===0)return Promise.resolve(void 0);const o=new _.CancellationTokenSource,p=d.checkExists(d.folders,k,o.token),C=setTimeout(async()=>{o.cancel(),E(`workspaceContainsTimeout:${k.join(",")}`)},t);let i=!1;try{i=await p}catch(l){A.isPromiseCanceledError(l)||A.onUnexpectedError(l)}o.dispose(),clearTimeout(C),i&&E(`workspaceContains:${k.join(",")}`)}function s(d,v,k,E){const o=d.get(R.IInstantiationService),p=d.get(D.ISearchService),i=o.createInstance(I.QueryBuilder).file(v.map(l=>(0,P.toWorkspaceFolder)(M.URI.revive(l))),{_reason:"checkExists",includePattern:k,exists:!0});return p.fileSearch(i,E).then(l=>!!l.limitHit,l=>A.isPromiseCanceledError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=s});var Je=this&&this.__classPrivateFieldSet||function(ie,e,c,M,_){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!_:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?_.call(ie,c):_?_.value=c:e.set(ie,c),c},Te=this&&this.__classPrivateFieldGet||function(ie,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!M:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(ie):M?M.value:e.get(ie)};define(be[33],Ee([0,1,124,17,74,24,14,6,20,2,15,5,32,178,72,31,30,176,16,25,23,152,7,85,4,29,73,12,61,64,38,3,217,69,154]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E,o,p,C,i,l,r,a,w,f,m,S,T,g,b,u,F){"use strict";var O,j,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let W=class Wi extends I.Disposable{constructor(H,G,ue,q,le,se,ve,Fe,Me,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=ue,this._initData=ve,this._extHostWorkspace=q,this._extHostConfiguration=le,this._logService=se,this._extHostTunnelService=Me,this._extHostTerminalService=Ne,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new k.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new u.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=H.createChild(new m.ServiceCollection([s.IExtHostStorage,this._storage],[u.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(ze=>Qe.add(o.ExtensionIdentifier.toKey(ze))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,qe,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,E.transformErrorForSerialization(qe),x)},actualActivateExtension:async(ze,qe)=>{if(Qe.has(o.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,qe),new h.HostExtension;const x=this._registry.getExtensionDescription(ze);return this._activateExtension(x,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(H){E.onUnexpectedError(H)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let H=[];try{H=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(G){}await Promise.all(H)}isActivated(H){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(H):!1}_activateByEvent(H,G){return this._activator.activateByEvent(H,G)}_activateById(H,G){return this._activator.activateById(H,G)}activateByIdWithErrors(H,G){return this._activateById(H,G).then(()=>{const ue=this._activator.getActivatedExtension(H);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(H=>this._registry)}getExtensionExports(H){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(H).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const H=D.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(ue=>{if(!!this._getEntryPoint(ue))return this._hostUtils.realpath(ue.extensionLocation.fsPath).then(q=>H.set(P.URI.file(q).fsPath,ue))});this._extensionPathIndex=Promise.all(G).then(()=>H)}return this._extensionPathIndex}_deactivate(H){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(H))return G;const ue=this._activator.getActivatedExtension(H);if(!ue)return G;try{typeof ue.module.deactivate=="function"&&(G=Promise.resolve(ue.module.deactivate()).then(void 0,q=>(this._logService.error(q),Promise.resolve(void 0))))}catch(q){this._logService.error(q)}try{(0,I.dispose)(ue.subscriptions)}catch(q){this._logService.error(q)}return G}async _activateExtension(H,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(H.identifier),this._doActivateExtension(H,G).then(ue=>{const q=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(H.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,G),this._logExtensionActivationTimes(H,G,"success",q),ue},ue=>{throw this._logExtensionActivationTimes(H,G,"failure"),ue})}_logExtensionActivationTimes(H,G,ue,q){const le=K(H,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...q||{},outcome:ue})}_doActivateExtension(H,G){const ue=K(H,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const q=this._getEntryPoint(H);if(!q)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${H.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const le=new h.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(H.identifier,(0,A.joinPath)(H.extensionLocation,q),le),this._loadExtensionContext(H)]).then(se=>(_.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),Wi._callActivate(this._logService,H.identifier,se[0],se[1],le))).then(se=>(_.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),se))}_loadExtensionContext(H){const G=new C.ExtensionGlobalMemento(H,this._storage),ue=new C.ExtensionMemento(H.identifier.value,!1,this._storage),q=new F.ExtensionSecrets(H,this._secretState),le=H.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,se=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([G.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Fe;return Object.freeze({globalState:G,workspaceState:ue,secrets:q,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(Me){return M.join(H.extensionLocation.fsPath,Me)},get storagePath(){return ve._storagePath.workspaceValue(H)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(H).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,H.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,H.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(H)},get globalStorageUri(){return ve._storagePath.globalValue(H)},get extensionMode(){return le},get extension(){return Fe===void 0&&(Fe=new $(ve,H.identifier,H,se)),Fe},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(H),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(H)}})})}static _callActivate(H,G,ue,q,le){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(H,G,ue,q,le).then(se=>new h.ActivatedExtension(!1,null,le.build(),ue,se,q.subscriptions))}static _callActivateOptional(H,G,ue,q,le){if(typeof ue.activate=="function")try{le.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${G.value}`);const se=typeof global=="object"?global:self,ve=ue.activate.apply(se,[q]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(Fe=>(le.activateResolveStop(),Fe))}catch(se){return Promise.reject(se)}else return Promise.resolve(ue)}_activateOneStartupFinished(H,G){this._activateById(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:G}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const H of this._registry.getAllExtensionDescriptions())if(H.activationEvents)for(const G of H.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(H,G)}_handleEagerExtensions(){const H=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(G),q=Promise.all([H,ue]).then(()=>{});return Promise.race([q,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(H){return H.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(H,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(H,G){if(this.isActivated(G.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:H.map(se=>se.uri),forceUsingSearch:ue,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,ve,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(se,ve,Fe)},le=await(0,b.checkActivateWorkspaceContainsExtension)(q,G);if(!!le)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:le.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(H){throw console.error(H),H}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:G}=this._initData.environment;if(!H||!G)throw new Error(c.localize(0,null));const ue=await this._loadCommonJSModule(null,G,new h.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(c.localize(1,null,G.toString()));return new Promise((q,le)=>{const se=(Me,Ne)=>{Me?le(Me):q(typeof Ne=="number"&&Ne>0?1:0)},ve=(0,A.originalFSPath)(G),Fe=ue.run(ve,se);Fe&&Fe.then&&Fe.then(()=>{q(0)}).catch(Me=>{le(Me.toString())})})}async $extensionTestsExit(H){this._logService.info(`extension host terminating: test runner requested exit with code ${H}`),this._logService.info(`exiting with code ${H}`),this._logService.flush(),this._hostUtils.exit(H)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(H,G){return this._resolvers[H]=G,(0,I.toDisposable)(()=>{delete this._resolvers[H]})}async _activateAndGetResolver(H){const G=H.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const ue=H.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(H,G){const{authorityPrefix:ue,resolver:q}=await this._activateAndGetResolver(H);if(!q)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(q)),_.mark(`code/extHost/willResolveAuthority/${ue}`);const le=await q.resolve(H,{resolveAttempt:G});_.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const se={authority:H,host:le.host,port:le.port,connectionToken:le.connectionToken},ve={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:se,options:ve,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(_.mark(`code/extHost/didResolveAuthorityError/${ue}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(H,G){const{authorityPrefix:ue,resolver:q}=await this._activateAndGetResolver(H);if(!q)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ue}`);const le=P.URI.revive(G);if(typeof q.getCanonicalURI=="undefined")return le;const se=await(0,R.asPromise)(()=>q.getCanonicalURI(le));return se||le}$startExtensionHost(H){return this._registry.keepOnly(H),this._startExtensionHost()}$activateByEvent(H,G){return G===1?this._activateByEvent(H,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(H,!1))}async $activate(H,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(H)?(await this._activateById(H,G),!0):!1}async $deltaExtensions(H,G){H.forEach(q=>q.extensionLocation=P.URI.revive(q.extensionLocation));const ue=await this.getExtensionPathIndex();return await Promise.all(G.map(async q=>{const le=this._registry.getExtensionDescription(q);if(!le)return;const se=await this._hostUtils.realpath(le.extensionLocation.fsPath);ue.delete(P.URI.file(se).fsPath)})),await Promise.all(H.map(async q=>{const le=await this._hostUtils.realpath(q.extensionLocation.fsPath);ue.set(P.URI.file(le).fsPath,q)})),this._registry.deltaExtensions(H,G),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){let G=p.VSBuffer.alloc(H),ue=Math.random()%256;for(let q=0;q<H;q++)G.writeUInt8(ue,q);return G}async $updateRemoteConnectionData(H){this._remoteConnectionData=H,this._onDidChangeRemoteConnectionData.fire()}};W=Ue([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,f.IExtHostRpcService),He(3,d.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,t.ILogService),He(6,a.IExtHostInitDataService),He(7,w.IExtensionStoragePaths),He(8,S.IExtHostTunnelService),He(9,T.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function K(U,H){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ${constructor(H,G,ue,q){O.set(this,void 0),j.set(this,void 0),Q.set(this,void 0),Je(this,O,H,"f"),Je(this,j,G,"f"),Je(this,Q,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=q}get isActive(){return Te(this,O,"f").isActivated(Te(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,O,"f").getExtensionExports(Te(this,Q,"f"))}activate(){return Te(this,O,"f").activateByIdWithErrors(Te(this,Q,"f"),{startup:!1,extensionId:Te(this,j,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,O=new WeakMap,j=new WeakMap,Q=new WeakMap}),define(be[100],Ee([0,1,17,2,3,14,5,7,162,31,33,49,167,32,163,12,4,10,91,68]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let p=class{constructor(m,S,T,g,b,u){this._workspaceService=S,this._extensionService=T,this._editorsService=g,this._configurationService=b,this._editorTabs=u,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=m.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(O=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,S){const T=m;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let g=`debug:${encodeURIComponent(T.path||"")}`,b="?";return S&&(g+=`${b}session=${encodeURIComponent(S.id)}`,b="&"),g+=`${b}ref=${T.sourceReference}`,M.URI.parse(g)}else{if(T.path)return M.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const S=[];for(const T of m.getAllExtensionDescriptions())if(T.contributes){const g=T.contributes.debuggers;if(g&&g.length>0)for(const b of g)(0,s.isDebuggerMainContribution)(b)&&S.push(b.type)}this._debugServiceProxy.$registerDebugTypes(S)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(S=>m.push(S)),m}addBreakpoints(m){this.startBreakpoints();const S=m.filter(b=>{const u=b.id;return this._breakpoints.has(u)?!1:(this._breakpoints.set(u,b),!0)});this.fireBreakpointChanges(S,[],[]);const T=[],g=new Map;for(const b of S)if(b instanceof I.SourceBreakpoint){let u=g.get(b.location.uri.toString());u||(u={type:"sourceMulti",uri:b.location.uri,lines:[]},g.set(b.location.uri.toString(),u),T.push(u)),u.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof I.FunctionBreakpoint&&T.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(m){this.startBreakpoints();const S=m.filter(u=>this._breakpoints.delete(u.id));this.fireBreakpointChanges([],S,[]);const T=S.filter(u=>u instanceof I.SourceBreakpoint).map(u=>u.id),g=S.filter(u=>u instanceof I.FunctionBreakpoint).map(u=>u.id),b=S.filter(u=>u instanceof I.DataBreakpoint).map(u=>u.id);return this._debugServiceProxy.$unregisterBreakpoints(T,g,b)}startDebugging(m,S,T){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,S,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI,suppressSaveBeforeStart:T.suppressSaveBeforeStart})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,S,T){if(!S)return new I.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:g,provider:S}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,T,!!S.provideDebugConfigurations,!!S.resolveDebugConfiguration,!!S.resolveDebugConfigurationWithSubstitutedVariables,g),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==S),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(m,S,T){if(!T)return new I.Disposable(()=>{});if(!this.definesDebugType(m,S))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${S}' debugger.`);if(this.getAdapterDescriptorFactoryByType(S))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:S,handle:g,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(S,g),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(m,S){if(!S)return new I.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:T,factory:S}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==S)})}async $runInTerminal(m,S){return Promise.resolve(void 0)}async $substituteVariables(m,S){if(!this._variableResolver){const[b,u]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,u)}let T;const g=await this.getFolder(m);return g&&(T={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,S)}createDebugAdapter(m,S){if(m.type==="implementation")return new a(m.implementation)}createSignService(){}async $startDASession(m,S){const T=this,g=await this.getSession(S);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const u=this.convertToDto(b),F=this.createDebugAdapter(u,g);if(!F)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const O=F;return this._debugAdapters.set(m,O),this.getDebugAdapterTrackers(g).then(j=>(j&&this._debugAdaptersTrackers.set(m,j),O.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const W=Q,K={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(W.arguments.value);K.body={signature:$},O.sendResponse(K)}else throw new Error("no signer")}catch($){K.success=!1,K.message=$.message,O.sendResponse(K)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(Q),Q=(0,s.convertToVSCPaths)(Q,!0),T._debugServiceProxy.$acceptDAMessage(m,Q)}),O.onError(Q=>{j&&j.onError&&j.onError(Q),this._debugServiceProxy.$acceptDAError(m,Q.name,Q.message,Q.stack)}),O.onExit(Q=>{j&&j.onExit&&j.onExit((0,k.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,k.withNullAsUndefined)(Q),void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),O.startSession()))})}$sendDAMessage(m,S){S=(0,s.convertToDAPaths)(S,!1);const T=this._debugAdaptersTrackers.get(m);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(S);const g=this._debugAdapters.get(m);g&&g.sendMessage(S)}$stopDASession(m){const S=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),S&&S.onWillStopSession&&S.onWillStopSession();const T=this._debugAdapters.get(m);return this._debugAdapters.delete(m),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const S=[],T=[],g=[];if(m.added)for(const b of m.added){const u=b.id;if(u&&!this._breakpoints.has(u)){let F;if(b.type==="function")F=new I.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")F=new I.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const O=M.URI.revive(b.uri);F=new I.SourceBreakpoint(new I.Location(O,new I.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}F._id=u,this._breakpoints.set(u,F),S.push(F)}}if(m.removed)for(const b of m.removed){const u=this._breakpoints.get(b);u&&(this._breakpoints.delete(b),T.push(u))}if(m.changed){for(const b of m.changed)if(b.id){const u=this._breakpoints.get(b.id);if(u){if(u instanceof I.FunctionBreakpoint&&b.type==="function"){const F=u;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.functionName=b.functionName}else if(u instanceof I.SourceBreakpoint&&b.type==="source"){const F=u;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.location=new I.Location(M.URI.revive(b.uri),new I.Position(b.line,b.character))}g.push(u)}}}this.fireBreakpointChanges(S,T,g)}$provideDebugConfigurations(m,S,T){return(0,A.asPromise)(async()=>{const g=this.getConfigProviderByHandle(m);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(S);return g.provideDebugConfigurations(b,T)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(m,S,T,g){return(0,A.asPromise)(async()=>{const b=this.getConfigProviderByHandle(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.getFolder(S);return b.resolveDebugConfiguration(u,T,g)})}$resolveDebugConfigurationWithSubstitutedVariables(m,S,T,g){return(0,A.asPromise)(async()=>{const b=this.getConfigProviderByHandle(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.getFolder(S);return b.resolveDebugConfigurationWithSubstitutedVariables(u,T,g)})}async $provideDebugAdapter(m,S){const T=this.getAdapterDescriptorFactoryByHandle(m);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(S);return this.getAdapterDescriptor(T,g).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(m){const S=await this.getSession(m);this._onDidStartDebugSession.fire(S)}async $acceptDebugSessionTerminated(m){const S=await this.getSession(m);S&&(this._onDidTerminateDebugSession.fire(S),this._debugSessions.delete(S.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,S){const T=await this.getSession(m);T&&T._acceptNameChanged(S)}async $acceptDebugSessionCustomEvent(m,S){const g={session:await this.getSession(m),event:S.event,body:S.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const S=this._adapterFactories.filter(T=>T.type===m);if(S.length>0)return S[0].factory}getAdapterDescriptorFactoryByHandle(m){const S=this._adapterFactories.filter(T=>T.handle===m);if(S.length>0)return S[0].factory}getConfigProviderByHandle(m){const S=this._configProviders.filter(T=>T.handle===m);if(S.length>0)return S[0].provider}definesDebugType(m,S){if(m.contributes){const T=m.contributes.debuggers;if(T&&T.length>0){for(const g of T)if(g.label&&g.type&&g.type===S)return!0}}return!1}getDebugAdapterTrackers(m){const T=m.configuration.type,g=this._trackerFactories.filter(b=>b.type===T||b.type==="*").map(b=>(0,A.asPromise)(()=>b.factory.createDebugAdapterTracker(m)).then(u=>u,u=>null));return Promise.race([Promise.all(g).then(b=>{const u=b.filter(F=>!!F);if(u.length>0)return new r(u)}),new Promise((b,u)=>{const F=setTimeout(()=>{clearTimeout(F),u(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(m,S){const T=S.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new I.DebugAdapterServer(T));if(m){const b=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>m.createDebugAdapterDescriptor(S,this.daExecutableFromPackage(S,b))).then(u=>{if(u)return u})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(S,g))}daExecutableFromPackage(m,S){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,S,T){(m.length>0||S.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:S,changed:T}))}async getSession(m){if(m)if(typeof m=="string"){const S=this._debugSessions.get(m);if(S)return S}else{let S=this._debugSessions.get(m.id);if(!S){const T=await this.getFolder(m.folderUri),g=m.parent?this._debugSessions.get(m.parent):void 0;S=new C(this._debugServiceProxy,m.id,m.type,m.name,T,m.configuration,g),this._debugSessions.set(S.id,S),this._debugServiceProxy.$sessionCached(S.id)}return S}throw new Error("cannot find session")}getFolder(m){if(m){const S=M.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(S)}return Promise.resolve(void 0)}};p=Ue([He(0,d.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,h.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class C{constructor(m,S,T,g,b,u,F){this._debugServiceProxy=m,this._id=S,this._type=T,this._name=g,this._workspaceFolder=b,this._configuration=u,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,S){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,S)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=C;class i{constructor(m){this.value=Object.freeze({append(S){m.$appendDebugConsole(S)},appendLine(S){this.append(S+`
`)}})}}e.ExtHostDebugConsole=i;class l extends n.AbstractVariableResolverService{constructor(m,S,T,g,b){function u(){if(S){const F=S.activeEditor();if(F)return F.document.uri;const O=g.tabs.filter(j=>j.isActive);if(O.length>0){const j=O[0].resource;return j&&(j.primary||j.secondary)?j.primary??j.secondary:O[0].resource}}}super({getFolderUri:F=>{const O=m.filter(j=>j.name===F);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(F,O)=>T.getConfiguration(void 0,F).get(O),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=u();if(F)return c.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const F=u();if(F){const O=b.getWorkspaceFolder(F);if(O)return c.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(S){const F=S.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(S){const F=S.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=l;class r{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(S=>S.onWillReceiveMessage?S.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(S=>S.onDidSendMessage?S.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(S=>S.onError?S.onError(m):void 0)}onExit(m,S){this.trackers.forEach(T=>T.onExit?T.onExit(m,S):void 0)}}class a extends D.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(S=>{this.acceptMessage(S)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let w=class extends p{constructor(m,S,T,g,b,u){super(m,S,T,g,b,u)}createVariableResolver(m,S,T){return new l(m,S,T,this._editorTabs)}};w=Ue([He(0,d.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,h.IExtHostConfiguration),He(5,o.IExtHostEditorTabs)],w),e.WorkerExtHostDebugService=w}),define(be[218],Ee([0,1,74,2,5,32,30,25,12,29,4,33,91,15]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(o,p,C,i,l,r,a){this._apiFactory=o,this._extensionRegistry=p,this._instaService=C,this._extHostConfiguration=i,this._extHostExtensionService=l,this._initData=r,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const p=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,p,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(k,p,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let p of o.nodeModuleName)this._factories.set(p,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(p=>o.alternativeModuleName(p))}};s=Ue([He(2,t.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,y.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,h.ILogService)],s),e.RequireInterceptor=s;class d{constructor(o,p,C,i,l){this._apiFactory=o,this._extensionPaths=p,this._extensionRegistry=C,this._configProvider=i,this._logService=l,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,p){const C=this._extensionPaths.findSubstr(p.fsPath);if(C){let i=this._extApiImpl.get(I.ExtensionIdentifier.toKey(C.identifier));return i||(i=this._apiFactory(C,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(C.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((l,r)=>i+=`	${r} -> ${l.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${p.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(o,p){this.nodeModuleName="keytar";const{environment:C}=p,i=o.getProxy(_.MainContext.MainThreadKeytar);if(C.appRoot){let l=C.appRoot.fsPath;n.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${l}/node_modules.asar/keytar`),this.alternativeNames.add(`${l}/node_modules/keytar`)}this._impl={getPassword:(l,r)=>i.$getPassword(l,r),setPassword:(l,r,a)=>i.$setPassword(l,r,a),deletePassword:(l,r)=>i.$deletePassword(l,r),findPassword:l=>i.$findPassword(l),findCredentials(l){return i.$findCredentials(l)}}}load(o,p){return this._impl}alternativeModuleName(o){const p=o.length;if(p<=7||!this.alternativeNames)return;const C=p-7;if((o.charAt(C)==="/"||o.charAt(C)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};v=Ue([He(0,D.IExtHostRpcService),He(1,P.IExtHostInitDataService)],v);let k=class{constructor(o,p,C){this._extensionPaths=o,this._appUriScheme=p,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=C.getProxy(_.MainContext.MainThreadTelemetry);const i=C.getProxy(_.MainContext.MainThreadWindow);this._impl=(l,r)=>{const a=M.URI.parse(l);return r?this.callOriginal(l,r):a.scheme==="http"||a.scheme==="https"?i.$openUri(a,l,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?i.$openUri(a,l,{}):this.callOriginal(l,r)}}load(o,p,C){const i=this._extensionPaths.findSubstr(p.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=C(o),this._impl}callOriginal(o,p){return this.sendNoForwardTelemetry(),this._original(o,p)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};k=Ue([He(2,D.IExtHostRpcService)],k)}),define(be[219],Ee([0,1,14,16,74,6,2,5,212,15,57,61,29,143,12,65,33,38]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(p,C,i,l){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new D.RPCProtocol(p,null,l),C=E._transform(C,this._rpcProtocol);const r=new y.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...C}),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),r.set(d.IURITransformerService,new d.URITransformerService(l)),r.set(v.IHostUtils,i);const a=new h.InstantiationService(r,!0),w=a.invokeFunction(T=>T.get(k.IExtHostTerminalService));this._disposables.add(w),this._logService=a.invokeFunction(T=>T.get(P.ILogService)),_.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",C),this._extensionService=a.invokeFunction(T=>T.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(g,b)=>{let u="",F,O;for(const j of b)u+=`
	at ${j.toString()}`,O=j.getFileName(),!F&&O&&(F=T.findSubstr(O));return f.set(g,F),`${g.name||"Error"}: ${g.message||""}${u}`}});const m=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),S=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(T=>{const g=M.transformErrorForSerialization(T),b=f.get(T);b?m.$onExtensionRuntimeError(b.identifier,g):S.$onUnexpectedError(g)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const C=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,c.timeout)(4e3),C]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(p,C){p.extensions.forEach(l=>l.extensionLocation=R.URI.revive(C.transformIncomingURIs(l.extensionLocation))),p.environment.appRoot=R.URI.revive(C.transformIncomingURIs(p.environment.appRoot));const i=p.environment.extensionDevelopmentLocationURI;return i&&(p.environment.extensionDevelopmentLocationURI=i.map(l=>R.URI.revive(C.transformIncomingURIs(l)))),p.environment.extensionTestsLocationURI=R.URI.revive(C.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=R.URI.revive(C.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=R.URI.revive(C.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=R.URI.revive(C.transformIncomingURIs(p.logsLocation)),p.logFile=R.URI.revive(C.transformIncomingURIs(p.logFile)),p.workspace=C.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=E}),define(be[220],Ee([0,1,17,21,56,27,24,193,39]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,h,s){this.config=n,this.provider=h,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const h=this.config.folderQueries||[];return new Promise((s,d)=>{const v=k=>{this.resultCount++,n(k)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(k=>{const E=k.toString(),o=c.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,o)||this.matchFile(v,{base:k,basename:o})}),Promise.all(h.map(k=>this.searchInFolder(k,v))).then(k=>{s({limitHit:this.isLimitHit,stats:k[0]||void 0})},k=>{d(new Error((0,_.toErrorMessage)(k)))})})}async searchInFolder(n,h){const s=new M.CancellationTokenSource,d=this.getSearchOptionsForFolder(n),v=this.initDirectoryTree(),k=new D.QueryGlobTester(this.config,n),E=!k.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(s),o=I.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,s.token),C=o.elapsed(),i=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(l=>{const r=c.posix.relative(n.folder.path,l.path);if(E){const a=c.basename(l.path);this.matchFile(h,{base:n.folder,relativePath:r,basename:a});return}this.addDirectoryEntries(v,n.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,k,h),{providerTime:C,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,D.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:h,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},h,s,d){if(s===this.filePattern){const k=c.basename(this.filePattern);this.matchFile(d,{base:h,relativePath:this.filePattern,basename:k})}function v(k){const E=c.basename(k),o=c.dirname(k);let p=n[o];p||(p=n[o]=[],v(o)),p.push({base:h,relativePath:k,basename:E})}v(s)}matchDirectoryTree({rootEntries:n,pathToEntries:h},s,d){const v=this,k=this.filePattern;function E(o){const p=A.hasSiblingFn(()=>o.map(C=>C.basename));for(let C=0,i=o.length;C<i;C++){const l=o[C],{relativePath:r,basename:a}=l;if(!s.includedInQuerySync(r,a,k!==a?p:void 0))continue;const w=h[r];if(w)E(w);else{if(r===k)continue;v.matchFile(d,l)}if(v.isLimitHit)break}}E(n)}matchFile(n,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(h))}}class t{constructor(){this.sessions=new Map}fileSearch(n,h,s,d){const v=this.getSessionTokenSource(n.cacheKey),k=new P(n,h,v&&v.token);let E=0;const o=p=>{E+=p.length,s(p.map(C=>this.rawMatchToSearchItem(C)))};return this.doSearch(k,t.BATCH_SIZE,o,d).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:p.stats}}))}clearCache(n){const h=this.getSessionTokenSource(n);h&&h.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:R.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,h,s,d){d.onCancellationRequested(()=>{n.cancel()});const v=E=>{E&&(k.push(E),h>0&&k.length>=h&&(s(k),k=[]))};let k=[];return n.search(v).then(E=>(k.length&&s(k),E),E=>(k.length&&s(k),Promise.reject(E)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[221],Ee([0,1,13,21,56,27,11,17,24,10,2,39]),function(ie,e,c,M,_,A,R,I,D,P,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,p,C,i){this.query=o,this.provider=p,this.fileUtils=C,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,p){const C=this.query.folderQueries||[],i=new M.CancellationTokenSource;return p.onCancellationRequested(()=>i.cancel()),new Promise((l,r)=>{this.collector=new s(o);let a=!1;const w=(f,m)=>{if(!a&&!this.isLimitHit){const S=this.resultSize(f);v(f)&&typeof this.query.maxResults=="number"&&this.resultCount+S>this.query.maxResults&&(this.isLimitHit=!0,a=!0,i.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const T=this.resultSize(f);this.resultCount+=T,(T>0||!v(f))&&this.collector.add(f,m)}};Promise.all(C.map((f,m)=>this.searchInFolder(f,S=>w(S,m),i.token))).then(f=>{i.dispose(),this.collector.flush();const m=f.some(S=>!!S&&!!S.limitHit);l({limitHit:this.isLimitHit||m,messages:(0,c.flatten)(f.map(S=>S?.message?(0,P.isArray)(S.message)?S.message:[S.message]:[])),stats:{type:this.processType}})},f=>{i.dispose();const m=(0,_.toErrorMessage)(f);r(new Error(m))})})}resultSize(o){return v(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,p){const C=Array.isArray(o.ranges)?o.ranges:[o.ranges],i=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:C.slice(0,p),preview:{matches:i.slice(0,p),text:o.preview.text},uri:o.uri}}async searchInFolder(o,p,C){const i=new y.QueryGlobTester(this.query,o),l=[],r={report:f=>{if(!this.validateProviderResult(f))return;const m=o.folder.scheme===R.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(f.uri))):void 0,S=D.relativePath(o.folder,f.uri);if(S){const T=i.includedInQuery(S,I.basename(S),m);(0,P.isPromise)(T)?l.push(T.then(g=>{g&&p(f)})):T&&p(f)}}},a=this.getSearchOptionsForFolder(o),w=await this.provider.provideTextSearchResults(h(this.query.contentPattern),a,r,C);return l.length&&await Promise.all(l),w}validateProviderResult(o){if(v(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const p=(0,y.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),C=(0,y.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),i={folder:t.URI.from(o.folder),excludes:C,includes:p,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function h(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class s{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,p=>this.sendItems(p))}add(o,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!D.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(d(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=s;function d(E){return v(E)?{preview:{matches:(0,c.mapArrayOrNot)(E.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:E.preview.text},ranges:(0,c.mapArrayOrNot)(E.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function v(E){return!!E.preview}e.extensionResultIsMatch=v;class k{constructor(o,p){this.maxBatchSize=o,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,p){!o||this.addItemToBatch(o,p)}addItems(o,p){!o||this.addItemsToBatch(o,p)}addItemToBatch(o,p){this.batch.push(o),this.batchSize+=p,this.onUpdate()}addItemsToBatch(o,p){this.batch=this.batch.concat(o),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,220,12,65,15,2,221]),function(ie,e,c,M,_,A,R,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let y=class{constructor(d,v,k){this.extHostRpc=d,this._uriTransformer=v,this._logService=k,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,v){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const k=this._handlePool++;return this._textSearchProvider.set(k,v),this._proxy.$registerTextSearchProvider(k,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}registerFileSearchProvider(d,v){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const k=this._handlePool++;return this._fileSearchProvider.set(k,v),this._proxy.$registerFileSearchProvider(k,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}$provideFileSearchResults(d,v,k,E){const o=n(k),p=this._fileSearchProvider.get(d);if(p)return this._fileSearchManager.fileSearch(o,p,C=>{this._proxy.$handleFileMatch(d,v,C.map(i=>i.resource))},E);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,v,k,E){const o=this._textSearchProvider.get(d);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const p=n(k);return this.createTextSearchManager(p,o).search(i=>this._proxy.$handleTextMatch(d,v,i),E)}$enableExtensionHostSearch(){}createTextSearchManager(d,v){return new t.TextSearchManager(d,v,{readdir:k=>Promise.resolve([]),toCanonicalName:k=>k},"textSearchProvider")}};y=Ue([He(0,R.IExtHostRpcService),He(1,I.IURITransformerService),He(2,D.ILogService)],y),e.ExtHostSearch=y;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(h),extraFileResources:s.extraFileResources&&s.extraFileResources.map(d=>P.URI.revive(d))}}e.reviveQuery=n;function h(s){return{...s,folder:P.URI.revive(s.folder)}}}),define(be[222],Ee([0,1,21,16,3,35,2,116,79,112,55,60,5,183,182,48,184,32,185,186,187,169,188,49,33,189,170,192,194,195,96,172,200,201,202,72,38,204,173,8,7,207,50,97,31,30,51,159,191,86,95,99,100,101,15,65,12,29,196,156,64,70,180,205,155,73,71,210,208,209,181,37,203,206,69,68,87,198,98,199,11,145,197,153,190]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E,o,p,C,i,l,r,a,w,f,m,S,T,g,b,u,F,O,j,Q,W,K,$,U,H,G,ue,q,le,se,ve,Fe,Me,Ne,Qe,ze,qe,x,Y,ee,ae,V,oe,fe,Ae,xe,$e,we,Ze,z,J,he,Oe,Ve,tt,ut,ht,St,Pt,dt,bt,ft,Et,Ye,Ct,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(Z){const ce=Z.get(ee.IExtHostInitDataService),ge=Z.get(Ve.IExtHostFileSystemInfo),me=Z.get(Ze.IExtHostConsumerFileSystem),Ie=Z.get(r.IExtHostExtensionService),Be=Z.get(ue.IExtHostWorkspace),Le=Z.get(Pt.IExtHostTelemetry),je=Z.get(k.IExtHostConfiguration),Xe=Z.get(x.IURITransformerService),ne=Z.get(Y.IExtHostRpcService),pe=Z.get(O.IExtHostStorage),re=Z.get(we.IExtensionStoragePaths),B=Z.get(qe.ILogService),Ce=Z.get(oe.IExtHostTunnelService),Se=Z.get(fe.IExtHostApiDeprecationService),Ge=Z.get(G.IExtHostWindow),We=Z.get(ht.IExtHostSecretState),it=Z.get(St.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ne.set(n.ExtHostContext.ExtHostLogService,B),ne.set(n.ExtHostContext.ExtHostWorkspace,Be),ne.set(n.ExtHostContext.ExtHostConfiguration,je),ne.set(n.ExtHostContext.ExtHostExtensionService,Ie),ne.set(n.ExtHostContext.ExtHostStorage,pe),ne.set(n.ExtHostContext.ExtHostTunnelService,Ce),ne.set(n.ExtHostContext.ExtHostWindow,Ge),ne.set(n.ExtHostContext.ExtHostSecretState,We),ne.set(n.ExtHostContext.ExtHostTelemetry,Le),ne.set(n.ExtHostContext.ExtHostEditorTabs,it);const mt=ne.set(n.ExtHostContext.ExtHostDecorations,Z.get(Me.IExtHostDecorations)),vt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(l.IExtHostDocumentsAndEditors)),nt=ne.set(n.ExtHostContext.ExtHostCommands,Z.get(d.IExtHostCommands)),ot=ne.set(n.ExtHostContext.ExtHostTerminalService,Z.get(j.IExtHostTerminalService)),lt=ne.set(n.ExtHostContext.ExtHostDebugService,Z.get(Qe.IExtHostDebugService)),Rt=ne.set(n.ExtHostContext.ExtHostSearch,Z.get(ze.IExtHostSearch)),_t=ne.set(n.ExtHostContext.ExtHostTask,Z.get(Ne.IExtHostTask)),Ot=ne.set(n.ExtHostContext.ExtHostOutputService,Z.get(T.IExtHostOutputService)),di=ne.set(n.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(ne)),kt=ne.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ne,vt)),$t=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(ne,vt,B)),Zt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new C.ExtHostDocumentSaveParticipant(B,kt,ne.getProxy(n.MainContext.MainThreadBulkEdits))),gt=ne.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(ne,nt,vt,kt,re)),Kt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(B,gt)),Vt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Ct.ExtHostNotebookEditors(B,ne,gt)),ei=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new dt.ExtHostNotebookKernels(ne,ce,gt,B)),ti=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new ft.ExtHostNotebookRenderers(ne,gt)),It=ne.set(n.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(ne,vt)),Qt=ne.set(n.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),nt,B)),wi=ne.set(n.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),It,ce)),Wt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(ne,B,ge)),Ht=ne.set(n.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(ne,kt,nt.converter)),ct=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(ne,Xe,kt,nt,Wt,B,Se)),ii=ne.set(n.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(ne,ct)),Nt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new w.ExtHostFileSystemEventService(ne,B,vt)),xt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,b.createExtHostQuickOpen)(ne,Be,nt)),Yt=ne.set(n.ExtHostContext.ExtHostSCM,new u.ExtHostSCM(ne,nt,B)),bi=ne.set(n.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(ne,nt,kt)),hi=ne.set(n.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(ne)),fi=ne.set(n.ExtHostContext.ExtHostTheming,new V.ExtHostTheming(ne)),ni=ne.set(n.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(ne)),ri=ne.set(n.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(ne,nt)),jt=ne.set(n.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(ne,{remote:ce.remote},Be,B,Se)),si=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new he.ExtHostWebviewPanels(ne,jt,Be)),_i=ne.set(n.ExtHostContext.ExtHostCustomEditors,new J.ExtHostCustomEditors(ne,kt,re,jt,si)),yi=ne.set(n.ExtHostContext.ExtHostWebviewViews,new z.ExtHostWebviewViews(ne,jt)),qt=ne.set(n.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ne,nt)),Jt=ne.set(n.ExtHostContext.ExtHostUriOpeners,new ut.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ne,gt,vt,nt));const Si=(0,le.values)(n.ExtHostContext);ne.assertRegistered(Si);const Di=new Oe.ExtHostBulkEdits(ne,vt),oi=new s.ExtHostClipboard(ne),ai=new S.ExtHostMessageService(ne,B),zt=new o.ExtHostDialogs(ne),Mt=new F.ExtHostStatusBar(ne,nt.converter);return h.ExtHostApiCommands.register(nt),function(Re,Tt,Gt){const pt=function(){let X=!Re.isUnderDevelopment;function de(ke){X||(B.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")de(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&de(rt),!Re.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,q.throwProposedApiError)(Re)}return rt}}(),Ci={getSession(X,de,ke){return ke?.forceNewSession&&(0,q.checkProposedApiEnabled)(Re),ni.getSession(Re,X,de,ke)},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(X,de,ke,rt){return ni.registerAuthenticationProvider(X,de,ke,rt)}},ki={registerCommand(X,de,ke){return nt.registerCommand(!0,X,de,ke)},registerTextEditorCommand(X,de,ke){return nt.registerCommand(!0,X,(...rt)=>{const wt=It.getActiveTextEditor();if(!wt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}return wt.edit(Dt=>{de.apply(ke,[wt,Dt,...rt])}).then(Dt=>{Dt||B.warn("Edits from command "+X+" were not applied.")},Dt=>{B.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,de,ke)=>((0,q.checkProposedApiEnabled)(Re),nt.registerCommand(!0,X,async(...rt)=>{const wt=vt.activeEditor(!0);if(!wt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await It.getDiffInformation(wt.id);de.apply(ke,[Dt,...rt])})),executeCommand(X,...de){return nt.executeCommand(X,...de)},getCommands(X=!1){return nt.getCommands(X)}},mi={get machineId(){return ce.telemetryInfo.machineId},get sessionId(){return ce.telemetryInfo.sessionId},get language(){return ce.environment.appLanguage},get appName(){return ce.environment.appName},get appRoot(){return ce.environment.appRoot?.fsPath??""},get appHost(){return ce.environment.appHost},get uriScheme(){return ce.environment.appUriScheme},get clipboard(){return oi.value},get shell(){return ot.getDefaultShell(!1)},get isTelemetryEnabled(){return Le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(ce.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return Ge.openUri(X,{allowTunneling:!!ce.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===ce.environment.appUriScheme)return di.createAppUri(X);try{return await Ge.asExternalUri(X,{allowTunneling:!!ce.remote.authority})}catch(de){if((0,Ye.matchesScheme)(X,Et.Schemas.http)||(0,Ye.matchesScheme)(X,Et.Schemas.https))return X;throw de}},get remoteName(){return(0,Fe.getRemoteName)(ce.remote.authority)},get uiKind(){return ce.uiKind}};ce.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ce.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ii={createTestController(X,de){return qt.createTestController(X,de)},createTestObserver(){return(0,q.checkProposedApiEnabled)(Re),qt.createTestObserver()},runTests(X){return(0,q.checkProposedApiEnabled)(Re),qt.runTests(X)},get onDidChangeTestResults(){return(0,q.checkProposedApiEnabled)(Re),qt.onResultsChanged},get testResults(){return(0,q.checkProposedApiEnabled)(Re),qt.results}},Pi={getExtension(X){const de=Tt.getExtensionDescription(X);if(de)return new r.Extension(Ie,Re.identifier,de,gi)},get all(){return Tt.getAllExtensionDescriptions().map(X=>new r.Extension(Ie,Re.identifier,X,gi))},get onDidChange(){return Tt.onDidChange}},li={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(X,de){return Ht.changeLanguage(X.uri,de)},match(X,de){return(0,t.score)(K.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,ke){return ct.registerCodeActionProvider(Re,pt(X),de,ke)},registerCodeLensProvider(X,de){return ct.registerCodeLensProvider(Re,pt(X),de)},registerDefinitionProvider(X,de){return ct.registerDefinitionProvider(Re,pt(X),de)},registerDeclarationProvider(X,de){return ct.registerDeclarationProvider(Re,pt(X),de)},registerImplementationProvider(X,de){return ct.registerImplementationProvider(Re,pt(X),de)},registerTypeDefinitionProvider(X,de){return ct.registerTypeDefinitionProvider(Re,pt(X),de)},registerHoverProvider(X,de){return ct.registerHoverProvider(Re,pt(X),de,Re.identifier)},registerEvaluatableExpressionProvider(X,de){return ct.registerEvaluatableExpressionProvider(Re,pt(X),de,Re.identifier)},registerInlineValuesProvider(X,de){return ct.registerInlineValuesProvider(Re,pt(X),de,Re.identifier)},registerDocumentHighlightProvider(X,de){return ct.registerDocumentHighlightProvider(Re,pt(X),de)},registerLinkedEditingRangeProvider(X,de){return ct.registerLinkedEditingRangeProvider(Re,pt(X),de)},registerReferenceProvider(X,de){return ct.registerReferenceProvider(Re,pt(X),de)},registerRenameProvider(X,de){return ct.registerRenameProvider(Re,pt(X),de)},registerDocumentSymbolProvider(X,de,ke){return ct.registerDocumentSymbolProvider(Re,pt(X),de,ke)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,de){return ct.registerDocumentFormattingEditProvider(Re,pt(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return ct.registerDocumentRangeFormattingEditProvider(Re,pt(X),de)},registerOnTypeFormattingEditProvider(X,de,ke,...rt){return ct.registerOnTypeFormattingEditProvider(Re,pt(X),de,[ke].concat(rt))},registerDocumentSemanticTokensProvider(X,de,ke){return ct.registerDocumentSemanticTokensProvider(Re,pt(X),de,ke)},registerDocumentRangeSemanticTokensProvider(X,de,ke){return ct.registerDocumentRangeSemanticTokensProvider(Re,pt(X),de,ke)},registerSignatureHelpProvider(X,de,ke,...rt){return typeof ke=="object"?ct.registerSignatureHelpProvider(Re,pt(X),de,ke):ct.registerSignatureHelpProvider(Re,pt(X),de,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(X,de,...ke){return ct.registerCompletionItemProvider(Re,pt(X),de,ke)},registerInlineCompletionItemProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerInlineCompletionsProvider(Re,pt(X),de)},registerDocumentLinkProvider(X,de){return ct.registerDocumentLinkProvider(Re,pt(X),de)},registerColorProvider(X,de){return ct.registerColorProvider(Re,pt(X),de)},registerFoldingRangeProvider(X,de){return ct.registerFoldingRangeProvider(Re,pt(X),de)},registerSelectionRangeProvider(X,de){return ct.registerSelectionRangeProvider(Re,X,de)},registerCallHierarchyProvider(X,de){return ct.registerCallHierarchyProvider(Re,X,de)},setLanguageConfiguration:(X,de)=>ct.setLanguageConfiguration(Re,X,de),getTokenInformationAtPosition(X,de){return(0,q.checkProposedApiEnabled)(Re),Ht.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerInlayHintsProvider(Re,X,de)},registerTypeHierarchyProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),ct.registerTypeHierarchyProvider(Re,X,de)},createLanguageStatusItem(X,de){return(0,q.checkProposedApiEnabled)(Re),Ht.createLanguageStatusItem(Re,X,de)}},Ai={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return ot.activeTerminal},get terminals(){return ot.terminals},async showTextDocument(X,de,ke){const rt=await(R.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return It.showTextDocument(rt,de,ke)},createTextEditorDecorationType(X){return It.createTextEditorDecorationType(Re,X)},onDidChangeActiveTextEditor(X,de,ke){return It.onDidChangeActiveTextEditor(X,de,ke)},onDidChangeVisibleTextEditors(X,de,ke){return It.onDidChangeVisibleTextEditors(X,de,ke)},onDidChangeTextEditorSelection(X,de,ke){return It.onDidChangeTextEditorSelection(X,de,ke)},onDidChangeTextEditorOptions(X,de,ke){return It.onDidChangeTextEditorOptions(X,de,ke)},onDidChangeTextEditorVisibleRanges(X,de,ke){return It.onDidChangeTextEditorVisibleRanges(X,de,ke)},onDidChangeTextEditorViewColumn(X,de,ke){return It.onDidChangeTextEditorViewColumn(X,de,ke)},onDidCloseTerminal(X,de,ke){return ot.onDidCloseTerminal(X,de,ke)},onDidOpenTerminal(X,de,ke){return ot.onDidOpenTerminal(X,de,ke)},onDidChangeActiveTerminal(X,de,ke){return ot.onDidChangeActiveTerminal(X,de,ke)},onDidChangeTerminalDimensions(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidChangeTerminalDimensions(X,de,ke)},onDidChangeTerminalState(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidChangeTerminalState(X,de,ke)},onDidWriteTerminalData(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ot.onDidWriteTerminalData(X,de,ke)},get state(){return Ge.state},onDidChangeWindowState(X,de,ke){return Ge.onDidChangeWindowState(X,de,ke)},showInformationMessage(X,...de){return ai.showMessage(Re,A.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return ai.showMessage(Re,A.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return ai.showMessage(Re,A.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,ke){return xt.showQuickPick(X,!!Re.enableProposedApi,de,ke)},showWorkspaceFolderPick(X){return xt.showWorkspaceFolderPick(X)},showInputBox(X,de){return xt.showInput(X,de)},showOpenDialog(X){return zt.showOpenDialog(X)},showSaveDialog(X){return zt.showSaveDialog(X)},createStatusBarItem(X,de,ke){let rt,wt,Dt;return typeof X=="string"?(rt=X,wt=de,Dt=ke):(wt=X,Dt=de),Mt.createStatusBarEntry(Re,rt,wt,Dt)},setStatusBarMessage(X,de){return Mt.setStatusBarMessage(X,de)},withScmProgress(X){return Se.report("window.withScmProgress",Re,"Use 'withProgress' instead."),hi.withProgress(Re,{location:$.ProgressLocation.SourceControl},(de,ke)=>X({report(rt){}}))},withProgress(X,de){return hi.withProgress(Re,X,de)},createOutputChannel(X){return Ot.createOutputChannel(X,Re)},createWebviewPanel(X,de,ke,rt){return si.createWebviewPanel(Re,X,de,ke,rt)},createWebviewTextEditorInset(X,de,ke,rt){return(0,q.checkProposedApiEnabled)(Re),wi.createWebviewEditorInset(X,de,ke,rt,Re)},createTerminal(X,de,ke){return typeof X=="object"?("location"in X&&(0,q.checkProposedApiEnabled)(Re),"pty"in X?ot.createExtensionTerminal(X):ot.createTerminalFromOptions(X)):ot.createTerminal(X,de,ke)},registerTerminalLinkProvider(X){return ot.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return ot.registerProfileProvider(Re,X,de)},registerTreeDataProvider(X,de){return Qt.registerTreeDataProvider(X,de,Re)},createTreeView(X,de){return Qt.createTreeView(X,de,Re)},registerWebviewPanelSerializer:(X,de)=>si.registerWebviewPanelSerializer(Re,X,de),registerCustomEditorProvider:(X,de,ke={})=>_i.registerCustomEditorProvider(Re,X,de,ke),registerFileDecorationProvider(X){return mt.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return di.registerUriHandler(Re.identifier,X)},createQuickPick(){return xt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return xt.createInputBox(Re.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,de,ke){return fi.onDidChangeActiveColorTheme(X,de,ke)},registerWebviewViewProvider(X,de,ke){return yi.registerWebviewViewProvider(Re,X,de,ke?.webviewOptions)},get activeNotebookEditor(){return(0,q.checkProposedApiEnabled)(Re),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeActiveNotebookEditor(X,de,ke)},get visibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Re),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Vt.onDidChangeNotebookEditorSelection(X,de,ke)},onDidChangeNotebookEditorVisibleRanges(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Vt.onDidChangeNotebookEditorVisibleRanges(X,de,ke)},showNotebookDocument(X,de){return(0,q.checkProposedApiEnabled)(Re),gt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Jt.registerExternalUriOpener(Re.identifier,X,de,ke)},get tabs(){return(0,q.checkProposedApiEnabled)(Re),it.tabs},get activeTab(){return(0,q.checkProposedApiEnabled)(Re),it.activeTab},get onDidChangeTabs(){return(0,q.checkProposedApiEnabled)(Re),it.onDidChangeTabs},get onDidChangeActiveTab(){return(0,q.checkProposedApiEnabled)(Re),it.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,q.checkProposedApiEnabled)(Re),f.InlineCompletionController.get(X)}},pi={get rootPath(){return Se.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return Be.getWorkspaceFolder(X)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(X){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,de,...ke)=>Be.updateWorkspaceFolders(Re,X,de||0,...ke),onDidChangeWorkspaceFolders:function(X,de,ke){return Be.onDidChangeWorkspace(X,de,ke)},asRelativePath:(X,de)=>Be.getRelativePath(X,de),findFiles:(X,de,ke,rt)=>Be.findFiles(K.GlobPattern.from(X),K.GlobPattern.from(de),ke,Re.identifier,rt),findTextInFiles:(X,de,ke,rt)=>{let wt,Dt;return typeof de=="object"?(wt=de,Dt=ke):(wt={},Dt=de,rt=ke),Be.findTextInFiles(X,wt||{},Dt,Re.identifier,rt)},saveAll:X=>Be.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,ke,rt)=>Nt.createFileSystemWatcher(K.GlobPattern.from(X),de,ke,rt),get textDocuments(){return kt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let de;const ke=X;if(typeof X=="string")de=Promise.resolve(R.URI.file(X));else if(R.URI.isUri(X))de=Promise.resolve(X);else if(!ke||typeof ke=="object")de=kt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>kt.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(X,de,ke)=>kt.onDidAddDocument(X,de,ke),onDidCloseTextDocument:(X,de,ke)=>kt.onDidRemoveDocument(X,de,ke),onDidChangeTextDocument:(X,de,ke)=>kt.onDidChangeDocument(X,de,ke),onDidSaveTextDocument:(X,de,ke)=>kt.onDidSaveDocument(X,de,ke),onWillSaveTextDocument:(X,de,ke)=>Zt.getOnWillSaveTextDocumentEvent(Re)(X,de,ke),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let ke;if(R.URI.isUri(X))ke=X,await gt.openNotebookDocument(X);else if(typeof X=="string")ke=R.URI.revive(await gt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,ke,rt){return gt.registerNotebookSerializer(Re,X,de,ke,Re.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,de,ke,rt)=>((0,q.checkProposedApiEnabled)(Re),gt.registerNotebookContentProvider(Re,X,de,ke,Re.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,de,ke)=>Gt.onDidChangeConfiguration(X,de,ke),getConfiguration(X,de){return de=arguments.length===1?void 0:de,Gt.getConfiguration(X,de,Re)},registerTextDocumentContentProvider(X,de){return $t.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(Se.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Re,X,de)),registerFileSystemProvider(X,de,ke){return ii.registerFileSystemProvider(Re.identifier,X,de,ke)},get fs(){return me.value},registerFileSearchProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Rt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Rt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Ie.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,q.checkProposedApiEnabled)(Re),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,ke)=>Nt.onDidCreateFile(X,de,ke),onDidDeleteFiles:(X,de,ke)=>Nt.onDidDeleteFile(X,de,ke),onDidRenameFiles:(X,de,ke)=>Nt.onDidRenameFile(X,de,ke),onWillCreateFiles:(X,de,ke)=>Nt.getOnWillCreateFileEvent(Re)(X,de,ke),onWillDeleteFiles:(X,de,ke)=>Nt.getOnWillDeleteFileEvent(Re)(X,de,ke),onWillRenameFiles:(X,de,ke)=>Nt.getOnWillRenameFileEvent(Re)(X,de,ke),openTunnel:X=>((0,q.checkProposedApiEnabled)(Re),Ce.openTunnel(Re,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,q.checkProposedApiEnabled)(Re),Ce.getTunnels()},onDidChangeTunnels:(X,de,ke)=>((0,q.checkProposedApiEnabled)(Re),Ce.onDidChangeTunnels(X,de,ke)),registerPortAttributesProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Ce.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),ri.registerTimelineProvider(X,de,Re.identifier,nt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:X=>((0,q.checkProposedApiEnabled)(Re),Be.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,ke)=>Be.onDidGrantWorkspaceTrust(X,de,ke)},Ti={get inputBox(){return Se.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Re)},createSourceControl(X,de,ke){return Yt.createSourceControl(Re,X,de,ke)}},Ri={createCommentController(X,de){return bi.createCommentController(Re,X,de)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,de,ke){return lt.onDidStartDebugSession(X,de,ke)},onDidTerminateDebugSession(X,de,ke){return lt.onDidTerminateDebugSession(X,de,ke)},onDidChangeActiveDebugSession(X,de,ke){return lt.onDidChangeActiveDebugSession(X,de,ke)},onDidReceiveDebugSessionCustomEvent(X,de,ke){return lt.onDidReceiveDebugSessionCustomEvent(X,de,ke)},onDidChangeBreakpoints(X,de,ke){return lt.onDidChangeBreakpoints(X,de,ke)},registerDebugConfigurationProvider(X,de,ke){return lt.registerDebugConfigurationProvider(X,de,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return lt.registerDebugAdapterDescriptorFactory(Re,X,de)},registerDebugAdapterTrackerFactory(X,de){return lt.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(X,de,{parentSession:ke}):lt.startDebugging(X,de,ke||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,de){return lt.asDebugSourceUri(X,de)}},Mi={registerTaskProvider:(X,de)=>_t.registerTaskProvider(Re,X,de),fetchTasks:X=>_t.fetchTasks(X),executeTask:X=>_t.executeTask(Re,X),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(X,de,ke)=>_t.onDidStartTask(X,de,ke),onDidEndTask:(X,de,ke)=>_t.onDidEndTask(X,de,ke),onDidStartTaskProcess:(X,de,ke)=>_t.onDidStartTaskProcess(X,de,ke),onDidEndTaskProcess:(X,de,ke)=>_t.onDidEndTaskProcess(X,de,ke)},Li={createNotebookController(X,de,ke,rt,wt){return ei.createNotebookController(Re,X,de,ke,rt,Re.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>gt.registerNotebookCellStatusBarItemProvider(Re,X,de),get onDidSaveNotebookDocument(){return(0,q.checkProposedApiEnabled)(Re),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,q.checkProposedApiEnabled)(Re),Vt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ti.createRendererMessaging(Re,X)},onDidChangeNotebookDocumentMetadata(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Kt.onDidChangeNotebookDocumentMetadata(X,de,ke)},onDidChangeNotebookCells(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCells(X,de,ke)},onDidChangeNotebookCellExecutionState(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCellExecutionState(X,de,ke)},onDidChangeCellOutputs(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeCellOutputs(X,de,ke)},onDidChangeCellMetadata(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeCellMetadata(X,de,ke)},createConcatTextDocument(X,de){return(0,q.checkProposedApiEnabled)(Re),new $e.ExtHostNotebookConcatDocument(gt,kt,X,de)}};return{version:ce.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:li,notebooks:Li,scm:Ti,tasks:Mi,tests:Ii,window:Ai,workspace:pi,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:P.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:n.UIKind,Uri:R.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:bt.TextSearchCompleteMessageType,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(be[223],Ee([0,1,57,96,31,95,32,48,49,38,99,100,101,72,64,70,97,71,37,69,87,68]),function(ie,e,c,M,_,A,R,I,D,P,t,y,n,h,s,d,v,k,E,o,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,c.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,c.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,c.registerSingleton)(k.IExtHostConsumerFileSystem,k.ExtHostConsumerFileSystem),(0,c.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,c.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,c.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,c.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,c.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,c.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,c.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,c.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,c.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,c.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,c.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,c.registerSingleton)(C.IExtHostEditorTabs,C.ExtHostEditorTabs)}),define(be[224],Ee([0,1,222,33,218,7,14,5,11]),function(ie,e,c,M,_,A,R,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(s){const d=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(k,...E)=>{E.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const o=E.slice(0,-1).join(","),p=E.pop().toString();return`(function anonymous(${o}) {
${p}
})`}});function v(...k){return d?self.eval(d.createScript("",...k)):new Function(...k)}s.create=v})(P||(P={}));class t extends _.RequireInterceptor{_installInterceptor(){}getModule(d,v){for(let k of this._alternatives){let E=k(d);if(E){d=E;break}}if(this._factories.has(d))return this._factories.get(d).load(d,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);h(d,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,v,k){v=v.with({path:n(v.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const E=await fetch(D.FileAccess.asBrowserUri(v).toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),E.status!==200)throw new Error(E.statusText);const o=await E.text(),p=`${v.toString(!0)}#vscode-extension`,C=`${o}
//# sourceURL=${p}`;let i;try{i=P.create(y._ttpExtensionScripts?.createScript("module")??"module",y._ttpExtensionScripts?.createScript("exports")??"exports",y._ttpExtensionScripts?.createScript("require")??"require",y._ttpExtensionScripts?.createScript(C)??C)}catch(w){throw console.error(d?`Loading code for extension ${d.value} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${v.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}const l={},r={exports:l},a=w=>{const f=this._fakeModules.getModule(w,v);if(f===void 0)throw new Error(`Cannot load module '${w}'`);return f};try{return k.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),i(r,l,a),r.exports!==l?r.exports:l}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),k.codeLoadingStop()}}async $setRemoteEnvironment(d){}async _waitForDebuggerAttachment(d=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+d;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=y,y._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,d){return s.endsWith(d)?s:s+d}function h(s,d){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(o,p){const C=console[o];console[o]=function(){s.$logExtensionHostMessage({type:"__$console",severity:p,arguments:E(arguments)}),d&&C.apply(console,arguments)}}const k=1e5;function E(o){const p=[],C=[];if(o.length)for(let i=0;i<o.length;i++){if(typeof o[i]=="undefined")o[i]="undefined";else if(o[i]instanceof Error){const l=o[i];l.stack?o[i]=l.stack:o[i]=l.toString()}C.push(o[i])}try{const i=JSON.stringify(C,function(l,r){if(r&&typeof r=="object"){if(p.indexOf(r)!==-1)return"[Circular]";p.push(r)}return r});return i.length>k?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[225],Ee([0,1,57,15,33,73,224,211]),function(ie,e,c,M,_,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(_.IExtHostExtensionService,R.ExtHostExtensionService),(0,c.registerSingleton)(M.ILogService,I.ExtHostLogService),(0,c.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[235],Ee([0,1,23,3,177,219,213,17,74,11,2,223,225]),function(ie,e,c,M,_,A,R,I,D,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const h=fetch.bind(self);if(self.fetch=function(o,p){return o instanceof Request||/^file:/i.test(String(o))&&(o=P.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),h(o,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,p,C,i,l){return/^file:/i.test(p.toString())&&(p=P.FileAccess.asBrowserUri(t.URI.parse(p.toString())).toString(!0)),super.open(o,p,C??!0,i,l)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:C=>C}),p=self.Worker;Worker=function(C,i){/^file:/i.test(C.toString())&&(C=P.FileAccess.asBrowserUri(t.URI.parse(C.toString())).toString(!0));const r=`(${function(m){function S(u){return typeof u=="string"||u instanceof URL?String(u).replace(/^file:\/\//i,"vscode-file://vscode-app"):u}const T=fetch.bind(self);self.fetch=function(u,F){return u instanceof Request?T(u,F):T(S(u),F)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,F,O,j,Q){return super.open(u,S(F),O??!0,j,Q)}};const g=importScripts.bind(self);self.importScripts=(...u)=>{g(...u.map(S))};const b=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:u=>u}):void 0;g(b?b.createScriptURL(m):m)}.toString()}('${C}'))`;i=i||{},i.name=i.name||I.basename(C.toString());const a=new Blob([r],{type:"application/javascript"}),w=URL.createObjectURL(a);return new p(o?o.createScriptURL(w):w,i)}}else self.Worker=class extends R.NestedWorker{constructor(o,p){super(n,o,{name:I.basename(o.toString()),...p})}};const s=new class{exit(o){y()}async exists(o){return!0}async realpath(o){return o}};class d{constructor(){const p=new MessageChannel,C=new M.Emitter;let i=!1;n(p.port2,[p.port2]),p.port1.onmessage=l=>{const{data:r}=l;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const a=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,_.isMessageOfType)(a,2)){i=!0,k("received terminate message from renderer");return}C.fire(a)},this.protocol={onMessage:C.event,send:l=>{if(!i){const r=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);p.port1.postMessage(r,[r])}}}}}function v(o){return new Promise(p=>{const C=o.onMessage(i=>{C.dispose();const l=JSON.parse(i.toString());o.send((0,_.createMessageOfType)(0)),p({protocol:o,initData:l})});o.send((0,_.createMessageOfType)(1))})}let k=o=>y();function E(){const o=new d;D.mark("code/extHost/willConnectToRenderer"),v(o.protocol).then(p=>{D.mark("code/extHost/didWaitForInitData");const C=new A.ExtensionHostMain(p.protocol,p.initData,s,null);k=i=>C.terminate(i)})}e.create=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/df115e761ae11cf87ca569ca1824b7257099553a/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
